(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     40480,       1616]
NotebookOptionsPosition[     36431,       1477]
NotebookOutlinePosition[     37136,       1502]
CellTagsIndexPosition[     37093,       1499]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Demo Simplify", "Title",
 CellChangeTimes->{{3.473453169214683*^9, 3.4734531718811283`*^9}}],

Cell["Examples", "Subtitle"],

Cell["\<\
Now we do a couple of examples.  The first example illustrates basic 
techniques. The second example is more specialized. Many more examples
can be found in the file SYSDOC.doc.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Simplifying a Complicated Expression", "Section"],

Cell["\<\
The next example is one most people would be advised to work through.
Note that the output of In[1] below will change based upon
which version of NCAlgebra you have. We have not changed this
output each time we have a new release. If the example
does not work in any way, let us know.\
\>", "Text"],

Cell["\<\
<<NC`
<<NCAlgebra`\t\t\t\t\tload NCAlgebra package\
\>", "Text",
 CellFrame->True,
 CellChangeTimes->{{3.4734530045486383`*^9, 3.473453018898425*^9}, {
  3.51662645560964*^9, 3.516626457379026*^9}},
 Background->GrayLevel[0.849989]],

Cell[CellGroupData[{

Cell["\<\
<<NC`
<<NCAlgebra`\
\>", "Input",
 CellChangeTimes->{{3.473453027368904*^9, 3.47345303290462*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"You are using the version of NCAlgebra which is found in:\"\
\>"], "Print",
 CellChangeTimes->{3.4734530417314587`*^9, 3.516626460989294*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  \"\>", "\[InvisibleSpace]", "\<\"/Users/mauricio/NC\"\>", 
   "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm["  ", "/Users/mauricio/NC", "."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4734530417314587`*^9, 3.516626460994831*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"You can now use \\\"<< NCAlgebra`\\\" to load NCAlgebra or \
\"\>", "\[InvisibleSpace]", "\<\"\\\"<< NCGB`\\\" to load NCGB.\"\>"}],
  SequenceForm[
  "You can now use \"<< NCAlgebra`\" to load NCAlgebra or ", 
   "\"<< NCGB`\" to load NCGB."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4734530417314587`*^9, 3.5166264610007877`*^9}],

Cell[BoxData["\<\"You have already loaded NCAlgebra.m\"\>"], "Print",
 CellChangeTimes->{3.4734530417314587`*^9, 3.51662646100635*^9}]
}, Open  ]]
}, Open  ]],

Cell["\<\
You see a new window pop out and a long list of files which NCAlgebra.m is \
loading 
scroll by on the screen.

There may be a few changes to what is documented above.\
\>", "Text"],

Cell["\<\
NCMessyFunction.m \t\t\tcontains several grubby functions. The variable \
coexz1 was defined in the \t\t\t\t\t\tfile NCMessyFunction.m.
\t\t\t\t\t\tAlso, a lot of variables are defined to be noncommutative in that \
file. \
\>", "Text",
 CellFrame->True,
 Background->GrayLevel[0.849989]],

Cell["\<\
As an exercise let us simplify the expression named coexz1.  \
\>", "Text"],

Cell["<<NCMessyFunction.m", "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["A first approch", "Section"],

Cell[CellGroupData[{

Cell["coexz1", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{
    RowBox[{"tp", "[", "C1", "]"}], "**", "C1"}]}], "-", 
  RowBox[{"X", "**", "B2", "**", "C1"}], "-", 
  RowBox[{
   RowBox[{"tp", "[", "C1", "]"}], "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "X"}], "-", 
  RowBox[{"X", "**", "B2", "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "X"}], "-", 
  RowBox[{"X", "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "B1", "**", "C2"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", "Y", "]"}], "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "B1", "**", "C2"}], "-", 
  RowBox[{"X", "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "B1", "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "-", 
  RowBox[{"X", "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", "C2"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", "Y", "]"}], "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "B1", "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", "Y", "]"}], "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", "C2"}], "-", 
  RowBox[{"X", "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", "Y", "]"}], "**", 
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"Y", "**", "X"}]}], "]"}], "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}]}]], "Output",
 CellChangeTimes->{3.473453053998631*^9, 3.516626465993039*^9}]
}, Open  ]],

Cell["\<\
NCForward[coexz1]\t\t\t\tApplies the basic rule     X**inv[1-Y**X] -> \
inv[1-X**Y]**Y\
\>", "Text",
 CellFrame->True,
 Background->GrayLevel[0.849989]],

Cell[CellGroupData[{

Cell["NCForward[coexz1]  ", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{
    RowBox[{"tp", "[", "C1", "]"}], "**", "C1"}]}], "-", 
  RowBox[{"X", "**", "B2", "**", "C1"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", "C2"}], "-", 
  RowBox[{
   RowBox[{"tp", "[", "C1", "]"}], "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "X"}], "-", 
  RowBox[{"X", "**", "B2", "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "X"}], "-", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X", "**", "B1", "**", "C2"}], 
  "+", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
   RowBox[{"inv", "[", "Y", "]"}], "**", "B1", "**", "C2"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "-", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X", "**", "B1", "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "-", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X", "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", "C2"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
   RowBox[{"inv", "[", "Y", "]"}], "**", "B1", "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "-", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X", "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}]}]], "Output",
 CellChangeTimes->{3.473453058868717*^9, 3.516626467355402*^9}]
}, Open  ]],

Cell["\<\
NCCollect[ %, B1 ** C2 ]\t\t\tCollects the terms B1 ** C2 of the last \
expression.\
\>", "Text",
 CellFrame->True,
 Background->GrayLevel[0.849989]],

Cell["\<\
A glance at the last expression reveals that B1 ** C2 occurs on the outside of 
several terms. Let us Collect these terms.\
\>", "Text"],

Cell[CellGroupData[{

Cell["NCCollect[ %, B1 ** C2 ] ", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{
    RowBox[{"tp", "[", "C1", "]"}], "**", "C1"}]}], "-", 
  RowBox[{"X", "**", "B2", "**", "C1"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", "C2"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"inv", "[", 
       RowBox[{"1", "-", 
        RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X"}], "-", 
     RowBox[{
      RowBox[{"inv", "[", 
       RowBox[{"1", "-", 
        RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
      RowBox[{"inv", "[", "Y", "]"}]}]}], ")"}], "**", "B1", "**", "C2"}], 
  "-", 
  RowBox[{
   RowBox[{"tp", "[", "C1", "]"}], "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "X"}], "-", 
  RowBox[{"X", "**", "B2", "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "X"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "-", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X", "**", "B1", "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "-", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X", "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", "C2"}], "+", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", 
   RowBox[{"inv", "[", "Y", "]"}], "**", "B1", "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}], "-", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"1", "-", 
     RowBox[{"X", "**", "Y"}]}], "]"}], "**", "X", "**", "Y", "**", 
   RowBox[{"tp", "[", "C2", "]"}], "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "X"}]}]], "Output",
 CellChangeTimes->{3.47345306394937*^9, 3.516626469667613*^9}]
}, Open  ]],

Cell["\<\
NCSetOutput[All -> True]\t\t\tDoes nothing but beautify the screen Output
\t\t\t\t\t\t\t\tBe suspicious when working with parts of the \t\t\t\t\t\t\t\t\
\t\toutput if you have used this. \
\>", "Text",
 CellFrame->True,
 CellChangeTimes->{{3.473453076584785*^9, 3.47345307915215*^9}},
 FontFamily->"Courier",
 Background->GrayLevel[0.849989]],

Cell["NCSetOutput[All->True]", "Input",
 CellChangeTimes->{{3.473453068640918*^9, 3.473453074903554*^9}}],

Cell["NCC is an alias for NCCollect.", "Text"],

Cell[CellGroupData[{

Cell["NCC[ %%, B1 ** tp[B1] ** X ]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            TagBox[
             RowBox[{"X", ".", "Y"}],
             HoldForm]}], ")"}], "\<\"-1\"\>"],
         HoldForm], ".", "X"}],
       HoldForm], "-", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            TagBox[
             RowBox[{"X", ".", "Y"}],
             HoldForm]}], ")"}], "\<\"-1\"\>"],
         HoldForm], ".", 
        TagBox[
         SuperscriptBox["Y", "\<\"-1\"\>"],
         HoldForm]}],
       HoldForm]}], ")"}], ".", "B1", ".", "C2"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            TagBox[
             RowBox[{"X", ".", "Y"}],
             HoldForm]}], ")"}], "\<\"-1\"\>"],
         HoldForm], ".", "X"}],
       HoldForm], "-", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            TagBox[
             RowBox[{"X", ".", "Y"}],
             HoldForm]}], ")"}], "\<\"-1\"\>"],
         HoldForm], ".", 
        TagBox[
         SuperscriptBox["Y", "\<\"-1\"\>"],
         HoldForm]}],
       HoldForm]}], ")"}], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "X", ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "X", ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453085869998*^9, 3.516626473463423*^9}]
}, Open  ]],

Cell["\<\
Substitute[expr,rules]\t\t\tReplace one symbol or sub-expression in the \t\t\t\
\t\t\t\t\t\t\texpression expr as specified by the rule. \
\>", "Text",
 CellFrame->True,
 Background->GrayLevel[0.849989]],

Cell["\<\
Here we are using an approach that favors collecting pairs of terms that 
have similar leftmost inv[1-X**Y]'s and rightmost non-inv[1-X**Y] 
parts.  And now, we are substituting the identity:
      inv[1-a**b]**b - inv[1-a**b]**inv[b] == -inv[b]\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
Substitute[%, inv[1-X**Y]**X - inv[1-X**Y]**inv[Y] -> -inv[Y]] \
\>", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", "C2"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "X", ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "X", ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.4734530907341843`*^9, 3.516626476123714*^9}]
}, Open  ]],

Cell["\<\
NCBackward[coexz1]\t\t\tapplies the basic rule        X**inv[1-Y**X] <- \
inv[1-X**Y]**Y\
\>", "Text",
 CellFrame->True,
 Background->GrayLevel[0.849989]],

Cell["\<\
NCBackward will cause the inv[1-X**Y] in the last two terms 
to hide behind the X**Y, so that when we collect on inv[1-X**Y] 
we will be extracting inv[1-X**Y] and (1-X**Y) at the same time.\
\>", "Text"],

Cell[CellGroupData[{

Cell["NCBackward[%]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", "C2"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "Y", ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "Y", ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"X", ".", "Y"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453094536688*^9, 3.5166264780894814`*^9}]
}, Open  ]],

Cell["Finaly we collect on inv[1-X**Y]", "Text"],

Cell[CellGroupData[{

Cell["NCC[ %, inv[1-X**Y] ]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453099004868*^9, 3.5166264794147863`*^9}]
}, Open  ]],

Cell["\<\

We are FINISHED simplifying according to some tastes,
 because all inv[1-X**Y] terms are gone.
 There is ANOTHER WAY which works on some things but not others. \
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["A second approch", "Section"],

Cell[CellGroupData[{

Cell["coexz1", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", "C2"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        TagBox[
         RowBox[{"Y", ".", "X"}],
         HoldForm]}], ")"}], "\<\"-1\"\>"],
     HoldForm], ".", "Y", ".", 
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453104149049*^9, 3.516626482648312*^9}]
}, Open  ]],

Cell["\<\
 NCSimplifyRational[expr]\t\t\tis based on automatically applying a carefully \
chosen 
\t\t\t\t\t\tcollection of rules like NCBackward and subtitute repeatedly.
 \t\t\t\t\t\tRules can be added so it should get better and better 
\t\t\t\t\t\t(that is, work well on many expressions.)  \
\>", "Text",
 CellFrame->True,
 ShowSpecialCharacters->True,
 Background->GrayLevel[0.849989]],

Cell[CellGroupData[{

Cell["result=NCSimplifyRational[coexz1]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453106679563*^9, 3.516626484630175*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["WHAMMO!",
  FontSize->24],
 " We got the answer in one shot."
}], "Text"],

Cell["\<\
We now turn to making the expression shorter by factoring. It is a good \
exercise.\
\>", "Text",
 FontFamily->"Courier"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Condensing the expression", "Section"],

Cell[CellGroupData[{

Cell["NCC[result, tp[C2]] ", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", "C2"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.4734531089853888`*^9, 3.516626489514041*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCC[ %, inv[Y] ** B1 ]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     TagBox[
      SuperscriptBox["C1", "\<\"T\"\>"],
      HoldForm], ".", "C1"}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", "C1"}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.47345310988097*^9, 3.516626491490727*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCC[ %, C1 ]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       TagBox[
        RowBox[{"X", ".", "B2"}],
        HoldForm], "+", 
       TagBox[
        SuperscriptBox["C1", "\<\"T\"\>"],
        HoldForm]}], ")"}], ".", "C1"}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C1", "\<\"T\"\>"],
     HoldForm], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm], "-", 
  TagBox[
   RowBox[{"X", ".", "B2", ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.47345311056502*^9, 3.516626492854418*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCC[%,tp[B2]**X]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       TagBox[
        RowBox[{"X", ".", "B2"}],
        HoldForm], "+", 
       TagBox[
        SuperscriptBox["C1", "\<\"T\"\>"],
        HoldForm]}], ")"}], ".", "C1"}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm], "-", 
  TagBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      TagBox[
       RowBox[{"X", ".", "B2"}],
       HoldForm], "+", 
      TagBox[
       SuperscriptBox["C1", "\<\"T\"\>"],
       HoldForm]}], ")"}], ".", 
    TagBox[
     SuperscriptBox["B2", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453111333788*^9, 3.5166264937035913`*^9}]
}, Open  ]],

Cell["\<\
This is standard Mathematica, picking a \"part\" of an expression.\
\>", "Text"],

Cell[CellGroupData[{

Cell["factor = %[[ 1,2,1 ]]", "Input"],

Cell[BoxData[
 RowBox[{
  TagBox[
   SuperscriptBox["C1", "\<\"T\"\>"],
   HoldForm], "+", 
  TagBox[
   RowBox[{"X", ".", "B2"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453113371993*^9, 3.5166264955974627`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCC[ %%, factor ]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       TagBox[
        RowBox[{"X", ".", "B2"}],
        HoldForm], "+", 
       TagBox[
        SuperscriptBox["C1", "\<\"T\"\>"],
        HoldForm]}], ")"}], ".", 
     RowBox[{"(", 
      RowBox[{"C1", "+", 
       TagBox[
        RowBox[{
         TagBox[
          SuperscriptBox["B2", "\<\"T\"\>"],
          HoldForm], ".", "X"}],
        HoldForm]}], ")"}]}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["C2", "\<\"T\"\>"],
     HoldForm], ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm], "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["Y", "\<\"-1\"\>"],
     HoldForm], ".", "B1", ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453115887994*^9, 3.516626496945924*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["factor = %[[2,2]]", "Input"],

Cell[BoxData[
 RowBox[{"C2", "+", 
  TagBox[
   RowBox[{
    TagBox[
     SuperscriptBox["B1", "\<\"T\"\>"],
     HoldForm], ".", "X"}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453116780053*^9, 3.516626497843732*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCC[ %%, factor ]", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   TagBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       TagBox[
        RowBox[{"X", ".", "B2"}],
        HoldForm], "+", 
       TagBox[
        SuperscriptBox["C1", "\<\"T\"\>"],
        HoldForm]}], ")"}], ".", 
     RowBox[{"(", 
      RowBox[{"C1", "+", 
       TagBox[
        RowBox[{
         TagBox[
          SuperscriptBox["B2", "\<\"T\"\>"],
          HoldForm], ".", "X"}],
        HoldForm]}], ")"}]}],
    HoldForm]}], "+", 
  TagBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["Y", "\<\"-1\"\>"],
         HoldForm], ".", "B1"}],
       HoldForm], "+", 
      TagBox[
       SuperscriptBox["C2", "\<\"T\"\>"],
       HoldForm]}], ")"}], ".", 
    RowBox[{"(", 
     RowBox[{"C2", "+", 
      TagBox[
       RowBox[{
        TagBox[
         SuperscriptBox["B1", "\<\"T\"\>"],
         HoldForm], ".", "X"}],
       HoldForm]}], ")"}]}],
   HoldForm]}]], "Output",
 CellChangeTimes->{3.473453117617324*^9, 3.5166264984764147`*^9}]
}, Open  ]],

Cell["This is about as good as I can do.", "Text",
 CellChangeTimes->{3.473453120823557*^9}]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1122, 820},
WindowMargins->{{77, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 6, \
2010)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 98, 1, 60, "Title"],
Cell[668, 25, 28, 0, 21, "Subtitle"],
Cell[699, 27, 201, 4, 56, "Text"],
Cell[CellGroupData[{
Cell[925, 35, 55, 0, 72, "Section"],
Cell[983, 37, 308, 6, 86, "Text"],
Cell[1294, 45, 242, 7, 57, "Text"],
Cell[CellGroupData[{
Cell[1561, 56, 108, 4, 50, "Input"],
Cell[CellGroupData[{
Cell[1694, 64, 159, 2, 20, "Print"],
Cell[1856, 68, 293, 6, 20, "Print"],
Cell[2152, 76, 391, 8, 20, "Print"],
Cell[2546, 86, 134, 1, 20, "Print"]
}, Open  ]]
}, Open  ]],
Cell[2707, 91, 191, 6, 71, "Text"],
Cell[2901, 99, 298, 7, 57, "Text"],
Cell[3202, 108, 85, 2, 26, "Text"],
Cell[3290, 112, 36, 0, 37, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3363, 117, 34, 0, 72, "Section"],
Cell[CellGroupData[{
Cell[3422, 121, 23, 0, 37, "Input"],
Cell[3448, 123, 2002, 55, 68, "Output"]
}, Open  ]],
Cell[5465, 181, 162, 5, 42, "Text"],
Cell[CellGroupData[{
Cell[5652, 190, 36, 0, 37, "Input"],
Cell[5691, 192, 1899, 54, 68, "Output"]
}, Open  ]],
Cell[7605, 249, 159, 5, 42, "Text"],
Cell[7767, 256, 146, 3, 41, "Text"],
Cell[CellGroupData[{
Cell[7938, 263, 42, 0, 37, "Input"],
Cell[7983, 265, 1953, 57, 68, "Output"]
}, Open  ]],
Cell[9951, 325, 352, 8, 72, "Text"],
Cell[10306, 335, 105, 1, 37, "Input"],
Cell[10414, 338, 46, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[10485, 342, 45, 0, 37, "Input"],
Cell[10533, 344, 3683, 152, 63, "Output"]
}, Open  ]],
Cell[14231, 499, 212, 5, 57, "Text"],
Cell[14446, 506, 269, 5, 71, "Text"],
Cell[CellGroupData[{
Cell[14740, 515, 88, 2, 37, "Input"],
Cell[14831, 519, 2451, 104, 59, "Output"]
}, Open  ]],
Cell[17297, 626, 164, 5, 42, "Text"],
Cell[17464, 633, 214, 4, 56, "Text"],
Cell[CellGroupData[{
Cell[17703, 641, 30, 0, 37, "Input"],
Cell[17736, 643, 2451, 104, 59, "Output"]
}, Open  ]],
Cell[20202, 750, 48, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[20275, 754, 38, 0, 37, "Input"],
Cell[20316, 756, 1312, 57, 40, "Output"]
}, Open  ]],
Cell[21643, 816, 185, 5, 71, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21865, 826, 35, 0, 72, "Section"],
Cell[CellGroupData[{
Cell[21925, 830, 23, 0, 37, "Input"],
Cell[21951, 832, 3610, 151, 59, "Output"]
}, Open  ]],
Cell[25576, 986, 391, 9, 87, "Text"],
Cell[CellGroupData[{
Cell[25992, 999, 50, 0, 37, "Input"],
Cell[26045, 1001, 1310, 57, 40, "Output"]
}, Open  ]],
Cell[27370, 1061, 100, 4, 38, "Text"],
Cell[27473, 1067, 131, 4, 26, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27641, 1076, 44, 0, 72, "Section"],
Cell[CellGroupData[{
Cell[27710, 1080, 37, 0, 37, "Input"],
Cell[27750, 1082, 1303, 56, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29090, 1143, 39, 0, 37, "Input"],
Cell[29132, 1145, 1280, 55, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30449, 1205, 29, 0, 37, "Input"],
Cell[30481, 1207, 1333, 57, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31851, 1269, 33, 0, 37, "Input"],
Cell[31887, 1271, 1311, 56, 43, "Output"]
}, Open  ]],
Cell[33213, 1330, 90, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[33328, 1336, 38, 0, 37, "Input"],
Cell[33369, 1338, 223, 8, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33629, 1351, 34, 0, 37, "Input"],
Cell[33666, 1353, 1190, 50, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34893, 1408, 34, 0, 37, "Input"],
Cell[34930, 1410, 227, 8, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35194, 1423, 34, 0, 37, "Input"],
Cell[35231, 1425, 1065, 44, 43, "Output"]
}, Open  ]],
Cell[36311, 1472, 92, 1, 26, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
