(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     58199,       1754]
NotebookOptionsPosition[     55140,       1655]
NotebookOutlinePosition[     55678,       1675]
CellTagsIndexPosition[     55635,       1672]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["NCMatrix Demo", "Title",
 CellChangeTimes->{{3.4734538145259523`*^9, 3.4734538192060823`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", "NC`"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "NCGB`"}]}], "Input",
 CellChangeTimes->{{3.473453801408657*^9, 3.473453808445821*^9}, {
  3.473453948144999*^9, 3.473453948317004*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"You are using the version of NCAlgebra which is found in:\"\
\>"], "Print",
 CellChangeTimes->{{3.473453809854347*^9, 3.473453826111974*^9}, 
   3.473453861483478*^9, 3.473453959405159*^9, {3.584363593866024*^9, 
   3.584363623107595*^9}, 3.584363700953293*^9, 3.5843638937720537`*^9, 
   3.584364181514468*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  \"\>", "\[InvisibleSpace]", "\<\"/Users/mauricio/NC\"\>"}],
  SequenceForm["  ", "/Users/mauricio/NC"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.473453809854347*^9, 3.473453826111974*^9}, 
   3.473453861483478*^9, 3.473453959405159*^9, {3.584363593866024*^9, 
   3.584363623107595*^9}, 3.584363700953293*^9, 3.5843638937720537`*^9, 
   3.5843641815168467`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"You can now use \\\"<< NCAlgebra`\\\" to load NCAlgebra or \
\"\>", "\[InvisibleSpace]", "\<\"\\\"<< NCGB`\\\" to load NCGB.\"\>"}],
  SequenceForm[
  "You can now use \"<< NCAlgebra`\" to load NCAlgebra or ", 
   "\"<< NCGB`\" to load NCGB."],
  Editable->False]], "Print",
 CellChangeTimes->{{3.473453809854347*^9, 3.473453826111974*^9}, 
   3.473453861483478*^9, 3.473453959405159*^9, {3.584363593866024*^9, 
   3.584363623107595*^9}, 3.584363700953293*^9, 3.5843638937720537`*^9, 
   3.584364181519168*^9}],

Cell[BoxData["\<\"You have already loaded NCGB.m\"\>"], "Print",
 CellChangeTimes->{{3.473453809854347*^9, 3.473453826111974*^9}, 
   3.473453861483478*^9, 3.473453959405159*^9, {3.584363593866024*^9, 
   3.584363623107595*^9}, 3.584363700953293*^9, 3.5843638937720537`*^9, 
   3.584364181521166*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"<<", "NCMatrix`"}]], "Input",
 CellChangeTimes->{{3.4734538283198853`*^9, 3.473453829541885*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"a", "=", 
  RowBox[{"Matrix", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"5", "/", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], "]"}]}], "\n", 
 RowBox[{"b", "=", 
  RowBox[{"Matrix", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "8"}], "}"}]}], "}"}], "]"}]}], "\n", 
 RowBox[{"c", "=", 
  RowBox[{"Matrix", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}], "]"}]}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["5", "2"], "2"},
     {"3", "4"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.4734538385218477`*^9, 3.4734538655606623`*^9}, 
   3.473453970465746*^9, {3.584363594315412*^9, 3.584363624075482*^9}, 
   3.584363701786982*^9, 3.5843638944396048`*^9, 3.584364181631122*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"5", "6"},
     {"7", "8"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.4734538385218477`*^9, 3.4734538655606623`*^9}, 
   3.473453970465746*^9, {3.584363594315412*^9, 3.584363624075482*^9}, 
   3.584363701786982*^9, 3.5843638944396048`*^9, 3.5843641816343403`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}]},
     {"2", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.4734538385218477`*^9, 3.4734538655606623`*^9}, 
   3.473453970465746*^9, {3.584363594315412*^9, 3.584363624075482*^9}, 
   3.584363701786982*^9, 3.5843638944396048`*^9, 3.584364181636311*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SNC", "[", 
  RowBox[{"e", ",", "f", ",", "g", ",", "h"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"d", "=", 
  RowBox[{"Matrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"e", ",", "f"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "h"}], "}"}]}], "]"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"False", ",", "False", ",", "False", ",", "False"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.4734538394051027`*^9, 3.473453866810796*^9}, 
   3.473453971484367*^9, {3.5843635943434563`*^9, 3.584363624141715*^9}, 
   3.58436370185426*^9, 3.584363894470571*^9, 3.584364181662571*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"e", "f"},
     {"g", "h"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.4734538394051027`*^9, 3.473453866810796*^9}, 
   3.473453971484367*^9, {3.5843635943434563`*^9, 3.584363624141715*^9}, 
   3.58436370185426*^9, 3.584363894470571*^9, 3.5843641816644573`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"tp", "[", "a", "]"}], "\[IndentingNewLine]", 
 RowBox[{"inv", "[", "a", "]"}], "\[IndentingNewLine]", 
 RowBox[{"tp", "[", "d", "]"}], "\[IndentingNewLine]", 
 RowBox[{"inv", "[", "d", "]"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["5", "2"], "3"},
     {"2", "4"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4734538683102837`*^9, 3.473453972150592*^9, {3.584363594383711*^9, 
   3.584363624209393*^9}, 3.5843637019206*^9, 3.5843638945085897`*^9, 
   3.5843641816992607`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["3", "4"]}], 
      FractionBox["5", "8"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4734538683102837`*^9, 3.473453972150592*^9, {3.584363594383711*^9, 
   3.584363624209393*^9}, 3.5843637019206*^9, 3.5843638945085897`*^9, 
   3.584364181700781*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"tp", "[", "e", "]"}], 
      RowBox[{"tp", "[", "g", "]"}]},
     {
      RowBox[{"tp", "[", "f", "]"}], 
      RowBox[{"tp", "[", "h", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4734538683102837`*^9, 3.473453972150592*^9, {3.584363594383711*^9, 
   3.584363624209393*^9}, 3.5843637019206*^9, 3.5843638945085897`*^9, 
   3.584364181702126*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"inv", "[", "e", "]"}], "+", 
       RowBox[{
        RowBox[{"inv", "[", "e", "]"}], "**", "f", "**", 
        RowBox[{"inv", "[", 
         RowBox[{"h", "-", 
          RowBox[{"g", "**", 
           RowBox[{"inv", "[", "e", "]"}], "**", "f"}]}], "]"}], "**", "g", "**", 
        RowBox[{"inv", "[", "e", "]"}]}]}], 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"inv", "[", "e", "]"}], "**", "f", "**", 
        RowBox[{"inv", "[", 
         RowBox[{"h", "-", 
          RowBox[{"g", "**", 
           RowBox[{"inv", "[", "e", "]"}], "**", "f"}]}], "]"}]}]}]},
     {
      RowBox[{"-", 
       RowBox[{
        RowBox[{"inv", "[", 
         RowBox[{"h", "-", 
          RowBox[{"g", "**", 
           RowBox[{"inv", "[", "e", "]"}], "**", "f"}]}], "]"}], "**", "g", "**", 
        RowBox[{"inv", "[", "e", "]"}]}]}], 
      RowBox[{"inv", "[", 
       RowBox[{"h", "-", 
        RowBox[{"g", "**", 
         RowBox[{"inv", "[", "e", "]"}], "**", "f"}]}], "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4734538683102837`*^9, 3.473453972150592*^9, {3.584363594383711*^9, 
   3.584363624209393*^9}, 3.5843637019206*^9, 3.5843638945085897`*^9, 
   3.584364181703685*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SNC", "[", "k", "]"}], "\[IndentingNewLine]", 
 RowBox[{"a", "**", "b"}], "\[IndentingNewLine]", 
 RowBox[{"a", "**", "d", "**", "b", "**", 
  RowBox[{"tp", "[", "a", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "**", "d", "**", "b", "**", 
   RowBox[{"tp", "[", "a", "]"}]}], "+", "k"}], "\[IndentingNewLine]", 
 RowBox[{"%", " ", "//", " ", "NCExpand"}], "\[IndentingNewLine]", 
 RowBox[{"%", " ", "//", " ", "ExpandAll"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", "False", "}"}]], "Output",
 CellChangeTimes->{
  3.473453869441374*^9, 3.4734539728156967`*^9, {3.584363594414132*^9, 
   3.584363624280293*^9}, 3.584363701987877*^9, 3.584363894539651*^9, 
   3.584364181729404*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["53", "2"], "31"},
     {"43", "50"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453869441374*^9, 3.4734539728156967`*^9, {3.584363594414132*^9, 
   3.584363624280293*^9}, 3.584363701987877*^9, 3.584363894539651*^9, 
   3.584364181731133*^9}],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       FractionBox["5", "2"], "2"},
      {"3", "4"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"e", "f"},
      {"g", "h"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       FractionBox["49", "2"], "39"},
      {
       FractionBox["67", "2"], "53"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellChangeTimes->{
  3.473453869441374*^9, 3.4734539728156967`*^9, {3.584363594414132*^9, 
   3.584363624280293*^9}, 3.584363701987877*^9, 3.584363894539651*^9, 
   3.584364181732706*^9}],

Cell[BoxData[
 RowBox[{"k", "+", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["5", "2"], "2"},
       {"3", "4"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], "**", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"e", "f"},
       {"g", "h"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], "**", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["49", "2"], "39"},
       {
        FractionBox["67", "2"], "53"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}]}]], "Output",
 CellChangeTimes->{
  3.473453869441374*^9, 3.4734539728156967`*^9, {3.584363594414132*^9, 
   3.584363624280293*^9}, 3.584363701987877*^9, 3.584363894539651*^9, 
   3.584364181734304*^9}],

Cell[BoxData[
 RowBox[{"k", "+", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{
        RowBox[{
         FractionBox["49", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"5", " ", "e"}], "2"], "+", 
           RowBox[{"2", " ", "g"}]}], ")"}]}], "+", 
        RowBox[{
         FractionBox["67", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"5", " ", "f"}], "2"], "+", 
           RowBox[{"2", " ", "h"}]}], ")"}]}]}], 
       RowBox[{
        RowBox[{"39", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"5", " ", "e"}], "2"], "+", 
           RowBox[{"2", " ", "g"}]}], ")"}]}], "+", 
        RowBox[{"53", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"5", " ", "f"}], "2"], "+", 
           RowBox[{"2", " ", "h"}]}], ")"}]}]}]},
      {
       RowBox[{
        RowBox[{
         FractionBox["49", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "e"}], "+", 
           RowBox[{"4", " ", "g"}]}], ")"}]}], "+", 
        RowBox[{
         FractionBox["67", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "f"}], "+", 
           RowBox[{"4", " ", "h"}]}], ")"}]}]}], 
       RowBox[{
        RowBox[{"39", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "e"}], "+", 
           RowBox[{"4", " ", "g"}]}], ")"}]}], "+", 
        RowBox[{"53", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "f"}], "+", 
           RowBox[{"4", " ", "h"}]}], ")"}]}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellChangeTimes->{
  3.473453869441374*^9, 3.4734539728156967`*^9, {3.584363594414132*^9, 
   3.584363624280293*^9}, 3.584363701987877*^9, 3.584363894539651*^9, 
   3.5843641817359743`*^9}],

Cell[BoxData[
 RowBox[{"k", "+", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{
        FractionBox[
         RowBox[{"245", " ", "e"}], "4"], "+", 
        FractionBox[
         RowBox[{"335", " ", "f"}], "4"], "+", 
        RowBox[{"49", " ", "g"}], "+", 
        RowBox[{"67", " ", "h"}]}], 
       RowBox[{
        FractionBox[
         RowBox[{"195", " ", "e"}], "2"], "+", 
        FractionBox[
         RowBox[{"265", " ", "f"}], "2"], "+", 
        RowBox[{"78", " ", "g"}], "+", 
        RowBox[{"106", " ", "h"}]}]},
      {
       RowBox[{
        FractionBox[
         RowBox[{"147", " ", "e"}], "2"], "+", 
        FractionBox[
         RowBox[{"201", " ", "f"}], "2"], "+", 
        RowBox[{"98", " ", "g"}], "+", 
        RowBox[{"134", " ", "h"}]}], 
       RowBox[{
        RowBox[{"117", " ", "e"}], "+", 
        RowBox[{"159", " ", "f"}], "+", 
        RowBox[{"156", " ", "g"}], "+", 
        RowBox[{"212", " ", "h"}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellChangeTimes->{
  3.473453869441374*^9, 3.4734539728156967`*^9, {3.584363594414132*^9, 
   3.584363624280293*^9}, 3.584363701987877*^9, 3.584363894539651*^9, 
   3.584364181737693*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "**", "d", "**", "b", "**", 
   RowBox[{"tp", "[", "a", "]"}]}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"e", "\[Rule]", "1"}], ",", 
    RowBox[{"f", "\[Rule]", "2"}], ",", 
    RowBox[{"g", "\[Rule]", "k"}], ",", 
    RowBox[{"h", "\[Rule]", "2"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "**", "d", "**", "b", "**", 
   RowBox[{"tp", "[", "a", "]"}]}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"e", "\[Rule]", "1"}], ",", 
    RowBox[{"f", "\[Rule]", "2"}], ",", 
    RowBox[{"g", "\[Rule]", 
     RowBox[{"-", "3"}]}], ",", 
    RowBox[{"h", "\[Rule]", "2"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "**", "d", "**", "b", "**", 
   RowBox[{"tp", "[", "a", "]"}]}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{"d", "\[Rule]", "c"}], "}"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       FractionBox["5", "2"], "2"},
      {"3", "4"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"1", "2"},
      {"k", "2"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       FractionBox["49", "2"], "39"},
      {
       FractionBox["67", "2"], "53"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellChangeTimes->{
  3.473453870717965*^9, 3.473453973531465*^9, {3.584363594445518*^9, 
   3.584363624309557*^9}, 3.584363702056077*^9, 3.584363894572384*^9, 
   3.5843641817628527`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["863", "4"], 
      FractionBox["681", "2"]},
     {
      FractionBox["497", "2"], "391"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453870717965*^9, 3.473453973531465*^9, {3.584363594445518*^9, 
   3.584363624309557*^9}, 3.584363702056077*^9, 3.584363894572384*^9, 
   3.584364181764751*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["815", "4"], 
      FractionBox["649", "2"]},
     {
      FractionBox["753", "2"], "599"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453870717965*^9, 3.473453973531465*^9, {3.584363594445518*^9, 
   3.584363624309557*^9}, 3.584363702056077*^9, 3.584363894572384*^9, 
   3.584364181766151*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"a", "**", "d", "**", "b", "**", 
  RowBox[{"tp", "[", "a", "]"}], "**", 
  RowBox[{"tp", "[", "d", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "NCExpand"}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "ExpandAll"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       FractionBox["5", "2"], "2"},
      {"3", "4"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"e", "f"},
      {"g", "h"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       FractionBox["49", "2"], "39"},
      {
       FractionBox["67", "2"], "53"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{"tp", "[", "e", "]"}], 
       RowBox[{"tp", "[", "g", "]"}]},
      {
       RowBox[{"tp", "[", "f", "]"}], 
       RowBox[{"tp", "[", "h", "]"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellChangeTimes->{
  3.473453871822022*^9, 3.473453974113509*^9, {3.584363594482136*^9, 
   3.58436362434381*^9}, 3.584363702088654*^9, 3.5843638946103983`*^9, 
   3.584364181796466*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{
        FractionBox["49", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"39", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["67", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"53", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}]}], ")"}]}]}], 
      RowBox[{
       RowBox[{
        FractionBox["49", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"39", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["67", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"53", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["5", "2"], " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}]}], ")"}]}]}]},
     {
      RowBox[{
       RowBox[{
        FractionBox["49", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"39", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["67", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "e", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"53", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "f", "]"}]}]}]}], ")"}]}]}], 
      RowBox[{
       RowBox[{
        FractionBox["49", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"39", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"e", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"g", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["67", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "g", "]"}]}]}]}], ")"}]}], "+", 
       RowBox[{"53", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"f", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"h", "**", 
            RowBox[{"tp", "[", "h", "]"}]}]}]}], ")"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453871822022*^9, 3.473453974113509*^9, {3.584363594482136*^9, 
   3.58436362434381*^9}, 3.584363702088654*^9, 3.5843638946103983`*^9, 
   3.584364181798962*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{
        FractionBox["245", "4"], " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["195", "2"], " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["335", "4"], " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["265", "2"], " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
       RowBox[{"49", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{"78", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
       RowBox[{"67", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{"106", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}]}], 
      RowBox[{
       RowBox[{
        FractionBox["245", "4"], " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["195", "2"], " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["335", "4"], " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["265", "2"], " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
       RowBox[{"49", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{"78", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
       RowBox[{"67", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{"106", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}]}]},
     {
      RowBox[{
       RowBox[{
        FractionBox["147", "2"], " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{"117", " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["201", "2"], " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{"159", " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
       RowBox[{"98", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{"156", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}], "+", 
       RowBox[{"134", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "e", "]"}]}]}], "+", 
       RowBox[{"212", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "f", "]"}]}]}]}], 
      RowBox[{
       RowBox[{
        FractionBox["147", "2"], " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{"117", " ", 
        RowBox[{"e", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
       RowBox[{
        FractionBox["201", "2"], " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{"159", " ", 
        RowBox[{"f", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
       RowBox[{"98", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{"156", " ", 
        RowBox[{"g", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}], "+", 
       RowBox[{"134", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "g", "]"}]}]}], "+", 
       RowBox[{"212", " ", 
        RowBox[{"h", "**", 
         RowBox[{"tp", "[", "h", "]"}]}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453871822022*^9, 3.473453974113509*^9, {3.584363594482136*^9, 
   3.58436362434381*^9}, 3.584363702088654*^9, 3.5843638946103983`*^9, 
   3.584364181801585*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"m", "=", 
  RowBox[{"Matrix", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", "f", "}"}], ",", 
    RowBox[{"{", "3", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"n", "=", 
  RowBox[{"tp", "[", "m", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"m", "**", "g"}], "\[IndentingNewLine]", 
 RowBox[{"%", " ", "//", " ", "NCExpand"}], "\[IndentingNewLine]", 
 RowBox[{"g", "**", "n"}], "\[IndentingNewLine]", 
 RowBox[{"%", " ", "//", "NCExpand"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"f"},
     {"3"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453872951647*^9, 3.473453974761578*^9, {3.584363594516333*^9, 
   3.584363624375566*^9}, 3.584363702122568*^9, 3.584363894656187*^9, 
   3.584364181829545*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", 
      RowBox[{"tp", "[", "f", "]"}], "3"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453872951647*^9, 3.473453974761578*^9, {3.584363594516333*^9, 
   3.584363624375566*^9}, 3.584363702122568*^9, 3.584363894656187*^9, 
   3.584364181831443*^9}],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"1"},
      {"f"},
      {"3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "**", "g"}]], "Output",
 CellChangeTimes->{
  3.473453872951647*^9, 3.473453974761578*^9, {3.584363594516333*^9, 
   3.584363624375566*^9}, 3.584363702122568*^9, 3.584363894656187*^9, 
   3.584364181832911*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"g"},
     {
      RowBox[{"f", "**", "g"}]},
     {
      RowBox[{"3", " ", "g"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453872951647*^9, 3.473453974761578*^9, {3.584363594516333*^9, 
   3.584363624375566*^9}, 3.584363702122568*^9, 3.584363894656187*^9, 
   3.5843641818344603`*^9}],

Cell[BoxData[
 RowBox[{"g", "**", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"1", 
       RowBox[{"tp", "[", "f", "]"}], "3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellChangeTimes->{
  3.473453872951647*^9, 3.473453974761578*^9, {3.584363594516333*^9, 
   3.584363624375566*^9}, 3.584363702122568*^9, 3.584363894656187*^9, 
   3.5843641818360033`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"g", 
      RowBox[{"g", "**", 
       RowBox[{"tp", "[", "f", "]"}]}], 
      RowBox[{"3", " ", "g"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453872951647*^9, 3.473453974761578*^9, {3.584363594516333*^9, 
   3.584363624375566*^9}, 3.584363702122568*^9, 3.584363894656187*^9, 
   3.584364181837563*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"m", "\[IndentingNewLine]", 
 RowBox[{"Matrix", "[", 
  RowBox[{"MatMult", "[", 
   RowBox[{
    RowBox[{"MatrixToList", "[", "m", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", "g", "}"}], "}"}]}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Dimensions", "[", "m", "]"}], "[", 
  RowBox[{"[", "2", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.584363978413162*^9, 3.584363979449231*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"f"},
     {"3"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453874161825*^9, 3.473453975492882*^9, {3.584363594543621*^9, 
   3.584363624409378*^9}, 3.58436370215456*^9, 3.584363894726124*^9, 
   3.5843639802303743`*^9, 3.5843641818623333`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"g"},
     {
      RowBox[{"f", "**", "g"}]},
     {
      RowBox[{"3", " ", "g"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453874161825*^9, 3.473453975492882*^9, {3.584363594543621*^9, 
   3.584363624409378*^9}, 3.58436370215456*^9, 3.584363894726124*^9, 
   3.5843639802303743`*^9, 3.58436418186421*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.473453874161825*^9, 3.473453975492882*^9, {3.584363594543621*^9, 
   3.584363624409378*^9}, 3.58436370215456*^9, 3.584363894726124*^9, 
   3.5843639802303743`*^9, 3.5843641818656893`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "1"}], "]"}], "]"}], "**", 
  RowBox[{"a", "[", 
   RowBox[{"[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "All"}], "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["25", "4"], "5"},
     {
      FractionBox["15", "2"], "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453890331141*^9, 3.4734539764910383`*^9, {3.584363594831452*^9, 
   3.58436362464151*^9}, 3.584363702274028*^9, 3.584363894938931*^9, 
   3.584363983869293*^9, 3.5843641818963203`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Matrix", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"e", "**", "f"}]}], ",", "g"}], "}"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"%", "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"e", "\[Rule]", "a"}], ",", 
    RowBox[{"f", "\[Rule]", "d"}], ",", 
    RowBox[{"g", "\[Rule]", "a"}]}], "}"}]}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       RowBox[{"e", "**", "f"}]}], "g"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453891228533*^9, 3.473453977273465*^9, {3.584363594848998*^9, 
   3.584363624693327*^9}, 3.584363702286935*^9, 3.5843638949884853`*^9, 
   3.584363985774001*^9, 3.584364181933165*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       RowBox[{
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             FractionBox["5", "2"], "2"},
            {"3", "4"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]], "**", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"e", "f"},
            {"g", "h"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}], 
      TagBox[
       RowBox[{"(", "\[NoBreak]", GridBox[{
          {
           FractionBox["5", "2"], "2"},
          {"3", "4"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.7]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
       Function[BoxForm`e$, 
        MatrixForm[BoxForm`e$]]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.473453891228533*^9, 3.473453977273465*^9, {3.584363594848998*^9, 
   3.584363624693327*^9}, 3.584363702286935*^9, 3.5843638949884853`*^9, 
   3.584363985774001*^9, 3.584364181935214*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Matrix", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"e", "**", "f"}]}], ",", "g"}], "}"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"%", "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"e", "\[Rule]", "a"}], ",", 
    RowBox[{"f", "\[Rule]", "d"}]}], "}"}]}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       RowBox[{"e", "**", "f"}]}], "g"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.4734538921042843`*^9, 3.473453977981621*^9, 
  3.584363594878543*^9, 3.5843636249223633`*^9, 3.584363702322138*^9, 
  3.584363895056732*^9, 3.584363989961432*^9, 3.584364181962433*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Matrix", "::", "notamatrix"}], "MessageName"], 
  RowBox[{":", " "}], "\<\"This is not a Matrix.\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.47345389214579*^9, 3.473453978024082*^9, 
  3.584363594962512*^9, 3.584363625029376*^9, 3.584363702406454*^9, 
  3.584363895109413*^9, 3.584363990068933*^9, 3.5843641820587673`*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.4734538921042843`*^9, 3.473453977981621*^9, 
  3.584363594878543*^9, 3.5843636249223633`*^9, 3.584363702322138*^9, 
  3.584363895056732*^9, 3.584363989961432*^9, 3.58436418206008*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{869, 852},
WindowMargins->{{150, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 100, 1, 61, "Title"],
Cell[CellGroupData[{
Cell[692, 27, 214, 4, 56, "Input"],
Cell[CellGroupData[{
Cell[931, 35, 329, 5, 22, "Print"],
Cell[1263, 42, 422, 8, 21, "Print"],
Cell[1688, 52, 559, 11, 22, "Print"],
Cell[2250, 65, 300, 4, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[2577, 73, 121, 2, 38, "Input"],
Cell[CellGroupData[{
Cell[2723, 79, 732, 26, 73, "Input"],
Cell[3458, 107, 824, 21, 65, "Output"],
Cell[4285, 130, 801, 20, 57, "Output"],
Cell[5089, 152, 821, 21, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5947, 178, 310, 9, 56, "Input"],
Cell[6260, 189, 323, 6, 38, "Output"],
Cell[6586, 197, 798, 20, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7421, 222, 227, 4, 90, "Input"],
Cell[7651, 228, 801, 22, 65, "Output"],
Cell[8455, 252, 895, 26, 73, "Output"],
Cell[9353, 280, 906, 25, 57, "Output"],
Cell[10262, 307, 1750, 48, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12049, 360, 474, 9, 124, "Input"],
Cell[12526, 371, 243, 5, 38, "Output"],
Cell[12772, 378, 803, 22, 65, "Output"],
Cell[13578, 402, 2055, 59, 73, "Output"],
Cell[15636, 463, 2132, 60, 73, "Output"],
Cell[17771, 525, 2403, 74, 73, "Output"],
Cell[20177, 601, 1665, 48, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21879, 654, 868, 24, 73, "Input"],
Cell[22750, 680, 2055, 59, 73, "Output"],
Cell[24808, 741, 855, 24, 73, "Output"],
Cell[25666, 767, 855, 24, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26558, 796, 260, 5, 73, "Input"],
Cell[26821, 803, 2775, 80, 73, "Output"],
Cell[29599, 885, 6121, 185, 73, "Output"],
Cell[35723, 1072, 4509, 133, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40269, 1210, 505, 12, 124, "Input"],
Cell[40777, 1224, 774, 22, 73, "Output"],
Cell[41554, 1248, 793, 21, 38, "Output"],
Cell[42350, 1271, 815, 23, 73, "Output"],
Cell[43168, 1296, 831, 24, 73, "Output"],
Cell[44002, 1322, 835, 22, 38, "Output"],
Cell[44840, 1346, 849, 23, 38, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45726, 1374, 420, 10, 73, "Input"],
Cell[46149, 1386, 799, 22, 73, "Output"],
Cell[46951, 1410, 851, 24, 73, "Output"],
Cell[47805, 1436, 240, 4, 38, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48082, 1445, 234, 8, 38, "Input"],
Cell[48319, 1455, 849, 23, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49205, 1483, 359, 12, 56, "Input"],
Cell[49567, 1497, 830, 22, 38, "Output"],
Cell[50400, 1521, 2910, 77, 65, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53347, 1603, 318, 11, 56, "Input"],
Cell[53668, 1616, 825, 21, 38, "Output"],
Cell[54496, 1639, 374, 7, 21, "Message"],
Cell[54873, 1648, 239, 3, 72, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
