(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    620001,      11424]
NotebookOptionsPosition[    614488,      11245]
NotebookOutlinePosition[    615113,      11270]
CellTagsIndexPosition[    615025,      11265]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["NCTeXForm Demo", "Title",
 CellChangeTimes->{{3.4548758544973497`*^9, 3.4548758553878107`*^9}, {
  3.4548758893949747`*^9, 3.454875890627369*^9}, {3.4549442216095257`*^9, 
  3.454944223464699*^9}}],

Cell["\<\
Mauricio de Oliveira
mauricio@ucsd.edu
June 2009\
\>", "Subsubtitle",
 CellChangeTimes->{{3.454875856942534*^9, 3.454875866482774*^9}}],

Cell[CellGroupData[{

Cell["Loading the Package", "Section",
 CellChangeTimes->{{3.4548745232092733`*^9, 3.454874525707424*^9}, {
  3.454882784245483*^9, 3.4548827849516077`*^9}}],

Cell[TextData[{
 "NCTeX is part of NCAlgebra. It can also work as a standalone package (see \
the NCTeX demo). It uses NCRun, which is a replacement for ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s Run command to run ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"L", 
     StyleBox[
      AdjustmentBox["A",
       BoxBaselineShift->-0.4,
       BoxMargins->{{-0.5, -0.3}, {0, 0}}],
      FontSize->Smaller], "T", 
     AdjustmentBox["E",
      BoxBaselineShift->0.5,
      BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}],
    SingleLetterItalics->False], TraditionalForm]]],
 ", DVIPS, etc. "
}], "Text",
 CellChangeTimes->{{3.454882640385257*^9, 3.4548826874142017`*^9}, {
   3.454882730700768*^9, 3.454882767936368*^9}, {3.4548827998408318`*^9, 
   3.45488280266931*^9}, {3.454893970498431*^9, 3.454893996310384*^9}, {
   3.454894132236375*^9, 3.454894135678491*^9}, {3.4548944160145683`*^9, 
   3.454894418597888*^9}, 3.454894458857164*^9}],

Cell["\<\
For this demo you should have NCAlgebra installed in your computer. All you \
need to do to load NCTeX is load NCAlgebra:\
\>", "Text",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBmIQvbzt0bbaPS8dz9VobgfRYpvm7QXRGec+HgDRLz/M
q60D0kyPaupA9KsNxgZdQHqyWwyYdjrTYQqiYwoTzUB0l2XzVhD9i3feLhBt
8WISWy+QXqUmzg6iX0wS/AyiV595BqbDVStOzgPSb7Y+A9NBfF0RR4D0ehPp
KBD9aMHGJaeA9CXPRxtB9Ap3+X0g2mHx9YMg+sLnpGMg+uu6N8dB9KRrf5+B
6H8z676A6FVMXaXL9r503GaYWA6ig/42VYPoZTt314JoiVsn2kH0o5/5vSBa
TCHtynogvWetynUQXbbj3j0QfebD5acgGgDQVrnM
  "]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"<<", "NC`"}], " "}], "\[IndentingNewLine]", 
 RowBox[{"<<", "NCAlgebra`", " "}]}], "Input",
 CellChangeTimes->{{3.454874647284143*^9, 3.454874651562066*^9}, {
  3.454874869252027*^9, 3.454874895051025*^9}, {3.4548938833669653`*^9, 
  3.4548938875503273`*^9}, {3.4566897126650476`*^9, 3.45668971316895*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"You are using the version of NCAlgebra which is found in:\"\
\>"], "Print",
 CellChangeTimes->{3.5166277505695667`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  \"\>", "\[InvisibleSpace]", "\<\"/Users/mauricio/NC\"\>", 
   "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm["  ", "/Users/mauricio/NC", "."],
  Editable->False]], "Print",
 CellChangeTimes->{3.516627750573736*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"You can now use \\\"<< NCAlgebra`\\\" to load NCAlgebra or \
\"\>", "\[InvisibleSpace]", "\<\"\\\"<< NCGB`\\\" to load NCGB.\"\>"}],
  SequenceForm[
  "You can now use \"<< NCAlgebra`\" to load NCAlgebra or ", 
   "\"<< NCGB`\" to load NCGB."],
  Editable->False]], "Print",
 CellChangeTimes->{3.516627750578739*^9}],

Cell[BoxData["\<\"You have already loaded NCAlgebra.m\"\>"], "Print",
 CellChangeTimes->{3.51662775058223*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCTeXForm", "Section",
 CellChangeTimes->{{3.4548828273144093`*^9, 3.454882829681055*^9}, {
  3.454894509922173*^9, 3.454894512494032*^9}, {3.454894759339323*^9, 
  3.4548947609861727`*^9}, {3.454894876867776*^9, 3.45489487836244*^9}}],

Cell["\<\
NCTeXForm is a replacement for TeXForm that can handle noncommutative \
expressions. It works just as TeXForm. Here is an \[LineSeparator]example:\
\>", "Text",
 CellChangeTimes->{{3.454894538612069*^9, 3.454894601356206*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNonCommutative", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", "x", ",", "y"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"exp", "=", 
  RowBox[{
   RowBox[{"a", "**", "x", "**", 
    RowBox[{"tp", "[", "b", "]"}]}], "-", 
   RowBox[{"inv", "[", 
    RowBox[{
     RowBox[{"c", "**", 
      RowBox[{"inv", "[", 
       RowBox[{"a", "+", 
        RowBox[{"b", "**", "c"}]}], "]"}], "**", 
      RowBox[{"tp", "[", "y", "]"}]}], "+", "d"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeXForm", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.4548946107926693`*^9, 3.454894652046401*^9}, {
  3.4548946890440607`*^9, 3.454894704227187*^9}, {3.454894823295081*^9, 
  3.4548948235271263`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"inv", "[", 
    RowBox[{"d", "+", 
     RowBox[{"c", "**", 
      RowBox[{"inv", "[", 
       RowBox[{"a", "+", 
        RowBox[{"b", "**", "c"}]}], "]"}], "**", 
      RowBox[{"tp", "[", "y", "]"}]}]}], "]"}]}], "+", 
  RowBox[{"a", "**", "x", "**", 
   RowBox[{"tp", "[", "b", "]"}]}]}]], "Output",
 CellChangeTimes->{3.516627750647937*^9}],

Cell[BoxData["\<\"a*\\!\\!*x*\\!\\!*{b}^T-{\\\\left (d+c*\\!\\!*{\\\\left \
(a+b*\\!\\!*c\\\\right )}^{-1}*\\!\\!*{y}^T\\\\right )}^{-1}\"\>"], "Output",
 CellChangeTimes->{3.516627750654192*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Using NCTeXForm with NCTeX", "Section",
 CellChangeTimes->{{3.4548828273144093`*^9, 3.454882829681055*^9}, {
  3.454894869277874*^9, 3.454894874051343*^9}}],

Cell[TextData[{
 "Note that the ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"L", 
     StyleBox[
      AdjustmentBox["A",
       BoxBaselineShift->-0.4,
       BoxMargins->{{-0.5, -0.3}, {0, 0}}],
      FontSize->Smaller], "T", 
     AdjustmentBox["E",
      BoxBaselineShift->0.5,
      BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}],
    SingleLetterItalics->False], TraditionalForm]]],
 " formatting contains some special code so that the expression looks neat on \
the screen. We can see the result using NCTeX to convert the expression to \
PDF."
}], "Text",
 CellChangeTimes->{{3.454894720341371*^9, 3.454894796339114*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"NCTeX", ",", 
    RowBox[{"TeXProcessor", "\[Rule]", "NCTeXForm"}]}], "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.456689766054611*^9, 3.4566898139202414`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NCTeX", "[", "exp", "]"}]], "Input",
 CellChangeTimes->{{3.454894800447564*^9, 3.454894802404029*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.005235602094240838], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
     1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
     0}}}, {CompressedData["
1:eJxd03tIU3EcBXCxIMU5dbu7W5Dz3rmHiTkjmxVKXzFDUZYvMsTYmqlRs8Qs
S8WZlUwzNAUzsc0e0/IR6lamzAfLLS2aaMaSNAxdSYWylswUs/rnN+iPw+ED
599Dys4lZbq6uLiE/s2/Xvc8axpZoINwIy7pjpoPLSKB9WEIHXJSF69a0wTg
qsRDlVQaDFIjC4XzAuBIVgvkcd7IlO+7b03mbUMOGaqwtJesH5w1PDbWO7jI
b2ZuHqn14SBLjPaM43sIeBLT6i7ycAXQ7pVrXvpCbItKmsZzQ06JTbZ79Loj
D7XIBpnNnsjvA7N2/g7wgSW7OXVTQsDp6U1N9yUfOF9D+pzE/UA5nbshtdDQ
nkK1ru3qxZDptiKIxnDkCHFQ3PgvHLqz8zsc3Wy4PLr/qLmRCcfqoz7zHH4Q
OFXRb4xiAdcsXMZ7CGjjZecVmVggX8xSEIsk8jVNrr34h9N5MbpgBY8DN0a7
KsNynDarS8OWxE5TCt5OXvnKRFaMPsu2zTEh0tx82OTNAYO6HHtkYELXkCjI
MkbC2sV0FYvFhPYdm20xJQRo1IyB1QwcPp4Y81A/YAP/DHtC/ApD7hGRbt/0
dOQVT5vunooOlIP71Ac6/JClmf4mMpxATjql6yrrIICv3Ho3TUsHgXipIOAd
AfkSszyVxEAR7X+I/ZSEEVFDeEo1BsMKcVNvJQdm6iZoF+5j0MmptfQNcIBG
lVESNzCItdUnZCn84YOoqmyulQHFwcl1UiMXuNRp6B9ngJdv/FQTnwd6/bK5
JhMH7ev0630xfDDo5XPadhxkDt8XGRanC3WCsOFPTvsRYrxzxenGxIj5qngB
fBGVa/ihOCh/lrKrFQJgU9OFtysYyAlWXetCA4b8XKTaTt2CAekyG77mJYD/
//IHHGRnQg==
     "], CompressedData["
1:eJxTTMoPSmViYGAQB2IQfeTsyhSGGEGHqqdXp+wvV3S4oZWm+U9D0GFHTMQk
cRkEX2edtXq7kKKDQ43/bPXJAg4banyilu9WcGCzC9iRsY3XwejnBg0zN3kH
jquJD0SauRzuJZ7knr9YzuHGlcqQP4EccP6cjXJrFXJY4PyWjVrpU4KZHdg3
3jgdnaUA57+8ll11wUARzv/37cJMfn0lB7eENfkJV1gd3s5fzti8UMVhthRv
a8l8doe4kGeOV7tVHUSMFk5+z8nlsPTc23ypnWoOV5vvcqtP4HUoMC9fZVSq
7nDP/SSbboQAnC/S0Zvx8YEQnK/Q0d5tnivsUF1omzrhsiqcv8+DV8h9K4LP
qHB3399pqg4feEsW10UIO+x8sT/pRbmqQ3J8uMU7P2EHJ3E51/Q4VQf08AUA
nIaVkg==
     "]}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYje3pLuXP6g5mGzxTpWeoezw4Ar7pO8L1B3m
uk6ZfVZY2aE6ea2bdKCGw4F6vznbu5QcLlh9Ubdm1XSYy7Tq5FxWJQej/Ko9
pg6aDk1HH57Rv6HoYLk+bNLD6ZoO5nxsLzimKTpsUNAQUt+F4Eeusbnz8ieC
79F//3aJnZaDTV7w9PTLCP4zy+Oqm1WU4Pzd8oxvI3yVHPSMlrGGaGs5rDjk
ohHdoOTg4M/MdvKZpoNZ4IedFkuUHIxfLpW4pqzuwPfr0m35f8oOeZ4RqQU3
NB2eLtr6ly1C1aEw0y3AjUXLQVT25NP9Oapw8y+5/rTg7EbwawRzj4fcQfBV
7z4IXaCrBne/lq0e6/8sNbj/YPwZh99Zsy1H8NcyWKkH9mk6PHk6/7xZmpqD
rJH+xVcRmg78DGkcE23VHGDh/8I+KkglRQXufhHns68fT1R3qHIw8Zunoe6Q
8GvFBa4r6nD5GSEnPhh7ajjkN8x8/2CtGpw/XWrhfM0kBH/SruAPp1TUHHzn
vuHmZUfwmZ4JqD87og7nn3ttt026Fxhub5z2rqpGuOfm67vy+SwqDnazXp38
Y67msDTwjs+Dw8pw/8D4MP8uuih75NwCBP+Rhv6L4ngE/47GpmsBksrw8ITx
YeEN48Pi41S2aol4qLJDJ9+dO5+zVR2ernhb0NqkDI9P/8fNziLOag4hgYmC
L5hU4PK1K+reM6xUguv30ctm95iiBDd/Aqv1ln+lCD4svcH4sPQIcz8svcL8
B+O72bos3r0FwTdk+Lm94CzQ/tQpshdnKcLDL8j73JOyw4rw8K3ivjXr8Rxl
ePjL9AVLZkcpwPnL9mz8/dIBwW+dMMP17At5h3uF+lc/AsN90tvrP5bnyzto
anLvkliJ4MPSCzqfMbBb5q+OAjz9TI7/avamWMEBPf8DAI+1sYU=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4vs6+REpkQYOJlu8U6VnKDvofDloVLbRwGGu
65TZZ4WVHap2i/B2cBo6HKj3m7O9S8lBRX3H3+nJhg5zmVadnMuq5BDq+Ntd
tNHQoenowzP6NxQdIhNfGr1eY+hgzsf2gmOaooOI1KVPvPsQ/Bfxd8Lf30Xw
Ey6uvW7CYORgkxc8Pf0ygv/M8rjqZhUlOH+3POPbCF8lh8tKE3OWfDN0WHHI
RSO6QckhZuP+N3FXDB3MAj/stFii5BD2T6DsaZGBA9+vS7fl/yk7FOtlzTE6
a+jwdNHWv2wRqg4ldg8nyj42dBCVPfl0f44q3PxLrj8tOLsR/BrB3OMhdxB8
1bsPQhfoqsHdr2Wrx/o/Sw3uPxi/I3tre+0WBF+IK/qv0gpDhydP5583S1Nz
OLUo9FJ+r6EDP0Max0RbNQdY+L+wjwpSSVGBu1/E+ezrxxPVHX5q3pjgWWrg
kPBrxQWuK+pw+RkhJz4Ye2o4fDnZ9fCVOYLPMb3Pkl8Iwec6d/7w/mf6Dr5z
33DzsiP4TM8E1J8dUYfzz7222ybdq+5wuD7+xHk5hHsC/0d+Tj6m62A369XJ
P+ZqDrKpEQpXW3Xh/oHxYf6Vejpz+uEkBD/KZvXuDEUEP8RGb5XrbR14eML4
sPCG8WHx4VS/0J1HXNehk+/Onc/Zqg6xezJdqlx04fGZ8ru+u4XJwCEkMFHw
BZMKXL52Rd17hpVKcP0+etnsHlOU4OZPYLXe8q8UwYelNxgflh5h7oelV5j/
YPx9AQfKNpQh+CuFS7tT+4H2p06RvThLER5+Qd7nnpQdVoSHbxX3rVmP5yjD
w1+mL1gyO0oBzl+2Z+Pvlw4IfuuEGa5nX8g7rD4UGlIsYuAw6e31H8vz5R0C
5h0+1maK4MPSCzqfMbBb5q+OAjz9TI7/avamWMEBPf8DADQGtxE=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1FswnGcYB/AVcRh2yIGgYvf72G/XMex3ku4weZLsIlSRSiMkq2SkCIlk
JOLQkKRxqEOls5pKZqMqRKLRpESNTjBigmaYCEHaSlvi1GBCpLOaoHv1vjO9
eC5+F//n5v++Dxl7fG+coUAgMNDPx/pZp5/Zl2Zd99048LGpZJS2FBiluydl
KTiI1qiM1VoKymxCXitTOUjxTrtFn5KBV83SjXgJj1xtEkI/8MIWHfhhZF8y
tpNdL/WqkofEYZe3A94ycLALteqN4iHH6tSkSCyDdcKUyXcuPMyo5s6WVUmR
LdqNlabu2CZE5GNilIKhc7HvZal4+O6odYNVNgWLfZXCp/nYV1pyUwfasN0T
iIVcS2/gWp5fKhrGLur/3JvTSpGVDndPjGhlsKCOTK/P5KHVYmeG57gMigNV
rUek2G+O+sUsajjkebfEQj9fDm7O/xb56oUU5IaK7SsiDiJtNhW+Pi0Fq9xN
acZ/siCouRt7qEEGIaM1BfkRLMp/4jobcdUSOyZPPuNpxiAnDy7XiDNp6KPM
P2SiKWRScXNw45gEuTb/TOnuegloRVS7QoPtsuLyb3w5dl986LN9t7FXTm7d
Nt1IQ7vq/PpvmyVQEEbGb2mhITT1kG7nhATm43gntSUDHUHW8o06qb7XJ4ep
ewzqdzBoSpRsxiJ/4CGgn72PfWVpr/DlJRZ01Olu50DsC2F7tAJWiqxesr5e
rqEgPrF7m/+nLOQFMed/VEjQ/to/XJeOJJCgmnM66DHGgJrqNCh3JfR7+8/Z
f8HA85ge84oqERzuKr3dbI9t1KAz1AixU62Gsh49oZFTwps95ddosDloW1JE
isHgweJU1O80rF+L6ikJF0Nt/XBI5GYGCrNnVjM3E8iXs8fJjgrsad7HVuhM
orzcomBoIoTUv4Nk5WQTdrj/iEFMEvbZMJnqsQcNvo++kb3rJZCLo89QPR7Y
9VP3nCZLRHCic61jfx0N0MAlVXc5QPvVnq/C7RjkXclxA/Zt2HMjpp1udiwE
BOxpLFAQsHV80LaVYCE9tmjVOIKAEXOjJJMdLNDLd5x5PzH0rIpiPitncf5n
R53Yi0MOYLYEyxge2Xcy+EvvDh4yVDX022MkcsOON43Ts9huC9RyE+EId7pm
SnPqsHPuO/jMV2Fvl3rt0hZjf+/vZnpc/7/zLq7Z/SJ0BCJB2gcXeND981H+
7DSJ7k/njcDqmTIxXN5f/1PvRQ7120Ze4xs57ApJ82zdAIu84eGSS1IdC391
VnZfHxUjm/U/bJJ/TSDnjylvqU1IOPZr0UBpCwsZE081bWkk7ArNNtkwxMLf
yy9OBh9whP/f0/8AW9Y1Lg==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYq6z+5c3q9k4mGzxTpWeoewQPkWoaWqdjcNc
1ymzzworOyyJTo1Zfs3G4UC935ztXUoO/sc5fLcb2DrMZVp1ci6rkkPDQ+/p
Jn62Dk1HH57Rv6Ho0MJo1cRVZetgzsf2gmOaooP9LiUn3W4EX4RBdznfagS/
u/CfWshZWwebvODp6ZcR/GeWx1U3qyjB+bvlGd9G+Co5/Dv0cPfhw7YOKw65
aEQ3KDm0BwrY1C20dTAL/LDTYomSQ+O8xKMsDjYOfL8u3Zb/p+ww79yu14Gz
bB2eLtr6ly1C1WHBPcOHNhtsHURlTz7dn6MKN/+S608Lzm4Ev0Yw93jIHQRf
9e6D0AW6anD3a9nqsf7PUoP7D8bfzM12fU4jgm+3arWPU6mtw5On88+bpak5
fHVaptgfZevAz5DGMdFWzQEW/i/so4JUUlTg7hdxPvv68UR1B5VTGg8ynGwc
En6tuMB1RR0uPyPkxAdjTw0H+azbBlysCL6x+f0OvfvWcL5Bu4Vh/QFrB9+5
b7h52RF8pmcC6s+OqMP5517bbZPuVXd4J79B/P1ra7h7Ls//6xG4wcrBbtar
k3/M1Rx2Xqq5zznBCu4fGB/m3x2TZKUb6xD8CDu1tZdjEfzQfekqh6ys4OEJ
48PCG8aHxceZeMXipRFWDp18d+58zlZ1iKprLYzJt4LHZ9/sC7cWn7d2CAlM
FHzBpAKXr11R955hpRJcv49eNrvHFCW4+RNYrbf8K0XwYekNxoelR5j7YekV
5j8Yv+vEhq7yDgSfQYtb9NIUoP2pU2QvzlKEh1+Q97knZYcV4eFbxX1r1uM5
yvDwl+kLlsyOUoDzl+3Z+PulA4LfOmGG69kX8g7XkpYtnvTQ2mHS2+s/lufL
O9TYiYgtY7KB82HpBZ3PGNgt81dHAZ5+Jsd/NXtTrOCAnv8B1fKpxg==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4uTX+zj2Nzs4mGzxTpWeoezA6f/i6/H1Dg5z
XafMPius7LBhk+DjC7cdHA7U+83Z3qXk0JqRfPsGh6PDXKZVJ+eyKjnM+9rS
MF3c0aHp6MMz+jcUHeaz/ilt0nV0MOdje8ExTdHhb+KHq8JmCP7zltIOFjcE
f7FtnId6uKODTV7w9PTLCP4zy+Oqm1WU4Pzd8oxvI3yVHGKfnReKD3J0WHHI
RSO6Qclhoe7zIBtHRwezwA87LZYoOchd6Z9eP8HBge/Xpdvy/5QddHL2aC2z
dXR4umjrX7YIVQfdL+VLZ3s4OojKnny6P0cVbv4l158WnN0Ifo1g7vGQOwi+
6t0HoQt01eDu17LVY/2fpQb3H4y/nStpgbchgv/npkm0nLajw5On88+bpak5
RKhtOnpE1tGBnyGNY6KtmgMs/F/YRwWppKjA3S/ifPb144nqDu8zPy/ZONHB
IeHXigtcV9Th8jNCTnww9tRweLvTx5epGMEvX+BXKZKA4Jd5VJ/dE+Dg4Dv3
DTcvO4LP9ExA/dkRdTj/3Gu7bdK96g5XRLYfKElDuKdv5e5N3hPtHexmvTr5
x1zNoeSOlSdLoT3cPzA+zL/Fc263VMcj+MIeT8TO2SH4AidU+/ZI28PDE8aH
hTeMD4uP9sz7d+Zb2jt08t258zlb1UG0w/l2WIA9PD6XBrkr+Uc4OIQEJgq+
YFKBy9euqHvPsFIJrt9HL5vdY4oS3PwJrNZb/pUi+LD0BuPD0iPM/bD0CvMf
jO96Ke9LYSaCv9v4ZN2ZUqD9qVNkL85ShIdfkPe5J2WHFeHhW8V9a9bjOcrw
8JfpC5bMjlKA85ft2fj7pQOC3zphhuvZF/IOHmab2twSHRwmvb3+Y3m+vIO0
ykv7C4UIPiy9oPMZA7tl/uoowNPP5PivZm+KFRzQ8z8AD7exVQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAWIQHbJFY9HXcieHEM2LbxlW6jjA+LMa4pVPrkXwn3y/
7Zx+T8fhuG/G24vpCL6ik9AaBW8Ev49775byD45w/SV2Nt4GFxD8/0dyb7Id
c4Tbd57pn9XD7Y4OvJecdlgsQfDZJqU96vFB8A1yzobFCek47AzN3pN/GMHX
z8+cEHsNwZfddEdXRcgJzj9wd7FHh4iTw8K7ikcb3mnD+Vus7nXW7UbwVdcY
/VgwXduh8lzhSR1OJ4dd4Y7pa19pOUhHcTadYQKGxy7t3Q/qtRwK6uT+TZ3t
6JCdZ63cwKLiIJjVFlLY4+gQ5neN2ZFN2UHj/B6ZsnZHhzVNSaVftyjB+b+u
PVpnyYzg74o821Igr+BQ0jaDce5JRweHzaY5S4/LOsjdOs51T9UJzi+QvFMt
uxPBr+2UNeoKcnaY9Wj3veM3FeH8idznHuRvVYHzF/JdUGpoUXOoiNwReFLA
2WEfn2OV/mN1hydNxj+i1zrB+TbrD5XrlCD4n/x32cU6OjmEzrrH3xmg7vD+
ef5cKRknhysZRYZtm9Uc0NMLAMUb+Lc=
     "], CompressedData["
1:eJxTTMoPSmViYGAQB2IQnfiwvs2I2ckhrOQWZ6q2qsPb5QI3J3I5OXiUZ385
OhvBv6LaER+2VNXBZLtTxFtRJ4fJeu4339xVdQj0ucewOcjJgefwxMD1GuoO
6l2vizd0OTkUmJevMipVd3AMz7n7fRWCX3yy6fKZ6wh+vE66l9tPJ4cVfmt+
aN9Rg/PLBD9sNZymCufvWnp1wo5MFQeX/dvqrC44OSx4ZPHhlbySwx/1ky0v
dzo5sIiYlNvFKTo83CWx8+4EJ4fiQ/e75DkVHKyeL7dYF+7kcC/xJPf8xXIO
kzenSTmrI/jLNgQ5sv51hPN7nBeV/rzs6LCeS18mebs8nF+eKs6zLkQRzq93
VXaR24rgd6jq1/SJKjkYrD8R8uy5o0MJd2zngTBlB/TwBQAf/J4E
     "]}], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1H9Q03UYB/A5hOGwU+O3eSeLwca6bV9qnnGpPPndd9wQhA1QMRGRlFAQ
lLmrKElFNMQhU9BhcOSJkN5sIZIIyjmSjSa/yYS8SjOTAYq4hTiV9s++z13+
8fzx+ufzPJ/357kPZ3OOcosbg8GY5axkZzGdFakYMnQEUsCuz50doRcDUb7H
OLKYgt1avaiATQCZmTPRzKEgOLbV7eY8AlKu2dOmJRTI7VWpWd4EfCA6R8VE
UNDHstwO8CXAtvd+lWMt+jnz87vbMtEZ2nXKW9Xot7pfbNNeQjPaZNpECwVx
Vkv/7x4EMBv1W7smKWiqj9t18DcxFHcM//GZjQLmu6qxeBV6fa0tZuapiLZS
/Ezi34I+Kwo0mUtEcHLfku41jyjoDNEsYwwIYX6uZ9K5MQoyd+8qmjyPDrQa
jMsPCen+O7m9m9LVQmg75ifKc6D/OTN1pNRTRvv5pw9bUtkyKCzkpxIVQngj
dmhEPFcGzQxJdF2PENzf9Ik0Bssg/PIDTegygnZId3H9h0kESDZekccEopse
Kwq+noN+X7BUkfOYpJ0QMR6mH0LDlheOO7+iV3PWWpv7SIglvtn+p5iA5IJV
jNOVJFzwu51ufCgE338b2y06EnzVChsMCyF/3olFcRUkMP2m7XlX0OvjA47r
6tHXvy/jBlQ683n7p3LHCZK+v+C9Wrt/LbozPPnOQQNaIS1KkjSQdL4zr44L
9v5Iwhe//FzYZnHOEz5GyKwkhK20qle4EdBiWPJRCEtK78c64knUghK0m7n3
h78MaKVVu3ORBV2RF3Zh0mnXvrrsOt/lb8VXX5bNQlfqdDr5EzE4SrxYarMU
eld7RMlbxfCx5u+U6UQpqFUbjrTu4IN1qfdAWKwURs1l3TWjPDg2fPiT/dFS
OLW8lz1m4oGtpsZH94ikPdXeU+Ddg/4y+6WNNL1ufXax6UYO2mPBd5kZGTxw
/0qwY8JMwlND/PbKKB5cVvbsI26hXf1cJts3D/Z5SmmzB6YWbuSg++6VpFkj
0EHucZzgRPSGhKCLh7PQwemXpv0PoOdmlW/qOo0ezBfUJbegLc6FHO1HL0zn
tXLH0dUjIR3DsynaA01pPoNeaIdppWoi4HVf77p3Q1uKduXXEOr3LHQ+enH+
VYe/Hd8jZf812577aNd8Ls+Rb7UrjeggKNJUnZHCVMN444F+vO/RBBWXdRc9
w7fezPbiYx4rNA8OcdGRpYrqznf4UKe8yIo+KwVHY/Gr3BQ+/P///Q8T4nab

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
    3}, {0, 1, 0}}}, {{{53.612526062499995`, 9.8515672}, {53.74951236249999, 
    9.8515672}, {53.93475519999999, 9.8515672}, {53.93475519999999, 
    10.05082}, {53.93475519999999, 10.2500728}, {53.74951236249999, 
    10.2500728}, {53.612526062499995`, 10.2500728}, {48.27940033749999, 
    10.2500728}, {48.14241403749999, 10.2500728}, {47.95717119999999, 
    10.2500728}, {47.95717119999999, 10.05082}, {47.95717119999999, 
    9.8515672}, {48.14241403749999, 9.8515672}, {48.27940033749999, 
    9.8515672}, {53.612526062499995`, 9.8515672}}}], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4jPTz15yUfV3eOC4z6r29Cd7YfYL72+r+zts
aPfus176yT5SjCnf3NjfwaFAb4sm70f7c+8X1M0xQfC7DFx3bglA8BeZrn5c
G4Lgi6+vDF0e5+9QoLUwIdsYwYeZD+MbRD4/x+T92f6ifbmFQIy/wwdH0/xn
cz/bd18oka6MBLrvydfd3OJf7LV4zKSWavs7JDw1035z/af9t4UyYlue+TkI
FGfrqvsxOvjsM1kwc7qfw5li7thOIS6Hdl3bWa94/RxckhcnBW0QcZjV9TPu
xS1fhxeazVsEuuTg/B0vWz9y8qnA+QbFakIfn+s4GB88nb6l2s+hy+jAqvu8
hg4Mq4S170X5O3zLPJ1//KKRA8z9qiXTj0TeRPBD6pIl3zxA8B/GZARLPUPw
w/W4Cmf/N3IoOc33cX0ogn9en8FZ1Q3Bj/rX255hiuCL9HdnXTRC8LVs5F46
AeMr1zq31+O1kcOh/ft6dqzxc9C5GJkmKAXU/7q75ZqSn0Noh/uj1O0GDo2i
Pgt/nPR1uGU3a4GNpa7DlEUfTKZM8nXYaa2odXi6lsMBl6IXj0t8HcSXZ5tz
J6nD+f8cRNQvCanA+UaMF4pebZRzCPjNEV69xtfBh+HoiUlMIg4VFVrWO8r9
HHjqRUqftbE6VP94cfjkLD+HiLXC0x9nMjlYJlbcnn3Kz6Hh3PWLd93+2cP4
DiKpqnMU/tl/8fTMirnu56Ag8mvVMtM/9jaC8sbeL/0cLmyLNvda/dN+Y9fb
JSWf/RwSnP6vjO35YY+efgF6cD11
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0,
      1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxd038s1HEYB/AbuZVSDtOa8L1zkpwfW5IhHrRmST7k11rnlF9rnQlt1252
J7SKqNRsxXaKM+dwzh3T1NkUuuYUS+fiblzS9QNx7PRr0h99P1t/PHv22t57
/no/9HP5idlWFArl8Ob83U4CjoPeNgGSvMcWKBIW/PODEo6Huh17zjIVnWtg
wa+W2R65FbZjOOVk0ndE+kKpdbf5KYIZ7ULanS4WdF5RhWcpEHl/eH6Ver4D
gd14VG9wEwtks9XTolYEjF3VjWWV2NSaHOPNE9gBXE1KugMLEj951cd1Yocl
bbORPsZWrA2cqtZip/geNeomETzU0wdLFn1IK0MMNwR9PvDyAC1u7S2Cd6sp
jvxkH2AKKyVCOQL/37GJ90X7QEbjSY80I8hLNZV9OO0Fz6k5My73EKh2RvL9
33tBELOJ+ZmHLfbtWFb7YZdW2Ow5MxAP+gHJYK2FSVozXRVfQ2OQ5gyaM9kH
CaiYLLCrskYAikNc8bAr8O56B6QHYt8K7n/yBbD5it0ugRnYK5S+iGdXESya
R1M3OARM1ZXzVBUIim7TaVnO7qCX/uRKGnDec2k8rFmFncxmyXlvsPdnahNe
GxHIcy+1WeRuMBJyPWrmK4K02uh5T4s7XAvV9OZbEDBH/ZecuwgQ2cc61W0g
4JpyhISJTrpcfNFcvIJdGKP0E3oyQNP6aoL6AzuypR4Y69jdEwn8qWXsEduG
oqhNR442HBuyZwBszTOwlxB09gextGo6KLNtPyrnEEj3brTGCAiIWF8zFeoQ
GM6qt4sa3cBSHnR8sh9bJm+2s5JhM2VFl13bEeyICBaFtLmTzsj2GKKHEaQN
zmMujj0E2ec8cXH7Nx0BoUrdo/nNfrJfCAq2BNDh///6A54hhnI=
     "], CompressedData["

1:eJxTTMoPSmViYGAQB2IQrWidn/y5I8Ch6unVKfvLFR0+Mey2P9wa4LAjJmKS
uAyCr7POWr1dSNGBY9rNa6k1AQ4banyilu9WcDBReL7oWUKAg9HPDRpmbvIO
b9aos/i4BzjcSzzJPX+xnMPrnBP2h00R/IuTe5OmiCH4Fz7HMlzgDXBg33jj
dHSWApz/8lp21QUDRTj/37cLM/n1lRzcGBclXFMMcHg7fzlj80IVB0l2X0Z9
gwCHuJBnjle7VR2uLj94s8k5wGHpubf5UjvVHJK7mqduiQ9wKDAvX2VUqu5w
yGii7rYKBP9Y2dpip4VIfLG7V9lWBThUF9qmTrisCufv8+AVct+K4DMq3N33
d5qqg/L9aPfdKwIcdr7Yn/SiXNXBSmSVgxKQ7yQu55oep+qAHr4AT+SftQ==

     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4tUM93PvLQpy8N24ZS7DFmWHbr18PvPAYDi/
59y8gt+RCP4rttTSa6mYfPXv1iKsUipwPqPt4S7OBhW4fhgfZj6MD7Mfnb9M
PDtvN5sWnG+hdrVjlS+Cv+X75+1+a7UcPojz3ZedhuCb6tsGxHZi8mH6YXyY
+TA+zP4cs98rsm8FwvnZ0067Lb+I4PPGsTqdOYrJh/kfxoeFD0w/jA8zH8aH
2Y/Ovy19XWppkAycv+Mf07NjR6Th/OV2r0ufMUvD/Q/jw8IHnQ/TD+PDzEeP
fwA0Wdr/
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4glCYgVdUqEOBrarxZQ2qjm8sUqtrxJA4s8y
ld3GjuC//sW6++O/EIc/TFUPz6WrOUgeLfL+/SXEobFwV9lmSTWHst6Pe9Z/
DnF4p/RxuvVBVTj/cmvE34lzEHy1Wd+aC+RVHTy2n9qxD2je7SYvRr5nKg5X
fYttGrhC4XwZUU/WfBkE/8CSufZCuqEOz5yexp9OUIXzZ5377HNFRw3Oz5h+
ysxbTd2hvyvq6xT+UId9fI5V+o/VHS7+ndPE8zgEzm8RkvF16UPwb8fJLDtu
FeLAa7t3rT+PKpz/QjLMh8FeCc5fVXPeo6VUweHeJYXdH+NCHBw2m+YsPS7r
sGVD7ITN8xF8g1M3So/8QPBh7itQtTZj+qsA578sm31niqUinL9s/mn9e+GK
Divnm4t6aoY6mOqVH9xdregwcdbFV/WqCL4Jk7VHphKS/KmdO2UVQx1kC3N9
4wsVHbzTCwXyZEMdPLqN23Z6KDpcmnvmyYXXIQ73Ek9yz18s57A1xj0tfjmC
H/5lxqRn8xH8Zqal4ZEVCH5W7/eZmenA8Krcne/mrQDn+3gHXg6uVYTz3fTe
fVXxU3JQLTuhoVUS4jAvg3eKl42KQ4sTi8yjzhCHnS/2J70oV3Voy3r/Y/bc
EIfY6ReEWWepOXS+Wtu49kCIQ4F5+SqjUnWHnqwcrv2PEXzJqV01sT8R/Ld6
q7knC4Y6HF+d9CDfVN0BPT0DANuBOhY=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4sk2vVnHU8McTLZ4p0rPUHZIf6f48HR1mMNc
1ymzzworO1gt2BZ+YWKYw4F6vznbu5QcVKrvB4esAMozrTo5l1XJYaNjwbLN
68Mcmo4+PKN/Q9Fh00ltxZW7whzM+dhecExTdHj4XfXix30IflhnhtarYwj+
5qcxXdXnwxxs8oKnp19G8J9ZHlfdrKIE5++WZ3wb4avkILBrar742TCHFYdc
NKIblBw2xS7kbzsS5mAW+GGnxRIlh48bvm5Uzwlz4Pt16bb8P2WHH3+6f+86
FObwdNHWv2wRqg4/D7zcYXoizEFU9uTT/TmqcPMvuf604OxG8GsEc4+H3EHw
Ve8+CF2gqwZ3v5atHuv/LDW4/2B82zNx23r3IPgPjE8Il+8Mc3jydP55szQ1
B75bbJ6nNoU58DOkcUy0VXOAhf8L+6gglRQVuPtFnM++fjxR3eFW9fIdB4D8
hF8rLnBdUYfLzwg58cHYU8PhhvIVnsxYBF9W/KrSp2AkfvZrHzefMAffuW+4
edkRfKZnAurPjqjD+ede222T7lV38AnsdFMKR7jHbeOdS1YcYQ52s16d/GOu
5vC/tuaHBgPCPzA+zL//16YcP/Y7FM5/fuNZ9uzPCP4zi+2c11+FwsMTxoeF
N4wPiw+Xhal3/T+FOnTy3bnzOVvV4fmKf3P+fg+Fx6dJQWA5f0CYQ0hgouAL
JhW4fO2KuvcMK5Xg+n30stk9pijBzZ/Aar3lXymCD0tvMD4sPcLcD0uvMP/B
+MXVnsku/xD8i8IPWKMZwxxqU6fIXpylCA+/IO9zT8oOK8LDt4r71qzHc5Th
4S/TFyyZHaUA5y/bs/H3SwcEv3XCDNezL+Qd2B61aXaHhDlMenv9x/J8eYcP
EUpsF2IQfFh6QeczBnbL/NVRgKefyfFfzd4UKzig538AD/XVaA==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4f1/WNjmhTuYbPFOlZ6h7HCtYGI115Zwh7mu
U2afFVZ2WKmk9onvVLjDgXq/Odu7lBym/PV7N+kBUJ5p1cm5rEoOCkfuO3x6
Hu7QdPThGf0big6KPrN3P/8U7mDOx/aCY5qiQ0DV1GyD7wj+Ue4bRzT+I/hK
GWdUdrFHONjkBU9Pv4zgP7M8rrpZRQnO3y3P+DbCV8mh3oaVK4w1wmHFIReN
6Aag/AOBVUf+hDuYBX7YabFEySHBONUnbUm4A9+vS7fl/yk7pNf/nvrzV7jD
00Vb/7JFqDpkOEcGlzBEOIjKnny6P0cVbv4l158WnN0Ifo1g7vGQOwi+6t0H
oQt01eDu17LVY/2fpQb3H4y/xu9cwJkvCL7/NvN1Wz+GOzx5Ov+8WZqaQ21M
2WOO1+EO/AxpHBNt1Rxg4f/CPipIJUUF7n4R57OvH09Ud/D8Jxb8H8hP+LXi
AtcVdbj8jJATH4w9NRzclzkvXz4Vwe+Z6bLXoAeJ/zbqeUtLuIPv3DfcvOwI
PtMzAfVnR9Th/HOv7bZJ96o77L7840FCP8I9W419cisdwh3sZr06+cdczSGP
4c2kdAuEf2B8mH/zDK4kspog+GHRYWy3tBH80N1qS0SVw+HhCePDwhvGh8XH
ZuWr5X1a4Q6dfHfufM5WdQjTzjO3MUDE5+JPBwT9OsIdQgITBV8wqcDla1fU
vWdYqQTX76OXze4xRQlu/gRW6y3/ShF8WHqD8WHpEeZ+WHqF+Q/Gf/R3x98m
MwTfYZr/gpmWQPtTp8henKUID78g73NPyg4rwsO3ivvWrMdzlOHhL9MXLJkd
pQDnL9uz8fdLBwS/dcIM17Mv5B1KU74dPgmM30lvr/9Yni/vEH974gK+qQg+
LL2g8xkDu2X+6ijA08/k+K9mb4oVHNDzPwBc/LTb
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4ukBBx9uvRThMKV/coX+WhEHGD9gx+HTFacR
/Aaj65sNH4g4cK2Le8VzIsKhYupW34+9og6J+/YwcFdFOGjp5jbtnCTl8HpD
xQKWtAiHZ2FrP+7jVYTz1b9bi7BKqcD5Is5nXz+eqO6wXJF11a7aCIeyhsJd
3zi0Heqrndu6TkU4cH61mz+pTRduP19oj9/Hwwi+mtC0Q77nEPwWNb2corsI
vvDWm3/9GfUclJrvuFpciHAoOlm4vERAz8HyTsSs0DMI/lpOvit8xxD8FZU3
QoV6gfYJLao5uFXH4Up+gfG29AiHlAenlE/qajm8YLjkEeoe4WD64NH0DX/U
HXZ+Y/1yyD7C4UBHzrXzx1ThfJh/YfzrczTW+fcoOTCYKTjtcYtweDm5ccUC
JQWHhKLFJ2ZlRjjs+Mf07NgRaQdZ970f+/sjHA73V7N43BODu2+XJw+TtrsI
3P0wPsx/MD7M/2VFNqElqQg+LH4BtlzfPg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
     1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
     0}}}, {CompressedData["
1:eJxTTMoPSmViYGAwAWIQ3fX0I/+z65EO+n+9g2bOV3MQrbgruORMpENu+Ivm
p1HqDtq5Z9yadkU67ONzrNJ/rO4wt4urO2Aegs89RSTCIBTBX6H9smgKe6TD
3UMrj077rgLnn73T6z9JUAnOjz/6OTnWWMHhg92N4s+akQ4Om01zlh6Xdbj7
s3/akSgE/+s8VeWgdAT/oWRd46w2BD8iXXGZ5ppIh3efz4X/j1dwcGR6fVdl
Y6RD8QRFwRQxeQdnoaTL/McR6ntCLRfzPEXw9xyeJH7vF4Lff9J2hxlnlMPG
9JI13zfKORgtfLfCTTjKIWKa8zPV7/IObxcay1+TjXJQOaf/XmyTggNr+cYq
RrUoh5wXafUKLxTh/JalBZ9rPiH4RR5b9OpVlRyMBc1schUQ/BV8zMs75BB8
GZsdDxwlkNQXst1aIR7l4HhugdsxASWH5XmXXY6IRjls2G+mc/2kooPUmQJf
ae4oh9Uy/1d51Ck4LI2L8b/5P9LhXuJJ7vmL5RxiX8/ZYPcMwReT4C3JuIrg
d4neutd8OdKBx95ivtUaeTg/IVX5mKKNApwflLFlQ9MaBQdd3+jc81ciHdT9
3pVrXFVwWPQq3Gr97UiHeldlF7mtig7iHSHs/Y8iHQ7U+83Z3qXk8FJ2h8jB
x5EOa5UmXd+5V8mhRzXwSt7LSAfPj9MC0uqVHSRObD4t/iXSoUYveHLCURWH
3qkz0qd+i3Tgl/W5MkdN1aGMoerCJ6B/Np+Oad3poeZQfmEiYyhLlEPSd9nD
ydcR/Kot6uYHHiL48gp+Ymu/IvizAm0f9/ioO0hmPNa98yfSoeNLg1x/vbpD
79EGM+NPCD5DMBufxmMEX+yFytJTNyMdFBnu2vziV3dAzy8AC1di/w==
     
     "], CompressedData["
1:eJxTTMoPSmViYGAQB2IQ3b7w6snI9ZEOVU+vTtlfrugQka64THNNpMOOmIhJ
4jIIvs46a/V2IUWH/D/2tmcWRTpsqPGJWr5bwWF2my+nb3ukg9HPDRpmbvIO
wcJ9WZtyIx3uJZ7knr9YziHost4yzRgE3+LX5xO/bBB886gjaWYmkQ7sG2+c
js5SgPNfXsuuumCgCOf/+3ZhJr++ksPadI7jNh6RDm/nL2dsXqji0JC7OX1q
WKRDXMgzx6vdqg7WfBoOLzMjHZaee5svtVPN4eSHl7+l2iIdCszLVxmVqjto
zvw+WWY+gq9zV/jWiuMIvm6ts03uhUiH6kLb1AmXVeH8fR68Qu5bEXxGhbv7
/k5TdehyPbRW8Xykw84X+5NelKs6LKwSWN5xLtLBSVzONT1O1QE9fAFM/58D

     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4kmr3qr9uBDt4Ltxy1yGLcoORTdqjwfUx8D5
xRVrNUU7EPyLG4r1PkzG5Kt/txZhlVKB8xltD3dxNqjA9cP4MPNhfJj96Pxl
4tl5u9m04HwLtasdq3wR/C3fP2/3W6vlcP2gzAzzIwi+zE1vzvLtmHyYfhgf
Zj6MD7M/+AFnUisHgh/kcOv/gf9RcP4XdpHfTz9j8mH+h/Fh4QPTD+PDzIfx
Yfaj829LX5daGiQD5+/4x/Ts2BFpOH+53evSZ8zScP/D+LDwQefD9MP4MPPR
4x8Ax0ftyw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAWIQvTXfM7PxeaxDiObFtwwrdRxg/FkN8con1yL4T77f
dk6/p+OQZ/OyL/8+gj/HzO6d2EUEP2j25KJDixH6j5pc3jtvMoLP9eM1S1cf
wr7PYltMy9tjHXgvOe2wWILgs01Ke9Tjg+Ab5JwNixPScUg/kFVm14vgK53N
TNg6DcGfmae8fsYWBD+bpX3Pqa2xDgvvKh5teKcN52+xutdZtxvBV11j9GPB
dG2H43/e/pHZEOuwK9wxfe0rLYeZhyxvvlkDdP8u7d0P6rUcDoe4TA+sjHXI
zrNWbmBRcZjiVeG0vzDWIczvGrMjm7KDfO3kZY75sQ5rmpJKv25RgvN/XXu0
zpIZwd8VebalQF7B4WgEo2TohFgHh82mOUuPyzrMYpo5t3Qfgu+spBwmyhEH
53vdct54OiTOYdaj3feO31SE8ydyn3uQv1UFzl/Id0GpoUXNwd1J0PG1cZzD
Pj7HKv3H6g5/r/lNMWFC8DVzxa7MeRoL57fYTjI3PRPrEDrrHn9ngLpDE+fb
Z5N3xjpcySgybNus5oCeXgCL+QAd
     "], CompressedData["
1:eJxTTMoPSmViYGAQB2IQbcNWelt+baxDWMktzlRtVYemzL0t5zfEOniUZ385
OhvBv6LaER+2VNVBtTDMpXZbrMNkPfebb+6qOmy2XiLx4EqsA8/hiYHrNdQd
5t3SunTvQ6xDgXn5KqNSdQdtx9dtTIxxcL5L1TfGXHEEf9fqjL2aGnEOK/zW
/NC+owbnlwl+2Go4TRXO37X06oQdmSoOuqUTri8WjnNY8Mjiwyt5JYfOlTOj
qjniHFhETMrt4hQd/hQdLPn6Odah+ND9LnlOBQcNzs4tsddjHe4lnuSev1jO
ISQ/Q1VjP4J/L/eeBecqBD/QnC24eWqsw3oufZnk7fJwfnmqOM+6EEU4v95V
2UVuK4Lfoapf0yeq5KCcO/NQ5fxYhxLu2M4DYcoO6OELAIHRl4g=
     "]}], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4qpns5UfTo53MNninSo9Q9nBb4bBrKcr4x3m
uk6ZfVZY2UHR66jAq/3xDgfq/eZs71Jy4FF9x5N3DSjPtOrkXFYlhxmv6+LP
3o13aDr68Iz+DUWHmcVWtw69iHcw52N7wTFN0eHEQpMu7rcIvq1x+WPmrwj+
rP5s56l/4x1s8oKnp19G8J9ZHlfdrKIE5++WZ3wb4avk8D15iYbh73iHFYdc
NKIbgPLsG07M/xTvYBb4YafFEiWHG1Es2Y6z4h34fl26Lf9P2eH+sllbrnyI
d3i6aOtftghVhwdZPwr9v8U7iMqefLo/RxVu/iXXnxac3Qh+jWDu8ZA7CL7q
3QehC3TV4O7XstVj/Z+lBvcfjK9Slpu//BWCf/zutTMTnsc7PHk6/7xZmprD
12ZRpicP4h34GdI4JtqqOcDC/4V9VJBKigrc/SLOZ18/nqjucFB1W+EtID/h
14oLXFfU4fIzQk58MPbUcNh/9tHRpm4En+Xg49vcTUh80V+sCVXxDr5z33Dz
siP4TM8E1J8dUYfzz7222ybdq+5g/Hv6f+tWhHt0o193h5jFO9jNenXyj7ma
wzP17o1Oegj/wPgw/z4LL254oIngn2v6qrJVEcEHOvfQBwlEeML4sPCG8WHx
oe1dMi1TId6hk+/Onc/Zqg7ngnjDxNUQ8SktlWCgWRfvEBKYKPiCSQUuX7ui
7j3DSiW4fh+9bHaPKUpw8yewWm/5V4rgw9IbjA9LjzD3w9IrzH8wfpRqhEyc
DoK/Y++7fSX6QPtTp8henKUID78g73NPyg4rwsO3ivvWrMdzlOHhL9MXLJkd
pQDnL9uz8fdLBwS/dcIM17Mv5B3edk99tAQYv5PeXv+xPF/e4TqT4f6XXQg+
LL2g8xkDu2X+6ijA08/k+K9mb4oVHNDzPwA2w8iL
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4sarb+7wpyU4mGzxTpWeoeyQrWcuIVSY4DDX
dcrss8LKDiHtjcEiNQkOB+r95mzvUnI49WVqYFg7UJ5p1cm5rEoOAhH3frF2
Jzg0HX14Rv+GooOAjM2OhgkJDuZ8bC84pik6aBhbCiydhOA/qr5ls3Aagi+4
6sqbl7MSHGzygqenX0bwn1keV92sogTn75ZnfBvhq+TgIFJ4f/vMBIcVh1w0
ohuA8s/K9POnJjiYBX7YabFEyWED/0IGh8wEB75fl27L/1N22GKas7RzSoLD
00Vb/7JFqDpsEZdmcZ+e4CAqe/Lp/hxVuPmXXH9acHYj+DWCucdD7iD4qncf
hC7QVYO7X8tWj/V/lhrcfzB+2NyrTMUTkeQDuzY+709wePJ0/nmzNDUH+yWa
PhN7Ehz4GdI4JtqqOcDC/4V9VJBKigrc/SLOZ18/nqjuoPL1Z3MPkJ/wa8UF
rivqcPkZISc+GHtqOKh4Cqx7kIjgHzskYKkai8R/I+3nH5ng4Dv3DTcvO4LP
9ExA/dkRdTj/3Gu7bdK96g737r/y2huHcM+tfpGJnuYJDnazXp38Y67mYF72
ZLGDMcI/MD7Mv+Z9Ed38hgj+6sUz7/7UQeJfblwzXQMRnjA+LLxhfFh83GSP
FAsB6u/ku3PnczZQvlv1m5Y+Ij6D3vs9No5OcAgJTBR8waQCl69dUfeeYaUS
XL+PXja7xxQluPkTWK23/CtF8GHpDcaHpUeY+2HpFeY/GP/jF69IPyMEX8Fx
2qqbwPCoTZ0ie3GWIjz8grzPPSk7rAgP3yruW7Mez1GGh79MX7BkdpQCnL9s
z8bfLx0Q/NYJM1zPvpB3sF6RuacQGL+T3l7/sTxf3mF98natKYkIPiy9oPMZ
A7tl/uoowNPP5PivZm+KFRzQ8z8Axwu8vw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYqGzvk/XCSc6GNiuFlPaqObgkPj1zTI+JP7E
u7tduBB8+4NHux6xJjr8Yap6eC5dzSFM7U/Qc4ZEh8bCXWWbJdUcWrt2dzsC
+e+UPk63PqgK519ujfg7cQ6CrzbrW3OBvKpDnvwKzpNA8243eTHyPVNx2JJV
c3olN4If4fdcf6EIgq81TfDsJ5lEh2dOT+NPJ6jC+bPOffa5oqMG52dMP2Xm
rabuIMT5Qd0E6J99fI5V+o/VHTY7TXz3/nsCnM9z9sLl7rMIvvnngIazixMc
eG33rvXnUYXzX0iG+TDYK8H5q2rOe7SUKjhY6l7uerQ1wcFhs2nO0uOyDipz
CkudryH4jzT0X5xmSoTzYe4rULU2Y/qrAOe/LJt9Z4qlIpy/bP5p/Xvhig7z
Jt8z55NOdDDVKz+4u1rRQXji6kWakgj+E5eEwHniCL7QSvmuH2KJDrKFub7x
hYoO+eXVWxVEEx08uo3bdnooOmwGKgj6k+BwL/Ek9/zFcg6qRWkJkrcQ/G+2
/d9iriH43K6ikdMOIfj1XXZVcruA4VW5O9/NWwHO9/EOvBxcqwjnu+m9+6ri
p+Rw99+yg3UHEhzmZfBO8bJRceB56rI76nSCw84X+5NelKs68FbuWml+NcEh
dvoFYdZZag58OyXzDjxLcCgwL19lVKruIPCzwsjzB4IfzteRLcGcCOc7REsY
G/MnOhxfnfQg3xQY32jpGQBx6TGp
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4t4zJ47urU10UP9uLcIqpeIA45cH+lftWq7q
8HLNbjnHqkSH1Khv9ZmCGg47+apuX8xIdPiUV7Z1WaCWQ7TKW7froYkOuWpW
as+O6DgIHz5ydbpVokPRycLlJQJ6Dmci5xeVmCP4EW13ZZpNEfx58q/9XEwS
HZz84/bv/q0L57eo6eUU3UXw1YSmHfI9h+Dzhfb4fTys63DW2u+iIdA+nzN8
Pp4Zug7PpdIyrkQkOgQc+2HwO0/boSS///2crESHoL+Wu7NdNOB8mH9hfJVz
+u/FNik4dMko5fHFJzrYdmm6b4+XctDiWvUn0iLRoftTodD7KFG4/Q1G1zcb
PhCB8wN2HD5dcRrBn9I/uUJ/LYIvZWd8aU6BCNz/uzx5mLTdReDhA+PDwg/G
F+2+LyIWDrRvx+rwiX/EHP73C6sdyUx0uCodxdnEI+NQejxp9pdKoPl8UydE
mivA468/lTvIKlfJAT1+ATBDzIQ=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{145.8783221015625, 14.084065500000001`}, {145.966584890625, 
    14.084065500000001`}, {146.1300345, 14.084065500000001`}, {146.1300345, 
    14.255142757812502`}, {146.1300345, 14.432758000000002`}, {145.973122875, 
    14.432758000000002`}, {145.8783221015625, 14.432758000000002`}, {
    141.77900589843748`, 14.432758000000002`}, {141.68420512499998`, 
    14.432758000000002`}, {141.52729349999998`, 14.432758000000002`}, {
    141.52729349999998`, 14.255142757812502`}, {141.52729349999998`, 
    14.084065500000001`}, {141.69074310937498`, 14.084065500000001`}, {
    141.77900589843748`, 14.084065500000001`}, {145.8783221015625, 
    14.084065500000001`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4rtPtr9YsjLJ4c1tT5eGpwYOMH5T5EKPdmFD
h5vrre8aAPlcOecOGosaOrRUp95jWYzgBzP0pDNMTXKQPNVZJrrKwKHxsVEe
XyOC7zVBMECiApNfuZnt/eokAwfjrH1ewbUIPpvW4/uHuhF8U/nrbaemJzkI
zIr9rjcLweeYVM6nKqUF5++pEpXMXaKJUF9ltlquTNNBI/bX9LeNCP6TD57q
Myox+Rlvt3Gf/arh0MLz5GZHLYL/7tlKvtoZCP7DDSYf5ixA8DXOVM/JXI7g
v6h9nM1+GMHXF3b1uH4ckw+z//WyKdcb9yP4sPBH58P8B+Ova43MYJfUckCP
PwAkZdNo
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4pqLlS/E2pIdTLZ4p0rPUHZI0zqiLDkx2WGu
65TZZ4WVHfyb+eKl5yQ7HKj3m7O9S8nh6Ael2NjlyQ7zmFadnMuq5MAdks3G
uzrZofnowzP6NxQduCVOHm7fkOxgwcf2gmOaooOy/jHpNZsQ/Lvl6R4rtiH4
PMsSf3zYlexgmxc8Pf0ygv/M8rjqZhUlOH+3POPbCF8lB2uBf6/27Ux2WHHI
RSO6ASj/iNm6bGuyg3ngh50WS5QcVnPr8bh3Jjvw/bp0W/6fssN6w58bJmxJ
dni6aOtftghVh/XCK/j9tic7iMmefLo/RxVu/iXXnxac3Qh+jWDu8ZA7CL7a
3QehC3TV4O7XttVj/Z+lBvcfjB84M4mvaiOSvK/43nfrgfY/nX/eLE3NwWrB
tvAZa5IdBBjSOCbaqjnAwv+FfVSQSooK3P2izmdfP56o7iD/sa1/MpCf8GvF
Ba4r6nD5mSEnPhh7ajjIu87d+bwRwT+4b66LTi0S/8WKyLDKZAe/uW+4edkR
fKZnAurPjqjD+edf222T7lV3uHm7POxIHcI9V7sXzgkIT3awm/Xq5B9zNQej
osL17sEI/8D4MP8adT2dJhaI4C+br/aSwReJf55vxzwPRHjC+LDwhvFh8XGF
+ZlitE+yQxffnTufs4Hy7ZsYjfwR8en7+vY7q+pkh5DARMEXTCpw+doVde8Z
VirB9fvqZbN7TFGCmz+B1XrLv1IEH5beYHxYeoS5H5ZeYf6D8d98uJ4SGoTg
S9sqb3sADI+61CmyF2cpwsMvyPvck7LDivDwreK+NevxHGV4+Mv2BUtmRynA
+cv2bPz90gHBb5sww/XsC3kHsyXfjlcA43fy2+s/lufLO6yKdzGb3Yjgw9IL
Op8psFvmr44CPP1Mif9q9qZYwQE9/wMACT/BCg==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4gObZxibKaU4mGzxTpWeoeywiudxnoVuisNc
1ymzzworO0xO1V1lZZHicKDeb872LiUHzsuOK2qcUxzmMa06OZdVycHfrCtQ
xz3FofnowzP6NxQd/H8951vuk+Jgwcf2gmOaokO64NO0034IvmJU2+TjQQh+
QEeDs0B4ioNtXvD09MsI/jPL46qbVZTg/N3yjG8jfJUc6j/JmN0LTXFYcchF
I7oBKH9EqW1qYIqDeeCHnRZLlBzev/UJT1NNceD7dem2/D9lh8/CEn/WB6Q4
PF209S9bhKrD56/HonKDUxzEZE8+3Z+jCjf/kutPC85uBL9GMPd4yB0EX+3u
g9AFumpw92vb6rH+z1KD+w/Gn1rdGDnTF0le34yDDxgeT5/OP2+WpuZQ13R1
0XaPFAcBhjSOibZqDrDwf2EfFaSSogJ3v6jz2dePJ6o7JF9eemsTkJ/wa8UF
rivqcPmZISc+GHtqOCSr72Fhl0PwWRfu6feWROKfPr6kVDTFwW/uG25edgSf
6ZmA+rMj6nD++dd226R71R1k901b+FgK4R7JvAPP8z8nO9jNenXyj7maQ1nI
hF9p75Ph/oHxYf4ty2F5ZPoWwX/V6Gqi8BKJv1GXed+TZHh4wviw8IbxYfEh
8Ywlt+pFskMX3507n7OB8pkXfQJfJ8Pjc+LZX5ZR4ikOIYGJgi+YVODytSvq
3jOsVILr99XLZveYogQ3fwKr9ZZ/pQg+LL3B+LD0CHM/LL3C/AfjG1z+tr7k
HYIfL+/EyPAh2aEudYrsxVmK8PAL8j73pOywIjx8q7hvzXo8Rxke/rJ9wZLZ
UQpw/rI9G3+/dEDw2ybMcD37Qt6hqk1UeAYwfie/vf5jeb68wzvH5MZdsgg+
LL2g85kCu2X+6ijA08+U+K9mb4oVHNDzPwDENrhy
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1GlQ01cQAPBwSIlYp+FIDEcg5uKog3IqtbAw4ABStCigjog4L6AtR4tC
FDm0JMqNWrGchUAhYJSzoqKQ1shZrhIQECIw2OI0wIApKO3o9P+leTPth/3w
m3m7b2Z332Oeigvi65BIJC0iQonQJqJIz0ddoUKQR3n5d3s9Fw7HuP48s4jA
0iqQencNe7cyNItM4mnc9aWO+QIL+6vxmi1vUnhwqMzyWsorBDnGcWS+lAcv
FuqnBuexC1Mzz0tnsRvmZdA4hWBI5d5qlkucD1efnJxAEC04GlYIPFi76XkM
CK9V3/eg8Xjw3frAu3tjCF7xTxzxzeSCMn/KXjCKgKucDa7YQVhygLZvBEF+
rE1OUB0HlDL5e+NhBM218zl7rTjglmdp++kgAv/RRuGxW2xQl7oHsH9C4JXd
eu6WNhN2uwSk/taBYIb6q5lRqxXIZ6VR8U2EI3oNyqsYcNGVB12l2NeNK3PH
crDHO1kSfiYC31p6UOcuK40NKVU5yiXs9M65fvsJJljQxra35SEo87lZMmDE
ghtZXc/jihAEOr13fKhgA1pnKATfI2jXr/+so4oDlmEUcWs5gmRKTPfhaew+
3w+ccz25Gv/bL0ZvSfNkAQLZVs8k+3ke7B+6LTp9BVsVInqsewb7ceLT5NIw
Ij+tZY9ai6Pxcy/VXtEoW+OlcolWupgNO937T9ScxKaTU/keEdgCsbF+CMJW
XYnJriSsF9aUMCNlwy5tW3NmJIIGa46u3Ts2mF7ofMuPRVAXeOet3TQXnkWd
9SxOIvbLVXDbIYEHy+yUe+tC7CSm4lrUVWw90kRfQc7/bV6Rn1sywtW4PyNy
w+QQF5LI4XWFxDycTRvsewY5sF++QrlM1NvhVvUmNJYDS1m2H9ZcRND25NHx
p0Es6Dj9x7B3IgKqsVQq2bld43D9F0T/mRoPCX8Zat5ggFOygaqDqO/Z4hxd
3W0BK9Zurn+VYK/+8Im7fi22fHRVndWMgLmx58/+swx4PaIz5vwIwUGqfsBq
riUceKhY+Pg+gi+WolObhRZADsl2T2lBcGTztElwiRlIWZVqEwmC3x3YSlEG
HdCKJ12X2IfguaGVSMdtMHG0qMDrWwRNDjIPfwoNnq0ZJOqIsGXr32yqv4Rt
5qe06YnHbu9pi70Ug4DuP00/XrcN8p2MojLisSPucBSCRGwJ+fqTFmJ+Qd52
pX48OjiSNr9sTEFQMVUgaU+nQ203pauNuC9ZPFWj2GKqseLB5YDkEexTfYnn
DKnmMJa2YH3mPAJ5R5m30MMcIh7M7AtPwPYblwgCYrFHwyY3sYh9sxnmvWYX
mmm8EJ8u3lpM19hvbmzASkKDxfUfGb1fE+9VaFdx0JkKsq5il49E2IFpnytp
1djqyAtyw04Eiw7i5dpBOhi4mPL7BhAk3RUu3/BhwH//138Ar6Zn5g==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1H9Q03UYB/CNOXCIIQMmQqHAZBNv+35B4KIGPVSOH4c4Ns1jRCvws2Ww
gTiWeSd1Ib8WDEfCASJnZDhNwstfHT9MVzAEIZzpkUhH3fmLKErhJI6o7z/j
ucs/nj9ef3yez+d533OfkJwCJeGwWCw2U5lMuTE1xqOu7tUS8LQVrojroOBH
dWPZgo6Aqa5D+qEnDT/V+lkN7xIQbuvhXPemYf1Gkz5BTyB17pgm35eGtYm5
4SoDAafH0FiAPw3c23sXl4rRSbG7htUH0KF3LKcuVKC9H13q3F2DTibmuFt1
BBRTQ86f3WmoDD1hONdC4KJte1HFOAURupnq4GMEOFHGaYURnfXFbNq/T6TL
VlHz0Wu70Sel6xwD1VKQCsoH6o8SGNxokbFuSqD6xkunIxi/V1xU/vhLdODU
WXt8pWT5/iLh6Nu5JgnsV5dM3m1F21tN82Ft6P6bjzmNjMsOiTV0gwSGVhZ4
e31OoIsVnXryBwnwunpP/GkjEPnNfUu4jF52+IjZlriTBv9tOpGqHV0cOWzM
aUMLPpI/Gg9CT3CMmjwBemzkqeqpP3r8oKXW4EcgnW7Jm6RoeKt+Vb3NnUCn
YCzX/lACq5/c4+5jLDBlzMIdCeg+CL77KZfJV/D33L4utFoRcKTJhrZ3WoUB
zcw8l/csLHFxfqVbDl/OQy+wvb1CvdAtcnVEjRfmm8zs0eRqAiW3Bg99OySB
4atbPrMGEoh4dcqUwKHhUkh/3rUQ3I9W9px2xWvoqgf57Lg09POF2ZEOJVrP
L72yqMR9ddnV3+U2qvcfKxvd0tTUlPIXBY7G7oYXGI+muyel9FAQsq4oPyGG
wPvGN2t6DGIoLe2tSt1CYHrAOnL8NxFIzgTNHI9izsePek47RNA3sUHdHoQu
b5+e/d4X/WDNi/wbPs/6K73Z0VeA9vA5tUenE0HVzlJaxicwe1aR15wkgljz
mZhqf7TrPpcztT7m6FB06umLR3eJ0bI/sjoOSNGjprSJlTFozeAVdtjL6Izn
tL7yRPQna4L155LRB3d8V3I7Hd3N5ft170Bvt7i9npKFnqE+7o99Bx0f5hM4
l4Ou0PGiZNpnbR/+ta+uFu3KL/qVJSdvN1rh99BXno3WvCF2rs9Eu97n8mCS
0nlEgT68tXm/KIXA/Ne/ny9z4ryHVUahxy9o1qap6/pVYswjwXK/UoiG2ozW
a5vFEGW+11DH9Fs8b14qzBbD///f/wAO+lPT
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGINIGYCYjPHrg9PXdMcTvw+s+WGkIoDjH8+6/SpA6c1
HSY+/2UXYpDmMCPJ/XHAA32H0oIN5hc/pDrUKF6ekK5n5LD4X1Vr6JtUh0B2
3gjecCOHYpXp/xMepDp0KJ7dvHaXkUPXcrnMFTdSHeLK/fiqPhg5LHzHPCHr
WqrDnu5n2+f9N3K4EHT4xJGrCH7RsWczp15E8KN3L94acQ7BX5DmIVp6GpPv
tstlluwzBF/3r5XawdtGDs7zTi4+cCbVIfr48m2nLho56GRWr4o8m+pw/sWi
mjlngOb7Sy4xBbpvQ/ebKRHFRg4vV8o/LXyZ6rCk+1Oh0HNDh8uLZjZZ/E11
cGfpUFc4Z+DA0i7uskQ+zeG+MWPpzhO6DgfyX1xK0Ulz6AkQ9Ll1WwPOh4Un
jF+l9WDe8+tiDn1bS9WU2dIclizhmrCplwPuvgU9D0znvfpsX8TUeUcKyH+w
eNLUXdM/28P884HhksdUOQSfIU7wT/7ST3D+BLcvinG8H+1h4QXjw8ITxoeF
N4wPiw8YP8Y53sDvZqqDQ+nh6J6gT/alSuXHP3wH8iV/nfmX+t9+wvVmz0yp
NIeEYP726BNcDmxngw8tAKYPH99Cbp/zog5yCUGKl+3SHGq+LTN2dJWGpye1
dPFDCncVHNDTGwB3hjW3
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{185.11816210156246`, 18.164155500000007`}, {185.206424890625,
     18.164155500000007`}, {185.36987449999998`, 18.164155500000007`}, {
    185.36987449999998`, 18.335232757812506`}, {185.36987449999998`, 
    18.512848000000005`}, {185.212962875, 18.512848000000005`}, {
    185.11816210156246`, 18.512848000000005`}, {181.01884589843746`, 
    18.512848000000005`}, {180.92404512499996`, 18.512848000000005`}, {
    180.76713349999997`, 18.512848000000005`}, {180.76713349999997`, 
    18.335232757812506`}, {180.76713349999997`, 18.164155500000007`}, {
    180.93058310937496`, 18.164155500000007`}, {181.01884589843746`, 
    18.164155500000007`}, {185.11816210156246`, 18.164155500000007`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4um5y9cGTkx3aJrRws34y8QBxpcQu8PPoWHq
MNlCe9HdCekOCzQ4O7domjrYsYQu3tiF4PN2VuusrUl3WN92xHbaPhMH6xwl
490ZCD6LJKPo0XhMPn+B4zadchOHt5/W8jOkIvgHNl1akl+M4L9ffsy7vD7d
YVnYjH3r1yH4s1rL/CYrGsL5XyqPBm9/ZgDnz/t5VWbCeQOHR09fxszKRPDn
VVq+cUnE5HsZi/mm9xs42E29PM80FcFfkT/zsmYDgj/bUmWrZweC/ygkO1Gs
H8FfxHbZYMsqBP/lbBPelvWYfJj9S/Vb5ugtR/Bh4Y/Oh/kPxs+tT69mAfof
Pf4AtwPITw==
    "]]},
  AspectRatio->Automatic,
  ImageSize->{191., 22.},
  PlotRange->{{0., 191.}, {0., 22.}}]], "Output",
 CellChangeTimes->{3.516627751092247*^9}]
}, Open  ]],

Cell["NCTeX also handles standard functions just as TeXForm:", "Text",
 CellChangeTimes->{{3.454894885693379*^9, 3.454894914491127*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"Sin", "[", 
        RowBox[{"x", "+", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"y", "-", "z"}], ")"}], "/", "2"}], " ", 
          RowBox[{"Sqrt", "[", "2", "]"}]}]}], "]"}]}], ",", 
      RowBox[{"x", "/", "y"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", 
      RowBox[{"n", " ", 
       RowBox[{"Sqrt", "[", "5", "]"}]}]}], "}"}]}], "}"}]}], "\n", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "+", 
      RowBox[{"Sin", "[", 
       RowBox[{"x", "+", 
        FractionBox[
         RowBox[{"y", "-", "z"}], 
         SqrtBox["2"]]}], "]"}]}], ",", 
     FractionBox["x", "y"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{
      SqrtBox["5"], " ", "n"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.516627751116364*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.006024096385542169], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{3.9496992000000004`, 
    0.7906855999999927}, {6.879338025000001, 0.7906855999999927}, {
    6.879338025000001, 1.3884439999999927`}, {4.5474576, 
    1.3884439999999927`}, {4.5474576, 30.080847199999997`}, {
    6.879338025000001, 30.080847199999997`}, {6.879338025000001, 
    30.678605599999997`}, {3.9496992000000004`, 30.678605599999997`}, {
    3.9496992000000004`, 0.7906855999999927}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4pmfjr1bflvZYZq2eOuOd5YOMP4Dp8Ps0hpW
cL7arEDbxzpWDvt4BMTu5yD4BtZVmy5aKTnEb2zrvjPZ0sHK9OGKZe0KcL7I
5Ebf5+fkMfh/bBYaRbpbOhx83MAk4q0A55v/4Pl0pEgRzpere+s/o0zJ4ZW/
DmNTO4Iv9/pzUlGSCZy/6OWbFAN2E4cDmaHLitOVHBZYuvE2vjB2+B4r+Of9
UgU43/3Th597WDH5M8HA2MEu9Pzkms0IfpXQ8YLVSUpwfoxFlLyCpjJCfdzb
s1PeI/iV0k9XHZ6nCucX1B12afZRw+DD7D8gtNgpYI0qnP+DLX7GmVfKcD4s
/HearXdNYzGB81OKstJvJCH4sPgDAFRY0xc=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYkeTz09mWRk42GcrOxs/MXU4+No4/e9nIzj/
SPan93zixnC+jS83c7UbJl+HL73OVNwMzpfcuGqnuZcZXD+MDzMfxofZj87P
nle3egKvJZy/ZelmCw5DBL+IzzngVoKlQ8jE9StnsCP4Z+9cv6OzUh+DD9MP
48PMh/Fh9reJnVg031ALzm8Q855Y81oTzp8QLJm9pAeTD/M/jA8LH5h+GB9m
PowPsx+d33/zn9UdOWM43+3SybUpv43gfKdHhyfqnDaC+x/Gh4UPOh+mH8aH
mY8e/wB7Sd8l
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1F1M01cYBvBa/EAcWhhSOgZKATGzfq3/c07Bga+ToOIHaAxWJVpIRYbB
BfwgMKplDBAdKojEBKmpoEYppQgWKlhQY+wiMCzr2MSEIeNjaOMQ1BC0sTc7
x8yL5+J389y8ed6AxO+37XPh8XjTnNnoDN+Zoti8y/a1GMa6m0hrAYKZ1g6h
fzaGBZpgi0WFwBrduS5gC4HpK4+8a9nOXFvoPRp2kaNeLgv9Ok/EQWqSdnfG
BAbBgVWNX9RLwXTjxqUuCfO1J75hM+IQ9a61dcuKJzmwdxl8XkdyIGjn5o5b
OFjWO6791x9B/91kk+IuB78ZE7ymA4KIMq3mnZmDF4cOnFBEI8gJL8yef4X5
aYKvG/+nT31Fd741TcYcORJnrnBjTu2rdGSZpNS1URKfOaeZk4/HxXyZLYWH
E8MxIi2zRbl8YLWeuU6Yyner42BOtV+K+pgUPHX3ORjgYF55YH6TXgqak5aD
B0c4KM9c3DZUz9zfZXytb5JC/PiOfPBBMNjW4jE8IoVS1d4jswoR7f9K15jV
PsXM44faLqzE1FXqhEahnFCLE9/2Xu0g0GJM7cwI4ag997T/NdnH3DNT1pmx
H0FmUvmxO2oCan7pkoQGBEeNE4vmJhLIvRmWK+hGoDG0Hy5xJ5A+I9j7XhCG
/WWfiV5dx1B5XObICsXQPDpbuTMCQ1G6rb9jMwa1YbffgB6B/U2DvygFgyQz
UlPggqDEKi6WnGLe+dzm8XgBoTb/yndkZRK401hW4BXlvLPl4bkNzwgMHxau
eCLG1PGi+J+V4YRayF/qGxxNIM9W/0PRFKaW6c+6gA7D7aUTqHATgX2uRl7g
eQwizyqBQPGRnzWvSVcyt9o9cgNzPvXCsfwzA1rmlGQXQ46VWS1X8wJthDpi
7O1QCU9GndfUUZvjKYPTlUPfuSYzj/a8fNEX/5Fn/dGskjOb7KVpvFUEfnQN
kVvHCcx/dSs4jCNgsJ4b6f2HwInurSG5fgSeSkyDZiuBNbrqNrkXgRqx/azk
EQFx7YOjsTcx7StaWNEds565a0e4/7cBzFN7pm13G+Ko/9vD88nVkrYkQm1o
LR7c0IOpN/UqJy+pMLzpfGRzr3Hu2ez++98Iw5LQwT8dYxzc+uaBouE9AsXn
UWnekQiCHOkZIc0IVCsqSh+fQqBOVP5ysRrB///TB39W9xs=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0,
      1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGAQA2IQLaJs5LnjmqXD95mZG0/9NndoMlz360qFhcO9OQyV
T+8j+LIhj6yOTTV3WPZu48Ryfks4/1rG0UoDFUuH/fZeExe2IfiCIS/EGzgR
fNOMeUJu0SZw/gJLN97GF8YOe61LitbyIPgbfkt138uzwODPBANjB6dVW9gn
7UPwJ308mrXV0hLOt6q9ZVJRieDD/Afjv4lwOnVRzQrO53r2oGFzNSYfZv+C
i35bPB4g3AczL1pJfI7jVwR/ks317w8jTBzQwxMASxedyg==
     "], {{
     25.838749480000004`, 25.649190474999997`}, {25.838749480000004`, 
     25.966749625}, {25.603693442500003`, 26.175342399999998`}, {
     25.340617480000002`, 26.175342399999998`}, {25.049521592500003`, 
     26.175342399999998`}, {24.842485480000004`, 25.90759645}, {
     24.842485480000004`, 25.649190474999997`}, {24.842485480000004`, 
     25.3798878625}, {25.049521592500003`, 25.1214818875}, {
     25.340617480000002`, 25.1214818875}, {25.603693442500003`, 
     25.1214818875}, {25.838749480000004`, 25.3300746625}, {
     25.838749480000004`, 25.649190474999997`}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIzIGYCYrdA8bg2JhuHPA3Fv9Ls5g4wvmnGPCG3aBM4
f4GlG2/jC2OHotsqWuzPreH8G2/WXV9uj8mfCQbGDrOWiqx8Ow3Bv5xfHWMr
aQPnmz9J2HogFcHfuJTjfeV6BP+lvsA9BwVbOP/D/CtNXcWYfJj9p4s6Iw6e
R7i3mbtFl28rJv/9A3W+B1EmcP7/zY6NQXpmcP5zTiuBDjNzB5Pnrw+lJ9k6
BKxr8TxzxNxBiyt7xrx/CH4to3Jw4Qw7OP9ohkadymY7h+IXdl7brBF8xYnb
Pi5fZQbnw+yH8WHug5kH40dcua6x4ostBh/mf6aC5BehXnZw/tdH1ml3jyP4
26Kdimfx2sP5l1Y0pn4OQPDXnZvO5HoRwX+mOztGWNgBgw+z/5aEG5ftEns4
n1l5qu+aVEw+8zrtNBZTEzh/x5vsHckyZnD+qR4h/4nfEfz/06K3urmaOxS6
CDNFS9k7rGL6vzRsvrmDfdSOtuofdg7TWIXrp5w0d0hXWcGatMLO4fvMzI2n
fps7RKuseyQtg+C//79E4ViWLZz/7L6lytkfNg7e79L+GE4wh8eveqK3ie5X
RHzD1MPS7705DJVP7yP4siGPrI5NNXdY+PRD3cx3CD4sf1zr4Sm63ozgw/IT
APCacR4=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4lf3Kme8merqkPP2Zf/VXC0HA7+arc0zXB3U
pkVH8WZqOZTFrjO5v9jVweKzuDy3mZbDazNfF5elCP7y8o91MQcR/P014StV
jyL4Jt9Upf3PuzrUeS0LuWyF4MPMh/HDBPKdjtVqObxrU/63/YyrQ97Zim1K
HVoOK8QVHyqccnU481AgwX26loN78KP7PnNcHe4w/sxN9td2EH554nZ0uKvD
F8a3m9+n6zhksj5MdeRwdVBmumrPMVPPYUnJy/hJdS4Oma8/9ribGTpsv7hU
ZYK3i4PQ3UzF7WuM4fwSdp635oJmcL6BT0ytdp2VQwBHhW7MGxcHJVfO+UIS
tg6yH/d/aD3t6tBXI5Ly67Yd3P172x7s6HmM4L+ZsIZX/jWCX5m/0d33A4L/
3iE49RynvcMEod3bwo8h+G/K1nCc3Ybgl7la+QosQ/ANrpkbVC5G8N2bT617
Nd3VgdVvW2P1VzuH+2zZQQmyrg5HHi+KclGxcyg3svCqm+zi8HbWhGszDto4
zIv5kbbAysWB1Wiay8VlVg4bXs75Zc0M9P+GyE6RMEuHu91y67qfOjuoPPvX
b7HbHM4XN77MPkfYDM5/IvR3wtptxg65TltllGVdHFYHVS27zmXoMHX/NYaE
Fy4On12ut8qX6TrMsJ/aWcjt6tAmEH7u3jodh7AVKgudrV0dGOTPLnK8qw3n
7zhul1t5Q9tBaOJXfRYPV4ct6R/3Ss3WdoiMOP3jU6SrA9ecWv3zntoO5y7O
zJJJcXWo4b0096OqtgN6+gUAF7YyNA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H8w1GkcB/BVp6vLoFJGHFZ+5O7SaL/7/YbRfIjv81VEtDu0u4QhrDux
duOQqdXduLPp7pR2rC2j5erQsYWQXGqPiJslw0SuE6dLbpvTjzuTu/3r+8zc
H58/XvPM+5ln5vN5PtykrOiU1RwOx8JcQnOtMpdjq9HWX4eA1DpYC86TUF+Y
nKxuQNA3KX3zZJwE08BSXVE/gqimkrDBuxQEfodOlnMZ1m97cw1dXtjXFy47
rKGxWwd5EHOEgYiVqZdOdebzcHlbUCAD4xrl0TtqCjzp05fi3BlQ3bitfyfC
vpgTvoVyxda4KcS9b0mwPXnC32EXA+l9IxG3+knQemn192Kwc6rP/h6Shd2Z
O6VzrmRAn7U78O9X2PEF688+iKVY+9dwd7hMUKDN+id9VwQDb9TpzfeXKcic
zSo744btqjBJRicQayfhKtlKI4KFdW3cHwop6A7K6J/QIgh1Nt5sCKVgp3Is
Lb4YwYXZGt2TGQoGm1xzLgbgvEDQO7HdHnts9RxXVkGzFn10n/M8nIZi3YGq
wZsk6++vVT8OKMBeEJ7uOpRIQu5wgiovDrtjT9JVGzF2We4rhzWp2JfzRSHD
6TTk8b96fSqVhD/mJYmpmTT0DB43jRSS4CSb3/NBJQ357SNlAV9QMCUip188
o9n+2sz1dH1jh+djQBhhQJ9g53Qo9FGxCCo8SmLRNezDnS+Cee7YP1sdMhSP
khAnb767EoxA3J7EL/Mi2fszT8V/NtdNQB+Z8CibgwB5fCwvdiGAO8JfTBul
wVYa0LZVz4Ox2s0lVDV2vTpsp+4cdsK+9uc9ediSDO97sngatN7D9ueNPNDV
0NzSIhriNl6qE07zIN/eT7BWTYPEeOsv0yaCdbLR39LuMLaVz1GOn5Zg881q
1bRHCwHGAWXkUAb2cLJf09eh2E/nf43c60kDlbd5rW82dkKw5Zf2XGxlGVm0
0Gh+r9sD6/dTaEgrFkY6FfLA0rpFYanBNrz+d8uzReyqhoM2Lx0RdLV+OnTc
iwB9c5tfhwuCh3vLZSRJwAZD5MxjHwRPo+Qneh7xoPT25JSDGLF5R228t7Qe
uz9ufGRxO8M6hLe0pDjGgICvUf34E8E6u6X3QD2Hz9pn/eSxM1v58G7bHblj
Cvass3h/dCJ2UEzKkLcQe3kmqflb8/8WPWQsLtjy4UbukYrlKAbsrGW7r6wQ
7P4p7aqSNP7JA5PUfV2wEbH9fe+ghuFfxZZHX9nmm4+9oxYFb0hB8Isy21Nj
QbD+sKBheL8Ae1IpDftNRYC4cVNlbSYCgeX17o0GAuh5K9/kzxGoyjsbJ0g+
/H+f/gdSVE6U
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4rPMEU+uf/Z2sM9WdjZ+YurQG1+h2hngC+f3
z7/+UjAJwfcWSPl8vBKTr8OXXmcqbgbnS25ctdPcywyuH8aHmQ/jw+xH52fP
q1s9gdcSzt+ydLMFhyGCX8TnHHArwdIh3GjbsbBbCP6DBJGVVw9g8mH6YXyY
+TA+zH6//AlRn5K84HxffcNpmYEI/sR9S3o2W2LyYf6H8WHhA9MP48PMh/Fh
9qPz+2/+s7ojZwznu106uTbltxGc7/To8ESd00Zw/8P4sPBB58P0w/gw89Hj
HwA4KOd3
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4q7TH7mOqAc6mN2TlTS+be0A45+JLpW14rRx
aEj8+fm2WqBDSN6iac+4bByu//D51iyF4JcyzeKo/hfgkHwm1vvEfGuHiyee
i06/huCnKC29ueoIJv/w1luH4yKsHUyu/TuncB7BvxXq8fP/awTfysHAnZ8l
0CFqjuGZh/0Ivt9p/pijTBZw/or9cYkvj5vD+UH2+VqHNpg7yO8pywy9EQDn
T38s2rHqOCb/X8X6qJkF5g7XpLzedp9H8FefvxpWwhoI509Mfi25RRTBV5hV
WeSrjOAv+Osh2BmF4Oto8JzSSMHkw+xf4r/6RW0wgg8Lf3Q+zH8wvuJRhk4z
oP/R4w8AqMXMaA==
    "]], 
   RasterBox[{{0}}, {{63.067600000000006`, 21.7477}, {73.6276, 22.2277}}, {0, 
    255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIlIGYC4hZ+1agLrQEOPo/F4zwf6Tok3V50RscgwEE6
LcPm5FJDB+466aQ23QAHb7sy8YCdhg7Hv7SobtAJcJBfmOZhe8jQQYcvvc5Y
E8Ev/6pl9EMNwTfOmfJVEcif3md5fsIBQ4cZrWV+S5UCHFSnTdm9fquhwzFT
u8l3n/k73CtOsMwyNnSw5K6+ZXvX3yEmLNHYQNXQ4dHaz/nTb/k77DuwJsBG
GcG/ZZGk+00MwX+mtE/49l8DuHkw/tKln8oMXiP4UuJ8LY+EAhyi5hieMfQz
dDhZGnxKtSjA4VHMYZ7cSToOh8TVgs1LAxzUzLvWHE3Qccg9ltnRVRbgcOvZ
sS8tkToOP54kLjSoQfB/fdBx1GpA8B3a+mR/tSD48t+cGH07AxyybrzvnDpX
x0FnLv/5WamBDl1rTKcUXTVxULV/FL4mI9DhgY7q6ZlvEPxg1VP3qr4j+LfN
v4er/0TwazlWufWLmzoY/7Zx60wKdPivutLnpKqpQ2h3R5JZHIJ/kGmG0Ypw
BD9rqcAJxtBAh/CEE6/eCZs6yGxqLHEODnS46nTyyRZWUwf09AAAipzumQ==

    "]], RasterBox[{{0}}, {{69.5477, 20.7879}, {73.6277, 21.1479}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4r0lkyVYnIMcuooy/xT5GzicOv6OKdUYwZeX
XH1W0CjIQcT+2B1ZDQOH92wXozp1gxw0I/2cTtboO4i4bd60Vj3I4ebZnjqR
SH2HzXXGhvIqQQ5f7jiFBznrO/yQ07MsY0Twt1okz5D9HQjnW7P0sYStQPBr
DDTtNlwPdNjGX3m61c3A4de8iRzFzwMdikw3aetWGDj0er1iaWIKcrgf8CNn
6mkDh6Q7vIteKgc5sIRXMhmaGDrA/HNdnDNXchGCb5l4KGOalxGc77466lKi
orHD5NP1Hh+FgxwuhalOrF1i7NAd2mzAeTsQzp+2udzt42IEv+Xbq8cL6wId
ljkvf17Kg+DvCzhQdiLbCM4vLYnpbREycnC2D15/eEKgw44pn4/e4zRymPbW
+d6nKQh+l+2Wfv75CP6KJ3NuOK8OdNhSeCQqRRPBv3LZ/QF/DoKf73Y2vLPX
CB5+H4Xm/HI4Z+RwOrBBo2ASgv/U85Kp7oJAB5cO7fTnDsYOhdP/7vLdF+hQ
NyH1YEiKsUOb7dsPopcR/HPHty6M+4/gz2x7qJwkFuSwfMp1rx83jeB8pXtW
//28EHxt/Z/zj6w3hMdv6TM5oWmmhg777qi7s78NdLBY/Gz1lq8GDhrujIvY
mgMdzu/7pLB3nh48vHbHzVL6UIfg5/Ndz1pfjuD/OJSyKkFEz+Hu7PsGpqZB
cD56+gUA4RhAWg==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxd02sslWEcAPAT5pqZD0XEOOo4+eCI9+K4/uOQkaj3aSOXws6itugilRgd
UaRVMxOF6EITkqy5prXksDmFjuZkE5VbFyqzSJ0v7/M0H/4ffvvvffa/vfbx
yXvlugKBYJ02dmhDRxvKjLipno8cFHuOGPi8paFcshjbv8xBcM6K0KKIhmPj
+cMqcwTRtyMdLofREN3++DUSI+iLN/D4u56GqfOyLc0SBN6yas+gRQqmjQUV
tR4IShLpXmqYAkvp790LPsSFSq+amUDiGdF2w3NhCEotNXaTP4iTVzdMXdpM
Y0fON/VpXGjYuZz0xSIUgeo5mo4J1ubLUwtzZQgs8p2adkXTIF7olYjnOFCM
WfuDEQMSn4Nn2vwQfHU1HXJrYcBFp5NhghDof98YdPUZg9+X6zXMNw8Qe8xM
Pd2/RGymEmYJ7Flcv3lWr7rBl8X98T5p6kZd8SK2SL15LU2K4CjS6QjxZiHA
evSl0hVBTpz83ZKYBX7+KdkHMv28GFy/vu6mEOEgC+Yd6Uy31nVjuR30Txbn
XxUUhyqd3cFMXpOf9J4YRdRWLgz+57ouZWA/B8JG8WiLKXHGUGti9RyLnaDe
49KpYkFxPeaFUE3qyVhoDPe8yEFZvWOrs4gFpiv81LYsDvfDm++X+eYe0JNO
bGvVNl12gtjmbEGe+jCH58mbnzdvfh/pH6RR4cc56E6s9HfS7st25o3VahqH
93nk0dZfZioORMYTMXdMSL71yXx/YyyNv69a+hyBEI3fl02GNUgCiPl7483f
I18/f698f7wftNuMyzKJDfc1K6KyOfAsWpkoUVN4flvzbvTMzlJ4vtJDFcKq
ERrPP1+sGZezFPaArwl314n41oWSewl6FHg7RN0vGOJgPDqRs/rkBo6liwqV
hpi/l7X+Y3R6ot6OwvcTaP4wRSSjYO3//w9nT8fv
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4tlxSTrN90MdEl3DjWtMDR1g/An+yh18tgi+
jJ7GIRsnQwe+Pf9Nbl0Jdbh1bP6KNbmGDqlnYr1vtIU6HFtzduu9dUYO7/dJ
vr5YFOrwnofzHP9EEzhfIDbgvpG4GZzPxizprXTZ3GG1/rIv7V2hDtsVszet
7rN0aO58ciH8eqgDw52LSyrPWsHtZ+6p+KPxBsHvz6o1C/+I4O8r8ex++QPB
Z7ORD7nBZe2gNrF2AuvdUAdTt9crsoSsHWxf/XyidBPB3yi+Xu7OJQR/TXvl
gvszQx2as5qFBVOtHG7UCtY1l4Q6rLso/lxE0dLhDV/xZKWQUIdpF5UXdnBY
OOxlWW43wSfU4c7SDIcZb83gfJh/YfwX6910IgJMHVhcDvZ0Boc6FGoXr2yQ
NnFIaXARzigLddBS3MyX9NvIQTE0ziZ2TqhDrmtg2KGDhnD3vSreKvpb2hDu
fhgf5j8YH+Z/qbrGrF5lBB8WvwAcdtQQ
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1GtQlFUYB/ANAgZYrhIQCBsst1QM3n13X8FgH8hRaBDZBc4bICooGzdF
ER3j4qCgEJtA6wrFQhYgyEUD0cyBgQxQjFhuAi2YSxqMQHKTWybY9iHOTH34
f/h9OM+Z8zznHJvIBGGUOoPBeEMVWhU1Vaq36DRGc2j4INYuMC+CAtbLaTTO
pUF8LGRU8xy2ecA+C24O9n4z8im7GJvsOjey+QEF1qEtCzbONPw4NaF4oqSA
O/OruI2NXbXxYnuaFfbg+OvgrA00HBwSuDT3UMBRigoUejQQVsqM1GoKInzV
P61k0nCS1F9sLKGgkrmxR6JFw1FpxJmH/hQQfIp8S4MGgx7bdIaNygks9QYG
Da3mu2SKxzwgLmv1BbxCMMAtl/kX8WBqe4vTNysIvu7MKQwP5kF4yGp8wiME
VpUX8lLEJEyIzXvnFAim/rB46hZFwtroUJluC4KFO3bm5g0cSMiVBzVcwpb5
tM30nsB2qLlvO39EVZ/LXzNmk+vWmMywZJ3B9thRtt1niYQbuzdZyD5B8GHm
K1szKRdKSL0czTwEZSmuM8wkHgCzOdn0SwTDUdqpBo94cEtRaiqVIXCffPZ9
6Ar2bxrfzSxtotb9b78a6m+7DWchGHkmNO74iwL95gHlcjT2nq6c3S5bsWeZ
2vL9Zqr1Nsz5d8W8dU+oXX2RmISd6Ko5OBfKA4XMXHLcCrvGNfXyFWvsqMiq
3/vssP2dw6bi7BGsGegavnOAB8Psh8wYJwT9izuG2rN5cM1I9978NgQ92dmC
nacoYM+I6DABAnL1cPWDNgoCY5L5JiLsuEiHpcVY7AyWS6zwxP+d4/rS8vRx
7CdXxgSNHAriCU/HjxIQFExrH5bO8UC/ImLFKQ6BZE1dsPcuD4TcgenEQAQK
7/wMSQMXFmaDTtb5IMia0tqcaYtdE2Uzu1RNrvtbb3vtkg4OjJoVVper6vvJ
+XVvp3KAPrbgbSnFDolZDqBqsdc6Dja9fxdBmxIk7EoOhLdnnZb0ITD8mLxa
+5wDphLH8vSfEAwWdy3sjeNATmeBwKYVgfGhqiKNOQLkorZGYTUC7pGUnwXx
BHgx3tR6rwhBb4jISMeMAMf+G69rziJw2mo7dlbuCva6X/zgLMJeYp5Xng3H
vlbv7nTbC3u+brHekUKgllQVlkUSUJBdUUp5Ybuf6kw29cW+R5SG5Krml094
NKkFEfCYJS3OphEc+sWshRVHwP3rZQeKVfuN+E54Rl3ArusWRnc3Y5uYBMzf
NOAAm7XH4U8/BFv+OZAFB9zz+ZFjO7F15N2tLduwWSPEaLzq/p0PbvrcbZZY
N8/z4mrDUWy5ojJ75YUrBOhNGt3hI0j39kjLLFT1o/aW1y4R9gZrdh6qwN73
PDHMbxwBdX04fziNgFzxza8al1Xv9bN+w0syDvz3f/0bcDJbwA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{101.93208606250002`, 21.8913672}, {102.06907236250001`, 
    21.8913672}, {102.25431520000002`, 21.8913672}, {102.25431520000002`, 
    22.09062}, {102.25431520000002`, 22.2898728}, {102.06907236250001`, 
    22.2898728}, {101.93208606250002`, 22.2898728}, {96.59896033750002, 
    22.2898728}, {96.46197403750001, 22.2898728}, {96.27673120000001, 
    22.2898728}, {96.27673120000001, 22.09062}, {96.27673120000001, 
    21.8913672}, {96.46197403750001, 21.8913672}, {96.59896033750002, 
    21.8913672}, {101.93208606250002`, 21.8913672}}}], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsqrEBLWICow==
    "], CompressedData["
1:eJxd1Hsw3FcUB3CsiDeTrrbJkCHxSEkj7O+x3crOsUGeohsdae4PYdczMh4l
ghBJiFc0iXoUS5lqEsQ0JcqWjVQqSEM8Oh7bILEpFVHpFEk8urp/7e30j/PH
Z+bOveecufO1EkUdDWZpaGhoquozVWmpaq5ppXLPbQSyhpB7eiICDq/TEtYA
gnqyyTl5iQBK/0CIzXMEqP2XNT5JgtVUjKhmGUFA4Jlo23Rs1hf8yzkZJBTb
Mu8ILRmQPDLK4JlQkKaZbjJEMTAjSsj7LoICh7vnq8nPGZhaajVwZGgwe5so
WEpl4GzH3ljpMHb+Bc8/2JPYT2aObupepWHvl0pWYBJ2JUo5bZb4H+cEu92J
w2ZnOd9+rHrPS//IaMlrGppeSQylUQzUPjbpPjhBw/PNct4/vgywd0c7nvCn
QVGTd3PYiwHF9SlhK4cGOzmhMQXYpSEtI3InbBelgXagPQMOKc6mhap5vPPt
JSwrBjxaVgxZ2TQsoaCiHWYMHNqyXxbYSUOYVLMiVR/3p/fMgPtsCamd9PBb
B6MubJa5U7igFoG1UWTEIV3sZKtslucApXY7VxqX20HB1a1BSts6BGJry0eh
P1AQmP7UpbUeWzs3YS2sGXvYakxPIkUQVBDqf+U+BYnH/Yqnf0SguzvecPMg
BSN528vbHyD4ete0AA7QcOumO2fDLHaBwCRC4xV2YYOP0nYNe3HWnKWly4BP
qGmSkKah86+uKvQuA6fiYouU22iwKRn62NeRAV6LxqxsjYJSalDXhcJe5n/P
T/TANg7KFCypzl8xVhLWeRQ8cc+Mj1tF8BHd7K09TkKKUXtMiaqf2tGFax2N
JIiJjIKT/QikQ6IbYjcSarqaDKV9CPq22WSWuJLqfUycWAhoVxBQVWVQOZGL
YP2Fjv4aj4BYssHB6AyCT9rce4R1HLW9zk1vfFiKrfPe5JjZeQ7sCnkazUvB
HigPWL90DruFa09fSMP2i771oCcdgWdk1KaJdA5U/boQmZyluv+IkutQwYF9
Z2XX5osQ+LTdH4/7mwNbhKmimhoEbgOedeXOBNyTXXctuostDooU6/Zgby2U
VJODCLL2e7a+b0FA/mDXiHwSwacTnGa7UQ5YnrbvuziHgDvgnX3sBgcKFfze
jje4v9Q/vYqn9Ri1y+Kdejv2YVfMkor5CAbqhsLSLKSE2nx266naFezltcur
JzeSYG8h9IgJZ6BxyjfHgU2C68VM4/gg7Chzw/5Jf+ye33Nci/wYsAvdMc/V
IQEUx+rqGQbeyHbSClU+RY7VGRz3VP2HhAaJ3J8Ab7GgJ9iGUc+/mHM4uNMU
e2yqaZSrjR2a8M1vr98imClz+6BzDwF0bUL3i5cIqi6ZSTMOqvYXfEf+1TAC
Ld74z1GqfCRWBqJ5vQjmZM7ssnACNuys9v/wJ2zRom3/ZBv21bb8gJeN2P/P
238BjLdrvw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYi9HRlX/+BgHgdiA+0biZg4wvgVX1CTee2YO
LEzPr4VGxDis69MVfSpk4bDkaHJAuWmMw9cZb9czG1s6PPvgqd7EH+OwqcQ/
Y3GOlUOY3k8X5pvRDqZur1dkCVk7nIpeV7fnEoL/cIvW5ZvnEPyc567mMWei
HWQ7H5rwcSD4+0o8u1/+sILz+7NqzcI/IvjMPRV/NN5YOZyS57ExvxHtsOi4
5e+QfVYO/+5aZ9WIxjgsObLu7dqDlg4S7X0VvJYxDqoJ543SdCzgfJh/Yfw+
j1NnrJNNHFwfbi79oBjjwH3kj5rcIiOHlj2HJ7VfiXaQv3dO8k2CIdx+GT2N
QzZOCP4Ef+UOPlsEP9E13LjGFMFnMtzfGa5mCPf/q+Ktor+lDeHhA+PDwg/G
j96nd/i/YIzDHH/Z1SEnDR0MTkx7Gm0e41D4ouN6AK+xg7S56YU94TEOnS9q
ZO+qmsDjz1nEou6sg6kDevwCAMtFy6s=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGINIGYC4icLp2z9tDzW4XfjnoyZwmYOMH7dzt3FvB8s
HGa/Kw06XxPrkLz1Z33oL2uHJIaHzif/xjhMVtWcP8XCzmGfTNn9i19iHDK4
k9OsEu0c4jPWXX5xJ8ZhvqryoVtH7Bx68vYuKz8b41BavURm+S87h11/2r/8
PhHjcLnf5thpTnsH8aNsaRuOI/gxa3w5gvYj+LrTjtvf2IHg73gj8F9gMyY/
dt+sFV4f7OB8F8aJJu+e2jn8jxaWWbE1xqHo9N8j32/bOVz4WKZ5a1uMw7M3
P7pOXrNz0N+3SWbSmRiH4/1Oi1tr7Rw8i/fP43of47C736PB/qOtg1zq5pvT
xWId4jjumfresHFo1F0fkx8d68A279qJzndWDt//BVR9KIl1iF0TZyJVYQHn
w8ITxt/Gx/dN7YChw5SubMVcjViH8I3rDhwz14O775BkxuO1E7UcolUm9cZs
iXFYFROXH9iuBfePj8exozoVCP47Yz0ZjkwEn2HiqwesZlrw8ILxYeEJ48PC
G8aHxQeMr7/MzvTwuRiHa2UqK1bHaTkkp+Qlc/DEOoR5e3+TZNRxmH6uPf1n
AND/d/P/FRzTc2jZqR6ZURvrkBVuJMhQZ+iw9b6K+NmZQP8etI+uvW0ET0+r
tifm760wcUBPbwDL0S7m
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1FlQk1cUB/CEsI1QRBkMSKGAKClV0xjhW1g8LGGRrew1o9jcIYVa1JIp
QlARrMhUKxUaQKBopLZogaIwVQgqixAbOlSsGZGxCIXiwmKqghRamH4v/S7T
h/Pwe7gz557/PdcF7Y+V8zgcDpepRKaMmKpY9cjpsDGCwanQ2QQRCZcGeQ1x
RgjqftmT3zdDQIcyY9ThbxmsqQkcCVURQCwFyV8ZsIP4+muxy3y5aKyw+yl2
W1Ut7fGHDNJdxfxP6giYWydJUU3LIK3M+KKyk4DGSf5U8HMZ1BN7CsKWsB9+
l70z3pxk/XXnsHDfJhIUHT9s2D0hg1qpRXN/MAndJuqY1ePYO6ICnp19hF09
c/PF7IAMDlltDAFHbEFoehZ/iGDdeSKuofo4AZZ+fbrdTL9OMec1rckE5Hop
hsCAXZWUmZg9j70rXfp2CTOvcNM8D20xAe2t7TmO5giutWhTmx4ScKRrsMH3
DQSiK/Mtx3MJOLM1eHLRDrHnT4sjHxS7YGvENpbuNLZDSkmxKARBbKBD3nqK
ZN07fOOb1x9h56T/nOd9lARKEqJIDcIOTr7frQ3EtqmWr7kN2F0L2wqLGd/4
ArWWKknIzbi0vW0bAvFFL/JFCglXojk93t4IMrlCsX6aAF7TQNv+zYjNt6Ja
YlC6YqceUf82Z49duWsuMdsWsXn/56LEHy/YcEnWdJJqNRKSIP1w1YkzaxGo
Bp2/+vQuCR1PXz4ud0YgSHmyd6aMAp+0A0O/uyE41X9HP/kWDboSqiyf6afp
Zr7uVAQN7iLz+lJPbF1mXC/HC9t1+Fu92gfbwImWOvsjOHdbcMfHi4b+q5WZ
+5j536q2WDe+gQYTh4H2SQLB9dNWK5VzFGtjX/1V3QPsjefGlWnNFMhHE/1z
mHm5mGpem1RSUJfV4rgdsF9arl2wl2Cj+Vd7uREIvlS8W/WnBlttt2NLO49m
Hf6Tme/JFBrudclt0/wQfL/SzfDmURrUFzqMHntij/opPg58B/uyc9/7nUw+
NRXuA1vDaJiNEIpsnRDMaMNkz81oSBCV5rox834v3qs+P4qG7rsJGmtrfH4k
zKK8l4d9yKPWN2RSxjq8sU8bMMTsZ8/Jgpg6ivVSnpnpyAHsyJl5QVUyBUEx
6uj4EexKQcDE4jIHCAxjg2PYsxrJB3bMPn7W6ZmlklMwfX+L/SZm30tbijLG
D1IwJU493Mj8B8LPm12lRjQIF8NjC/+Ssfkq3ZLPRvJw3gJ5bGD5imXvw/TX
nmPMfeOy5Px/NmNTK6xNbg1TrJ/lRvlbXadAX3Ew9Amzz+drJpJ6EQX3bMqy
JywQ7OQW5Cysp+D//+m/5FVaTQ==
    "]], 
   RasterBox[{{0}}, {{142.388, 21.7477}, {146.948, 22.2277}}, {0, 255},
    ColorFunction->GrayLevel], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+A5HqRzIbOawAR04Cnw==
    
    "], CompressedData["
1:eJxl1GswnGcUB/AVsqkQZK3sdFY3SyRRsuvdlxBCnGUxNOmgmi3TqPcJada1
NNWOREhdQ+4iSeMymlipS2qWLuMaKTHNpdpat6KoVGnTjXFprMvS99M+nfbD
/8PvwznPmTNnHiuUEBylz2Aw9OhI6WyiQ0QvVbf5I3Dabzj2XgsJA8/b+4sD
EKxJSm2mVNjW6rT0rEHsVFRit3MSm/Xp33ZVTEdw15YJ+X4Itr3obqm3dAR1
xj6jKG/sgKZVSy1gh64eHBlwR+CaO5DXbe4IDYSROt4NQalFkPmReRIiQmXB
j1wReJU5yuqnSTA/MbzOPIAg6H57M6uWBG6A2mfeGQFHnhkhzydhj1ShkZII
Mh5ftL6rEUHKV3GdBiIE7EVOinuPCG6kSg3EdgiSf9xtGTZLAFQoZTffROCr
4YhVIwTM6l8Zpv5l22bhmmongsp3F3NOeBGQF+6r+NUE28Ne9siK8X9rn2Qs
Giuxl++FnL/Wh031xEpznURQc/WYzHgzgl4bRXlkuQg4/i0/pRkhsDJh3WEL
SPDtrz1lRL/H0ssJVEaR4DFXLOCbIpiI9zchTmPHtp4qCPwC+7O4hMaalyQ0
E735J5kIPDr7brgRjsAleXLNCqVz7TcX+rKnsGei7V9pRihgtzQ01ruTOif9
qf/4LR42qS5ajdlCQtPBmMbZMewa69HIK+PYZxa4e3Imsb8vFCtbaTMDL+wL
NSOh40wdOvacAr6cVXprFwnxLg9dqmYoyE5Zec24gQTicMXWrjkKJElkYvUK
CcXn//ByWsGOEN9WPNViB0g0nHMbFNi/UbMRM43d6ucs3dyG/WLLJ1evXSdB
Gyjr+pauvzM8IXkWR8JTi7GpB2sUHA6b2yY/SsJ8amJl+AIFh8xCy39OE0HI
TGt3ND3PZY/TwoJD2NrJ4ELmHKFzUuFes997saviOm0jzhKQkDGcIF+mIDye
6PtSQkAZ93adHX0PWR96FXRZEPB1ia0h0xCBwiAYDRoTUFQTZKo0wZYvHw+z
5GD33Dc72sBDkOsqLmq1pfvlcRsrdiPg8W/d9YwgwOp9vawpawRlyZqYTQwC
vOk9XeYj6Lx+Tj8gzgF6N5IE1XQ/sR57F7ddCJ8zXndb2I7gVbBCNB4khPre
cnYKPc8HIfm5aEwAkck72jzXKZ2FTFPVd2vYticLOofmsdudufboJQXTAqln
9ttCmGClp21dpSCRldFhdxzblFeRas500Jnnzfgo1hD75lKik0uyA9g0reVQ
ixRYjZYoR/IcoPJBOMWex176QZX+zl/YPdy9WU2/UWA45HeP54OdMnd29JJc
qLPEp7/WZlEAyevqOvYsBfF1vh6SjwVw0a8yM2wdO+nAQrUlG+k8+It7f7EQ
wcMSSeZ4thAKXDqe+exH8CR0SLWDT8B//9d/ALN1YTg=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsqrEBLWICow==
    "], CompressedData["
1:eJxd1Hs01GkYB3AxIZsxzRi5jJmxOK04ZpeZo1yfhoOI94ckrXLNtWVrZ2vT
LjkhlwlpkHVCnEqxyxFqaQaN1t3mFOkcaQ7aWCnXyGzZ2X/m3bN/fP/4/PU+
7/M+z2sSkeR/XE1FRWWLIocVUVXkZie16Vd7BCSLfFq/CQ2i/S/V2KcgGOMO
ykRJdLCPrXdOqUJwNpK1rTJRDyjMLXaZfyAQTQ0/c7qzU2l24Vv+0N2dkPo4
biCeTMCPQkvrvFEDiK8t7HlrRkDj7MjXxzyNgBqTH47CCLjJm3YLU2fB39ez
5OREAjbvpS3yk9lKc2yKnsvzsDtUKjkRXWzY7agtTo7FvkgSWnNi/mOu4ONA
BLb8q32xM4rzbrkWt21tZcO10juPho8ScGzAoCwmmw190tfLet4EhDObn7Bp
LOgNqAxbcCLg6mrO0cuxTCBfcP3tkzV2GqW3YJmFbVpjKE7WJ0DiLzm0rsEC
e6e9B411CNjt8XJ/g5gF46TvEF+NgIrInAtFwWwo72I32CwiZX0yGm9yuRu7
88/oXp947Ke5qW73v0RQVVgnHW41VlptWt9sbIKhtN6+kZmRWgbMFbxKTOMi
uPZOwHdNYkB+yPjcbRfs0QRywlZv7LMlIxlxPgiu1xfmv6hmQLv6WJUKgcCG
OeihOcmAc2ei6lpiEGTpXzK5IWGCWXXNmFMD9tqYgye3FfvD/b7EtKfYzRZB
P9i9QXBCzvs0e5oJv/w8GiIgEfCQ8zCp3JwJ212nV743JmDDfU1cIjSGNJms
M9AMWzYjWSvkYq9qF8vJTAK8r76Z5U4YQfpLy1DGEwRr9sNRzdoG0JNYERjd
hqCtQxrcckIfRA8syjR/QrDUlFpvU6sH7Kmc3OpzCHxns2y0KvWU/RC+6Cy9
bUYHehm3cWHVF8jqFGdRBhWaJGm9Pn2+4B/0mcecF0XpA0F5vB4S9mHBInXN
Vgcs2OMBNaPYSfkT37o8x+Y/OinjTWFn/Tuvr3whxzqqfc8RHdCVkwireV/w
LZn/QOhRIMSr+ApFC0F80KbwTOQOUH1vZJfJQfB5tWW3YRQVvAdjV0ODsEWM
jT1uAuxtKQel5ecV73neQk2DTIWV9TqT1xUIwp9Jl/gbFCA7n6LsbUawXOXq
oGpLgXX9su3ifqSsb9BaXKWygH2BDZkTPELpTJFbmeYRAqRNJaaGybpKa9bL
enzS6Uqv+pmRiHt02NEdupkTRMDkSoyL/190+MKquDvfH/vQ74bZ8gPYd/NK
N+oV+1m/UTR0sZEOu4TRx/v3E/DO79aS1Uk6BGa2dZ1yIMATJOladBrYa/tl
pNII5f1b4locOz7ifmSyck1vTGOXuUXsMhlC0Dis3vaggAqONWQ1jSYE5QKv
9xIpFbSY6eaR2QiM3OPMI01pYOfZGVBzWrGffu3RukCDsdpvOHkh2JcdE6hr
wdjzj91stdyx///f/gMHlVWJ
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJVIGYC4sVVxyTLDiY4FBQ/y5gvwefQvrJDT7srwYHd
2mOm3Co5h7NO0xLedCQ4nFCeZsn0V87hz7LQmW5AvlPpt/tTLOUdnvRHOCq1
Ifjz+PZ/029F8M8W1el3tSCp3+8gcKAxwWHGyqZAzxdyDj/tuH8wJyc4bJXt
uaH+WtrB7kOP4JT4BIf0NsWzm/ukHU5xmfS5A/m3r7MkKbci+FWP707cGI3g
lzxOaOgTlXZoKVSLaUtIcBB5b7lB5o2Ug/riUwZxSQh+rkpKdUAygm93YInT
NyS+evGjxANpCQ77dq21y7CVdthyc5HYk7IEh5nK69a+PC3jULJmDnvmlgQH
ma5kYf83bA7i9xzuOGxLcFgiyt6WdJbV4UVl4+JnQH7PjrPrHXexOuz6XnDS
cxeCv3iSFaPrfgS/J/YN+z0gP2ChdIAqL5tDj2uFAv+hBIc7RRs3G9mzO/DI
Cwbv8k90uN7z23X/XA0H6+yYJa6BiQ7Tpu7aH3pNw2FDwFb1SUD+nTceX2Vv
I/hB+14Jzf+C4Lft2NOcqaPpYN18oVsEaJ4OS1Hn4ihNBx7/n4oR3gj+XSml
HbPdEfyGLHG9bW6JDvNKj30/aqbp8CX9yYyLLokOM0UrPdJ/ajigpx8Amy8A
Qg==
    "]], 
   RasterBox[{{0}}, {{138.66799999999998`, 12.2676}, {143.70799999999997`, 
    12.7476}}, {0, 255},
    ColorFunction->GrayLevel], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzFDMAOUzoInTgk1Pu6jFBgDBVwJ/
    
    "], CompressedData["
1:eJxl1H1Qy3EYAPCfRe289Dprsq2VzUs4V6Q50jPkjgm308uU8t0t5M4QFZvX
Wi+0Fnel0OKUODruYrkVWnlvSWkh4mqc6oohIyX8/LHft+OP54/Pfe/7fJ97
7vs8PrLtkngHgiBGkSEmg/Y3ZkRU0C0IhNZSP/cJLLA7wz3FMfIeG0oyBGbl
QwSWKpZhQywPGB1johvLsHcs9up/UoD91kDXJRxFsHb8wUWXnHkQyUmLm3cQ
QYVEFNpay6WcpylKDw6cAoPckHhFOgJZonSh0XMKRCUUFZTmIugjsqqVNl/w
OzPH6fRJ7Owb6oA7Ndg9aUaBqhUBVHc3aY18yoT8eXnPKAHlWxonYi5PAKW0
aa+yzAgurrnJ6BYKQNM7I03+FJvl2Pzbc4SXbz0mTGwecc4N7Xr/BMHtWUGy
79MFsJt9pLP8EYLd+iqRdIAPs4NkKaoqBOtY5/M1OXxg9NU06s9jVxqepa0+
ia0PXyF3yUbg1jlafOo6HyIWmomUfQgCuCulM8n8lm1W+Y+9+P0f54JjN47w
NKfhE1V7sOsVm76WJP3vloTUsCWu2PryoQd1NXzKUdXtzMltHMoO7/IDh/jY
61m+F662sKl6KIer9vvtwzbxZqvvkGaKJIMDn9mQnuktoR1AsCfphbZ/FgdC
numEiYfJ/6X3T66r50BU5gdhlwbB1Ae6p7Ud3pDVzJLQyrAnCtscp1Zid6V3
bOi9Rfa70JwU5sKFXanzF8QYEdBLr6XmSzkQwyF2Rt5DkG1Veg9bJlP+9pr+
fqnUi/Lg8y/1tjgW5Su6x2uYv5iUrYqxTdFnGdAUsZ07QL6X4an1r/3mDsuO
vTEVkvV8GsMecNrmBsOHylcFX0bwMjQzefQmV6jMNSn4OmxdhLHfkIGt7rJa
g8l+tpmiveSp7uAijLHRdiDYYtya/LGdAeEGW4iNdLvb6nGxLQxQj+OKv+4k
53N5pDbwIQNcfxoq9idhX3+c0zPp0Agf7y3LI+eJ1xDUR2+YSFlZMvRGfJ9J
uVVZ06w1elL3bxJn58jusqj8dtvrsbtD3Cm6Fo8g675i0FmF7d9whZdYzKT8
a3quh8nHA4rMnQFCFYLCbovg42Zn+Okab2AWY/9WJzRCHbZ9/4iIOONhBw/4
dz/9ASViFJY=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYtkKgWk8/UkOyT6hpnM+STiwX4y6yDcrycEs
/9lChlfiDh80l/IILk1yqHkctfjKdTGHtOk7uYI3JDmYvxT8t+CsqMOaX4xb
mLYkOTDmN7IcLQLy98UX1u5McshiOGVV/k7E4cjVmJMLdyP4dXL/vs7dj+Cv
9fmx9NnhJIeSAykzTTJF4fwT4T7bTnOLwflFygdcxGPFHO5smzJjy6EkB59M
993Sh4HyHbNeZO9Lcshsm3fvGpe4g8+mIzttJiU5iN9IVlq6T9Ih4EZ/XNve
JIdjmpppxUUyDgG77PY6H0hyUJMLMHs6WwZu/oL8DXfKbyD4n9lm/OSrloXz
3ebViy2TlYO7PzBOqjR5hhzcfzD+J/ufu/N3Icl/Xpv1ZEeSw5H1fzkv98k5
3HbzZe3bmuQg9aSzut1WzgEW/qeTi/jXdUnB3S9kqrNQrFjB4cB0WdtOID/u
DXub7VYFuPw0N/VlaVqKDgdeG6ff7ULwk1JNPim2IfH77dl9mpIcvPu9D9q/
UIDzGW7k35FYhuCfuTs32y9PwaGqiY9lVzvCPWVGFl5uCUkO5RKT/8UZyTlc
luCItY1B+AfGh/n3skGNC08Ugu/utnfat1AkftnS1CmBiPCE8WHhDePD4qN0
Vc35AKB+PsYyFd9ZMg7uep7r1SMQ8fluYtEcg5YkhyVtDb2mJyTh8l9Ndnum
i4jD9U9xmFL59ZUY3Hzp98aXk9Yh+LD0BuPD0iPM/bD0CvMfjN87PU/IOxrB
3/N4Z/I1YHh8W/dsKfsPEXj4LaiKMgn2FIWH74dfhQt0/kjAw9+UIXWudbkQ
nO8Rq5hk6YLgN5aEbTBaLehw3au3NA8Yv30XpybzGgk6eLPdfjyhC8GHpRd0
/v/WK4vjZYTg6Udp8YobtquEHNDzPwCe57bC
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzKNsqrEZoHwQAABOfgKl
    "], CompressedData["
1:eJxl1Hkw3HcUAHAlRMQm27WOZO2ujUqohpnKxa56VokjqdlUaDA2fB1N1NnV
gzAkjiakLXU3Gh1JSRwbdVR2y7DOyLKLVFNBolYdtSRiCGH094/9dto/3h+f
+c6b75vv973HCoo6E6Khpqb2BhHniFAngpUu0ZXYI5g3N3oa6EmBjt9+uTzK
QWAGpw/7Nb4JJ4ZSlat2COoz9yi1pWSVu2d6a7WKsBUHtH/se7AXbMtuMHwd
EHxhNV2tT90LNR+RhrTfxx7NUnA6T2IXtC+wQ08jeNjZ31vVSLgy3qvAE0Hx
QtwZfjkZdLOHfp8kXOchNE8WkcGu865j6YcITJAbtaGQAl3dY8OpZxFIsr/n
tBboQZfwwmKDD4ITLj5fH+2hAjvxg0wbXwRdhsoX3HV9YIeMlAX7I7CXVjg1
vW0I3WEkW7cABKzBXqP43UZwsaiWxDqPYEFEGS2bM4KiqY2AqkAE/Cie8cqj
fcChJylXgxA4NJy9RU/ZD/fmgq7GhSCwEC9fU6+ggZlcrCshfE1I8xMM0KC2
vkQt+CKCW9b9FhQSHV5d11mtjkcQaTHMD/E2gQbJcvN4AXZG/yWjytvY0Smi
43EVCFxSityLjzBV3kgf+s5JQVe5Oz1yZWcEDShhzo9GixBQhT6bjd4GUP/M
mc/KQ7AYqSP3K6VCicysLToHQZLo4Te7GvXAfE5q/xbhTMPdTgoOtplpWKBn
H0Xl0oUldFlJBqm4VNB6A/9fH9Mqd+sutnzadSixG9s/tZ9cN4jAD1m263nr
q6xpfZPHL8d+KjjYg0gG4PxpTay6HHtGUjZjLPvXecn9jHek//eBUyuC/Yv6
sMXaXKnuxffJNYsFrR0I8pczI6pLKdDErXN5LkIw4pzx2Y5QMnDXpGXBVdjR
1wWV/uXYjie1qM63cf9ve3s+tl3D63Tqr6PAzakvo2VEfvvAuprbHT3YuKKU
niPe51sRtyP2KypY/nR4l1iI4HNTe2+7MgO4Ov6SlC9G0KJl4z+kQVNZK9ir
RdeVrrL5zs189yUmxDiw2ZdqEPyqVmod1GEC6QFH01ILsX+e4fI0E7FXDf+6
oxeJgNuWsLm1xYBw24moqY8RzFoYypwNGcBR5jF8wxCwZTY8/iETKLQ5Jsvy
xflj/hsRh05h6/jw+vrtsZ/YLbhPHCfep2Gf+pPXTMgb6JluPoLAte3VHlMX
JlQd2xJKrBHEGBko2fN0qAydTjpviYAcIK6fyKWpfO9CriIqHHvYlBQZrkmD
JZnun1essEeKW2aMrbFNdig84F3svFmOLItw0KDFH6/30IA1HxUcQ9Tj8tij
pnmRBkmf5DDv2yJ4EEXziWhngI7D2NSWA5635KoXk44e2KY11bMJPOzxDUv5
315Ev8Wux79HxV6btXI4+JihcpNQYzpLnQGFCTlpa8S+Yv+Q9pKfTYflwKDC
58Q+ezZZLjVPJur7z/79B/xMbPY=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.45073999999997`, 
    1.3884439999999927`}, {159.118859575, 1.3884439999999927`}, {
    159.118859575, 0.7906855999999927}, {162.04849839999997`, 
    0.7906855999999927}, {162.04849839999997`, 30.678605599999997`}, {
    159.118859575, 30.678605599999997`}, {159.118859575, 
    30.080847199999997`}, {161.45073999999997`, 30.080847199999997`}, {
    161.45073999999997`, 1.3884439999999927`}}}]},
  AspectRatio->Automatic,
  ImageSize->{166., 32.},
  PlotRange->{{0., 166.}, {0., 32.}}]], "Output",
 CellChangeTimes->{3.516627751557033*^9}]
}, Open  ]],

Cell["\<\
Note that NCTeX represent commutative products with a single * in order to \
distinguish it from its noncommutative cousin **. We can see the difference \
in an expression that has both commutative and noncommutative products:\
\>", "Text",
 CellChangeTimes->{{3.4548949268990726`*^9, 3.4548949921309357`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{
   RowBox[{"2", "**", "a", "**", "b"}], "-", 
   RowBox[{"3", 
    RowBox[{"c", "**", "d"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.4548949941928596`*^9, 3.4548950143832207`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"a", "**", "b"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"c", "**", "d"}]}]}]], "Output",
 CellChangeTimes->{3.51662775165483*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.009259259259259259], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4ruRrNWxF8QcQv4rTFKUEnbISk0va7oiCudP
vf/XR2KxqMM6gY0yNc8EHSoOLdOMjRZ1eMaSW/RDRcDhzLbL1zp+iDjw/euP
3SzC73BsW9jR1E0iDrvTVjjIFPE57Ct4fshDWgjOVzgUrOxvLwjnCzAzOU1I
YoHzOWZP9fi7gcdBKGPDys+ewg6+qd/kLpeKOPzeGT5HYbeEA8y9DtN3lXrc
kYLzLRY/W/3knBycPy+8renxMkWH5Phwi3d+wg7eakwGP62UHexDW9mSZHnh
/G9LT2Tn+7PA+TOuLdu4V+yv/cYtTu4PixXh/EsTY/45l8nD+Qxsd3d2e8s6
CO3tSdoZzuQA48desXgqPRHBTyovSFt1hxnOD3mQIr2jmc1hTSD/xRf7EfyO
XfwOWX7ycD7nM+fV71QVHMwffD7Mocrq4PRgku6dxQoOLuX/+X7XMsH5fiEN
lkceMsL5MrN4e5t2I/iXmhK5FJoYHf50sPwQnq/goGZ7SN7El9lh8fbLhk5P
FB2OXWFSmFzP7mD3bIWH1lwlB43QiQeusvDA+bOChfuyegXhfKOnzgGmVsIO
+zdujGlgVoTzuTKNOracloPzp61LkP64UNphTUFB330PQYcT+1u1w5olHOa/
SXOz9+FzuCm2/vAjATGHK8bnPmw4989+z9+dGSfsuOHh+16kaOm8eC44v1/B
+6qOGYJ/eIrHoumBHA7rbMyVLbeJOsD46OkZAP+3MhA=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4lXz1H/mWKg5HJlWyZYhLergont27YQXag7T
d3IVnxEScbi/uyhpywx1h7u69SULGIQdTCbvdL7io+Eww9jsfM43QYdpx+1v
nGvXcEjaufTqhNmCDnPZZdZV3ddwOOP1jttZXNBBpPKt7gFGTTh/LwvTjyZH
BH/N8yXfeds0Ha5xdWYxTELwNRcVtE83EYLzL+c+EX3cKuQwqStb8W2RpsPa
zdk9z18LOSxZfkIxSU/T4dSFQ+sXGQs7THfMNsnPVnOoUOr4XPBc1OHSQtlG
TgVNB/USX3P72RIOVw9y59z31nToyChh33hEAm4+464ra50ZJeH8kMA9p24t
RvBXvFj8vNBNCu7+TSvs3PQPSsH9B+P/kd4SPv+dBpwvGPnf6dVVDQe1X4q3
522Xcmjs+vKmeYGGQ43eOp/gNCkHWPjrrJv2oHKzGNz9bVtqhH/yyTrcm/Ez
07xAzUFO2eSu22RZuHzf9SLZmbVyDpdvxHFXfVWF838Xpe0+tBLB/yYkyZOS
o+rwI2N3sPdPWTg/4Rdz198SBP8Xa8KKDFZZhyIXjpvOh1Xh7rF1WWzN4aPs
cCNp+3mtaCkHzlULMyq5leH+gfFh/mXTenw//YUSnO/W+IWZdzmC79BY/ull
ghI8PGF8WHjD+LD40Dvyqn/DHCWHAu9ZXyUOSzh4Mm7ukTulBI/Pzdae8Wu7
VB1YLy6JY/woCpcPr78vZWwrDNf/rWuH10FhYbj5tZYRS/SuC8H5sPQG48PS
I8z9sPQK8x+Mv2oq5/6QPwj+1Ih9lzlFlR0ifnKVX1YQhIcf09E6VvkiQXj4
BrpOK/yhIgoPf92pQnf5HHjh/GD/7jSuWzxw/tHar0x/l3M7OJ368qFrnarD
ffOSzE1buRx6Gy9c3fgBwYelF3T+gQUfX4Z18cDTD/vtmcHCy3gd0PM/ABzz
sV0=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4ulB03uUmY0dOt6vXcx6+Ik9jF9gqm8bsPUp
nP+B7XStePQz+9QTPOvrbxg5rJHb5yNy8rX9fs5WjooFhg582+fVXP3N4PD8
ckl7XIChg+YdG/n1bAJw/hqZqBRreTE4v21LjfBPPlmHG9OWrTVbb+iwdHpS
RP8/RQfzf/Plyh4ZOVjwGNhq16g4wOy3zal907kTwQ/VbE94dhjB32wrz8V9
GcF3OnNq9otvKg5HZVhkdX8aOSx4kOTKy6bqoNj4NW/RSwT/g9mp0PYLCP7d
b59jpr4xdLDVnCwVtVrZoft88GWVcEOHyd93H0xUVnS4K3xLY+FVA4cT75Zn
T3oi66DweuXV8O0GDnfsd7+4UCEJ58P8C+PzZBjPuMAs7GD1QojP9rKBQ8Ka
U5JPE3gcdt2U19geZ+igFXXK+UM8s8N6nfYz3d8MHRp/lDE+Vf1sD3PfjgPF
7x9OemgPcz+MD/MfjA/z/wK2rx06rY/s0eMXAGGP2j8=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
     1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
     0}}}, {CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7XVSPHK6mbnDbo2qB8la0g4lwscS+jnNHSzubnL+
s0DG4czzRhOOg2YOt7xTDCZslHWYElvl6hiA4Ps0L6o8oG0K5+97+OVJwFdj
B/EtpsfjbonD+T+e/70VyicE55sXTWa/sZjH4aHexhdn6kwcrA/rB6xNZXeY
IjWhWNDJFM7/uu7ZUvcSBH/xLA/5zI8IfuOFqxuXtps5lOowXI8P43VQs/kz
YdJsM4dFteyztJi5HHRrbqTZfTaDq/frNF1mmG0O5ws4zS4vP4TgR0W6/7r5
29xBRmfthUArToeX27n2SqpYOGR1erusO8LtcG2X3LRwPwsHr6nNJvvm8TmY
8YuxsOZbOJj9X29VtFsQzk+rPKykfQHBd9jvNVPfTMjhXbkG15YIBH9fbsxW
xUAEv0/ZcA6bBYL/+ntm4yJTC4cHp5RP7uURctjzdq6OgJ6Fw961/lPu1wk6
dCUL++cwWzhknD+g3Hqe12HL2oNhKdfMHcoVwvsXyHI6THlw+PbPfAS/YnLL
ywU6CL5H544pfKrmDpdumWy7rscN51t9Cpzw8hgPnM/8b6pVbgefw5X0veds
tMwdwqbWhrNo8zusuLueaY+ruUPMTo0juaGCDjXBi8ysE80d7urWlyxgEHY4
tMoghznN3GF7MdvrJWnCDgEnp2TtqjF3eC8gcPfvSxGHpmB5j7jl5g4h3R1J
n0rFHUI6N20P2WjuUJNR9STLQsLhl4lF9Cmgf44cne22pEbK4U/JdPngF+YO
SrJyh37MlIbzg6Ybrtq4DsGfnVeX0X0NwZ90MYbJu0XGofXy3Qv5p8wdcsSf
VPi/knEI8gz+fHo+gi9fnxk4PxnBr7z8eK2mnbnDAr05W1W5ZRzQ8wsA0sNX
Hg==
     "], CompressedData["
1:eJxTTMoPSmViYGAQB2IQbbNzmUPaFDOHoJ+9qRtuCTg0Xri6cWm7mcO555MS
EpQR/K1dkV32AgIOt1UC+AySzBxq/L89+H+Ez6HHt83O+Iupg5y/2slzSVwO
OQ0dh0/0mjqUK4T3L5DldEhr4N601B3B/yetYPvqlAmc/2d24pYby00criqo
L79Yzwvn69/ZaXDJRwDOj5JpyQ/wFHK4crHQ9NN3EwfzPEN7cz1xB7mXsjtC
DE0dJK6v23+bSdKBL+eD5JI6U4cVp/dKp8VKO7h9+86R/d7UwWbuhQnTrso4
HJqul1kYbAbnX1g+v3HRVwT/snoc1xYJc4dgwVi2oEmScP6t/X/i94ci+Al5
c3bqSEo6uHtGXmgVNne48D+Rkem2hMMS2UlbFQXNHR7FyB37v1zCAT18AQTE
n0s=
     "]}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4jdRPaeZpts6HJlWyZYhLepgqXR/qch7W4fp
O7mKzwiJOLS9NGxQc7dzuKtbX7KAQdjBMPRqgdlCO4cZxmbnc74JOiTlS+ze
vM/OIWnn0qsTZgs6pPWzLet8Zedwxusdt7O4oIOix/vUNb8R/G+9P0/1StvD
+bn/T3ldtrV3uMbVmcUwCcHXXFTQPt1ECM6/nPtE9HGrkMODgHX3nUzsHdZu
zu55/lrIIfP+nfi/gvYOpy4cWr/IWNghWUfvZfMGW4cKpY7PBc9FHRpi2vkv
ctk7qJf4mtvPlnBoyvnHskfB3qEjo4R94xEJuPmMu66sdWaUhPNDAvecurUY
wV/xYvHzQjcpuPs3rbBz0z8oBfcfjD915qVf0p8QfAWLioKDT+0c1H4p3p63
Xcrh+oUiV77Tdg41eut8gtOkHGDhr7Nu2oPKzWJw97dtqRH+ySfrwBbxlfnF
JlsHOWWTu26TZeHyfdeLZGfWyjkw/lge0lmK4IseXb1mrT+CLyTKGvrPwNbh
R8buYO+fsnB+wi/mrr8lCP4v1oQVGayyDhfW1ljnxSDcs1X3VM4FBRuHG0nb
z2tFSznMTvBk7mSwgfsHxof5d5bCKzuG99ZwvtWZTxeCziH45j4mHo6rreHh
CePDwhvGh8XHurdvp6mctHYo8J71VeKwhIMNT9DU2/et4fFZoDn3n5KDrQPr
xSVxjB9F4fLh9feljG2F4fq/de3wOigsDDe/1jJiid51ITgflt5gfFh6hLkf
ll5h/oPxc8Jq1337geA/2n7dIpDVxiHiJ1f5ZQVBePgxHa1jlS8ShIdvoOu0
wh8qovDw150qdJfPgRfOD/bvTuO6xQPnH639yvR3ObfDjg9FxwWDbB3um5dk
btrK5RB35oGlajGCD0sv6PwDCz6+DOvigacf9tszg4WX8Tqg538A7ZKxXw==

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxd02tIk2EUB/BNW4t5mdtczY13aVeczcCJInY5j5p4q9DNFCQzIV1Oaeqw
JJdCpaZiYjpvKOatffGSd0uomX4xc4mlppiSypJQkNDcTMsv7/OCH86HHw/v
wzn/57wu8fci7ljTaDT6fqH9stovhUdz9Z4vgmFd5mGliA+W8vE8phJBxQAr
fYzrCC/NfzQOZQjmpdmaehoPMtqDUwQGBJUyL2PyFgeKL6i400YE8QPNX0tq
OFAS9oM5tIJgLGTdxv8YB9b1U4nydcozH2OEAXuUy54EzCaw/WCK9SyJVkrZ
tUGdV+HJxZ5MWeYvPeXCNWlvUx3LD1q7VEWmX1wo1XxafmhGMPp5qL1BxgO2
KMP1XRCCByfyf6tNfCC6GgZXNhGc1Vz1vlwjALFvrPcczQ/ylRrm62EBvp/+
5kurP90JWxE+ODrbSFn/s9GUGijE/XfqLwWeNwjxfKT14UEehauU15xFazeX
EJyxuMzV9QkhOKUy6tAUgiz3tjB5ghDI/M+16RYzu47i/nO7s3hmewIWO755
bQQjEJ/0nA98QeDz4uk0okorhu802QJyo6w0edooBJQTn9++9fcIgm3lW3mo
mcCOs1gX7GooWxhxeiWDgJGY2ohuMdVPvyhAtZIDMBPfZ5TECMGt53GvQQ14
HtLkvBK+QrGbSHknKbq2JYqyWWKeIQIB50mazJs0+R49O5E57EgAdWj1puCD
AHZY+f+S4gC/p65K2l3sgIAx0RRL3+Dj86jsBaHsIg9/v1XQH2Lg8fD9Wp/o
JvdpLja5b6TJfST7J/eVnI+0YwdRtJ1MeXwxZOJ0OkC0mXV/0pmD87MaecQ4
nsbB+YZf0aVun+Lj/KXl3Hl7sMOWXy9MYM3aYo9oN612X9mAj7ZSkOuEYMFb
c7ezhwW2KuMEW0KZ3JeDfl+/sXqjwBbvD3OuSs5rsYOD//9/Xxy1rA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAWIQ7fabz8TUwNmhyeFQ98x5yg4w/onpAQcTFyP4Qvxn
H/6/rOywc4pfvaACgi/c+cM2gRnBbwha7LZ9hRNcf1qr0t38DgT/I3dItlud
E9y+g55PzigUODnYvDQOuzgTwTddGd6g6oTgxzXv+/KNXdlh9ZxAv/XVCL7i
Nn+luX0IPv/PQ/uTTyH4m1S6bh0/4+Rw4YtQsuQTJTj/ceB5dfGNCH7IYeVp
lr1KDtmiEdE5B50cXuQZsbo9UHTgXfhemGc30P0XZSIrSxUdko6yTLga7ORg
wh3ZZPhF1IF5Y86zDS5ODpyn+5w3fxd2kBJbvG6rvZPDNuPlajKhCH7QneUz
l3wUhPOXHv7ZpRLC45B2tm7ynUYnB+vD+gFrU9kdBBTXzZG9h+AnJRzijS10
hvPzLzAfOcnl4jDxc+TPA/ME4fwG17q/AmHicP4C76ZGwy9SDlkL5j3mOOns
cMs7xWDCRlmHayclu2anIvh631Zw5ugg+E+mLbgw56eTA0fy/GjnHhmHh3ph
+lFXnBxYGI7Psw2SdkBPLwDJOvZU
     "], CompressedData["
1:eJxTTMoPSmViYGAQB2IQHayRJlG028mBQ3y6/29HCYf7775lXTzk5PBGZqfK
XiVJOJ+t6tOvu6aSDmr/NF7pnHNyaOkueMe1XNLBefKRSZ+4nB3KtrDe77eR
cZC8eJH1g5Ozg83cCxOmXZVxMJ4XlG+ejOCnCmSm8kxA8AOLfe+0bnR2WHfa
SrdzsTSc7xl4aPkUcUk4/0Jlb+yifWIOZmxzBao6nB3mfg6WYdcWcniXt15M
s8jZITXMS2vdcgGHy4z/vWQ9nR3a0pwXP/jF7aCj13fqLb+zQ7lCeP8CWU6H
1l8+a5ruO8H5M75bXHbZiuDXdXWwW/Y4OUgVKW3QcOWG831+CoT0ThGA82N2
ahzJDRWE83MqHUz8xIQclL6te6a6wMnBzXWO36YZIg7o4QsAU3mXkg==
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4i2TNppum+XqsEYmKsVaXswBxve52GCwzErS
QUOkdubhHlcHjcfnrFn45BzSZ5f1sLm7Oii2pQfbuys6vP3oZCXz28Vhjq32
kbpdyg5nchaWyvW5OCx4kOTKy6bqsOU498sJjQj+o0qWSacrEfyf96yiLpS4
OBSk+ceGfFSB8zfbynNxX0bwQzXbE54dRvBtc2rfdO5Ucdjqfzy5rcfFofrx
/5cPY1UcZM6oHRBgd3Wov/vy3OQUJYdAuTN3jPxcHZg0wzZxlMjB+TD/wvhe
U5tN9s3jc1h1Sez6D3lXB5NCcbaLUxkcNDvNBNVbXRxc2BcWMRm+sofZ/4Ht
dK149DM4v8BU3zZg61M4v+P92sWsh5/A+XuSVxcU3HtkD/P/jgPF7x9OemgP
Cx8YHxZ+MP61Hp4icQZXh5LZ5n5c8z/b1y+4s+28l6tD6pSKrrT3zA5hdZI9
E7uB8TFVYteJzTzw+Kv++eP+0qNCDujxCwCRqt2X
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYgOFJIVoIw+HHxO8y42CRR0+VDcl8vR7wvmf
dj9UnboAwV+nk6fvvQOTv0YmKsVaXgzOT1iREejyWgyuH8aHmQ/jw+xH51/V
i+EJ+aMA56fbHlNzdlaE8x/zPQ19vkjRYZffAaZbEgi+c63c04j/7hh8mH4Y
H2Y+jA+zf2P3rGmlC93g/A3e1pfe9CP4X26tO2FWgcmH+R/Gh4UPTD+MDzMf
xofZj84vnFK0dk01C5yvFXXK+UM8M5zPdWtWsv49Rrj/YXxY+KDzYfphfJj5
6PEPAHzi1g0=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{62.7320860625, 5.3312472}, {62.8690723625, 5.3312472}, {
    63.0543152, 5.3312472}, {63.0543152, 5.5305}, {63.0543152, 5.7297528}, {
    62.8690723625, 5.7297528}, {62.7320860625, 5.7297528}, {57.3989603375, 
    5.7297528}, {57.261974037499996`, 5.7297528}, {57.0767312, 5.7297528}, {
    57.0767312, 5.5305}, {57.0767312, 5.3312472}, {57.261974037499996`, 
    5.3312472}, {57.3989603375, 5.3312472}, {62.7320860625, 5.3312472}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H0s1HEcB/BzleOcc3ZY95PrHJlVW9GRLHzE5eGU7xEVKvKQ3dolD6Ek
lGIqlUbSdaKThzOzaPJwiolSiTRDqHSV8pArk7TW/fX7bv3x/uP1z+e9fT7b
x/LwsYDoFRQKRUcbT22o2iQaRd3gtiCoqPS0mhIQ8Ka8+dmeGQTEmPu03w5z
mPMzHFazxOD6yCeX/deCNFBW0vJzeaTbBcsaJys+2G0cSc4YQSCyoW5ecraC
3Lix8bVy7CDVEeuOcGx+VJdpqx2CFBeXUKUpn/SDfoU1q5xHes67hiXU4QFD
rqo75YZgR2QmvcxnLSxW9Z2UibHPTUcM0qOxe+eGJ9KPI0grWhwrZvNIqw1C
vKECe5KpDvpcZgn1dPXl2EDsLMbr2jZf7Kfds9SuAwiKRwJoqRl8uF1r+0xy
HsEyc7gkoYUPHjqjj3NuYQtnrMLaGrEVDhHBZ4cQXCccmsdF2NKbOT2/z/JI
L3jb8mO9sD0fPbnp6MmFqTgVP7UbQfWso8lk9hr4sp0zMNSAoFsY0tcoJ8Bj
TBkzoN033WJ92tFMAuImW7ZFXMG+4K3RicnDlnHuj15Kw5Z+a9ogTMH+wGiY
N0tAkC41NH6bTIDbUrgqU4pgvv27QiTFTprtP3GPiX1UWvg2XsGBYA0jKTIB
G8QCyfBpbPn7FwSjGHt1wd+DI8+xw7n2ao+PCKaDs1sHf5qRZlZeC9tvyiZt
oXnn5BxrAMKnCxTaQwTJvL35pRb6UFqvFkll2I26Cm5OFnaWksrK0t57q/KQ
fC6JDhm38ogiF21//K+7bHMjqDeTU1EAgkhNK32inglGNH2xKgpBHqvzfpU7
i3R6oUzQ2W9Mel+760TLbjYsXg0teKmdL2lvZK+zNAHGBd8epTt2hskr+R17
bDrtolsJFwFFFFiVfplNuuaKpkDSaUw6RLlLr4NggE1DSd+m/QhCT2/oyX6o
C5+cwtCgDDtf0FTb9hVbr3pnna61GCT+Z5SFGkPS1tmG1bGr2KQXflTwTb3M
YEtTQGLqHwQxUk6v/yEO/P8v/gE2JcGP
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYg3v5CzGgiCHI9Mq2TKkRR3+/Pn+gLUtyGH6
Tq7iM0IiDufX9YRzzQlyuKtbX7KAQdhhV+fW4L5NQQ4zjM3O53wTdHALcFv2
dmeQQ9LOpVcnzBZ0cL/BqPj4SJDDGa933M7igg5lbH8uaJ9E8F9Pt9NSuYjg
e3wx6tp6M8jhGldnFsMkBF9zUUH7dBMhOP9y7hPRx61CDktPZOcHXg9yWLs5
u+f5a6B8Tjn/gXNBDqcuHFq/yFjYoW3/6Y2JZUEOFUodnwueizr0cif9/nIm
yEG9xNfcfraEQ9/5/TvyLwU5dGSUsG88IgE3n3HXlbXOjJJwfkjgnlO3FiP4
K14sfl7oJgV3/6YVdm76B6Xg/oPxL90y2Xb8GIJf6jRPeOPhIAe1X4q3522X
clj84o4Hy94ghxq9dT7BaVIOsPDXWTftQeVmMbj727bUCP/kk3XI76rd8QvI
l1M2ues2WRYu33e9SHZmrZxDrtEqnsXpCP4m1dVKOnFI/MqDPg1hQQ4/MnYH
e/+UhfMTfjF3/S1B8H+xJqzIYJV1eBgf7xaTiHDP7f2bLpUIBTncSNp+Xita
ymFKT9CPJC6Ef2B8mH+n7LE6zsCG4Nc835N99W8gnF/t3ssp+DUQHp4wPiy8
YXxYfNxcb32380+gQ4H3rK8ShyUcarZfmWPOhIjPk3Xq5Z5RQQ6sF5fEMX4U
hcuH19+XMrYVhuv/1rXD66CwMNz8WsuIJXrXheB8WHqD8WHpEeZ+WHqF+Q/G
5+iST67jQPDTlLaxTuUOcoj4yVV+WUEQHn5MR+tY5YsE4eEb6Dqt8IeKKDz8
dacK3eVz4IXzg/2707hu8cD5R2u/Mv1dzu0w+0OM5lFg/N43L8nctJXLoTX9
BytXOoIPSy/o/AMLPr4M6+KBpx/22zODhZfxOqDnfwCJBMGh
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4p/aKev2ZIY4dLxfu5j18BN7GL/AVN82YOtT
OP8D2+la8ehn9jmdjNuF40Mc1sjt8xE5+dr+8Mz4s4KCIQ582+fVXP3N4ODb
I53L/TfYQfOOjfx6NgE4f41MVIq1vBic37alRvgnn6wD59/lZQdFQhyWTk+K
6P+n6PAw7FnQxMQQBwseA1vtGhUHmP22ObVvOnci+KGa7QnPDiP4m23lubgv
I/hOZ07NfvFNxaElrl7IPj3EYcGDJFdeNlWH2dt/p8UkI/j8TzcsEI1F8LlC
q5UkVYD2aU6Wilqt7GDmLcyw91+ww+Tvuw8mKis6eN0pEY25F+xw4t3y7ElP
ZB2kL604cPJasMMd+90vLlRIwvkw/8L4PBnGMy4wCzskCR7mO3w32CFhzSnJ
pwk8Dod83aYuZAhx0Io65fwhntmhXilh3zS1EIfGH2WMT1U/28Pct+NA8fuH
kx7aw9wP48P8B+PD/L+A7WuHTusje/T4BQDXD929
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4grn0nNcbaEO+1ZYZJb6SjtcyT5y91c1Ev/0
lGqzYgT/snaqZFFWqEOIybV/53ZJOTB+u7iyOiHUIV4wXHOGnJRD3L4AaYP4
UAeLkiPZK3Il4XwWq8lmoSoI/sqk885CWhIOBi80xe2B5omYlNv5bhd32Ft3
aRZDGYLP4rYi+X07gr/i6p+5k2aEOmhsWfP7+BoJOH/C6ZNXb7pIwfl6seUr
j5vLOJTv3hksCvTPLe8UgwkbZR126v150OOH4Oc4V68+8jMEzj/cX83isSzE
oWJFzPQLzBJwvl5S3xXDTCE4P8WfaXbxGl6HY8wNkkWnQhysD+sHrE1ld5jz
cM87Y+5QOF/it/kVlxQEH+a+6k8bArJP8cP5BjKSX6PiBOD8VbmVs9/OEnCY
eGFa8ckpoQ7Huy7sW/FIwKHytIEnw0QEX8Z41rKXvUjyvyUk5vWEOkwX2Hvt
/VkBB+MZF/LedYQ6vHXx9FhSI+Cw65y2c2B4qEO5Qnj/AllOh7m9y47cF0Lw
7VV/fEjjRvCzjVm23XwcAucH7Qv78fJSiMMW501mNcy8cP63Iy2PbjwVgPNf
de1Tr24XcuBdrt6+6n6Iw6z/f5KPJYs55BQnVyV9DXG48D+Rkem2hEPebL9w
Gc5QB4nY5mRreWmHQmneB7o6oQ42cy9MmHZVxqFk9ukMe38En/HYy1t3UxD8
q/FcWcK1oQ5vWpf/EQiTcUBPzwDFOkP1
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYpNvt3u/3AhzODKtki1DWtSBY0UBy893YQ7T
d3IVnxEScbgdyVr9lyXc4a5ufckCBmGHYyZ65Y3S4Q4zjM3O53wTdAj6ve/k
A6Vwh6SdS69OmC3oENxc5XJNN9zhjNc7bmdxQYemjSVf5IwQ/O9O233FrRD8
kPmr165wCne4xtWZxTAJwddcVNA+3UQIzr+c+0T0cauQw8biJ5NcHMId1m7O
7nn+Gigv/sFos3m4w6kLh9YvMhZ2mJTlcjXkfphDhVLH54Lnog4zt92Se2Ea
7qBe4mtuP1vCYVaVxZ0k63CHjowS9o1HJODmM+66staZURLODwncc+rWYgR/
xYvFzwvdpODu37TCzk3/oBTcfzD+vda1N3fpI/iNb8XMl+iEO6j9Urw9b7uU
w/rJoTnfVcMdavTW+QSnSTnAwl9n3bQHlZvF4O5v21Ij/JNP1qHa9Nvtt0C+
nLLJXbfJsnD5vutFsjNr5Rwq7yoZTLuA4O+7oOwmfxyJr2JVULw/zOFHxu5g
75+ycH7CL+auvyUI/i/WhBUZrLIOb7luZPqfQrjneZb2t/TqMIcbSdvPa0VL
OSwwPy0dVhwG9w+MD/PvgvTNrz7nIfgdk0z7T6Qh+O2fWHVZ4sLg4Qnjw8Ib
xofFx9OoLQy1qWEOBd6zvkoclnDoSPI9oJUdBo/Pq5oLZtkcDnNgvbgkjvGj
KFw+vP6+lLGtMFz/t64dXgeFheHm11pGLNG7LgTnw9IbjA9LjzD3w9IrzH8w
vojpjLbCQgS/6KyeZkdJmEPET67yywqC8PBjOlrHKl8kCA/fQNdphT9UROHh
rztV6C6fAy+cH+zfncZ1iwfOP1r7lenvcm6H5bOv+uwAxu9985LMTVu5HCYK
FWr+PY/gw9ILOv/Ago8vw7p44OmH/fbMYOFlvA7o+R8AG2DBQg==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4sUV3hrGghEOR6ZVsmVIizqUaz2YZ64e4TB9
J1fxGSERB687JaI2thEOd3XrSxYwCDuYbJ8reCA4wmGGsdn5nG+CDgdr9VLk
oyMcknYuvTphtqDDIdZX90TSIhzOeL3jdhYXdPho/KQvNgvBTzuq9iK0CME/
rCjt8bwqwuEaV2cWwyQEX3NRQft0EyE4/3LuE9HHrUIOCt+CdZsrIhzWbs7u
ef5ayOHQzPizH/MjHE5dOLR+kbGwA+PbzfmTxSMcKpQ6Phc8F3XgsPTaqZYX
4aBe4mtuP1vCgfPv8rKFxREOHRkl7BuPSMDNZ9x1Za0zoyScHxK459StxQj+
iheLnxe6ScHdv2mFnZv+QSm4/2B8Xw7Zkp/pCP6H/LaLj1IiHNR+Kd6et13K
QU7sKJtZXIRDjd46n+A0KQdY+Ousm/agcrMY3P1tW2qEf/LJOrzanlqmIxHh
IKdsctdtsixcvu96kezMWjmHF/GTTl3hQPB1gyc/iP0fjuAvX8m16Xu4w4+M
3cHeP2Xh/IRfzF1/SxD8X6wJKzJYZR1iet1Z+pgQ7gl7O2vCss3hDjeStp/X
ipZy4N9ltW3K6nC4f2B8mH/5Xym1Gi1H8L+LLNVkn4/gfyspPe40LRwenjA+
LLxhfFh8hNxVnr17brhDgfesrxKHJRy+P9kTlbk4HB6fLmv4Tat/hzuwXlwS
x/hRFC4fXn9fythWGK7/W9cOr4PCwnDzay0jluhdF4LzYekNxoelR5j7YekV
5j8Yv3k7u+KGlQj+Q/95h4+tCXeI+MlVfllBEB5+TEfrWOWLBOHhG+g6rfCH
iig8/HWnCt3lc+CF84P9u9O4bvHA+UdrvzL9Xc7tICbn+vwbMH7vm5dkbtrK
5cAw9cFha2D8w/iw9ILOP7Dg48uwLh54+mG/PTNYeBmvA3r+BwA09biZ
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0,
      1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGAwB2IQ/WfdvoLYbZEOTQ6HumfOU3aA8U9MDziYuBjBF+I/
+/D/ZWWHJzcdRI3WIfi/8uLXXFmC4AdtThIuyYx04H9/75vmCmWH6Ztk5z6J
Q5i/Tjwk9WVkpIPNS+OwizOVHaYJvbNSCIt0CFSrd5RpRPBNV4Y3qDoh+HHN
+758Y1d2sJJq/3U2GsFXbs1I1k5F8GepKW3ia0bwbeMWO0S1RDpc+CKULPlE
Cc5/HHheXXyjksOm6ILVpU2RDpw8HhuFvJUcuDe8YmeIjXTYrVH1IFlL2mGa
0zXOfYGRDhZ3Nzn/WSDjsMb8qN0c+0iHW94pBhM2yjrIhTI3Zykj+D1xvAFe
tyLgfM1vD7PW9UQ4iG8xPR53SxzO//H8761QPiE437xoMvuNxTwOhZwXs3nX
RzhYH9YPWJvK7hB3pKPv3n0EvyxTTjrnDYKf9KSscgt3JJx/01BqnrNhpEOp
DsP1+DBeh0NnHl+1M4t0WFTLPkuLmcvhyJ2o05o+CPW8Ckaz1bIQfNu+bv4f
9Qi+wBSzDQF9kQ4yOmsvBFpxOmzOfr4gYUakQ1ant8u6I9wOeTk64h8WRTp4
TW022TePz6HNcVWR9OpIB7P/662KdgvC+WmVh5W0LyD4Dvu9ZuqbCTlsua1n
0r4Uwde8+XveosUI/hy2jTei5yKpt/5/8dCcSIcHp5RP7uURctCwPGNzb1ak
w961/lPu1wk6zJ6W6Wo6IdIh4/wB5dbzvA5qmqHun4HxXa4Q3r9AltPh3tap
KyKyEfzpj1hzmqIQfO4Hl67NjYh0uHTLZNt1PW443+pT4ISXx3jgfJMdHM/X
reODp+f8T9t0Ve34HZSfWjCmx0Q6SOy/L2flLeCAnr8Ar/52FQ==
     "], CompressedData["

1:eJxTTMoPSmViYGAQB2IQzZFz7mCxSaRD0M/e1A23BBxuGkrNczaMdDj3fFJC
gjKCv7UrssteQMDhwzEL02fqkQ41/t8e/D/C5yAT6MaYzhPpIOevdvJcEpfD
lbttSWc+RTiUK4T3L5DldLg8V32e80MEf+eRNwdEDiH4O1T2xgXsjHC4qqC+
/GI9L5yvf2enwSUfATg/SqYlP8BTyEHPiHF/2NkIB/M8Q3tzPXEHRos18etv
RzhIXF+3/zaTpMOeGwoWzO8jHFac3iudFivt4LX70WcT7kgHm7kXJky7KuOw
KvlDt5kKgr92Oc+lQz4I/jp3G5P20EiHYMFYtqBJknD+rf1/4veHIvgJeXN2
6khKOnAL7F5qHRLpcOF/IiPTbQkHJVfO+YuCIx0excgd+79cwgE9fAHU4JpE

     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4pLb54tDy6Ic1shEpVjLiznA+D4XGwyWWUk6
6M3ZqhqTH+Wg8ficNQufnMO5eKP5tT5RDopt6cH27ooOAt0SZR1qUQ5zbLWP
1O1Sdmg4cXwy54dIhwUPklx52VQdvnytOXvoJYLP7f9T8cFTBH9ao0hb0uNI
h4I0/9iQjypw/mZbeS7uywh+qGZ7wrPDCL5tTu2bzp0qDl923uqyfR/pUP34
/8uHsSoOGhVcO5t0ohzq7748NzlFycFJMfa4cECUA5Nm2CaOEjk4H+ZfGN9r
arPJvnl8DvnVTUe+WUQ5mBSKs12cyuCwLmzSw97XkQ4u7AuLmAxf2cPs/8B2
ulY8+hmcX2Cqbxuw9Smc3/F+7WLWw0/g/D3JqwsK7j2yh/l/x4Hi9w8nPbSH
hQ+MDws/GL814q8gm2aUQ8lscz+u+Z/to5JSTZL8ohxSp1R0pb1ndnC9yCx/
OA8YH1Mldp3YzAOPv+qfP+4vPSrkgB6/ACKu3AU=
    "]]},
  AspectRatio->Automatic,
  ImageSize->{108., 12.},
  PlotRange->{{0., 108.}, {0., 12.}}]], "Output",
 CellChangeTimes->{3.516627751929585*^9}]
}, Open  ]],

Cell["\<\
NCTeXForm handles lists and matrices as well. Here is a list:\
\>", "Text",
 CellChangeTimes->{
  3.454895099979403*^9, {3.454895136442893*^9, 3.454895156391193*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"{", 
   RowBox[{"x", ",", 
    RowBox[{"tp", "[", "x", "]"}], ",", 
    RowBox[{"x", "+", "y"}], ",", 
    RowBox[{"x", "+", 
     RowBox[{"tp", "[", "y", "]"}]}], ",", 
    RowBox[{"x", "+", 
     RowBox[{"inv", "[", "y", "]"}]}], ",", 
    RowBox[{"x", "**", "x"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.4542085365012217`*^9, 3.45420857187649*^9}, {
  3.4542086851409397`*^9, 3.454208704173193*^9}, {3.454208738053905*^9, 
  3.4542087391978693`*^9}, {3.4542088813750963`*^9, 3.454208893637043*^9}, {
  3.454209115126361*^9, 3.454209117213262*^9}, {3.4542092354129133`*^9, 
  3.4542092377010317`*^9}, {3.454253549277091*^9, 3.4542535497400713`*^9}, {
  3.4542713460826607`*^9, 3.454271352577384*^9}, {3.454272050827353*^9, 
  3.454272067112833*^9}, {3.454895061747003*^9, 3.4548950658539963`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", 
   RowBox[{"tp", "[", "x", "]"}], ",", 
   RowBox[{"x", "+", "y"}], ",", 
   RowBox[{"x", "+", 
    RowBox[{"tp", "[", "y", "]"}]}], ",", 
   RowBox[{"x", "+", 
    RowBox[{"inv", "[", "y", "]"}]}], ",", 
   RowBox[{"x", "**", "x"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5166277519945927`*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.006134969325153374], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 
    1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxd030s1HEcB/DjHOb5fu6BijwcYt1hmkXy++hIyMPqVspDi0XUauVKU7Om
uTq3HkaO0BJmKYxccp7DCkvrEM3DuvN4nrrrOqtQ8s99b/PH+4/XP599tvfn
Y59w+dg5IoFA0NmK/1Z0t8IN0x+flpKhp551qTzEHjR2C7nfUd7ugOyV8rul
xMMR2NyaBKEEg+Kn62eb6x2hMEzNbsy2BC77+PU1MwZ0vaiIgAsUENr1zkUK
GDAnqF7Sd6HD+6LxT4alDGgh06hXoulgqkrRk1QwgLSQMBR6mw5F0Chxeqt1
w8HdRsZDWlMHr/kFkJyATaB6JTO19oGM4arXNGRys28j5xWG/Len0pfPNAPx
6ax5H10Gch8nSeGZ74A8IehWW3XbIP/b5XHKedUa+VbYY6szkdbAEs9mTjmZ
wNeSO8mHmFZAE//Yf8LUGHhB62b7SujgHvWr8oHKEHgJsjE8mwZqvuxhsIEe
spw/f1HnJhF5gr8S0vJdF6aEi3H0DK2VXvwvGZjW8obwA4erqPB5b61QmkxE
dg7k+PGZesi85ykzETkGyJr9H8UekVAGKcgFFm0jigEL5KrZtLw2kQ5yTn/4
8KDVGq4xy6X7qHe9Glf6GI/kuZKh9Z1CKS9dwWkZ0UTFNwwMbbFEf5sZ3Lbz
A8kknQpNnWkKWa4Mj4rjzAWIaMgxNorATRYdWdPvdi8n5m3cM59Fbs0dqKvG
5XiZaMI/KkhrqcB9bFpKQ+axCtgB/ZbAeLmY0z66gEdJlrfuDQMHlz5XJUON
e3K9WcxNMqwXX5V6LP/BNff9U5ZaO1O3jizqb4roJW4g13alVycOEtA/ZPHx
HN9JE+SN0qHCN8HmyKOhcha/nAyBEpXK7SMZitLy81YNMMjcc5dUE0iGcrGe
EHtGgaUed327GFMoi+0gZVZQ4YZR/JNYTyPUv2Ze6nlinU4SHVl3Mryy03UH
cqUg/uRk2E7Y/s//AcoRvVg=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H1Q03UcB/CBgLAnBsLYYA9s++2H2Hho8azmx2MWIwMcudmc0nlwICLI
QxoCagaXEKTktdqQWAgRCgiXcGBTlN2q2XgqgeMp0LMlAYcYIHBexF/f311/
vP94/fH+/PO++wiOZSlStpBIJLvNKDdjv5k67V5GgSMGwxrsepcPC4Zai9Wr
Qgw4qpMx82I2rMxb0kq1GOyqHriiHeLAaxTP3wZWxMjMPoutxBVHds4ue+Pm
JcLui+beqUUcpJOh0lE1B5wWf72hS8FBo7I6Z/lzoH+YEr9mh0PwHWOkRuqD
nN+yYNob7Y2ckamdyKlnw+me5x0vI3CodaTVqmdY0KrJqmrsJkwKiTzxXYAf
MlaZkUzr9YNfamuSYvVs5A8HZ29UiX2QbWky/hOcCy2F03maehzG3kkOvtLG
BVtix7/WdTFyh7ZT9nQEQ25gknTl2zFopegX3dp9INBc82JtVgTuR5wUrFFv
WHqYcIqaKYKjZ/fZzR3gQnp+/peMJCHql29zCAnrFSBzq7iN94r5yLH9bxqK
Yriwnr868lUjC7mmNuTP9255Ibfs+V3T+bYXUFdnHf5uIrw7Z2Ou9gHhfl/d
caUbD7lcbjHWBPHgjy6bLFvjBUbTRN0hGQ9eMasl7e1e8K7n65VndHx4YqZ+
kzjuAzcDBuSxLAHaN0+53j3aQziZLbG1CYTIGw2D+qFBIew/22e9eJ5w8mDe
aWmiN7K3F7042YMN+qvGqYpCIWSYY0D7ARPdb54PxzbuMkCpy41S5wgg5MWj
cz9doMKP5L6SsB5fOOOrumzguoCoSn/n8UM+cqM8yiP+c8Kp/bdeShp4yMr+
CJPpERdmPJavFrDJoCsV1mX28sCkLiRfOE+G8IiO6LRGPvylTs9VYFRk5mHF
RvpBOnLANXWGfCcD9e/HLj17VcYAu3EK8+twws/0nZRPaFzkCtMSC7ZxoK3U
j5lId0V+PlZP+7SCisyUBHcHLjmD+rKScdSFBztNQQnNKVtBO1cUf+ABHzlB
t7I9XCJArj+1m6yaFsBE0UxM6X0qbCkZ+qFgQQAG23L2uTAaFA6HqukSIfDi
cUvfMTIcMR6XrU8LiX5Yds4eOoasER/ixHngyG999rMhU+oHCV2B3/pZGMim
Zmu9vdkN+TYjMLBG4g474jaukxwJWyNT18eXceRdlHKnKAthLO7iF5P3cDgR
+TjL7OAO1MqPeB/fxiGOU7affNcN/Z/opvd7Qu0psHby0qK+C0P7yu3TFlLZ
hMnO1w6rDoqQ52I9h0ccRFBk2+rSVElBfmqYUvgH0ZHHbSO+k/+4wve5+/wF
IhEo1ipSWscYkJC0o5KvFoFU2CSwVrvD///pf1tRNvM=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYvGJ/15tPq/j8NVvt9/Ncg4HGD/Fn2l28Rpe
h6ylcwonBek4eFh+ZvscL+CwbefeZ7792nD+gW9864NeacH5nXf8gje1aTnU
+H978P8IH5x/YMHHl2FdPHC+nL/ayXNJXHD9h6d4LJoeyOHgdGLVe8kJ2nC+
Abdc74PTCH7KUvmEfB4dh5baaU7VSzgcjlqWTVpqp+PwoXC7qXEUp4OKH5/N
KV8dh8C0e6xLmznh7s86LH7n6DROhw1/tJZHhSP4TUnLnr6LQfBP7DSR3p6I
0A/jc+uYzXmRzgHnX3FSmec+i8nB1SOzQnuztgO3/ZIW1iO/7f1adzkY8Gk7
/Nx0tP701G/2y2devWF4Xcthb+g8hxt3v8D5f3ICFnzpQvA5T/UHnxdE8D+e
nM3r/POT/aSYrrfP3ms5nM3JELkT+cmeQ0+HO4NTG87fIClYnOaA4MPi7+Up
2TfM1f/s0eMXAIuy5Tk=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H0w23ccB3Cs8xAJkXMhJKqNh7pK8vv9EvXQ7fbpUCmpWai0WbSbY53S
OfN0dNRc17Rx0ZqOq3oqtWqHqVvWsirjtHNUObSeWUtQ2uroreiYv77fu/3x
/uP1x/vzz/vusyMyXh79noGBgeFWwrditJVkBsvF4xoFj1VOlY32tpBbJO5a
bqCAqzgpfeHMAQfvcPndRQo+KOm9WDDIhcYH68ZTxWJkoVt4ns8N7Or03zwf
zmDX+AycOW4nAWrcgxpWcuEnH0Wi34AYVIpu03g3LuQIUv2TKsRANN31VlH2
yGl1r9r3+dohx31dMPZNFQeOVsakLTeLoeJ9RoVy3hZOLVXHygwlyPwxbX+g
F7ZO4xqyoZbAnxVlxwKLOMjJfQs3rzjbI+u/8tv+1IUH6VlfDDmviGEkKIq4
eIsH7DgZb6IUO1N7sDWGgZ16MOF5s46CevOi11Y6e2hy2leYVEgBK8JYbjts
B6XXOY8zDlNwNN3fcPFTHgxt1M5t9pKoPx+0fJt1Dvt5tZf0ejaBvLBgSBfO
imAt7e2Twhu2yGUVkpmwX2yQ6z7qV90JsAEXcN/eQCeQGxzII1NW2AqNwuuh
M/bZS3ztMQEBE416vwSVDbASdz3QUgS8Y5e463Q2kKL+MHtQTcDTDnpp6Kg9
rB4ebisWkGjfiJMvM6azsQeDTfJCGrD5bGVsJI0CWXpPd/Zp7Ki+pBQq1A7Z
zsbiTJQ1B5ZyHmnvTZIQ1yGFgs/Z6H7tC0+nzWYm9Fjs/v2akgTJ3wOZ97Po
8F3A0NQPRiSkOioulPPMYHGukE5cIpBzBzYjzb/H/tdjfPTjIOzV5JbcajYB
89Zv8k9xaKCZXt3fH0ZAu/JbWtZpGpC9E3V9OQTMKk8kyp3oyOzP5JsnDlkg
C4qVcQf2MlG/NXBl7p2GCc+8kiojRNhNfff+qO8UITP0KukFmQhunXdlh1pY
Ii+NVDHUWjoy251oEa6YwtqM8c5HfAL2totCaqNN4EBz7+uuPOyu3Dgq35NE
Tlmz5FfmkTCWMS8930qHqm1jqR6XSSjXv0nI3MOASAG9K/M2CQ6fuHT2RNJA
7ujSumJF4f64m6KwGrsvjFdT+rMY+b7JoZd1PhIIaRRede1kIrfXdlcZdVgh
/8oUCsvcWeA1v/TqHz622aTTlWgudluA51VrY+w9MdRxvYEEYr3/iu/YxoKb
GoHgzroYgrkaGa3ZCv0f35ojbR5G5uCYpmP7b1BoX6lv1Y+767B37W8J4suw
L8+un3vGpyBDb2JWk2eOPF0+KXcTWSCP6p84ji9bwtv1fMpUTIF8VRtdP8KE
roSzX6qDKaB21uzoLmHB///pf+HPPnE=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1F1Mk2cUB/BKZbQNTFJTHLMtlb60ExFWMvq2vGMcigtFLerEzZEhs8SB
tZWkuGXQiEykxjABQxUbtaC25VsZbFmAwWxLN1hdAJnIxwQsYZPFoQycRVDG
Td8nmRfn4nfznOf8c3I2KXM+OESlUChrVuvj1fJZraFpQ+GwXQrudy/fWntd
AO2aievcPinY2/TBvzCEMMmyrXTdkQI3yuzIZAmBeetXd9yiFFQnsnRmthD6
q8T1U2tiId9s07wIEYIsqSFNFo+ckjz0gKdEfiu7wvHsNnL5xNhCznPkNFtO
4kIYAV8cdhw8QxVCekPco+ljBJTG6SL3DghA3V85/t6XBIz+VFXLViFHx/Lo
rpkw0uHd/Dl3M3KBY1uR4WQYnJErOjxHCLja3uZx9WCQx5/vqcomIIFhknVd
RZ4r+L2AXoCR/ZPblthRagyGVet0Ij2y4OxArKoaeWdM6wWGmYBPglM3Lpdg
kHvf8E99DQHnzme8luvEQJnFuNI3RECs7+LIG0eFpENFCQG7qoVgX/mwZcqG
7AzVcw5cQ+6p3G3bfBQnvfLdD1qLDHk4YCzINx75aXH5fFc0DtqnmRVf7xOC
vywvpKxbDPoGKq90HINTUTutbrsY/mYcb/bvxyBFGbh/pkMMo/VYS3wzcvR0
4u5DJmTjts7JqTIMDpxWbZf9KCbnb6yLYOhGkB9ZDffSniAvuWZ7W+fFZL4f
JfgfU7wUQ6rqXyixYVBkaS+8l4lDeDClXr4sgD6z4u75Kzi5Hwxz9w1NjYR0
xmDRSeYc8osNNJ9TYVLSxeExureFaF+99r7v9ZsLlu8fe5C1kc59rD8FsCt9
MQLnSaF2SkRltQiA92nTaJxUApeYgRWBvVzY2kpzmjZL4HRHPmvEzoETnsXH
ezAJ/GF+djZHx4GEYr78uBonneT6iqvdipzKvU8b5Lxqhq/aj+9ik+7cUbfj
s3Y2ZCbiS1s24XChxJNyO58NvQ8LsUYC2dvP6/Hemp9nq5E1MwOpfneQl2jL
D0KoEtJGReHBczhy4F+hxcpsZBNdwdQZkbUbAyanf0OmELjmpa+U9JPuxg38
GORSuqjScBjZEBTZQDEiU76xJM1bkVMGs/wibK9a5GSv7WRwSHvz6yx/fZ3x
JnKlND1Il4e8fnsGLXk/svd/Xh+5e4M+tx75omOW0A9LwFQW7b5WziHn7euP
t1makJt0W5i5PlyUR03u+3XvIEfJn38bnsiF2ofyyIkxCVgr1J/nWbnw//v7
HxM8azY=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4saLT88+PGXn8MVvt9/Ncg4HGD/Fn2l28Rpe
h1W3TQQDe+wc3C0/s32OF3C4mHr09DotBD+U5Z2+4Q1bON/qOy9T4jJbh2r/
bw/+H+GD8w8s+PgyrIsHzpf1Vzt5LokLrv/QFI9F0wM5HMTfWl8Q0baD83v7
vsr98EDwl0eXddhn2jk0105zql7C4XBj6cKFUU12Dh8Kt5saR3E6sG/I/fam
084hIO0e69JmTrj7Mw+L3zk6jdPBj/2P9tY+BN9sl6V3/UQE/9ZThrTHkxH6
YXwuHbM5L9I54PzLTirz3GcxOUjozp4y18bOgdN+SQvrkd/2c08f/iH/ytbh
+6aj9aenfrM/GXrxyIJztg67Q+c53Lj7Bc7/lROw4EsXgs9+qj/4vCCC//7k
bF7nn5/s7bZr+/++ZetwOidD5E7kJ/tf8//c3f0cwT8r+l7QmtkOzofF3/NT
sm+Yq//Zo8cvACqp7SM=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1FtM03cUB3AEBGy5FCK0tHQDRUwDcukEBNk4/39BCxSKRQWhHZNLtIAl
UEDkPqaZMNgwmOJAFDFlblJBVjYxsm6YMlhqM6OAdFwGhAobF+ViphMZT79f
sofvw+fhe17OyXFLyRalm5mYmGzbyvGtmG5F1THX3fwZAcNi95s9LAYEFZyz
2qgmgBV/hr+4xxk+1VIEU98QENL8e51iyAX0NRKP1U3sqt7qTFcLEvmQ8f5P
Undsfn/E7A8fkeA37s8dTXSB8ENfiJUsEsTxOqtsjgv8GNoU3mtKgu/9B0Fi
Lgu58M7yQ4LHRM6SKcZylc5wo+jyZAmNhNbtNq2J8wzwdVMncLjY5g1tNbei
saNlq5GV+SQMtF5Pjmx0Rs57/Pd3TXtYyLOnw96f9mCDj5Rmp/AkwRCV5lt3
lw0bExf8Vkyw72ZbmB24RyCrhAxGSg0BHdTGl/bdLBAerJB9WEqAvcRCxBhl
wi8lCzZ9EgIkReHbFo6w4eNbAXQzJu4/jxktq1kH5FMb//YP52Iv7v5TGeMJ
8PrcPyMN3zKQr7Xunz3aQUdWhT4R3ztMh+2D+dyxQOyoA4VCeTD2ezKqRhqG
7S/PmefyASZ6jGE5YjoUT8stfosEeOvU7NXdTQdV1ruZM/kAU1rra3F/sEB2
THD+yACg/bZMDp9cX8GWxKZm3qbg+zBT1ySoAwgQFOl1leXYqY/zCrhxTGQm
3fZ82k5n+Ev2qzTFjYBMLR8Unzih+e2Lge6bvTQ44ZtfMTQB8MHK07L+Cmvo
0kXV67oAClzjv2ph74DTzZ6cpmLsoPrkp1Z52C95+jr3eOyl1NCMkRCAuZ3r
9cXOFAhsEvcvJAH0JZZQKsopQLUXvsk8C2BMzJCL3K2RHZNEmxnHbJH3XU3M
ijhIQ31N5Nrc22oapGm/XvOLwD4pEcYt78bOn3611mYO0Fm11ynO1g55yaC0
+bzWGtnRy1fjvWYFy6yZ7zN4AMEPfWJV6ZagsBxgSYuwE144PhA8wt7Xdkp9
9A3AWOk8v+pnawi7/WiC/Q6gxbieUxZgAzc16RdJGwLYQo9BfQoFWD0rlaXB
BOqrGvL0+gvYSXFLhSJLEnnIi9JoiCEhtsf7xt5BGnKfSqc01dojq2ne3te9
HOBL9jNmOQ/7LCP3RXco9hNBsbx2P3bteOHxV34kZARNZWvNHeCwrCAo2YeE
aJdqAaXXHv0fsv1En78pFSrTg+8oOwm0X0Vk1+KVi9gWAs3A5XhszVXJ8zwe
ASVGyx3tl6jIMy2TIo6PLbLBOOI6vmoHS22cEMsoAkSva9M7DTR4NrVruD+B
AO6udjddswP8/5/+B4vyQNg=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYs8luX86J7k5/JjgXW4ULOrAydBna/3eHc7n
dnjLeITBA84/vqGSu0oCk79GJirFWl4Mzk9YkRHo8loMrh/Gh5kP48PsR+df
1YvhCfmjAOen2R5Tc3ZWhPMf8z0Nfb5I0eHypdP3OCoR/BhGrYPt8Zh8mH4Y
H2Y+jA+z/xT/sqIljK5w/snzbuukP7jA+bzxu5ak3sDkw/wP48PCB6YfxoeZ
D+PD7EfnF0wpWrummgXO14w65fwhnhnO57w1K1n/HiPc/zA+LHzQ+TD9MD7M
fPT4BwAyQdlV
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1Hs0lHkYB/CR+xiLaIe5aHfdKrdcQ3gfMep9346DZbRid7JEG7NZSbms
TSkixiVtLKlZLbYZaTM7rou2JdSx27IOJTa5nJK7lUuz84/3PWf3j+8fn39+
v+c8v+f5fRj2pX+EIoVCUZAnSJ4t8tg7qA9rz+Fw2q/aTnSACezeP7bRlnEo
5n8dldVPunsyz9frFelJ5ak4mS2LsNsz68DtEyxgCeL8zo3hEBfU6rPmwQa0
4U5q5++kd29jLrg8IJ1dtajrU4vDqjKvMkqZDZzi9sL5Chzs2FeWj0Sz4CZ/
7UyOEAfvRL/Gz5xZYLlkoRZxDQeL1bLXbRsM8Ar+vPdYIQ6Vk8KJWG8GeDbY
8SuycEjUcAjodzOAfQwl2mgaDq2pVYHV5vog+Tiu/mwSDjP9npxxOh2Kc2Y8
DD1xaM8sw5pGtKB2wYRq5I6DvVRtQix+D4ZKv6/hquFw6oOg3HK2OjSt5Onc
qsMI68Wk7H8RT3qX7XmRURQGAxu7WhNKaYQpN3yrBy5rEQ6rr+gTlOiAZwL6
XXwKBlfrqXE9W/VAn6OVfLASg7dFw0JhPh14iydCo5sw6Efc/xLZGgCa63Il
sg2DAL+mrkEh6dlfZitwPoPwZr+8kfChhWsYDOLhuwW1bFgLKjezDiGdfIqq
WD6OEm5ZUlGSSVHwtkJr6DN0wtr3pHV7C0k78m2QPVZ0yNM1zTZ9QNoemb51
qYN0Vfl+m5dPSCc5/uhO70MhctLLbHYfHQqMSs/qDKHQkGrhdfElHZxk1EXj
dRTE3S6WmUImmDS0v79sgYFraa+gqI8FF8RT45Fc0nXlHgHmPNLjjEDXsZP/
dyFfIShKwCS8iNRYheYxQAKxkhn5e/wWBiVtGQawZiY9lCc/T3Jzh/lohz6c
877OMbHBoPenT5bqBXrQ0VwWUM7EIIPrVPDNwa2EGUjZDzhfmzD36GF650N1
uK5h1JxxDAOX+9a+oghVyGl5Nh1/l3S++IW6+G/SQzFNI1KafB98nHjrzWrw
7VGliHBrHA5l/qnFmaeCBsXrDmzHIXtP2cmO5yqw8NVHGmnaOETFJgtpmoqQ
WJXyfGwYA9V0g/CnjzcQ3tP1+NIWDO67d97lJa4gVmnBkVdzMbA7n/5mem4B
2TlvPFXMJd21RDHjcEi7IF9IRZqkf3Ub6c5ZQeHJ6Fuug/8qojHtIRLTMML+
PVmh0SzSxz2cmSGWGEi7HHiv0HWkhMm+4euMwRuzkcuNjRtIjLPrztPy+8KQ
fy7pjsgIf/q4Q/twkgJsOmWulndxixKYMAru2Rhj4D4ooxwPVAL/9TgLqj7p
hYTCmZY1lLBhfvAOA/n8UTd0Q26rKBLWTC+Kl+m9QzZd6D5iegBdRlKXO7Nq
1TFoeOh4QjVtFumRl/2IS1pZf++F1/2kSySDhgNcHAzTNaujJt4ha/OhFZIz
ONz++VFAxhE1+O//+i/WcVpS
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4sNxRW9DWXwdvvjt9rtZzuEA46f4M80uXsPr
cOOxZD/vUx8Hd8vPbJ/jBRxeayTl2GxB8HUryub97ULwFxS2tYsW+ThU+397
8P8IH5x/YMHHl2FdPHC+rL/ayXNJXHD9h6Z4LJoeyOHQlzM3L38Lgu9p+0s0
8TCCf23xrlMtl30cmmunOVUv4XB47xEQLvTAx+FD4XZT4yhOBza/bY23H/s4
BKTdY13azAl3f+Zh8TtHp3E6rKysnWP/DMGXC5ZZs+Q5gv/+Rf3Oay8Q+mF8
Lh2zOS/SOeD8y04q89xnMTn085y9YLzXx4HTfkkL65Hf9hejHzJ9nezj8H3T
0frTU7/ZP1d4kWHa5uOwO3Sew427X+D8XzkBC750Ifjsp/qDzwsi+O9PzuZ1
/vnJflGg6LqkHh+H0zkZInciP9n/P1r79dAkBP8lQ3l/0wIEHxZ/z0/JvmGu
/mePHr8ALmjrwA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H0w23ccB3C1UYlEE0XkqcN5mM08xLRUbz41KzX5/YhpyOJ0HjqnOqXO
VdXD9XQ92RRnY3QeGtPNGg03dk2mo7G4KbM6VAV1TUlllaEeqq0789f3e7c/
3n+87nvvzz+f732ck7NEaW+YmZnt2c2J3ZjvRumW3nPJhYQHUtcWFdcRgpe2
bPSeJHDFZyJMbmwoDZaJBo6RcKThfmXNBA9GzWe9HjZif+1PzbFoxY6QHtYS
/diRRwafXZslwW82QDAl2X3voabI1CRIxcNWWZ48UHdzouTXSfBV9wRJBVzk
87eW+49+yEHO/KJmJqeVDT+s7Dd8piRBbkGXS4yOIKj1T7IZxbaku1eXL2G/
naP6yZ8aDX/Km5Ii69nIuaPPfr7mxkVeSA97S+/OB8FchX3BPRJ0H6f6Vnby
wSzOInCyCbtr4TKFL8bu0NYeCH+XBKV1/Sqzmwuizp1cFx4JzERLkeMUB/qf
n7b7cZuAxAsf7VmK4cPJA7/yF28TqG/8I/5y9jfYGecK/vqNib1cl6TwvyeE
l/lbk7VtjsiN8vcXPlGykNtDxqS3w1lgFbIRePcBNnHrRVz8FLbTvExLPMEO
NK4ss54K4ZHKEJYtZUFR/BpNaRTCtkODV3c3Czr0hf+I7Ah4rKU1xk5zIXto
SHbwcwLttyXuRLquCjtpQJ9d2YZt+Q4tqW6CgKgLI8OXirFTRnPzBLEcZA7L
pjTVjg2m+WNnw/sIOK2NgJqTDmi+wnTIdecOA6Q31r9UFxLg/3y8aKCEBt2h
Q3WdMQTkOYkrmvkUyNh/06eEgx1MmdOZbLHXVMJayqYQeXXq97M900JYtNuo
LmBTIYg5Mzz6SggayUVqSTEV6FdGzGIcCDBIMs6JXGnI9p+KdjLibJDf+16S
eTyYgfq9keuL2zIGnApmv3ZYxE4ZG0kY12Cfj897/VWLEDrKPBxibfYh/6tr
pV8ppyHbe/n2eq9bwWpVsprUC+Fwv090e9peqCsMdyHYBLLk1Lcav0xsH95T
dVAdATOFxoiyPhqEOwsXzBsIaDZsZBcdpENrwMJVDwUBfNJ9cCSZCnyfnLLk
KdxX0tfHf3ElkRMHzxQfuoH9UF7W3GsiIVrlfd1jkIGsaR9uNdcykbsY3t5N
XrZQVS12TtVj519d3ax/hD2heZWfM4ZdEbslnb5PQkbQ4yztm7ZwfH4jJGyE
BCFPFkW9w0T3J1SRoAkwt4bSaVWXjCTRfr/r81sv9MCmaD74O38T/4e7trOm
BD0BFw17KYoqa+QnzXMiTx8bZJ1h0ml2bR+s8NpCl4wEiF6Wp3XoGKATy2du
viBA4KJwHm6whf/f0/8Ap+lUew==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4nU3T3n/Uw9y+DHBu9woWNShjz36Tdg1BL9/
eZef9H0E/+39gOBvrzD5a2SiUqzlxeD8hBUZgS6vxeD6YXyY+TA+zH50/lW9
GJ6QPwpwfprtMTVnZ0U4/zHf09DnixQdPn/4ucdWGsG34NDUq+XD5MP0w/gw
82F8mP35/M/buuMD4fy8/O0qx8MQfAHzj/JvvDD5MP/D+LDwgemH8WHmw/gw
+9H5BVOK1q6pZoHzNaNOOX+IZ4bzOW/NSta/xwj3P4wPCx90Pkw/jA8zHz3+
AQC53Ig=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1GkwnHccB/DduJYSgmatoxXjSEKJK0SSfX7OEuJ6/hYjUjaIjmQ1IyKj
JKox7mYdQYqt2Bi6jlRoQhxxTLquikqzUhVh4krjWGlQ4ui+8Twz7Yvvi8+b
33/md/wPsKN9w6UoFApVEn9J9kiiX17Uaj+C4KqPwLLWVQuKohMDHv+B4HvO
tchMEen+uRxvp7ek52TexOxYaBM++dLM79NZbSh8enp1YwhBjH+H5wd7HagL
u5BdKiStl3tAyOok7XXmO/+Qhwg2ZEKqImV0oAatFN6vR2Cpc2s19II2jLbn
ZCT9hMAl3qfli2PaoJss+C2qGoHJBm++c0sTqhufWC9WIaia489ecpF4qlY6
6y6C+I+skegkAwTqBc8OlSHouP6jn8BYA8LqTx+OL0GwJHJ0nqHTQTSYyXFN
QtCVzjvVOqEMbGrlcF8iAqsm2mxd3V6IY0VUTLERXNH1v1mmIw9zUsGsrGOk
1dt9lwUM0j/osvT7VRG82DrcEVeqSJhyx1vwIluZMLu54jm3eB8YdzdpXdZB
UNisEDOgqg77BcWZrywQrBeM8/m5dGj+xiNh6QQCEcYcqbVggKmXucZFDAHy
ae0b5ZMWPxZXuHM0Ce/2y8TI5XiDMYJR97Aj3HodSLUMmxxSJN3jwPCSH8YJ
f5lc+NS2BQcXU7d79CU6YZXGpp+P55M+yjHHbEzp4LuvMs+jk7R+pcKda12k
x0dsZqp7SAvL38w79eJwfs7JSOxAB/w2e6/DAA6Prps4pU7TwTD1trB/DIe6
frvP0vlaUBK2EmC1gsOJ0iFuwXNtGBin2S/II8JTI41rg3tJb+a3Rxkz/u98
DtU/kqtF+D12zzQ4RxOmKgcOmqsh+IUNxZ1pDEjVEq9TlRE8KD9oPCnUgH7B
ObH7Gg5DDYErzVx1uBjxOi59Hoc0lm1ekocqYU2MV+nOUSHMigii9/TKQ2C2
QU2ipL5dt5l3bbgcDM0kO723IT08nuKr4k06jvmu7eNwyT142oZsttFAZLc/
KeoKgoD035Wd3ynATbkHFYEcBFk2vMvCV7IgZW+Ab0QgiLyUwFdUkoLPx3zb
jD0RyKUwwsYGt7BHsbk0GhNBN7Pnfkj8P1iZqz01xVByXzdSFheW/8Z4SYZd
sgqko5PVJ4OopA2Neg9xp3HCUYY3Gih/4vBscp1l7buBKW9b3VWZJt2wEJiw
NE8aqzoSdF4yv6Y+65C3bpuY/y09XugHHBaNJrJbWrYw0Ldgx0reY2NrGWoT
O4TPDgpVgr6mwq4Tl+tDUvdIQ0n+S6NhMQ7M0R1KlJ80NMgMnmv/i/S3jmef
FI2RLvLunHSW7J/CltqZGlkpwkopBbE76tvYrvOZE4aubqtYb/JVtdzXkn3s
PfqVXLIYi9ZzctSV9GfXWXn1XLNTpEfY1GCDDASfpCgJIme3MTmqY1l+MYKa
h7+itFAa/Pd//RfC62UC
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1H9Q03UYB/DJMGPAKdBOfoyB7Lt9YyMnK5oRHA9tmIAZlp/140zOFpCI
mRKcbThPKjicTX4ahBETmBuFTCQ86Ca/BEW4JLs6WdMCTg0NPb2BExjX/tme
u/zj+eP1z+f5PO977ln34b63spgMBmOFq95zlZerGo15706PEZhKONnn3SSA
urSkSftVAgPdJSFXWDQ0dUodtnECXHHzoJJNg/ivBXORlUDu4Rx1M4eGiLW/
RxlsBFTN/XudETQswqNfnPfQmhWWT3+yo+NSY6L3rFZ4vDpHEzcSij6SyUtt
5SugcPfgrjImDV5WxbnsVxSgS1Svf/tXAWxSzj5IiFeAdfh7IycXLYmP9Bmd
4XssvMh7OGVGawblX1QX8+GN/tAckVQB+p5ux+hlCnw2fikkLysgmdXw2gU9
+qHGpvHRUJ7+qd2LHHEeBZOpvt90J6I/u7Y4/LocrUmw3xCnKGBHyPawJS0F
pYZ/7Ws3KaCiJvOZ/CEKmD5HIya3KSB+5ZOJ4E9oj6Nik/3fbKQhTHyDMmxB
2x4bey/K0eE19cbzUuJx68n56j9i0HrJ8qH7IrSxXDRne57AgTll1TFCw5le
PmObP4GSH5iRupsU+Kmtk7f8CMyyDpn9xim4UJquo30JWFupjiQzWnJLlpHV
gK6TW/6ePu7KJ2DqitNl9/wn6q4taAPRt2tj7suC0cKoQWFoCPHke+RwWk1f
GIHtufOg7afgWHBhMC+OgDCE0bp5SQA7r3/bVinD/Xmh1tH0bAma+dE/1/fX
ooUFIxt1Leix7ufeedKC++q2+323Q+0t5x840AfWDxH2HQFohr9ivtpMwDgd
y2R3CODFS4/OFOUSqA9cU7VmhAvz9WUz1dkESn9WsScGwiF9NqUzOYvA7ebH
X+9Th4M6I+PoFinaOXmnt4xG93VpFvS8p81ambeKN8rx2JJuSs/u4YA3sKUH
KQIntI6tYyoOfGDKSQ4Wod393D61K/bux3J0yYzavz0DvXv/8Ia5HeiK4tPl
Abno9ujyiZRCdOVZ65K2GL2qK82cXYG+l1jz24/foXMaJcsFJrTubNDOyi70
uD1QuXcAvefPDay7Q+hl5br4g2NPO3aI421hhXvszu/9IN+ioMvoCstNp7YH
3Z6cqUrqQLv/53YJdU4VrUcHRMouba0k0HBcMnWqPNwz79XxpP6WNnSbWhSY
78XFPE7np5heQos3L3QKZVwgpgkmv4qAoSqv4HMDF/5/f/8DlX5xRw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYu4FEpFG7OEOX/x2+90s53CA8VP8mWYXr+F1
mJr0RrPve5iDu+Vnts/xAg5yrRNmqN5H8A+smWXYdgrBr1yppCa0L8yh2v/b
g/9H+OD8Aws+vgzr4oHzZf3VTp5L4oLrPzTFY9H0QA6HD2rrJO3vI/h+/TFv
tz9D8Kcc2nP85Lswh+baaU7VSzgcFKay9wl8DXP4ULjd1DiK02HNdCvlr9/C
HALS7rEubeaEuz/zsPido9M4Hep05xmo/0DwLWbl7riJxFdMld9f9BOhH8bn
0jGb8yKdA86/7KQyz30Wk8OHb0e9Fj4Oc+C0X9LCeuS3/US5C48Zz4c5fN90
tP701G/2Mo2XxZROhDnsDp3ncOPuFzj/V07Agi9dCD77qf7g84II/vuTs3md
f36yr5LM2mlxOszhdE6GyJ3IT/Yrg+XuZpxD8OU+Sq3yuIrgw+Lv+SnZN8zV
/+zR4xcAc4fewA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtM01cUB3AeG2pbasuAvugEBBkTacdwCrpwRBBwMFl53J+lMqzgtKBY
QeQ1nnsgCxRGZAlvKsSMFWRREthwMljZzKAKiNgiMtBWzGAGBos4Butf9y77
4/zxyb3f88/JOS7yVEmStYWFhaW5Ys1lZa7C4qq+UEcK7svcrvQIuPCzafL0
Cx4FAnQmdMGdB8nlLV8o3qBgf/3diupxJ2AvDWemRROnliYKShHxcMPaTx0n
iXXMIGo8jYK3pnb76KXmd92TqnA5BTI0tDnV0wk++zWl5EEMBeLvev1kPgLs
zI7nAwcO8rFTzlY/PN/Kg79PnY7pllGgftVWLX3GhcD9q5XlZ4i9Li7tfD+H
eGSWS9+nouAXdeOHh2t42Okjv7fVuguwjaeCts3uEEJggsdCkIICw3uJ4opv
heApkK8vRRMXn3B9ellMXBj1zWIbn4Jr9JpFdpcAJGHTddzXKGAfs5Fw9Xyg
Ky7PS60pOJYdbDn/gRD0+f7KnBmE86+P0d3hDnH8m8IwYxlx87uqvS4KBKtZ
Lya++pqL3aD2NUZf42C3B4zJukM4sItlWP/oHPHdkLiy60rinlk3bUcGcbAR
SasyETzqMQUpZRyYc9LPPcpCsOZY79XVxQFLecOEWIVgRstoiJoUwPFY7VV1
N8Lzza4trV4eJtaPRdbe0RNrPjWy7z1HEJ6tGyrKJz4xkp7hE8XH5nOYnyTa
82Db4yL+TiOCZG0oVCc44v6ahT1uGzdZMDGgb30ygODtpXt5gwUMsLYLFv3W
jiDDGamahFsg/qVvdsiXxCEruiN55cRXImy8GQXEzVM/1BjPI5izX6nK4dHg
UNZw6LkiBP3SXFpBPg3ENwZnRRUITFJFmsSNge0QJ9lQxDCxd9VJU8L2sXD+
1uHlubVSFsiY89N2WcRxhkMq5UliYx0/YTgWQeclD8co5lbsPwyttp+XMbAd
vMS3vJc3g7qnIkBknp//gCiyPWkTXBAVp3VUEt/f3nbQ+XviH9dHA1pGEDz8
+FnopT4GhFvajJeMIWgyrSjz3rGFXPqop2ASgfDIjts6OQ32lnCvdi+SfOFF
ffhxDoVNxTi6bqeIHQJbfJ6a9y2yx7vZ4zYLu799qNVKy8a+wfL2bvSyA6U/
Pc0vg9i058FUdDqx/aisse/sf/7XTLIumPdb4TeTqn3FDnRyaZFnCgURTqXh
tJtsfH8CNUf7d1vRITm+t3fIi8LzXYnMlA1yidtH1sOCLIhpLyOO+v6FINe0
aYumko79uGla4iliYhtME85Tf24Fl43rxf+sIpCsliV1GlhQXdcZOWXu5+Oq
cRmqt4P/39N/ARORTSQ=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4vN/rz7eNzfK4ccE73KjYFGH9dppLeI+0XD+
htNTn90OQfD5WGJeb0vA5K+RiUqxlheD8xNWZAS6vBaD64fxYebD+DD70flX
9WJ4Qv4owPlptsfUnJ0V4fzHfE9Dny9SdBARZQ39NwHBj9QxOWbbgsmH6Yfx
YebD+DD7Jxh/kvO5Ggnn908+tKf9DIJvGP1n+5oDmHyY/2F8WPjA9MP4MPNh
fJj96PyCKUVr11SzwPmaUaecP8Qzw/mct2Yl699jhPsfxoeFDzofph/Gh5mP
Hv8ADfztgw==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1Hkw3GcYB/BFnKWOyCyLJDRC64hEHBH8HuImrnHG+2PtBJsQiVmtoy2Z
hGQdYYVqNBiybFXijsQG45o64qhOEBFtJdOUII4Q4oruP/adaf/4/vH5432e
med55tVkXPYOE6NQKCKC+AsiKohdN9dH9CwJ8V6VxlVOasDPZS8le5DwU3QS
M2MMu38mx9NuDntG/C1r94S60FZ/HPM9NK0OTSsBWc0OJLD82923bDTgN3ac
drAV9plH+iFUM+wrVwsWDxuQsClOr2CKa8BgPMWIpUOCscYPa6FR6rD1ulDL
5igJDolezSGn1MGG13hBX5ME/c3i+Y4dGgyMDw9WHyShYoY7HeMgsBS/0I1G
QuJnJj5jVqowYF4aOXuAhPbkX3wr9VQgdTSg00KJhMWxM/b/UKmw/j5fQnoN
QWdasUvLlDxc166/mLGC4GST1HR19edwJzHGqnwcwTeH/bNLNKRBWpe54FaD
bfKaTIvMxm63C23JYCMY3/mqPa5IVmhKqWfl+C15oRn88lHOXUVwm+5qOJmL
4Ee+DGtASRnMhnhflFQg2Mj/k8u9TYWJcn/l2noEY4T186oTquDBsqw1aETg
49XydIKLvdS2VO4aTRN6b15nXb2esUoRTLieN+LUaUCF/+WEnGvYb8OPTPc5
Yqfz7kVsGAneGzrXUBepQis8bGo8nYdtGn2cMDOkAsukXk/ODNu+/8Apwhx7
d8s2Kcoae6Z7NUWcQBAxY6ezZEuF2NZLPFFbBE+S9e1uvqGC4/2ykExvBNX9
FgZpXDVoZVOWVy8isCwa5uSPqsM7UeUXVcnY4ttt2dkp2Br8PrH5rP87L1rE
n8lRE3qVqDEkc2ggMfC8fVmwj24G3O1gq0IFsZXTKaj36J6u3qseFZgfimbL
XkIw3BD4gc9Rhqz0BXkXBgK2n3nuVTcloWlE8c+u0QpC+4UHUXv7pCGxzsjO
Og2BRdcxz6owSViWyZp8WIW9IpozO/wr9h3Gju/YBIJNd3P6dqsUrAdrqujP
IwhIG5G3fy8DtXodVrS/EWSaFcf2/CUBR8KM5p5MImDGfMeVlRMDJiXYd74L
gWSq6vnJoR3iZUFRSW8Dgi7r3np64keiI8qtwL4QgXFK6sK75RWirez4uZ5k
bA7vUIJ6HLaj60iHZxB2pku2a4cngmevNvxMvDcJIy2w/P0c9ohimHItA5s+
cHpFJxJB01MT+pzzNhHPNzDVikGwoDN1q7l5hwh1sto0EfRjEOvp+6d2hQ4e
6lEI+lYE9vz9ch39pug+aG2aabsdjsB6YpcS6bsPRr58sZVExy6LuEAGemPz
YwcSJAT3J7OzHz2QEBNaLjX/613lT8Se86ynjjo5rxGzvOv3vQMF99hnekXy
2hLBcfB4OZWMXfW4RXepDfvjDdkPb3YRHEyVq2ROfyJ0td3NfRVJePB40Icd
KgX//V//BaCRb0Y=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{122.83811210156252`, 8.723905499999999}, {
    122.92637489062501`, 8.723905499999999}, {123.08982450000002`, 
    8.723905499999999}, {123.08982450000002`, 8.8949827578125}, {
    123.08982450000002`, 9.072598}, {122.93291287500001`, 9.072598}, {
    122.83811210156252`, 9.072598}, {118.73879589843752`, 9.072598}, {
    118.64399512500002`, 9.072598}, {118.48708350000001`, 9.072598}, {
    118.48708350000001`, 8.8949827578125}, {118.48708350000001`, 
    8.723905499999999}, {118.65053310937502`, 8.723905499999999}, {
    118.73879589843752`, 8.723905499999999}, {122.83811210156252`, 
    8.723905499999999}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4jbuSpbtE+IdbAQil8wUUneA8dO5OdYuz1N3
qFnY8PZcf7xDmUHSfIYidYfLFlfelzUj+IVOikx56fEO097c4DgyW83hLEc+
f5c9gp+QpHN5ri4mP2T/pZ8feNQcDMTaTghbIPjXpp7/9CkEwTdr2O7AlBvv
0NTTwPW9GsG/fqUypOawHJxvt2xrJs8NWTj/2ZLvvfnVsg7Sf/4meTgi+JOV
5zbONcDkT+v+4XemSsbhUtTFZ3UWCP5y/tiA9DwEv3dxkfDyOgRf5hZDjkMP
gj/H9gJXzWEEXyNj8mHps5h8mP0L+o0eFexB8GHhj86H+Q/GV9pjy+F4UM4B
Pf4ALZHMig==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYoHK01f7fRIcvvjt9rtZzuEA46f4M80uXsPr
EBplum+vS4KDu+Vnts/xAg6zsttLOy0Q/Ox6nkOWegj+8dqAPf/VExyq/b89
+H+ED84/sODjy7AuHjhf1l/t5LkkLrj+Q1M8Fk0P5HBothEzm2aB4G8qeDs/
yAbBD+2S7Y12SHBorp3mVL2Ew2H2Z6cPdc4JDh8Kt5saR3E6PCy5Y1UIdG9A
2j3Wpc2ccPdnHha/c3Qap8Mp+z5HLlcEX/1baWsyEn/27XMcG1wR+mF8Lh2z
OS/SOeD8y04q89xnMTk0qyzyO26V4MBpv6SF9chv+xAL9dnlBgkO3zcdrT89
9Zv9zJcrtrDrJjjsDp3ncOPuFzj/V07Agi9dCD77qf7g84II/vuTs3mdf36y
P2H6hXUyMHxO52SI3In8ZH8/6Jy4tgGCP2uhz79Zxgg+LP6en5J9w1z9zx49
fgGAx+FF
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H8w23cYB3DVrkhIQ5FEktOY+rGmETZWaa97qF7VtCpWJuP2YewM9aum
XauYYbh1wnZxlwqajnVt/DzamZlMG2UJh1JHQxedjLbWVfzqLqvlr+/H7Y/3
H68/3s8/zz0PJz5dmLjdzMxsmymRppibon5SasUcR/AgxvVaF5MOaaz9s8sT
CJhRZ4KX9jIAMmyf75tBcEg2IpZMsMDepTGRb8AOTHtxq3sFO+t8D/mkcYv5
cad15nHgPePrMyViQabY28D6B0FMlMYy3ZMFw19/ujRnmsf/6Wf/GB8m4fPN
z+8EHHEinJom0WY1MKB0xnBfuI5A/pqNXLRIB+69g8s9m9hXEw70ynbGET4r
VfO+pcbBgLzuwxApg3D26NMbV/YyCc8nBTnPubGBOzXmzHiFYPrdBL64jQ11
fhkeGQZsjWikJkCHrR6zdwl9gKCFLH1h28mEjqHm9cIxBLaxO4X0KSegzpY5
f/cbgtgLR7c9C2fDRpI2rqML96V2qm5JK7bgl6ETixXYD++VHLXIQ/Dys43J
6h/ohGvlb82/10Ij3PTO/Zgfj9GA4624/sbn2AbNs/SRLU6SjpJPFmE3MVMi
oRjBbJc+KDOGBvm3b7L1JhsdZdzOThqQRRSHCjECncq6NuIhEw6Nc/491oD3
O5BTtPJ3C/Z61Z85s53Yuqfe7b8rEYReGNYU5mN/NJqd4xPhRNiJRilKsGfA
FWmB31fdCFJUwSBBjsR8xdLbrps9VFgjcY0LNxC8uTye119gDTbtOqW+DkHO
nqiKerYVCBqjP3aqwm6+5jbqK8bWhgUqjaVbXF2b80khggX71W8uMkjQPN8w
xCtH0CfKJRXkk+D1L+RSSiUCvSj5rNDVmrDDB8LN5NMUwvtrRKnHD1KJfm/I
yoKxnAr+fF9GQTH2Aclchlcu9qVzodGx2Qhay9wdIyi7CP813WDz5WVrwg5c
fi9vxRK0xRbHKab9Ce54nWpKtIB+pdnjoUrsNYG9uqQRO+W6x+BAGwLtpcXg
MqU1tHn27e5uR1CvX83M87OBQZ7H4aJbCNhhboPD8SRwP6M2jv2K++o/boZ9
P459OyJEYLmK7RBSGfjEdG+nunhX3QephPuaNA3mKlvCHVQer45rB0H9d+N3
78B+FbSPztmO7VC1tBFphn1kTeHdZrrvZH9dumqHHWSJUpPJJp9glYeSemyJ
/xOoiO7zNSdDwPsyi9hHeL8l4Rcnoyew5yoPD9MHsalu+gnqXQS5egsrRSWZ
8OP6R0JPLwrhaf3knhnDLqjxYKSsqhAIX15ObJ2mQuS56vBE0zwfFwVHI7OD
///T/wBPI13x
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4uSffuomrxMdjkyrZMuQFnXwDZqZZPYt0WH6
Tq7iM0IiDmarH8+1YExyuKtbX7KAQdhhjcSP2VU8SQ4zjM3O53wTdPhU7eCq
JZDkkLRz6dUJs4F8+3lMS0WTHE57veN2Fhd04AqfHXVSHME/Mt+m/ag0gv/5
rJk5n0KSw1WuziyGSQi+5qKC9ukmQnD+pdwnoo9bhRyULC5r3pFLclizObvn
+WugPOfNyslSSQ6nLhxav8hY2GGSMbN3yrtEhwqljs8Fz0UdpkWee79WMslB
rcTX3H62hMM061q/bJkkh/aMEvaNRyTg5jPsurLWmVESzg8J3HPq1mIEf8WL
xc8L3aTg7t+0ws5N/6AU3H8wvsVBc9/pYkjypW9+cwPDQ+2X4u1526UcFE90
T9sqmORQo7fOJzhNygEW/jrrpj2o3CwGd3/blhrhn3yyDmySMec2APmyyiZ3
3SbLwuX7rhfJzqyVc2DLLfrB8hzBX/GsqNnzERJfoG5G8b1Eh+8Zu4O9f8rC
+Qm/mLv+liD4v1gTVmSwyjocYPad+vAxwj17Npfdzt2T6HAjaft5rWgpB8lZ
bu9SdiTC/QPjw/wruWnXVeNtCH7v8d/qcpuQ+N8ff9u9NhEenjA+LLxhfFh8
7NbenVCxMdGhwHvWV4nDEg6969sd/LckwuPTRHijbsSDRAeWi0viGD+KwuXD
6u9LGdsKw/V/69rhdVBYGG5+jWXEEr3rQnA+LL3B+LD0CHM/LL3C/AfjX5ZY
u7hoO4LPlPrjy19geET85Cq/rCAIDz/Go3Ws8kWC8PANcJ1W+ENFFB7+OlOF
7vI58ML5Qf7daVy3eOD8I7Vfmf4u53aQPXOabRowfu+Zl2Ru2srlMLFdsnTH
MwQfll7Q+QcWfHwZ1sUDTz9st2cGCy/jdUDP/wBHHsVJ
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4uW3c4uC25McjkyrZMuQFnWYaLJjbeikJIfp
O7mKzwiJOFT1Mr0Mn5vkcFe3vmQBg7DDh19iz2euSHKYYWx2PueboINZXPwE
zzVJDkk7l16dMBvIV9rre2RjksNpr3fczuKCDn6Wu5a+2IzgczRFX3qyHcE3
3xDapLsnyeEqV2cWwyQEX3NRQft0EyE4/1LuE9HHrUIOaVKfSn7vSnJYszm7
5/lroPyb70c2bUtyOHXh0PpFxsIO10SVpjV3JTlUKHV8Lngu6nDL+q3V2a1J
Dmolvub2syUcbsnOmdm1I8mhPaOEfeMRCbj5DLuurHVmlITzQwL3nLq1GMFf
8WLx80I3Kbj7N62wc9M/KAX3H4xfszhsxrZNSPLh3O7awPBQ+6V4e952KYfU
VaseXlmb5FCjt84nOE3KARb+OuumPajcLAZ3f9uWGuGffLIOXr+rJC8A+bLK
JnfdJsvC5fuuF8nOrJVz8PKf6KzSjOC/OTHxXEYdEv/TnMeTqpIcvmfsDvb+
KQvnJ/xi7vpbguD/Yk1YkcEq68DyLPsBQwPCPQzTpqr1RiQ53Ejafl4rWsoh
tibVsiUE4R8YH+bf2Ck3FYKDEPyLK6WKbf2Q+DeZnG57IsITxoeFN4wPi4//
vLdWT/dNcijwnvVV4rCEw8WJy7rzAhDxWfH1fEV5TZIDy8UlcYwfReHyYfX3
pYxtheH6v3Xt8DooLAw3v8YyYonedSE4H5beYHxYeoS5H5ZeYf6D8cV/n343
MRjBd3MXd5ANTXKI+MlVfllBEB5+jEfrWOWLBOHhG+A6rfCHiig8/HWmCt3l
c+CF84P8u9O4bvHA+UdqvzL9Xc7tkLjuVeBWYPzeMy/J3LSVy+FqpsWB600I
Piy9oPMPLPj4MqyLB55+2G7PDBZexuuAnv8BDLnKow==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtM01cUB3CkyqNAWxAobWnkKZFgZUVG2HQekE2UEktBkYqy/S44YDxk
El6WR8wyI9IJojVTnrVEXYowkAlGQSBlQxkMcDyqBWGh4bHq5JHJhrD+da/Z
H+ePzx/nJPd8c48rlS5JoJmYmGwy1lFjmRpLJpQqq1wRjMR63GzjOcG2+PWs
LHcEvOjUUIMnB97cnz7f4I1gT+VvpYrfnUGTlL3eDMRLLV2H9wUTuz/+TjV4
8D3nCF/FixF8oPMXjkudwW3MtKTmAILY6D6L9B3OUDjy2benghD4PngYGCvk
Yefcfd0dtJ+LnZKmePF1HQcCPTUpIyEIlFtslNI5J9AxbC4GhRNL1JbHXKOI
PaYrfmafRPCLsjru0HUOdubgwg83PHnYM4kh26a380HnomqtCEOgDYv3Lf2R
D+KCoM4lIM5X1vprBMQyrv7BgHFfDVbX39i28CDBoajUzAWB7QkzidM4Fzo9
j7d6OSE4kffppj8j+HCnsf6fAHPSHyZVRHHXKeyFLdX6FB1xCfPYRPFTClZz
345eu+OEXaXcPRPVwMau3zcc23qADUM5+UF3+4lV9u0WUQPEnGmlanCQ+CTa
87p7iIKJNn1IRiwbfDdkPyUNU7DmWOnT0sKGh7WT9XYTFExprKsin/PAwFu6
+nSRwvnmth+RZ74jvq1tZVI0kv9lP1pYPAOBKK+/71whMRrMzBJGcrG5bMY3
8fYcEE1HDDAtEXylCQXF5454vtoQ4LHxiAW3JO+upLylwG/xWUFPkTW0rzbF
JBsoyHKJvlTDt4QFg/dG5SRx3MLfSW06Yvm1rTFFI+95Mp1pMO5n1n6l/CyH
DnE7s081jVLQJZXRiwrp8OzJGb/LxvfrpclnJB7W2A7HJRvJRxjYOyukKQc/
ZuH+jkPLs2vFLJjPNmuiDRPP6Zotm3uJBR38xZedFDRe8HKMZDCxX2nrbM7L
rbEdfHw7BMsWIP91bKrMmN9H3bvE9QnmkG0xdDZikvjWuRlEXyZ2/mv1C9EG
BS/y50IvPLYGKqNc/YkJghr9SkbBhzaQl7U6Yr4ZAf/w9t5+ig5j9yquHmUi
3C/zyZ/1diNOvMEbvhhM3FNGPU81/jdxm6DWq5eF3VXfV2eqscW+xxIIqn3s
YMVG8a8igrihZK1RJSbuGW8v04YTL+8teLLb6OTAqXTNZjtwV+6lXRIhCHcu
FtEf2eL7E6yO6fI3tYLF6rSalz4I5xvwvei0zo24fJz5ZYUjcWfq/bQrtghk
enNLdZkV9h81k5IduxjYWv2oi26JCeGn52m5WxFIVuUJjVoWmHckzs8a5wnd
1K59lXbw/3v6H7bXWC0=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxl02tIk1EcBvA3dTMtL5huoeZlztBMQSszjL1/7xoZZaEZNWQnISUplJQu
ZJr3mckS855lecupeMnLkmbmNJkjLS8IlQPRLXSpE80L1vqw80p9eD78vhwO
53mOPe9GWLQuQRC7NOFooqNJUF8CYSxBULHWPlPTZA9a+wWurmVNsbAbS+ay
7mU6AF+vMSOpHYGeGVca5c+GnBI/4YcaBBsFQvLzBBtktOzgi08QVE7zAozo
jnBT5MJgZVP2SUlaXkqnvC+oT9ab+r/jZvO/+MrY2A/8QouhlA0VIauoOo3y
ljyX3pNJee6lj1V8JQLD+Nd336Ww4dNaYxnRgKB5KjCUVuwAXfXzoqFGBNnl
aa7nvrPgt0sGvacJwVBBf2t3NeWWCRHJLaN8hbjF5SjssQ0lSftDJAewPcvP
Jyc8tsbup20auuZZwsiAZJjXjEDna2i12NkSmI4ePRVtCNYLv1VVCZgQ9Czg
VcRHzfupHY56PWKA++yvlu0xBA3Wl6562zLweVGsAuGMzBzbmDY5v2Bihh0b
PuA9smCKvWHLsBNf1sXOjNvtz7HZJLUukjNrxwvWyK7l4PjjtQgiOdtJSr6a
3BZxEgpfIMgz8RlTPF8kLU4oWbGlCN4eo3l485Xk1jqh4mv66xQMNzeQCnJY
2F5GaPq4YKOIcFbPkdq+Bk+HrVj1zmJ31tmdDVLOYLeJE37KBXLyUBi9dTud
cmRu97hbNuWcrIbkmDrK2j0uPzzodl21iJ1rCv3SmC3sQTvXNL56L97vZo2V
06KvGfb92x3XOhRmkDjAKz0s0/S5R6V/0sAcEp/ekeaNIggIKDvTUmQOlinv
f6xPaez0JrW6yQKOTNro16h2WFxvO7m4w7WeXgZqBKPjowueXZS1fWqdwZNP
kekMyE8UIPclyqeM4ghjFeWxDqmyZJqy9v4r4+JwAy4T2/rvQKOt4N///Ac5
PMcm
    "]]},
  AspectRatio->Automatic,
  ImageSize->{163., 13.},
  PlotRange->{{0., 163.}, {0., 13.}}]], "Output",
 CellChangeTimes->{3.5166277523471518`*^9}]
}, Open  ]],

Cell["And here is a matrix example:", "Text",
 CellChangeTimes->{{3.454895190117477*^9, 3.454895203200274*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", "z"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.454208805755584*^9, 3.454208814307929*^9}, {
   3.454208859428432*^9, 3.454208876843842*^9}, {3.454209845595008*^9, 
   3.454209846133011*^9}, 3.45424712663667*^9, {3.454253556388185*^9, 
   3.454253556779378*^9}, {3.454271548255204*^9, 3.4542715577256317`*^9}, {
   3.454272089314067*^9, 3.454272090351903*^9}, {3.454895206434762*^9, 
   3.454895239513467*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "z"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.516627752400401*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.029411764705882353`], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{3.770740000000001, 
    1.1279696000000001`}, {6.440416187500001, 1.1279696000000001`}, {
    6.440416187500001, 1.7257280000000002`}, {4.368498400000001, 
    1.7257280000000002`}, {4.368498400000001, 24.540173600000003`}, {
    6.440416187500001, 24.540173600000003`}, {6.440416187500001, 
    25.137932000000006`}, {3.770740000000001, 25.137932000000006`}, {
    3.770740000000001, 1.1279696000000001`}}}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H9Qk3UcB/AB8kNQFOEKgbE9e7ZnBgJ79jxieAmfCC/BrJhDFjN+LFED
JiGKGKMQYYUECSQFCFL8dPLr3FkOGjASECpoOw4MyiXkSXBMuAOTVIq/vs9d
f7z/eP3x/tz37nPfD6ZIlSTasFgsq/UcXo/1epp8KVa7FgfPBetUSTkFd/dl
ROw04tDiGyUz36VgNbdLpg/jw67nSs3QbRr8a+36NjQIkN3f6xrX6Rk72alw
cyCB7Kb+Tu9aS4D44KDEo5EGB7W+8mdXAvTzKXd6KmgwJT8P9usQwKkN19ye
yhnnGXadpbmMz6fF6XufUHAuerrR96EA3nxR39Y5RMGNpfjC35UEsvWQj3xy
ijFBxEpfzRLCV91YzeMVxq8NLy8Oy2hkzqJjsdevNHS4mI5eOkTAb7OSbXee
0jA722RhXRMg3/LV0O5qPrLm+tKnveM4mGS1uc0qGkQxJdN+lTj4KLs8NPto
+DsuNB68cMimC+3MMzSkOCfnh23moX5x8wqelIUh8/pZBcR9b+S3VrGcB/Ve
cHR597MhHYVctKYOCcpibGw4yZYkULCNN/pn5EY2cuiV6Z8cvRmPRajCu5WM
S9Jbrth/xoZ389Kjc45RYFjoyeutZUODZ0KkUUWBJMQtzbziDbH2+oWX1TS0
9RmCPhrgov1mzM+3b07DkI+3sccfjDK22vvDxY05PDh3WqkLa2cc7DhRJ+Iz
bpHvFWaPUVC9o23U4MMDsH+jvEBIofmRxtdHZ7pJkPkn+hRzMdh52m1cxSGh
+2rPmaQPuLCi47u7a0Wwoz+7MlzIQW5LZy9/O+eNnLJaOvGFDWP5qmedL8mG
C5m3MstMIqjR2uaNv+QNwQkF9lKzCF5RVOC/2HIgFGuSWlxJ5P0Y/5hLDOMl
1dsJgTUk6pfPZgB+gwQ720cr/5axkRduV83Pve+FXLow8aQp1RO8BtdO+Kcx
DiuxPHTDGJ+Y4tz7q1UEcbqgxf5ENhwcCenYrhJB1QsJATo2B1niP+uePMlF
brIN+OdiMQZf20YHnBGuv8djsK69GoPO0swxKpCEj5OFEaGTGAxdjTXrp0QQ
Hymn/T/noX7zjwpF+vc4cmxn+KbcPgHyfq7u0jd/ELAnL9/SaiCRD1u1ttez
xMiuMf3GQg8x+M0sltFaxiMjsrkt9YxDarMfK88yFs6k57qs/2/gixWXt4ph
C5HkfFNBwOqRIxWNayS6Pyed8rs1j0TwzPrD+yPH+Wi/B758x1w1iCNvqi46
UGjD2GK2G3DS8uCmKeaTCisS2Xr4sig8irHBJNWYi0i47rB7e5SRB3uk1Zyt
AyRIlj3PH3LA4dS9eueJQDH8/57+BxTtS1g=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1FlQU2cUB/BUBNkmgIaC0NKSAMUm9+be5AYHqHJGaLVY0KS0AQZagmAk
ispO2YoCI7LpAC2bbAI1A4ylBaxitaUJq2WzCCJrQAsFFFHJIAg2L9470z78
H35v5/vPOZ914ClRsBaNRntLE7EmWzSRFzRXOG7lgZvM5vMLEgLieg4YY3Qe
ZIX5TOmkUTY//JWFIINygBkxw7pEWdCTNsruIiDGI+Oc1QIOfyz8MzI9ScBA
5daH8jbKFeKR7ux6yuLkLMOmVByChoXY7X4CuiX29I1QHHjvTqYk1BKQol98
nwjBIYagr9wsJaDIbOOFyguHsHzJmUFPAtpVIWkL7jgY9zOTadYEtFXqtwY6
4qA0318yMsEHpaTu1cgHOAwJqks8i/lQN3hebLkTh8t3Mgr8v+BDhPvZY15y
DKyuZF+Iz8ShkrG06l+GweKixYxjMA4rxxZd23gYrNywMTdvxCBsT45RpwWX
dD/9o9lfLVHS9izxt7cfIlApcNnczsJJ68ynWL53hvJetyrnA2ocsnafcNJx
QuFg6iumWT4Ppk6m3JA8QqE6Hl8yjOTDJlvfRSXgwmiwXoLRGB+qCjCr3k+5
4Dw/d913lfK09rUl9YcE6Td9fS8ednhdh8LYnGh75zoBspYO6WITQjqMOH3v
xwk26W/wwBG2PRtirA2f7crkk57fIn8eHkk5AtcZWvblg0I+8bLLm/Ih8XqQ
byBl2/GgHGUe5ePEc0VWIRtoxgbG7wfwoXuupS+qgQ2DK27Dbel8kIjDixQE
BwbS04WfxBLAcBXa6K5yQLARWtul1LyH8TiorxQh7TX+mcW4krJpe3HL72bo
/5yJr1kmRVCeqXkkvMnX7J+/QdWTWQQKnuiF5i9r5luz40S1I5C3qSX0a+VD
RqRiUqmLwIN9F1NyG3lQLGy1/OlnDqQvbGOnMinXB1s/VdfipBv22eqVdmKw
ln73lmgeAY9el4adCRhc87qVvI3OJd3OuPd0tpeyWvedH847Y9A2CbmsKxic
Xqu7OpWMgYmUkNc/xuBLhP1xUQAGw5d6Xvgdx8B2x9yapSsGdp0igcE0F6S0
PfsVv3HhxJi6sOo+Cq/vOFbW7OVCdeOfTAaKgsORhqPZZ1EQ+bl1a2t6ZLIe
hJaUIaTluHuwmw9lqXip9u84DukcYceqzI4DOnOiX+ghKNTTPZPmoyl3ZUa5
qJopcwLYDhUvOcAMjovVlqMw39niEb4Lga4GbpLLEAoE7D5p7IvA9by7id2a
u3rjI+U1/WWJlE0Zh581GWl6UOSWqAc5gAz4HDWxwKDj4Nvx3tWU3Z0Kz7H5
lNWXG2T5F9lAr4tlRUxxSYcm2K1LVSjpssZDJsuaPUgkZKsrMg5opcWt6XIR
uIp3REvLEdJ5LbxpVTmXdHSxN7OzD4NTfs3Wzeuafnd8zU0zxWE06y/j70ow
+O//+i+FrFDd
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1GkwnAcYB/B1RdUmdlln7O777sE2bpYmovKIpJZJXJEsaho2iK2GrCtU
HWlHJ2FHREc7cWuTurLSKFHjTncRipVRG9c6y9ASk4MZR3S/9H1n2g//D7/n
2/OfeR5UEB8YpUEgENRU4auirsrX3CujSYgluAgbbL8ioMCpvP1zBNcS+m+Y
eIu8cM9xGR1DAbjjfhvyrU/GbWonOtU2ggKjkljhvmEB3M9PuH2wj8I4Ty34
wo+4k5rq2FQR7gUtcq0QtYBUT53VWSUKff28h7uv2UAZYRaEFaLgambtEbvG
hvL9mwlTqShEc1+lyXrYUNDBySNOIdDTP1j8QsKGYW79rcgsBDp5h/X7ctkQ
L17JsNmiQ1u/7+3mq2xoJoRlqS3RILdB99RxHzYs8bfiPpJTwax4L7wuhgXj
MjW/5hojSLEdv9kRxAK9GZeyBj0joCnkxuIMJtiTPxVZehnAg9PfVDxzZGDW
pHBvdDqhmMM4fnrdewjMH/TpGGgbYk4encz0zDLCzHcNPli5YALdbpED2oEo
iF07SpmDZkBJSve+ouplw/ju0I4PDRwd1EcWzjNgsHuToPUXHRSlnIaRCAaw
hB/umNgimBMrR68GfIv7374GwkZ6CVIUYqJ1Ja+5qnlX1/b67whmn0T5gGCd
ijn0WtPz0GxzcHu0+yKumob5kHPsbOE53NYvF2Pyl6mw8YnE4Pt53Nqty6st
b3A3SlvdxHwqZvfE8WrzCCqECbf9vXapsDcV1bVRQIVHhNlryjIaHGsdC8y9
R4OAn1KsNm1Q4PG8m3RICJjc8ZjZ6lXtY/rnG3kz7lsLZ+qU07i9Bwt9ntqh
/7NsO6T7Mgt30py99eR9BPIEGk6bBwgoRWkCMYJAxQGtPUWJQD1zKuh4Nh06
09rie1VzGZdIJ3sfhVJJAj+qiA4ZirV2haYpZr1u/9EfLIwxI9xw55NlBmCb
P3A+SB2FQsHAqE2sPqyFNJN0LBiYd0yHsleXcdON7acpd5iQUDMcctHYACg7
futPTVlQJSt9nOZAgbnLvmbcCSa0laotuXL0IdOqP+dEORNqW6+nz7iToETL
WSFVMCBOKsoxDyaC06iDQ/UlBpxDnz1USnTgs5iarfxiFDSl1T4PhNpwifN8
v/QJgnna5fTbsyLcLq3DyXI2HXOOJJM88SUNxl7Nv+u/9z70WIrNX1DpmHfQ
qXJZCe7wKGZvFRmBj1eyNO4X6QJtuHEm0UN1H4YXzcS+RIg5a/eOnIBASdWc
ya/hhzHz5NaROn8fwfxLmu5kcSsJ8goM+ZsTdKDEOdYRF0mwXWVu1JSKezcT
sQv9joY5yD/grVUAFb7IaudLTuK+fsb+iG06ETMX/SM6sOg9ECRKSS+16NAX
na3b+FgLFly6DglbEMx9XccSFlsYmBHX2rG7LSxIk8bWCJaIUGX1ZEPXkw2D
YaZBR1f14b//9R9Wx0cp
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsqrEBLWICow==
    "], CompressedData["
1:eJxd1GswXAcUB/BrvSrCeGd3sQ8h2N17965kSDUbRxKk9WZLisZbqGSRaPNC
ibCeoSO6sh6Z2ZpmkyqVUBlp4hVV6jHtSEPRqookFYvYCKuoT/fO9MP/w+/b
/5wzc9gxKUHxmgiCaOzkxE4oO5mZUUwes+CBSBVvqKRYwIxdRWO6LQoOSP1E
WwAVDmRa6ua2otCPrWr2+NOgUBTzQp6EwWyj4teoYjrh1I97hcvX6eAZ1ZAy
XceHwVCKY3ObFQxVX3TIdsSB0toQkuPIgDNFp0soewRwOXvqZtcKC8w+C1Qh
fgK4Zb0gHv2HTfipFAkt3SadmKD/7coBGxj6I1bd5ELaHYnszHEi7da5vbHG
Im30/f5bCTQB+N/WeFfKsQGZaNxqt4EAdJzyqOvrbPDbHHrC6sZhTOXxnK1m
wQfC7wryS3FIn8Z5v9ezIEJ9aL4jkLQjHvx+hTnpOOv9byIX+aBbNqAoVbGA
+qN9Y3o9H4R64fIkfzbYa65Kajz44NX/BrEfYEOPcnpQtIQR/Qa5TpUfeZMO
OL8u6BrlEb6hH8FIVnJhvdE9Uu3LIhzctMjY6GASTtjd8PdaCRPWmKq+sk0u
LLR7CxMCmCDxG3kg4PAIy4ul92+Gkua7tuzFo3mwfCmpCMljgtfbh9KSZB5c
efnVEW4PEw62Lz6MG+DBq2WB4ewICyYTkZScVyhhW/BFw80wwlhnQV9ZJmlG
bvvCqUkMTsbmZ+g0sOBes8kKz58PhZk+rVG5LAhRd4zX6ONgp3cqYsqZBZzU
uwZW9qTrv+A8M0okrbaTqBBDHKpje2ZDOxgQEWZQuHEeAy8dReSY0hKSpRMx
e2kY6JfsXNrXEmqGtS42MFE4kh1y58MSGgwkFrpS6SjUtUSiaA6N2Mekour6
oDYVao/jT3w0uXDyl7mDbQnmQH8a59Ql4oDcZsbdkGdKuMYmHp9/ZkI4I8//
KuOyCSxFDIdz80m/Qx8bkZSTDly2vRZ9n3RSI0Z51M2BypmCMLdrJiD7Kc3n
vWkO1MU8Vp17awIPtNvCBoO50G7zm0R2zAyCW4ZeyF9y4ayY0i30MIcLxhoz
eoU8wjf8PJdk/5IWjzbRtDEUrngjW46LZmDVaVyx7xsUmuWyhfgJU8ge3ecn
RjA4KqY725mZAgcGDmeFYUS/DGmQtGSeNJ7KZ7qdwQkfAvdzzzdxMM0WM4Th
ewifuNTWkxpPJexhvbF1tooKn+xq1FxewcGp87Drpz9TobdOYqs1TTpLV8a5
10/6tUPl0tXHOGz3nu6/U0GFbkZ/9esfcHCzzlrwD6LCBV1rWnkuDlX6lZ+j
qzv38pxzzu/jE/Pb5rpsF9mQjgkrkjEeYYTblHO3DeMwoNROtf6ZZg6umVXU
rzdQULqxl/+qN4c0kVhuEYhCsjGw8rUswG4zJpyrg4KR9ZfRLmwLUBSbDXTX
8giXD+8KSaggvcVMG797lPT//+1/I706eA==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{29.631584800000002`, 
    1.7256879999999981`}, {27.559667012500004`, 1.7256879999999981`}, {
    27.559667012500004`, 1.127929599999998}, {30.229343200000002`, 
    1.127929599999998}, {30.229343200000002`, 25.137892000000004`}, {
    27.559667012500004`, 25.137892000000004`}, {27.559667012500004`, 
    24.5401336}, {29.631584800000002`, 24.5401336}, {29.631584800000002`, 
    1.7256879999999981`}}}]},
  AspectRatio->Automatic,
  ImageSize->{34., 26.},
  PlotRange->{{0., 34.}, {0., 26.}}]], "Output",
 CellChangeTimes->{3.516627752681336*^9}]
}, Open  ]],

Cell["\<\
In some cases Mathematica may misinterpret or fail to import certain PDF \
files. In the above example a more accurate result is obtained if looked \
through an external PDFViewer:\
\>", "Text",
 CellChangeTimes->{{3.4548964202721043`*^9, 3.4548964789164658`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NCTeX", "[", 
  RowBox[{"exp", ",", 
   RowBox[{"DisplayPDF", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.454896464565049*^9, 3.454896469053131*^9}, {
  3.4548967068081217`*^9, 3.454896714815837*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.029411764705882353`], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{3.770740000000001, 
    1.1279696000000001`}, {6.440416187500001, 1.1279696000000001`}, {
    6.440416187500001, 1.7257280000000002`}, {4.368498400000001, 
    1.7257280000000002`}, {4.368498400000001, 24.540173600000003`}, {
    6.440416187500001, 24.540173600000003`}, {6.440416187500001, 
    25.137932000000006`}, {3.770740000000001, 25.137932000000006`}, {
    3.770740000000001, 1.1279696000000001`}}}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H9Qk3UcB/AB8kNQFOEKgbE9e7ZnBgJ79jxieAmfCC/BrJhDFjN+LFED
JiGKGKMQYYUECSQFCFL8dPLr3FkOGjASECpoOw4MyiXkSXBMuAOTVIq/vs9d
f7z/eP3x/tz37nPfD6ZIlSTasFgsq/UcXo/1epp8KVa7FgfPBetUSTkFd/dl
ROw04tDiGyUz36VgNbdLpg/jw67nSs3QbRr8a+36NjQIkN3f6xrX6Rk72alw
cyCB7Kb+Tu9aS4D44KDEo5EGB7W+8mdXAvTzKXd6KmgwJT8P9usQwKkN19ye
yhnnGXadpbmMz6fF6XufUHAuerrR96EA3nxR39Y5RMGNpfjC35UEsvWQj3xy
ijFBxEpfzRLCV91YzeMVxq8NLy8Oy2hkzqJjsdevNHS4mI5eOkTAb7OSbXee
0jA722RhXRMg3/LV0O5qPrLm+tKnveM4mGS1uc0qGkQxJdN+lTj4KLs8NPto
+DsuNB68cMimC+3MMzSkOCfnh23moX5x8wqelIUh8/pZBcR9b+S3VrGcB/Ve
cHR597MhHYVctKYOCcpibGw4yZYkULCNN/pn5EY2cuiV6Z8cvRmPRajCu5WM
S9Jbrth/xoZ389Kjc45RYFjoyeutZUODZ0KkUUWBJMQtzbziDbH2+oWX1TS0
9RmCPhrgov1mzM+3b07DkI+3sccfjDK22vvDxY05PDh3WqkLa2cc7DhRJ+Iz
bpHvFWaPUVC9o23U4MMDsH+jvEBIofmRxtdHZ7pJkPkn+hRzMdh52m1cxSGh
+2rPmaQPuLCi47u7a0Wwoz+7MlzIQW5LZy9/O+eNnLJaOvGFDWP5qmedL8mG
C5m3MstMIqjR2uaNv+QNwQkF9lKzCF5RVOC/2HIgFGuSWlxJ5P0Y/5hLDOMl
1dsJgTUk6pfPZgB+gwQ720cr/5axkRduV83Pve+FXLow8aQp1RO8BtdO+Kcx
DiuxPHTDGJ+Y4tz7q1UEcbqgxf5ENhwcCenYrhJB1QsJATo2B1niP+uePMlF
brIN+OdiMQZf20YHnBGuv8djsK69GoPO0swxKpCEj5OFEaGTGAxdjTXrp0QQ
Hymn/T/noX7zjwpF+vc4cmxn+KbcPgHyfq7u0jd/ELAnL9/SaiCRD1u1ttez
xMiuMf3GQg8x+M0sltFaxiMjsrkt9YxDarMfK88yFs6k57qs/2/gixWXt4ph
C5HkfFNBwOqRIxWNayS6Pyed8rs1j0TwzPrD+yPH+Wi/B758x1w1iCNvqi46
UGjD2GK2G3DS8uCmKeaTCisS2Xr4sig8irHBJNWYi0i47rB7e5SRB3uk1Zyt
AyRIlj3PH3LA4dS9eueJQDH8/57+BxTtS1g=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1FlQU2cUB/BUBNkmgIaC0NKSAMUm9+be5AYHqHJGaLVY0KS0AQZagmAk
ispO2YoCI7LpAC2bbAI1A4ylBaxitaUJq2WzCCJrQAsFFFHJIAg2L9470z78
H35v5/vPOZ914ClRsBaNRntLE7EmWzSRFzRXOG7lgZvM5vMLEgLieg4YY3Qe
ZIX5TOmkUTY//JWFIINygBkxw7pEWdCTNsruIiDGI+Oc1QIOfyz8MzI9ScBA
5daH8jbKFeKR7ux6yuLkLMOmVByChoXY7X4CuiX29I1QHHjvTqYk1BKQol98
nwjBIYagr9wsJaDIbOOFyguHsHzJmUFPAtpVIWkL7jgY9zOTadYEtFXqtwY6
4qA0318yMsEHpaTu1cgHOAwJqks8i/lQN3hebLkTh8t3Mgr8v+BDhPvZY15y
DKyuZF+Iz8ShkrG06l+GweKixYxjMA4rxxZd23gYrNywMTdvxCBsT45RpwWX
dD/9o9lfLVHS9izxt7cfIlApcNnczsJJ68ynWL53hvJetyrnA2ocsnafcNJx
QuFg6iumWT4Ppk6m3JA8QqE6Hl8yjOTDJlvfRSXgwmiwXoLRGB+qCjCr3k+5
4Dw/d913lfK09rUl9YcE6Td9fS8ednhdh8LYnGh75zoBspYO6WITQjqMOH3v
xwk26W/wwBG2PRtirA2f7crkk57fIn8eHkk5AtcZWvblg0I+8bLLm/Ih8XqQ
byBl2/GgHGUe5ePEc0VWIRtoxgbG7wfwoXuupS+qgQ2DK27Dbel8kIjDixQE
BwbS04WfxBLAcBXa6K5yQLARWtul1LyH8TiorxQh7TX+mcW4krJpe3HL72bo
/5yJr1kmRVCeqXkkvMnX7J+/QdWTWQQKnuiF5i9r5luz40S1I5C3qSX0a+VD
RqRiUqmLwIN9F1NyG3lQLGy1/OlnDqQvbGOnMinXB1s/VdfipBv22eqVdmKw
ln73lmgeAY9el4adCRhc87qVvI3OJd3OuPd0tpeyWvedH847Y9A2CbmsKxic
Xqu7OpWMgYmUkNc/xuBLhP1xUQAGw5d6Xvgdx8B2x9yapSsGdp0igcE0F6S0
PfsVv3HhxJi6sOo+Cq/vOFbW7OVCdeOfTAaKgsORhqPZZ1EQ+bl1a2t6ZLIe
hJaUIaTluHuwmw9lqXip9u84DukcYceqzI4DOnOiX+ghKNTTPZPmoyl3ZUa5
qJopcwLYDhUvOcAMjovVlqMw39niEb4Lga4GbpLLEAoE7D5p7IvA9by7id2a
u3rjI+U1/WWJlE0Zh581GWl6UOSWqAc5gAz4HDWxwKDj4Nvx3tWU3Z0Kz7H5
lNWXG2T5F9lAr4tlRUxxSYcm2K1LVSjpssZDJsuaPUgkZKsrMg5opcWt6XIR
uIp3REvLEdJ5LbxpVTmXdHSxN7OzD4NTfs3Wzeuafnd8zU0zxWE06y/j70ow
+O//+i+FrFDd
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1GkwnAcYB/B1RdUmdlln7O777sE2bpYmovKIpJZJXJEsaho2iK2GrCtU
HWlHJ2FHREc7cWuTurLSKFHjTncRipVRG9c6y9ASk4MZR3S/9H1n2g//D7/n
2/OfeR5UEB8YpUEgENRU4auirsrX3CujSYgluAgbbL8ioMCpvP1zBNcS+m+Y
eIu8cM9xGR1DAbjjfhvyrU/GbWonOtU2ggKjkljhvmEB3M9PuH2wj8I4Ty34
wo+4k5rq2FQR7gUtcq0QtYBUT53VWSUKff28h7uv2UAZYRaEFaLgambtEbvG
hvL9mwlTqShEc1+lyXrYUNDBySNOIdDTP1j8QsKGYW79rcgsBDp5h/X7ctkQ
L17JsNmiQ1u/7+3mq2xoJoRlqS3RILdB99RxHzYs8bfiPpJTwax4L7wuhgXj
MjW/5hojSLEdv9kRxAK9GZeyBj0joCnkxuIMJtiTPxVZehnAg9PfVDxzZGDW
pHBvdDqhmMM4fnrdewjMH/TpGGgbYk4encz0zDLCzHcNPli5YALdbpED2oEo
iF07SpmDZkBJSve+ouplw/ju0I4PDRwd1EcWzjNgsHuToPUXHRSlnIaRCAaw
hB/umNgimBMrR68GfIv7374GwkZ6CVIUYqJ1Ja+5qnlX1/b67whmn0T5gGCd
ijn0WtPz0GxzcHu0+yKumob5kHPsbOE53NYvF2Pyl6mw8YnE4Pt53Nqty6st
b3A3SlvdxHwqZvfE8WrzCCqECbf9vXapsDcV1bVRQIVHhNlryjIaHGsdC8y9
R4OAn1KsNm1Q4PG8m3RICJjc8ZjZ6lXtY/rnG3kz7lsLZ+qU07i9Bwt9ntqh
/7NsO6T7Mgt30py99eR9BPIEGk6bBwgoRWkCMYJAxQGtPUWJQD1zKuh4Nh06
09rie1VzGZdIJ3sfhVJJAj+qiA4ZirV2haYpZr1u/9EfLIwxI9xw55NlBmCb
P3A+SB2FQsHAqE2sPqyFNJN0LBiYd0yHsleXcdON7acpd5iQUDMcctHYACg7
futPTVlQJSt9nOZAgbnLvmbcCSa0laotuXL0IdOqP+dEORNqW6+nz7iToETL
WSFVMCBOKsoxDyaC06iDQ/UlBpxDnz1USnTgs5iarfxiFDSl1T4PhNpwifN8
v/QJgnna5fTbsyLcLq3DyXI2HXOOJJM88SUNxl7Nv+u/9z70WIrNX1DpmHfQ
qXJZCe7wKGZvFRmBj1eyNO4X6QJtuHEm0UN1H4YXzcS+RIg5a/eOnIBASdWc
ya/hhzHz5NaROn8fwfxLmu5kcSsJ8goM+ZsTdKDEOdYRF0mwXWVu1JSKezcT
sQv9joY5yD/grVUAFb7IaudLTuK+fsb+iG06ETMX/SM6sOg9ECRKSS+16NAX
na3b+FgLFly6DglbEMx9XccSFlsYmBHX2rG7LSxIk8bWCJaIUGX1ZEPXkw2D
YaZBR1f14b//9R9Wx0cp
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsqrEBLWICow==
    "], CompressedData["
1:eJxd1GswXAcUB/BrvSrCeGd3sQ8h2N17965kSDUbRxKk9WZLisZbqGSRaPNC
ibCeoSO6sh6Z2ZpmkyqVUBlp4hVV6jHtSEPRqookFYvYCKuoT/fO9MP/w+/b
/5wzc9gxKUHxmgiCaOzkxE4oO5mZUUwes+CBSBVvqKRYwIxdRWO6LQoOSP1E
WwAVDmRa6ua2otCPrWr2+NOgUBTzQp6EwWyj4teoYjrh1I97hcvX6eAZ1ZAy
XceHwVCKY3ObFQxVX3TIdsSB0toQkuPIgDNFp0soewRwOXvqZtcKC8w+C1Qh
fgK4Zb0gHv2HTfipFAkt3SadmKD/7coBGxj6I1bd5ELaHYnszHEi7da5vbHG
Im30/f5bCTQB+N/WeFfKsQGZaNxqt4EAdJzyqOvrbPDbHHrC6sZhTOXxnK1m
wQfC7wryS3FIn8Z5v9ezIEJ9aL4jkLQjHvx+hTnpOOv9byIX+aBbNqAoVbGA
+qN9Y3o9H4R64fIkfzbYa65Kajz44NX/BrEfYEOPcnpQtIQR/Qa5TpUfeZMO
OL8u6BrlEb6hH8FIVnJhvdE9Uu3LIhzctMjY6GASTtjd8PdaCRPWmKq+sk0u
LLR7CxMCmCDxG3kg4PAIy4ul92+Gkua7tuzFo3mwfCmpCMljgtfbh9KSZB5c
efnVEW4PEw62Lz6MG+DBq2WB4ewICyYTkZScVyhhW/BFw80wwlhnQV9ZJmlG
bvvCqUkMTsbmZ+g0sOBes8kKz58PhZk+rVG5LAhRd4zX6ONgp3cqYsqZBZzU
uwZW9qTrv+A8M0okrbaTqBBDHKpje2ZDOxgQEWZQuHEeAy8dReSY0hKSpRMx
e2kY6JfsXNrXEmqGtS42MFE4kh1y58MSGgwkFrpS6SjUtUSiaA6N2Mekour6
oDYVao/jT3w0uXDyl7mDbQnmQH8a59Ql4oDcZsbdkGdKuMYmHp9/ZkI4I8//
KuOyCSxFDIdz80m/Qx8bkZSTDly2vRZ9n3RSI0Z51M2BypmCMLdrJiD7Kc3n
vWkO1MU8Vp17awIPtNvCBoO50G7zm0R2zAyCW4ZeyF9y4ayY0i30MIcLxhoz
eoU8wjf8PJdk/5IWjzbRtDEUrngjW46LZmDVaVyx7xsUmuWyhfgJU8ge3ecn
RjA4KqY725mZAgcGDmeFYUS/DGmQtGSeNJ7KZ7qdwQkfAvdzzzdxMM0WM4Th
ewifuNTWkxpPJexhvbF1tooKn+xq1FxewcGp87Drpz9TobdOYqs1TTpLV8a5
10/6tUPl0tXHOGz3nu6/U0GFbkZ/9esfcHCzzlrwD6LCBV1rWnkuDlX6lZ+j
qzv38pxzzu/jE/Pb5rpsF9mQjgkrkjEeYYTblHO3DeMwoNROtf6ZZg6umVXU
rzdQULqxl/+qN4c0kVhuEYhCsjGw8rUswG4zJpyrg4KR9ZfRLmwLUBSbDXTX
8giXD+8KSaggvcVMG797lPT//+1/I706eA==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{29.631584800000002`, 
    1.7256879999999981`}, {27.559667012500004`, 1.7256879999999981`}, {
    27.559667012500004`, 1.127929599999998}, {30.229343200000002`, 
    1.127929599999998}, {30.229343200000002`, 25.137892000000004`}, {
    27.559667012500004`, 25.137892000000004`}, {27.559667012500004`, 
    24.5401336}, {29.631584800000002`, 24.5401336}, {29.631584800000002`, 
    1.7256879999999981`}}}]},
  AspectRatio->Automatic,
  ImageSize->{34., 26.},
  PlotRange->{{0., 34.}, {0., 26.}}]], "Output",
 CellChangeTimes->{3.5166277530672894`*^9}]
}, Open  ]],

Cell["\<\
In some cases Mathematica will simply fail to import certain PDF files. When \
this happens NCTeX will automatically span a PDF viewer so that you can look \
at the formula.\
\>", "Text",
 CellChangeTimes->{{3.454896497477681*^9, 3.4548965133802834`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"exp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"NonCommutativeMultiply", "@@", 
      RowBox[{"Table", "[", 
       RowBox[{"x", ",", 
        RowBox[{"{", 
         RowBox[{"Floor", "[", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"i", "+", "j"}], "]"}], "]"}], "}"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "30"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "20"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NCTeX", "[", 
   RowBox[{"exp", ",", 
    RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell["NCTeX Options", "Subsection",
 CellChangeTimes->{{3.4548828671006536`*^9, 3.454882877840214*^9}}],

Cell["\<\
Other options are available with NCTeX. The following examples are from the \
NCTeX.nb file. The following command:\
\>", "Text",
 CellChangeTimes->{{3.454882885148134*^9, 3.4548829376875267`*^9}, {
   3.454896777142989*^9, 3.454896805798574*^9}, 3.4548968412178183`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"Sin", "[", 
        RowBox[{"x", "+", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"y", "-", "z"}], ")"}], "/", "2"}], " ", 
          RowBox[{"Sqrt", "[", "2", "]"}]}]}], "]"}]}], ",", 
      RowBox[{"x", "/", "y"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", 
      RowBox[{"n", " ", 
       RowBox[{"Sqrt", "[", "5", "]"}]}]}], "}"}]}], "}"}]}], "\n", 
 RowBox[{"NCTeX", "[", 
  RowBox[{"exp", ",", 
   RowBox[{"DisplayPDF", "\[Rule]", "True"}], ",", 
   RowBox[{"ImportPDF", "\[Rule]", "False"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.454875313028338*^9, 3.454875323133481*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "+", 
      RowBox[{"Sin", "[", 
       RowBox[{"x", "+", 
        FractionBox[
         RowBox[{"y", "-", "z"}], 
         SqrtBox["2"]]}], "]"}]}], ",", 
     FractionBox["x", "y"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{
      SqrtBox["5"], " ", "n"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5166277570511293`*^9}]
}, Open  ]],

Cell["\<\
opens the PDFViewer without trying to import the PDF. By the way, this is the \
default behavior when NCTeX from the command line. Other options to NCTeX are \
:\
\>", "Text",
 CellChangeTimes->{{3.454875329548409*^9, 3.454875335006876*^9}, {
  3.454882240953561*^9, 3.454882256013431*^9}, {3.454882940796283*^9, 
  3.454882975223599*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "NCTeX", "]"}], "//", "ColumnForm"}]], "Input",
 CellChangeTimes->{{3.4548753360024357`*^9, 3.454875344578216*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"Verbose", "\[Rule]", "False"}]},
    {
     RowBox[{"DisplayPDF", "\[Rule]", "False"}]},
    {
     RowBox[{"ImportPDF", "\[Rule]", "True"}]},
    {
     RowBox[{"BreakEquations", "\[Rule]", "True"}]},
    {
     RowBox[{"TeXProcessor", "\[Rule]", "NCTeXForm"}]},
    {
     RowBox[{"PDFViewer", "\[Rule]", "\<\"open\"\>"}]},
    {
     RowBox[{"LaTeXCommand", "\[Rule]", "\<\"latex\"\>"}]},
    {
     RowBox[{"PDFLaTeXCommand", "\[Rule]", "\<\"pdflatex\"\>"}]},
    {
     RowBox[{"DVIPSCommand", "\[Rule]", "\<\"dvips\"\>"}]},
    {
     RowBox[{"PS2PDFCommand", "\[Rule]", "\<\"epstopdf\"\>"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{
   Verbose -> False, NCTeX`DisplayPDF -> False, NCTeX`ImportPDF -> True, 
    NCTeX`BreakEquations -> True, NCTeX`TeXProcessor -> NCTeXForm`NCTeXForm, 
    NCTeX`PDFViewer -> "open", NCTeX`LaTeXCommand -> "latex", 
    NCTeX`PDFLaTeXCommand -> "pdflatex", NCTeX`DVIPSCommand -> "dvips", 
    NCTeX`PS2PDFCommand -> "epstopdf"}],
  Editable->False]], "Output",
 CellChangeTimes->{3.516627757404299*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["BreakEquations",
  FontWeight->"Bold"],
 " use the package 'beqn' to produce nice displays of long equations. Take a \
look at the following example:"
}], "Text",
 CellChangeTimes->{{3.454875358972855*^9, 3.454875415850533*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"Exp", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "20"}], "}"}]}], "]"}], "//", 
   "Normal"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.4548754236283197`*^9, 3.454875479428261*^9}, {
  3.454896896907359*^9, 3.454896926939431*^9}, {3.454897185560031*^9, 
  3.45489720515152*^9}, {3.45489816211866*^9, 3.454898169503559*^9}, {
  3.454898236166998*^9, 3.4548982510629187`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", "x", "+", 
  FractionBox[
   SuperscriptBox["x", "2"], "2"], "+", 
  FractionBox[
   SuperscriptBox["x", "3"], "6"], "+", 
  FractionBox[
   SuperscriptBox["x", "4"], "24"], "+", 
  FractionBox[
   SuperscriptBox["x", "5"], "120"], "+", 
  FractionBox[
   SuperscriptBox["x", "6"], "720"], "+", 
  FractionBox[
   SuperscriptBox["x", "7"], "5040"], "+", 
  FractionBox[
   SuperscriptBox["x", "8"], "40320"], "+", 
  FractionBox[
   SuperscriptBox["x", "9"], "362880"], "+", 
  FractionBox[
   SuperscriptBox["x", "10"], "3628800"], "+", 
  FractionBox[
   SuperscriptBox["x", "11"], "39916800"], "+", 
  FractionBox[
   SuperscriptBox["x", "12"], "479001600"], "+", 
  FractionBox[
   SuperscriptBox["x", "13"], "6227020800"], "+", 
  FractionBox[
   SuperscriptBox["x", "14"], "87178291200"], "+", 
  FractionBox[
   SuperscriptBox["x", "15"], "1307674368000"], "+", 
  FractionBox[
   SuperscriptBox["x", "16"], "20922789888000"], "+", 
  FractionBox[
   SuperscriptBox["x", "17"], "355687428096000"], "+", 
  FractionBox[
   SuperscriptBox["x", "18"], "6402373705728000"], "+", 
  FractionBox[
   SuperscriptBox["x", "19"], "121645100408832000"], "+", 
  FractionBox[
   SuperscriptBox["x", "20"], "2432902008176640000"]}]], "Output",
 CellChangeTimes->{3.51662775747329*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.0024449877750611247`], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYrbTOa+ZKvkcNk0Xeld1IsQBxm+du7fv8jUE
P8xYcQ7rjRCH2cYTO+7v5YHzk99a/lr5ld1BtXLd+8MbQxy6r169/FeDEc6f
5LtiWnLAX3t0Po9MqeTieSEOS/tDrDabMTjA+DUPW36UXWWB86V+shUcecLh
cPyBuO/adQj+lOOdqZmpwXC+KTvHsxl+wQ4Lli87abgCyI+WE3jrFuxQWzFN
QXkRI5xfMVnTYJ3TP3t0vjEYBDvMDO2rD73B6ADjt3vlfhaYygHnCzzaufbx
Om44f0YlW8a2E3xwvvP2T293HBKC8w1r1ytayIlg8GH2X1yaJ3vprhCcXy9z
duLUrXxwPiz8q2dZxD3zRfDTMpc/a0pF8GHxBwDwF7nv
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4pUrfk09Z67iMGf51Lk3jwY7rBKvmTV5lSac
v0H85+ptHxD8Bbe0LvX5a2HwIyak6cy6hOALV5rvjrqP0A/jw8yH8WH2o/Mz
StZ8N5gQAudbbft5i28mgp854W4C89IQh/NJxfKnLirD+V9l3qw4mo3Jh+mH
8WHmw/gw+2PX7rhb8EIazg9cu2+XVgyCX6AenVc1TwqDD/M/jA8LH5h+GB9m
PowPsx+db9Dcc7tZBMGPc7T/sZQbwY89avtx+v8guP9hfFj4oPNh+mF8mPno
8Q8AmGUD0g==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtMk2cUB/CWTjamgekkRhAYd0LRkfdmi3QcrprRbZbnLcQSQSiwQtZA
DLJBKGayMCcbF3GMwWTcsi4ItUEDA5GLl4GmgkiGs05gCyq2hW0FFIbY9Yvv
s+zD/8Pvw/98OCc53um5CZkCHo/HtyfRHgd7NIN/9C2l0KCg0BvpVgS10leO
dKlpsF3VvrtJwEKAOeBxkZaGtNXdMzYJC8OFhobGJIYzcz8gYE2JrQ/53FDe
hH3R0rYz4BcGjkhjnFiGBZ0l8DVBJQOCi51ZEpKFmpn9RuIwA6F9/WKDL3b+
k9TTxu3/sdzUuvE6C1nyMOeuTxh4PBD5VrgNQWlLIW9zP7awIkXltIR9OXx1
rj9qL/TOu+2Kt/dfuu3ceCjPF9uddq3bHs3CCYJQz+kYiCcDCwfjWfD09Oj6
7hB2WYSnPGiU5nzcFnm8OI+GA5VhXz8TsnBlamsImUBDChu5vteThR8OmXLC
36SBjKOZ67EszOpLNAPlFNf/e+OqdCIK26pwepApITm/0E7Uy3UEhBQ0LUWs
I849ovxrDWbskz6L694PEeyxPr+QN4Ldd5u/2GjATg0PulU+i10Rt+ztOU+A
UJF7Sv0IgZv/WrJ0gYCNQdMo34KgROy840wUCeY+vj55Dwv8ze1JyfMkd99M
r8FtrRKK8wPer/4uamzhaDDP+zoFxNRCS6MIu3XfybP3XLFt42kDFj4Lq5Im
H009BXNF/sbzU4ibr1JnqMqKEUwNrX+gdKXAq3ZHeweL4Iu1H4/JLpNQrW0o
qhEjWK5XNS++j11bdvvZjQjsTfOdeXxHbH5Qle+HEwRQ3wwlHI1EcLr25v1q
FxKUE/kFLTEIxCfOR1fFkZAR2e90Q4ad9an7mEyJfbDu0ZbkfNwXk/qYxEIE
ZlOMaJeJ4PzQTb9S+z22i79N5JhGgDH4jvPObOwMjwrdNjn2Yq6bZb8IgUPd
3e6vpgnQftQyOylEIMttLjslJTlPgmREZsUu6ZjtSZNSUBymGmpPRNDZ3bFl
GVFw5aw+W6FAkDPzW6rkKAWO3jmW/mgEijtP2QsGCvcr/zHLlTTne46LcDiL
4TzW61+qXmHAx0j+JdJgZ/dqmp5+iV03LsjOq0EADcOfdU9jb61eedvvLvbN
tVeZySHsd9wFz9suMeDn4HXLWoWgK/zFcEE3AwlVT9w+ts9/+X/+vET6/XQA
QZCw7Jygl+bue3DlWLBJhR26Wjn7uyN287cGj5ZpCoZ3Z0+R72GfMfcMeaVj
X+sMTI3NQ8DTZYz8vECBz1hhsazEvm/fpPVYJxr0+n2i0noE//+n/wI+JF6K

    "]], FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
    1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4kdRbxP1/9g6zFk+de7No8EOhpzin05EOcD5
xp5l2wJzEPz3O5kOsLdg8iMmpOnMuoTgC1ea7466j9AP48PMh/Fh9qPzM0rW
fDeYEALnW237eYtvJoKfOeFuAvPSEIev21eq6Z5E8DlE015rTcPkw/TD+DDz
YXyY/U8N4/xSblkh3LNx/tGg7Qh+5oW2Tc/aMfkw/8P4sPCB6YfxYebD+DD7
0fkGzT23m0UQ/DhH+x9LuRH82KO2H6f/D4L7H8aHhQ86H6YfxoeZjx7/ANEc
9tw=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYgexv3+C2FwcLrVlSPaVhTnA+Et7hHc9a0Hw
y5TKj0u0hTmcijl/bMErZzg/7cXLXNl5zg6uGSzS1+PDHF4ua14dZIjg/+3+
/cqVE5Ovw33aZZtPmEPXpNeMekoI/orp52ylchB8pZ1uovxrnR2en8+tOBCD
4G/Zdn9CjXAonB/6LVZwzZ8QB64tD165rgTyvUqsGb6GOEhs9Gd4aoHg60w7
bn9DAJMfrNQZ5/YwxOGVnr2ahw2CbyFXe1d4BYK/8bki58abCL7mxmMmftwu
cH7FApY3kuUIvpllzaXORZh8mP1ecl8Ea6sQ/AjpZHUZLgQfFv6zO/s6f/5G
8Nsi/gpOA/ofPf4Avqe7Ag==
    "]], 
   RasterBox[{{0}}, {{37.1477, 79.0676}, {42.1877, 79.5476}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYu7MF79mHnVx+Gh02K3zTaBD7aqQWXLLEPxD
leqhH+e7OLCb5Lz3uxnoIDdtz4ef01wcvD4f32K2N9BhpUlS2vwuF4c3i3pP
9GwOdFgxxYjldqOLg1HaMv6KdYEOz1c/Sf6uh+ALm33SrxBG8BnuLfffbugM
5zeICyrM2+bsUKtpk9H2PtChsittvUeVi8OceWnmM92CHGDuLTjzZ8vqDARf
vze+4upyBP/D249zD78PctizcpJQTqiLw9H0hcFuSsEOysIfslP2OsP5+h4u
Tq0GCH7LFxFLlytODpMqO8OSXwbB+ZJv2nK9NyH4MZ/tXs7vD3JY2LnhIaeg
M5wv6n2bc4EIgu929N3HCE0E/yq33dmTwc4O4hKbdj2dhuAvkVt08ex6BH/v
fE7mpfuDHC7/Pnb9nq2zA0t98Oak80EOLlvL/+QKI/gih+X7V3Ei+IXTI0rc
2BH8v1d1fTYwOztIb1m45uS5IIdFD5t7ExWcHT7MvF2c/z3IQeZ1e217srPD
EfttZT18wQ5Klycsv70awXfW8JprLesC55dZTfh6JcjFwSTS3DL8dhCc3+Op
UrZoOYL/VDfcnq00yOHp6VDbVSIuDj/qIifIOAc5zNR5Zx90wdkhU+RO5Ffp
IIc8fb7LzI+cHF59elZwd0ogPHwXbz6j9KQXwWeo8Z4yowfBX5S++VVxbaBD
6tJ3+aGLXOB89PQMAFP8TcY=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxd03ss1VEcAPCLEcqNUnfz7IbIq6Wwlbrfu+R3WF1yfnl2PVMitdrsNr2V
V08hacy72NrNrmpxL1HWlNWuTRbdMZfQWMuKW8yj+8/5nc0f3z8+Oztn39cR
Jp0NTzHi8XgG+hDrw1Af1qJ0pwMbEYh3Syql7zAoa0ssD4kQnAkSjPcpMCSa
vFli0xG8uOvtoqjG4Ne2XnesDAF/eXDKohCDJHhnuW0DgnQdeCTcwhAW3Vho
0o4g++oTiW02huevKmYevacuGxDW5fdTsw/Mk59N6O1x37m7gPpvvbR0ppi6
WRsYavwYA3/PJa8xLQLLCHlpShWG8OvFGZ29CEa7R5G2DoPaNaDZaAuCRTtH
Lwc1hqGO1IPunxEIzsdaxS5gGGacOx0HEEi1Uu/fi/T9zImuKBWP5TwVX9Tz
3Zw6fjAhgL+J5fJPyAnZoLRjufqIU+P4KnUntdxLm1mrRCBTlq0V6m2WFTeC
5AjaLyvC1wlYIP1vMZ5RDWto/vYnHJpKxSxUt1d1+AoRrBlqva0JZrlzyYf2
pmtRLFRazJ/MNaR2m10oLvvFcHatcP0BIwwcP7K1b28Y9cVvuTodQ+1bfrpx
CVjISU3W/JtjuHwuuJnPbo9iwNBqtCd6MwvTb4NFJojh6iEm9U4JbYbEImqV
zGHbtDd1q39HYpI9w/WTmPSbmMwj09TOjPVk4I4I5AP6eakEkvwmf4abZ8TT
PwF9kwyMT/bueq2m5z1FJaFZ9Zi7f9OpyGesBnPvZzh4mtpUUpN9Iyb7SPIn
+0rqI/7SNma9L5D63k/LmLQQBtJCIo++zKb9c8nbz/+Yh7n+uq+s1Ov0/430
/8oOdUlDDHXYnM05WSR1V9Cy8eRhDPMFcTU9MwyUBPgo2CAMn2QPY1gDxJns
y2prXP3651m6X/JTN1q+SjGs/v//AfEat8c=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtQlGUUB/BdmJaLqQiaUEa4go6AMIbIHU7iyvY+Lyn7vC4jAiM4ILcK
uWksKwK2kpNGwg6EhBUICNtyTySWm7i06jqGqLSALIXSxDJbUMYltP3iPk0f
zoffh/+ZZ55z5myO/VAQZ8pisdiGEhrKxFDWip1XJRwavtHadsTOYags6F9+
spqGkNT3514xZWB6CAfdcqbhavW8hBXIwK7yGruxfGL9rfvRFp8QN8ybtghq
ieX3L45c7qOhbsGimdnNQD0e3n+hkgZ0JH1NoAcDb4ZOedd8TMPJ+PzJO1uI
u6ROvqPr/2N2E3puyYBZ4fhQXDEN7slmP/i/wCB1W0HW7cSJ1frcz+8Rt4j8
A5MXaGBLtTeQIf/SunDpCGsL8dFJTdCGYAakWYdMcuU0FE/oHHoRA7G6u46j
BcQbxfufOfgR20TFrEJraSjyYwUsuDDQzlfFbGXRUMMyq/K2Z2DrOU92gxaB
aG5p/CaPgYH2XEtdBTLm6UhuWuZJYrUlr7PnL8powc7tX3jJKcjgxl+CZWz0
iymflIoZ4nt3W6u4TzAkP+x2utlJ3Mzr2xOpIC4QMS2CQeJLpzvH3rhNQTrH
8+0PnmKY1Hcttqgp4KU0pZroMNhkhzwSLlDgcWwwPNKNgeFY6QlfhIzz5cy+
dfBxJnF/lCy65DxxYt8D9OV1BNn5rdRlb+KZ6VCeZgNxSM62+Fk2AwdyrKJQ
NQLXbTN5TQ+xsX+TnbPV2RwM3QHd6d0xCI7tGQ/7lsFgqymRtHsi+AnHcEt8
MKjrMzadeU4ZXflV3eAfz4iFYRvPrNYQM8cLo3p7KMgJliylvYOhou7K9QeP
KWgQ+9pX7cWQal82yyxRIJvNa1aFEct3TGYKjhKX7ZW1Hc4g+byJTJ3wIwyq
oZ+nX79DrEwq2zdSQzyqD/r1s7MUcB+VfmeXSCxTYaHNQeLdm7TFfG/De7e7
1mIlBXrbhMJhFwz/rF+3VrBCrFiJbvQ8gIy+2NpUGyBGMPB0R0KDEEN9x2tD
nDwEllTWusMRGMzVcpFLEYL31O4limAMp5V+WfEKkre+oui7Zk4b3XvEK8Xv
HLGvLz5/40cakiSLpT5i4ua4YP7fnxJrRSqr48UY/nTevCZBSTzm9P0vlf3E
3hED8VnXiOd+63t3oo2GFPlUxnwRBpmox5XfQkO5f2P/CUP/l/fHK2Hxdgcf
w3RawdcXPGjjfJfDl7V5q4hTDpl3iTVkXxzrazRRSgQWGrdTu0KJx0rFCQ6x
xK9GzHL2pWLAbWnuv6sRJGUHOQpOYQjQJ6saRxEsRLK1BeWG//rfPf0XC6pw
3g==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYCYp2bGwU7Pvo59BRMDgycGOLgVp/xzPMSgv9e
8WH14vN+DusWr+KsaQ9xmPBXZ9qkY34OfPcP7eLNDXG4Wf3R9fYuP4cla72U
pmeEOEi8/ei0b7OfQ0d+4t17qSEOi3SfB+XkIfgyiYGCuxMRfI0fy15q7/GF
81cG3I15IOXncD08nFWsP8Rhme66j6lWfg6uC1Pv1s8OcTjdEv+qucDPQVFj
+9vIDSEOZSuWqQQD7VuVKX654VSIA8w/9yN3v/31FME3X7NSR0ogFM7fvY+f
/axrqMONtq7CpMl+DnMzD32bnBbqcGLWRMdJigj+/bCq3KTNvnD+rjsJKw5n
+DpcfpLEM8kBwZfQ0NyQJoHgsxle2CrKFOpgkWdoz97r6yD+86vzm/8hDvdO
Cc1NnYrgH8/6/H/eSgSfeeeRieyHfB3CDLRWnmUPhfPvcXR3VUgg+K2pOS+u
KYTCw2+phMJFFsNQB/fJ3YYJExD8mmZ9n1urfR1+fXXOWecb6jBZri1M+oWv
A0fFpUOdYaEO+7JSD60W9IPz/eq/KdtmIfhP/vhquMzwcxD+qbf0kzGCX3Ta
PYhDAMHfEl++K/UlIn7bzjKI3wLGh/7KW3l9rn4O2/cU7X24C+i/ul6V3kJf
h8PZ0818AkPg4XUg/sy0IF8Ef/vXy/VZPgi+x5qjyxkcQhxy1L2cXl31g/PR
0y8AxGJMJQ==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4kXJ7FN3uAU6PAmOdr11NNihaeJ0U8GvCH6z
4fHpV/8i+A8ze+ds4AzC4C+w0bky6xKCH636Nyn6PkI/jA8zH8aH2Y/O36BQ
NN9wQgic35S0v4l/JoK/0WYxB8vSEIfnVWZsPywRfJ1JqeXmuph8mH4YH2Y+
jA+zP3mm8gXXugA4P+nn59zGUgSf5aBu5rJMTD7M/zA+LHxg+mF8mPkwPsx+
dH6FflBziwiCv+wty4Jl3Aj+0kLmmTP+B8H9D+PDwgedD9MP48PMR49/AIFY
46Q=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYq4ZXNbXTgU7SBnrHewrC3OA8d9a3Ex83oLg
7ztnky/ZFubgv/uz/N89CL4sY2Px7mnBDr0ipw5djw9ziHvgKxSWgOC/uMS5
yd8Hk1+yfcKbbT5hDvrXGvcejkDw90UU395Zi+BXZ+q7m8wLdtCvMVY4GIPg
/0laalErHArnz12kvHPNnxCH92l/NvrPAfK/WT5m+BriUPZ0s418CoLPcCP/
jkQAJn/2OT8294chDvFLVp+/kIrgs83xWr1tNoJ/iEHWsXULgl+f+v5a8FkE
Xy22b5Mlcwic36p5aulHCUw+zH5+mTbX1ywI/rRZthd2nUG4Dxb+j01DDH/9
RvDPsRzeOQ3of/T4AwCaftGN
    "]], 
   RasterBox[{{0}}, {{76.2676, 79.0676}, {81.30760000000001, 79.5476}}, {0, 
    255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQffT8rRMXUoIdfgqdr/vpE+QA40eop2vIxSD4fmo7
Fs37HeQQPu2FTvCmYIfbLjILQ4WCHf7WCgj7XULwd/jl7rJ/iODv0vvzoOd3
sAPXcZ3qT3zBDksyv1b5cIY4TFmrt5zlT5CDxO4b/Hv+B8P5Ys+ZY8OeYPKT
2w1fzr+P4LMsbuSTPBPkcHF7AovH52AHz2lNKosOBTns/hQ5j50xBM7v1XjL
+48LwU/4t/7+DlkgP+rBQ5kTCP4KvhVvWR8g+Gnvq7sesQQ76J/5sTaHKcTh
aPrCYDelYIeoOOaci+eC4fysz0s+BtQj+NU79NzytIMdZOboHv11IQjOt3sX
vXazK4Lv4X/7Qt7cQAdrXvYfJSXBDs/rHkVvLgh0CN8l1sG5HsHfVRYx/ecX
BL8y+uXWmwZA92/O+LB2NYKfHlHdF/cPwf/JJsot5BfkULL/5+GvP4IddC/+
W2PXFeTQ9kLAImgzgt+0J+PmlA4E/25JQWhcYbDD2QLf0yuzEPEPSx8AdbEF
7A==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQnfc+pbFgXbADwx1poyvNgQ4nooOPnmxD8FWeFBV9
LQ52WNa+8KrnykAHnvs8HjoFwQ79n5rslm8KdDh6/taJCynBDu+zVrBzX0Dw
1+4+bM7HFATnK2neMA3gRfDtnIqus9sFOfDW26z6UBHs4DyNVbi+Jshhrqbk
0gUbEXxHxlNTN+xG8DsDom9OuYHgvzDh3iL9Jtjh16Z/D/aGBjnou9gal38P
dlDnVbm3wA7BDzouWblfDsFX3DlhkSYDgn+zdOclnUeBcP67XwklTw4FOixa
eMv6HND8KwdDf1auCXTQ6biT/uBmsENsyaYrr9oCHYSm6y5+tAcRXujhCQAQ
m58I
     "]}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxd030s1GEcAPCLTAl1Ihu6EL0gGmkV43tbU2zOuef3+52y624VJi+9YFQj
k5dVWji7JXNlMVaTnV68XNSdDd3aLrO8lnYkmyzW6qw4+v3z/J7mj+8fnz17
nn3fHq+zFyVJ1jwebwMbQjas2PCU6K1EgzQID4nUMj2CX9bSq5JZGjKjXGeG
NAj6X35fYCw0PL8b6Kt5hKCtwnl+fDsDjqtjcw4VCCKkjRHH3BlIM4O/4jaC
yC+KzqA9DBTdaBS5FyHIdEhMzfMjnlbX6S8FE8NypbdVGGv/ez79t4iXGmSq
RSVxm+l4nE0NgjqjwVZ9hIFtTIsq6SF7njXcZH+Qgan+qZOmxwgK+vxino3Q
sOKx64DAiKDESacUBjLgeiWRn/gXQemwIP51CAMykyzw5wp5P+dbb4KWR3Ge
k1cZvtoRy8cU4Y4uFJe/oiTGqcuD4urDNpiUIud9xBnRlqcWHwZyu+5v8WJd
uxBmEgsY6M7XSOxdKcD977BZ1E5OkPx3JgtaVUIKUio/iU+M0mD7ufPORDTF
nYsGulsLEyhIOrq5cWGA+EmAnTbvzX8u9Jx5307D+XjvoTAx8fXxUrP5BHFo
bXqzBSgYS+6ZbNaTfIb6+Gm6LBqs+FOGUzsoKFdqKlrTaK4ebFxveW+NPDaF
OPuH+0ZvOXGWaL5extBcP7Fxv7HxPAZfPcgZltFQHgkto+y8sntCQovP0dw8
dSWlW1VaGmZmP4S0G8m5oao67loD4u4X764Knq5H3PsZgoBNbmpivG/YeB9x
/nhfcX3YvMqCZUMq8Zn9LmpTOg0XYqT0iyLSP9+yCMd3ZYjrr9/aWoOZ/W+4
/wVBxuqm08Ti326Xc6XEvVGrNrOxCJRLWh3/LQ3V4cEaKgpBfqZUzQwQ431Z
74m9hz/+och+taTe7BiRIVj///8BmETKeQ==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtM01cUB/BWNhlIGGTiQB52ZQxSBMZ4M9Aj5aUVDdxfextwAnU8dC3g
gNrJw4C8sqFjAwYDEhSYE+xYCYywRDZlczxEZMsCipC2hkeytpPHJghR1n/g
mP1x/vjk3u/94957zluSzLgUExaLxTaWyFg7jMX54ps7T0YotGhs+yTLBFL/
MWQ0j1GIypItv2rCgHlTb5X1DIX2tpUy1gEGVJvqgr1m4m1b1ss53hZoqdJy
RGiPljmIPsh3E8P1NbMuxt+4Pv20fmWPGARJ2ZYHfBhweVh46YK5GBSpxdpR
Z/TNWpfgR7tfMlsleGHOQIM8Lz7RWgxeH5kOhWwS0B7eVefHRd8tecX7Xy90
1iLP6jFfDOxazS8CY37Lelr7gOWMPqWdOmjDZ0ArC1rWOYmhWq3n3BIwMOSW
Y9Jghuae9dWHzNFtc5L7n8bep1D1Pit0zZ2BJdHS1Z8HKVxjmbYGOjHQce7b
JXYfhbzl9Zk7EQwoLh2Vc7/CfL/GkbdwEf08wOtYZRgaBFdDh5wo5HBTG2GD
bHtzNkjapEOPj3W3cucIjDrqTV53QWcKZV/Gv4MWL/qPCN3Rs8unE4M9KGTv
9HsvY55AOU9nKPWkECFVZe3QE7iSqZqe5FPwSRukJzwZYH04qTwsw/+wt72p
sbEYrdBKrsgvowXVq3vy2iicL+4+0hyI1i3EREzZoKPyXVMNbAZ+WqzZ98fX
FPa76opUE2T7fJUdz6o8n4D8d13HZwoKaWEzsd8xBFr2Ud9yCYWHJJlbE0Tg
uWnUhb8j0fM7tIwLHx2WYOvT7YsG3XhzpSuFfH7Z+seHCMyVqWPeDKBwoyDY
qTWcwP3bDxYmwikoDUVdw7HoTg9tbtwpdH24sichB/NF6ly96BMCG/YvZn/0
QK8viGts7dElHftTcnZR4E7W9dqdRiuHiegNIdrfQVMdHUjg0GBL+ASPwhPb
9Io/3QnsDq1VCCPRud43owcz0UkWc+GCMgq/znuk3xAR0FnaTnlVUDA/IrdO
iCdgbzfrOfA5hWP3vGr6+QQma3nKxGuY55TqYl8bRa9K3FxHjP2+5Z7jvQGX
3xXDmbJndUEF6K4UfvRqJVqTN2x1tpqAVbSjQsNDl0b89XjDDd2tzmhLc35p
/3WDjYOxv6WdszkrVQRkWdLycY4YGkK+HzhnPH9r/gSkP7vbF03AXDp2O1uL
71tz8tNk2T30UbXVcV0Put006eSjDgpmU56FvjHo6bqCdI4EbRFv2BmZReCW
xW8VbZ0Uzpw/+HZcIQG/jgFhyQ8U1k6wNRcbjPf1v3n6H3afXSI=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxd1Hss1WEYB3CXQiRnKZe5Uy5xcmtDF56KqM2lc95f3l+2aqVjkRK5lK6o
RjlaStrZySUSCichUlptOR2kKaMjqVyWkdrczlLp/HM8W398//j88T7b8zx7
Xpv9R3kHNdXU1NSV8VdGQ5nTPYWukh4KlV1GPb/fEVghyomp/YVeIvG88MaQ
BdnVA2OSZvRQ3Eh4ohA9ZuXvMUIJlFTVzbZNUjA3qO/9HkTgqaTQjSNH97Xb
lAdK0anmWpM+RRSOPr2rbRFMIKdDSDKFFPK9LsXUHSCg6ep5eKQYnTHocaSk
jIL+xlnLq/HoZaUztktPob9Emj1OzSJwgrOBD2IK9uESRcd1AomiuGpZDjp8
6pIgLx09z1VXJCRT8H5RbGubjRav3GlYdhJd0HnuZOlOAlGl253GSygc396d
ZOhFoGytaav0A3r1D3PZRSN2wdyC4RNxwELIpJB/ZB/a1s+sUX4F3X/bWpJe
TUBRtXnvzCoW8v+uLnfpIrDVP1reMk3BhLPbIPYjgWF5mLu9HQu0JjtF9l3Z
j9ua8kxPFuLbAnk6HGbB6VbdNX3O6HK+ZX9KMAO1M8n1pXosiA+9mMkVMNBq
ditQodyXynJo6t1RgZamc5PmMiik6Rwb3h2KvrOUcdfjos9W6OoLLJmFfTr9
DPHdZMSAs8X9+fMitOu1pDuz99DjxwaixRIKg9Y2shhr9JXMjtaXLmixscOz
fB98H/xJzXNgC9ZXmR2dWG9QSeHmN5faVQwDPRaXY9++ptD6S8v+AcvAMvKq
JUCOjvEYjI2YQHc45kVE6rJgvI4rEYShVfNU2cTRqUZgwkCYHfeGxSIWOCJp
+x8NBvam8a1SFBQ0mxcvL5wiULMnYFv1qPK+8nf4zX0lUM9PaLTpp1C8ludo
qLSpaJfug1cU3Avum1R9JiDzlT6Mf4J+/r5TlNWE1mvODQ19jNbgibyjGtBF
WWYNvbUU9hOew6MBtF+EtvZlOVp174eSg9yHGtDXnKddzrSg//8v/gGRMeop

    "]], FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
    1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYksxEbZUvmiHJ8HRrreOBjtIuixZtncPgi/1
5DJH01EEv0JmFm/sRUz+AhudK7MuIfjRqn+Tou8j9MP4MPNhfJj96PwNCkXz
DSeEwPlNSfub+Gci+BttFnOwLA1xqNN1Ll/CiOAfdil68fhLFAYfph/Gh5kP
48Ps/+Vt4PjJFcH/uZrhvq4tgj+72OpWkCEmH+Z/GB8WPjD9MD7MfBgfZj86
v0I/qLlFBMFf9pZlwTJuBH9pIfPMGf+D4P6H8WHhg86H6YfxYeajxz8Agobh
lA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYqsnG1xldOIcpIz1DvaVhTnA+G8tbiY+b0Hw
952zyZdsC3OoZ5+l5SyH4Pv6qtcx/oh16BU5deh6fJhDn84XmTkHEXwJ+Q17
pq7F5Jdsn/Bmm0+YQ7ySxgnOXQj+uyWSz/7fQ/BXb70aWPU/1kG/xljhYAyC
/ydpqUWtcCicP3eR8s41f0Ic5Dcv2jP1L5D/zfIxw9cQh2WGUe6pRxF8AxWx
53EbMfmzz/mxuT8Mcej/EHhL7DiCb/biw9Y/fxD8Tz6HvU+LxsH56zdOfThT
D8EPW2mytz4Fwd9aWrDBvAqTD7PfPkMnwDANwT/27PEtBj0EHxb+j01DDH/9
RvDPsRzeOQ3of/T4AwCASNbH
    "]], 
   RasterBox[{{0}}, {{115.38799999999999`, 79.0676}, {125.46799999999999`, 
    79.5476}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4k0ze++rfop1+Gh02K3zTaBD1i5n/YxHCD6v
0tqewPuxDuwmOe/9bgY6WG8ov3X1VqyD1+fjW8z2Bjo01ntNXXEl1uHNot4T
PZsDHRrWG6W4XYh1MEpbxl+xLtBBYTf3lCvLEHyzBqFfIjMRfJ2Qt50mGgj+
mw+Kn5ZnxTrUatpktL0PdMhcdcay9kysw5x5aeYz3YIcYO4tOPNny+oMBF+/
N77i6nIE/8Pbj3MPvw9y4NqV9JpvV6zD0fSFwW5KwQ778gQluPMQfOdO6+bZ
6gh+3v3F/6p+xjhMquwMS34ZBOdLvmnL9d6E4Md8tns5vz/I4c/Kj5fuisfC
+du52J+vkETwzx8XiGZVQfDFsnecsLWMdRCX2LTr6TQEf4ncootn1yP4e+dz
Mi/dH+Qg+viPr4derANLffDmpPNBDufsQx/wSyL429xWauqJIPhPN7jK/BFC
8LUCDDgMBWMdpLcsXHPyXJDD39DbKzrlgeEz83Zx/vcgh11RdxfIOMY6HLHf
VtbDF+yw99zDrW6pCL5v5b4N3+Yi+OlND2MO74h1MIk0twy/HQTn93iqlC1a
juA/1Q23ZysNcpDzPsKwDhjfP+oiJ8g4BzlUVgswNZXHOmSK3In8Kh3k8Lhm
wekohliHV5+eFdydEggP38Wbzyg96UXwGWq8p8zoQfAXpW9+VVwb6HB/u8Cs
5gexcD56egYAS4ZbWw==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQrRHx+m6TdpxDzVqrxIrHgQ4fNvxV2nARk//mnj63
0DoE3727VvjL9EAH38qaKSkX4hyW9M87rjsx0GGZ7vE+rUUIfnn83BrZqZj8
RembXxXXBjrsvxQjvWMdgs/+iXXCv/MI/qc5bnufvELw77q3vzrFGg/n8xs9
Sl2ljuCHL13I4uqIyYfZr369/JO5CYLf0H3ozV9WBP9usGPcJpZ4uP9gfJj/
YXxY+DxafmWmpjMmfypXifnMbwj16PyM20dUxOWC4fwZK9+ZqWgj+I0BRY/Y
9IMdMm4Vven4FQfnH710U+f2FwTf8sKy6d8+Ifh1k/ffe/g2zmEdU3a3o3qw
Ayx+YfajxzcAr4fvOA==
     "], {{123.37600193, 71.85310160000002}, {
     120.9522784175, 71.85310160000002}, {123.37600193, 75.63890480000002}, {
     123.37600193, 71.85310160000002}}}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYvtSdp63mQkOjiZ+82IPBTtongt0f1+S4JDn
Jv708sZgByH1OU0f6xMcNvfqqW5cEOzQMWVDg3F3ggPfv5uveCcEO5z7/kPz
cV+CQ/Y3B+2ELiB/d9jz2CkJDk31S/2km4Idnl0Ktm+ahuAvkP6aXTcLwT/v
+V76+DwgX7tf5Xgngv99Sey0D5MR/E0PXfxZZwY7/NvczTd1boKDQNjaaanz
gfKtE+N8ZiY4PDr+yOPh4mCHvPW79WVzExz+yMjryp0Pdii62nYlbUaCg3hR
tGD0LyB/u6mxyuwEh9iHsXqf/iDML312OGI3Qwic/yp+0qknXAh+/M0EGz7R
ELj7E1q9hHbJhMD9B+OL2H4wDJiKJP9hyYMjkxMcynfN4FYE8v86u1TnTUhw
2Fu7MYhHPMQBFv47WD/svncb4X7ZNLn10xxDHB5NEdmcCeSz393ZfdszBC7v
d2Lv+oYIoPwLrbt7UxH8liTtDKZEJH6PWa1ObIJDSqDSZesABL/6Vtu3b+4I
vunsnBV/HUIc5tSzVs1KQrhnhr7+ATXrBAcmwUenIsVCHL6K/r8ka47wD4wP
8+9X3eJdb0wQ/EznLTzXDZD4xXNul+ggwhPGh4U3jA+Lj+nLi10Ngfp77B3W
3gDGV6a2gyqHMSI+BfozhQTjExyePr9gvP08Qv7UpCn+VUuC4fpblCcZPV4Y
DDc/V06HQ2oegg9LbzA+LD3C3A9LrzD/wfjrp6R2aJsh+PcebLi5DRgeWV7h
oVuaEOGn2m7Hd7I9GB6+Wv//L/kGzG+w8K/TPz9leRSCH/BVqrA8HME/7PaP
9blvsMNP95bXfsD4nWJjtDHELdghl/lSZGEqgg9LL+j82+pmV3+GINLX2szm
Hddjgx3Q8z8AbbHDrQ==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtQ1FUUAPBd11hwGEJ5tCopLhAZr5H3EuhJWJ5Kwf23OLvocNEFCtJV
wOI58RBiAiJgAZFChOkhzxU1bAFB6MEkJGhACOPuRJQ8hodTgBH0/6KH6cP5
8Ju558y958w9+yLPhMp5HA6Hy4aEjS1sdBonzXVEUbiiEbRFLhGgvi/fUcZQ
8FO8t/QCjwGnSu79gTMUvq57ksM5yAD/SFnA/Qtolwpt5YlctPxK4/xC4SZL
Q0TZSgpfreipGFcGTn27b+R2PoWgiHiDg04MdLfJBy/kUPggKlN71wLdrrTy
eGi8ydyWoPVtDKTwJ7/5K4+CQyz/R88NAnsXbYYjitGlha/WwkV0VK96h1st
Ba5S0xPE5j/zbJhylGOBPqkdO2TizcBeXg+vvYhCyaNZ864gBoojIvSNctC3
s7s+nIxHd65t1Zln+1X0OsdrxYaBL5c/f2glp/AFh1/rvocBnm4yz+84hZSl
pxPfiRmYKb4rDjuC+QWeN6pF3mi7PzsO5AvRA4vn9181pJAgjLoE/5Dn3pgU
xVXNoO8NtNYKfydgLKvK7zdCT/09TuKN0bLe7vkFU/Rlsczjt5coxOu4OJ6e
InBOe4mbJ6AgjmtRbJklsJ61vnLAgoJT9A9h4fYMOKxv10674XzVlxNGSw6j
p9tHpBn+6AcmwrIsQiE5szWw2h0988dR8ZgJ2i/VOmqOy0Bhr2KXQzAFW+uZ
jJZh8rx+y87XDHNTCTx2NtN87EUh+vBESCNDgDM+WJfnSOFXQoWlIgJ29wIC
OyzRNf2mN0aF6J+THOuqd29yd6FU34RCqnfO03NvsOdfLFMNmlGoT/PYU+tD
wLSxOF3Fvr9hLkPVF4JustMmhp5EV/g0XJclYH7Go8RZSRIBW6nVv0IB2qZr
iBkyQCtqPL04fArCkfKbO99BN/QRidHbaFczTYm/O3vf5mVbFTu/eUHMRw9s
CNyaXvheYYl+fGpr834R+sSQoDHWh0LvlF1MvYRAHbm2fFxMYVvg+e0yKYH2
YwKhdQCF4H6H0g5vArvK1ZpEBvM7DaqcAqPRV9m+1OeidRMyXilg/9u7Oavl
ojS0Su7tv5yP1qT0GZ4tIeC2cN33Zhl68fTutR4lWrd9Yny1GO1q/pkJwzqu
aTLhSREBeXZ4cNOnFCo9m++8z9Z/tn/cYlZ/avMn4JxZMLNxFueblBKrXotG
/6K2v6aWoXlvDd9qlVDQG7NPdz6KHi9PizGPROtL53R8FQQ+CdV7s+IY+97k
Q5ah6QQCanJddMMprIRzNVmVbL/+t0//A2+2X64=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
      1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ/bkwd8UG1SSHF4c89LPaQxxg/AkdmhNdZoY4OD2N
P53Ni8mfGaizfUFcKJzP/zOd7Wc6gs8+26qfKzvUYWb8WcbJHAi+E5Pb9Des
CL7lDN8GFiT+83wnxUtMSQ4BZcaLr6aEOux3m6SwZ2ci3H4YH+beeedEl3L8
wuS/vLnm16tkBJ9hOsMf41AE/+7crbe5AkIcGk/9+B74AsF3llyVlPsIk++x
5uhyBocQBwmmhuTwtwj+X/4NYbN+I/gnOFYUzGdOgvMfLz4qeYsbwT+x8SuP
rBSCP3fWaV52VUw+zP74lzUVSvIIPix80fkw/8H4MP/D+OjxC+MDAGKn308=

     "], {{143.86150049999998`, 84.92609961718752}, {143.86150049999998`, 
     82.39481}, {142.0570168125, 82.39481}, {143.86150049999998`, 
     84.92609961718752}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYrX/k/dXcyQ7PAmOdr11NNhBTOwO/4p4JP6z
zw5cKQi+K1P44e+ZmPwFNjpXZl1C8KNV/yZF30foh/Oh5sP4MPvR+RsUiuYb
TgiB85uS9jfxz0TwN9os5mBZGuJwoku7QpoJwc8SO2yw+3cSBh+mH8aHmQ/j
w+xnk1KKdVqC4LN6cek8mI/gX9NdvvLTTEw+zP8wPix8YPphfJj5MD7MfnR+
hX5Qc4sIgr/sLcuCZdwI/tJC5pkz/gfB/Q/jw8IHnQ/TD+PDzEePfwBa+epJ

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4s6n1nMvvE5xkDLWO9hXFuYA47+1uJn4vAXB
33fOJl+yLcxBu3wD/5MnCL6QVLnl4YspDr0ipw5djw9z2Nx5t2PCNgT/R9Pu
iN41mPyS7RPebPMJc5jdUh53fBOC/8i1INfpKILv6Oe3uP5qioN+jbHCwRgE
/0/SUota4VA4f+4i5Z1r/oQ4/D6zJaL3CpD/zfIxw9cQB7seAbnSHQh+c+u7
t4XrMPmzz/mxuT8Mcdic3fPcdyeC3/48+qrDFQT/qaSrwooHCL6zj142/1sE
X/zE3wgmjlQ4323d7KB7Qph8mP3dyyuVbnMg+OfSrj4/9AbhPlj4PzYNMfz1
G8E/x3J45zSg/9HjDwDOruOT
    "]], 
   RasterBox[{{0}}, {{159.428, 79.0676}, {174.428, 79.5476}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4j/3vNs6vFIcFM9MWrpbKNgBxv9y0dZNRBHB
P5q+MNhNKdhhXsGBH7OdEfxW4XalaoMUhylr9Zaz/AlyUGt+W+ghiuBn15x2
dOXG5FcHfL3w+EWQA19du3u9IIIfat8Q9ksZwd/iHtdjbpLiYCY6g+XdDwSf
+Q+n7Kr1gXD+EuuOuTdnBDrkHTvi6GoM5PfPO647MdBhY6sCu644gv+t7t81
TV5M/qL0za+KawMd1FLnXGCVQPB/Pcje98MIwY8QDuVMsEfwt7nahRz3RvC7
DvI67UpD8HcuX209rRCTD7P/34JO7snpCL5jwtMLVd4IPiz8X53bIao+A8G/
Old93uH1CD4s/gBgXtdm
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYok9Stc/SqY6fDQ67Nb5JtCh5Mzff0JCCL5b
w6a17QKpDuwmOe/9bgY6xB6ffsWTL9XB6/PxLWZ7Ax3+6zEaGXOnOrxZ1Hui
ZzOQ71YqycSZ6mCUtoy/Yl2gw/kziYaeX1Lg/Cj91JTMtwh+6MwgnZ9bEPyt
z3MeGF1LcajVtMloex/oUOzi1CLLnuowZ16a+Uy3IAeYewvO/NmyOgPB1++N
r7i6HMH/8Pbj3MPvgxxcfHhjn/1NcTiavjDYTSnYYd6ylOIn1xH8h5t/rliz
BcH/dm9t2py5KQ6TKjvDkl8GwfmSb9pyvTch+DGf7V7O7w9ysD1y5cLZNQj+
rJL7UZvXIvhqwU+mPNyE4J9S2XG6dm+Kg7jEpl1PpyH4S+QWXTy7HsHfO5+T
eel+ID8hio95R4oDS33w5qTzQPP6266nrUXwZ00y+PN1FYK/8Xjd1xgkfoh4
SXb5yhQH6S0L15w8B3TvrJO7F29Icfgw83Zx/vcghzlzTpnnHkxxOGK/rayH
Dxg+13ycmi4j+M+0d9vfeo/gF204M9UBGJ4mkeaW4beD4PweT5WyRcsR/Ke6
4fZspUEO50T2Pd8KjO8fdZETZJyDHH7rpLyYfyfFIVPkTuRXaaB7dXV8eRam
OLz69Kzg7pRAePgu3nxG6Ukvgs9Q4z1lRg+Cvyh986vi2kAHPe+ULQqCqXA+
enoGAEViYwE=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKL00S85k555UhzmT1hze6B7kAOM7r6v85VsV5FAm
d/mR7u5UB0kNzQ0X1gQ5uFmYvgzckOpwfU6RddftIIdYZklOtkWpDkoTPiSZ
SQQ7nGdiWzOxI9XhaPrCYDelYIf5JndmtlQj+PMYzD0fZyD4PzclclsGpToc
ke6QviYY7KA2W9621TXV4dqZKC6N60EOIak9Z/usUx3KPixXbF0d5KAq6VjD
bIVwH4wPcz+M/zVoo2G8BIJ/KGWmSc39QIdNi/V77rqlOiTsOCdVvj7QQeBU
XHJsSKrDouLcuOiaQIeI6PzFVtmpDjt0dgVsyQ90iNzs5D+pCsEv0vjA09SN
4DNYz5oeuDjVodtOPvULUP8lN6VPshtTHaSPnmV5tyMQHn41CxveTngSCA/f
9Y/XiZwQRYQ3zP3a/s1iFsDwWpS++VVxbaBDQcLVs8z5CL5gQXb91JhUh90v
pGS8ewMdwiwTG76EpTqYWFUfunsy0GHOq0czW4JTHT7yTX196T2C/22SwLfn
mkFw/s9fUdO1/BF87bmRMXPLEXyG8pvroxcGOQjsOG7KBDT/6pJ83bzDQQ72
V7R2vI9OdZj68PL3pXzBDgUGb/+lFqc6WLzM2R4sEgx3P4wfZf3vZHsrgr9T
+IuB+qxUh083rSx+cAQ7vNAP3yyyABheTzqr008FOejNrBGzAIbnkrqifM7l
CL7zpeWhLOUIPsz9MH7w7njWG/II/hrvmiXPvwQ6lHj90z8xP9WhamXt/ZIz
gQ7/p/RWS85OdZBo3LgvcUKgQ2f+VWOXTkT4ooc/AI0tXnI=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYp6NoXfretIcHE385sUeCnb4xrlAonF6mkOe
m/jTyxuDHe4nvQpuXpTmsLlXT3XjgmCH0Av/Ao+uTXPg+3fzFe+EYIfZxu6/
SzamOWR/c9BO6ALyvy/Z8X5bmkNT/VI/6aZgh818iwREdiL4ueHOtgJ7Efw5
rbZvIw4C+dr9Ksc7EfzvS2KnfZiM4G966OLPOjPY4fT7m/fVDqQ5CIStnZY6
Hyh/8L7+vd1pDo+OP/J4uDjYwfo1J+P6/jSHPzLyunLngx3sBa8u/bErzUG8
KFow+heQ/7mZZRvQ/tiHsXqf/iDML312OGI3Qwic/yp+0qknXAh+/M0EGz7R
ELj7E1q9hHbJhMD9B+M/rLBjfrQdSV7n88YwYHiU75rBrQjkn6qf5MOwOc1h
b+3GIB7xEAdY+O9g/bD73m2E+2XT5NZPcwxxWH8hqeU3kM9+d2f3bc8QuLzf
ib3rGyKA8iqV6/w7EPzAeZWWU5qR+Cda/PbVpzmkBCpdtg5A8KtvtX375o7g
m87OWfHXIcQhc3ewt04rwj2p2bUTd8SmOTAJPjoVKRbicCjQd8n6SIR/YHyY
fw9lHuyuC0fwzeqZ7mUEI/HXv1rD5o8ITxgfFt4wPiw+Uh4fFDsclObQY++w
9gYwvszS+77NDEXE591T2x8vakxzePr8gvH28wj5U5Om+FctCYbrb1GeZPR4
YTDc/Fw5HQ6peQg+LL3B+LD0CHM/LL3C/Afj11zYHLk3AsFfLfN/lUdUmkOW
V3joliZE+Km22/GdbA+Gh6/W//9LvgHzGyz86/TPT1keheAHfJUqLA9H8A+7
/WN97hvscKz50p4HwPidYmO0McQt2MHKXkGbuQPBh6UXdP5tdbOrP0MQ6Wtt
ZvOO67HBDuj5HwBUPNQ4
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H8s3HcYB/DvuZbQRjSdUl3tRtXW8yPY1K/yrNdDmBmfLxIsVXY+iuqZ
Q+vXuCZ+9MS6+hmVtkM29IYr5aSm1k5KjYnQdsp6sqtu7sTCMr/Wdt9/2kf2
x/PHK/m+n3y+z5PP5934s+ESPsMwPK4iuTLgSvHp/YHQMgqNGkt1/AoBJ3lK
pb2CQoD0zMpOPgvMw9DmuMsUWptXixlfFqZKtFaSFrTBlHPqX61o19+2BuWq
ba65ZrJPTaFl3VjFurPg8s/ZlrAOCsFxGaa+bixU/N3VaMHlzyXK53+2RfdX
23k9eWubeZ3BL01YCBS5lpUoKTinGA37vCKgd8j5bqUbfepBlmzyNtqNMdEO
D1HgVWvuBXP519ZHVT9mbNEJ8zN+5iIW9L57pkO6KFQ+1QsGg1k42dA+19yC
Lh80Dc+qQSs8yKNCbl6XvJlj60IWZG5Lyt4SCt8yRk0e1ixMiIanHn9JIXdl
c25IzIJ63MrizzTMR5/jp49K0Ju2u/nWYvQVx6FNbzcKMpvEK7BF3viV1jO1
QYeeGO9qsnlGYL5m8bOT7uguV6HdzqPo9xizH+We6DNFrbsyvShkGH7omrZA
wO/g4qSVNwVxaqfUQE9g9M7HD+5x53Gj96NinVj41zPuZl407rd09m6rnQTd
u27nsDcF/U2YlJpnUciRdwVd80DrnoeIZ8zRAXn2iUs8FmKYO7pBKQUHe11R
50Pypn/n/iNmJXkEeqTJqoNxFOjxubDvWQJjFoKsAxEUfiWnbKo8CWzuqjsQ
GoBOM5YUJ4vRDbcKM118t/nFrPAqN588UfHmFx9x3wdr5Ql+FG7ke1k3nSDw
+x+aUJE/BeVSkWokDN3uOJ8ZnoCuO6HsjpFhvuhppj7yPIGN6ozxbi/0+pbg
8Ocu6GNzF00vv0/B5lFtz/7TaOUIidwbgXZ/W1MZ6MGdVyd+eZzb37JlUumU
kEDxYb86gwB0z/XwwtsxaKEpLXiRSOGnBcekG5EE0r9iRpYpBZOgrD0x0QTK
qhJX1dy+PhlzrvpBROD5pPFNo2zMK4IWd8yWobP7Spd92tDTHb+sWfdTSC7e
qPXMR6skosC1crQmd8QsvZLADge+ZWAfeqDt9FiEGj29JmxX3ELzY3ULz7j7
ndqula1eIuA62PYOcK736bibzfV//f4cTdoYVQcS4A086f+6Cvfr39tXXnER
3biWdyGkAD2hOKQQn6dgPONU8EEIerY2P0kQj94dvWToLyUQWxElOJLL/W+O
36HwAgL75qYN67l+67E8zYV6bl7/e0//A3kyadw=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxl1GlIk3EYAPBNlyhNVzlNwyQ1W8lMLWsLSZ5MzSOi8r+NZZba7H3JaafT
EJOVrUOwy3WsjGYWMztASSublmlWhjRzHqBguk7nJJmkRdn7xR6hD8+H35fn
+B+PX/rerRmOLBaLzUQcEw5MnOBZJ0ImKOBeZS/niCQwW3ptj8WBhltei0yc
MAkMJ672DXdB70h7/lvLRVd2WtWypegFQS8nn4hp8CoTPhyUo5sMFZsepaI/
6kezP2RIwPK4gRctokEapj0SS0nAWmaShqxGJ8g14uZVaAM/YoF8hhXFFf1H
wzFf1Hm5UR5Cg0GlqZxMk8Abhfg6ZzENO83y4FCmn4DAtVwBH72tOqjJ1w09
VORy87UDOu/bOaduOwWeMm3BZ4UETlbXld4bo/7V/5SlVEXNsLYt9jN3hmvu
/mqNGv3fCfWmVkU6+pSwo3lDMtp/oW9TRzf558b49zcS3qE33k//PvyGwHD5
F3XtGFoQp8zV29HT/Uu8kp072whQ/so81g8KSM4ZpdREYKuzZd4qFg3xxSs1
+78ROOzdcmCLKw17V3oMzrUR6LPySnv56M2Zutw6P3RGojRGLaDBeXjKh99L
IIVa/0fLvIcszmDOJTMBUXl+1yEhDbpo44CglUBhaolvYzANPRsbektq0RdK
7aGRZejMY+4mv7PoIs0fl90qAvzK0NpEpl5mWN7lJbsI6F2fOY0w/Yw08dp3
JRFIEs0vfOBFgw+vtmckjoCxPPmBwA09Or8mUMhCF8Y1FrR8p6AnMYnjKSMw
+96m9t1WCrraRsO99xOIYu2zbh9H8/y9D/RNUqBMreLo89GxR37PmdKgdWN+
BqGOQLnFvEbJ5P/5WL+snpmvw/1iXo4Nvcf2pXBiBL3CY/DcrKH/bbbJ2Lrj
6MBrnk+lOwg0yyJOX2bu91C8WeUuIuAWo45MYead9kC0PbN9Gbo/supt5zoa
KqfuThanoRtKxIr3V9DGtc7sLW8JqD8dtNUz/8k+dSfgxU/mPI/nDN32QLs2
Xs1O5aLFXS1ZKjYNKa8CHhnHCUzvF8PXGsciC3p63/wFQx4FGw==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4s9Wjybwamc6PAmOdr11NNjhcaDWQ8smJL6i
k9CcNgRfyG7plM4eTP4CG50rsy4h+NGqf5Oi7yP0w/lQ82F8mP3o/A0KRfMN
J4TA+U1J+5v4ZyL4G20Wc7AsDXGYeqzSc60Kgm8eJMjkK4fJh+mH8WHmw/gw
+y+HFuhdOZYB519qjfhbeAjBX5z5taplDyYf5n8YHxY+MP0wPsx8GB9mPzq/
Qj+ouUUEwV/2lmXBMm4Ef2kh88wZ/4Pg/ofxYeGDzofph/Fh5qPHPwBdzeKQ

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4jDFrrwkvmwHKWO9g31lYQ4w/luLm4nPWxD8
feds8iXbwhx+bPr3oJQdwb8fepQr9EuWQ6/IqUPX48McGo5qRyndRPCP7uPU
kj+PyS/ZPuHNNp8wh4wDR/UjryL46xv32V15juDzdc0pEfyR5aBfY6xwMAbB
/5O01KJWOBTOn7tIeeeaPyEOJziYteS/A/nfLB8zfA1x4D4R957tNoIfcNBm
P/NFTP7sc35s7g9DHBqW39px/zaCH6K8atmlbwj+ptDJHy2Zs+F8gY4am4X8
CP4TZh+tKVoIvvCrl8oFpph8mP0Rj49/ztFG8GcD/RHCj+DDwv+xaYjhr98I
/jmWwzunAf2PHn8AstbRWQ==
    "]], 
   RasterBox[{{0}}, {{208.508, 79.0676}, {223.508, 79.5476}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYCYv/pR49MW5zlYD5xJvcflmAHCy/mJwnLshws
bJsfLudB8G+XsBR85kXwMz5b8DyTDnZgVsq8kxGN4JesNjSKMkXwF/N/zNpi
kuXw5aKtm4hisMOLFf/mlBpnOSjf4Zy9TCPYQbcro3WxNoL/b+7bi8GKWQ67
m2/MvLQqyGHnnuaXqpoI/n9bWRMJrSwHpvlHekS3Bjm8+BAV/Egny2Hi33b/
0LtBDoss/9TfM8hymLSyUJXxKZCv2DGDH2hfdcDXC49fBDkskexepu2N4HsY
755s4o/gpyzReOjcj+BPVrPc/aA7y8HElPPegntBDqxSOa9airMcSvYwXXw8
I8ghUa533r6cLId/uyqeHGkOcmCacmH5/4Ash+wQa7k63SCHXikms2tuWQ4H
79zd2XYlEM6/dJUn3nUygl+auET8aQ+C/2+zQahUQaBDvMLaa3qhCL6RWkR5
ezImH6YfxoeZD+MbabGc/bQZwWf3eXBN9jqCX7fx+6PqX4EOyz/bCLOmZTlY
r7JPV5cF+i9K/6FzepZDiHkizzNtIF/LXWhZdpbDvLTGMvHkIAfvVIc1qZVZ
Ds9tz5l87ApyQE9PACBQB5Y=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4k/h2w0abbIdPhoddut8E+jglzEpYpEJgq8g
484ubpztwG6S897vZqCDebKO3k2DbAevz8e3mO0NdLh5amr3Id1shzeLek/0
bAbyH3EWT9TOdjBKW8ZfsS7QYWXGt64bYgi+yemfe3/wI/j6ps9bO65nwfn9
zYxWh35kOdRq2mS0vQ908H1w7e4azWyHOfPSzGe6BTnA3Ftw5s+W1RkIvn5v
fMXV5Qj+h7cf5x5+H+Qg92LhtlKFbIej6QuD3ZSCHSqcfp4p/pUF5+/272Oy
uY7gX6hyOqB9IMthUmVnWPLLIDhf8k1brvcmBD/ms93L+f1BDuIJmVqx5xH8
EoGSLU4XEHyG9xXvCq4i+EsO+KjyPshyEJfYtOvpNAR/idyii2fXI/h753My
L90P5P95lz7pVpYDS33w5qTzQPO0pQ2/nUfwS/SOhraeRfC7k4X935xB8PU2
cxxlA/Kltyxcc/Ic0L1mcaLGl7McPsy8XZz/PcihzCJ+4p/HWQ5H7LeV9fAB
w6fo4WzBbwj+geP+MzOFsuF8H5/E9+flsx1MIs0tw28Hwfk9nipli5Yj+E91
w+3ZSoMcVmwIcnQVyHb4URc5QcY5yOHqiR+O+v+zHDJF7kR+lQa69+SBZbMP
Zzm8+vSs4O6UQHj4Lt58RulJL4LPUOM9ZUYPgr8offOr4tpAB47nP3g3ANMn
jI+engEhY1Uc
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKM3K5DTB4362w5xJaw5vdA9ygPGd11X+8q0Kcri2
9Zvd3rvZDpIamhsurAlyWHY+wvXhpWyH63OKrLtuBznsnWWTOvVItoPShA9J
ZhLBDvqzNDkUV2c7HE1fGOymFOzw//T/r8LzEPx/06OWFnUj+JFereknSrId
jkh3SF8TDHZoM3KeKZKR7XDtTBSXxvUghy1/1mvKxWU7lH1Yrti6OsihdUPK
jUkxCPfB+DD3w/hfgzYaxksg+IdSZprU3A90ELIOfpGTme2QsOOcVPn6QIeC
xKb9b8qyHRYV58ZF1wQ67Pg06f/J3myHHTq7ArbkBzrs9EpbrTgXwb+0XzhT
cB2Cn3Bp7+cHR7Mduu3kU78A9Rvdc/VbeznbQfroWZZ3OwLh4VezsOHthCeB
8PBd/3idyAlRRHjD3N/9bFnRcaB9i9I3vyquDXS48P2H5uSJCH4he/9tlfps
h90vpGS8ewMdtl1oudNcme1gYlV96O7JQIc/jWzfhIH++cg39fWl9wj+t0kC
355rBsH5P39FTdfyR/C150bGzC1H8BnKb66PXhjkUOD/euLEimyHq0vydfMO
BznMz/YTqa/Ldpj68PL3pXzBDheOC0R/nZrtYPEyZ3uwSDDc/TD+rkuKauIr
EHzJ1eK92/ZkO3y6aWXxgyPYweN4Ff+SQ8DwetJZnX4qyKHPYEHRcWB4Lqkr
yudcjuA7X1oeylKO4MPcD+MH745nvSGP4K/xrlny/Eugw5WHij3hQPOrVtbe
LzkT6BCvs/H6ir3ZDhKNG/clTgh0eMn2s//yakT4ooc/AEfxfYo=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4vPL6iz51uc4OJr4zYs9FOyw8/+JEoFdOQ55
buJPL28MdlgUIbxB6GiOw+ZePdWNC4IdJI6prwu5kOPA9+/mK94JwQ5xmgXh
LFdyHLK/OWgndAH5b8+K1N/McWiqX+on3RTsUMZyOmfxbQTfwDdn5vz7CH58
dZrni8dAvna/yvFOBP/7kthpHyYj+Jseuvizzgx26HvKZLPtUY6DQNjaaanz
gfLbOXpy7+U4PDr+yOPh4mCHfw+MYu025Tj8kZHXlTsf7MDE/o+x426Og3hR
tGD0LyD/5ZoE1wc5DrEPY/U+/UGYX/rscMRuhhA4/1X8pFNPuBD8+JsJNnyi
IXD3J7R6Ce2SCYH7D8ZfkpceX3gLSV5Jhu/ZjRyH8l0zuBWB/N7S3Sv6r+Y4
7K3dGMQjHuIAC/8drB9237uNcL9smtz6aY4hDkXHuh90Afnsd3d23/YMgcv7
ndi7viECKC+1iOv+KgRfZMqiqcrLkPj71q7yXZTjkBKodNk6AMGvvtX27Zs7
gm86O2fFX4cQB52NNct3L0e4RyNx2Vv3hhwHJsFHpyLFQhxa3csY7GsQ/oHx
Yf5tjX/1nLcKwf9Zom31oxSJv0SYc1ohIjxhfFh4w/iw+FC/+aooCKi/x95h
7Q1gfP2M2R6kWYGIzwUHHtgbLclxePr8gvH28wj5U5Om+FctCYbrb1GeZPR4
YTDc/Fw5HQ6peQg+LL3B+LD0CHM/LL3C/Afj2x+7s9WnGsHPE9JgvwEMjyyv
8NAtTYjwU2234zvZHgwPX63//5d8A+Y3WPjX6Z+fsjwKwQ/4KlVYHo7gH3b7
x/rcN9ihs/K3RAEwfqfYGG0McQt2+Gvi2T5pFYIPSy/o/NvqZld/hiDS19rM
5h3XY4Md0PM/ALVh1Ks=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtQ1FUUAPBdHjqQMCTqSAnJghnKQwGFJdNjCy6wsgb3LxJgCga7KJco
wOW12K6FqGjogqyv0XhNAstjENKSiQITWkxdSHTl6Yg4LaC8DGwG+n/Rw/Th
fPjN3HPmnnvmXPvoL0JijDkcDpeNUDaM2BBve/FOXwWFov7l16LHCYzJ8p83
aCgIE+m4qTEDzdpUzourFK6UTGRzNjNQKLeQTf6BvtkW1nqoHT3V4Wi7uHOe
j7fGluop/DBtVstsZGDSoDYZuEdBtDfJcrMHA8F/d8+WaSmkxioH2h3QNwpW
+TxaMs/cGtGsOQNv8SMGl92h4HZgYeumOQLVvGJjZRfasenS3ahe9Mspdwh7
RoFb0N8sYvNfe3hXwQOOA3rfgH7LUgED1Z4+63v+oqDqG17ZJGKAd7qL76lF
72jwqjK9jha7ZnpYVVHI+5Dz0fRaBryclpkJyymUcRYWe9sxoOKPrZMWUcgY
f9Vz04+BjBZBUuopzLdNcL4dnoNutNmwRyNBf+YwGqrdSSGZF3se/iVvPPeE
H3/BgL77Z10xb5BASa71T6Nh6IMfMIr8T9GGKW/bxZHodTKdxGQ3haQFG9wT
nhIwsrZ2K2ftF1+TaDRM4GR9yvtESsFDcmtXpCsDv7gdtVwkx/mKdAbT+iPo
9FFxTtEJ9OfCs80lagrpyrrAS95ow1CQn34pWpi5OnaEy4DdyyHhJyoKzqsN
ipr75E39Gps1VkcyCaTFqiw0SgqSj3uCNQyBPIsAXbmMwkMSxcvnE2jk/irr
jUOvnzvxeEaC3lNx5V7T3nmeMM1xCaeQKch+9dVW9vxWi77xKAoVch+7Yl8C
Zb1mlTq2/8oRRW1bMLrKZSAlZB9a7Vt5NSIZ8xV9KcOhaQRuHL+wxnc3+uex
AOUEQXM66vbbb6fA6ypssIlDV7aRUOud6I0r+lX+3ux9BxLCdREUni+X5nSu
JRCwQjp5Kg6ddiajOzALPWqcp889SqHlqYu0IpSA57dOqw4do2AeePDtiHAC
2499t8P/JAXxbbf8RgGB8lZ3y8KzmC8G66gDlWif6lpReztaXTpNqth92589
U8iXo2tjBP7/5KL7M9qsvlQRuGXvnNz1CK24fNppUI9WjzDm7z5A/x68RJDC
7nd81ZPkiTwCU/UdGXfuUzi3qfo3GVv/9f/jJZ3RXvMn0FJnYmP/I87XTPP4
ma0GHTNS2td9Ga1SBA11nqdgpnfN8gxCdxfKpSuj0YvCRxZsSyTw3jdfZ16/
yPabvsUxJIvAQ91stNP3FKYjuf2Hz7Hv9b//9D/LRHtr
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBWIQPfXNDY4WiTyHqf79uVsvhzjA+PK/3oVFfA9x0PcV
fMAsledwZd6k4gnioQ5eL/Q67ZTyHKxc7swRMAp1iJEMkZ6omeeQo7FVfKJn
qMOGVXF19qZ5Dsd/samtjQx1mNAslMbnjODHaS/c3eWJ4EtzczUbBOU5lPiI
fa8NDXX4VbUvrTksz2E7f+XpUPdQh/UbHtTZByL4K/JnXr7ok+ew9F6wJbMD
gr/6cuOaUmME/99uu+JlGqEOHOaSoQkBeQ5/g+zzteRDHV7obObYEIbgn1Dy
3fM/BsGv7Pl05nBCnsMuoxVmF9QR/PcxEi+9TRD8EKYkoTN+oQ79y6qM+sPz
HOZmHvo2OS3U4VLb4UvPHRH8ays/2SYpIfjNX+v5jJnyHPgezkj9r43gXznQ
nzXjTAicn3WiYsqqyBCHkpjeN9dkgOHjebVM2DzEoTDMxfeuCYL//4yCXYU/
gh/qK1A6Py3PYZuEjc/rBARfidVf8eZsBL9KtvDEtyshDqa2GhrvgeETZ6i8
x/J/iIOjegvfFXMEP1CzzGSNGoK/ecNyWUvZPAcdXy/Hnc8R6QWWfgDKqf2Z

     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQ/f5fxfqFpnkOMvzbbrz1CHHYrlp0cJ0Wgq8kPueg
slKeQ/qetV82hIY46KgklHTK5jnwXP4uJZIZ4vD4fnqMk1Sew76lc/RDykIc
pr65wdEikefwxYLnmXcPgj/l72eTXcsQ/AdmwYpVF0McHsy8oOKumudwM6W3
quNTiEPRHU3ZW2YIfprOrHPfHBD8de4Pqw675zlc8fluNfVViMOaJaL3XX3z
HN7teFgeeivE4Xve52OdQXkOC/7L7ZlxEsF3KMq+xL0dwV8pXjOrdS6Cv5Xx
RkNWC4IfUqIy/W5hiEP42WKXOT55DqllYnu3JoQ4AKU9E4H2H86ebuYTGOJw
zTSKL94BEV7o4QkA4eyo+Q==
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4tsd6rtn+uY7PAmOdr11NNjh9Px87mNLkPj5
7TYaKxH8X92v9omux+QvsNG5MusSgh+t+jcp+j5CP5wPNR/Gh9mPzt+gUDTf
cEIInN+UtL+JfyaCv9FmMQfL0hCHWpH9xZbuCL78gjCdmw6YfJh+GB9mPowP
s3/34q0RCS/z4Pxdl+eq/3uC4Hdvt1oqcB+TD/M/jA8LH5h+GB9mPowPsx+d
X6Ef1NwiguAve8uyYBk3gr+0kHnmjP9BcP/D+LDwQefD9MP4MPPR4x8AUXT0
JA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4tjK+qJTBwocpIz1DvaVhTnA+G8tbiY+b0Hw
952zyZdsC3PQO7RTO2Qvgr9IeO6Bw5sLHHpFTh26Hh/mUOQdkKG1DMEX8bC/
oLEQk1+yfcKbbT5hDs88ZC+7LkHwu1bOjGpei+DvXNvxdeHWAgf9GmOFgzEI
/p+kpRa1wqFw/txFyjvX/AlxEHtrfUEDxP9m+Zjha4jDjjMvN8ksR/CjTt6Q
kl6EyZ99zo/N/WGIQ9Ge5eKdyxH8mKr+PqatCH63MIuJ2W4Ef9eaipuZBxH8
JVkJAY/PIfh7YvV9A69g8mH2x0XJbfU/j+AzWJ2Z7nwQwYeF/2PTEMNfvxH8
cyyHd04D+h89/gDCsd0W
    "]], 
   RasterBox[{{0}}, {{257.588, 79.0676}, {277.62800000000004`, 79.5476}}, {0, 
    255},
    ColorFunction->GrayLevel], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzFDMAOUzoInTgk1Pu6jFBgDBVwJ/
    
    "], CompressedData["
1:eJxl1GdM00EUAPAqCEisoG39gIsCjlpcpZoIGl4LageI//uXUVARXFW0HDEO
KlAR0ICJAetChuAmDBGqpmrUKDhaicYoEqyrosYBiRoHqMT70l4TP7wPv9zd
u5e7dydMz0RrPDgczhASahJDSdSUj6m/morh0MXl3IWDDDht7QpIuadEgBWD
V74jDIN5nbWRxQhEW/TGiXLqxJPb1TXh1KMcmYG9YRhClVESpRGBldeYj2Zg
6MjxjixbTy3tX1sxtgdBJX9vYeZsDH0HJ3zNeIXAZrFUlczFcH1diDzYjsCs
KXhSFEHd82r6p/Il1Pw7tp4tWgy+xodtRQLW5SDNksDz46nDtWaVQchClpfx
+p8kDIe/qHpLQ1h4a9hp+phILfZ5zLS5WX45TJ/lPs7f116fQPLFDnTuD2JB
y2u+uY/FsPTax9HGcSxcrKnk/lBjaPDV5U7yY0G0Qz3PJKMeeN1pSo2g7p/p
7wlSDG0efKk3nwXr8fhH30Ix6Ort8dkkv//8VZ4XxHT/igTffJ2bW302VAnc
XHh1QkyJ6H/bzaukOROp5z1vidoooE4KE1YOS0EuO9pHVN+Ko55aPOltkwq5
6nF5Vl1pRyh1oWAoP2A6hta9SQZTDAKH4rfBQjzQVxMctRRBJA7XZ80k3jVm
dGAyuW9Fep94DgZ+9HPvnTsQvOn9abDIqKcJk+JtSmre3WecplgMovP+N3Ur
EGhv79a/I/3gqH0h57IIOkwZvqsZDBWkjU9EUOd/54l8gqmDDqYv3uxBnStr
jovvZVwuG2k+k32HgT2zgtPMZL8A5f2/LxsYkHV0X/JUYRgydc6G6AMMVLfL
fiVEY+DYx0oeFzAwEMMUqxZQ65ttaoGE+vX2N8pEcp4rQ7ShR08xMKW2/L5l
MoY6XsAjuY0Ba9q7L5IpGG4odLY6K5lfYtjWQuxlPxL18x6ZX6AQbxNR92e0
LGqf4ebYtFO7yHta3bM1W9pN3S08cbbrA3Vc6oOnOf10fdO6Ru7l4ciV32ln
PU77ie1fy4TkvWmSu0OGUa/RXBuR8p5xWZL8uaL0HAObMpdlaEh/vM9zpLRi
Bqq41U23FlAfWxxo6Yqjdv4/pxMtXg2N1M7/6R/g+ALu
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKP3R2StCYWOBw5xJaw5vdA9ygPGd11X+8q0Kcrg1
d8n6qA0FDpIamhsurAlyOLTq6qY3qwocrs8psu66HeTgO+H4oWOLCxyUJnxI
MpMIdmATsJvCM73A4Wj6wmA3pWCH9xqa3G0TEPx3fdeSTNsRfOkXr50fVBc4
HJHukL4mGOxgdOdUTFtpgcO1M1FcGteDHDwdGVW7Cwocyj4sV2xdHeRgNDu6
5mg+wn0wPsz9MP7XoI2G8RII/qGUmSY19wMdKh4EtRiVFTgk7DgnVb4+0GF5
8av8TzUFDouKc+OiawIdvPd84k/sKHDYobMrYEt+oINPxp2nPBMQ/BtKm4+0
zEDw5XU4unKWFDh028mnfgHq5zDy2R60usBB+uhZlnc7AuHhV7Ow4e2EJ4Hw
8F3/eJ3ICVFEeMPcb7Kt5mQ80L5F6ZtfFdcGOlzfp7rUtQvBX37sQy1fY4HD
7hdSMt69gQ5eq7P/2dYVOJhYVR+6ezLQ4W2zDncb0D8f+aa+vvQewf82SeDb
c80gOP/nr6jpWv4IvvbcyJi55Qg+Q/nN9dELgxyWv5K7eaS2wOHqknzdvMNB
DvsrAmbtbihwmPrw8velfMEO15dt3FvWU+Bg8TJne7BIMNz9ML6PjtXi9qkI
frXE1rDr8wscPt20svjBEewwedkz8XOLgOH1pLM6/VSQg1l05cl4YHguqSvK
51yO4DtfWh7KUo7gw9wP4wfvjme9IY/gr/GuWfL8S6DDTWOra8uB5letrL1f
cibQQe4mY03AggIHicaN+xInBDqkHFO9kTodEb7o4Q8A1NlzLw==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQbS3i335/b4FDzVqrxIrHgQ65qybfyHqOyX9zT59b
aB2C795dK/xleqBDS8znL+JA/pL+ecd1JwY6zOJsK+68jeDzTfut53YDk78o
ffOr4tpAhwdFq6+tuYfgb951tfjfMwQ/96nq/+1vEXwNgbKuwi8I/pZTPpkv
/yD4bcv/CAQwF2LwYfb/Mi46w8OA4As+ZPGu+4Jwn8bklHTtLwj/wfgw/8P4
sPDRzPA0Owk0H50/lavEfOY3hHp0fsbtIyricsFw/oyV78xUtBH8xoCiR2z6
wQ6nv3zgWvgRwX+0iWu26QcE3/7T3tI97xF8AeUW9/J3BQ7rmLK7HdWDHWDx
C7MfPb4Bbdbt5A==
     "], {{270.56321185, 71.85310160000002}, {
     268.13948833750004`, 71.85310160000002}, {270.56321185, 
     75.63890480000002}, {270.56321185, 71.85310160000002}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKC3L2T9xe0Chw5xJaw5vdA9ygPGd11X+8q0KcmBL
fvnio3+hg6SG5oYLa4Ic3uVLvWn2KnS4PqfIuut2kENlKM+fWOdCB6UJH5LM
JIIdjK42nV1sVuhwNH1hsJtSsIP0u1wXWQMEXypEes4ZNQTffa1Bbbl0ocMR
6Q7pa4LBDnEL+afJihY6XDsTxaVxPcihlM0tTkmg0KHsw3LF1tVBDnEJC7bG
8CPcB+PD3A/jfw3aaBgvgeAfSplpUnM/0GHJ0ul7TwLNT9hxTqp8faDDZQv9
lZ0yhQ6LinPjomsCHcobzT1/qBc67NDZFbAlP9ChQldRfok+gs/y4vtfaQsE
3/ujz2Fml0KHbjv51C9A/SbfJ3x4CQwf6aNnWd7tCISHX83ChrcTngTCw3f9
43UiJ0QR4Q1zf0L1QabvQPsWpW9+VVwb6MDcknXvjiaCf7nbdPtShUKH3S+k
ZLx7Ax3KCjaYX5UtdDCxqj5092Sgg6RnoYss0D8f+aa+vvQewf82SeDbc80g
OP/nr6jpWv4IvvbcyJi55Qg+Q/nN9dELgxwur08WigGaf3VJvm7e4SCH17ZT
LwcB7Z/68PL3pXzBDsw5377x6hQ6WLzM2R4sEgx3P4xf8bHujpwpgr/87s/+
PPtCh083rSx+cAQ77M/WDkx1AobXk87q9FNBDkkK+5i+A9PTkrqifM7lCL7z
peWhLOUIPsz9MH7w7njWG/II/hrvmiXPvwQ6sP6s47cHml+1svZ+yZlAB695
blufA+2XaNy4L3FCoMOE7izBv2aI8EUPfwDm4lrU
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4sQvahcKdxY6OJr4zYs9FOxwVeHM20/7Ch3y
3MSfXt4Y7ODlW8hdcqTQYXOvnurGBcEOrC3VXKKnCh34/t18xTsh2GHFVvn7
b04XOmR/c9BO6ALyp5+zXXWu0KGpfqmfdFOwg4ny2cw95xH8icdlG3ZdRPBX
3pO6ce8ykK/dr3K8E8H/viR22ofJCP6mhy7+rDODHQ4IZ150BfIFwtZOS50P
tO9PdqUi0LxHxx95PFwc7FAhyPiIc3ehwx8ZeV2588EOVUvStqy7UOggXhQt
GP0LyBfdl8x7qdAh9mGs3qc/CPNLnx2O2M0QAue/ip906gkXgh9/M8GGTzQE
7v6EVi+hXTIhcP/B+N4R0snKSHyTTaW7YoHhUb5rBrcikL8/+mj7pjOFDntr
NwbxiIc4wMJ/B+uH3fduI9wvmya3fppjiINRy1plAyCf/e7O7tueIXB5vxN7
1zdEAOXX7bCI2o7gM7+2qPuzBYnfsK9DcHOhQ0qg0mXrAAS/+lbbt2/uCL7p
7JwVfx1CHPp/qraf2IpwT+9Fq1V8iwodmAQfnYoUC3HYc2SRMdcChH9gfJh/
d1+IWf5xHoJfGl174dkcJH7xx+1bZyHCE8aHhTeMD4uPXt67byYD9ffYO6y9
AYyvMv/DMf/nIuLTkzHiMjPQv0+fXzDefh4hf2rSFP+qJcFw/S3Kk4weLwyG
m58rp8MhNQ/Bh6U3GB+WHmHuh6VXmP9gfEmWML6J8xF8g1W/t4UBwyPLKzx0
SxMi/FTb7fhOtgfDw1fr//8l34D5DRb+dfrnpyyPQvADvkoVlocj+Ifd/rE+
9w122Bv7dL8SUP8UG6ONIW7A9GLN8914O4IPSy/o/NvqZld/hiDS19rM5h3X
Y4Md0PM/APDR4Mc=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtMk1cYB/AWBQQNK5vtICBrQWQrAxSwFEbh6QDpKChw3tVMdJtUS8fK
BkdEuWkqhi2EZIzLcGDiAqgYkMsAR+YugDBlzIXEDcptlIxBFi6OlgTEbe58
0Yfsw/Phl/M+T877P+97JKkfJp/cwuPx+Kw0rGxYifunYTyEQp3ZpTvVQsAy
uc/3BzmF2MwMi+0WDibsGjpSwyncaLAW8yI46H9neflELHrStrJaqkJbHTd6
rWr06tyQTnGIQuO6QzsnY+uizv0TcRTU755yigjiQCIaCfyOzTuruzDzkxf6
myrvsImdm8xvU//ryMF5hXBPzhsUAt63vxf+hEBSYGhXUwJ6u/GrWrck9Kqb
8YFIQ4FfZb6jZv1PvXi4ysTzQmtnxiOFURwk3t4aPxZPoWJ6Udyj5sAxnQxf
jEVLCopKMiLQ4m7v+xaWV9lrPMW6LweVXZYQJ5bnNZ59vdyDgzsK85BHEIV8
y8bUQAwHsiKHpWtS7Lc3/ePqsgc96mej7RWiG7/87e3hHRSyPXW18Jg885PZ
UMPlBfTwzx31nn8QUKdlCVKd0MFdzqudm7zstrXP+hz608nEeYOAwim7/YEf
zBHIk678+D1zjKEt02aRQE9+3YGdIgpBaXcPH/XnwCRv/jpTjOf7Uskx2YA3
Wubyydrtl9FN0cFChT+FvAsdcVfk6IX5hJhxITq2wEe3xOdg2+WU0XJfCq/6
LBjbRsiz+W2uUsFHBQRk3L4wpReFtNenkm5yBHp9St17dlEYI8c9K0MJmCSq
h2MidPkXLQ3zQvSNnHB39fPoxpr0M3yWR0FU8QZVsjyUy56zbL2pMMyjPppA
fJnBgWPzmpeM7YNJ6Ba/mdPJWvSl6ObOlGzsN06fXtTkEhid67pXKtjkz0uz
Z7ejc0t69Y/tKXiOVt9yfQ/dPEg0L7yJlrmbK1Rytl/nK+YHbL8PXfQf/+JL
YFdr7c0OEVpmuCoRSNB/1bWK29n31T/np2/SEKjQ/h0j9aHgGJfjnHKE5asL
mHB6hcLB+wGV30YROGhrDLvlj/1i5YpWLEd/dhbGElXoAat2Ssn+t/TiR9Wh
hej2k1GqtVK0OX9QkFVBYLK9MGPkEDp0Za/q2CYPvFguX0/Y9PzgCneV2dAy
m20tI2DNT8pKZq4Jb+07w+Y/vX9C9I+GulUEJjb+jMxX4PkWrpmu58rRTdVh
Xm8FovuOO/n8GkDBYdz/XHACerK6UC9ORe84smR3IJPAtt+vZ93dy943L3J3
8jkCOsf5E+fZvPWjfHNRDcvrf/fpf8AQVN4=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYCYstt8xa6TC9yuMVx5HWdT6hDkpfKxdgZRQ4d
hy8dOB2I4E/UPX19cxCCf5Lt0tFlsaEOLMd+tZ2qRvBfm62o7SxH8P8cPFAc
V4bgb38f+L+nCME/9UDj592cIodFu1XOdcSHOlTaMWetAPI3Pag78DAp1OFc
0KY5wUA++2yrfq7sUIf6m7aVMzIQfEv28yzHU4ocrKMdMibyhTqEc6zeWJuB
4K9YdcFhM5AftfSLj7NoqMNFu7CCM5lFDp+516scNgp1eLvTx7ctu8hBSa5z
urd5qMNkY5HyVKB9ldUCTJ8sQx1Wx6yo0SpF8Oex8Uw6WYbga5kIeGf2Ifif
bJUnfu0qcjjhbd6prx7q8PnBO53i1iKHmhvcrHncoQ53rjd+1msucvBYNzvo
078Qh0DhWjtuoPkrrZ6ksW0KceAIzfp2oLjI4Um7l/K3LATf9XDSlfYABN/S
d77sMm8Ev8TzapmweYgDt4rGvx0VCL75kYqzp2sx+RfVP6loeiP4a17wn2UJ
RPBD1n3Qu5+E4N9jV9j6f0eIw6o530R0mooclt59kdz1IMTheMJRzYdtRQ72
z/Out/8IcUBPTwDm4hJ1
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4mDLt5o7OYodngRHu946Guxw2kUwyN8Eia8z
N6vBDMF/vOucdrklJn+Bjc6VWZcQ/GjVv0nR9xH64Xyo+TA+zH50/gaFovmG
E0Lg/Kak/U38MxH8jTaLOViWhjio/Ldg62RF8L8daXkUwYTJh+mH8WHmw/gw
+w+7bamYc60IwY/TSMi+guCvufBtXslFTD7M/zA+LHxg+uF8qPkwPsx+dH6F
flBziwiCv+wty4Jl3Aj+0kLmmTP+B8H9D+PDwgedD9MP48PMR49/ABlz8jA=

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4h+qFxulPUscpIz1DvaVhTnA+G8tbiY+b0Hw
952zyZdsC3M4mcdtvdQVwbc98O68iE2JQ6/IqUPX48MceH8sLK/WQ/DXf5lw
v1ITk1+yfcKbbT5hDo1f8x5N00HwVcNeZ14xRfBDom6xfLYtcdCvMVY4GIPg
/0laalErHArnz12kvHPNnxCHjTN771eC+N8sHzN8DXEIrrQ+lKuP4H8t1dLK
0cLkzz7nx+b+MMSBN/On2i19BP+72sO5wbYIvtqBUOd2ZwQ/NPLUi12eCL69
+KZ4k3AEP5yrMWZRDCYfZv9PtoIjC8IR/NnPZJdP8UTwYeH/2DTE8NdvBP8c
y+Gd04D+R48/AIEX1T4=
    "]], 
   RasterBox[{{0}}, {{311.708, 79.0676}, {336.668, 79.5476}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQncCuedm4odihZq1VYsXjQIdJc3NV9q/E5L+5p88t
tA7Bd++uFf4yPdBhpf9Zhxwgf0n/vOO6EwMd9v+J3393LoJv3Hm1atYsTP6i
9M2vimsDHVjTWpUYFyL4N9au3x+0EsGfdOO/F88GBN+XOeDa0W0I/s29altt
9yP4q2ddi1lyFJMPs19e3Uci8RCCb3bl3rRL2xB83za7zfXbEP6D8WH+h/Fh
4eMXrdwkewyTP5WrxHzmN4R6dH7G7SMq4nLBcP6Mle/MVLQR/MaAokds+sEO
H56fCvu6GcFnX/bkWecmBD/l6fSDAkh8U7G4yaeB4bWOKbvbUT3YARa/MPvR
4xsASRHtzw==
     "], {{314.70879199999996`, 71.85310160000002}, {
     312.2850684875, 71.85310160000002}, {314.70879199999996`, 
     75.63890480000002}, {314.70879199999996`, 71.85310160000002}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKO30J+Mut3CJw5xJaw5vdA9ygPGd11X+8q0KctAO
O2ziJlTiIKmhueHCmiAH4eQv5jd4Shyuzymy7rod5DDP45n7JtYSB6UJH5LM
JIIdwk/ESP74UexwNH1hsJtSsIPDQ/cJhZ8QfHv3r88VXiL4OQu4Tp6+W+xw
RLpD+ppgsEPzlJcPC68XO1w7E8WlcT3IYdZP+VVll4odyj4sV2xdHeTQHFzF
uPFiMdx9MD7M/TD+16CNhvESCP6hlJkmNfcDHU7OKOSUu1HskLDjnFT5+kCH
H9qcX+/eK3ZYVJwbF10T6DCnRHCqz6tihx06uwK25Ac6zFX4nfXjI4Kvefui
Z8EvBL/giRp/BFuJQ7edfOoXoP7IV1k2drwlDtJHz7K82xEID7+ahQ1vJzwJ
hIfv+sfrRE6IIsIb5v7WvNl+3sDwWpS++VVxbaCDRrmLluEbBP9HHT/zr0fF
DrtfSMl49wY6zE7uatZ8UOxgYlV96O7JQAc7G+8JhUD/fOSb+vrSewT/2ySB
b881g+D8n7+ipmv5I/jacyNj5pYj+AzlN9dHLwxy+LHINm7D/WKHq0vydfMO
BzkIGObLLwfaP/Xh5e9L+YIdNOIvOCW9K3aweJmzPVgkGO5+GH/ukwiN4u8I
/pkLl28fYixx+HTTyuIHR7DDkzjWuTtZgOH1pLM6/VSQQ7vwDD9vYHguqSvK
51yO4DtfWh7KUo7gw9wP4wfvjme9IY/gr/GuWfL8S6CD1puI6MlA86tW1t4v
ORPokD9RgdGGqcRBonHjvsQJgQ5b6lxiA38iwhc9/AHaumnT
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1G1Ik1EUB/A5Z4mFVhStx6QMlJo23HQzXdZZ+FKm0+dOyZKm+VLNKCWu
y2Et1CxKcxU1KTWREsIke5XEaoQzl7NWulRIIbQ08i2xEtGw55NH+vD/8OPc
ez+cc7jeadkk05nH4zlxCefC52K8XJFbtZvC+eOfzDINgXtSCd8vkcJ7yJxb
lk1gvK81wkNDgWeWHbbeQgvuFLiv60Bfv8iLUc0TeLVaP5YbT6H1SI06cpMa
HN9C2qqU6Ch9ZdISKbp5YMoR7kvhfrtrU+VfsuDAfpl0jx3NlDbaPZoJ5EpO
Nj/dQiEgZI+qoIFAAJWLw8ToLkHFOWEgutZFf0EmpzCyJlV74CVan1Evb7Cj
ey0HheETBDQdiqkGMborZjq02B99V7FjRZSEQpyhRPXHTQ3Ms+WFOQoKn8PX
1ySuUoNz9Mz8NCxycYlvRBTas4epbYyjoHozLEgXoKPlj88ftpEFM/5DEkcL
mmeMLRdVExjzkQqf7qUwdPWrJqKIwGivq2UZ935Sm+nSQAYB59dbte1cv99Z
0n//TSNQVjjpNR6GdnjOxzVsRzPx2ZEz2xadt+Qww8HokdKJkgquP19nHo1n
cOZbmZ06GYVZMe+77RB6UOle+zF5kS9mJe9IJLD7TWv9Azmaf9tDFBOCZvjy
biGg88S7jiyPRUevtFuHCIVjeVp9kAh9JjarZfsou+DLoqPzm00sCObMxrXc
PvP6PKWOIhaYP/lpEiU6xebXcyoU3RVUpG7k5q3ZWFlnKmOhM8fHpOD2yzhk
bTc/YUETJ/qg5epGt2kf3UMWdDZLugu3Xy4J/VYnMzpj7keqcy960v3GSOcE
CwEn9tO33P0pQ59hZo6FXL8bTkoRurNMF2zwXVQvyaw+7U2hfp9caJ9CL435
0u3Vg065Mhj2soKFFzpti3cAhWHDQPKTHBZGy28ORivR3aafocUJ6KCghPye
NAqnvFwG8+vQqlnl87ARtOKa7WzSBgLm4HL/X0kUBpqIqC+ewP//xT/W5+A0

    "]], FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {
    0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4vAll1m4N5Y4fDQ67Nb5JtChVefgDOm1CH5e
m/SH0DUlDuwmOe/9bgY6/NTsYzZfXeLg9fn4FrO9gQ6n7zptWr2yxOHNot4T
PZuB/Jd/VCevKHEwSlvGX7Eu0GGTzueNZvMQ/B93S04fm4Xgf5uUvb6vDsFX
21XRqd1f4lCraZPR9h7onozk2wuWlzjMmZdmPtMtyAHm3oIzf7aszkDw9Xvj
K64uR/A/vP049/D7IIfcNyfcWReXOBxNXxjsphTsMGvmlyCWCQi+tcL+3Iw6
BP+Y6UyfB0UlDpMqO8OSXwbB+ZJv2nK9NyH4MZ/tXs7vD3LIWrGGsbIKwZ/B
sOnYayT+vfwtj5tqEfwNEXL/LzSVOIhLbNr1dBqCv0Ru0cWz6xH8vfM5mZfu
B/LL8hcIN5Q4sNQHb046DzSvl7X1aBWCP6M/Sry3EsFXWcU4xQGJ/zXwz7mz
FSUO0lsWrjl5DuheYfXvyTXA8Jl5uzj/e5DDzCnqW0+0lDgcsd9W1sMHDJ+N
GVaXexF8uzvylv9nI/gt8zRSNi0qcTCJNLcMvx0E5/d4qpQtWo7gP9UNt2cr
DXLYFKDI+xYY3z/qIifIOAc5nIwp4U2aVOKQKXIn8qt0kINy7A37GSUlDq8+
PSu4OyUQHr6LN59RetKL4DPUeE+Z0YPgL0rf/Kq4NtDhUXZJ8aI1CD56egYA
169bfA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKJ3wc8aWPKZShzmT1hze6B7kAOM7r6v85VsV5OAZ
/Jl7JWOpg6SG5oYLa4IcDBNU+K3/lDhcn1Nk3XU7yGGPq5i86NcSB6UJH5LM
JIIdSo/2fIh6UeJwNH1hsJtSsEPcvfL0Kw8R/FgX1f3NNxD8rrlWC/TOljgc
ke6QviYY7LBwouTOK8dKHK6dieLSuB7ksOObf+PNgyUOZR+WK7auDnJYGLDq
hjCQD3MfjA9zP4z/NWijYbwEgn8oZaZJzf1Ah+dTFz5oOF7ikLDjnFT5+kAH
MU3LMw7nShwWFefGRdcEOuwqdMxZf7PEYYfOroAt+YEOu2W1naIfIvjuNxgV
L79E8Psehj3bBfR/t5186heg/vLns4QXAsNH+uhZlnc7AuHhV7Ow4e2EJ4Hw
8F3/eJ3ICVFEeMPcvzj7tOo6oH2L0je/Kq4NdHArKWGcchvBF6uxvxVzqcRh
9wspGe/eQIedCbuies6XOJhYVR+6ezLQIcayOv0KMDw/8k19fek9gv9tksC3
55pBcP7PX1HTtfwRfO25kTFzyxF8hvKb66MXBjmILcg1FQaaf3VJvm7e4SAH
Pb353ziB9k99ePn7Ur5gB7cYBqmjd0scLF7mbA8WCYa7H8bf/bDj/9VnCP6r
s8ybVT+WOHy6aWXxgyPYgSnGtETmCzC8nnRWp58KclgqcEJ1HTA8l9QV5XMu
R/CdLy0PZSlH8GHuh/GDd8ez3pBH8Nd41yx5/iXQweNlh9G3zyUOVStr75ec
CXTo7Qu4MQ9ov0Tjxn2JEwIdLlWXmGx5gQhf9PAHANttfbA=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYtVloXaiWaUOjiZ+82IPBTvMvPQrelp+qUOe
m/jTyxuDHfj+z68ULy112Nyrp7pxQbDDSdNVFTuqSh34/t18xTsh2CEn3c93
Qk2pQ/Y3B+2ELiDf8+9q3/pSh6b6pX7STcEOP678vh7fgOCHVvq8i21C8HMn
eLo1tQD52v0qxzsR/O9LYqd9mIzgb3ro4s86M9ih5eh0+5fNpQ4CYWunpc4H
2rdu1vMjjaUOj44/8ni4ONjB5rB+wNrsUoc/MvK6cueDHezCpioFAeXFi6IF
o38B+cffXNwAtD/2Yazepz8I80ufHY7YzRAC57+Kn3TqCReCH38zwYZPNATu
/oRWL6FdMiFw/8H4/FxeF4/VI8knL9FgBPLLd83gVgTym3m/fA2tLXXYW7sx
iEc8xAEW/jtYP+y+dxvhftk0ufXTHEMcvpnemXgZyGe/u7P7tmcIXN7vxN71
DRFA+fjny/6mI/jH56S/mZ+KxDd8+21LcqlDSqDSZesABL/6Vtu3b+4Ivuns
nBV/HUIcgleHfM1OQ7gnsDlTYlNQqQOT4KNTkWIhDg1lFxeuDUD4B8aH+be+
qVt0qj+Cb8m7xq7LF4mvqqAW6Y0ITxgfFt4wPiw+AvdzR5sD9ffYO6y9AYwv
K8ZPpxb5IeKTd3Ob4/KUUoenzy8Ybz+PkD81aYp/1ZJguP4W5UlGjxcGw83P
ldPhkJqH4MPSG4wPS48w98PSK8x/MP7drS01JgEI/pdoLdVfQH6WV3joliZE
+Km22/GdbA+Gh6/W//9LvgHzGyz86/TPT1keheAHfJUqLA9H8A+7/WN97hvs
0MgvoncMGL9TbIw2hrgB08tbq9Tr6Qg+LL2g82+rm139GYJIX2szm3dcjw12
QM//APWZx+U=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtMk1cYB/BWBwyzsap0gygIZYsErBJwjLsPVgbS4SLnBRzoRCpQsAw2
OKBy2cCN2wzTASsKGUwYwdhxDzQIEekmdlI2hNRxswVb1AGywDZrvbDzRU6z
D8+HX973f3LyPHmOY1xqePx6FovFJhVJah0pHbZqyX2A4ZLWRh63jKCrLPZC
0kMMwWkpy2brGaiV33Y0X8RwuWGlkBXAQPFGuyOvGqjrugfMhk3c3evsJn1G
La8yjmlXMTQZLNsYT/L95mx93lMMwth0qwAPBvSDr/xwjORPJhTMDDlR91a+
4zNpbWJ2q/DFBgYES4IKWyOGXScsbvqtIuDqEp0+fEH9m/uc5TV25prlqpbA
HvNMYFdqFUKSf+mFqMo/WE7UopmJPVwBA9YpHj05zzGUaxYc+oUMDG8pCHA2
UOv57QbOErUuifH9jvTrnC/L3+DKwKFEx8a2+xgaWRb1XvYMFC1Z+Qzcw5C9
bJz+JYgB426vmNBJmr9VsqP4qpq6WuM2cvwGteT466r0PgwZvIRqeIrWvKrz
ltTMU/8+3FHP0yN4w7Yuz+watSEB4g6ZuF3l7ibtp44o+zyCcx1Duvm77p/M
IQiY2uYtIg6StKatW0DwJX+ks5vcxyNxMOrwTgZq/pxwth6h873ne7ZBrKY2
Kvvij45Tp/4bd0Z7F8Ppgo7QWi/q+fthQRNc6uCc7QmLbAaGwkqDPKcw7Ng+
n9+qRmvnt9q6cIpyEBjNYpt0oxgS904f/IlB8NV4T6loGMM4Osar8EZQM5p5
JHeQOjJ8etPXN6hTnE+UPhqglnxwQd9A+pMjKDR+Fkj6sbL1fJECw5VcH/v6
fQg4e6uzHpO8bDG/TXmQupk/g8NF1FX7ZJ0xGTSfr8ELkacQVFfpPN2um1h4
dbaol9rf7y/193IMvDvSLtskapkSRW6OoPbcqi0P8SL3VagOZJH5LdmIi8dc
EczE/rolapDaaDf2TccIdSdzt4y5g+HnOb74SiSCKK5rp4p4Q2jmxpho0t+3
Pt7fTuZ1QLWrok+AYFN3S9NHGprXLW+7rXhAHe2SGvy3gbrkx2+FerJvyYVP
pN651G3xgpDHZ6m12UrOp+UI6kSyyVMs6ueXjnaxTFyi7G+sJvu89n+2gyKE
WNKsy1g5h6Cb/4XmH7KfF/1aBrLI+S/fn/fET27JQxDUymya7R/R+QZetnjT
7iF16v6k889mqQs3+1ee1GKwnNiZtzuMekqaK3aIo34tetH8/TQEQxVqTfIM
huTTe94Oz0Pg0ssd5ZH9Nhxma89cJP3633v6H4aXjWU=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGCQB2IQPe34LME9JmUOx05lPNn5MMRhgcjaGGXbMge/xSeP
pnwKcXDV2NbU5lTmILR8cs53tlA4X3Nb0zJrVQRfxXcP8zH/UAf3PN9djeZl
DnMzD32bnBbqIFt4ou2NDoIfkMN69q0Cgr9EfOtvGfEyh9ur+9v/uCH4KvPe
pHnIIvgJs5QObOUIdaiIqkvolCxzUN0aYHTyZ4iDR8bpnY3SZQ6LvrROEPwY
4uD5bkNnnWyZw3Y+vm93noc4HJ/29LWTXJlDlnT9IrlnIQ5T7Uoc96uUOfR9
TPx27FqIgyPXPKfJQPlluxqmc54JcchRPOG4UrjM4Ztu8a4jmxH8My3xrza2
IPitc5OuPgsKcUjTmXXODOifEs+rZcLmIQ6Z9wq51ukg+Hfl34d2WSH4220d
k164ljmYpth46cYg+KknNn7d0Ivgc3v8lp+wKsSBcb682wbHModL4RPSZA6H
OGwV9P+Wa13m4B7DIPX9YoiDS9PKZxxA8x85yR0svhrikLggO97BrMxB+4mX
re29EAf0+AUAEcfcoQ==
     "], {{354.1811888906249, 84.17641074218751}, {
     354.00357364843745`, 84.27883916406252}, {353.81179277343745`, 
     84.46408205468751}, {353.81179277343745`, 84.71688411718752}, {
     353.81179277343745`, 85.14839108593752}, {354.31085891406246`, 
     85.40119314843751}, {354.80338707031245`, 85.40119314843751}, {
     355.33732246093746`, 85.40119314843751}, {355.80914699999994`, 
     85.06557661718752}, {355.80914699999994`, 84.57958644531251}, {
     355.80914699999994`, 83.97155389843752}, {355.09759636718746`, 
     83.66317896875002}, {355.08452039843746`, 83.66317896875002}, {
     355.0703547656249, 83.66317896875002}, {355.05618913281245`, 
     83.66971695312502}, {355.00933357812494`, 83.69695855468751}, {
     354.1811888906249, 84.17641074218751}}, {{354.5157157578125, 
     83.22622367968751}, {354.8970981796875, 83.007201203125}, {
     354.91126381249995`, 83.007201203125}, {355.449557859375, 
     82.68575030468752}, {355.6260834375, 82.58332188281251}, {
     355.96714828906244`, 82.37737537500001}, {355.96714828906244`, 
     81.97419967187501}, {355.96714828906244`, 81.46096789843752}, {
     355.40052297656246`, 81.13951700000001}, {354.81428371093745`, 
     81.13951700000001}, {354.1866372109375, 81.13951700000001}, {353.6472535,
      81.54269270312501}, {353.6472535, 82.10386969531251}, {353.6472535, 
     82.610563484375}, {354.0231876015624, 83.00066321875002}, {
     354.5157157578125, 83.22622367968751}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4hPWbcfrlmk6mN8xc/oq6uNwchX7GWdJfTj/
/KqWu2nxCP6B3G3M9vsw+WvX3ogv00fwVeqrar97IPTD+DDzYXyY/ej8s6Up
3xav8oXzi37+2xO/B8G/uPbYCY8rvg7vvv4LqHJA8EU2lN8qvaWBwYfph/Fh
5sP4MPvPvkxf8CJJGeGel6/6jsog+NfVdma83auEwYf5H8aHhQ9MP4wPMx/G
h9mPzo+frLLPc7MXnL+Lv+t770IEf4d4+8vCTi+4/2F8WPig82H6YXyY+ejx
DwDkift5
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4v+M+xd6r3d0CPR9J7N+d4ADjK8SPHMv+ykE
/+uLP6csTwc4dHpMzJ45GcFXvbJaSMzd0eGIXpfcjyUBDismuQZ433KA8/eU
7+2324TJX30xwOP6xAAHz7q1y9ROI/jpzRMeCYk6wvkPl3DsYg9zdEib9rn6
4UIEP/3XKQ3rjX5w/srK45qzmv0cTs5f1G8X5OiwXPFLrVOJn8P1OYJL7z50
gPNfN3Y+ubATk7/kouyRcz5+DiulGE87PEXwv3PaN/EEOsL5BZcfr13ZhOC/
mNNx020Lgm/ec2yCkIITnP9Vxa68yRuTD7Ofk2vbtlJlBF+cXfWMyGaE+2Hh
b7JAQ8q0CcHnsmPTztuI4MPiDwBiL9aI
    "]], 
   RasterBox[{{0}}, {{19.9875, 56.14770000000001}, {49.9875, 
    56.627700000000004`}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H8s1HEcx/GLFA0LRQ1DZpSizn3vi1nehO8P+RnVquvqWsWx6pof86PU
cV3rxyUrMoXIDEWpHSdRfsy1yY9U5GeYn7drOsX8at1f38/WH88/Hn+/tped
4GL4WV0Wi7VOm582HW3p56e+m/RxQeo19CUvgAJ9hU/xbCEOW8dXg8goCkS8
O4Muru6QPPLE7kMjsrgUuyzYQTMuinNTt9+kIaG/8UhuJA56++JX6zto6FW1
z5tHcRnr2y8YFF7AGO+vi+2UVnOga+FAW7QEecQyX9HkhFyZVPA7hEXDREkY
fmOGA/09Lb/YMxTIuh+eMWJjjJsHhj82pSGPTDcsZr3CIOyuxnFiPc04Ztft
JtlOZGeVWlIbRUNihOq1hwdy3fFiV5k5ch9pmlEhwGDbSUpjVUiD84+lQl89
LuxVCXMGKmlocGlOq+Mhtw1PTt9pQiZYg93PKBwsfq7jL2QhG3VkC9ZskasU
f2v7TJCT0z6lS5QUHFWH6qYa4EBIVkzfZlIQbl3/fqGBC85zfOGfQxS8z99k
NirkgplqyXt3KAXxNQF8qz3IXYG211y3Iztl2k91DGGMY3s9HZ+3I3vxHL3n
azDwjcxmLwdTUGU8IMovweBSI9tBGYQME8EFPT7I3vEbDV9wKDCev3XQQYH8
5oKT3doYMvulbLwthMt4S0LYb5YNzphTbGNUmopDSLgemTtMMo5b3TBYJkB+
INeJEMsJUAa7pL7u5ELSdqGi7z4BbnPq0tDTyFI/labmD8b43cDp2gLt3liR
sJxXSoA8TzI2P8qBXJeW2apfBCRm9Ih7ORg8SrB9aqUiQOOfUp95FYN0A/Wk
mz7J2PeYvgXuicxLO7H7WzQJ90Strd2eGPD5qnD7DBIm/a/n0hoO4+qUnEVr
OXK/vzRh/TkOfN5cIOkQIUuXNDqx7si4eKmr/AMBgcut8sOhGBD8RcOcGAJo
I6ViWsBlPLeCu8qyccZfu0VYdYo7RD32snQaQTY/Km+tOEUynpN8jBhVkiDe
VERdGdLu8bW3bNqZgv//4h/Z6+w7
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQ/cW12NvDw8ohp/1CkLKKpwOMr7mBYVmOE4Ivum7R
rNxGLwebhFW3A+usHQxeZ02/vc7L4dI/zxLbfwj+Ace9gixWNnD+yYM/Vlss
tnHofd/tLbrCy6Fw7V1h81s2Dgv39C+2bPJysP+clf51M4Jvtlh8TpwbJt++
YKp6gSeC37TctChJyctB+VmXpWqTjQNPn/m8En4vh9MX8xcq70TwRVbuif/7
AMFPYDix7IW2rQOv2GeJLCkE/3Rdk4GNF4Lv5qCV9XWyl8Nc89f3t++zcWA1
LP2z55yXg1uD6A2vD9ZwfseV2e88NlnB+SdfHHLYl2TpsHFm731VHQT/u+2r
9dNFPeF8ToaX33iPujucslbhuNlm5eAe/51nera7g/WHJA/tQms4//jDzNbX
HTZw/pGStf+zK2wdeE4wm/U8RPA9hDSL3rZ5wPm5+THZIWqeDhtZ3pvfmWHj
cIXZYP3aeZ4O31d4c/g1WcP5L36s6o24bgXnh946WVtXZeUg4nz2dXM8Iv5h
6QMAgEv1FA==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQPePIbN3jedYOlZJZO29MdHf4Xxpqq3PBCs7PnX75
460WK4ejBaUMR+64O/A3W3tsK7VymOFmcanuvbvDF9dibw8PK4cI8+YUNy0P
OP/KjZ1HfPoQ/P2bHx24sATB//ZUjMWBzdNBiPnXheMzrBwY+myr9Zo9HYLX
5uxpr7aG8x9xG9QfX4zgM3uW9kaI28D5dbdMfhSn2jjkHdcXX2Pq6TBT/O+X
h5NsHI5XVwkWsSP48h9S3dcf94Dz914OntXcheDr+C791emH4IeGf7H9ye/h
kN5bJG6XYeOg/PSuu8pjd4d+9arjbTI2DiZe0/+xznB30Ejet6V/BSL80MMT
ABNCm8o=
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYrnFymGXdB0dYo7veOSU7OHQ/6T/axgfgn91
c9IGTQ5Hh46TXCbnbDwcDC989zb67+DA73Fo31wWD4c9eXMPXv/k4BC83PeZ
50d3h93ncuOFXzk43NOtL1F47u7w66n8fv3pCL5agW73hmokvsGx0PvG9nD+
pECf6mtyDg4lW1ap2mZ6OPQcWcjV+MjBYeO8/4eTxD0dYO6N+qW9vz0awb9Z
/dH19k0EP9JWbOL2TC+Hc4/P5i7Z6+DAalj6Z885LwczX+3jc1QR/GaW/1bV
hvZwvl7sAo2fFXYO80Jcmb7HIPhrLB0Mjr/zhPONPDaoF6z0dEhrv17Z8gnB
D+DSPbXhJ4K/4V/wLCVlezj/fPenAJYKe4flE6ed+r0dwT88r+zH6ZcI/pcF
rtFVnF4Op7NZ0vR87B2a4m/u/qrh5bDmXup6n+92cL7fr61Xjj5G8DkWq8//
ew/Bl1O45Hfxup3DxpOl6w6rezlkmtddNBa0d4ia+tKGv9LLIdarbWP9dHsH
xofznDyXezmY8J5hEhFxgPNDk1p/FLci+B0lpwN4dzs4PBJeePyeA4I/+UuV
Yykw/GF8170PLtuUeDp8Z50441GNg0N2/NPSTAFPhzVpmrO7LBwcfLtecUgf
8nBgvDwppmKKnYOfO4P5683u8PA9eOL0rB9LEfzqyJO1iYsR/H0GM7UkWt0d
Ku5rnu7lcoTz0dMzACq2RRk=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{36.54942554, 51.561904562500004`}, {
     36.096436752500004`, 51.856113775}, {36.057520190000005`, 52.18923955}, {
     36.057520190000005`, 52.3558024375}, {36.057520190000005`, 
     52.9535608375}, {36.6973084775, 53.3660764}, {37.397806602500005`, 
     53.3660764}, {38.11698467750001, 53.3660764}, {38.74743299000001, 
     52.8554911}, {38.74743299000001, 52.150322987500005`}, {
     38.74743299000001, 51.59148115}, {38.362937352500005`, 
     51.119812412499996`}, {37.7714056025, 50.7773466625}, {36.54942554, 
     51.561904562500004`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQ7Rg6b/Gif04Of7audjsa4OnQJ/OxdkuYs4Ob6xw/
o3pPB/nF82XXTXJ2YH3XpdV7AME/du3GqQJhLzi/Kzzytkm7l8OF01d9N6oA
1RuW/tlzzsvBqpUzUXaLE5y/ZFvjz8kWCH7rRf7pUVccHc6di3i1vhDBv/N7
/bk3fzzhfL+73hdMnyH4/Vd6wuav9XRw5tp+v4/DyUF3AduhJUWeDrquGyr9
xJwcznfnSTQkezoY+mrVhro4OTievbWdxcXToarF/WZWspODRofoyU16ng4v
egOXeUk5OfC+rtHj5PJ0CBaf+0pinaODnIKfmO9hDzi/0OTNHG03BP/wiqiD
rgfcHS41vOucq+fk4B7/nWd6trtD5vulwa83IfiXJn/o0Xd0hvMDYoVOvd/h
7MAVsWdR6hUEX3fvm94N0R5wvsevLV1ynR4OaUqSBgarnR1Wua1ne3HQw4G1
zE9Mu9rZYfrFuijp7x4Oyw62cTklOzvYfPVoni3o6RAvpKqp5O/sEDrrHr+m
nKcDevwCAHwd19U=
     "], {{37.003970990000006`, 50.218504825}, {
     37.27794359000001, 50.0519419375}, {37.74027235250001, 49.757732725}, {
     38.2103844275, 49.4541835375}, {38.485913690000004`, 49.2673840375}, {
     38.946685790000004`, 48.973174825}, {38.946685790000004`, 
     48.375416425}, {38.946685790000004`, 47.6500117}, {38.21194109, 
     47.1394264}, {37.4071465775, 47.1394264}, {36.563435502500006`, 
     47.1394264}, {35.85826739, 47.7480814375}, {35.85826739, 
     48.5606592625}, {35.85826739, 49.1303977375}, {36.1711565525, 
     49.757732725}, {37.003970990000006`, 50.218504825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{41.53663547000001, 51.561904562500004`}, {
     41.08364668250001, 51.856113775}, {41.04473012000001, 52.18923955}, {
     41.04473012000001, 52.3558024375}, {41.04473012000001, 52.9535608375}, {
     41.68451840750001, 53.3660764}, {42.38501653250001, 53.3660764}, {
     43.10419460750001, 53.3660764}, {43.73464292000001, 52.8554911}, {
     43.73464292000001, 52.150322987500005`}, {43.73464292000001, 
     51.59148115}, {43.35014728250001, 51.119812412499996`}, {
     42.75861553250001, 50.7773466625}, {41.53663547000001, 
     51.561904562500004`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQvVNtT8f/GleHP1tXux0N8HRge8eXLHjV1cHNdY6f
Ub2nw/SSvUzcgm4OrO+6tHoPIPjHrt04VSDsBed3hUfeNmn3cvCY+9mIb7Gr
A6th6Z8957wcNoWpu1UZIfgyHfPvfdjmAuf/XaRbsz3IxeHcuYhX6wsR/Du/
159788cTzve7633B9BmC33+lJ2z+Wk+H3bevHHnd5uKgu4Dt0JIiT4elYufi
Vk9xcTjfnSfRkOzpsFLOI2nTIRcHx7O3trO4eDp8Ck3dd/yhi4NGh+jJTXqe
Dgnx+d3LZ7g48L6u0ePk8nQ4/WLX+VIdFwc5BT8x38MecH6hyZs52m4I/uEV
UQddD7g7eAXx5P9a4+LgHv+dZ3q2u8PDA4ctPAxd4XyvVL6inv0I/gk9g/U+
5m4OXBF7FqVeQfB1977p3RDtAed7/NrSJdfp4XDvs5lor6abwyq39WwvDno4
1Lrn/G7/6eow/WJdlPR3Dwe5yUvez3vo6mDz1aN5tqCnw/XHTnz1Z10dQmfd
49eU83RAj18A6Mrf6A==
     "], {{41.99118092000001, 50.218504825}, {
     42.26515352000001, 50.0519419375}, {42.72748228250001, 49.757732725}, {
     43.19759435750001, 49.4541835375}, {43.47312362000001, 49.2673840375}, {
     43.93389572000001, 48.973174825}, {43.93389572000001, 48.375416425}, {
     43.93389572000001, 47.6500117}, {43.19915102000001, 47.1394264}, {
     42.39435650750001, 47.1394264}, {41.55064543250001, 47.1394264}, {
     40.84547732000001, 47.7480814375}, {40.84547732000001, 48.5606592625}, {
     40.84547732000001, 49.1303977375}, {41.15836648250001, 49.757732725}, {
     41.99118092000001, 50.218504825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd0F1IU3EYx/GDMYSckqksjU1Nw7kV+ZJhs+CZs/3/5xAu50VJapZpSqWS
JEXmar5RGfkavlRX09xUNsWBjFpZKQVb4sK2RCyzMXWRmZGR1tpF5xzo4uHh
c/flF3mqVFmwiSAIH++F/vtApLdqjRgG627NtISSQJsw76QsVSTUTUQoKvUY
+gZrjJPzJLzcpy3i1mCI6eJZ0qQUROQnL8xQGB5fD9p+30TBYt7ncj8nAk78
xY1HrykQCQ+J7QbW0ccMCxmFrJsij6/0+iHw6UhtmBmgAD1TjrxzyCFm3VV8
LZmCP0ucXx6DHApS1e2SORJkJsewTSdn+mjT/bRP+7aNfDFhxr9FBWYhiaHi
U/N3yawcUmwTNwWLCJavKjIkwQjM2H+rS40g4HlThr4UwZKp50d7MYKgqPdE
wADrirXWNctX1v3Sgzv8jmC4M1sWHlqDYK0sp+FAvXdPtzWXu4GY/S5oEuOU
mZjZ1yFsrHpqZE33ZzXP8bv13p64DtG2WgTn7LHrb6pYfwtRj4YlebsTim6P
axD4pmSN3RUg+DglnHbzMfCJPLF9C4IcVfaut8Wsz9RnSolZ1uePLlTXCknG
k11O/7OXWV9ROIddFhKWk1Y7rWEIovoCDdxACvp7VJrqBASa6Om0yocUlPBu
PMluROBO5L6wD1FMP22ezOqed7Bu1mjqT4ox5Ib0jkXcoyA9JL6JJ8NgiJUf
9ggoKDSN87sVGEZzeXtlDpKxh6Mm9l9iTffTDnesnPjwCjO2/RQ98JRjqFRZ
q51SDCXDu4PDojBotZuHRHsw6PLbbKs6BLYgUcuUi933//3/AqHBYJ8=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4qqlFztX/vR2SM+MjfzB5+OgwPm7bJOqj8Oh
3vfPnrz1djieo5KyO9DHwUtGLn3+aW+HOUplMYfrfByY/pZ8iljl7bBl/XTG
pl4fh91vnYr/zvN22Laf73vOYh+HF/+5dxX3eTuIyDCH/1uN4P+z6+B8vxvB
3/W94KTgWR+HV+H3U0/PRfCveNV4ym1C8D2PeO123+PtULLg0WTPEz4OLGul
vThOejvseP7zstp2H4cVE9rW/b/o7WDat0gii83H4Z7V/7JKDR8HZ7Xzqyds
9nEQeVpu/xnobpd1XWpt+3wcFhyuqVRs8YGbf/6sx7nN3Qj+zgNPN7ItQPCX
bG6aGrnFB+7+pdxhjhsP+8D9B+OfO1KiaLYcwRee4n6HYyHQP6WfjOsP+Tjk
Pzjitn6yj0PcH+VDoTt8HGDhH8KzcMovRx+4+xXO/q3K4vV1YFNhU5vD7uPw
aZeJyRdZX7h840SbGjtrXweWkvhzb154w/l9UYm//l1F8HuZ+vyWH/N2WLeY
9fAWLQT/9tZznNpSCL6f+axcCx5fh9fnTjrG30G4515fQdQEO2+HV0qtmz5s
83EI1NiwNEfPG+4fGB/m34COBucVqgi+4r2WnkBRBF9+nuqJE8ze8PCE8WHh
DePD4uN2XlP+LiFvh7/1juXvmoHm1W15JyrnDY/PPTxRiy3PeTusv5DUsloT
IV+l9mq34WVvuP537k8bmYHqYObvs5XULTyG4MPSG4wPS48w98PSK8x/ML6V
slf1Yi0E/0tw+YELBsB0OzX/+NJ+b3j46fPbWZ6f6Q0PX8v/B9K0BHzg4f8o
Pt6tx94bzm95/e2ftiWCn923V4Nbzdsh/sMRdsPr3g68Var1z8S8HYzu/T6w
6zmCD0sv6PzZAbrHDUwQ+cP+yvHeN67eDuj5HwB9+c8n
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtQlFUYB3DuoUEsBeEGyW5surNARNzEYH0IlOB99z1vLGHkSrJCME2A
4EgIQrKLZAymKIojwnBHa0HBDbnfFhSM+3hBXUrAViEgEFCBpPbTe2b68P/w
+/A/c2aecx6uNC4oUl9HR0dXmxBt9LRJsjtvNjuDQND5LFsvjgSDab6UXEKQ
MJ6vG3CKhAqbsaDzxjS4B14SCI1EIDpqBMWu2D9vKpi47oG9wdEtW70Le2PB
EVv9YBrcnt1O0zwnwXjvu3uSP6EhuaPSs2GehI7QcmTkTsOd/u4/7g5jhzmY
5Cxew5YYcJWeRSS4vyi20XjR4HtvUFF3nIS0W86hzSLsaEP7xZQ92Cbxn41E
x9HwVCAru12I3XL1r37hELZClXgxiiWC1LmvlAmBNGxsvxDWwhVBxOUL3Rw3
7NaFL6tVLOzDqpvxNcsIDJM6zjlOkGB9xaknW4PAWW9QWn2DhOz5/Cjzmwge
/Fk32mMpAoGN5kCQHDH92s7jow/DsF3if+FsUVOM6/NO/luQS8HAzhPi1qMk
48lbrsuHwrEzCvkRsmAShr3ez7YvxrZSbL3cWYo9Nd64qaEKW/cJx1dWQ8Fv
pvbp7N0k+IfY7WMrKYi9z133kZJw+FGVd8vvFBCDqG9ZQ8L23rWxImfEzPdb
cWaTnwSb3/Vm9+pB7MGtXrX6RQhGDfm1KWsk46YhSeXCr9gJK2ZTVj+RUDeR
qKrJQuCF8jiFHiRzvp+rpTchJ4BXxnvA+xRB7bGU9jwXAtJgbcbaBsG5S/Lw
yFeB4GL+UDb9mGJs8JrZB1+MYTdfT50+2I7deG9OtaWCgrEf+s3tTAnQMzPh
eHVT8PE/bqHytwi4m7EubnpEgbe66/shR2yQyI0naGyLLHbmUgLuP2lTLE8f
IcDJM4BKr8V2GF5XCE9g+4RUUM9jKBBcmf/xgARbmBvdu98Vm/ZM9xtY1d73
5GnTRgUFnR/lOGrGA0Ga8t2h+klsu4huy4vuiPFLttUbZfsRxAzYzJ7xIIBl
m7otJgrBSm7VjkUhAbEulhM5iQjS8zk7680J0DiUqPtKcT/pdR5/89/YZyap
KXobzZgeUq9YSGhoMFWSVzMIxv59/lX2ZdjlL8VC2xoCqnp8t0eFYHNvsMpl
wdho39mv5yhsBd9itET7v5v3ZhnxFARsWDgdsJukgZ1sW+JQSjD7Rzx8TVlt
TUDlzJJ81YRm5hveGu7/dAG/j5G22Pcet2NnsUx9uhQIXig3syt4BOOCD5tn
UynsV8p8Qe83BDS8c/9siBJBw/KOyPFMAko/H3F6uxPBnUaV2q+NgP/v0/8A
oIViIg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQzZ986f5p50CHkFPZqiysfg4w/mLrjrlndX0dpA4e
+7qZJ9BhFa+fy34eX4cb2yd33PoYAOf/frXKgfUFgr+p2SvG9gKCLz9P9YTO
kQCHZ9Hy19RVfR2WHH+fm3AtwOH+349xlhq+Dv5lxos3Xw9wuJDy3+auE4I/
8fM/+1+eCL5P74XzS2J9HWxd+QQTgeYf91kU9yHP1yH9WpBD1WEEf0L69PzJ
2xD8Ox/V9l9dF+Dgcc9yim48gj9l0dTqQg8EP/mqwplCXl+HYh+x79EnAhyi
mnoauF76ONjorXJ98BnBZzVelvDUOBDONw5suZJbEOhw4UMa760EXzifYcWj
Yxfl/OB8w9dHA4798nNYahjlHmof6LD2UFoDt4e/Q0T/7zBJbgQ/38c/IulP
AJyvZR7o3X83wMF54rvnU5z94eEprFtpIyjk73DO9MyFH1sCHMK0Vqx49cXP
Qa3gdZ7c4gCHhNUs3cGXEHyD3er8l5sQ/ElxV96lC/k5tNZad647H+BgfUxU
3H0/MH4ku5dFMwfC+UEJjD5L1RD8UCOGkLmWgQ7aAd0Hs9/5wtNLlDdjZrEY
Iv3A0hMAfRQH2Q==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQraOzQ56DNdDBLd5x1sobvg78GrOLAj8HwPl/esvu
ND0KcHgW+7VB8omvw8YHdQf2Xw1wcIqv+r2ex8/hgY7qac/TAQ4qXLqvy3QR
/KjkC5y5QQj+7prXh781IfjFn3tfqG1D8JWsWPoKbvo5RD7Q3jX7RoBDtJPd
i7t//Bxkqr/FbHoc4DA/3ObrBml/hxVM7yqvfApwYHj6/p6tnr9DjbaQ8AGu
QDh/Hf/rXgclBP8Eu+3sv/qBDsK6lTaCQv4OCySPsCeZBzp45Pnu4v3t58Cf
fOn+aedAh/bgZ88+X0Xwi9PVJLRmIPj6QRrc4ZUIfoD01Zc9bH4OjZx3dm1U
RIQfengCAKBxmmo=
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4qvTrE68tgx2WLeifPlHUR+HrUdOZbi8QPC3
pfw6xfERwReZe+D84z+YfJUqyaNF+gj+bO/djz57IPTD+DDzYXyY/eh8F6el
0QtW+cL5L47aK8XsQfA9qtj1XK/4Okity7TU1kXw44/OWJWlgMmH6YfxYebD
+DD7p50JY64sDILzp+qoL9ySgeCbf0mYczMGkw/zP4wPCx+YfhgfZj6MD7Mf
nX8tPlXZbbMXnG9451RM10IEX//Jcb+8Ti+4/2F8WPig82H6YXyY+ejxDwAB
3PtV
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4q8vD0VGl0U69G7u81+7O8ABxo/fafmB9RSC
b+g/96/56QAHK941dk0ZCD5HsOUkB6dIh/9TtAK/LQlw8DRiM7zNjeBfVjl0
4cr3CAz+M/OPVVcnBjhIaVjd8WCJhPNXrtL+ZaeJ4Kftfp660zPSYdGfyevu
L0Tw7x3j7jPf6AfnK7hx9E9r9nO4tWPLhSvukQ5y70we25X4OSSa50Qv4Ufw
X2tq/J77OwKDLz0vTvO0j5+D17fkd6GCkXD+x7dMp6zdEfy1QVfjuRIQ/Kzt
y7/eqEDwBde7Xdy3DsEvqG46UnYEkw+z/1euXUrBBgS/8c3Xd/YVCD4s/Ffn
ZNYbNiH4jVzuE7I2Iviw+AMAVMzaDg==
    "]], 
   RasterBox[{{0}}, {{84.06760000000001, 56.14770000000001}, {
    118.98760000000001`, 56.627700000000004`}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1Fsw1HEUB/DNpSg16IKiKGkLTVYorXHQtP//v0FtfiYVK5PJpZLowtSY
VouoHbS5DJuiRpSlIZM007jEdmEUIhUV0tokptsi0/9pz0wP34fPy5kz55w5
NmExwnBdDoczh812NjpszH9sfWVbTyCV/76rYAcNCWmZevvHCCwdnPGlImi4
4jRo+tU4EBIH5DYNj9HiUpcTYasZrYvjncdepDHQbVx1L6WPgL7TyZlH7Qw4
kmpzuyK0ptgjRBmKbqEK/BudCHT88mmNlKAHVlyra+SiFQlFP/w5DFQly1Tn
PQn0dTZP8FQ0FEhv1ZTsRnNfui0yCUfHdFVaSGIJ7L48uW5Yj9E6ekNGo3Q9
2l49JnkQwQAZf6g8tgdtN3F7pIlBH73bzH8eTMA8hJ60vM6Ad/asbmwKgU3q
qNy3CgZGhqumpYVo1UvN1ab7aHq5W+bFHgJm3+aIfmWjF7bnhP21RlfWzT7o
NUEnJrUlS5Q0XCayA0mtBASSadP6TBou2Ywv6K9h+/suivq5h4aRBvH1Xnbe
i9UaT4ddNCxRZsUdzkTbOyq3HclAe82mLZWdRZt2SMN3nkGnTFy0t4oj4E1y
eFN+NAy+d/2TeozA8ce8tUpfNAz7FXV6oT1PzjOq2EzD1OtPisg49JDL/JsD
59A+LSUBpvnoR6e78j68QOvpGqxihgj4C/Wp/H5K6/iZue/KwtCyWp0Aca0A
VBXP3RfWEUiwiKrrzRLA9px6SbwcHaRO3CsVo+2yeuk0dt8uxVHlwaUCsD1/
MEDuQSB/Y/No5YQAyHQ8P1BIIO+U9Q1LtQCq1f3pzYcIJBuOfXY2oLT23mdg
5uaODk464PA6koKCU05tXWx9kUgtXHOBgqpoa51qL7St5tabUh5aoT6YcGMl
gVfGRZL2WHSqZlLnyBa0m1jTUd4ggGd5sYauQew9iH4b5UYLIN2Kl94nRztb
SEeaRtF3pZYqI9tAiCjkr+AOoJftrX1yJ5TS+rvkacBHJQU9hVxF0gy7j+6e
si/2NPz/L/4B1rHqpg==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQbflcu9BoephDTvuFIGUVTwcYX3MDw7IcJwRfdN2i
WbmNXg6n11pe3fIkzMHgddb02+u8HAqnJu5ezxIO5+uk7UtaKIzg67n5dr7T
DXfofd/tLbrCy0Gi0U15nXW4w8I9/Ystm7wcei5p7pA1QvC7/oWw7hDD5NsX
TFUv8ETwm5abFiUpeTm4nt+4ZqVquANPn/m8En4vB32u1W6Zxgg+o4Pdtnhb
BP+KKGOHVEC4A6/YZ4ksKQT/dF2TgY0Xgu/moJX1dbKXw+LHnmHnTMIdWA1L
/+w55+VwrjRExJgRwb/H9W3mpo1hcP778/XvzseGOWyc2XtfVQfB/277av10
UU84n5Ph5Tfeo+4O61UiFlxbFubgHv+dZ3q2u8Ppi+kG2Q8RfL2+lfbR6uFw
/tsiqzjrZKB/TjCb9TxE8D2ENIvetnnA+bn5Mdkhap4OL6555YRrhztcYTZY
v3aep8Ov/4kPNj8Ng/O/Xd7Z+G0Xgh/Yc/Dv/sVhDiLOZ183xyPiH5Y+AB/K
74g=
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQ/Yhtm+alB2EOlZJZO29MdHewKV6Sq70TwZ/x+7BU
+LIwh6MFpQxH7rg7NHyL/dC7KMxhhpvFpbr37g6Wz7ULjaaHOUSYN6e4aXnA
+Vdu7Dzi04fg79/86MCFJQj+t6diLA5sng6N03qDglaHOTD02VbrNXs6CDpm
+TI9QfC3SkjbCb1D8P+mr2n8xhUO58f4xMTUyoU75B3XF19j6umwOLrv9g3N
cIfj1VWCRewIvvyHVPf1xz3g/L2Xg2c1dyH4Or5Lf3X6Ifih4V9sf/J7OIjt
1H6iLx/uoPz0rrvKY3eHBfN1BZx4wh1MvKb/Y53h7tC2rs7b5T0ivNDDEwBu
4Jje
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYu/nCZ2ccyIcYo7veOSU7OHAzCF+07sHwV+W
32Bm2hnh0HGSy+ScjYfDlb9eLTtbIhz4PQ7tm8vi4SB1Vta+py7CIXi57zPP
j+4Okn9Z+bSqIhzu6daXKDx3d9jJcd92RwCCf/7s08U/nBD8owsPGEtcCofz
W+2+zu4WiXAo2bJK1TbTw4Hpx/zHCWURDhvn/T+cJO7pAHNv1C/t/e3RCP7N
6o+ut28i+JG2YhO3Z3o5LGY3m/opOcKB1bD0z55zXg7he54cfCeO4N+5xqdb
fzEczmfXLV8RtzjcYV6IK9P3GAR/jaWDwfF3nnC+kccG9YKVng5Tvx+pOXgQ
wQ+IuDWh5zCCnyH6hOXlWQR//Y7uIsXH4Q7LJ0479Xs7gn94XtmP0y8R/C8L
XKOrOL0c1hlc+K59I9yhKf7m7q8aXg7pvRpdnw8h+P5Tai4L7kPw6/5JHLu/
B8E/PJd5k8jucIeNJ0vXHVb3cpi2eF1Q7slwh6ipL234K70cglds8GJ4He7A
+HCek+dyL4cwma3xWvwRcP6zYxOjbrkj+AwXtrAtT4pweCS88Pg9BwR/8pcq
x1Jg+MP4rnsfXLYp8XTYPmP6qonOEQ7Z8U9LMwU8HYROPl6dqhjh4Nv1ikP6
kIdDzaniUrtV4Q5+7gzmrze7w8P34InTs34sRfCrI0/WJi5G8PcZzNSSaHV3
qGB94pzeFQHno6dnAIipS3k=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{100.62952675999998`, 51.561904562500004`}, {
     100.17653797249997`, 51.856113775}, {100.13762140999998`, 52.18923955}, {
     100.13762140999998`, 52.3558024375}, {100.13762140999998`, 
     52.9535608375}, {100.77740969749998`, 53.3660764}, {101.47790782249997`, 
     53.3660764}, {102.19708589749997`, 53.3660764}, {102.82753420999998`, 
     52.8554911}, {102.82753420999998`, 52.150322987500005`}, {
     102.82753420999998`, 51.59148115}, {102.44303857249997`, 
     51.119812412499996`}, {101.85150682249999`, 50.7773466625}, {
     100.62952675999998`, 51.561904562500004`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQ/dB67abClkiHP1tXux0N8HTomH9tftWGSAc31zl+
RvWeDhcerc0vPxfpwPquS6v3AIJ/7NqNUwXCXnB+V3jkbZN2LwfN7yfYK6cD
1RuW/tlzzsvh3uUkQf14BH/ym3mxWYoIPvOv1DW+7yMczp2LeLW+EMG/83v9
uTd/POF8v7veF0yfIfj9V3rC5q/1dEietvNCOmekg+4CtkNLijwdbhhvm+su
EOlwvjtPoiHZ0+GWebG8t3qkg+PZW9tZXDwd6i43nr1qFumg0SF6cpOep4Pp
DbYtrkKRDryva/Q4uTwdXs/RuaZzJ8JBTsFPzPewB5xfaPJmjrYbgn94RdRB
1wPuDqsCr6rmy0Q6uMd/55me7e7wlWMj17Q4BF8rOkx9x1IE/6X9c9cZDyMd
uCL2LEq9guDr7n3TuyHaA873+LWlS67Tw6Fk0auKHbciHVa5rWd7cdDDwcWH
9c3WQ5EO0y/WRUl/93AQKVJMO7gt0sHmq0fzbEFPh4JZBaUb10Q6hM66x68p
5+mAHr8ALovntw==
     "], {{101.08407220999997`, 50.218504825}, {
     101.35804480999998`, 50.0519419375}, {101.82037357249997`, 
     49.757732725}, {102.29048564749998`, 49.4541835375}, {
     102.56601490999998`, 49.2673840375}, {103.02678700999998`, 
     48.973174825}, {103.02678700999998`, 48.375416425}, {103.02678700999998`,
      47.6500117}, {102.29204230999999`, 47.1394264}, {101.48724779749998`, 
     47.1394264}, {100.64353672249997`, 47.1394264}, {99.93836860999998, 
     47.7480814375}, {99.93836860999998, 48.5606592625}, {99.93836860999998, 
     49.1303977375}, {100.25125777249998`, 49.757732725}, {
     101.08407220999997`, 50.218504825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{105.61673668999997`, 51.561904562500004`}, {
     105.16374790249996`, 51.856113775}, {105.12483133999997`, 52.18923955}, {
     105.12483133999997`, 52.3558024375}, {105.12483133999997`, 
     52.9535608375}, {105.76461962749997`, 53.3660764}, {106.46511775249996`, 
     53.3660764}, {107.18429582749997`, 53.3660764}, {107.81474413999997`, 
     52.8554911}, {107.81474413999997`, 52.150322987500005`}, {
     107.81474413999997`, 51.59148115}, {107.43024850249996`, 
     51.119812412499996`}, {106.83871675249998`, 50.7773466625}, {
     105.61673668999997`, 51.561904562500004`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQPUfFRnXB4SiHP1tXux0N8HRw7kgVWvk+ysHNdY6f
Ub2nQ/dpm0dLeaMdWN91afUeQPCPXbtxqkDYC87vCo+8bdLu5fDkfnjV8mtR
DqyGpX/2nPNymLnnY3PsPATf76ruhRkJCP6+R1/kavSiHM6di3i1vhDBv/N7
/bk3fzzhfL+73hdMnyH4/Vd6wuav9XSQq/dwnuYR5aC7gO3QkiJPh8kyrgJl
/lEO57vzJBqSPR2mKjBNqkyLcnA8e2s7i4ung+UeAQeWsigHjQ7Rk5v0PB0+
HJiqVhIY5cD7ukaPk8vTYVnrbo9o6SgHOQU/Md/DHnB+ocmbOdpuCP7hFVEH
XQ+4O6RapcyYGx3l4B7/nWd6trvDho/2tUfmIvhPnZ/OfPYEwV+iUbbjmEK0
A1fEnkWpVxB83b1vejdEe8D5Hr+2dMl1ejjod1e+fiYZ7bDKbT3bi4MeDv9N
psQ9YYx2mH6xLkr6u4fD+agNN95/jXKw+erRPFvQ00G7+f/z+6+jHEJn3ePX
lPN0QI9fAJz04is=
     "], {{106.07128213999997`, 50.218504825}, {
     106.34525473999997`, 50.0519419375}, {106.80758350249997`, 
     49.757732725}, {107.27769557749997`, 49.4541835375}, {
     107.55322483999997`, 49.2673840375}, {108.01399693999997`, 
     48.973174825}, {108.01399693999997`, 48.375416425}, {108.01399693999997`,
      47.6500117}, {107.27925223999998`, 47.1394264}, {106.47445772749997`, 
     47.1394264}, {105.63074665249997`, 47.1394264}, {104.92557853999998`, 
     47.7480814375}, {104.92557853999998`, 48.5606592625}, {
     104.92557853999998`, 49.1303977375}, {105.23846770249997`, 
     49.757732725}, {106.07128213999997`, 50.218504825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKB0vyKr9NT7GYWNb953Jkp4OMD7DPlWvM3WeDkyV
eR33YmIcVm9s2XrxsafD4jVGU9XcYxzUZ4ufcXH0cjjv9OtKn1aMw95GYem5
u7wctjhekVr2PdqB1bD0z55zXg4hSxu+dd9F8ANtzUI9dyD47Iu6b37pinZg
munUc2etl0NSEbttb2G0g/rv55kNFl4O+9gexi6IjXZIdWqaYfXQ0yExz2t3
Z1Q03H0wPsz9MH4K+9Qd73Z5wPl/tVL3aXh6OFQ1q9+2LYl2sL50vkvupbuD
2YXWTtv+aId9HrxCz5vcHY59Wsb5Y0+0w6tdy77NyHR3OLHIN3H5bQT/V8+K
O21/EXzRTX8+qurGOPTfK5CXbHF32HWSZ/k+D2B4vj4bx/PHHR5+RUuMDYKC
PeDhe0NjQt2BrQg+zP3Zt869/3QH6B6DmVoSre4OX/8UxXUdQfAtZOYfXDs/
2uG9UUbvsSXuDofWdR3OnhLt8Oiqxq3Xsh4OfoJ937p7ox1i62N0rmUi+Ont
wY4M9xD83PAXza0annD+xdlPebMrEfxq/6dbnp/xdDBfE67XPinaQXm14AYe
QS+HqU9kjZPmRTssUbnlUrPcy+HbnEUH/M5GO7w25jlyfZMX3P0w/qlNR8Im
fUTwO5I3qFyUinGIE11xVGGOl8Oz2WWaa9RiHDZouvn8l/NyKMo7+P6TTozD
wThxE+cbnnD+f9YmBssKBB/mfhhf/sbH+AcnPeD8Sz+05v0v9nD4e+GIkjDQ
/LwtuiJSyh4OImmPd26ViXFYlTz10udV7g4a0sVa3D8R4Yse/gDk/nEG
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKC31a/Jc5fmxDhvbuu9MlvR0gPEZ9ql6nanzdNib
+PcXz5xYh9UbW7ZefOzpEDf1IHtoW6yD+mzxMy6OXg5d2p3uezNjHfY2CkvP
3eXlkKeV3HvFLNaB1bD0z55zXg78ffyZu2QQfB61o8fLv8fA+Ye6pHyUT8U4
MM106rmz1stBNnra+t0bYhzUfz/PbLDwcqh8n3/h3JwYh1SnphlWDz0dZMJv
6u6YGQN3H4wPcz+Mn8I+dce7XR5w/l+t1H0anh4OpjnbfHM2xzhYXzrfJffS
3eHjDpE/2ediHPZ58Ao9b3J3aLxtWqP2J8bh1a5l32Zkujs0d9+5fFUqFs7f
Wmruv9UGwb8wqzslJCfWof9egbxki7tD6abZkm/bgeH5+mwczx93ePgVLTE2
CAr2gIfvDY0JdQe2Ivgw96sdjk1SBIbXPoOZWhKt7g4bnjJe3MGM4H9m0TO5
cy/G4b1RRu+xJe4OtdMlzWZdjnF4dFXj1mtZDwfOXzKZu87EOMTWx+hcy0Tw
09uDHRnuIfi54S+aWzU84fyLs5/yZlci+NX+T7c8P+Pp8GnKswVbL8Y4KK8W
3MAj6OUQcHbN0gl3YxyWqNxyqVnu5bCx1dC4lifW4bUxz5Hrm7zg7ofxW2cH
nzxggOA7+9hP/x8Z6xAnuuKowhwvh4UtrHNupcY6bNB08/kv5+WgGx6QpAgM
z4Nx4ibONzzh/P+sTQyWFQg+zP0wvvyNj/EPTnrA+Zd+aM37X+zhsGNn8FRH
oPl5W3RFpJQ9HM77Fek8iY51WJU89dLnVe4Oj5mZ5lpaIMIXPfwBj2xiAA==

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4r2XXhy5YhPvkJ4ZG/mDz8dhYkut9c2geIdD
ve+fPXnr7ZBiJrTpbka8g5eMXPr8094OfoLW6xLr4x2Y/pZ8iljl7XD7+mmG
g23xDrvfOhX/neftcCe+vXrbxHiHF/+5dxX3eTtw9zVq/5+K4DfIH2n5PhfB
v1u940nHsniHV+H3U0/PRfCveNV4ym1C8D2PeO123+PtYBXw8aTKkngHlrXS
XhwngfZ9/pM5eXa8w4oJbev+X/R2kHYP5DF1jne4Z/W/rFLDx0Fp8vPQEzPj
HUSeltt/rvNxUA53FXaeH++w4HBNpWKLD9z882c9zm3uRvB3Hni6kW0Bgr9k
c9PUyC0+cPcv5Q5z3HjYB+4/GD89aZfA7MkIPtcp5byWCUD/lH4yrj/k42BR
kLT4eme8Q9wf5UOhO3wcYOEfwrNwyi9HH7j7Fc7+rcri9XVgEWIWPgfkf9pl
YvJF1hcu3zjRpsbO2teBaZd+epkJgu++1qD2vxYSn9F9ebByvMO6xayHt2gh
+Le3nuPUlkLw/cxn5Vrw+DqUPX+yQF8P4Z4Cdwtdj/txDq+UWjd92ObjoCly
I8jsehzcPzA+zL+aLgcUr1xC8AXznY6tOIXgC5wXSnlyMA4enjA+LLxhfFh8
5JkfNI89Gefwt96x/F0z0Dz7qO9c5+Pg8RnHtvaijHq8w/oLSS2rNRHyVWqv
dhte9obrf+f+tJH5nDfc/H22krqFxxB8WHqD8WHpEeZ+WHqF+Q/Gnyu4dG/g
VQT/90rrhIwbcQ67puYfX9rvDQ8/fX47y/MzveHha/n/QJqWgA88/B/Fx7v1
2HvD+S2vv/3TtkTws/v2anCreTsYVDxqnqEd78BbpVr/TMzbQep9bcJdYwQf
ll7Q+bMDdI8bmCDyh/2V471vXL0d0PM/ABCSyww=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1Gsw3FcUAHBsGUu1MYlptWkQmbHxahLCLLWO8Sr/u1ZCPTqSuSQm0nqE
tmy9EtaKRyIkSNNFpSS0Xc9sjAhiQwiJV4eSEhlR2lSj4pEUSdr/pz2mH86H
34dz5tx75hyTsJiD4Rw1NTV1NgLY0GBjSnvO1VFGwfz20hmNGAJpDjnvbi2l
EDctU/fKJ+CXF72bVFKw8642F2gJwQw45b4t6E/O+DybuImWFr/nEd25yT7t
59T7KOxfGkmde04gozbPyklJIVFZxb+xSGBa/rMZh80f7b/z6Jdh9GHLNwuW
r6FD3jBR8MsJyDZ83/qinYLr2KC8KYuA8+w3llPdaEV60VpbPzqzmXdcMUbh
D/P0ypEydFv9fL9gCC3vjC85tkUIzi8+/JR/h4JOx7eH20yE0OjfH5bfgn4k
thoLrUZPLcaGRLL/pSlWFls9JtAzr7uv4hKFvRqDYbXdBExfzgV3FVD4dbZp
/K6BEHRP80tGTmF+zZ6dz5sS0MJJ8yxuIHphduakmTuFAfezfu2niMozfbar
X4WiM8p4R9P9CdiKuDPeH6O15r1+XNzkpGZrj2gG3cG/m08JhXt6FmmGgQTO
j2oHaQkpRD8wee0SRmCH+HNRHdsPMyi6vzpHQLSUah8RifOdKJy21k9A6zS4
NbxORq9wz/2llkVhXJPXmLRBVL45FFL17Do6bu3tJ+/kEahtfnhCnk7hI9FF
4zJ7oqrvZmvgxEgY4O7OtuPGUWiUJnVctGHAeEiwoXWMQnG1JDT8lTcIu5rK
HYLRSqVENyAQ/XfUd+vbfTf5+kZ9theFh6f79U31GFByONqiAxQcX+4Plmxl
wO7yvyPWQRScJrtODlmhIUSi/dgXvS3HMHMlDvN/vyVf/TOZAeJz3q+coBmF
808iV3R+0Q8XUhzZ/atbzD4RghYURvQesUX78tPcBtbZfiuOSqzZ+d3eV2A1
N+0ND6YOfbAQhOYGx2pWRaFTu6WcJ2IKUQPbn16wZ6DL08hn4msKa4U1zssC
BiaJVFyZQiFNZuzerM+AQy7PfjkL86c0uDk9MnRfbNWXvFY0L2IhWWeAwg09
BanPYFT2vO9ZY1GJvvKPn8CogYHA30xKbe6h9Y9kHXTpQ/PqvW0SetAB23Qi
h9n9bj2Uo7VLzoBU3Ftpwdow0eh7ywpGdX/8hq8pat9nwD9+3SXlKs73Usy4
fmIJerVOps3PR5u6uW7Zm0vhhWKH4dVdjMqle1qfpvigXylk5r2fMVDnEX/F
4Cz73lXn8OlMBo4XreRK2XqjLZ2TbrcY+P89/Q8AtWdN
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4vvZHH3cBokO86qWHDQ08HeA8TMtLzibuvs7
3DbraZqun+iw9lBaA7eHv0Mb07bmbE0EP7T9Dk+6dKLD1sIjUTVC/g7NWc3C
pewIvo940te6fwkY/JRnTNOPv/NzMP3I92EncyKcz7HRuFVTCME3X6auYyiX
6LAhUk+6k8sfztcqlH38y9kXzg9/feRpjxqCr6Pt6/VTytdB64mXbQgHgv+s
fNaZf/8TMPhMHrmPnvzycWibbFL/HugeGP9D7q/Nj+UQ/MfmrVOZ1RF8reAz
jhd0EfxXLCaCeZ4IvuGsqW9t/TD5MPvf6j6teeGK4MPCH50P8x+ML/xuauVm
ZwQfFn8AZOrBQQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}}, {{{142.72321728000003`, 60.1710383828125}, {
     142.72321728000003`, 60.9338032265625}, {142.63386482687503`, 
     61.4808145859375}, {142.31568292062502`, 61.9668047578125}, {
     142.10101910031253`, 62.286076328125}, {141.67278112375, 62.562851}, {
     141.11923178, 62.562851}, {139.51524628, 62.562851}, {139.51524628, 
     60.6701045234375}, {139.51524628, 60.1710383828125}, {139.51524628, 
     59.6719722421875}, {139.51524628, 57.820633}, {141.11923178, 
     57.820633}, {142.72321728000003`, 57.820633}, {142.72321728000003`, 
     59.6719722421875}, {142.72321728000003`, 
     60.1710383828125}}, CompressedData["
1:eJxTTMoPSmViYGCQBGIQfa5ca/+FxYkOqdI7mHOZfB1E3COMF81E8L0/am+V
6kl0+K9iV54l5evgsuEJ59r2RIdWzsWRosm+Di9kH06e1JLoML0nWSV5OoIv
V3iCje8Bgv/4mO6z2Yp+cH7K5D8dwUkIvs3eoGkbl/o5/HCybnsNNF9zhiFr
/DU/h81iN9dOB9r/+MElw3YZfwdTkxubL85KdHDJa5MW0fd3+O6xt+31YgRf
3W6j7uf1CP573h+3a3cnOvxZ+fHSSUF/hxCuLxkN+xMddhZ2/yy95+ew5WLx
K77DiQ4CCs7H561D8C/f4Urcm4fgw9wP48P8B+OfjZxfFDPP12HVw6nMWgcS
HRQ+HGCYlObrsHiBX8QeoP1TPx+991nU1+Huzx2ia9Ygwhc9/AHzaLee
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYq0prevX705yWLeifPlHUR8HqdVn/98WSkbw
q58a2Ikj+J7TPTZry2LyVaokjxbpI/izvXc/+uyB0A/nQ82H8WH2o/NdnJZG
L1jlC+e/OGqvFLMHwfeoYtdzveLrcEZeNsN/K4Kft3qLwvt1mHyYfhgfZj6M
D7Ofa72wb1k4gs95/7e0SDCCf+vQjJlqvph8mP9hfFj4wPTD+DDzYXyY/ej8
a/Gpym6bveB8wzunYroWIvj6T4775XV6wf0P48PCB50P0w/jw8xHj38AvCj1
AQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4uNzyzk6tNIcejf3+a/dHeAA48fvtPzAegrB
N/Sf+9f8dIBDpv6bqtnKCH7ApU1LqgTSHP5P0Qr8tiTA4aOj5Bf3r6lwvpn1
98MurzH5z8w/Vl2dGOBw02bzybqPCL7Cv9U3fjKnwfn1bF185iJpDov+TF53
fyGCf+8Yd5/5Rj84X8GNo39as5+DZeuHwy7CaQ5y70we25X4OdS4+HTqfE+F
8w/aakVqvsXkS8+L0zzt4+fwUflEEOsPBP/o/OkOP4TS4HzlSw3d8fIIfiNL
1rVj2gh+aIPlkZ1uCH5L2vW9UwMx+TD7T8Zv7Z3kjuDzyAsGV2kj+LDwX52T
WW/YhOA3crlPyNqI4MPiDwAIMcuf
    "]], 
   RasterBox[{{0}}, {{157.02800000000002`, 56.14770000000001}, {
    196.98800000000003`, 56.627700000000004`}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H0s1AEYB3CuRDlbkWKuplp5OZmXLDXLE9bvpem4FJW6dr+f0oWoo8iy
4Qi9aU30cookKra2rrveLDFaSC9KIpVcL9c1THTu3Pr9dc/WH98/Pv88fzzf
Z88S6QFxwgwrKytrLhFceFxe7o3+QZkYKAwZeHNxAwW8O9m8BGcWnIdMkWQi
BadnXS9a6cFC1uDlJU+a0Lm1QQelS2mLq+SB+o7jNPhl8N9P2bNg459uethF
Q7zLqRP0b8bisNDNjW4v0F6OvBvl9xjonghv26dAD7opNc2e6IbMynGRFQ3K
RrP8yGMG+l63jAb8oMApqHB7URt629YoW3iJno7lO2S9YyD65JjH8Eza4v3e
Jc2nvNBCnV6hTqQhdbj0a0o7Ok5rJ3dtQZueli2+3MmAyy5qTHCFBq0qkDfy
mQE/nez8hwYaNJ/4ZvMv9P2t/hsrDOifUyIyew4LC39bSybOoh26yqTT7uhG
jVndOw+dldOZp2in4ET5Md/DPBYIhdHxwRkKSszCghXcfOGIRPZnMwWarvTu
am7fTjpDqE8UBd3R02t0WvSOfBdl8le09tffYusB9IseY8BAH7poj8F5Qy8D
YVvKAqY2UXCvX5Rt7GEgtSlgeXskGoY3Vb5ejw5Nt+XfXkVB+Pua2KRetPr4
GnHtAPpbVEE96NDX6pQdHjasxcQB9en+uSyIxDZkxUfSYrlpVn+dFH1OxYvJ
VRFwP+LConVGBjJdZZreUgK+BTs+TdOjDw6l3TIPorep3GuOcn0HVcnqd9YS
EOeb4F3wiIEK35afjaMEpOpSlF+4+yrPcL8q0BFQOVTd6srdV95svTbQjrQ4
bLvdwtVr0Ttz4n3e7iPByatTe5WbL5HoxMvySVBWR1iXNqFjZbbJ9mr0JWY4
xK6BgVdzKxVdaehCwxgvKRi9OtfQXf+EAO+1+nzxcwYIyST//H4CirMjW6/p
0ZIs4yHX+azFgrvN44/8WEi8FOLmOYheEKdqvbmbtHhE8SzmczsJ/g/J2EkB
10fPu7rvQgr+/xf/AOoD9Ps=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQfUV2y5vFm1McbNe+OaMn4ekA4wdOSuFR+uAB56eX
BNrlnXZ30DfrYVs5OcWhUjJr542J7g4X7F3/HWtE8KMnbGTuqUHwF1x83fk1
G8E/13nwzeLkFIfVl++kSu1wd9h+ZFdbciGCrzNpvtLD4hSHhpf/fsfeQfC/
vep4UfMRwc/VKZqpIuHhcE7zo19GToqDA5Np9n0tD4fIni+NHakIfsFHLa/e
BAS/vc3zoX54ioN9VeWHl/IIfqPgqxviH9zh/JWffe3PznV3eNrhFfszPcXB
Pf47z/Rsd4edXN9ZEpoQ/KWq9UdzViH4VZpceqEXUhzmTOPr+STmAeerv3ia
9k7VE86PmvrShr/Sy6HvSVmE3JoUB1bD0j97znk57CpJvCc0AcGPrrCV2VuH
4Bf6314fkZ/iUC4k+I91h5eDVoSsxJnEFIdo3962RfVeDme0BdtvhADtdznH
w+Pu5fDruk7ZfN8Uh68OpXvthBD8tx5f5/7f7Annn7jsu/ekmKdDx4HTr10y
Uxwqemyils32cCgRlDRN7kHwS+0fnp4wH8FnOnX+dhbQ/bc45JfyXkCkF1h6
AgBXfRMo
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQ/eLDlH/WvSkOPkz6farbPRzEWm3YTDoQ/KK7xU8O
ViL4zq+ly//lpzjM0AxiK2bzdFjwuGl7QFaKQ+ufWgFhUwR/UeXSi5wlCP7b
hMzWcxsR/E8VUXUHviL43z9Ii74z8HLozNl68ENBisOTw+7yffFeDqLqPQsy
gPYzOuY/aJnn5eDKWKAW25riYPA6a/rtdV4OelG7EuMnIPi7Lwm63JuH4O9J
WFXhvjLFIUZ26XaWFi8Hpk3RX2avS3GYI/LMNs/by0Fq+0G51E0pDtlFzyt+
K3k5XJHd8mbx5hQHOe8jDOsue8L5fWsWVj6dieDnfRd/5mno6RC/6pDJuxWI
8EEPTwDah6Hk
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQbTTpt6p1cKqD7do3Z/QkPB1g/MBJKTxKHzzg/PSS
QLu80+4Ovasu2zsYpzpUSmbtvDHR3UFvS495nCKCv5Plp42yDIL/z9X4cA83
gq/zj0PNmjnVYfXlO6lSO9wdRC2ZDvwSQPC72J5HVwinOjS8/Pc79g6C/+1V
x4uajwh+rk7RTBUJDwedeRYd/4HmOzCZZt/X8nDYzmCzW54VwT+XWtSswoDg
P/01Qer4txQH+6rKDy/lEfxGwVc3xD+4w/krP/van53r7uD8d+K0CeypDu7x
33mmZ7s7iNfb2X1XRPCZZx37x+yF4N+YG5j+Jj/VYc40vp5PYh5wvvqLp2nv
VD3h/KipL234K70c3kTsm7jVO9WB1bD0z55zXg4SL1eIr9JH8He+aQkNkUPw
zx9WevmeL9WhXEjwH+sOL4eOMymByYypDtG+vW2L6r0ctBZEHMj/kuIwx+Uc
D4+7l0OET8l6s7cpDl8dSvfaCSH4bz2+zv2/2RPOP3HZd+9JMU+HZybCqnc4
Uh0qemyils32cLjUmpD3SxvBv7xZg1XDHsFPsBMXZfJJdbjFIb+U9wIivcDS
EwCdeQfE
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQ7ZZ6x/yyTqqDD5N+n+p2D4eSn832p9UR/AuBu2Uj
JRH8hfHJG6bypzrM0AxiK2bzdPgXfurDc85Uh9Y/tQLCpgj+osqlFzlLEPy3
CZmt5zYi+J8qouoOfEXwv3+QFn1n4OXw/MGfX+0CqQ5PDrvL98V7ORTPvnzz
v0SqA6Nj/oOWeV4Oi0u3x39RSXUweJ01/fY6L4eec4yzv+kj+JLukbWldgi+
1NWPG+95pDrEyC7dztLi5ZCgtljX2C/VYY7IM9s8by+HCm3OiD+BqQ7ZRc8r
fit5ORhN+q1qHZzqIOd9hGHdZU84v2/NwsqnMxH8vO/izzwNPR32ynHltXog
wgc9PAGUl5zR
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4gTRg0mNd1Id9vwMX7B8vZcDjJ/Euu5hxBkE
n9Ww9M+ec14OTMtNr065iuC/9Pzzr/hQqsPCPf2LLZu8HLp2Jvk5Lkfwz29y
kLObi8nPZ5L9/j3ay6Foyx/lisUI/s7Sr0aftyL4EnWXMwyOpTo8606K46lB
8Bsj3fpbXrrD+YdvOE14vNvd4dIfSzm7o6kOBxvyn3SvcXcQ3TP1sepKBD9q
a/FmpfmY/H0GM7UkWt0dumYLrv23EsGPE3846+MRBH+P56mnERcRfKmazQYH
7iL47743yW3+geDL3lOQ6GdOw+DD7E+6/u9590+Ee5ZOi1pbfBfBh4W/3//F
DXW7EHyVuY0Tt79E8GHxBwDcItso
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQffHZkQQxzzSHnPYLQcoqng4wvuYGhmU5Tgi+6LpF
s3IbvRykTp2edD0/zcHgddb02+u8HN7svc96tR7B91Lru+nbjuB7T7uaUzIl
zaH3fbe36AovhwPGlyxDZqc5LNzTv9iyycuh6o4zS880BL+y6KbWzQ5Mvn3B
VPUCTwS/ablpUZKSl8P1W+3/AiekOfD0mc8r4QfaV9Fy2nA6gm8q7MesOwfB
l6vTz+lamubAK/ZZIksKwT9d12Rg44XguzloZX2d7OXA9jQ4+AnQPFbD0j97
znk5SOtFbhKrQ/AX/9AsDQtD8LVv58mn6qQ5bJzZe19VB8H/bvtq/XRRTzif
k+HlN96j7g7drNEVLwLSHNzjv/NMz3Z3kLqTdMAoD8H33sV8Qmsigr9ax+e6
1Hqgf04wm/U8RPA9hDSL3rZ5wPm5+THZIWqeDiviQu5pTE5zuMJssH7tPE8H
w8/xEuEFCL7+Xe7MH1EIfuxOfvVY/zQHEeezr5vjEfEPSx8AvFTtpw==
     
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQvfQbp+2z3DSHSsmsnTcmujtc0mG8LxSF4DN8nLB1
RUCaw9GCUoYjd9wdSt7FKhzxS3OY4WZxqe69u8PFZ0cSxDzTHCLMm1PctDzg
/Cs3dh7x6UPw929+dODCEgT/21MxFgc2T4eSfaWBasFpDgx9ttV6zZ4Oe4Wf
+NXlI/h99TbubSUIvrE6a+aPJgQ/STL22u6eNIe84/ria0w9HVgVv03NnJTm
cLy6SrCIHcGX/5Dqvv64B5y/93LwrOYuBF/Hd+mvTj8EPzT8i+1Pfg+H/edd
pER70xyUn951V3ns7sBy2NVgXnOag4nX9H+sM9wdyr3e+cqXIsILPTwB3PeY
Gw==
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{183.56384417000004`, 51.561904562500004`}, {
     183.11085538250003`, 51.856113775}, {183.07193882000004`, 52.18923955}, {
     183.07193882000004`, 52.3558024375}, {183.07193882000004`, 
     52.9535608375}, {183.71172710750005`, 53.3660764}, {184.41222523250005`, 
     53.3660764}, {185.13140330750005`, 53.3660764}, {185.76185162000004`, 
     52.8554911}, {185.76185162000004`, 52.150322987500005`}, {
     185.76185162000004`, 51.59148115}, {185.37735598250003`, 
     51.119812412499996`}, {184.78582423250003`, 50.7773466625}, {
     183.56384417000004`, 51.561904562500004`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQzTr/2zE5hXSHP1tXux0N8HS4EdBtq2yW7uDmOsfP
qN7ToeZT2VJF13QH1nddWr0HEPxj126cKhD2gvO7wiNvm7R7OayoaSlcpAlU
b1j6Z885Lwfm7MCyWl4EP648X2b2uzQ4X+zfpcM9V9Mczp2LeLW+EMG/83v9
uTd/POF8v7veF0yfIfj9V3rC5q/1dHA98+fqzEdpDroL2A4tKfJ0YJCu3sP5
LM3hfHeeREOypwPj3Mja7o9pDo5nb21ncfF0uPwq4UrAzzQHjQ7Rk5v0PB30
chcf53ie5sD7ukaPk8vTodN/W8Sf02kOcgp+Yr6HPeD8QpM3c7TdEPzDK6IO
uh5wd3i5sqtB9k2ag3v8d57p2e4O/a0/PhkA/Qvjr9TzZjxkgOBzLpwssMkv
3YErYs+i1CsIvu7eN70boj3gfI9fW7rkOj0c/IJEtZy80x1Wua1ne3HQw8Fs
+aLHDvbpDtMv1kVJf/dwkNu1YYGbZbqDzVeP5tmCng4+fhEr7EzSHUJn3ePX
lPN0QI9fAF7z4U8=
     "], {{184.01838962000005`, 50.218504825}, {
     184.29236222000003`, 50.0519419375}, {184.75469098250005`, 
     49.757732725}, {185.22480305750005`, 49.4541835375}, {
     185.50033232000004`, 49.2673840375}, {185.96110442000005`, 
     48.973174825}, {185.96110442000005`, 48.375416425}, {185.96110442000005`,
      47.6500117}, {185.22635972000003`, 47.1394264}, {184.42156520750004`, 
     47.1394264}, {183.57785413250005`, 47.1394264}, {182.87268602000003`, 
     47.7480814375}, {182.87268602000003`, 48.5606592625}, {
     182.87268602000003`, 49.1303977375}, {183.18557518250003`, 
     49.757732725}, {184.01838962000005`, 50.218504825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKJ0uetvT8126w8a27juTJT0dYHyGfapeZ+o8HSxO
9v/Y+ybdYfXGlq0XH3s6cDz++O/hw3QH9dniZ1wcvRzk112Vm3Y53WFvo7D0
3F1eDhPXHjqouCvdgdWw9M+ec14OifdnrBdZi+AnrP4cVzwLwd8dK6d4sjnd
gWmmU8+dtV4OL1zvBImWA83//TyzwcLLQUzA87FcbrpDqlPTDKuHng7PD/+d
ODkb4T4YH+Z+GD+FfeqOd7s84Py/Wqn7NDw9HEr83izMrUh3sL50vkvupbvD
pRLpyret6Q77PHiFnje5O0ix6ew8NSfd4dWuZd9mZLo7SMf9T1Fag+CbXF6j
JLQXwT/0NGztwyvpDv33CuQlW9wdpny8x77uEdA9r8/G8fxxh4df0RJjg6Bg
D3j43tCYUHdgK4IPc//bn/Y6J4D27TOYqSXR6u5gxD3p8eQFCP5lKY2pqn3p
Du+NMnqPLXF3kHgiO62lI93h0VWNW69lPRzips5fLwL0T2x9jM61TAQ/vT3Y
keEegp8b/qK5VcMTzr84+ylvdiWCX+3/dMvzM54Ol5JavCe1pzsorxbcwCPo
5cBY//xsfW+6wxKVWy41y70cjG6vFPm2JN3htTHPkeubvODuh/Flnu26L74d
wa/et8Ft++l0hzjRFUcV5ng5rLolfHLJxXSHDZpuPv/lvBw+OFvqnACG58E4
cRPnG55w/n/WJgbLCgQf5n4YX/7Gx/gHJz3g/Es/tOb9L/ZwMPu6yzUCaH7e
Fl0RKWUPh4P2XhNXnkl3WJU89dLnVe4O3lKTPK/sQoQvevgDACXGehA=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKH1Hv6/hQW+Gw8a27juTJT0dYHyGfapeZ+o8HdY+
dtIP7clwWL2xZevFx54OtX+XmFY2ZjiozxY/4+Lo5TDlREeobnGGw95GYem5
u7wc2E6U/tgRmeHAalj6Z885L4drP72frfZB8K8eXTaVywrBN6i4GJ6gnOHA
NNOp585aL4fYhP7ONWJA838/z2yw8HLo1vojuY0nwyHVqWmG1UNPh5h7G05o
cSPcB+PD3A/jp7BP3fFulwec/1crdZ+Gp4fDy4z5N1gkMhysL53vknvp7uDe
f259i2qGwz4PXqHnTe4O/Qr33yfaZDi82rXs24xMd4cJFZtm7/RG8Fe+jY9c
GYPgmzNwPakoyXDov1cgL9ni7sDJM8nOtQnontdn43j+uMPDr2iJsUFQsAc8
fG9oTKg7sBXBh7k/SeRzUjwwvPYZzNSSaHV3WK7qKqXtgOB7mN4+vUc3w+G9
UUbvsSXuDr3/LpyR1shweHRV49ZrWQ+Hy+uDnq1WyXCIrY/RuZaJ4Ke3Bzsy
3EPwc8NfNLdqeML5F2c/5c2uRPCr/Z9ueX7G08G91rxJUz3DQXm14AYeQS+H
spmzWMSB9i9RueVSs9zLYfnXGO9elwyH18Y8R65v8oK7H8afyJAntj4Mwf9w
I7nWLzvDIU50xVGFOV4O8l+P/bcuzHDYoOnm81/OyyE17k1SPDA8D8aJmzjf
8ITz/7M2MVhWIPgw98P48jc+xj846QHnX/qhNe9/sYfDav68mvcFGQ55W3RF
pJQ9HMyi/h53yMlwWJU89dLnVe4OB0xcG7KjEOGLHv4AWixopA==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYs5TJ7ZMjMp0SM+MjfzB5+PwWUn4w+TUTIdD
ve+fPXnr7XCnOlZ7WkGmg5eMXPr8094OQS8LNW9UZzow/S35FLHK22GGz65L
7fWZDrvfOhX/nQfkC0hMYGrNdHjxn3tXcZ+3wwZ10Rdq7Qh+VsE2EeVuBH/m
vA1HsvszHV6F3089PRfBv+JV4ym3CcH3POK1232Pt8MJDt/tln2ZDixrpb04
TgLlbwWxf+zMdFgxoW3d/4veDhYstTcOxmY63LP6X1ap4eNgo+VRyw2UF3la
bv+5Dsjn+X77BND+BYdrKhVbfODmnz/rcW5zN4K/88DTjWwLEPwlm5umRm7x
gbt/KXeY48bDPnD/wfj3Jm689aUVSd41rTOzBeif0k/G9Yd8HI7PYFURbsx0
iPujfCh0h48DLPxDeBZO+eXoA3e/wtm/VVm8vg5rXl6N5ovLdPi0y8Tki6wv
XL5xok2NnTVQ3vZNa1IYgu+3/Y3A8kAk/sPvqhd9Mx3WLWY9vEULwb+99Ryn
thSC72c+K9eCx9ch7coxJftghHuSWj5knNYGxo9S66YP23wc9mcdqD6kjvAP
jA/z7/4mk+SJqgi+8YzSrdWKSPwTsS2SsojwhPFh4Q3jw+Ij8Y/Ju6sKmQ5/
6x3L3zUD5RsYz61RRsTnrcdau7f6Zzqsv5DUsloTIV+l9mq34WVvuP537k8b
mc95w83fZyupW3gMwYelNxgflh5h7oelV5j/YPzKl2qGF9QQ/BWmRU3RGpkO
u6bmH1/a7w0PP31+O8vzM73h4Wv5/0CaloAPPPwfxce79dh7w/ktr7/907ZE
8LP79mpwq3k7HJ7jOuUzMH55q1Trn4l5O5hHTGYSC0PwYekFnT87QPe4gQki
f9hfOd77xtXbAT3/AwBhBNae
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtQlGUUB3CuRiUjBORsWUpSrMtFlIuCuJyCDeV5FwjEBWZhYIVJHico
zJUBkZbltpQVAwJCrWhLMM1yERaLUFFIQpSrQkBIAYERQQQtKyHa+2mP04fz
4ffhnDnP+c88tpKkkHhjAwMDQ7YOs2XEVl6CV7FERIHXtvSJURIDDuXj1CuC
QvJEueHBzxlYX2hLOx5DwSOgmsffIIT+CtHSSSn6yZ8XfY1T0Dt1iaVnM55y
3QuT3BwK7kv3Ts+sMOC8aSojLp1C6o0qz+ZFBj42t0/lnaQw2H3zl6F+dLTj
xoLlRrTYxFbjWcGAQFwZU5ZKwfenXvXlPAZmBfOnTeXo6KlZMq1Au3DSW34u
pPA7L1N1T4m+Wj/Xze9Dq9ulX7xrIYRZUZY6Rkbhuetl0VdthSBusm36VopW
jMh2KOLQee901Bay9zJNuVHsNMnAB0xMVlcYhV1GvZLaDga6xfvUc0IKo9OX
hztthND04MzCmjf2iwqkB8Zd0TrvjFEXK3Tp23sHAg0p9AjOhF77iNF7qstN
eyIWnaXkxmUeYmC8Lso92QRdT5SPNpuiX+fIS88+g6ZlW6ZyzSjcNneQcUQM
eHtEfeP0LIXEEdvHb0oY6BxuvTDE7kN6g+5oZxhYDbmr+IyL+WZr3WV7XdEa
y3PGb3iilXSKz/WjMGzKbUhbY/Ru6RNX/d2ETl7dNLv5UwbCObvb7/IpeAeV
bFPuYfTz/dxs9hM5gUbF/TwXZwoN2WnXS1wJdLkUCp23UyiulsfGrweAzu75
5Vgb9LHXhqPSrdDnepYZv41P+cVg40vsfe7ndltuNydwLE4UKTWnsO+Re4Tc
isCvhofsD1tT2D/2Q0afExrEcrPJYLR1Pifnn2Tsf9Cq1v5xisBK7Uzlj2Zo
rXXRuvRJgt5eK+vTKl0C8OoWFe+L0fyio7eOuKGDPWV+Pf+y+5o0D4ax+bXt
LnCamQgAuU9Dko0NurH5pqhnB5prPxpm4U7hvZ4t84V7CCRWH68w8qCwWlTj
s8wnkFMz0nWbzUtWvk3wnSWB3+ZOKV4SYH/ekaixBRH6w4G1jqAU9EDnW727
8ik0m2uY+iyit/8d/xoHFbryYSh/6yUChgLpX5G56Jb2MdXRHPSAxflspRxt
cCL62sNMClei8jfYqQnsHHlFF8Kak7r1ouNXRP//hPY3ampfJvB4KLBIJcF8
ffsc4y6Eo89bLEbGMOhuVYkk3J+CTvMq52s7oveXLlfm0wPR65py3i1KIKKq
S+d9kH2v1id+IoeA1cqBcTU7b/D79jG/VgL//0//A9LRaJU=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4pQSByGzN1kO86qWHDQ08HeA8TMtLzibuvs7
JNgfYTv0Osth7aG0Bm4Pfwdu7nfs054i+Lf6RSZOvJ7lsLXwSFSNkL8DR/Hu
6fMPI/gX5WdVrtyFyU95xjT9+Ds/h10/3Uqe7Efwe3dmc4acQ/D3rIvfEH0r
y2FDpJ50J5c/nK9VKPv4l7MvnB/++sjTHjUEX0fb1+unlK/D+jdNB+uOIPjZ
DZcCNPdg8pk8ch89+eXjwD0nh1nqAIJfWmZkwXcbwc9w2Cup9xjBXx/NcuzX
SwQ/nzdn6gzWbDh/26KzhRlcmHyY/UVmsozCTAg+LPzR+TD/wfjC76ZWbnZG
8GHxBwClj8zO
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYiOOZ8eVs7Md5lUtOWho4O8A42daXnA2dfd3
0LucuWd9VrbD2kNpDdwe/g43503e25yC4K9Q3uVWH5btsLXwSFSNkL/DNbZE
314nBH/+Znv96ZaY/JRnTNOPv/Nz6Oh9o3nJDsGP9hXc7+iL4Hc5saZ5RmY7
bIjUk+7k8ofztQplH/9y9oXzw18fedqjhuDraPt6/ZTydaht0CjPcUbwLUUq
2MStMflMHrmPnvzycbipL7ST3R7Bd+a68fZ3JIJvdiXpvHQSgl/7fmX1iwwE
33ahoHdbC4LfYlasHtaJyYfZ73Dq0DaGRgQfFv7ofJj/YHzhd1MrNzsj+LD4
AwAMtL+i
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4l9fnXM2VOc4rFtRvvyjqI/DK56ePXcuIfHv
LH5rdx3Bl/zJVqBzF5OvUiV5tEgfwZ/tvfvRZw+Efjgfaj6MD7Mfne/itDR6
wSpfOP/FUXulmD0IvkcVu57rFV+HOY23VQJKEXw73uK77/Mw+TD9MD7MfBgf
Zv8tgUuc5eII/k2HXTdEhBH8VSrhYeq8mHyY/2F8WPjA9MP4MPNhfJj96Pxr
8anKbpu94HzDO6diuhYi+PpPjvvldXrB/Q/jw8IHnQ/TD+PDzEePfwDvDPpi

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4s6DmzqmyxY49G7u81+7O8ABxo/fafmB9RSC
b+g/96/56QCHKK63jopSCP656AvXJggUOPyfohX4bUmAw7zJzXXfmRD8RoWn
Z17/zsfgPzP/WHV1YoCD0MSAl0KMBXD+to9nCgK4EPynX3dz5wsVOCz6M3nd
/YUI/r1j3H3mG/3gfAU3jv5pzX4OTqb5z74KFjjIvTN5bFfi5/BERPbkS2YE
n0dZIunC33wMvvS8OM3TPn4O81hu64axFMD5HYcOLTkviOBvjzb3YpZA8J99
Wf3eTA7Bv7BpctoGbQT/xdKkZDlDTD7M/q5FgadldBB8nab/awXkEHxY+K/O
yaw3bELwG7ncJ2RtRPBh8QcAf2fTGw==
    "]], 
   RasterBox[{{0}}, {{235.028, 56.14770000000001}, {279.908, 
    56.627700000000004`}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQffrpV7GlWbkORXuWiysGejjoC9Xv3L0Xkx8kPyk7
5Jk7nM9RoVsjscvdIbbM7pMokH+wIf9J9xp3h64Lye9/LEXwi176pRXNx+Tv
M5ipJdHq7iC2eN1W+zUI/i4j5g+P9iD4Bh2L2cJOIfhL7zrLnryO4O8L+nhr
xwsEP4knUKvtKyYfZr+Xqs3C/+8Q/PL6xHmPriP4Sx8rXLe5jvAfjA/zP4wP
C58Vva9KKr5h8peUSR1JKveAq0fne0nsmRd3zAvOX7mF/3DFAwS/mklcyu6F
l8OrZZZyGpcQfEnlXLvA8wj+5YWXP8edQ/DLmBOmXzmd63A9jSNn8w0vB1j8
wuxHj28AQa7pbg==
     "], {{238.02879199999998`, 48.9327016}, {235.6050684875,
      48.9327016}, {238.02879199999998`, 52.7185048}, {238.02879199999998`, 
     48.9327016}}}], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYCYpP3TZcuTs5zeNGcmqMxxctBdtGBj7On5Tm8
um0h0bAYwTfwtjYVX4bge3osyf1z0MvhRaXaq8XeCH4k83v7qaoIfkf6uor3
KnkOSazrHkac8XI4y7Bn1QblPIcDkm7dtbe9HIQeqU6+J43gP/666n6fYJ7D
x4zHHVfvezrME3H8niCJ4D+ZessxWCrPoW7+7rzoL54OZz0kEmVl8xzmxDh9
ueXi5dA+cWevpGKew9wtoguMQoD8StdlXkD78plkv3+P9nLoLPTYkmaN4Ot2
VyzMt0fwPf88fVdXj+BX1H07IV2T5/DotItgkbuXw6tCzR/7k4H+uWX+/ftu
Twe3Mq81P2PyHMquK8vtmujp8Px171YrxzyHAK6VE3WeejgUFe13FjTPc/gt
9e6ErTGCL8/rI7x7gzucn6JS3fJrMYJfdnLy/5QsdweXiqwnma4IvnidaOuh
YEw+TD+MDzMfxr+31eq96CcEv/3nJ6YcCw+EeUcUpTXqPRx6vH8pOITlOXzY
ulG5/oiHg9umN+/qwvMcFC98yf3zEMhvYlF4GJ3nsE3P1Ck+wNPBYO/fnQsy
8xw87p7bJ7TA0wE9PQEAAk0Tng==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQfd74m6q1cL6D7do3Z/QkPB1g/MBJKTxKHzzg/PSS
QLu80+4OWj7n7B0+5zlUSmbtvDHR3eF0aLt53EMEP2zZZxvlOwj+7Oe6h3tO
I/gn5zOrWR/Oc1h9+U6q1A53h023/uz/dQHBV1/xMLricp5Dw8t/v2PvIPjf
XnW8qPmI4OfqFM1UkfBwOGlv3PEfaL4Dk2n2fS0Ph5BFZrvljyL42ey5zSoH
EPymOd1Sx7flOdhXVX54KY/gNwq+uiH+wR3OX/nZ1/7sXHeHB/N6pk04nufg
Hv+dZ3q2u8MWBUu77w8R/AXWB/8xc+XD+aX2Pulv9PMd5kzj6/kk5gHnq794
mvZO1RPOj5r60oa/0suh89eOiVu58x1YDUv/7Dnn5bC1a7H4qvd5cH5YX31o
yD0EPydV9uX7c3kO5UKC/1h3eDmo5sUHJh/Mc4j27W1bVO/lcNwx+ED+ljyH
OS7neHjcvRy+vs1bb7Y2z+GrQ+leOyEE/63H17n/N3vC+Scu++49Kebp0HyN
V/XOiTyHih6bqGWzPRzy1aPzfr1G8AtClVk1/iP4f+8LijLx5Dvc4pBfynsB
kV5g6QkA5DkWKA==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQ/ZjtuvnlN3kOPkz6farbPRwEZ9fZn36O4Od+3iob
eRPBt2OM2zD1fJ7DDM0gtmI2T4fZP498eH4yz6H1T62AsCmCv6hy6UXOEgT/
bUJm67mNCP6niqi6A18R/O8fpEXfGXg5tDR9/9V+Ic/hyWF3+b54LwcB23M3
/9/Ic2B0zH/QMs/LwUF8U/yXJ3kOBq+zpt9e5+WgWfBn1rf3CP62F8G1pf8Q
/O1lbzbe48h3iJFdup2lxcvh7/G5usZ8+Q5zRJ7Z5nl7OYieZY74I5jvkF30
vOK3kpfDeeNvqtbC+Q5y3kcY1l32hPP71iysfDoTwc/7Lv7M09DTIeoAS14r
0HxY+KCHJwBjfqkH
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKP0q8v/c5vP5Dhvbuu9MlvR0gPEZ9ql6nanzdNjN
u8Xnx9l8h9UbW7ZefOzp0K0uFixzON9Bfbb4GRdHL4dFn34WXdiS77C3UVh6
7i4vB5FPz0RjZuc7sBqW/tlzzsvhifJeZv8+BP/xe/HNa6sRfLtFTqXMqfkO
TDOdeu6s9XLI7mJY7h8BNP/388wGCy+HmSG55pF++Q6pTk0zrB56OmRxKD07
64NwH4wPcz+Mn8I+dce7XR5w/l+t1H0anh4O3ycJfFseme9gfel8l9xLd4fQ
nfZn1dPzHfZ58Ao9b3J3mOsVwMtal+/wateybzMy3R3mLVLeGdOL4G8Xv1jm
Mw/Bd9WqZpTZlu/Qf69AXrLF3UHcjDnmBTB8Nr4+G8fzxx0efkVLjA2Cgj3g
4XtDY0Ldga0IPsz9BXYpDUzA8NpnMFNLotXdYav/NvNzjQh+WLzPy/j8fIf3
Rhm9x5a4O8zWcHq1LzPf4dFVjVuvZT0cHt48zOyflu8QWx+jcy0TwU9vD3Zk
uIfg54a/aG7V8ITzL85+yptdieBX+z/d8vyMp0Po8hXzz2TkOyivFtzAI+jl
0HKYW2lXXr7DEpVbLjXLvRy2yp/LMGjLd3htzHPk+iYvuPth/Pla942DZiD4
/5iuzvq4Jt8hTnTFUYU5Xg668hay9zflO2zQdPP5L+flUNwR28AEDM+DceIm
zjc84fz/rE0MlhUIPsz9ML78jY/xD056wPmXfmjN+1/s4bDT8v7MSUDz87bo
ikgpezi4tOQ9fbw232FV8tRLn1e5O5yL2zaXbw4ifNHDHwBfhmqJ
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKP38yaucXvMCh41t3XcmS3o6wPgM+1S9ztR5Opy3
cz1y3KzAYfXGlq0XH3s67PAuOx5pWOCgPlv8jIujl4OzYcZ1Y60Ch72NwtJz
d3k5/Nlwb0WlbIEDq2Hpnz3nvByenDwp/1kMwX+sX16+iBfBF+zsifBlKnBg
munUc2etl4P/r2uPnn3Pd1D//TyzwcLLofaIc/GHt/kOqU5NM6weejr4VfxQ
TH2TD3cfjA9zP4yfwj51x7tdHnD+X63UfRqeHg63mZ4b2v/Md7C+dL5L7qW7
w1yR7pZ45gKHfR68Qs+b3B0cYiernOMrcHi1a9m3GZnuDo6ctb8qxRD8s4eD
b36UQ/BFzq6YdxPo//57BfKSLe4O/y69Ob0fGD4bX5+N4/njDg+/oiXGBkHB
HvDwvaExoe7AVgQf5n6tcNl7Z4D27TOYqSXR6u5wJv7Yzk0CCP7c9ImTqtkL
HN4bZfQeWwJ0rw+P8GqWAodHVzVuvZb1cHikclb+MzA8Y+tjdK5lIvjp7cGO
DPcQ/NzwF82tGp5w/sXZT3mzKxH8av+nW56f8XSY273/rSHQfOXVght4BL0c
tkh+XKcBtH+Jyi2XmuVeDmfcgy49FipweG3Mc+T6Ji+4+2F8p7O3tn+RRvAL
d4Zmu6gVOMSJrjiqMMfLocO9Xcdas8Bhg6abz385LwedP5L3zgDD82CcuInz
DU84/z9rE4NlBYIPcz+ML3/jY/yDkx5w/qUfWvP+F3s4nLty65UI0Py8Lboi
UsoeDiJViybsBdq/Knnqpc+r3B0i04+9uSSLCF/08AcAQZ1vcA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4tULFr26nlvgsOdn+ILl670cYPwk1nUPI84g
+KyGpX/2nPNyqHl5Z3FiFoL/weqAxcWEAoeFe/oXWzZ5ORwoKn5gHozgJ+Un
eZj5YfLzmWS/f4/2cjApcPAODkTwb1zYc2lCFILPfnV17vqkAodn3UlxPDUI
fmOkW3/LS3c4//ANpwmPd7s7pIjEe5gB+Qcb8p90r3F3YPvCo60VguCv+PB7
koY/Jn+fwUwtiVZ3hwOPT/VPC0HwVy3cxCaQhODftFJf45yB4HNcmR1Ynofg
f5rYfOJDNYLP1Rp0NK4Rkw+zf02jo25sDYLvl/iePzAPwYeFv9//xQ11uxB8
lbmNE7e/RPBh8QcAenra+w==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQnRcTlaG0pMAhp/1CkLKKpwOMr7mBYVmOE4Ivum7R
rNxGLwfhc7GMzdsLHAxeZ02/vc7L4c/x57sa9yP42n/2qdgdRvB1tiTlXTxZ
4ND7vttbdIWXwzOmhyGOZwscFu7pX2zZ5OXgfF3S6u4pBN9pUcpZ5iOYfPuC
qeoFngh+03LToiQlL4fCa9bmB44XOPD0mc8r4Qfap7pL1uA0gr/g07yda88i
+KIr+PNiLhU48Ip9lsiSQvBP1zUZ2Hgh+G4OWllfJ3s5dN5emNgJNI/VsPTP
nnNA/zeoTFy0D8GPeNpTdGgVgj8nbP3xk1MLHDbO7L2vqoPgf7d9tX66qCec
z8nw8hvvUXeHM9mqJdwrChzc47/zTM92dxAO15yxYRuCr33s52ydEwh+9P+5
i1WuA/1zgtms5yGC7yGkWfS2zQPOz82PyQ5R83SIklBarg0M/yvMBuvXzvN0
mPdI/cih7Uj867U5wmsR/C1H60+7Li9wEHE++7o5HhH/sPQBACvF+Ug=
     
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQHfmkJqxrW4FDpWTWzhsT3R3y6yuWL1iD4LclHpj0
enmBw9GCUoYjd9wdHB6oefxcVuAww83iUt17d4e8mKgMpSUFDhHmzSluWh5w
/pUbO4/49CH4+zc/OnBhCYL/7akYiwObp4PDiU0JWisLHBj6bKv1mj0dnnzK
jA/bjuCf1ZgWfWsngj+/pipH+CCCv71UTfnr0QKHvOP64mtMPR06f35iOnOi
wOF4dZVgETuCL/8h1X39cQ84f+/l4FnNXQi+ju/SX51+CH5o+Bfbn/weDs8C
pI4qHitwUH56113lsbtDxympgDSg/SZe0/+xznB3cOJ7f09tFyK80MMTAK8y
oqA=
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKO1r3un4Qa3QYWNb953Jkp4OMD7DPlWvM3WeDmYT
H8/QAvJXb2zZevGxp4PcPJE5exQKHdRni59xcfRyWNnMtmaaZKHD3kZh6bm7
vBySmGtr7/AUOrAalv7Zc87LwVsm40soG4Lv1STqw/q3AM4vv62lu+FjgQPT
TKeeO2u9HPrOc7qFvS5wUP/9PLPBwsthqYkDX/SzAodUp6YZVg89Hfr6ZqVO
fVoAdx+MD3M/jJ/CPnXHu10ecP5frdR9Gp4eDlcuT8xlelPgYH3pfJfcS3cH
5nTNyEOfChz2efAKPW9yd1i+3vCnwb8Ch1e7ln2bkenusCJa+vwd1kI430Ts
09oQPgS/Wt692Eaq0KH/XoG8ZIu7Q4pq9wIlRWB4vj4bx/PHHR5+RUuMDYKC
PeDhe0NjQt2BrQg+zP0TVu7epA8Mr30GM7UkWt0djDel9IkyIPjMu/TT730r
cHhvlNF7bIm7w7J5q57zfilweHRV49ZrWQ8Hz/LsL6FA/8TWx+hcy0Tw09uD
HRnuIfi54S+aWzU84fyLs5/yZlci+NX+T7c8P+PpwHwv9tCUzwUOyqsFN/AI
ejlI5/Q3dwPtX6Jyy6VmuZeD8awPy9yYCh1eG/Mcub7JC+5+GH+FfGVPODeC
f537i/1y0UKHONEVRxXmeDm8n6nKOE+i0GGDppvPfzkvh0l+OzbpA8PzYJy4
ifMNTzj/P2sTg2UFgg9zP4wvf+Nj/IOTHnD+pR9a8/4XeziYqlfuLwean7dF
V0RK2cOh6oxDqoJYocOq5KmXPq9ydziwM+WgKS8ifNHDHwA6qGJy
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKN1+5NGd3WWFDhvbuu9MlvR0gPEZ9ql6nanzdCiQ
szX5VlrosHpjy9aLjz0dIrTzzDsKCh3UZ4ufcXH0cngskOCelFnosLdRWHru
Li+HOROuSayIKXRgNSz9s+ecl0PryoP9imEIfgt//vMLPgj+xoyWE9WOhQ5M
M5167qz1cjgRk/xQ0Rpo/u/nmQ0WXg73D85cqWZW6JDq1DTD6qGnwwnpLwyJ
pgj3wfgw98P4KexTd7zb5QHn/9VK3afh6eHAl/ia4xzQfOtL57vkXro72H5p
+tLrVOiwz4NX6HmTu8NDm+4pf3wLHV7tWvZtRqa7w6MXJVkrQhH8vMXengpx
CP7WNQv4OLIKHfrvFchLtrg7zNv0xPodMHw2vj4bx/PHHR5+RUuMDYKCPeDh
e0NjQt2BrQg+zP2nzET9fgPt22cwU0ui1d0h136f5kN/BN/WvZNplVuhw3uj
jN5jS9wdHmizNN90LnR4dFXj1mtZD4dmlqP9ikD/xNbH6FzLRPDT24MdGe4h
+LnhL5pbNTzh/Iuzn/JmVyL41f5Ptzw/4+lgm709NgFovvJqwQ08gl4OoT9f
yIUD7V+icsulZrmXQ666l5NQUKHDa2OeI9c3ecHdD+M/WnNJXTkawRec6Xu7
KLXQIU50xVGFOV4Omur1czIzCh02aLr5/JfzcjhzW9DvNzA9HYwTN3G+4Qnn
/2dtYrCsQPBh7ofx5W98jH9w0gPOv/RDa97/Yg+H/C2XopyB5udt0RWRUvZw
2BI5i+EN0P5VyVMvfV7l7vDLbV8MYywifNHDHwDQoWaW
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4nM7VZvf3i10SM+MjfzB5+Pg9OzUgrzHhQ6H
et8/e/LW22G7UMG+9y8KHbxk5NLnn/Z2KPKs2jvhXaED09+STxGrvB1Eq+Um
ZXwodNj91qn47zwgP/bsB9XPhQ4v/nPvKu7zdlj44rSMxRcE/1+PjLHZNwRf
bIlkd9SPQodX4fdTT89F8K941XjKbULwPY947Xbf4+2gezO95eD3QgeWtdJe
HCeB9h3K0pn7tdBhxYS2df8vejs8vfZ/Suv9Qod7Vv/LKjV8HJ5npqZrAeVF
npbbf64D8m/tEesE2r/gcE2lYosP3PzzZz3Obe5G8HceeLqRbQGCv2Rz09TI
LT5w9y/lDnPceNgH7j8Yf4eslNj8z0jy5SW5Nz8B/VP6ybj+kI+DjuIRK72P
hQ5xf5QPhe7wcYCFfwjPwim/HH3g7lc4+7cqi9fXYb7nmmurgfxPu0xMvsj6
wuUbJ9rU2FkD5Yu3v756G8Ev2GBuWHETie+617r3eqHDusWsh7doIfi3t57j
1JZC8P3MZ+Va8Pg6/NmnYuVyC+GeX9MsY7uOAeNHqXXTh20+DppdC5+1HkH4
B8aH+VdjWnRU7mEE/5FCTXPSQSS+xYcsw/2I8ITxYeEN48Pi49el2/P5gfr/
1juWv2v2cXgscoi/+hAiPrcdC2urv1HosP5CUstqTYR8ldqr3YaXveH637k/
bWQ+5w03f5+tpG7hMQQflt5gfFh6hLkfll5h/oPx206GHOQ5guDPzf+VeQnI
3zU1//jSfm94+Onz21men+kND1/L/wfStAR84OH/KD7ercfeG85vef3tn7Yl
gp/dt1eDW83bQUv5SdE8YPzyVqnWPxMDpncG7lXrbyP4sPSCzp8doHvcwASR
P+yvHO994+rtgJ7/ARDX+Gg=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtM01cUB/ACkxEzNskEbVwmbBgcDykvSa2U01kEen9YwjNqkbaOjU2w
7AKDgMjLsVEBUYwkIEQoAjGFKXYEZlGUzSgCxQiCDnC48NRGHkNhKO73V4/Z
H+ePT3K/N/fek3MdlKqwOAsOh2PGVhRb5mwVF44tRsooON9aKDJXMRBbyxsT
xVCg45VmwaUMBPXUfj0mp7BT0ugstAwBj23Gmr+OoIPvnZHUJ6Dl/cspqiS0
QtvNbU+m4LMwcHzyJQPykZbpKBWFjJsN/PY5Bkr+HJjgs/nB3j+ePLyPPuT6
wenFq2jZew46/gUGnptvfDSfSGHPkEHb+jMD11/5xjtRdPre1n3lqWjFeHbB
mQwK0855dQPV6I7Lz3qF/Wht1w/nv9kQAh05Fm8jvqewvrPiUIdDCKS5h+Vz
EtAlojy/GSW6OMsx5yj7XuvSb55ze8qAWeb8bOFBCh7mBmXzbQZ4Fk+OV0RT
eDzROnzHNgQ0QVYXPpNiPqXqdU+ZBC1e5Nj57ULbpo/aMB4U+gKKw6/nMCb/
3e29lKpAn6je/lVeBANtrkldo57omowNDTwv9MFx81SVN3qtRloxzfqetUsu
N5qBqRcvsgQ+FI4+clgTKRlwE9WsnGLPQwzSnqVJBgLWLiU+F2N/i6SyGZCg
NaPFl3xD0JvXe91pC6MwvG57S+YqY/K1flnD/K9ouvLRzKYSBlIVB9QfhlLY
LS23r/ZlTPuLvW39SD4BDZdn1AdSaPkxs7Pci8AOo9og+JLCucZ8RdwbCQRM
7a2NFKDfxjVFH96FttstMNzeibaVf+ucxb7P6E+9Np9bE1izNA7G+lIQvPbZ
n/8xgfbII3oDm/cb+T273w0Nsnyrp6HojWpuwT8U81M3tEuzxwiItbpMK593
HHvSSc5DT0o7t6S5svP3y1xhkgwtPBt/97A3OpSfK+77lz3vUFWZlO3XLc/T
bpPjElCnVMjdBWiNR93AyQB0THzzA1dCIbHvE2OZLwHOF6vLF1mvnG3yXxQS
KHLZUaJm+5VbaR/QZkPgWne20SMc88WWc3bnZWgLoX9RTwLas11Z2sHOW7u1
jrl8gpgc2BPY5FKHvrgcLtx6hUBw2jH7sBR0fav76nAy2nO09FkyfWf9qbn3
HVjrY9SWjloCclGoYx87n9yMrbWuGmL6f8LvX9U1byEQ1Dm98FKB/Z3VDx1Y
kqE3x/AfDkSh3Z2sH4dGUHil+5Rb70hMruLpjVn70G90lc53vyOQ2ljvuCeS
ve+Sf9x4AYEHholNq+x+g791jYhvEPj/f/ofCXJpFw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYr7d7yX2LStymFe15KChgb8DjJ9pecHZ1N3f
oXuBoXALkL/2UFoDt4e/Q2LbMeG8xQj+yRORN7LnFDlsLTwSVSPk75BgtfZ2
0SQE/8iEOWe+92LyU54xTT/+zs9hx99PnlMnIPiLYltFzk5H8K0i/j+/MLfI
YUOknnQnlz+cr1Uo+/iXsy+cH/76yNMeNQRfR9vX66eUr4Px9wkFjyYh+IIH
LXZs78PkM3nkPnryy8fh4blWwQ0TEHyxPS+0teYh+PyK62SsFiH4m9ddLFqw
FMGf3N4alb8ZwTcL2uZxfSsmH2a/iEzchDUbEXxY+KPzYf6D8YXfTa3c7Izg
w+IPAJIh2ck=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4u9hB3/r/Cxy6LzAYdY219dhl3aEmetXBF/A
gT3zw5cih3Nm5stud/o6tOwO8Dn3ucihb206x/8QXwdfb8+k8E9FDru8yq8L
+vg6lEa+PFj8scih8dwS34Vuvg5tjC+aT75A8L+6b402fo7gX/+1v6zxEoL/
/Kgaa8S9Igf5+RPm8s8E6n94YLvHoyKHv4ZrfR9v9HXI5rlexvOyyGGLfUDe
9Nu+Dg8/yMelAe07dkjA8im/nwPMP/qLI/JuuiH4D9xN34jPRvBf5DAurGXz
d1ibs8c9422Rw9pDaQ3cHv4O2v57HfXuI/jr0qzcMy4i+Jnm0/NEThQ5iO9c
vpr9jx+cv9je5POG1Qh+fWDTP756P4eZnoUP55wpcljw8KzUnio/B71S3bUr
ziL42p2dN/UvIPifNh1+bXO5yEEuwOxpXReCr8f4Y/mV1Qh+za5dyRP3+MHD
b4+CkunbO34O1n17/rOfRfAdeQSdy4Hmp93OzHYQ83dYcj865f/1Iofm+20S
39X9HbROXi80vIvg73nNOc/5BYKfd3tKHcu7IocZD+3vnnjkB+eHthWaf5mF
4N9ad4F9va8fPH7ruh4fmC7g5/CjIO342sfA8M84zrv8g6/DpNMy83RPFjn8
OCbAUCPrCw+vz+uqDnSIIvgPbnVO2iGM4DN55D568svHYX/CFcedXxF89PQL
AClQXj8=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYiP/dZoTcood1q0oX/5R1MdhVdSlQLUZSHyn
uKzwWQj+oQv92n5zMfkqVZJHi/QR/Nneux999kDoh/Oh5sP4MPvR+S5OS6MX
rPKF818ctVeK2YPge1Sx67le8XVgFv3FmpCJ4F+95fpIPw2TD9MP48PMh/Fh
9i+KKa0otkLil7yMd7JA8LufbZ/nbYrJh/kfxoeFD0w/nA81H8aH2Y/Ovxaf
quy22QvON7xzKqZrIYKv/+S4X16nF9z/MD4sfND5MP0wPsx89PgHAIz+8XU=

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4tMrXvxbUFLq0Lu5z3/t7gAHGD9+p+UH1lMI
vqH/3L/mpwMc5nxU2qFViOALOLP5zkovdfg/RSvw25IAhwdVO78wRCH4TeUr
Yv6HYPKfmX+sujoxwCGkoi1eJgLB/3GD6XlkIoKvfvdjY0VmqcOiP5PX3V+I
4N87xt1nvtEPzldw4+if1uzn0CKzNOZ/RqmD3DuTx3Ylfg5qf4LsP0ch+Cd+
OC7/GIrJl54Xp3nax8/hwWuBJfHRCP6plT+kbmYg+D+dcg/w5CP4GncepjqU
IvhCs07e2dmE4Gv1zrip3oHJh9l/prPdUa0Zwc/LNFWRKkXwYeG/Oiez3rAJ
wW/kcp+QtRHBh8UfAD/k3xE=
    "]], 
   RasterBox[{{0}}, {{317.94800000000004`, 56.14770000000001}, {
    367.86800000000005`, 56.627700000000004`}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQvd+GU1D0S7FDTvuFIGUVTwcYX3MDw7IcJwRfdN2i
WbmNXg4p63hWlbKXOBi8zpp+e52Xg++Kackl/Ah+zZ3cswbCCH7tFEHxI5Il
Dr3vu71FV3g5mD/u/2ssW+KwcE//YssmL4cp2088Oi+F4E9uEi77JozJty+Y
ql7gieA3LTctSlLycji07dX9TeIlDjx95vNK+IH2sWYeU5JG8D9e8k1aIIvg
p3XsE/NXKnHgFfsskSWF4J+uazKw8ULw3Ry0sr5O9nK4tTuAqwZoHqth6Z89
54D+T7hsOZUPwV951Fp6669iOP+tWVzBnqfFDhtn9t5X1UHwv9u+Wj9d1BPO
52R4+Y33qLuDrM8VmX/fix3c47/zTM92d0gxv+GwmK0Ezq9ZtsJFXgLBX3Pf
x0dcHeifE8xmPQ8RfA8hzaK3bR5wfm5+THaImqfD6h8X/OWA4X+F2WD92nme
Du8PXcvZyo7E364jyva3GM5nXaZXYgF0j4jz2dfN8Yj4h6UPAAN37Js=
     
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQveqI9v8athKHSsmsnTcmujsciFcPmPynGM6/7phv
fe97scPRglKGI3fcHSYeuPrh9bdihxluFpfq3rs77LfhFBT9UuwQYd6c4qbl
AedfubHziE8fgr9/86MDF5Yg+N+eirE4sHk6TFyRyCn7s9iBoc+2Wq/Z08H0
sgSHJ3sJnC/H6cpylhPB/xCjKcomiOBzhF09/Vy0xCHvuL74GlNPh1s3F67e
J1HicLy6SrCIHcGX/5Dqvv64B5y/93LwrOYuBF/Hd+mvTj8EPzT8i+1Pfg8H
M8OTuSJiJQ7KT++6qzx2d7i56uSPCKD9Jl7T/7HOcHeY/G5uuyQXIvzQwxMA
T+qbbA==
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4vP+Z656lZY4xBzf8cgp2cPh7/WdmdGFCP4z
Q5GDUwtKHDpOcpmcs/FwKLzadqUsv8SB3+PQvrksHg7OndbNr3NLHIKX+z7z
/Oju4Dz167dLOSUO93TrSxSeuzto3XjdVJaE4Bd05s5hi0fw8+xSGs45Ifjz
UgujsoNLHEq2rFK1zQS6RzhmzYPsEoeN8/4fThL3dIC5N+qX9v72aAT/ZvVH
19s3EfxIW7GJ2zO9HJ5OPyjhml7iwGpY+mfPOS8HIde3yi4hCP7m09vtVjgh
+HYPJ8oqmJc4zAtxZfoeg+CvsXQwOP7OE8438tigXrDS0+FR8NJLO+wQfIE1
q6Zr2yP4YdJrtxxyRPA1WMQvCLiXOCyfOO3U7+0I/uF5ZT9Ov0Twvyxwja7i
9HLQUMooDHYpcWiKv7n7q4aXQ5jlv1BWewRfwDr4xRlbBH9O6K+UBiR+7t8v
83mB/I0nS9cdVvdyeLRP/sRiB2D4TX1pw1/p5SDooNDG4VniwPhwnpPncmD4
xCZyCwch+NvaJbjsExD8P56Kpp/SShweCS88fs8BwZ/8pcqxFBj+ML7r3geX
bUo8HbT+SN7TAcZ3dvzT0kwBTwdHjtx7C8NKHHy7XnFIH/JwmM1xUeCGRYmD
nzuD+evN7vDwPXji9KwfSxH86siTtYmLEfx9BjO1JFrdHaLEc10eFSD46OkZ
AJwsQ4k=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4oPt24vFjpY4xBzf8cgp2cPhPf9SdvWDCP6N
zP9xiQdKHDpOcpmcs/FwSOYtKnLaX+LA73Fo31wWDwfTg2qK2/eWOAQv933m
+dHdwfTsgynz9pQ43NOtL1F47u4gI3BdwWkTgp90MMLq0joEP6HMX27WJAR/
wtyYH2aLSxxKtqxStc0Eusfb3WvN7hKHjfP+H04S93SAuTfql/b+9mgE/2b1
R9fbNxH8SFuxidszvRyun1+zTWB7iQOrYemfPee8HFhqbxzkX4LgL2VefKd4
EoJvIFm7+3VbicO8EFem7zEI/hpLB4Pj7zzhfCOPDeoFKz0drnRPKGjpQ/CZ
nkw1/Y7E9wieEdQ3EcGXsmHKuzOtxGH5xGmnfm9H8A/PK/tx+iWC/2WBa3QV
p5eDVFQwv/yUEoem+Ju7v2p4OXgUvvx8oQ/BZyq2a5vRi+D39T5l8kHix5s+
sL3ZAwy/k6XrDqt7OVz5xpWWPwEYflNf2vBXejkwV3CrXJlR4sD4cJ6T53Jg
+Ez1WXlvIYK/Yj/zCq4NCP67Rp7Le7eVODwSXnj8ngOCP/lLlWMpMPxhfNe9
Dy7blHg6yJiw1vwAxnd2/NPSTAFPB2OHiJrcZSUOvl2vOKQPeTj0OuxZt7ij
xMHPncH89WZ3ePgePHF61o+lCH515MnaxMUI/j6DmVoSre4OPv4Rj9YeQPDR
0zMAW2VRpA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4icHC0ssJEodXjSn5mhM8XKImC3QMley1OHV
bQuJhsUIvoG3tan4MgTf02NJ7p+DXg527c4Nil9K4Pzvp9W1pR4i+Hx17e7H
H5Q4JLGuexhxxstho1ffA3Ug/4CkW3ftbS+HYOvDV+zuIPg2R1l/i10vcfiY
8bjj6n1Ph5lXLrAx3EbwbabK6lQC+XXzd+dFf/F02JC3x/oeUP+cGKcvt1yA
9gnzBt25V+Iwd4voAqMQIJ89+N6X+yUO+Uyy379HeznwN4c8ZXqD4D/ofxPN
/g7Bz/dYzMTPVwrnt3Wuzo/lKXV4dNpFsMjdy8Ge2bVdn6HUIemW+ffvuz0d
cltDE8/8KXEou64st2uip4Odw/enb4DmBXCtnKjz1MOhmVlA98bLEoffUu9O
2Boj+PK8PsK7N7jD+Skq1S2/FiP4ZScn/0/JcnfIaUutZfmI4Idx7j5r8AOT
D9MP48PMh/HvbbV6L/oJwW//+Ykpx8IDYd4RRWmNeg8HgYK1s/N/ljh82LpR
uf6Ih0Pu4mVM/L9KHBQvfMn98xDI7zaSdgD6d5ueqVN8gKfDIw39F/LMpQ4e
d8/tE1rg6YCengB9whJH
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKM2SdW2fa1qpw8a27juTJT0dYHyGfapeZ+o8Hd4e
NhBrSC11WL2xZevFx54OVy8kSgollDqozxY/4+Lo5ZCwLVjzTUSpw95GYem5
u7wcJM1O/TL0KXVgNSz9s+eclwOT/9bC1a4IPuPWpJNRNgi+Hl/FKiDbgWmm
U8+dtV4Orkzhh1drAc3//TyzwcLLISa9t3uDaqlDqlPTDKuHng6uB58/eqWC
cB+MD3M/jJ/CPnXHu10ecP5frdR9Gp4eDt1s91+Fa5c6WF863yX30t1h18yy
a+JGpQ77PHiFnje5O8Q9qitrsy11eLVr2bcZme4O8X0ZPkauCP5rD3vtVb4I
vlHQlA8TI0sd+u8VyEu2uDtIR9yQrQCGz8bXZ+N4/rjDw69oibFBULAHPHxv
aEyoO7AVwYe53/0Oh0Er0L59BjO1JFrdHV492cidbY/g73pT88TYrNThvVFG
77El7g6xF7+nJBuXOjy6qnHrtayHA8OqHYWrgeEZWx+jcy0TwU9vD3ZkuIfg
54a/aG7V8ITzL85+yptdieBX+z/d8vyMp8MugdX2r4Dho7xacAOPoJfDpXl3
GB6aljosUbnlUrPcy+HVGVuVOY6lDq+NeY5c3+QFdz+MHx90jHOtF4LfZ+e4
909IqUOc6IqjCnO8HJadKar7HF7qsEHTzee/nJeDZyOrQSswPA/GiZs43/CE
8/+zNjFYViD4MPfD+PI3PsY/OOkB51/6oTXvf7GHw5vIYzZngebnbdEVkVL2
cDD83/uoNLTUYVXy1EufV7k7lL3ZaNftgwhf9PAHAMXrYYs=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYvVboR6VW0odYo7veOSU7OEQmuR8p3MDgm+3
Z67xkfWlDh0nuUzO2Xg4nIwXcF+6rtSB3+PQvrksHg6zhY9+lVxb6hC83PeZ
50d3h9ny9ZmMa0od7unWlyg8d3doSir9umQhgn9C+Duf6TwE/9iJt5/+NCL4
397/OjNzUqlDyZZVqraZQPfMeyrHv7rUYeO8/4eTxD0dYO6N+qW9vz0awb9Z
/dH19k0EP9JWbOL2TC8HWyXv7uJlpQ6shqV/9pzzcsg6XzataDKCzx3muPFa
I4I/LVt6gl9ZqcO8EFem7zEI/hpLB4Pj7zzhfCOPDeoFKz0drO7puT6vRfAz
zEy4ouoQ/HVLzdQ/NiD4DX0LnOzbSh2WT5x26vd2BP/wvLIfp18i+F8WuEZX
cXo5NKz5+LixudShKf7m7q8aXg7rDrefMK5D8DOO3on6XYPgf7nffH0dEv9o
e52QDZC/8WTpusPqXg5WniutLtUDw2/qSxv+Si+HzFMrf5h1lDowPpzn5Lkc
GD7PX9U6TkTw+YQW1eTOR/BDrqxargAMz0fCC4/fc0DwJ3+pciwFhj+M77r3
wWWbEk+HprbFAdHA+M6Of1qaKeDpMHPSt4ALU0sdfLtecUgf8nD4PCmqma2i
1MHPncH89WZ3ePgePHF61o+lCH515MnaxMUI/j6DmVoSre4OmxZ+2yawAcFH
T88AxgdUXA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKF3R0vn1DmuZw8a27juTJT0dYHyGfapeZ+o8HRLv
PfYRB/JXb2zZevGxp4Pna5GAlf9LHdRni59xcfRyuHKBLaH5R6nD3kZh6bm7
vBx6A2oNT74udWA1LP2z55yXQ1lmxgqnpwh+6XlRhk+3EfxFGtoP51wodWCa
6dRzZ62Xw04Zrl9Op4Dm/36e2WDh5XCh0eGQ+9FSh1SnphlWDz0ddt6eJdl0
pBTuPhgf5n4YP4V96o53uzzg/L9aqfs0PD0c/itMUnwPNN/60vkuuZfuDnpb
NHnXXyx12OfBK/S8yd3h0h/DtbJ3Sx1e7Vr2bUamu8PlFdLNJ58g+PHJnxId
3yL4y3Lc1TV/ljr03yuQl2xxd+gv6g7hZwCG5+uzcTx/3OHhV7TE2CAo2AMe
vjc0JtQd2Irgw9y/+9vuNBlgeO0zmKkl0eruEPc/xYnpPoKvx24gffpqqcN7
o4zeY0vcHS6+XjX716VSh0dXNW69lvVwKDmSvcIJ6J/Y+hida5kIfnp7sCPD
PQQ/N/xFc6uGJ5x/cfZT3uxKBL/a/+mW52c8HfS048oageYrrxbcwCPo5eC2
s9+8Amj/EpVbLjXLvRzinn+IMn5Y6vDamOfI9U1ecPfD+JdzKh1cXiH4TJFf
Pk/+UuoQJ7riqMIcLwep56pbu76XOmzQdPP5L+flsHf2jjQZYHgejBM3cb7h
Cef/Z21isKxA8GHuh/Hlb3yMf3DSA86/9ENr3v9iD4eEksriFKD5eVt0RaSU
PRyWSjpK8n4tdViVPPXS51XuDq/YUkuV3iDCFz38Afnze8E=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{354.458264, 51.561904562500004`}, {
     354.0052752125, 51.856113775}, {353.96635864999996`, 52.18923955}, {
     353.96635864999996`, 52.3558024375}, {353.96635864999996`, 
     52.9535608375}, {354.6061469375, 53.3660764}, {355.30664506249997`, 
     53.3660764}, {356.02582313749997`, 53.3660764}, {356.65627144999996`, 
     52.8554911}, {356.65627144999996`, 52.150322987500005`}, {
     356.65627144999996`, 51.59148115}, {356.2717758125, 
     51.119812412499996`}, {355.6802440625, 50.7773466625}, {354.458264, 
     51.561904562500004`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQnWG97F2cXZnDn62r3Y4GeDoETfmgmehZ5uDmOsfP
qN7TQSX1WeyDgDIH1nddWr0HEPxj126cKhD2gvO7wiNvm7R7OVhpvT2s4AxU
b1j6Z885L4eMhcFufKYI/tTlSZJzVRH8j1kib0UlyxzOnYt4tb4Qwb/ze/25
N3884Xy/u94XTJ8h+P1XesLmr/V04AzSLJsjX+agu4Dt0JIiT4e0yozMEMUy
h/PdeRINyUD+ruueouplDo5nb21ncfF08E+M/vpdq8xBo0P05CY9T4faRX/e
XQaq531do8fJ5emwWrhtu69ImYOcgp+Y72EPOL/Q5M0cbTcE//CKqIOuB9wd
bjsUeMeplDm4x3/nmZ7t7rBWbznLCxME36r5QvcGNwQ/a0/J5BWhZQ5cEXsW
pV5B8HX3vundEO0B53v82tIl1+nhwDvVdMGH4DKHVW7r2V4c9HBotP/z571v
mcP0i3VR0t89HL56NN/+5FXmYANkzBb0dOARDr+f51HmEDrrHr+mnKcDevwC
AMa422c=
     "], {{354.91280945, 50.218504825}, {355.18678205, 
     50.0519419375}, {355.6491108125, 49.757732725}, {356.1192228875, 
     49.4541835375}, {356.39475215, 49.2673840375}, {356.85552425, 
     48.973174825}, {356.85552425, 48.375416425}, {356.85552425, 
     47.6500117}, {356.12077955, 47.1394264}, {355.3159850375, 47.1394264}, {
     354.47227396249997`, 47.1394264}, {353.76710585, 47.7480814375}, {
     353.76710585, 48.5606592625}, {353.76710585, 49.1303977375}, {
     354.0799950125, 49.757732725}, {354.91280945, 50.218504825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKL3E85xeydIyh41t3XcmS3o6wPgM+1S9ztR5OvQu
1mhbt6TMYfXGlq0XH3s6lG6I7HSYX+agPlv8jIujlwPDNO+ZUjPKHPY2CkvP
3eXlsFP0UFZCd5kDq2Hpnz3nvBwW6a19eLMFwV84JcqysxrBP/c2X8qkoMyB
aaZTz521Xg5PH/oZ38oEmv/7eWaDhZfDH7fW3/dSyhxSnZpmWD30dHi64H6Q
ZArCfTA+zP0wfgr71B3vdnnA+X+1UvdpeHo4aD+7FtWWVeZgfel8l9xLd4eo
yjw3t8Iyh30evELPm9wd/h0se7alpszh1a5l32Zkujv8z03Yk9CC4HdrmM++
0YPgXzLsSTgA9H//vQJ5yRZ3h93mF3qXAcNn4+uzcTx/3OHhV7TE2CAo2AMe
vjc0JtQd2Irgw9z/fDfDgs1A+/YZzNSSaHV36DqysnpmHYIfdaYkJKm0zOG9
UUbvsSXuDn83vL8ysajM4dFVjVuvZT0cFnRueHgTGJ6x9TE61zIR/PT2YEeG
ewh+bviL5lYNTzj/4uynvNmVCH61/9Mtz894OkR9WLReAmi+8mrBDTyCXg5F
dVcK+IH2L1G55VKz3Muha43plFMNZQ6vjXmOXN/kBXc/jP/fcF/l7U4EX0/O
Uld7SplDnOiKowpzvBzc1mS9U5xe5rBB083nv5yXw8uEv/M3A8PzYJy4ifMN
Tzj/P2sTg2UFgg9zP4wvf+Nj/IOTHnD+pR9a8/4Xezj0WO5b83tamUPeFl0R
KWUPh4v3WoOWAO1flTz10udV7g5iZ1au29mNCF/08AcAocaCRw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKH3vmvop+69lDhvbuu9MlvR0gPEZ9ql6nanzdDhu
0KRY9aXMYfXGlq0XH3s6rLfdrMLzvsxBfbb4GRdHLwcr5aUmz56XOextFJae
u8vL4fMiaTad22UOrIalf/ac83K4s5utdukVBP+24pYrIacRfI7qk1v/7y9z
YJrp1HNnrZeDfP6Kc0t3As3//TyzwcLLwezKvWmrtpQ5pDo1zbB66Okgr2f5
7slmhPtgfJj7YfwU9qk73u3ygPP/aqXu0/D0cEgtNvgWuKvMwfrS+S65l+4O
U9hOPBQ8WOawz4NX6HmTu4OF/4XGhjNlDq92Lfs2I9PdwfL3znCdKwj+0a0T
zJbcQfB59j/93f2izKH/XoG8ZIu7w9cjmppFwPDZ+PpsHM8fd3j4FS0xNggK
9oCH7w2NCXUHtiL4MPcrekZZ1wPt22cwU0ui1d3hSCCzeOo5BH9K5Ln3ukfL
HN4bZfQeW+LuYG7nWRB7qMzh0VWNW69lPRxuiXHVLj1Q5hBbH6NzLRPBT28P
dmS4h+Dnhr9obtXwhPMvzn7Km12J4Ff7P93y/Iynw5TaP15PgOGjvFpwA4+g
l8Mabj2e20fKHJao3HKpWe7lcMSyX3/ahTKH18Y8R65v8oK7H8a33C8uuvwm
gp+xetKJb4/LHOJEVxxVmOPl0GB5pPPtszKHDZpuPv/lvByU34VZ1wPD82Cc
uInzDU84/z9rE4NlBYIPcz+ML3/jY/yDkx5w/qUfWvP+F3s4HDsm7nEcaH7e
Fl0RKWUPB+6c+2/zn5Q5rEqeeunzKneHgEhmr9bbiPBFD38A9ld3eg==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4qipfc0x0eUO6ZmxkT/4fBzOHTReeDeh3OFQ
7/tnT956Ozi/u7EvLq3cwUtGLn3+aW+HfyqP9/7PLndg+lvyKWKVt8PCsPZJ
13PLHXa/dSr+Ow/ItzD7OKWg3OHFf+5dxX3eDrpHTGSXFyL4XRmtxkuLEfxF
9U3dJ0vLHV6F3089PRfBv+JV4ym3CcH3POK1232Pt8POLRdaDIB8lrXSXhwn
gfbNvazDAzRvxYS2df8vejsUbsqY+iWm3OGe1f+ySg0fh2LXc+kzi8odRJ6W
23+uA/K3qYr/AKpfcLimUrHFB27++bMe5zZ3I/g7DzzdyLYAwV+yuWlq5BYf
uPuXcoc5bjzsA/cfjO/ys0mMD4mvG3w31wMYHldKPxnXH/Jx2PFHx3puXrlD
3B/lQ6E7fBxg4R/Cs3DKL0cfuPsVzv6tyuL1ddBWFb0uFVvu8GmXickXWV+4
fONEmxo7a6C8v8Ibl0gE/0/3AsPnYUh8BTWbPyHlDusWsx7eooXg3956jlNb
CsH3M5+Va8Hj69Axq9dqczjCPW1Fi2J/OgPjR6l104dtPg5bU7mef3FE+AfG
h/l3S+GRqDsOCH7enyfNF+2Q+CKR2QtsEOEJ48PCG8aHxUfbOpcFdUD9f+sd
y981+zjkf9ASeGWPiE+nRfvb3oWWO6y/kNSyWhMhX6X2arfhZW+4/nfuTxuZ
z3nDzd9nK6lbeAzBh6U3GB+WHmHuh6VXmP9gfKGlew9WOyL4mt7JWY5O5Q67
puYfX9rvDQ8/fX47y/MzveHha/n/QJqWgA88/B/Fx7v12HvD+S2vv/3TtkTw
s/v2anCreTts++dTzAvUz1ulWv9MDJje7xSvkotE8GHpBZ0/O0D3uIEJIn/Y
Xzne+8bV2wE9/wMAT37Z+g==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H1Uk1UYAHA2kEjaMVM+hhhgdCQGh1TIiDYfD9COvO+EpBByWRA7GpUU
HXj9ABVHUAsMjAPkipAWEI4P55IhA+SrQD620UbA0Rl0mIyxFAHjI633rz2c
/nj++J17n+fce597r09S6gGRvZ2dHYOOODqYdLBF/IXuMQr8Ox/kM1NJsGR9
Y2wcpyBtQsrYV0iCvtr5iMBIwUtRNf48RwG02sVVRpvRhqrVKJcZ9OzlxHSj
FW3N2+XhN0dByAP9adNDEmabtph7Zik42VEd2nyfBI8mrqmGrmcY7LkzokMf
DniqaP4qWujgowytIOG4MXPsXQsF4b9r5Nc+JyHqt4qjJffQDtu8oh3n0Vb1
dC5jiYJp/3MyfTm6tdEyyNOi5V0Z3x55WgD7hB/+2/UXBetvXDzc6iMAe+cW
caoZ7bHVwo3/A81OKDh7mz6vdcc7SgInSSiIe8uyNErBDqYmqf4XEtRG/pkn
DRSMT10b7XURQJDvJxVFA5hvd0I0yOxFa4fed5U3oS/FvvZMSz0FQ5EFsW1n
SZv/vBm8mJ6Izin3Sz73BgkRTmNdZCM6MO5E9fdrfFf9QbrxClqSpbp4UEFB
P4uTzT5Iwqf98adraR8b83m8N4mEZs/1K4/p9RCa6IFFEwm6sU3HDnVif905
PeaGX9FBzQ9rq26iZVPS3u1aCkbX+SlOrZI2t2iF1XM/o9OWN5jdzpPA4HZJ
sgYpeDW61Lt8N2mrHxHswiXEBAQtllk5PRQoPjt1o3QXAdd75zW17RSU1IgT
RY+iQNfZUNmtQn+51zV+uAld6SbThCjRl8KG/Wfp87mdN7jxORYBksk3R4bo
8bB/QhLEmwiI3KFX8+h63FvdZ7SBaBCKnSZj0Jsl7NyFNMy/2y5fnMkkQJu3
NZNSrPErC9s1deg0zguepp/o99dw/4uPhWhe8dG+94LRMaHZEUMr9HoVjsVt
dP86dxYFmiaiwDXGPrFchQ5isQwrnWhzuJteSt+vj4Y8rV/vJiDfIXl5cx8F
y8V1e+Z5BLg/UXp+me5XttQ7UrWRAH7VtLVCi/nsyXg353H0V+ya/LAZdFtx
f2EA/d6aWUqyMYewmT/Ar+PI0D8uxfK8rhBgODDl3TGH3nmhbJW/xm2qZcvk
vTXzUxKcCmmr35Y4+soJmPVs9uXSZp/0qgz4gbD9P7G6q8r6LQTopa/Pi+5g
fzPK4FDyOFr2cuVIuB7dwswYb9dR8LfyWXaVL2Hzdy+qrVn70Y+UUv++FAIY
ORueVwzT+13cI5rIJeCdy/vdU+h6hutdtyLaCfj/f/ofIeCWVw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4vYsr016KhUO86qWHDQ08HeA8TMtLzibuvs7
sAT0rPmiXOGw9lBaA7eHv8MtU8W19xQQfKeKLYV3JCscthYeiaoR8ne4+ZK9
9DE/gm/r8D01gxuTn/KMafrxd34Ohmt9H7PyIfjSvA/W2ooi+JvZoxodpSsc
NkTqSXdy+cP5WoWyj385+8L54a+PPO1RQ/B1tH29fkr5OqxZ9pozWADB7yqY
HKjBg8ln8sh99OSXj0NU3YNVCnwIfn+289FZ0gh+xwWObavkEXydOB0eQWUE
n8f8wef7Bgj+ekbBR+7GmHyY/b2nd2jK6iP4sPBH58P8B+MLv5taudkZwYfF
HwCT4L23
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxd1H0s1GEcAPDDKFLXNZaI5NyknbuMFmG+6Szh9xyXt4nLu9wldOJXLS7p
3C7SvEaZl1iU0B8pozFdbbKFRhNKhURdNI7M2vX7xz3WH98/Pnvevs/3edkf
kyKI16PRaDpU8KjQpSJ3WNGbHEFCXwn92EcbBKIbskBOPPasYmH3RTEJBoym
pBPLhNauQy1eb8uxT3JFq61sApDR7fT0WBIebke8bmMCTPrf5OhHYk8wfkQV
h2ErWXFLA4iEQBG3ztKUAEPB636mLwl1wsUk5EVAgqiV4cbHloVyi0QBJOQn
Dg7qRWEXug6Mrl/Adu4w0xsvJOBlTNrNIYKE7ipebnY9ATmvsmzSfbE77/J2
Jp7AZs3XpQt5JHyV2I3alWI3m+d2OKZit92ayuNYEaDZopZ2UfmF5+RLjeb8
gT9/tnEpAvv8mL098xx2qsHe0qoMEujvNa49boTWT5PN9CtKsNkOTPX8BwJi
jSQ7ulOo/f90mHHfh6Cd65H8m6pvLb3syQsnBMKRFV0/qt0m4O91MgRB50HV
51gJCcGytCPLldiZnPzlynfYyjIrYsSUD4J7MC1KIuFxb4J0mw8fymfkcs9I
7AnOENskcFO7xiGoh6pXBk0ZWbEH+/nWfPXaMNI6lbfa3PoMac9TOZBNFz5A
sNhQsBJNYDsel57pDsC2vhI+9F1AgoujrV1nJ7ZC96qNeBi72eoQ3fQXHm/c
PPWnlsbXzr/h9TChtzeVf02P2xqbxQeLBP0iNXX/aDMLnzw4fGhyKvm2KxIb
xBYCsxjs0QPyAnOqPtWh7uo2C+yNem74vqfzUtsjBJdmVePyRBKKWBL2pBSB
R3ZmVnUc1T9R1c6MQxC44uSjiqLel3UmYwwQFEs0033U+u3+silDTwRib5cO
NpXfsIOb0tMdQWhLEFMYjD1SXGZpu8mNBXm+pUHYLEkf7/QmE9eS6jNPkXD4
juyL31HsxYbFmjUu9sZ7z+5azrkchK2Ym9SJDsH+/7/4BwIc2vI=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYo9jImsKl2k6SIct33l6goODp+m0DWaS+nC+
v6nwoch4BN/hh8sLw32Y/Inqntd9ViH4HD9ffTl7GKEfxoeZD+PD7Efnb3x/
JbdK1QnODyvONzEzR/C3qps7yPs7OeQ19JrmOiD4U6zY9mfc0sDgw/TD+DDz
YXyY/b4l31puJykj3FNSWbxDBsEP3+ju+2CvEgYf5n8YHxY+MP0wPsx8GB9m
Pzq/TUor2yHGDs63Ff5694QFgm+p/P7gBA47uP9hfFj4oPNh+mF8mPno8Q8A
/LrkeQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYkeeaa573rg7fNh8u8Lxk6sDjD9tv+GuT3xu
cL7l6x9XwgTdHE4HZfBzXUTw0+81bWtrcXe4WiZcc/mIq8OrOTJfdosj+P8a
pxivf++GwV+8Z8H5ifNcHbo7Wrymc7jD+St709uagxB85fX3YysmuztIuT0z
W7YPwd8qfCpdTscZzv8+6VhG7T8nB+5Vlcbr+90dvlp93qP63slBcvkLDz95
BF+3J6HD8bsbBv/TKxnmTcedHF6r3MjbqOQO51uKiKnV9iH4m+7uCpQ6gOBr
LY+v3f4Rwa+cNtekOdYDzjfXF5X+3IHJh9nvLdIb9SwBwY8U/JPf+gHhXlj4
N+1Uj5T4i+BHhLNmBQL9jx5/AN/N2dE=
    "]], 
   RasterBox[{{0}}, {{19.9875, 33.107800000000005`}, {74.8275, 33.5878}}, {0, 
    255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{21.58779575, 28.5221045625}, {21.1348069625, 
     28.816313775}, {21.095890400000002`, 29.14943955}, {21.095890400000002`, 
     29.3160024375}, {21.095890400000002`, 29.9137608375}, {
     21.735678687500002`, 30.3262764}, {22.4361768125, 30.3262764}, {
     23.1553548875, 30.3262764}, {23.7858032, 29.815691100000002`}, {
     23.7858032, 29.1105229875}, {23.7858032, 28.55168115}, {23.4013075625, 
     28.0800124125}, {22.8097758125, 27.7375466625}, {21.58779575, 
     28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQvfVg5wtxdnOHGi5Vi6jp1g4BAfpzrbebO/BrsnmY
fLF2KIztuaOnb+HQV/X4/8syGzhf0KfeYaOMLZw/w7ch0ZLFzuHyuh82psHm
Dr0MOxZ7TrZzWKmYkMxbZAbn17YETPlVZQrn2+3KOd++ycRBwaa+Xv+mLZxv
M03XY+V7G4R8ZKq39SEEf5H783C+QBuH3dq7Ez5ImTrcu3dLT/K2tUPfwrVT
8s1MHZS2rbp9fo+1w7SNC2fXTjJ1YLVslrpZa+2grnAneMUFU6g7rR2YjT+8
TbczdZhXcpz9Eae1wy3X9jKWNBOHg/cyr2fWWMH5aezLnqg1WcL5XB+adKPL
LBxuSGht5U03dRCO3XPk7xlzB7ZvMzxW5pvB+Tfs9HYb9pjD+VcvFppuqrZw
mOnn9mHWPAs4/57E8mMGay3hfJHJ5gd4OKwcGGPqGY0TgPZo6+yYX2nlYM/8
6qwGg4XDJsfT8WxPrBwaZkVtC7tg7vC3I34jm6S1wyfr6Z/FVpg76F7uOqVo
ZO2AHr8APoXQVg==
     "], {{22.0423412, 27.178704825}, {22.3163138, 
     27.0121419375}, {22.7786425625, 26.717932725}, {23.2487546375, 
     26.4143835375}, {23.5242839, 26.2275840375}, {23.985056, 25.933374825}, {
     23.985056, 25.335616425}, {23.985056, 24.6102117}, {23.2503113, 
     24.099626400000002`}, {22.4455167875, 24.099626400000002`}, {
     21.6018057125, 24.099626400000002`}, {20.896637600000002`, 
     24.7082814375}, {20.896637600000002`, 25.5208592625}, {
     20.896637600000002`, 26.0905977375}, {21.2095267625, 26.717932725}, {
     22.0423412, 27.178704825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4ruFYhaBU2wdQpfNaFaQs3NQ5WQxWrTK1iEi
zP72eRsE/4mJi+g/RwRfXF+s7USlnUPdcaOvD4Os4XwO4fLFOUpWcH6NSVGm
nayVg/tKzbzGPjuHlf/u/XQXtnJguRR58NQaO4fLHHq2269Ywvnhy8MWWjZZ
OqQWTNlTtdXGQW8ue9ypAwh+7PLLm2JOWDo03HXpaLtn47DU7uCatfcsHfaE
B01urbd1qGw5Ldj/z9JhH/vPVybzbB2qjmhdExewckhezD5z/1pbh+4WJ7cf
FxD8pYGH19t/RPC7bulJ7/poA+f/eb3p9YJrNg4eZuFnN7fYOvS1e6UeEgby
g21n7s+1cSheFcQ24a61Q76v6HNnSRuH8vC8gBn/rRxUNsuf0zhg5XCu+9dB
n3VWDlVXVtp4x1jC+Yd2pF50DbeA872fH958xBbBLzD8unLmKXOH5F1BxwUV
reH8Hy9Wnbk2GZMP0w/jw8yH8R25nDt/30TwJ03cvGF5miXCPHXBh/JfLB3m
hlxcfXi5tUMKl+Gns3VWDvldKdK7Nlo7HLPb3nZip5VDEZfyktNXrB0+/DbX
75tm7XDw4ZviE042DqKR2RpfTW0c0NMTADItF/c=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYlWGZ9878xwc/kysfS0XaucA47uv1Mxr7EPw
exl2LPacbOewzm3HwetBCL73pUsZIWwODsfE3350+mXrMEvxpo+wsT2cf+j1
idM/H9lh8JMXs8/cv9bW4d6PFT9PitjD+RLM+YWLViD4bIv1BdxEHRwCt01K
f/EWwW8NjDp544QFnM8ZEHx6Wq6Fw7u5J5/WCDo4sC9YU/zcz8Lhp2nhN3Mn
ezhfgSGxVO6THQafAQwsHOYYBjj987CH82U50m54CTjA+VMvcrG8cETw+Wav
128tRvBju94+C7iP4Esrp549wOWIwYfZr89xl2fLI4R7bVh9lIKLEHxY+CvM
FV1zJgvBP33jwlm7kwg+LP4A7Me0qQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4ru33dIeHXN2CF02o1lBzs6hcbntY65Lzg4R
Yfa3z9sg+E9MXET/OSL44vpibScq7RzWsV09orXMCc4v0vku/YEXwdfZ++Vf
BLeTg/tKzbzGPjsHZyXt47FsTg4slyIPnlpj5xCx/FKG6HNHOH/Wt2ezru11
dEgtmLKnaquNQ1uh/U+5uwj+3LKlyi8eODo03HXpaLtn4+DoNGeBwBtHhz3h
QZNb620dtFMVgxn/ODrsY//5ymSerYMOa+DWoyxODsmL2WfuX2vrYPI05q1p
KoJ/0Ft2UWQpgm8scPn6tFJnOP+NhKgDV4azg4dZ+NnNLbYO2549+DOLDcgP
tp25P9fGQeNHytnG104O+b6iz50lbRxWnSv61Frj5KCyWf6cxgErh6svLLQf
BDs5VF1ZaeMdYwnnH9qRetE13ALO935+ePMRWwS/wPDrypmnzB0UGJ6udepF
8LPFJxosPYbJh+mH8WHmw/iOXM6dv28i+JMmbt6wPM0SYZ664EP5L5YOtr4q
C2ZfcHJI4TL8dLbOykHtxdvr0646ORyz2952YqeVg7qG7xz5504OH36b6/dN
s3Y4L2zEIifn7CAama3x1dTGAT09AQBl9wu/
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{41.53663547000001, 28.5221045625}, {
     41.08364668250001, 28.816313775}, {41.04473012000001, 29.14943955}, {
     41.04473012000001, 29.3160024375}, {41.04473012000001, 29.9137608375}, {
     41.68451840750001, 30.3262764}, {42.38501653250001, 30.3262764}, {
     43.10419460750001, 30.3262764}, {43.73464292000001, 
     29.815691100000002`}, {43.73464292000001, 29.1105229875}, {
     43.73464292000001, 28.55168115}, {43.35014728250001, 28.0800124125}, {
     42.75861553250001, 27.7375466625}, {41.53663547000001, 
     28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQvVNtT8f/GleHGi5Vi6jp1g5s7/iSBa+6OvBrsnmY
fLF2mF6yl4lb0M2hr+rx/5dlNnC+oE+9w0YZWzh/hm9DoiWLnYPH3M9GfItd
HXoZdiz2nGznsClM3a3KCMGX6Zh/78M2Fzj/7yLdmu1BLg4KNvX1+jdt4Xyb
aboeK9/bIOQjU72tDyH4i9yfh/MF2jjsvn3lyOs2F4d7927pSd62dlgqdi5u
9RQXB6Vtq26f32PtsFLOI2nTIRcHVstmqZu11g6fQlP3HX/o4nB53Q8b02Br
h4T4/O7lM1wc5pUcZ3/Eae1w+sWu86U6Lg4H72Vez6yxgvPT2Jc9UWuyhPO5
PjTpRpdZOHgF8eT/WuPiIBy758jfM+YODw8ctvAwdIXzvVL5inr2I/gn9AzW
+5i7Ocz0c/swa54FnH9PYvkxg7WWcL7IZPMDPBxWDvc+m4n2aro53NDW2TG/
0sqh1j3nd/tPV4dNjqfj2Z5YOchNXvJ+3kNXh78d8RvZJK0drj924qs/6+qg
e7nrlKKRtQN6/AIAYRLXYg==
     "], {{41.99118092000001, 27.178704825}, {
     42.26515352000001, 27.0121419375}, {42.72748228250001, 26.717932725}, {
     43.19759435750001, 26.4143835375}, {43.47312362000001, 26.2275840375}, {
     43.93389572000001, 25.933374825}, {43.93389572000001, 25.335616425}, {
     43.93389572000001, 24.6102117}, {43.19915102000001, 
     24.099626400000002`}, {42.39435650750001, 24.099626400000002`}, {
     41.55064543250001, 24.099626400000002`}, {40.84547732000001, 
     24.7082814375}, {40.84547732000001, 25.5208592625}, {40.84547732000001, 
     26.0905977375}, {41.15836648250001, 26.717932725}, {41.99118092000001, 
     27.178704825}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4lbxWtaXKzwcbHXtC0L3WDp8j3i5JLcTwbfR
2BPv0OzhMNnwsVBOvqXDDJfA3x5VHg4L9YI0uP9bOCg//lbwLtfDQfNtRnny
DQsHJefjfFqpHg72v05PFjhi4ZAYVZnnJoTg9z5pszr+zR3Or+qxiWITRfB/
HV2q9Xamu0MOu/I3zxOWDp8tfu+cHuvh8Oz2GaOpKtYOMPdaTFbVvL8GwTeb
tsGsbaUNgi/564zdSVsHswh12d0WHg69DDsWe062c5h7sKVs8wJ3OH/ltxs+
V4QR/H+LVjpP3u7mcMA9Yv3e9bZw/h1BP+64yzZw/gs9vV/rPWwcpC1c30R8
QfD7f+aLvP+O4B8obv6znMcdzvffdem6hLm7w+WDv+yPpyL4XHd2zU4/ieDn
PIhIPMJh6+C7KvqRrqK7Q2dsg9Jud1uHfck87Hu/ucH5fYVbZv58g+C/dn1b
N/UVgl/ecijs/zM3h2eGO9nDXW0dZCZIzNjA7O5geXKByrvntg7TZsp0XHNz
d2hP4DZIcrFzmNOoukmrH8Hfe+3e8i4GDzj/wwsVBhUzDwf3Y/xWveW2cP6q
9sO6u1bYwPm8kv1BnvesHeKrXrn//O7uEBU7Y9oiMWsH4dtNXgs3uzvIbV60
h7XKyuHF3UV3g466OcjrnpNYFmsBD182g9QHBxwR/MrAhGWTbBB8BjCwcLgf
3Fy1pNUDzkdPzwDU7Tw9
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQrbxYuMTxoJfDvx/LXHTVrB1gfLXD0w4LX7OC84Pa
C9TX9Fg49LKU3A519HIov7hQtlHSwkFIO2LX2Z+ecL59LueFh08Q/MCiTy/a
FyH4HMGeJY6Nng63XNvLWNIsHDbY6d2x34HgN5Uc9DY75OnQXHh6Ufc6BD+/
5H71yRsIftz3jXcl1CwduC+z/w1a4unAuti8sc/b0sE8VvTk5Q4Ef/LHdy+f
lSD4b10z3Qr9PR2YJx/oXmyK4LcdXBjz/6oFnH+tNVMzy9DCId0/12z6JE8H
4dg9R/6eMXfYGiZ/1fAPgp92yP56yhwvOH/HxexKNhNvh92nXx3aomwJ51/K
m1mxxtEazrc8uUDl3XNbB859csrai70cehl2LPacbOew698Jq79GCL4Dr6XR
sreecP6MzA0NIhs8HYoOv192O9XOoaZnh+KjSk8HK8sX20W+2jow326/K+zm
6bBHPevI82Zbh93d32bqa3o65CnsUPWVQvDjDHY8OxdrA+eLumWqJitbO3zW
LSo4Ot3ToXS7W7yMrpXDosLlU+1UvOD8FZonPnwpQPBvBzcZxC7xcrDYwP31
1VREeoGlJwDAnAXx
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQXfx+2u6F6l4OMou1j0ulWDnoOJjeahRG8GcvFAre
edMTzr93Y9Pc1Zs8HbZ+LNy+lcnaIWCX3/wvsz0d+qafPP01HsE/PlHC7/Fd
BD8uYcHWnEgbOD9zQtPygIcIfnED69XV4bYOX+9KnCjZ5ungoxb78vUWWwf1
E8XOITc8HVoV1mTfNLJzeGrAHK3G4eXwtGTxzbZgO4eeKToe+iYI/v6yrota
eQj+oXVvFp+f7uVgfVNc6uZfW4c7nzdOUlzr5bD3+Ey1NT22DlYcXjZue7wc
IpvnzDlmbeugvFi4xPGgl8MBk7A12nNt4Pz53wXmzdJE8ON7/5YlR1g7+F31
nZI1DRFe6OEJAPGgnoo=
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4g6+mWVRz3wc/kysfS0XaucA47uv1Mxr7EPw
exl2LPacbOcgFJrtsOIUgr/uQetzlTofh2Pibz86/bJ1MJwvrxoliOC7tkxP
8X3pjcFPXsw+c/9aW4dLXe3Vpkw+cP6H/qztij4IftbGR31ivT4Ogdsmpb94
i+C3BkadvHHCAs7nDAg+PS3XwiFoTU2Kb6ePA/uCNcXP/SwcEla+rnwjgeCX
9CXvvP/BG4PPAAYWDkbqt+f7y/jA+Q1ikuHSHQj+z/t7m3bsRPALVyatC32N
4B+YsSBVMdwXzq8zlPCZ2ITJh9k/SWxCd0sUgr9A+P8C5VcI98LCX2Gu6Joz
WQj+6RsXztqdRPBh8QcAWGS7Zg==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4lrHX3f+CwY42OraF4TusXQwTdqg48SE4G+Y
bCwS/s/fYbLhY6GcfEsHng0n1sd/9XdYqBekwf3fwmG6X54q60t/B823GeXJ
Nywcpq2zO+zwwN/B/tfpyQJHLByuHv2gFNuL4DMG/Ht3txDBf/d9M5/sBD84
P89Q9j6zqL9DDrvyN88Tlg7pS4ry1t3wd3h2+4zRVBVrB5h7LSarat5fg+Cb
Tdtg1rbSBsGX/HXG7qStw6rD8y5e3Ozv0MuwY7HnZDsHQd0/WqekEXzZpADG
131+cH4Rn+KPlUZ+DgfcI9bvXW8L598R9OOOu2wD57/Q0/u13sPGoX/xngX5
+Qg+c+rzE6zFCL7J/V8b9rUj+IdVvXr0N/k5XD74y/54KoLPdWfX7PSTCH7O
g4jEIxy2DgdFL09zmePn0BnboLTb3dbB6Hzz7suFCD7TXW0/gQwEP35jivGa
VAT/9XtLbrEkP4dnhjvZw11tHSb87vc5XufnYHlygcq757YOXKxTbN4e9HNo
T+A2SHKxcxB4OyfNkcsfzjd0CotZWI3gp4TM2WK10d/B/Ri/VW+5LZy/qv2w
7q4VNnA+r2R/kOc9a4fLTxP/8Bf7O0TFzpi2SMzaod3t17/tev4OcpsX7WGt
snKI8ZSalOng5yCve05iWawFPHzZDFIfHHBE8CsDE5ZNskHwGcDAwmFVfO30
WIYAOB89PQMABakyZg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKC09q2FmX3igw/PVT5K/a1g7wPjNUpL2GZ+tHfYx
vvpWHhLocIvxumjxXhuHeNN1zAfsAh0uXfnjFFlh69B9utRZQynQ4d/CLw84
s+0cCk75d9q/D3DoZdix2HOynYOA3p8U1asIPu+xjYcfrUfwD2uxe/Q1BTh0
XAg63BFo5yD3u2m1WmaAw8Upc+supNk6VPXHnLEMDXDwU75022WHjYPs96Oa
ykEBcPfB+DD3w/jea79Lr822gvPrvkxXV+ywdDDjWex5PTvA4ZdT7gGeExYO
nyIYf1xrC3BgMHhxbu5vc4emaqWKiVsCHCJEpGcwnjR3aNE+ed7hMoK/TVTF
W+Ergn/RqiJhv0qgw+Lo9S8Z/5k7lAV1iEY4BDo8Lc3MePHWAh5+Gc9NuEvm
WMLD1/jD2+UBiVYO6OGvnuwV13MF6B4wsHDY2PrujPIeBP/LEikD9+kBDkks
847G2Fs41JmzGbH2BDh4eMnHLze0dOCaxZmq2hrgYDe3jbnmJIIfuLZE98JG
Kzg/znfepltu1nC+6rUZx5a+QPArbWeIzO+3cfhscnmOQleAw6kvH7heits6
BObOXPh7aoDDmeeNJidc7Bw2qcrpvzgS4BDF9syoPtoO7n4Yv83a4aj2SwTf
5Y325CyhQAf7k7Jmgnp2DotUPk13lQt0ePIx0vmcsa2D3nebuB5geLLH/BEK
W2YD5zeturja8Zk1nA9zP4x/yG9j1oROKzhfY4Ly83N3LR12RjpMXCMb6JDA
rnmZ2cbS4cK7OA1/kUCHG6k//Ld7Wzg8WfxuxpIPiPBFD38AidZEpw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKH2tiZ9n77Qgh+ernyR/17B2gPGbpSTtMz5bO1S+
qshcNjnI4RbjddHivTYOUnK2Ze9qgxwuXfnjFFlh6+C2hWVbWGKQw7+FXx5w
Zts5aG2+9ztXL8ihl2HHYs/Jdg6nxbqvB4sg+CfWOZgJvg+E8+uEp+3aczDQ
oeNC0OGOQDuHm48F5UJXBDpcnDK37kKarYNpxWu7jCmBDn7Kl2677LBxuHE/
ZE7gxEC4+2B8mPthfO+136XXZlvB+XVfpqsrdlg6fPxiuId1daDDL6fcAzwn
LBzWOk7IYj0W6MBg8OLc3N/mDrYpG1/t/xzoECEiPYPxpLmDvUiEU75QEJxf
+G/TXj8TBL9Hmf3y2+Qgh8XR618y/jN3MLQW72irD3J4WpqZ8eKtBTz8Mp6b
cJfMsYSHr/GHt8sDEq0c0MP/kffNC7uEgxwYwMDCISev1j7odyCcv7535aLS
a4EOSSzzjsbYWzhYKkxdYnw60MHDSz5+uaGlw9GmGdeDjwQ62M1tY645ieAH
ri3RvbDRCs6P85236ZabNZyvem3GsaUvEPxK2xki8/ttHNbJJvH7nwx0OPXl
A9dLcVsHnjANEa2rgQ5nnjeanHCxc8jlW7tQjCXIIYrtmVF9tB3c/TC+o8p5
8ygNBP//lV2sMwODHOxPypoJ6tk5xPI2cpXEBjk8+RjpfM7Y1uHl/dMXdgHD
kz3mj1DYMhs4v2nVxdWOz6zhfJj7YfxDfhuzJnRawfkaE5Sfn7tr6VDidJ75
dkyQQwK75mVmG0uH7utvZ9UGBzncSP3hv93bwmF+Ty33ZX1EeKOHPwBbJF54

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxd01tIk1EcAPCppGZmOCWbGunsQjldF29p9f1PwzTyxnZoqLQHKRyCSbmR
2aKZuWlmw3lBbfng0kQMI2uKt63hJefSREYls5sWlFGGJlka7eX7Tvjwf/hx
OOf7377grDzhORcWi+XkCOQIZ0ekNko3Vx/EQNVHZk+VAYSkrRXXJWJo6B9Z
MkoBlp20v3USDNykZVnhCYB39p7lIDmGaV4yK2IXQK7+1EmlAkPV9oCiVxyA
86Fug3I1BhN/biRlI8DddCfZQDkxe17w3FBFnJcQE5aow2BWd+W3bCNuL8Ti
FR5x8BJ3lBsNYA24wJ6rx2C3L4pnBY7vGRWPhJUYlCZJ33QSwAP2JF6KwWDI
eXkD6wEeS7Ib1RoMX33TksdXAJ5whzKdazAULGL16l/y/v21IPttV8S4cqHf
+N6fWDGboY/gIyb/q3HhqbeOIaY+2ithsekZZcS6Gr1BoHLU02xBGUcRWOI+
zNdewxDFW53YfwgB3X/ekctNtj6S/69VW2l8KYLameuZFYcxWL54Hp+oQ8x5
+lPfmxwDguqSjo7IfcSvCx4ODQT9Z+vwdzYHg2pq5oWmmbjzY4ufaw3x7uyL
V3zUCNw7z37+FkLycfbplrvZRGAWnjGNHUDQ+1Z856dVxNRDm663dwvkVD0j
1seavaQm4qYGbbu+S8T0kzbdb9r0PFguSBloFIGtg1My6piX3mOasgyKmHku
TPL87YEY1Kw4reoeOReeNo96pgBzf/hSv+ZNIjDv1+b+iE1CxPS+0ab3kc6f
3le6Ptr8mZ2u3mPEFfLe1j3jItAOJdiUHqR/btTWhDZfYPrrza+XbSgHpv/5
O/Jax2UU4+6oRo6XlFilCM21IgrMgiyrONixD6I/nOIQCtp71lp1e4mZfVnn
T6xNbX4SitmfcHeI1hRRsP7//we4fsUh
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtUk3UYAPAByeUgl+JyBowQi8ll3Dqjmlze56VzhABdoO9fsmFKckJG
DQExQWIiClNyjotg2zAbY0pNLookEAdcnhNqky06J7CFcQmhOAtSUJitfdq/
04fnw+88ly/PeZ7AbEFGjh2NRrOxBLKErSW4htTRGBYC2+U7nxvmARqh4ehs
JIKUF4vdXnUmgfOIJ92dgMC1VPimz3ESJlNP1ezLw46fYYQd+Qhb+vT6mPQY
tizX9OEtEQKXzera4UOWfLBcwfkEQcZSRVIDn4RdQUHNt/kI1M/li11p2K/z
Zlq0Edhs9rNhTz8SRm4F5igLEfg5XO6T2JHgfr7rUtkJ7LXR9thYCfbFOJ1v
sBLB0J493R0+2I0PNQ98UrGr/t7RnnjGMq9v0hQtRDBlLMxvlpGwWuzr+jAP
O/3biZXKbdhc9Qc2zVEIDKoLrY5ZJGxSNH29IQSB02uqAhFJwrhmuynJB0G3
l/h3xTkSVOPLwtxVytr/J+s7dvgsNqvqp0y9AlvQlJTsKqSg7XDO/gvrYHX/
2ka79F+weVpaYdZ9gPWDda7UKeyWSx7yL6qxq+MMY9JabA/CPU94lgJFvJ34
sQ7gRonk6V0xBduc1pz9DQD3+9Gcv5KCV8xbJkb3kxDZWd4r1lLW/SY/SWz7
bRpbFe701YARu3RSHji8AUFnDG0IlWDX02J67kVhp4Q8Wll2JGExLjaUvk6B
Z4Ug4mg3WOdzvp9oTDMRoPSv69GNW/J8lWyWR4CO/zzhBw0Fhs7eX4V/JQBr
16KIfRnbi1v9Pr8V+5BqMP5ZI7bgjSPt+hoK+IJUwuRGgOePJzOzmilgZjK0
AwwC/nGpWGa0URBK3+q3Ox07it7LKm3CHi+a3nLxAe7/dNLJodZIQGhuq9F8
FjuEbW7Zewz72ope0JdPwQuDksimq9ismuNXy/div6Pvbs34IwEKPN7mMiz7
i7mtL6m8mQBviWJPSFXYreXZO1102OLMM1zJHAUi0/wTwwECfN8bnDk8T8GX
ImeprIiAlJzTHMclCrrOLymZPgTYT43eUDogaz9XJ+HtCMdmdmij3T/Gnpby
Escs97a5jN7jbSasDjAF9NsHgNXlway0tTAAokFTyazFvi45t0iexp4K8+pQ
V/2n/nH9pmzLfTd8lu1pZgLIBl6q865EsHRltcPhZbD+H2RLP+kRTgDnm+J7
NxORdb+a9qj8axHYZWG970Z7Y/+80/5g4EYE8pHF7bYEYfXCUPBqVx32lZG5
guS7BBgz8+sX3BBIguhFAzYAB1Zy992xzFMvSBcCtgL8/5/+C3KmYsI=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4qDFE1KuhYY7vNwdHZm2y9kBxt9S1X4786Kz
g4flDN93IeEOP5jlJBwuOTvMv/Daf5oHgm97yyKpVyfcgWFz9acNc5wdZi5o
y1/JguDr/HI23vspDIO/Xn2X3p8KZ4c/a+dqGP9F8BfpPg8SkgqH85kkzi9Q
NAp3+D3r6aa9UxD80k1XqvTPOcL5i3Rqag9uQPDLc1ge6S51dHg+WfRwOhuC
H797y8M9X8Mw+L6dKlWSrY4O8z69cJv3F8EvXl6yoc04HM6PtO4qPuaM4L8o
lDgTH4jgZ1x9njW7A8H/8n+VsvUkTD7M/hx1L6cJjQg+LPzR+TD/wfhx+r6C
L84i+LD4AwC/tcrl
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
      1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ3Wi92+nD8giHvm1anW+EnRxg/HuOb3wWmjs5KCgt
6Egrx+S/u/xxRuQhZzj/llKmOddVBP9MGp+n7m1nh3Ni1V+35CL4CjE5ChkZ
CD5vR/Wn6WkIfoZ5qolxUoRDrCxD4eFzzg4ST1mM2S+Ew+2H8WHuvf6F22ZB
QAQGv//JJ/l3Zxzh/D1xs5Qa1iP45Tksj3SXOjrMfXPxoZEugq/YZbI9UxGT
79upUiXZ6uhwJvrBDltzBH9qucP8w8EIvlamweWzyQh+4vxsVecSBF9792nu
kxMQ/Ks95bxzl2HyYfZHat16dHkWgg8LX3Q+zH8wPsz/MD56/ML4AOCn1C4=

     "], {{97.30772516000002, 38.9658996171875}, {97.30772516000002, 
     36.434610000000006`}, {95.50324147250001, 36.434610000000006`}, {
     97.30772516000002, 38.9658996171875}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4qefu5bL5UY5tN3w33pmgoPDUUVpj3LpaDj/
2EGvVdYqCL7KL4H1YgaY/L8rP17yXYXgF1dP/nDuMEI/jA8zH8aH2Y/Oly2q
zaxWdYLzD34VNzA3R/AVVt23VvB3ctDi3iURl4Dg5yu97JwbjMmH6YfxYebD
+DD7l2kuf7R6SSScv7SzvOH5bATfPXBjNc8ETD7M/zA+LHxg+mF8mPkwPsx+
dH6sfHWSU4wdnC8i4Xb1lAWCL6DhsHMShx3c/zA+LHzQ+TD9MD7MfPT4BwBz
L+9o
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4ubFnTLHTZIcYsxaSpw+uTrA+ExOt7Z+5nOD
85fmLrwQLujmoGr6r++WLoLPc+PIjp1SSQ6OP3eXXzni6rDWXZuj/X8inP/J
gfNG81dMPr+95+lJ81wdpjodvbv3N4J/h3nfGwu+JDjfmmeOUplckkPbiT6j
5fsQfMVpRcnyOs5wfrJofkrdPyeHr11MN5plkxwS987eofbeycHCK25uNiOC
X+tsk5vxPRGDH5d79N+m404OazVvpbkwJcH5jUtXhpjLIvj3r0+aP08Twbfl
qnnFaobgC7Z53/gRgOA75Ly8eCUakw+zvzX1+MKLgQj+CRXl9J2mCD4s/N9Z
XwiR/IvgH7m5NjUI6H/0+AMAfonWEw==
    "]], 
   RasterBox[{{0}}, {{112.868, 33.107800000000005`}, {177.668, 33.5878}}, {0, 
    255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4mDfKCarjzEOfybWvpYLtXOA8d1XauY19iH4
vQw7FntOtnOYUeD8POExgp+27YKV/N4Yh2Pibz86/bJ1WD517s2dbQi+YUdk
5eYiTH7yYvaZ+9faOlR0X2xRr0fw2fkOL5JdguAfkavnm3EkxiFw26T0F28R
/NbAqJM3TljA+ZwBwaen5Vo4WMj4VG4+FOPAvmBN8XM/C4f9s5hZmrsQfM/e
/YtryjD5DGBg4bAi8vc0kx4E3z9wVpHUIQSfe1sOx8tbCP4JKft52z8j+PlC
9yrnasbC+efuSeaG2mPyYfZHXLzK46+N4N/3750u9xnhPlj4K8wVXXMmC8E/
fePCWbuTCD4s/gDvnbgL
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H8s1HEcx/HjdJe082slpaQjV7K24nzvp/eQsqkh1LTP1+1S6AdqVPKr
Jpf8SIdUa1ahGrby404/9AM7v2LKGHclQqdDLhuVH1H31/ez9cfrj8ff7+fe
DtLYoGN0Go1mZJiPYcaGBQ/n9l5xJUFukxnMTBeAMuEroz6chCcRrb6SFgG8
3+Sxxj+dhPPIVB+YIKScOUXkFfJFlFuvumVEM8VguUxXjPmTkEt7XupXIIZo
L+YGmSW2+w25hNODKBtzfwRuKUPgmBPCK6Vhe/eZbgrZK6I8JF9dGPtLCN/j
dJPD1QgI30PX3duE0J80X0dXYUe8ybY4049d2Ui3044i2PqiZuHOX+ywmdGd
U/tElDXx5XXQKgL5AKujqxlbOvhnnP0au/zOOk+XDwgUYZI8U64YUtOCGN1z
CLTxpRrZQTGwe0yW9SySstPb/bfZHOwMZnb+uB8JNRe7o15twL7HX4x95yGi
PGLZYXfZFvtCcVTNR5kQ2r105BCPBKty1Yc9NkJoY3mzxM4kaFJz014WC4D9
tK+EsCKhIr5xO6dIAAFKbUKrMXbkejtx5xKinDI5YDOrxz7weiSycgK7afCz
a4oWAdNvwVxVIAD7jqyFb18QRGzc/TNcjr0i+uT4uURs+rWBpm3hAuCquNXt
WuzNbPKR5zR2Wu3v0LNmJOW5CM5d8MSG6SMOFaEksL3VfONaPuWTtz5J2fU8
ypVmPUG9UgKc7tqLTrsYeu1+sPGyLQGX0s0ze82xb6q7wvSziLI0dYe/znBv
/UjJ3ywfAiQxytClpwiUiyGXdmoIkOvaxHWGvhTZrKmVnQT8UO/KdTT0lVX9
+IIHg0eZeXBQLTqBLS6W0ZPbedB/NOO9WwsCL1QWsHaZB98Px5tYK7AlY/Of
mA+xJ9TKJCM5Ak6DWd0pDXa+vLbq8XHsmZIGf6dEAhiyZrOiDgTW6JVqqdMD
WlbJcvgWJOVYxsg4G2HrkuImTxWRENLvO2yvIChXHeBznZ/xKB+rkATnX+WD
dVZy1VAMCUZ+Kcv39wvg/3/xD+yl5sY=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKL045X/s7KvxDs9XP0n+rmHtAOM3S0naZ3y2dnA7
k7G75VK8wy3G66LFe20cnv/XOXFmT7zDpSt/nCIrbB2Ep31hN10Q7/Bv4ZcH
nNl2Dj+mnPP1yY136GXYsdhzsp3DjB9VmkbBCP7UCQYd73URfO+vrTyzGeId
Oi4EHe4ItHNYdpSxwPh5nMPFKXPrLqTZOjBF3Z7gdjnOwU/50m2XHTYOSw+6
vNO/EAd3H4wPcz+M7732u/TabCs4v+7LdHXFDkuHfdcU+Z68jHP45ZR7gOeE
hUOVcsOexyzxDgwGL87N/W3uwOW20GaeUbxDhIj0DMaT5g4839yn+AYi+HYP
FvHrFiP4kazfVc4sindYHL3+JeM/c4d/Muy3UvbFOzwtzcx48dYCHn4Zz024
S+ZYwsPX+MPb5QGJVg7o4b9e96TSzCCge8DAwsEyIHeigRWCX5M/80uwaLxD
Esu8ozH2Fg5sTK3fBLniHTy85OOXG1o6TErp0DRijnewm9vGXHMSwQ9cW6J7
YaMVnB/nO2/TLTdrOF/12oxjS18g+JW2M0Tm99s4VP8PTNTliHc49eUD10tx
W4eb5hJpHCLxDmeeN5qccLFzsPow5/MXp3iHKLZnRvXRdnD3w/h8bPs7LdIR
/DPbVoWXT4h3sD8payaoZ+eg9b4gJmhOvMOTj5HO54xtHbYd3K00Exie7DF/
hMKW2cD5TasurnZ8Zg3nw9wP4x/y25g1odMKzteYoPz83F1LB0eV/aE7Z8c7
JLBrXma2sXSI2Hn3TfSkeIcbqT/8t3tbOOTk5cZuzEOEL3r4AwDo4lXN
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4sw3+3se9iY4hC6b0awgZ+cQNP/v6tUTEhwi
wuxvn7dB8J+YuIj+c0TwxfXF2k5U2jnIlicv2eyK4Pcx6PxaIo/g7015bfRf
LsHBfaVmXmOfnQPTvx8pB2QTHFguRR48tcbOwf1+ku87UQRf4vPzmfO4ExxS
C6bsqdpq43BZsG5jgTCCLzlZ/E+SSIJDw12XjrZ7Ng5MbqHSuuIJDnvCgya3
1ts67On75q4pneCwj/3nK5N5QH5ZU0IU0L7kxewz96+1ddiX15pXZorgJ3Vs
ja63RPDrfiqt7KtE8NdWGzdrlyU4eJiFn93cYusgn5+26XwskB9sO3N/ro1D
dXF7Gmd4gkO+r+hzZ0kbB5mXp/K9rBMcVDbLn9M4YOWwPP/PXwXDBIeqKytt
vGMs4fxDO1IvuoZbwPnezw9vPmKL4BcYfl0585S5Q2Xp8nmV9gi+T3WQ/SVf
TD5MP4wPMx/Gd+Ry7vx9E8GfNHHzhuVplgjz1AUfyn+xdDjoYX7bPyDBIYXL
8NPZOiuH6vWaK/sCExyO2W1vO7ETyK93vPUhNMHhw29z/b5p1g6pu6xKNiQn
OIhGZmt8NbVxQE9PADExDI0=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQ7fW7aMX3wwkOsWvzAsTsrB1g/Gv/zn1bUYXgr/8l
9GDVD1uHyfcqb+14leDwtGTxzbZgO4fUS72+234h+IetbBT1mRLh/COrmreE
8ic6zKt96vjL1c7B0qOh0VQs0eGY+NuPTr9sHT5/+OidK4jgf2prL9rFjMln
qv/xc30Hgt/x1qJ/ipWtQ8B7Uzdj7kSHObtsnu8QsXU40mMkLCyE4K9T/+PF
J47gT590d3O2AtA9pzbfWayF4EvNucTt0YXg88sr1e+StXOo/8k4+yjQvF6G
HYs9J9s5THFi//X9RwKcL8N7Y4/5RQR/yXuZdLflCQ7PLr7IlPazhfOLpBZx
/VewhvOnzZs/43W9hQOLFOeBk6cTHIRj9xz5e8bcYdIHAQ6Rlwj+kXMb+Xl4
EuF8Fcdfcn80Ex1m610Ve7HDAs4XOSzfv4rZCs6PrW1rrHCydlAsZlLj4kt0
0Fmmy6ltbOOwip0vweJ1Apy/4uPODTevIvjXzu7NszuV4LBWJaPp+hZE/MPS
BwCbPf6f
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQLce9o+X4iwSH8osLZRslLRy8HderfbmC4Fey2v/t
PJ3gwN+wY3X4eguHt0w8GUtPJjhs1bbzP3vFwsHrd9GK74cTHIx5rxTHeFnC
+ToBjiaZQlZwPhPbZJ1CewQ/P+v3Jn8ma4e3l5Rnsp9LcGjZ5bFQ54+1g5nG
pGnxrxB89imv+tLfI/hrrDdvuPkXwb+tyy03lz3RIUFX96Z6orVDnemSu168
iQ5C0w6d3cyC4B+qm2mp12oF5/91Lb1/jQvBv2MhseDxJEs4X993m9ohUUsH
iyefEr8BzT+V0WklscfCofb65/L6fwkOb4z+LL+tauHwIW7OVIYPiPBCD08A
Q76dwA==
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYCYtWrfv/5zyY6hC6b0awgZ+fA19Ejd+t8okNE
mP3t8zYI/hMTF9F/jgi+uL5Y24lKO4eb8Z/EHrUg+F4vd+VcjkPwK32rluoC
+e4rNfMa++wc9j1rv/4uJtGB5VLkwVNr7ByYT3zcLxOK4F+5XcZz1ivRIbVg
yp6qrTYO/b94VOYHIfhXq5flTQxOdGi469LRds/GYZ/ek97osESHPeFBk1vr
bR0qylt3hUclOuxj//nKZB6QHy94uQNoX/Ji9pn719o6VIWLPFxSguDLFbqc
W1uB4Fs92ii9dweCn5ly6Gvk1kQHD7Pws5tbbB1uh39V+TcHyA+2nbk/18bB
PEbspvm0RId8X9HnzpI2DjcuRj6qqEp0UNksf07jgJVDckR3gX9BokPVlZU2
3jGWcP6hHakXXcMt4Hzv54c3H7FF8AsMv66cecrcwTTOTHBFHYLPkfJwI0Mv
Jh+mH8aHmQ/jO3I5d/6+ieBPmrh5w/I0S4R56oIP5b9YOtQaHvOt6090SOEy
/HS2zsrBfMYO6b0TEh2O2W1vO7ETyM+44CM/NdHhw29z/b5p1g6Ki08+u7co
0UE0Mlvjq6mNA3p6AgDRew2t
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ3R+1Z7Pg40SHDHHZW4IzLB0+t7mGaZglYfA17n5s
rDhkAedP7dNYzJBl4aD4mqW/yTTJgX3BmuLnfhYOfq5aPalyCL5ZnCjzfXFM
PgMYWDjcEi8NWqOC4NctP9njb4rgf/mTufiQE4KfGcS1yzQAwW86vr1cNRHB
V2sUP/4pF5MPs59vFpNdTjqCb/1F3do/AMHPjHhevNIf4T8YH+Z/GB8WPjlM
GwWf5mHyz3QzGU99YglXj86XOO/6oqfJDs6/xv7W4OA2BL9q8e973sfsHNZJ
M+ye4oXg351ufHuvO4I/XWzWhNNuCL5VhZqJo0uSg1HOvSaz5XYOsPiF2Y8e
3wD1lMYr
     "], {{145.79205034999998`, 25.892901600000002`}, {
     143.3683268375, 25.892901600000002`}, {145.79205034999998`, 
     29.678704800000002`}, {145.79205034999998`, 25.892901600000002`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H0s1HEcB/DDdC4VZUtN19UkYst64neP+xQdFipcD7bDvmikTW5OhDw0
56HEnefGPFx2HT3IU0itOA8naxniFHmY0krK9Wy5fn/9vlt/vP94/fP54/N5
77MTRfuFm9BoNCMy7mSMyaz9OdDpM4JAbp0VQL/KBe7hH6MRiwjuhfUJQ3q5
0F/EEu8zILgkZnw+KeVRzlok8go5fMp9mQczIukCiDSV3VmdQ5BLa1N6FQig
SEUP8e3FTnwxmM5SYaPqxMTyPAS7rovYShq22yvGdpEHn/Jb+brC6B88GBPE
eyYVIyCEp28c6ueBt4a2N7cSWzGvnXBTY7u8z5hOvo9gd3vjnzIDdqB+znnR
k09ZF6tuhT4+qGPN2yRV2HJpugezHPuQv+VyVS2C5sCQPIaLAFjCu6P6dgTz
sUqdzF8Ay9GyIeMebP183faKIWzbHK1N6iyCxstDEZ022JWclegBVz7l2Y3P
t6VtxY6viGickPGgx/6XUeIEgk1qzcuj1jzQ5NaedSTn667kpnRUcGFZvKRU
kfuui33m6FDMBcZM3PqlJ9iFVoqYmE5sVpIkyLQF2yxcumamEbvru+SDVwMC
utcfC00BF75EaY8b7iIIYx74HizHNo2M+hCXgG2S/aZrTzAXkiJYThcbsL9a
N9nVt2DvmDYku3djTxJbqpwmsVNX94VOLyCwdRvnGDdxKEeVvEa2j9iU682H
/UYQAfphq6+Hh8m+DlUz07YSsKP/WrG0B7te8jHFuA1bcfRmfAp578+zNYYc
dwLkj6f+ZhchaFkRpTrrCFBfXoh5R/ar+dqGRbNBAsYlzDIm2a+cB6p41zVs
ynT/qXH+eWxBhcwkScsG7zZhRy05/4j41onNq2wY2/9kpLAEO/93KljkY48u
B1mukyFweGreekGHrZA3NajOYetrnnrbJRAQqj135pQSgZW4U/N30BW6zftK
b/dglzKkHsxP2CJ3Xv8zs1AQjQlnWM0E5QZfjov9Qzbl8LqQAEUmB84f63Jc
+YbAyCt5tcqHC///i3/nifDX
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQfbPoT1eIU7JD7Nq8ADE7awcY/9q/c99WVCH4638J
PVj1w9ZBKYx5r2hmssPTksU324LtHL54ihsIVyL4QZuOMvc0IPjBSrzTN/Um
O8yrfer4y9XO4cR+zpRJU5Idjom//ej0y9ahKaNa71Q/gt/4TyBUvAmTz1T/
4+f6DgS/461F/xQrW4f7afs1JnQmO8zZZfN8h4itQzDLnq/5ExB82/mtutlT
EXw1rvRpJ+YB3XNq853FWgi+1JxL3B5dCD6/vFL9Llk7B77C7lqlickOvQw7
FntOtnNQ3jXhTkg5gr+6JXH+FH8E3zh9medi1WSHZxdfZEr72cL5RVKLuP4r
WMP50+bNn/G63sJh8sRJi9S8kh2EY/cc+XvG3EEpY9argnQEP9jN+lNGF4K/
eUczY+SKZIfZelfFXuywgPNFDsv3r2K2gvNja9saK5ysHTa86uZI70l20Fmm
y6ltbONgWT/daWomgm+e6TzZLATBT3V1D5ztkeywViWj6foWRPzD0gcAwC/0
pQ==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQvbbJMV0lPdmh/OJC2UZJC4dbOyw4A4MRfI7aE/ef
eSY78DfsWB2+3sKhpmqqF5NHssNWbTv/s1csHG4W/ekKcUp2MOa9UhzjZQnn
6wQ4mmQKWcH5TGyTdQrtEfz8rN+b/JmsHWq81lan+CQ7tOzyWKjzx9rh6Hzp
yj0ZCP407pLCI7kIvvVmm8lmNQh+1tIpDL9akx0SdHVvqidaO/Cu1T2wvDvZ
QWjaobObWRD8Q3UzLfVareD8v66l969xIfh3LCQWPJ5kCefr+25TOyRq6XA8
usYluC3Z4VRGp5XEHgsHHv/aqDtA+98Y/Vl+W9XCof6aakVsHiK80MMTADSU
la8=
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{159.35268266000003`, 28.5221045625}, {
     158.89969387250002`, 28.816313775}, {158.86077731000003`, 29.14943955}, {
     158.86077731000003`, 29.3160024375}, {158.86077731000003`, 
     29.9137608375}, {159.50056559750004`, 30.3262764}, {160.20106372250004`, 
     30.3262764}, {160.92024179750004`, 30.3262764}, {161.55069011000003`, 
     29.815691100000002`}, {161.55069011000003`, 29.1105229875}, {
     161.55069011000003`, 28.55168115}, {161.16619447250002`, 
     28.0800124125}, {160.57466272250002`, 27.7375466625}, {
     159.35268266000003`, 28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQzaut9zFGMsWhhkvVImq6tcODO4fSE/VTHPg12TxM
vlg7tNStOx9vl+LQV/X4/8syGzhf0KfeYaOMLZw/w7ch0ZLFzmEDx57ZD5RS
HHoZdiz2nGznwP29Y8FuNgQ/jXm5283nyXC+XBfXu1Pnkh0UbOrr9W/awvk2
03Q9Vr63QchHpnpbH0LwF7k/D+cLtHHwjTBhuHE72eHevVt6kretHTiWb3rm
fj/ZQWnbqtvn91g7cGpOXH7yVbIDq2Wz1M1aa4fbZTP+9X1Kdri87oeNabC1
g9nPWx/dHiQ7zCs5zv6I09ph4u23TVZHkx0O3su8nlljBeensS97otZkCedz
fWjSjS6zcPhoemhV9NNkB+HYPUf+njF3mC5oIJsP9C+Mv3FXkzaDFoIvqHva
6oN7isNMP7cPs+ZZwPn3JJYfM1hrCeeLTDY/wMNh5RB2zyekwSXF4Ya2zo75
lVYOdsa3eOstUhw2OZ6OZ3ti5aDm9uJUi1GKw9+O+I1sktYOIbf6L9Xopjjo
Xu46pWhk7YAevwCa9djk
     "], {{159.80722811000004`, 27.178704825}, {
     160.08120071000002`, 27.0121419375}, {160.54352947250004`, 
     26.717932725}, {161.01364154750004`, 26.4143835375}, {
     161.28917081000003`, 26.2275840375}, {161.74994291000004`, 
     25.933374825}, {161.74994291000004`, 25.335616425}, {161.74994291000004`,
      24.6102117}, {161.01519821000002`, 24.099626400000002`}, {
     160.21040369750003`, 24.099626400000002`}, {159.36669262250004`, 
     24.099626400000002`}, {158.66152451000002`, 24.7082814375}, {
     158.66152451000002`, 25.5208592625}, {158.66152451000002`, 
     26.0905977375}, {158.97441367250002`, 26.717932725}, {
     159.80722811000004`, 27.178704825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKJ2/UKik/XmKw/PVT5K/a1g7wPjNUpL2GZ+tHRxC
jyv9eZricIvxumjxXhsHgXxNTYXbKQ6XrvxxiqywdVC34vW8cibF4d/CLw84
s+0cZlr+eh2/OcWhl2HHYs/Jdg6Z2RduBi1D8DPMtTs3TkbwD78M9WavTXHo
uBB0uCPQzuHDReHa4IIUh4tT5tZdSLN1kJvTwBubluLgp3zptssOG4f3/qZ7
LqYg3Afjw9wP43uv/S69NtsKzq/7Ml1dscPSoeaW8pnVhSkOv5xyD/CcsHC4
xRC8WLs+xYHB4MW5ub/NHZQmJT/mmJbiECEiPYPxpLmD8iuz/oSlCL5N/BOf
gG0I/qnCvuvy51IcFkevf8n4z9xhTq2Y0Rtg+Dwtzcx48dYCHn4Zz024S+ZY
wsPX+MPb5QGJVg7o4f+1tTyMDRheDGBg4WA1/STvpZkI/u1l8fuT21Mckljm
HY2xt3BQKAg9cKgxxcHDSz5+uaGlQ5ri9ZtBdSkOdnPbmGtOIviBa0t0L2y0
gvPjfOdtuuVmDeerXptxbOkLBL/SdobI/H4bh1vvdpdeaEhxOPXlA9dLcVsH
Tm75H3vbUhzOPG80OeFi52CV/tDOZF6KQxTbM6P6aDu4+2F8laJPnGEbEPxm
rxcFX4+kONiflDUT1LNz2JTm/fnRqRSHJx8jnc8Z2zr8OF8QxgYMT/aYP0Jh
y2zg/KZVF1c7PrOG82Huh/EP+W3MmtBpBedrTFB+fu6upYNd46f8aUDzE9g1
LzPbWDqcPN24+/nRFIcbqT/8t3tbOAQvO1kstAURvujhDwAk2V+Q
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKP1k99FVcu2pDs9XP0n+rmHtAOM3S0naZ3y2dtia
XxU5uTXV4RbjddHivTYOrZ134rdXpTpcuvLHKbLC1mFOyIH67JxUh38Lvzzg
zLZz4AtZq/Q9KNWhl2HHYs/Jdg73WpsFXrki+HcD7+33MEbwLVg4m+bJpDp0
XAg63BFo55D65tjmV/ypDhenzK27kGbrMHmbscsX1lQHP+VLt1122DikZL34
lMGCcB+MD3M/jO+99rv02mwrOL/uy3R1xQ5Lh49frjE5C6Y6/HLKPcBzwsLB
X5rt1iG5VAcGgxfn5v42d5i+RkxqgWmqQ4SI9AzGk+YOM1heHf3uguBvrJze
/DwUwbfvceTbnpvqsDh6/UvGf+YOgjNOZjRXpzo8Lc3MePHWAh5+Gc9NuEvm
WMLD1/jD2+UBiVYO6OGftUCrdy4wvBjAwMJh/cYal0xLBD/goNC3X2qpDkks
847G2Fs4TO3i+B6pmOrg4SUfv9zQ0uG2dZfAK9lUB7u5bcw1JxH8wLUluhc2
WsH5cb7zNt1ys4bzVa/NOLb0BYJfaTtDZH6/jYM/Z/6adIVUh1NfPnC9FLd1
qFO9pBcKtP/M80aTEy52Dusbp5Setk11iGJ7ZlQfbQd3P4w/s2epw1t/BP9H
yuzlPSmpDvYnZc0E9ewc1Bv/aVZlpTo8+RjpfM7Y1iH3lXLvXGB4ssf8EQpb
ZgPnN626uNrxmTWcD3M/jH/Ib2PWhE4rOF9jgvLzc3ctHTbPXrpMF2h+Arvm
ZWYbSwe7Zyaf6lJTHW6k/vDf7m3hcOJAzaqVwYjwRQ9/AEShWBo=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKO1kwPtkq1qaw/PVT5K/a1g7wPjNUpL2GZ+tHYSf
HJykpZrmcIvxumjxXhuHx3+VZ/pJpTlcuvLHKbLC1uHXCfadTDxpDv8WfnnA
mW3nkHPiS3Tfp1SHXoYdiz0n2znY/Drl2fgUwbc+pvrz/iUEf1pFwG7TPakO
HReCDncE2jkcTuB727g+1eHilLl1F9JsHT5qVdd2L0118FO+dNtlh43DoXv6
OgxLUuHug/Fh7ofxvdd+l16bbQXn132Zrq7YYengnylnc2tDqsMvp9wDPCcs
HNb2+wpH7Ut1YDB4cW7ub3OHrwpxweZXUx0iRKRnMJ40d/hWYfi/7wmCz//u
3p66rwj+XIZOdz/eNIfF0etfMv4zd8jnEVwkJZ3m8LQ0M+PFWwt4+GU8N+Eu
mWMJD1/jD2+XByRaOaCH/wmRomMmwPBiAAMLB161I7UMNxH8daZR+pOOpTok
scw7GmNv4fD5n7/BxwOpDh5e8vHLDS0dLDdc9Gzcm+pgN7eNueYkgh+4tkT3
wkYrOD/Od96mW27WcL7qtRnHlr5A8CttZ4jM77dxWFu77em//akOp7584Hop
butwZ6ZkxpujqQ5nnjeanHCxc+D9dntd0t1Uhyi2Z0b10XZw98P43xneVra8
R/DDbj56oMyS5mB/UtZMUM/OofWra7IgV5rDk4+RzueMbR1Ox2UfMwGGJ3vM
H6GwZTZwftOqi6sdn1nD+TD3w/iH/DZmTei0gvM1Jig/P3fX0kFQ4O39I5xp
DgnsmpeZbSwd5kTVaIuxpjncSP3hv93bwkHN9Mhjh8+I8EUPfwCyDFcq
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4g8mX1ZpfklzsJ9pmn6508HhVq/dM+3/aQ6z
9h7/sj/DweHwsw5FPa50ByWfbyVVbg4OliFz5QtE0x1u6fgymKg6ONRvf3pC
XjLdYbKsdOMNSSC/2rltlly6wwH9J8f9OB0cpk9yuLdPAcEPvP2Qa7cKgt/A
eWcXs2a6w6H27cXLJBD8NVUh4T91EHzFL0onlcwdHNYXV6y9qJ7ucOfO5/DH
zkB517q/HcrpDg0H4vbc8nFwkM9fcS7ye5rDtqzrLSGLHRyUpxYXL1ZKd3gj
EuB77ieQX650KUE13aHic0j7n38I85f/VbjTx+YI50/8sHf/QykEv+Zx1GIT
fUe4+2ut9fx77Bzh/oPxj/65c6FHHkl+w8R6RmB4rFl6yjHK1tFhHbOh1Gqp
dAcznT/nDYwdHWDhr2NTuejqHoT7f/y52uHa4egwOYQxaBmQf+oVj9P5GY5w
+ciDIl2S24DyK8Rrfr1H8E2VJNjtXyPxfZRlMp+nObRdvnuhfymCv/npMnG2
qQi+WnpRtXC7o4Ov/SeJ628Q7vF8Lx2ffDTN4VBQ7IHTho4Oy66+Low6mAb3
D4wP8++yt/GRmvsRfCnmhauFdyPxjTurNm5Lg4cnjA8LbxgfFh8e6QlPcnel
OVxdL9l6EhhfUq91jrjsTYPH50G/sI2+L9Mc2hmsJ7UtQcgHhR06yePnANd/
rHxv/z0PB7j503I/Wvk4Iviw9Abjw9IjzP2w9ArzH4yfEBKknnEAwe9fMLfi
MzA8Jh11v9rAhQg/dnsx91UiDvDwFdSfWcLa7QAP/2JQxJbYw/k7zOZJ8mUg
+G012rlnHO0dVrEXdnUD4/dU8G/JZmV7B7nD+36sfY/gw9MLGv8ZA/cq8Th7
ePrR43Aw72+0d0DP/wBlXcFK
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtU02UYB/DJQsAZ8wK0MWgiCiqXPCacMN3v+QkVKZjs1CSCchi+O0EO
QalYNFD0gKKIN2QbIhMbUtvYDkZLMC4RIDYWUccLQ45x90zYMJW1pN8/7eX0
x/PH5/zO9znv+b3v8wSkivlpdBqNtoAqAVUuVIn700rs0whcbDdl5gmAZQsX
CftsCLYtPcBcxSBh+P1H+xl2BJ65+a+xC0j4nnF4nLlE5PToLmOUfCm2T6rs
ZBh7nn15t1u4InhxpbqkdT8J3rmeOQ4fEfCt0rfOppOQ9Tk/s43qp/6n0qKL
w45MHr5oDMfeuHG21YtDQminSbDBSwQct9ofyugkmOpZByv9sN/Y4b01LxD7
pcJaXXaYCFqSkvRaNva5ofZ77O3YhTM76rYep/q1aZXPfEXwYCor44KChOgV
8d+8swQ7M0bNDXiOnBY3WWtCZhCYVRU17ikkJDYez02dQuCxQZVZTJLQ0LlX
eXgMgd67dPTyKRIUfMPwmT9wnueo5uX8gj2oqjN1fYst1e3pGpUh+PpgmrDi
b3D6un0xPWEAO9lIy0rpBejwLQ5ZdBG7/Ltum3aeFxdqToZVYye4xt7hKhFc
3kIvffwrQGB10aUOym962Bn+ZgBt9MPyfWoEgXPBd01CEoaan0uD2/B7yNgt
/Mx0C1v+5U+zzX3YR373jGgxI6iPoLUIcrDP0CKu3VqPvW3t+BObOwlEYYoh
/TYCL6k4/As9OPtHdd09F+cgQPbYXdrVSX1PVylGkgnQyW9E/9xE/f/6xsH8
aR4MlkZOzGqw+Sfo73qrsfOjuNEDV+a5QDIbW4UgXbydcDAJ4Pce2umpQhCU
6Gds8iOgM0Pq/4jKr2Nt4uxKwF7PagzNLce+k/1ncNU9nP/qvodbyRQBZvYy
xUdK7AHpjzOeFdgBwrUDm8sQvHCj7JVyDXZoUYEm70PsnX36Gv5D6rzi4R7L
JQQRHX05hww8+KTOnKbWYMtWWeP3tmMzT7vG1RoRFDsm/jJ/TMB7y6vOy3oR
KIsZckU2AZ+yXFv3/IZAd956JYhNQI+gVqofxHmxsajvqBX7gy3BzWPUvP9n
w6v7OrqpeVspYV3zmSOc5jq41xdywem8NaFx9hCAcW31iG0FtjLcXU6bZ4Pk
piTSH3vsfnHDKWq+z55I9ZoLAvCJedsyyRGB9epTrdvL4Nw/AhfWkeVhBIyQ
ucc2O/D9rns9MSnKhn1Uwkl4NoLdwGxPnB5CUNltiXchCKcnW9Y81Z3Gvto9
lhnbQ1AL8oml/wGCstWs7KYFAPbdB/pjRhGoJ+WT3E0A/9+n/wJX0HWN
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYu/72RznWjMcXu6Ojkzb5ewA42+par+dedHZ
wX3V+z+RQP4PZjkJh0vODp9KJf/p1iP4B3/Zt2sWZjgwbK7+tGGOs8P7u896
zWMR/B1dR/MdQzD569V36f2pcHZYmFKUVROJ4JeoTP//Oh3BXyzZvexzcYbD
71lPN+2dguCXbrpSpX/OEc5fpFNTe3ADgl+ew/JId6mjw7TwddvF4hD8oNd/
3Q6GYvJ9O1WqJFsdHT6xzfi5MRLBj3kYq7esBMH3X/2C/1gNgj/tmP6eSc0I
fljF9G6D+Qj+XN6f6QxLMPkw+yMXenxfNRvBh4U/Oh/mPxg/Tt9X8MVZBB8W
fwCyftFc
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxl1H0s1HEcB3BUipzUITnPdWrF0tOchfv8vqeEm1KjpQdlHb9fQilLRSs9
oGfdOdHVYjm19LC6CaVw4eQqm25zXQ7VXFrycNdmnaXfP35fmz8+f7z++Xze
23v7eCembxXNsLCwsKRnEz1W9LxueiVv15PwKUl2weuIAJBNqsvpARJmJ2rV
3skC8JmwVn8cwi5yvPFwlRG7N69+pdGeYhzTLa2M86Rg8MCopLsGG+V+bc1v
wc47mjVH1yEATuq1+h53CiixcmlFpwAWx5TPbHfDPmO3vT9hinta56pMHOxb
oZmXPDh43/ENy1P+OFHA8pDnzG0TgKWLjfCuLQXZOuH5rBcCiO9i1TX9JRkX
iszpdSZsV97nLaIB7Ce3ExUZOhJ+6JVcwwcBvBHlowgtydx39w5Zou/CVp9a
WHR/in8mqDP1mumOqQyu62vD/lgQoqh8iW2Vonlcr0CMg9/yDz6qwI69soc1
XIrAJ6525VYt9h5zMDdEhz2Zn9y3eX2DDMEdTbCvrJuEJE7NjOZKBAUvFQ0d
/SREh1sEmrUInqqLvAbpfm8VK3+v70PAvttLZJqx8zxSuNvmUIxl/3yNbnT/
761L9sMLBBJXx6pV8yi4GbTbOfwpgrRY4TkHNgWjtexfyWIE1ewEdbwjBanv
nPTrMrC/7ci9LOFjSwIb1Du52M0h0tDvIwRE7bLcb2BRIBYX7BS1E9DVcF2R
T+eRVte09Dwk4OJPg1/UBAl/omd9MUoJMMX67VaasH3bz3a29mNXm6+t2Ef3
labirwl7TgDa65lt1Un3pcqSRBoIOP4cSsd02Bs1A55ZvSRIR4bWxI9jR/pL
hM5sxHjEqfvE4SAE2mK5YTa9/9m9LzlXAYFNa5LvfA12WVmtv+QTNqV6xi9r
m27SPsJf6IBtTbWUNzcSYLa1462l81UoBS78IwRsGIv5NWbCXjj2dtEBB4qx
4+jJE4eWUTAvwOgeoMLmRdsaX/MQ48CqB351txHUlITJtjtTIA8YOnznLwIT
b2MhGicZh2UcdBsfxU4rkHIW/CDhWGNvqXgYweR/Yc20XO31AXvy3/wHOx0c
KA==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4ocJ+UkeolkObTf8t56Z4OBwsXz7ppIcJL77
+cfXChB8hhSjtCNlmPy/Kz9e8l2F4BdXT/5w7jBCP5wPNR/Gh9mPzpctqs2s
VnWC8w9+FTcwN0fwFVbdt1bwd3JofsMm/YIPwVetmHe5nQOTD9MP48PMh/Fh
9h+s/vufb2MmnH9g9dNza9Yg+BP7m3z2L8Pkw/wP48PCB6YfxoeZD+PD7Efn
x8pXJznF2MH5IhJuV09ZIPgCGg47J3HYwf0P48PCB50P0w/jw8xHj38A6Avx
Hg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4ls/lTd6JuQ7xJi1lDh9cnWA8Zmcbm39zOcG
5y/NXXghXNDNoaZ7hnJsJIKfrBfva+OW7+D4c3f5lSOuDizzjs7h1EbwPacv
zmFTxOTz23uenjTP1eHNjPgiB3UE3zgqonG3JYI/Kcls+w/PfIe2E31Gy/ch
+IrTipLldZzh/GTR/JS6f04OPg/n5LAB+Yl7Z+9Qe+/k0L/gh+E7HQT/ysxr
jK+VMPlxuUf/bTru5MDSUPL7mC6Cf+O388udHgi+mZ6uiWIogj8lQay+IxHB
z7jzNKe6BsGffqg5Lbwdkw+z/87uRLOQWgRfvnrvb+tEBB8W/u+sL4RI/kXw
j9xcmxoE9D96/AEA3pbaOw==
    "]], 
   RasterBox[{{0}}, {{215.82799999999997`, 33.107800000000005`}, {285.668, 
    33.5878}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4naRFVnq7dkOtrr2BaF7LB0eqzRP8qhH8Lfe
MHfcW5vtMNnwsVBOvqXDGXnZjPrqbIeFekEa3P8tHPLa245mVGQ7aL7NKE++
AeTP/7XGvCzbwf7X6ckCRywc7FSfH6lLRPBPtr/6Pi8KwT/y8fp+PSUEX8Xh
U3GGc7ZDDrvyN88Tlg6P5hwXDy7Jdnh2+4zRVBVrB5h7LSarat5fg+CbTdtg
1rbSBsGX/HXG7qStw+Ylkz5IZ2c79DLsWOw52c6B9/9LNilXBD+Ap97mkSKC
n2pu/OsiV7bDAfeI9XvX28L5dwT9uOMu28D5L/T0fq33sHFYIxOVwiyF4HOe
TXn3Aok/dXWmhrgCgm9Zaxu/WSvb4fLBX/bHUxF8rju7ZqefRPBzHkQkHuGw
dbDceX+hhWq2Q2dsg9Jud1uHqc+5s+dIIficr7f2a0sg+AoKLJ2TxBH8w/k/
/60RA4af4U72cFdbhzWf/PxvymY7WJ5coPLuua0D91f/04v0sh3aE7gNklzs
HHj0L13d7oDgh7Y4XOaPRfAfcgRplmVlO7gf47fqLbeF81e1H9bdtcIGzueV
7A/yvGftYJvrXP0aGN9RsTOmLRKzdshqfVl91TPbQW7zoj2sVVYOCm0bHzjy
ZTvI656TWBZrAQ9fNoPUBwccEfzKwIRlk2wQfAYwsHCYu/ile1gdgo+engG3
Riyv
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKK2dyX/0nWaOw/PVT5K/a1g7wPjNUpL2GZ+tHf7I
HClO1shxuMV4XbR4r43DGTO1qnbZHIdLV/44RVbYOjxm5JplzZ/j8G/hlwec
2XYOoYzfbY5/zXboZdix2HOynYOq8VmtXS8QfJX/6rckriH49RuD5uTtz3bo
uBB0uCPQzmHNTIFzuzZlO1ycMrfuQpqtw63k2rgjK7Id/JQv3XbZYeOwWtyI
13J5Ntx9MD7M/TC+99rv0muzreD8ui/T1RU7LB0sFinICm/JdvjllHuA54SF
w7QT/l8mHcx2YDB4cW7ub3OHe5EJJgU3sh0iRKRnMJ40d7i/0fjB8ecI/g+1
h3O3/0Dw2yy7NdoFchwWR69/yfjP3CHCVbg5WC7H4WlpZsaLtxbw8Mt4bsJd
MscSHr7GH94uD0i0ckAP/42+JctzgeHFAAYWDt/ijsVZ3kHwp+fFCJw+me2Q
xDLvaIy9hcMd8yBBrSPZDh5e8vHLDS0dlF5e1tp1INvBbm4bc81JBD9wbYnu
hY1WcH6c77xNt9ys4XzVazOOLX2B4FfazhCZ32/jMG3bjmPmh7MdTn35wPVS
3Nbh6CVpT1Wg/WeeN5qccLFz+KZ3r3/2g2yHKLZnRvXRdnD3w/gPLN9H7f2E
4NsLPT0Yw57jYH9S1kxQz84hT8/DxYs3x+HJx0jnc8a2Dlum5y7PBYYne8wf
obBlNnB+06qLqx2fWcP5MPfD+If8NmZN6LSC8zUmKD8/d9fS4ZfH+wN/eXIc
Etg1LzPbWDq0Tq7j8efIcbiR+sN/u7eFA3/esSOV3xDhix7+ABbmWBU=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQnXm2f/+VNTkO/34sc9FVs3aA8dUOTzssfM0Kzg9q
L1Bf02PhcORp+s2bPTkO5RcXyjZKWjikvle4+L0Kwf9g33ttTymCb9p4PEYt
FcFPtpy7/0pMjsMt1/YyljQLB5+SaZFTshD8g47VXwVzcxyaC08v6l6H4OeX
3K8+eQPBj/u+8a6EmqVD8s0zijOB5rMuNm/s87Z0eGd9IWRnHILPupBNdl8k
gi9jprolISDHgXnyge7Fpgh+28GFMf+vWsD511ozNbMMLRyqLNQMtBJzHIRj
9xz5e8bcwW/XpesTqhF8q6tRM+YuRvD5bz5laDuZ47D79KtDW5Qt4fxLeTMr
1jhaw/mWJxeovHtu66A8JUjbf2mOQy/DjsWek+0c/FVsNzp3Ivgf1CXfvy1H
8Nn+b2vqzMhxKDr8ftntVDuH/ew/X/2JynGwsnyxXeSrrUPi7TeRnH45DnvU
s448b7Z16G/n8LzgluOQp7BD1VcKwY8z2PHsXKwNnC/qlqmarGztIFuwfF9p
Uo5D6Xa3eBldKwfOg1/Yp7Qi+Fzv98w7OAPBn165et1soPstNnB/fTUVkV5g
6QkAmOoQPA==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQXbug4GJOW46DzGLt41IpVg6rTSRupjQi+Oy9/ts/
FSH4N2Z999TPzHHY+rFw+1YmawfTyXFdjck5Dn3TT57+Go/gH58o4ff4LoIf
l7Bga06kDZyfOaFpecBDBL+4gfXq6nBbBzmZiVMUs3IcfNRiX77eYuuw6lp6
8Uyg/a0Ka7JvGtk53Nrg/bO3Lsfhacnim23Bdg6HOaeZTOhE8AOa3orxz0Dw
AwXavCsW5ThY3xSXuvnX1mF6ovnxM8tzHPYen6m2psfWYX3a3I9TV+c4RDbP
mXPM2tYh82z//itrchwOmISt0Z5rA+fP/y4wb5Ymgh/f+7csOcLa4UvkPHb5
RYjwQQ9PAI8SoQU=
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4tCdT4TfpuY62OraF4TusXTYeHK/NV8cgt9c
W/KqKSbXYbLhY6GcfEuHWUciBV2jch0W6gVpcP+3cLDROZynF57roPk2ozz5
BpDvYh72NyTXwf7X6ckCRywceE4p57k4IPjTddQXplgi+JOmiWR+YUDwPz3R
k9VTynXIYVf+5nnC0mGDI8tBieBch2e3zxhNVbF2gLnXYrKq5v01CL7ZtA1m
bSttEHzJX2fsTto6NHqen/nQM9ehl2HHYs/Jdg63F6ttuK+M4Mtt3P10OQOC
b3wnf/H0lzkOB9wj1u9dbwvn3xH04467bAPnv9DT+7Xew8ah6uA03pM/EPzr
hQunr/uJ4CcHLLt45x+Cz65UxVHJmetw+eAv++OpCD7XnV2z008i+DkPIhKP
cNg6sMfJeP9jznXojG1Q2u1u65Dc4yGSBDQfxr/e/8ni4zcE/90RB6MIJP5E
EbMVRV9zHJ4Z7mQPd7V1qJre/WPenxwHy5MLVN49t3W4ObOnJIM316E9gdsg
ycXO4dZlvvpaeQRfWbO25qo1gr9+bd8la2B4uh/jt+ott4XzV7Uf1t21wgbO
55XsD/K8Z+3ALdSgshEY31GxM6YtErN2sNBSU52tkesgt3nRHtYqK4d3Wu86
2d/mOMjrnpNYFmsBD182g9QHBxwR/MrAhGWTbBB8BjCwcMj2UPsoHZsL56On
ZwCrJzd2
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYkvN3f4trHkOtrr2BaF7LB2mWk4rX/o3F85P
f+ulJvUn12Gy4WOhnHxLhzoTA987P3MdFuoFaXD/t3BQmDNz1dFvuQ6abzPK
k28A+Vt4J035kutg/+v0ZIEjFg4fLH+tvH0fwa+e8/fO7xsIfhnb6yXdCxD8
ayGskUcP5jrksCt/8zxh6TBl460/6z/lOjy7fcZoqoq1A8y9FpNVNe+vQfDN
pm0wa1tpg+BL/jpjd9LWIXXn0qsVL3Mdehl2LPacbOewX/jv67LDCD6T4iRF
+wUIvriP2329zlyHA+4R6/eut4Xz7wj6ccddtoHzX+jp/VrvYeMQZ5jrmTAD
wd/9sPyy60wE3/1ADW/JPAT/9cQAF4GVuQ6XD/6yP56K4HPd2TU7/SSCn/Mg
IvEIh63D67Of2qYuznXojG1Q2u1u6+D+Ry7g5wwEf/f/EyUd0xD8Sybiee+n
IvilLTxPOIH8Z4Y72cNdbR3i2JNMzObkOlieXKDy7rmtw17O5A3/1+Q6tCdw
GyS52Dnsc366S2Q/gs8+M3hHzm0Ef7JsKt/lF7kO7sf4rXrLbeH8Ve2HdXet
sIHzeSX7gzzvWTu8bwxL8LiZ6xAVO2PaIjFrB5lZfxKMTuQ6yG1etIe1ysrh
0qwjR+f15DrI656TWBZrAQ9fNoPUBwccEfzKwIRlk2wQfAYwsHDw3/FHZ/Mf
BB89PQMA9VI7xA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4oa5+oEnVuc5hC6b0awgZ+eQGZBbMGldnkNE
mP3t8zYI/hMTF9F/jgi+uL5Y24lKOwcTjcsZs5IR/KUbZ+/rtkXwr4hGf39q
k+fgvlIzr7HPzkFyfYbmcus8B5ZLkQdPrbFziJtwSfCqMYKvvyQ8rlUzzyG1
YMqeqq02Dq8OvS0NN0TwDVzaD3ga5Tk03HXpaLtn4yD5/ch9YdM8hz3hQZNb
620dLtun8QhY5jnsY//5ymQekK/+ScURaF/yYvaZ+9faOlyV/2oUG4zgV1qq
KqSFI/hTV03KLZ2O4B/RWewuNCXPwcMs/OzmFlsHM4VrZduqgfxg25n7c20c
Jql81/pQkueQ7yv63FnSxsF4lpWJYWSeg8pm+XMaB6wc9inkHGL3z3OourLS
xjvGEs4/tCP1omu4BZzv/fzw5iO2CH6B4deVM0+ZO0xQE09OiEXwk3UOMe/M
xuTD9MP4MPNhfEcu587fNxH8SRM3b1ieZokwT13wofwXS4cbP5fNN8vLc0jh
Mvx0ts7KYVLCzNzS/DyHY3bb207sBPINNs67Xpzn8OG3uX7fNGuHmuxVFtMb
8xxEI7M1vpraOKCnJwAnTgXQ
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{247.35105285000012`, 28.5221045625}, {
     246.8980640625001, 28.816313775}, {246.85914750000012`, 29.14943955}, {
     246.85914750000012`, 29.3160024375}, {246.85914750000012`, 
     29.9137608375}, {247.49893578750013`, 30.3262764}, {248.19943391250013`, 
     30.3262764}, {248.91861198750013`, 30.3262764}, {249.54906030000012`, 
     29.815691100000002`}, {249.54906030000012`, 29.1105229875}, {
     249.54906030000012`, 28.55168115}, {249.1645646625001, 28.0800124125}, {
     248.5730329125001, 27.7375466625}, {247.35105285000012`, 
     28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQ7TfNYrq/ZL5DDZeqRdR0awdFj7O8Ifr5DvyabB4m
X6wdjr7cURpkl+/QV/X4/8syGzhf0KfeYaOMLZw/w7ch0ZLFzuFj8THHy0r5
Dr0MOxZ7TrZz8Ema7LaODcFfnrfxzenneXB+/FeRKXvP5Tko2NTX69+0hfNt
pul6rHxvg5CPTPW2PoTgL3J/Hs4XaOPQd9hu2anbeQ737t3Sk7xt7eAptLfH
6n6eg9K2VbfP77F28Joy23fPqzwHVstmqZu11g4yjxYtafyU53B53Q8b02Br
h/KUp9MtH+Q5zCs5zv6I09rhktsPDd2jeQ4H72Vez6yxgvPT2Jc9UWuyhPO5
PjTpRpdZOBgtPBPg9zTPQTh2z5G/Z8wdbtRYHU4E+hfG/6Tae/GTJoIfNOPq
g0fu+Q4z/dw+zJpnAeffk1h+zGCtJZwvMtn8AA+HlcN0z/BfRS75Dje0dXbM
r7RyqJ/3ZHOhRb7DJsfT8WxPrBzSN34qKDfKd/jbEb+RTdLaYarrrIp83XwH
3ctdpxSNrB3Q4xcAUiHgzQ==
     "], {{247.80559830000013`, 27.178704825}, {
     248.0795709000001, 27.0121419375}, {248.54189966250013`, 26.717932725}, {
     249.01201173750013`, 26.4143835375}, {249.28754100000012`, 
     26.2275840375}, {249.74831310000013`, 25.933374825}, {
     249.74831310000013`, 25.335616425}, {249.74831310000013`, 24.6102117}, {
     249.0135684000001, 24.099626400000002`}, {248.20877388750012`, 
     24.099626400000002`}, {247.36506281250013`, 24.099626400000002`}, {
     246.6598947000001, 24.7082814375}, {246.6598947000001, 25.5208592625}, {
     246.6598947000001, 26.0905977375}, {246.9727838625001, 26.717932725}, {
     247.80559830000013`, 27.178704825}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQPeFP6O0Tp/Id/v1Y5qKrZu0A46sdnnZY+JoVnB/U
XqC+psfC4bWI3tezq/Idyi8ulG2UtHDokXv+5vUMBF88P/jThskIfsyG3gqp
ZgS/KyP59omqfIdbru1lLGkWDsWLY0o7OhD8FwWOgmzd+Q7NhacXda9D8PNL
7lefvIHgx33feFdCzdKhi2OybS/QfNbF5o193pYOotnTCtbWIPg6F85YbCpH
8J1TX58Pyct3YJ58oHuxKYLfdnBhzP+rFnD+tdZMzSxDC4eF6W+85erzHYRj
9xz5e8bcofTljM8tMxH8RBbFLRMPIvhmHGtkqp7nO+w+/erQFmVLOP9S3syK
NY7WcL7lyQUq757bOngdlnB3Ppzv0MuwY7HnZDuHsmDms+bLEXzx8Ptcj6Yi
+Lp6tfNq2/Idig6/X3Y71c7hmdl+to8V+Q5Wli+2i3y1dejg2lz6NzvfYY96
1pHnzbYO27adSzmSku+Qp7BD1VcKwY8z2PHsXKwNnC/qlqmarGzt4DI/91Zm
Q75D6Xa3eBldKweDD7uUOxYj+IZyzbu2bkPw960oPNUPdL/FBu6vr6Yi0gss
PQEAnvUUsQ==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQveS82duEJfkOMou1j0ulWDlcSr73JWI+gq+3R/Ty
swkI/v+Te1OV2/Mdtn4s3L6Vydoh5pDKstLGfIe+6SdPf41H8I9PlPB7fBfB
j0tYsDUn0gbOz5zQtDzgIYJf3MB6dXW4rYOrd/gG0Y58Bx+12Jevt9g6XGTV
6+8F2t+qsCb7ppGdA+MDQdGmOfkOT0sW32wLtnN4ZRET0LIcwS/fuNmIeRuC
X2Hvk55zIN/B+qa41M2/tg77Jvx9dOBovsPe4zPV1vTYOlybmszbdTLfIbJ5
zpxj1rYOE/6E3j5xKt/hgEnYGu25NnD+/O8C82ZpIvjxvX/LkiOsHaQ7U5SF
DyDCBz08AWkepKY=
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{257.32547270000015`, 28.5221045625}, {
     256.8724839125002, 28.816313775}, {256.8335673500001, 29.14943955}, {
     256.8335673500001, 29.3160024375}, {256.8335673500001, 29.9137608375}, {
     257.47335563750016`, 30.3262764}, {258.17385376250013`, 30.3262764}, {
     258.89303183750013`, 30.3262764}, {259.5234801500001, 
     29.815691100000002`}, {259.5234801500001, 29.1105229875}, {
     259.5234801500001, 28.55168115}, {259.13898451250014`, 28.0800124125}, {
     258.54745276250014`, 27.7375466625}, {257.32547270000015`, 
     28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQHSzwkMVep8ChhkvVImq6tYNtpraDo3mBA78mm4fJ
F2sHfivFkgN2BQ59VY//vyyzgfMFfeodNsrYwvkzfBsSLVnsHFT/q99iMCxw
6GXYsdhzsp1DcFlfzDslBL+hZq5+rTCCf8fen/kbW4GDgk19vf5NWzjfZpqu
x8r3Ngj5yFRv60MI/iL35+F8gTYOX9RSemp4Cxzu3bulJ3nb2iHQb3G9CX+B
g9K2VbfP7wHy+4USvooUOLBaNkvdrLV2sDKbxn1DosDh8rofNqbB1g4Z5eas
W4Dq55UcZ3/Eae0w7cWBs7pMBQ4H72Vez6yxgvPT2Jc9UWuyhPO5PjTpRpdZ
OBwTXZ1oJ1TgIBy758jfM+YOM5gfSZ1QQvBVI7gXTTBB8EMnrl/Z4VzgMNPP
7cOseRZw/j2J5ccM1lrC+SKTzQ/wcFg5/Mgs2HbBscDhhrbOjvmVVg45IubC
F6wLHDY5no5ne2Ll8EB238dLFgUOfzviN7JJWjt8fz7xq59ZgYPu5a5TikbW
DujxCwBaN8os
     "], {{257.78001815000016`, 27.178704825}, {
     258.05399075000014`, 27.0121419375}, {258.51631951250016`, 
     26.717932725}, {258.98643158750014`, 26.4143835375}, {
     259.26196085000015`, 26.2275840375}, {259.72273295000014`, 
     25.933374825}, {259.72273295000014`, 25.335616425}, {259.72273295000014`,
      24.6102117}, {258.98798825000017`, 24.099626400000002`}, {
     258.1831937375002, 24.099626400000002`}, {257.33948266250013`, 
     24.099626400000002`}, {256.63431455000017`, 24.7082814375}, {
     256.63431455000017`, 25.5208592625}, {256.63431455000017`, 
     26.0905977375}, {256.94720371250014`, 26.717932725}, {
     257.78001815000016`, 27.178704825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{262.31268140000014`, 28.5221045625}, {
     261.85969261250017`, 28.816313775}, {261.8207760500001, 29.14943955}, {
     261.8207760500001, 29.3160024375}, {261.8207760500001, 29.9137608375}, {
     262.46056433750016`, 30.3262764}, {263.1610624625001, 30.3262764}, {
     263.88024053750013`, 30.3262764}, {264.5106888500001, 
     29.815691100000002`}, {264.5106888500001, 29.1105229875}, {
     264.5106888500001, 28.55168115}, {264.12619321250014`, 28.0800124125}, {
     263.53466146250014`, 27.7375466625}, {262.31268140000014`, 
     28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQ3TvXagFXTYFDDZeqRdR0a4fyby23edoLHPg12TxM
vlg7eB6v4u/pK3Doq3r8/2WZDZwv6FPvsFHGFs6f4duQaMli5xDf01h6pqHA
oZdhx2LPyXYOvcwvvu8sQvB3cX4/5ZGM4IudXTHvYFiBg4JNfb3+TVs432aa
rsfK9zYI+chUb+tDCP4i9+fhfIE2Dnpb9qp7xBY43Lt3S0/ytrVD9+0/Ugzx
BQ5K21bdPr8HyJfJ+X0gpcCB1bJZ6mattUPJ4ffLFmcUOFxe98PGNNjaYRHL
xAX1QPXzSo6zP+K0drhQKpX5M7DA4eC9zOuZNVZwfhr7sidqTZZwPteHJt3o
MgsHhsUsfzmTChyEY/cc+XvG3OHSBOttk4sQ/PinKbYxLQh+vxyna8jkAoeZ
fm4fZs2zgPPvSSw/ZrDWEs4XmWx+gIfDysHo+8nAORMLHG5o6+yYX2nlsGzh
hHWzuwscNjmejmd7YuUgtVq8d15HgcPfjviNbJLWDoalrydItRU46F7uOqVo
ZO2AHr8AdRDXQg==
     "], {{262.76722685000016`, 27.178704825}, {
     263.04119945000014`, 27.0121419375}, {263.50352821250016`, 
     26.717932725}, {263.97364028750013`, 26.4143835375}, {
     264.24916955000015`, 26.2275840375}, {264.70994165000013`, 
     25.933374825}, {264.70994165000013`, 25.335616425}, {264.70994165000013`,
      24.6102117}, {263.97519695000017`, 24.099626400000002`}, {
     263.1704024375002, 24.099626400000002`}, {262.3266913625001, 
     24.099626400000002`}, {261.62152325000017`, 24.7082814375}, {
     261.62152325000017`, 25.5208592625}, {261.62152325000017`, 
     26.0905977375}, {261.93441241250014`, 26.717932725}, {
     262.76722685000016`, 27.178704825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{267.29989255000015`, 28.5221045625}, {
     266.8469037625002, 28.816313775}, {266.8079872000001, 29.14943955}, {
     266.8079872000001, 29.3160024375}, {266.8079872000001, 29.9137608375}, {
     267.44777548750017`, 30.3262764}, {268.14827361250013`, 30.3262764}, {
     268.86745168750014`, 30.3262764}, {269.49790000000013`, 
     29.815691100000002`}, {269.49790000000013`, 29.1105229875}, {
     269.49790000000013`, 28.55168115}, {269.11340436250015`, 
     28.0800124125}, {268.52187261250015`, 27.7375466625}, {
     267.29989255000015`, 28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQXX9V1e7a6QKHGi5Vi6jp1g6ZegWVN64VOPBrsnmY
fLF2sP6fujb8XoFDX9Xj/y/LbOB8QZ96h40ytnD+DN+GREsWO4fAIznCMy4U
OPQy7FjsOdnOod768tTWQwj+GsdHGSKbEXwO1ik2vcsKHBRs6uv1b9rC+TbT
dD1WvrdByEemelsfQvAXuT8P5wu0cVB4s+Ko8NoCh3v3bulJ3rZ2qBV+seP0
ugIHpW2rbp/fA+SHhM/s2VLgwGrZLHWz1toh7fctl/wdBQ6X1/2wMQ22dphi
U2Pnvb7AYV7JcfZHnNYOh9aysh9dWOBw8F7m9cwaKzg/jX3ZE7UmSzif60OT
bnSZhcOnW+9nXd1Y4CAcu+fI3zPmDkdOqIXEH0LwA2UDbqtfQfAbw748kn9c
4DDTz+3DrHkWcP49ieXHDNZawvkik80P8HBYOajob32f/rDA4Ya2zo75lVYO
M25W+6TfLnDY5Hg6nu2JlQPPYybtrBsFDn874jeySVo7KK+9pvfsaoGD7uWu
U4pG1g7o8QsAUijeRg==
     "], {{267.75443800000016`, 27.178704825}, {
     268.02841060000014`, 27.0121419375}, {268.49073936250016`, 
     26.717932725}, {268.96085143750014`, 26.4143835375}, {
     269.23638070000015`, 26.2275840375}, {269.69715280000014`, 
     25.933374825}, {269.69715280000014`, 25.335616425}, {269.69715280000014`,
      24.6102117}, {268.9624081000002, 24.099626400000002`}, {
     268.1576135875002, 24.099626400000002`}, {267.31390251250014`, 
     24.099626400000002`}, {266.6087344000002, 24.7082814375}, {
     266.6087344000002, 25.5208592625}, {266.6087344000002, 26.0905977375}, {
     266.92162356250014`, 26.717932725}, {267.75443800000016`, 
     27.178704825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKL37sW/da6NCh+ernyR/17B2gPGbpSTtMz5bOyyx
XXFVFci/xXhdtHivjUOP180b23UKHS5d+eMUWWHrIG5w+sVE1UKHfwu/PODM
tnO4sN5x13WJQodehh2LPSfbOew8oWMYKITg79C71cHAieA/bX+fufpvgUPH
haDDHYF2Dn+qzzUFfi9wuDhlbt2FNFsH4Ycs3mGfChz8lC/ddtlh4/DHKn7R
hI8FcPfB+DD3w/jea79Lr822gvPrvkxXV+ywdHBqCFv1F2j+L6fcAzwnLBwK
hd9N3fuvwIHB4MW5ub/NHURjvpnqcBU6RIhIz2A8ae4gxvGA+4Yggr/o0LZX
/lII/svT3BvM1QodFkevf8n4z9zh0kX/u7K6hQ5PSzMzXry1gIdfxnMT7pI5
lvDwNf7wdnlAopUDevj/C214rwUMLwYwsHBYGKd5WoAHwS9M+7L4JlOhQxLL
vKMx9hYOIt75KpwMhQ4eXvLxyw0tHbYrGxgGAv1jN7eNueYkgh+4tkT3wkYr
OD/Od96mW27WcL7qtRnHlr5A8CttZ4jM77dxKOxS+t//v8Dh1JcPXC/FbR06
JUIOtAHtP/O80eSEi53DQretjx35Ch2i2J4Z1Ufbwd0P44udsT0ZJI7gu+7Y
UbNIsdDB/qSsmaCenUOs2yvbmSqFDk8+RjqfM7Z1YPhd814LGJ7sMX+EwpbZ
wPlNqy6udnxmDefD3A/jH/LbmDWh0wrO15ig/PzcXUuHxZdt/xQBzU9g17zM
bGPp8KKCdZG0UqHDjdQf/tu9LRz00jT/GUgiwhc9/AGo31eD
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKL1W2lJme1Ohw/PVT5K/a1g7wPjNUpL2GZ+tHaaV
Ti7+2FjocIvxumjxXhuHuqYjZc01hQ6XrvxxiqywdeDM2NYWW1ro8G/hlwec
2XYOh57rRCzOKHToZdix2HOyncNqBonzMkkI/qq0o2pnIhD86/tvsZf7Fjp0
XAg63BFo5/Bu804FWfdCh4tT5tZdSLN1YJX88ELRqdDBT/nSbZcdNg7virwc
YhwR7oPxYe6H8b3Xfpdem20F59d9ma6u2GHpYLLD0eMk0PxfTrkHeE5YOCR7
3zTu9Ct0YDB4cW7ub3MH9ikPL3+PLHSIEJGewXjS3IHD4fTKxYkI/pRfCzuk
sxD828zffZnLCh0WR69/yfjP3OEIp3X1S2D4PC3NzHjx1gIefhnPTbhL5ljC
w9f4w9vlAYlWDujh/6E3u/cb0D4GMLBwmDxNJPNONIKfPO++49KgQocklnlH
Y+wtHNiaow5d8S908PCSj19uaOmwMlr6vAzQP3Zz25hrTiL4gWtLdC9stILz
43znbbrlZg3nq16bcWzpCwS/0naGyPx+G4fkQ7xzo4Hmn/rygeuluK1DdYB9
XBDQ/jPPG01OuNg5TK5b0MgbV+gQxfbMqD7aDu5+GJ+DRTNdLh3BN/+wWCqv
sNDB/qSsmaCenYN/3dXbKSWFDk8+RjqfM7Z1+GSU0fsNmJ7YY/4IhS2zgfOb
Vl1c7fjMGs6HuR/GP+S3MWtCpxWcrzFB+fm5u5YOU7k1Z9kBzU9g17zMbGPp
cGvDB/vnQPtvpP7w3+5t4aAwT2TOnwxE+KKHPwCd/FPr
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKK2p8Dcx8FKhw/PVT5K/a1g7wPjNUpL2GZ+tHYSq
wnd2Xyx0uMV4XbR4r43Dr7aOPbJnCh0uXfnjFFlh69CaU3Xm+5FCh38Lvzzg
zLZzsHvzYa7tjkKHXoYdiz0n2zmos94R2b4RwVfL7sxJW4HgBx+Z5ys4t9Ch
40LQ4Y5AO4esHbVp26cVOlycMrfuQpqtQ6PsFr09Ewsd/JQv3XbZYeOQVc7X
9m0Cwn0wPsz9ML732u/Sa7Ot4Py6L9PVFTssHTbsYe1Lnl7o8Msp9wDPCQuH
+/5zK5XnFTowGLw4N/e3uUPzjKWSk1YWOkSISM9gPGnu0OLS/952I4Iv8D/1
3NadCH44x+7Jc48WOiyOXv+S8Z+5gwPf/wPNwPB5WpqZ8eKtBTz8Mp6bcJfM
sYSHr/GHt8sDEq0c0MM/Z5L+5QlA+xjAwMKBf/aNdWWrEfz7ixa32y8qdEhi
mXc0xt7CoaldjiN/fqGDh5d8/HJDSwfVhPsi24HhaTe3jbnmJIIfuLZE98JG
Kzg/znfepltu1nC+6rUZx5a+QPArbWeIzO+3cbh/7OKjr8DwOfXlA9dLcVuH
7yHMS94sLHQ487zR5ISLnQN/c8rx5WsLHaLYnhnVR9vB3Q/jt3C8XbNjG4K/
+Ut6AsfBQgf7k7Jmgnp2DqebZir+P1zo8ORjpPM5Y1uHPHOdyxOA4cke80co
bJkNnN+06uJqx2fWcD7M/TD+Ib+NWRM6reB8jQnKz8/dtXQQFHh7/wbQ/AR2
zcvMNpYOYVu3tDYC7b+R+sN/u7eFw5xFNx5O24EIX/TwBwC9WGOa
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYh3Wd11aFkUO9jNN0y93OjgsMJy8YrVtkcOs
vce/7M9wcBCNszim41zkoOTzraTKzcHhwhSno2c9ihxu6fgymKg6OBQfezZz
qVeRw2RZ6cYbkkD+iqk/knyLHA7oPznux+ng8N94ikqpH4Ifc+OJVXEAgl/y
/uGk6UFFDofatxcvk0Dw11SFhP/UQfAVvyidVDJ3cOhWMej5F1jkcOfO5/DH
zkD7eI1NbvkXOTQciNtzy8fBwVnpxJxDlkUO27Kut4QsdnBw3aqbnw6UfyMS
4HvuJ5Cv1ip3DGh/xeeQ9j//EOYv/6twp4/NEc6f+GHv/odSCH7N46jFJvqO
cPfXWuv599g5wv0H44tlPpK944skf8imVAzIX7P0lGOUraNDV06PU7Z3kYOZ
zp/zBsaODrDw17GpXHR1D8L9P/5c7XDtcHT4O6Xk3gsg/9QrHqfzMxzh8pEH
RboktwHl99V/FjJD8M/9/m+x1RiJP6HV+ZRhkUPb5bsX+pci+JufLhNnm4rg
q6UXVQu3OzpEcb11bDRBuCfiEWPqcQVg/ATFHjht6OjQfjXz3SE5hH9gfJh/
2x4qJ62SRfAdcly650sj8Vt2FOVJIsITxoeFN4wPi48IuSXLfYD6r66XbD0J
jC/HhC7xHTKI+BQRku/bY1Tk0M5gPaltCUI+KOzQSR4/B7j+Y+V7++95OMDN
n5b70crHEcGHpTcYH5YeYe6HpVeY/2D8JyKyJz3lEPzfuw4V8ssXOUw66n61
gQsRfuz2Yu6rRBzg4SuoP7OEtdsBHv7F8vkrzpXYw/k7zOZJ8mUg+G012rln
HO0dOvLWVN0Gxu+p4N+Szcr2Ds4+lze+MUXw4ekFjf+MgXuVeJw9PP3ocTiY
9zfaO6DnfwB5g8M+
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtM01cUAPA+iEDqRsxYaS1IRC0wO1SUhbnI//w3cQyQjJqxzfEIRJYZ
GLBbaBgC4jYfjEKhtvNBEeVVQSi0WwUEeQxFsAgMcUygzo25IdAoIA8LC7uf
ept9OB9+Ofec3JyTezfHJYvj2QwGg4kjAgcLx/Rw1YriOgLW3N2LpqcAN83L
T7IbEQRvSHXayqGhyiUhSdCC4NWMHH/+CRrkKYZqt25iDfcz8YSN2wSdmbV3
iduXFJsX7yF4xaNO1vkVznsee362F4F49vj7ygQaZoQlZimur/u3xKwLJX4r
8q9L/T7Ee/a87HQW0BAcNv7YpweBwP7qjSI2Da7vMVKO9BH/WpQdMTxA3C4K
KhgYRtBx+LC+nk+setw1xg8h/m4+rObdPBoEfcZ1CiOCP5+hxPNqGh5kbMzb
1008IwsOFN4knu6ZOX0Nz8ukuVDhEEVDTHfzXLcBgaOvJiWXpqEgTHNqRIdA
/7r87/JCGpjKQU1MNakfmrw1PFhBXBbQ65ahJJZ0VfJz8xBUpcXHXlgBq1ss
69nh48SR/QwUNQDATfc3bswnXrv9m/ZLGzeLjJm1BcSRZpeybXIE5fvY8he/
AAS+03QyHfuAo4XjZgLIkx1l3sP32bLmOToYS0P5B5I071Ky36mLW2ezKoiZ
3hH6VA2x9KOVgYVaBA1+jI4IKfFZhp+hbydxsPfk4pwDDfdrPRQhNQicjyf7
fK0Ha/+3e0ZVoasUMOOXX7y8gvMJGvWTSApk/odG0tV4/g2Nj3KeB0C5r1ON
QkUcpUuLuawkTj3NHmEXEUuu7fK9geeTkBxCrTpRECk2mNQ4L/zEtb/VlQKX
K7tvrcf93uDtFXwcTryT1yjKOEf8UDLhWTpG6rN/d7SXPaOgbCnz20C5jWsO
7Sj5nnh/8ZktP51CYNdWtOOcllh05oQ2K5r4wyF9hXga39fj82IZ3p/f7SHp
N80BMNke90WiipiZlTjeU0rc8qN07GglgtzVpwumIxREp3YxJrDLcjnFagkF
U9JF1R28L90Ps5VCPgV8btBCUh2pnw5v2vTwOnFsrr3S8Q5xod328xb83jyO
8QzcNcpq91X3lnXuYHWWlyjUsh1A8/N+L3k/sR1rmcW1caHXp/MNfTbnR5uc
orGV+XHOa0KANhlPxMGerV6qt98E1v8ngsU7+dqbFFRxdJbdrWS/QQ6X43wb
iaVXmY826Ijz0YM/8rUISnrNB1kUZfVUh9eSTkFc3ftPSpCRgvvzSaKcegRF
23iSVibALoHW3R/3q5sqnnLfC/D///Q/iDKFGQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4shbK3f+YSh2eLk7OjJtl7MDjL+lqv125kVn
h2v7X28+BOT/YJaTcLjk7LBmacOWNX+L4HyRF8KVq74VOTBsrv60YY6zw+rI
9JqNbxB8/g1huWYvMPnr1Xfp/alwdmCWXfvq8isE/22N/VbuTwh+a/nODv4f
RQ6/Zz3dtHcKgl+66UqV/jlHOH+RTk3twQ0IfnkOyyPdpY4OdWLegopvEfyY
B58ivr3A5Pt2qlRJtjo66Lyz3/TuFYKfeHvRmYwfCH6UQ8beij8I/r+z3cL3
/yP495bZ/17LWwznNxYWvBQVwOTD7I+3ljB8zY3gw8IfnQ/zH4wfp+8r+OIs
gg+LPwAdI9ih
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBWIQ/fho/LNYnWKHZ+e3szavcXKA8X+rlN848dnJQf/b
74uyusUOaXn7BC1NnB32Hu5SszYsdjDcGZhimens4BYzN/+JSbHDtEbmKKsZ
zg4fligt3G1V7OCttrysaIezQ8LEPyKLHRF896eH7R+6IPhqoRXKJp7FDktO
HpUQ2eDsINobNDXWu9hBJ6D74OHJzg7vlycv3O2B4OewHzjd4lbswPHOYa5c
K4IvfGNOM3MOgr9rhZhgapizg8zreh4foP7t18Q5c52dHXie+Twr9kbw/zyQ
PDDbD8G/OjXnRG1AsYPRtJfTd4Qg+LNfnfyzPhfBTzON9d+wyNnh/iKD6sdA
834wy0k4XHJ2YBQOPc3viOA3L3nD4GuI4Ed5GWeaKhY73Px06qtYLIKfsmnH
f495TnD+hINdwbk7HB0u/bWMaNcrdlh62FnCvtjR4ULV1I4uKwRffBsz4w13
BN+prHpOdnCxg2aS4OF3xxB8Bmvz3FM2TnD+puzq3azrnRyM89jLJgPDp2ry
/UXdzM4OFsmmL1ltEHzHFL0/hcYI/kf14wU7gO4RPa27tusKIr3A0g8AACH8
+w==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQzX9+/c43VsUOX/1Y73ye5uhQnLTGqdgUwdeMPnhI
17DYoXvlF+GqDY4O6xKV5zzQK3a4cq0jweG6o0OnvbqArW6xg1XNpc4DHx0d
Hh+NfxarU+ywbNHGb+tlneD8p9qNU3qCEPyaefa5PCucHDrmRJfsNyp2yP+1
WV7zlZPDRduODx3WCP7pVAfP6Q4Ifv7n5Pl/nYsdUk+1L3C65eTwTrHu4j63
YoeZi2KkDu90chBhzz2a4Fns8E//+iLPGQi+rWjBef1iBF8gYWK8sgOCr27i
qfOWF8FPk3wUcfmFo4OzmS5LFtD8dtljS5qPOTr4n7zWdgZovzPHiekbljs6
NGcpZHo7IMILPTwB9EadXg==
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4jP2v9TOHit2aLvhv/XMBAcHF285/+RPSHzj
VelTviD4MQdva3R/x+T/Xfnxku8qBL+4evKHc4cR+uF8qPkwPsx+dL5sUW1m
taoTnH/wq7iBuTmCr7DqvrWCv5PDXFY35rmHEfz80xPv5xzA5MP0w/gw82F8
mP02vgdLN0xB4qeaxtZPQvBVrzPP6ejH5MP8D+PDwgemH86Hmg/jw+xH58fK
Vyc5xdjB+SISbldPWSD4AhoOOydx2MH9D+PDwgedD9MP48PMR49/AIir/vw=

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4ki27sqeaWUOMWYtJU6fXB1gfCanW1s/87nB
+UtzF14IF3Rz0PI/aiQ2GcGft2DF8dbOMgfHn7vLrxxxdci7EZ3/phrBF7jq
df1VGSaf397z9KR5rg6PrmrcYq9C8NvMlia6NiP4W62m/EnuLnNoO9FntHwf
gq84rShZXscZzk8WzU+p++fkIFTlfv1VV5lD4t7ZO9TeOzlsify6814Ngh8W
9kTxbjkmPy736L9Nx50c8jw3y3nXIvgR7LOnHulC8NsX8Fv/mIDgb7NseaA9
HcFf8D07fOkSBH/HK6sQ4VWYfJj9Uc819wguRfD/HLs+j3U6gg8L/3fWF0Ik
/yL4R26uTQ0C+h89/gDgjd8P
    "]], 
   RasterBox[{{0}}, {{323.588, 33.107800000000005`}, {398.348, 33.5878}}, {0, 
    255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H0s1HEcB/Dr7DqSSuapkpqUUjMj97tHH+46FEqcy1OnG6WuuayvpyYl
OadI53HVjgoLlcnhJGuReVZRk6tWo1XrD9Z2Y3FDv79+X+uP9x+vfb/7/PH5
vvfdKVceTzSj0WhryIjI0Mls3kTot5xBoLFXRzBzueDeNiqsv4igKaFfHN/H
hRSZPL8wC0F6nMVsWCqPsnqGKC7j8Cn353vnnWUKwK/S1sOYjKCI1lETVCoA
adKE+dZ47CETcTf3GLYg8bZdjwjBrkIJu4aGLZyw2C4J4FP+pllfppznwV/d
hiXPQASEWHrr4AAPdPPjys5g7Mh8Vl95GLab2nawJQLB7ucti3dWsKON3z1m
AvmUDaihHfr5MBU66X0gBDvybWkW/Qj2npefwnqPImiNji+28BGAltXweiYK
wQ9UY1CFC0A1Uu6XKltlpltSTyJ2VZT+pxe5n5ZLY0ldW7GrOSblEItPedp6
eFuOI3aGNqnlk4oHF+rfRHmeQ7C5offdIXseKGPqGAXkfEN20ZVOLRdUwqHG
AHLfjah7n1sFF6wZt2SKWGxp1T3N/hhs7bilOk266n6AVWxCJHbyxsJRBwkC
ZtDixt5SLuQd1l81hiNIcPKak2mwGWcVv9Mysc0KvvTslXFhOFA+6y7Bztvx
RDEoxdZeH7evOIltav5aX6DAHi1VrEtIQeAinOTQdRzKisrPcpcXbMqPLd8f
/yAnQJUdO1Z2muzr2AOnHEcCtBkOtU0y7OmQAYe5E9iReudyL/K9Z6cfrtwQ
ESAxdn/sCEDQZpJc9TAQMDXWZ/2L7FfrzQ0z5iMELIScqrtG9uvGs0cZrLVs
yszwr5P8c9gCrcosa5ANuj9zbWJyvn9c7TG7ZTb8feopfBmILbG2yTSJVp1b
0acWfBG4vbJsP2/ALtHomh+dxjY+fBXsmkmA7wKDUR2KwCauq3dphAXKLT6u
AzLsKMeiLPpFbH37n66IHASSj+Ip51aCcnMox2ePnk05sTE+oiSfA/6dXskp
6QjWBF1evh/Chf//i3+7UNxA
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzFDMAOUzoInTgk1Pu6jFBgDBVwJ/
    
    "], CompressedData["
1:eJxl1HtQjFEUAPBtSw+PYTSWyi6hGI8eWtNuX/t1MmabiqZUzKzZlLWDadLD
JSkkNlESqzXV9thIVGiRV+1mlWyG6LWRpISkQSNTmbGN75/9bsMf54/f3Ln3
nHvmzHHcEbtZas5gMMyoCKSCSUW3c5ww4yWCFuLa6Q3mXmByaWOhLtydgIrO
rVt1jxHEi7N6XFy9QcLU2w+rsc+5t32OrsAOjG2uvX8JwYp0H064lTdYqCzZ
nCIEVWHBIfurCdoBwpbHRfkCMKg+LiJUCNwfVLH7MgUwzc+Wv+UKggOMRrHm
kAC+9/fEhVRic/aeTJdqsYPCnFJ9mxGUiNFuv0iSNuNWtOFXKnZEk3mqXQ4J
lfLXIr0eQcfyiOlIScIi626Xu0+xpblrvp2d4hS/MzaCqeeqwcjEJgTbFQ7q
5AskyEtsIkQNCB6K3pWsTiFhZM3YVV0tgpVZbQFNQhIk1mUdEWpsbqyb66pK
bA/NnuIZlxFkxKU5bRKRYOF2M6ZeicBudlnVPOr9gOa64tQCnL9zQLKQO8Xf
cht4/fnYWv+Dg+F5//srV+fsmIEtMhgl/duxDS73nggPELTNkqQvSH9sVrp+
aJhL0PXQ1jBX5ymxtaXbbn6iLMy5QB7xJmChIYwlK6T6z7474B1IQJJRbiMo
RhAVk1VYnUDANEPtqXHq/8/iy5HbBAHs5BCWTI2984Z6RPEAe1P4OmWSBgHb
eb+4/TgB8tA+m1vUPDCHqiKlWwiwcnxS5qpDMFDb61c/4UX7sGfa72AF9mRN
XYJxPnb0rlG5rJ5Pu66A+Yu1gg86Tcqfo1S+fplkY7WGB8kibugrqp4UM6tJ
3208eL25QL7kDoLEVhX7mB0PuN0Vy1jXsa8KnAb7VNgOloJPS6h+jv1UWOaV
8CDKZXSXTIHAvjq/kPDkg8UPnzOTlBNPtKd1cfngsKBj7pGLCLJbcyWz1vIh
ak5p0/o8bI/fMz7kFE3x24cQROWzHp1FMPdhv/+iHT+vxq7pjb2zdATfd2V8
yVzg7kW/b7KpHpP976/LFp+j9oO6QNvAwZ55e1WGspxP2+fZQGOCngflf2os
F1PzYCuuazQ+94Su/HH/s9ex33QkhV2uxzbtnzmP5sf1PeLBv/vpL391FFY=

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzFDMAOUzoInTgk1Pu6jFBgDBVwJ/
    
    "], CompressedData["
1:eJxl1GlMU0EQAOAWoqLYUiEClRQhSkUxag2Gtq99jKL1AGIV8ACLB1Y0RNG6
zxuQo4TYQogHCQUMGLWaNKYIXgiigoocGsHUI4pUjFJRFIGCIuj707dEf8yP
L5vdmcxOxn9b8lq1M4vFYtMRTocTHc3xcR+iplPwhLh8YqmzFBw+V19yL0ZE
QDEnbEDvTsE+lf7NvPkyiJFW3LzOxs7cVZMV8gsxlhsrN2b1IQjMDvWNmSAD
+8veKttXBKZo5RrKTDBepXhy/6xBDg2vntaM70UgumUSdOjkMJg6avG3IzjA
qlfVHJFDB7+BKxjG5l3UzBRxKcag5/ly+BSUqtDO5VtIxqyrSZb+49jxD52P
8/NJKGmqGzrlTcHzWfGTUDEJU+BBc7oX9voWb13cGO9JO2R0GXv+qnV0iScF
mwt8yo+eJkH7sn84wIOCqti3pXOPkfBebVXkulIwR9+66qGChBjI18xhYwuN
Pi12ul8OBwxEy1/Q/crZmxEQGUuCPdHgqvuCgO92wTSVfl/GviSP6EZM/kc+
q6v+fMZ+13LFYhpjc3qC1t/2vz8H3xP652DHWkYSrJuxLfNuPFAcIBizD6tb
yJXYntkNtu5ggqmH8cDXx9u/YJtfKyLLaSvyT5OpMgK4XKhU0v8dL7jeKQsn
IGlRmtHlG4Ktu/UlZg0BgxzjrLp+BI37jGjBEAFuFbJKJd0vh9d9LM7bNhE7
NNdPuoxDgUBIqdoyCdDqmowp9Dw42Uxb1OsI+LnBHDbMo6Dzdvvy2iEp45SQ
jJ/KAuzRa9WaES/spMS+U9paCePqIqd+z0AJVAwkGsLpfFZtQoS5Rgy7T07v
LaLrOcaeMLo4TgyNJ7JFPc4UHHxWJkjni0HoXnDf+hsxNlA8rakXm0MGZvZ0
IbD/KBhfWCqGqB3t49Z8RDDNbCghQiRgFwYFNdI+mNWW8SJYAhxlrXnlJwR5
z84kcBZKIGpF7nauDTtANJi2qWeMPS628+l8Ln0cwmk/9ruuO4Mny7GvtSdX
zviO789ndem8RVLmfYcd9ThMfPebO9uK4Fx50Z06X+zJFUE5xUYJ49DGznpN
gxgKg8vOd9Pz4qGqrh9pDoHHre8/xY5gN01W/0h2oxg79g/vrtfejrti+Hc/
/QVL2xXr
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQbZDmHbbVttQhdm1egJidtQOMf+3fuW8rqhD89b+E
Hqz6Yetw9brfe9HAUoenJYtvtgXbOey7eGOFSCSC/5Z1g9DFGAT/3d7gmJTk
Uod5tU8df7naOazgueR0Ja3U4Zj4249Ov2wdWB9yaRSkIPgsa0J3T4vF5DPV
//i5vgPB73hr0T/FytbB+IGOanBiqcOcXTbPd4jYOrzTW819OAXBT/rTv9wh
HcG/vpEh5n020D2nNt9ZrIXgS825xO3RheDzyyvV75K1c/B+OslfJrXUoZdh
x2LPyXYOVztF600jEHyp97UJoS4IflzCgq0x+qUOzy6+yJT2s4Xzi6QWcf1X
sIbzp82bP+N1vYVDX6lY0jzHUgfh2D1H/p4xd7iaINXmHIDgvz3/qnN/IoIv
y9k/cXtBqcNsvatiL3ZYwPkih+X7VzFbwfmxtW2NFU7WDjJKwlP3JZU66CzT
5dQ2tnFIeCOxKTQQif8wL2qZG4Jfdr5g5w2HUoe1KhlN17cg4h+WPgAyv/ea

     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQLf0u10U2oNSh/OJC2UZJCwfDzsypxm4Ivkf2xoY6
x1IH/oYdq8PXWzgwvRI363Eoddiqbed/9oqFg0Gad9hW21IHY94rxTFelnC+
ToCjSaaQFZzPxDZZp9Aewc/P+r3Jn8nagenSYr+9TqUOLbs8Fur8sXZY9ifK
92UAgt9v1O6ZG4zgJ7ZlRy2LQvAr68UFO+JLHRJ0dW+qJ1o7eDM/+RCXVOog
NO3Q2c0sCP6hupmWeq1WcP5f19L717gQ/DsWEgseT7KE8/V9t6kdErV0WBHF
vXkL0PxTGZ1WEnssHLyucNv9BNr/xujP8tuqFg4sEg/O7AxGhBd6eAIAP5WQ
iQ==
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{345.13663545, 28.5221045625}, {
     344.68364666250005`, 28.816313775}, {344.6447301, 29.14943955}, {
     344.6447301, 29.3160024375}, {344.6447301, 29.9137608375}, {
     345.28451838750004`, 30.3262764}, {345.9850165125, 30.3262764}, {
     346.7041945875, 30.3262764}, {347.3346429, 29.815691100000002`}, {
     347.3346429, 29.1105229875}, {347.3346429, 28.55168115}, {346.9501472625,
      28.0800124125}, {346.3586155125, 27.7375466625}, {345.13663545, 
     28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQzXtgdZflylKHGi5Vi6jp1g7fJb4dtd5S6sCvyeZh
8sXa4eTL1z937S516Kt6/P9lmQ2cL+hT77BRxhbOn+HbkGjJYudwf92n+N9r
Sx16GXYs9pxs58CrFvnoxXwE30onY2v5BAR/2nvJzg/NpQ4KNvX1+jdt4Xyb
aboeK9/bIOQjU72tDyH4i9yfh/MF2jisu6YnVN5V6nDv3i09ydvWDtz/cln1
e0odlLatun1+D5Bvf/fp+4mlDqyWzVI3a60dvjxNmHhpaqnD5XU/bEyDrR2U
1Jm61wHVzys5zv6I09ohYEZ3sEZ9qcPBe5nXM2us4Pw09mVP1Jos4XyuD026
0WUWDg1HS59b9Jc6CMfuOfL3jLlD0OY1Cw7NR/Dvs19T796I4PM7Vuk3Hyh1
mOnn9mHWPAs4/57E8mMGay3hfJHJ5gd4OKwcNkla25zeV+pwQ1tnx/xKKwe1
I4wzT+0oddjkeDqe7YmVw6yzHeVnt5Y6/O2I38gmae2wcXpMtefmUgfdy12n
FI2sHdDjFwCkvuLD
     "], {{345.59118090000004`, 27.178704825}, {345.8651535, 
     27.0121419375}, {346.32748226250004`, 26.717932725}, {346.7975943375, 
     26.4143835375}, {347.07312360000003`, 26.2275840375}, {347.5338957, 
     25.933374825}, {347.5338957, 25.335616425}, {347.5338957, 24.6102117}, {
     346.79915100000005`, 24.099626400000002`}, {345.99435648750006`, 
     24.099626400000002`}, {345.1506454125, 24.099626400000002`}, {
     344.44547730000005`, 24.7082814375}, {344.44547730000005`, 
     25.5208592625}, {344.44547730000005`, 26.0905977375}, {344.7583664625, 
     26.717932725}, {345.59118090000004`, 27.178704825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYCYum4KDleoTKH0GUzmhXk7Bz6zX/qFgmXOUSE
2d8+b4PgPzFxEf3niOCL64u1nai0cyhV1tH69rYUztfLELj67haC7ypV8HE2
kO++UjOvsc/O4cWzsq4/N0sdWC5FHjy1xs6h6/rqOuFrCH5x4rslry+UOqQW
TNlTtdXG4ULBzg1XriD4xYZs13yvljo03HXpaLtn4/Cca+nTTUD9e8KDJrfW
2zq4rv/6e8ONUod97D9fmcwD8hdbd5wE2pe8mH3m/rW2Dm7ytv3XnyL44jpX
We88R/CXPele85i9DM7fqzpF0oitzMHDLPzs5hZbh7L5uoYsv0odPIJtZ+7P
tXFYomjHvfBbqUO+r+hzZ0kbh9I79/sPvih1UNksf07jgJXDrvk/rq15XOpQ
dWWljXeMJZx/aEfqRddwCzjf+/nhzUdsEfwCw68rZ54yd1is5Kd+8xWC37t0
cTnrJ0w+TD+MDzMfxnfkcu78fRPBnzRx84blaZYI89QFH8p/sXRw55nm6vK5
1CGFy/DT2TorhyX2/WseA/nH7La3ndgJ5KtLHxUB+vfDb3P9vmnWDpJHxSd9
+VPqIBqZrfHV1MYBPT0BACkAHYY=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQffuz23de2TKHDHHZW4IzLB14u7o9Zrph8jXufmys
OGQB50/t01jMkGXhoGLzOsUNyGdfsKb4uZ+Fg9XL2sfbrRD8daWf55WYY/IZ
wMDCoSFosdttWwQ/eNbZxzpuCD7vUdn8Zz4I/on3ub/mByP4IatcborHIPhq
7V8a6pIw+TD7Zwln2VjHI/gbD/zZtSYYwT9RFHM9MhjhPxgf5n8YHxY+J90d
l31PwuSf6WYynvrEEq4enS9x3vVFT5MdnH+N/a3BwW0IftXi3/e8j9k5ZF95
UXU+AMFvmsTEneKP4N+/uPXpKz8EfwNTzfalvmUORjn3msyW2znA4hdmP3p8
AwCCKNQw
     "], {{356.5120491, 25.892901600000002`}, {354.08832558750004`, 
     25.892901600000002`}, {356.5120491, 29.678704800000002`}, {356.5120491, 
     25.892901600000002`}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4rgyu0++68ocbHXtC0L3WDr0/NNui1uF4JdG
tN2dsbLMYbLhY6GcfEsHhj8/PlSuKHNYqBekwf3fwuHS+rXz3y0rc9B8m1Ge
fAPI350ufG1pmYP9r9OTBY5YOOz8Fzu/cjaC/3/9/R2cMxD8vynX5lysRvB1
eh6X5fWUOeSwK3/zPAF0j9W5E4+XlDk8u33GaKqKtQPMvRaTVTXvr0HwzaZt
MGtbaYPgS/46Y3fS1qFkn7Gpx4Iyh16GHYs9J9s5LMyOd3DvRfCdPmlGr65G
8M+ys1gpF5Q5HHCPWL93vS2cf0fQjzvusg2c/0JP79d6DxuHwirx97vLEfz5
l2S26FUg+E8d5S8erULwt2t1vhFuKHO4fPCX/fFUBJ/rzq7Z6ScR/JwHEYlH
OGwdtnvc6g2rLXPojG1Q2u1u6/A0vqCIowLBn594lOVCGYKvXZPT2IzE/6Oc
vkcAyH9muJM93NXWofDpxCfLKsscLE8uUHn33NZhQdqkRdxNZQ7tCdwGSS7A
8Gm+rC7WjeC7rutSc5qJ4HcXTA78Or/Mwf0Yv1VvuS2cv6r9sO6uFTZwPq9k
f5DnPWuHnUo9v/SB8R0VO2PaIjFrhwt6938t6S9zkNu8aA9rlZWDlr6z7u3C
Mgd53XMSy2It4OHLZpD64IAjgl8ZmLBskg2CzwAGFg4vbe8nPF2J4KOnZwAO
6D0a
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{365.0854727, 28.5221045625}, {
     364.63248391250005`, 28.816313775}, {364.59356735, 29.14943955}, {
     364.59356735, 29.3160024375}, {364.59356735, 29.9137608375}, {
     365.23335563750004`, 30.3262764}, {365.9338537625, 30.3262764}, {
     366.6530318375, 30.3262764}, {367.28348015, 29.815691100000002`}, {
     367.28348015, 29.1105229875}, {367.28348015, 28.55168115}, {
     366.8989845125, 28.0800124125}, {366.3074527625, 27.7375466625}, {
     365.0854727, 28.5221045625}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQvXb+4l/pL8ocarhULaKmWztM//HWNOtzmQO/JpuH
yRdrh8yTjzNf/ipz6Kt6/P9lmQ2cL+hT77BRxhbOn+HbkGjJYudQ3/fqvObb
Modehh2LPSfbOaxlDQwSv4/g3+JOUF12HsE3Oy/4U+5wmYOCTX29/k1bON9m
mq7Hyvc2CPnIVG/rQwj+Ivfn4XyBNg5+29Salp4sc7h375ae5G1rh9V3U0tj
T5c5KG1bdfv8HiBf7mqo3MUyB1bLZqmbtdYOU45GMDJeLXO4vO6HjWmwtcMh
tl+/7gDVzys5zv6I09rhQ3nz4bB9ZQ4H72Vez6yxgvPT2Jc9UWuyhPO5PjTp
RpdZOCgszQ1PP1fmIBy758jfM+YOnyYtEfh4D8Gvf352+s4PCP56haL5G/+X
Ocz0c/swa54FnH9PYvkxg7WWcL7IZPMDPBxWDkE/jdb8/FvmcENbZ8f8SiuH
Y4t/cvz8XuawyfF0PNsTKwertQ3Pf38pc/jbEb+RTdLaIbA85HX5pzIH3ctd
pxSNrB3Q4xcAQFvuLA==
     "], {{365.54001815000004`, 27.178704825}, {
     365.81399075, 27.0121419375}, {366.27631951250004`, 26.717932725}, {
     366.7464315875, 26.4143835375}, {367.02196085, 26.2275840375}, {
     367.48273295, 25.933374825}, {367.48273295, 25.335616425}, {367.48273295,
      24.6102117}, {366.74798825000005`, 24.099626400000002`}, {
     365.94319373750005`, 24.099626400000002`}, {365.0994826625, 
     24.099626400000002`}, {364.39431455000005`, 24.7082814375}, {
     364.39431455000005`, 25.5208592625}, {364.39431455000005`, 
     26.0905977375}, {364.7072037125, 26.717932725}, {365.54001815000004`, 
     27.178704825}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKP1y7WmrWv9yh+ernyR/17B2gPGbpSTtMz5bO1xi
V5u03a/c4RbjddHivTYOu0TCp3p6ljtcuvLHKbLC1sH1l8dSZadyh38Lvzzg
zLZz+Fe5vyzTtNyhl2HHYs/Jdg7PJ616+0gPwX/2I9x1kiqCLxyUq2YrVe7Q
cSHocEegnYOWm4/9Y+Fyh4tT5tZdSLN1cFzdxP6Cr9zBT/nSbZcdNg5arHfj
lPgQ7oPxYe6H8b3Xfpdem20F59d9ma6u2GHpUOB1Ja1fpNzhl1PuAZ4TFg7z
72YH+UuXOzAYvDg397e5g7Nayae9auUOESLSMxhPmju4XIo9kamH4F/oMVn+
0AzBF5/WmXMS6P/F0etfMv4zd2CYc3bmemD4PC3NzHjx1gIefhnPTbhL5ljC
w9f4w9vlAYlWDujhr6Pwb/UeoH0MYGDhcF5jefsiDQR/vkFRQrZ8uUMSy7yj
MfYWDk6ibx/Mkil38PCSj19uaOnw9O3at4+A4Wk3t4255iSCH7i2RPfCRis4
P8533qZbbtZwvuq1GceWvkDwK21niMzvt3GYH7JgtyLQ/FNfPnC9FLd12P7o
Yo0E0P4zzxtNTrjYOZwXMF5wWavcIYrtmVF9tB3c/TC+y7TdrU+MEfziJjNL
E7tyB/uTsmaCenYO3QIZv7Qcyx2efIx0Pmds66B39NfqPcDwZI/5IxS2zAbO
b1p1cbXjM2s4H+Z+GP+Q38asCZ1WcL7GBOXn5+5aOlycu3sHC9D8BHbNy8w2
lg5izs1xa4H230j94b/d28IhxmD5rkOmiPBFD38AKmxZmg==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQzfmA2+LDhHKHfz+WueiqWTvA+GqHpx0WvmYF5we1
F6iv6bFwMHvz/cinhnKH8osLZRslLRzYC68cYKxA8H1mdjmnlCL473YuZ5PM
RfBZpwlZfMgod7jl2l7GkmbhUGXMz3ohH8E3ncV4ma+w3KG58PSi7nUIfn7J
/eqTNxD8uO8b70qoWTqwpWllBgHNZ11s3tjnbengLb6m6VEmgn/d8/izlHQE
P2lKmNG2pHIH5skHuhebIvhtBxfG/L9qAedfa83UzDK0cJgoGv5BKrvcQTh2
z5G/Z8wdqsN0XfwqEPyPyYVLQnoQ/NtPt93wmF/usPv0q0NblC3h/Et5MyvW
OFrD+ZYnF6i8e27rkOr8Nle3t9yhl2HHYs/Jdg413Y82qNcj+D69F87XlCH4
1yvmzzyVV+5QdPj9stupdg4mtQd8WYDhaWX5YrvIV1sH1nSr1q7Ecoc96llH
njfbOsjYnvjzNrbcIU9hh6qvFIIfZ7Dj2blYGzhf1C1TNVnZ2iF54/TtB4D+
Ld3uFi+ja+VwI9Lujn8tgn+zYNHyZ20IvsK2meuDge632MD99dVURHqBpScA
P5gN6A==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQPdnzj8Oe2nIHmcXax6VSrBxWCV9wsahG8G/sf238
vxjBP3DMvlY2v9xh68fC7VuZrB3eORXPdcspd+ibfvL013gE//hECb/HdxH8
uIQFW3MibeD8zAlNywMeIvjFDaxXV4fbOiS39yyaBjTfRy325esttg4rn3yf
eAlof6vCmuybRnYOBy++vHKmstzhacnim23Bdg5m//o++dYj+DW7diX3tiH4
tYzs/w52lztY3xSXuvnX1kFh1X3rnL5yh73HZ6qt6bF1WL1G6GLAhHKHyOY5
c45Z2zpwPuC2+ADkHzAJW6M91wbOn/9dYN4sTQQ/vvdvWXKEtYOfmnDM1G5E
+KCHJwCMJKNg
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQrXHhjIXQnnKH2LV5AWJ21g4w/rV/576tqELw1/8S
erDqh63DWccLF4vOlzs8LVl8sy3YzmGbdVR34XUE/2m+4Vfd2wj+M/Wrdgcf
ljvMq33q+MvVzmFBWbCq4dNyh2Pibz86/bJ1+OvVw3X2EYL/R/T63M+3MflM
9T9+ru9A8DveWvRPsbJ10PZax77hfrnDnF02z3eI2Do8m6HzTv4xgh+VJtg1
9ymCf166yc7nFdA9pzbfWayF4EvNucTt0YXg88sr1e+StXNw9hcxqgSa18uw
Y7HnZDuHs5+nJU66huALRf532nQIwQ87pThj59pyh2cXX2RK+9nC+UVSi7j+
K1jD+dPmzZ/xut7Coe3+dJff+8sdhGP3HPl7xtzh7KnZGQvOIfhPLXNyZB4g
+KLFAiUi78sdZutdFXuxwwLOFzks37+K2QrOj61ta6xwsnYQ6ZlSLg0Mf51l
upzaxjYOEWGzpmw6j8T3/mDDfBTBz7P8NNsU6J61KhlN17cg4h+WPgBTHgb5

     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQLRzxXq3qXLlD+cWFso2SFg6an1+VTziC4DtcNUq+
vb/cgb9hx+rw9RYOv4JnSrzcV+6wVdvO/+wVCweNC2cshPaUOxjzXimO8bKE
83UCHE0yhazgfCa2yTqF9gh+ftbvTf5M1g6/rFUNpQ6WO7Ts8lio88faYV7a
HX238wh++xwOnVMXEfzID29smG8i+IUvZ3x+crfcIUFX96Z6orWDc27q5d0P
yh2Eph06u5kFwT9UN9NSr9UKzv/rWnr/GheCf8dCYsHjSZZwvr7vNrVDopYO
C470TBW8V+5wKqPTSmKPhYOTXa9CGND+N0Z/lt9WtXD405i4XuwSIrzQwxMA
/cifig==
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKM2++rfgA7sKh+ernyR/17B2gPGbpSTtMz5bO3xg
CcuUAvJvMV4XLd5r43BDsD1njUWFw6Urf5wiK2wdkr9X1LQZVjj8W/jlAWe2
nYNM+XvfMyoVDr0MOxZ7TrZzYJ1w64irHILP8q1d5qsIgm/oP/fvfM4Kh44L
QYc7Au0cPJxrxNyYKxwuTplbdyHN1iF+xaZ7Xv/KHfyUL9122WHj4MHEa9b6
txzuPhgf5n4Y33vtd+m12VZwft2X6eqKHZYOfe4sdp+A5v9yyj3Ac8LCYe+t
2ZqbuCocGAxenJv729whUXnJSQWxCocIEekZjCfNHZLO984/I4vgv+tMqXNR
Q/BNJ+901jGqcFgcvf4l4z9zB7mZfwuELCscnpZmZrx4awEPv4znJtwlcyzh
4Wv84e3ygEQrB/Tw95LVa5YHhhcDGFg4vFW9HscqgeDv1V1kfo6vwiGJZd7R
GHsLhwQh2R1/uSscPLzk45cbWjowv757xBXoH7u5bcw1JxH8wLUluhc2WsH5
cb7zNt1ys4bzVa/NOLb0BYJfaTtDZH6/jcPewAuTWoDmn/rygeuluK3D1fuM
IdVA+888bzQ54WLn8JY3udxMqsIhiu2ZUX20Hdz9MH7S5Ncx7soI/sT6NIHp
uhUO9idlzQT17BxW8s642GtQ4fDkY6TzOWNbB59DWs3ywPBkj/kjFLbMBs5v
WnVxteMzazgf5n4Y/5DfxqwJnVZwvsYE5efn7lo6vJ/1uj8daH4Cu+ZlZhtL
BxOHzaYCehUON1J/+G/3tnCo0r0+UVUVEb7o4Q8AkktBow==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKO1oEbp2dV+Fw/PVT5K/a1g7wPjNUpL2GZ+tHbQm
rWd51lvhcIvxumjxXhsHofkP2Cs6KhwuXfnjFFlh6zC35ZJ4UGOFw7+FXx5w
Zts5hLF4vpxeUuHQy7BjsedkOwd7WZMEwTwE36754fYDKQh+9p1vM7IjKxw6
LgQd7gi0c2i6cHWjYHCFw8Upc+supNk6zDTlqRLzq3DwU75022WHjUNTf9rF
AF+E+2B8mPthfO+136XXZlvB+XVfpqsrdlg6nLgSe3Mv0PxfTrkHeE5YOHxP
/3qkNqrCgcHgxbm5v80dZm/4m/ImtcIhQkR6BuNJc4c5Mc+tZuQi+Bri+yQF
yhD8fAXh+9+B/l8cvf4l4z9zhwi1cJ57wPB5WpqZ8eKtBTz8Mp6bcJfMsYSH
r/GHt8sDEq0c0MO/ZVW73GugfQxgYOGgvtng14V0BP/7rt+XZsZVOCSxzDsa
Y2/hMGt+WfDJ6AoHDy/5+OWGlg62FeYJgkD/2M1tY645ieAHri3RvbDRCs6P
85236ZabNZyvem3GsaUvEPxK2xki8/ttHL7f09QLAJp/6ssHrpfitg78udHv
3YD2n3neaHLCxc5BffYeIaasCocotmdG9dF2cPfD+HMUXH8IFSP4p3kOrE6q
rXCwPylrJqhn5/B41secyIYKhycfI53PGds6tPm3yL0Ghid7zB+hsGU2cH7T
qourHZ9Zw/kw98P4h/w2Zk3otILzNSYoPz9319JBU8NV2xhofgK75mVmG0uH
vLM8F28D7b+R+sN/u7eFw5ZdBrofSxDhix7+AET6Uro=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKF19dJ1H+b0Kh+ernyR/17B2gPGbpSTtMz5bO6TI
cy7YeLfC4RbjddHivTYOPjpWi51vVDhcuvLHKbLC1uG6oM5m2YsVDv8WfnnA
mW3nMGHiopbkIxUOvQw7FntOtnOoXNX7+85eBL9CwDq4ZwuCvzQzwMR8ZYVD
x4Wgwx2Bdg57YvV97y6qcLg4ZW7dhTRbh8uHUkUfza1w8FO+dNtlh43DHpkD
OTJzEe6D8WHuh/G9136XXpttBefXfZmurthh6cCUtL2kc3GFwy+n3AM8Jywc
DL/6JXiuqnBgMHhxbu5vc4ertuEMO7ZWOESISM9gPGnucO2lw7XkvQh+0hLx
rbePIvgr1+ZUHQb6f3H0+peM/8wdJm3esHwlMHyelmZmvHhrAQ+/jOcm3CVz
LOHha/zh7fKARCsH9PDfZ/5w5zagfQxgYOGQ6NA1dc52BN/QIzQvdV2FQxLL
vKMx9hYOV3QuvJuyusLBw0s+frmhpUM568Tfd4DhaTe3jbnmJIIfuLZE98JG
Kzg/znfepltu1nC+6rUZx5a+QPArbWeIzO+3cTDMaT4pDTT/1JcPXC/FbR08
f23pEgLaf+Z5o8kJFzuHRA2xdWd3VjhEsT0zqo+2g7sfxr+2dt7ke4cQfNZZ
ku56Zysc7E/Kmgnq2TnIanhzqF6ocHjyMdL5nLGtw4E7d3duA4Yne8wfobBl
NnB+06qLqx2fWcP5MPfD+If8NmZN6LSC8zUmKD8/d9fSIXnrvGP/zlc4JLBr
Xma2sXRYEZWWsxxo/43UH/7bvS0c3rl3ndhzBBG+6OEPAOsycMQ=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4kuX99f73VFzqLmy0sY7QMUhJynVpKhH3eFp
6qeiv6eVHdg/cr2caqPhwLFgTfFzJ2WHmBOBp7Z+0HB4qsSx8OxeJYd9f67H
bdDWdDj11H5J/AQlh6M2W0ximjUd6vVS9lv4KTnYrGvdsnApgv/UclZdylME
/4qMbd17TS2Hlr6NedO7EXy9KNW/j+4g+MwO8Uc6WJUddu1nXnFOTMvhw6NF
/7sslB3O3ElY4XxJ06Gu0G9iRoyyw/4y5t0B/OoOYVKGm/23qTj8uraV/fVh
TQfdw8JXzQTUHP5+W/zpwHtNh1hb9b3vVdTg5kulhQtYOiP4RwxPz2uZguDn
/rXTvfBUDe7+otieO3rK6nD/wfgqgT73GiYh+JZ900+ertR00GH7tyxNTt1h
5f6e4lQXTYdwhSP3D3xVc4CFv0HCDs0QGVW4+2OStQ8Le2k4sJ2b+EFCRN1h
hRT7CqseDbj8gxK1E8mMmg6/eb9PjJ6pBucrr/jnuMQXwZfz2DjJFejvqXu9
Htvs14Dzvdjy/4nWIvhiPHN7vV01HGZVLohXTUe4J7XS+tDL98oObbs8Fup8
UHMwvG/5Pmq9Mtw/MD7Mv3rx1WmePQh+3raerndeCH7GNv7K0yzK8PCE8WHh
DePD4iPsZ5PYJAdlh4t6VluUgfFVaOYtzJCnDI/P2wUPn/bpqTnMKdz/Qny3
Clz+6Ik7xwwSleH6p/idvFfuoww3/4bqzG49PQQflt5gfFh6hLkfll5h/oPx
L51a6Gq2AMHf2xsW9XoH0P7WT18YgpXg4TcrW2fPsmolePge0rYoEg5VgYd/
yrqNH2YJKcL57+7wX5b8qQDnd2VoVU1bo+CQ9b+nPCdIzUFQ/NRl5gIFh63b
MmImT0HwYekFne9Z+PKzzlMFePq5XR/MJ6Oj6ICe/wGuDKWo
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HlQ1GUYB3COoJUYjiGEQZLfruwRZOzvgN2AnGeR5Vpd43DX5YhcBFxc
SoSGGPMAESmOMIJhVCADXTLCOCJIMCAVEBPEBS0HXTGOAUWWZgBDIf5635n+
+P7xmXm/zz/PvA9b/UlEormJiYnpehTrMVvPxIRW1hBFQ65ozSpjiAurh4rn
tQk06Fpqxop286DYvjHTu5KGNuVItnqrAN7+VvGOaieDXGXa2NqswnaOtI8L
Ksd2dfC6ZLjJQNPSqWHzeT5sdGiq6MxloI+52ym/x4cVi+GUZxEMkEkyxfUY
bIVh3ybx3zzkXdCm+6CMB7cPX6vSfszATEH6l4EiHsz2mZ++3ohd2jK9/Ps0
Njch59NMsTcc+ctf0/EVtt44bpO4m49c+L5tKEshgJk9Ha+qahmw9KoOjz8r
gLxAXYByF/ZcYt3EeCeNPMW9ZStKosFo40sRlXzweHW241kwDd+JDqq3ePHB
5njGyiKLhpAbtr5FBwQQco9lk5VNob7KXT5WIMaOzi5NJWgSOel2jKddrRA2
Bmm4CU48ZE306/WSM1zk+brR5PQkLpQ7nwr07MTmLBUcVfVg96qb4oJGsRe1
R5vujwmBlWR4MHiQCzmyE08tnwih4psrg2mVXJiMr9DJxSRYadNZkp/4oCGZ
aceHJNrvH9LQmjiaQpby1a39auzSuZaSB79SAEH66j1m2ANpugzhUx7yxTcz
Dvfv4MFH+zyaRSUUDB44rRpfcEfz59fyB8rZHNg2ddLw1hvr76WcP/vGCTC6
0ZbWzSSI7gTErW0gILZ7gfw+EHu1Pjo/1xs71UZs2rEiRNbIXVrYvUKIkqds
Xgwh4N+OKO0OCxJuuln7Z6oJOF/3nj7Mn4S71cGjPwxgP6qWvDAq2chC5Znn
fgY26me9O/WjI4sDkfaDfaOPhMg7Jb554WXYmbIv+rsUQjg5u7jqmcdGHjk2
+nJ5gkDeJjg0LF1zg5Sre4ND9EIY+sfoYiF2g/YyTydpAInsl9yrtJ7GnhxO
CXENoKBkv66gfYEAxzGfyoZQCrpzZkZ87NgwbJE8v5RMweNzrbNhMQT0LB+f
SO2hcP/n3M/tVDSyZOtnd5xiGWQfw2UHwSwDPYmvWXnyOcgr8ZGFzhew0+1z
hybvc6CuW+aYpsfO+uVY18Nb2BTx9Y2iVuyLkqLC+PX/PXghzvjiGgdcEvIj
yHoGwKkp3vU8B90fjwzzS+4nCCgJt/O/2kCj/bZtMrlS+yF2xWaXtHMvKeQN
XYqGWD0F7WaX/cx02BFG9+K9cjbykFlNdvFvbNivn1NmP6Ggx4LRPvfigF/Y
4wKTNQool+1hR+y3wP/v6X9FKEbi
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4qM2c7W9fps7rOJ5nDcjy8ABxnfosiqeP8PA
Yf6U3edXfjd3ODEn/Y33LAOHXx85b3oeQ/CLJOyU1MLMHa7/Ulqoq2/g8MSw
NHzaNjM4X3dGVtrTPEx+3gl7447z+g756Ret985A8NnSvj+x5DGH81v4p8uU
55g7nDv1TdFd3gDOb/m8MjlURRPOt7jjnjd3nQac33M7g8G/QcNB8v+Gpf17
zeD8X3N0FZ5UYfKf+L1M+Ptf3eFb5b8tmbMQfE9f3WjuInM4/+Gc5nSuzQi+
bPmek/kvkfisv1zijlnA+f7r2TTuvsHkw+w38G1eZLgKwYeFPzof5j8YX+t5
915zZU0H9PgDAJ8pz9s=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
     1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYCYttXz/NuO9k67JLMO/Dd0MDhnI5jel6IrUMh
y0oRbXcEf/qaroLTXgh+heAyjellBg4fn604YtltDecnfq3X13RH8EuXcUys
MEHwpZqkvRK/W8H5npO7nhfMsXK49eSDp3ydgYNVnsFX8ZlWDhKVkcLN3QYO
PZsVFU5PtnIoSPLwU1tj4LBI7tYLiQgE3/3Xm4WM0lYOVcf2pTSX6DlI8azN
zwlD8LUM2ZOORlo5FIsndgmt0nPYXZwQFZFt5WDhY+IhOE3foVr1hOa3NiuH
bXdZ7ofs0nd4tt/+2IspVg55J+yNO87rO0QHNslbKlrD+VM+7CnVskbww07+
Z1XbagPnX0s1SH9Va+Pw0Kssp8RS3+HF1FfKR1RtHNo2SHlnROs5ZLNI9TYw
2jg8ipu5veu7rsPe3WdtXOWtHV4cvBupPUHbwfj6wt0LuKwdTmgL2K4M14Tz
T7JdOmrWogHnZ4Zt49eMRfBdLNJuTt6h7pB8vM5cMQrBlznVoeO3GpOvo+3r
5RipAeezGVl3y3Ug+G7xjrM+imnC+VO195z+elzbwTswbUnQR2uHCzeZnLxZ
dB00Jgd9XGxj4zBPzfie2RFdB/T0BAAHZvW2
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4i77w7NNdZwcpl4UKjXIUXHwmv34zrMOZzjf
57bTwvxZCD6Hz/lVqpsw+fnis16bXELwPWMVkywtVOH6YXyY+TA+zH50/jvz
k66v92nB+Q1uxgm3WLXh/D/iQf11qdoOInmKdVuEEPy5c+oTjH86YvBh+mF8
mPkwPsx+7tW/BQNmO8D5XNlzfI93Ivh+v/hdBIsw+TD/w/iw8IHph/Fh5sP4
MPvR+Vkxk0+yHJaF893t909RM0XwzeqXq7iVyMD9D+PDwgedD9MP48PMR49/
AIXuyr8=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYlW200px30IcFjy9ovnqh4kDjP/6T8MaHyNT
ON8whP+RiLmpQ5bmFvbWFwi+Rb5jtPOhEIesbBcDvnkmDpV+fL/udiP4zI6n
Zl4vx+Szf4+73hVo4uDl4rTUuwXBv3nM+LDjSgR/2vX3entOhjh85Xy1dPNE
BD/IK5nf46YenB/lHip8REnPgevqnpnXj4c4hD5nT0l9quswMbhEZXk/gi/t
ZnBkQTUm32P5uppp7roOVUI52yMmIviKXNyT7Y4j+Hfz7mrwPkDwZ11ev+/2
DwTf8bTfrIN6oXD+guldvZUumHyY/VpdbrrFBgj+Ro5/251+INwHC/+Ohzev
6Mvqwfn3IgIkRG4h+LD4AwBPQMcl
    "]], 
   RasterBox[{{0}}, {{43.5078, 10.187899999999999`}, {123.30780000000001`, 
    10.6679}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQ/TDzRWhwhpvDym99+yO9BB1g/H4bgcglNkJw/gdt
hX+rTWQc2L4zy0UwuzucEkl6Ir1A1iHwWPArX2cE/0Q6r6VhIoJ/Rl277fRU
d4d15lmtLzNlHRbMld3ltdHdwW9BhyuPtYxDu8OTx5rzEPymGVZ1cemYfAfb
bakHSqTg/JDv23cF2Ug6/LT8csax1d1hifZxqSdLJBzOrn/GcHABgl8kzftg
7RYEX+L4pGblW+4Oa7IXf+j/g+DP2yi3VqFaCs4v2htT9eqEjMO2JBWF7sXu
DlnOW3jU58s5cLVbzgmxQfB1NtYsD57rBuf7WE8I6Pvq6nCuo1w1r0sSzv+z
KmbFn6sCcL7NO6/G3W4/7c8+cdgyu93NgWeNbtse/Tf2rPYJV478QfBPb3/8
aUmHO5zv2chqkMrg4dDxbnFK87U/cD737GUloQc5HGD8VWbvmh9FCzo4eKr5
zJ3g7vDkZteiNXKiDsmzQ0zCWBH8GGeW8tvr3eB8oS3C+XmNbg4vLpe0x6kK
O6CnDwBSRO3z
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQbbzyz7FJv90c7GTyLgo/+GT/vPGmn+saBH/eJImV
c9rcHA6x3txUY/vHPr/DJ4Sr3s1B6YDx62tT/tk/zHwRGpzh5sD8xmPWk29M
DjD+eebNc73MOeH8yk0OCV3zueD8T68OetpHCzgUnFgtMXmCm4Ob9nemzU4i
DhNlU/k+M7rD+TfPHHsvJIbgZ2a/LLvtj+CrmXjqvCxzd9j6rePR/GuCDluC
1mot6HV3qJt5b8v5FAE4v7Ki5ETRWR44P2xT0PftvzjgfG/PrD+y1qxw/oPX
UYZCQYwOs3lfWPtVuDuUTXw+v5Xzr/36W68nFwW5O0wxFinfs/Szfc2PXq5y
CXd4eKGHJwAY2aE4
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQXSv6YW5cmofDGtuJZ/pTWB14j4to7NzkicEPuJ4n
1pX/1x7Gl3t3U5PnxXf74+FC3EobPB0cWKWNKs2+2VcdWP5/bTCCL6UScnuy
JSb/Gkvgd0aPj/aruC5LnMxB8G08VZnC1iP4QvOXxSg9RfBffFHf/k7KC873
Onl37do4BP/W+pjXjyZi8mH2VwtzHj9RjuDr1szbHSKN4D/nmTNvr4QX3H8w
Psz/MD4sfD5tOSS6Ziom/8SDPZNXnWB3gKlH50+pfS1nEiMH5/cldDiy6srD
+XLnD/3Uz5Z3+Cv5f1cWC4K/jeusNf9PTzh/Hmu6oNtXBF+zZ8Z8mdeeDn8+
+nbeeifnAItfmP3o8Q0At1jiBQ==
     "], {{51.49590193000001, 
     2.9729816000000007`}, {49.072178417500005`, 2.9729816000000007`}, {
     51.49590193000001, 6.758784800000001}, {51.49590193000001, 
     2.9729816000000007`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKG2p4vhL7q+Pw4UPabz3vgo4wPjOqy2qFsqLONR/
Ft768ZuPwzwPg6tn3MUdDkbNOdd42sehYcrxzlRjKQfJdm2/oEk+DnonlzFq
/JN1eNRy/2aDjo9DlvMWHvX5cg7KPhYTfX54w/myNYv9jq9F8Ltc/cLlgr0d
Qprlu5VnyDo4PHOV81fwdqia4lXh9FbS4Tvfz/jSH14Oeedk3gobizvY3Dst
5fHJC+4+GB/mfhj/6JvU25mMPHB+tFqGBddTFod8jraoDareDnkmqv/Onvhr
/2Kh0/b10d4OF1iuPL3H+NGe/XnLdpXt3g67p7B8Mtvw2p7H/VJa8xcEP1+6
I9bJwgfOX5pq0NEw3ceBab/bJAWNj/YfpgR82njOx2Ga4Rc7F2EGePit2+sf
urCdFR6+LCwS1m3ruB3Qwz9o25Vmqe/eDtdYAr8zeny0T/0tk+h5DMF/bVmq
PqHG2+GPl2HgOduv9gzxPto8ad4Oa64s+mJtyOQgphI80SfC2yEi5674w/ds
cP6XN77pTUZ8cP6aMl+P7FxBOP/0TPMZ078Iw/lS5qYXaiaIObyIfMbgnOTt
kCAyY+WSjRIOS04Vcf2s9HbIeHDbXzFV1iHdukb10nVvh3lROZ5/98vC3Q/j
C6QfCIxU8IHzu09Mf3utyMfBKM07zJVL1sHdUuV7T5ePwzEOm25LRUmH+Hs7
m6WA4Rmw8ejJiNdicL79ayld9tfCcD7M/TB+zQ+jwJYPPAh55qMmFZPYHUoX
H3gZ1enjkLf3wxT5FiaHRWf/ii8o83EITrr+rYz5m/1pc9mfXvo+8PBFD38A
kztXqw==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYZY1obvz/B0C3iysXdPG5lDiKvHV3h/B3yny
er2Qp78DC/+hSYnyLA5ihg3e0g7+DsXfLe2i5jA4LDivevCAsb9D7vX7uZbn
/tnP1/8W90fL3+HYCgET7s6/9vfcVuyTuOEH53Nd3No1cw+C/70ie9WNW75w
fvmmK1X74/0czuw9sCbgGZtDgaoWV5ayv8P5DeyeoU8EHGDuFenLUqplFYbz
eWZNi5D8IQbnCyzbs/F3mbTDZpew3N5/fg5Zzlt41OfLOUit23ysNQ3BV3vM
PnfZTV84v7r/xuTUWl8HswRT6+8C0nD+sg6e1RXzxeH8K3960g6UiDrMUCmx
0d6F4PM8m5dycC+Cb5uwyafqEoJ/Zhmjxus/vg4NHvtrZV8i+DEb97+ZVy4O
5z87ZM4sVCrhcGpalxHDc1+HiO1X2d8WSDpYB1iH9+9B8LnjHr88vQnBzzCS
OZ++AcH/UvBx2cU1vg5nOHbOiUmXdJhZ4/6i6aSvg1RauMDOj9IOwm3eN1bw
+DkEHGa060yWdZDMC2H6G4LgWx3m/RFzDMHPvRoc8O23n0NQlHCaqYEUnH8v
/pHJyy9icH7WUoETqqeFHe6kSc44vdfPYc420xtdawQcJhzfOKu40s8hSnrf
A70SHofUUxd1Vbt9HU5cM25JVvpuDwtfPdYlf/lTvsL5uTJhsTqCCP41lsDv
jB4f7WMcNp0q8/aH89HTMwCkn0Ol
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H0s1HEcB/DzdAmzHHHHyVKX3NVKUhjuUx6O9PClO6lWnu48hG4yD7NT
blK0VTpHxua5LCMXcrdwTteTlB6kRQ/D0oOp6yxDXdbvn37frT/ef7z++fzx
eX/2WRsvjhSZUCgUIyJBRIyJnLs3s89UjiCv9ucz5+M0+BK9q8D3AYLvI/pK
aaotGBvLLw19RUBTLnmFutmT5i8o70T6MUhHxl6XXRczIXAydnNiJ4ITgV1W
brVroJollJvlYidlfh9r9sH2YuwdqrdAcC+DnXCRzyQNVb/n+WIG6Y5i6rCa
QwcXfrAojo7A/oiH8vUpB1gZE7W1kI1dUf+l5Ic/9vum2HLhHgRPWLXJyYhO
usZa6H87i0G6yi4v2kTsBNr+1KD9m7DlA4cTGtdhv5VkqVp2IKC2Cno2sJ1B
Ed9+BsUgeGwX/9GpzhkE3XE5J7OwDzW02DRewlbOfLZMUSAwcBzXzmmYpBWc
AX+2B4O0upiiN1XRSdOV2bzUdHswsILfHK9DcHr6k8ah3Q5+6WvP911EUO1n
IZl5RAOBzJOpIvb9wXZ8Y30LDQord+tCUrCr/uQqw4XYimGfK5kCbGkdd5Id
gT0/4NtsCCf6FfX1raqnQcTNz5lJPAT3u+siC65ih01L173biQ2ikJLmYRtI
aS5jh+3FPkjtcemPwu6o4D/XZ2BzQovsNNewT42oqtz7EEirT7yk+VmT1voX
0Zj5VNIl/dL1vKwFbvRpSffsFQQBzJMvbCfmuB2JaUb8bOyHPZxX6Uexy+NK
7icRfas9z+hvlc5zyyJozyX2CDZqFIal8WWudoil8uIQ96TxeVRqvsx17b1M
bSLuS239SdM7SoF/bnKsvqubNyEdnfbeYVJHhZW8qdAuYr4kbaigU24OLn4v
8mWO2LLBKMF5S2zvXNaMke4A3CiktiaKV5Betg6WBoyZkDbdflQbNb7I9U5x
LVq9DYFV6+ZzvVtmuYvfpszuZGM3fA1IaNRiO8U8Fc4aELDy1JaUCwbSuoW8
Nt9jVPhn2WhbTdmEFYSkj7nHjCLwFQ3mnC22gf//xV/9X9Zq
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4sVNrBoizkEOXbfMeppOyTiUvGhIW+ER5DBl
1sVX9q6ycP4RkaeXfkQi+BP+6kxTspRz4J7hE75jUyCc/3bVXabZaQi+V3FM
iX9qoEPQsyozth45h2tLy29cTAp0cOm0btZmlXdIyPBeqRuM4DNOCHXqswt0
OMWkVvBaXdyh/GxjoZEfgs98YQubeECgg9n25/Okzog7XDE1cF0dGuigtkD2
tFiAlIPX8aJ5i2MDHQwSdmheOQXkT+86zwq078C5Tw//cUg7+LVPeG07CcGf
suvDUf9ZCP65OacT8qSC4HythW9EVggHOYRJGW4+nyLlwN8RVPzhUaBDSN/J
R/84xBxOTJhyO/lqoMOnMk0pge0iDpw10u+ezg106JJeluO+lM9BvrOOa3Jn
oIOd2vcHUW3McP67CWt44/d8s4fx2yr7jX1VvsL5K8w9dC0fv7Y/MuWKt8sy
BD9zgVbv10OYfJh+GB9mPoz/ZEVj967n/+D8f3yujXY3mR1g/Fd7DVkYXDkc
gqy/HPlwPNCh56pBb8EsHofjHDcT8k4FOsytSDJ0LeJzOLGC47DR5UCHbwZb
rCzXCDnMkfv9beO7QIeOpY3yVzVFHdDTEwAMPAzu
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H1MzHEcB/Bfrv0KdatfT3d1tYWUiiRlUu4zT0l52Pd3yGPEqRG3TNhV
OJE7oyep1m1dYXmoS4hrynWpthwrtExNFqsM6dxxrqYd94/vd/PH+4/XP59/
3u99/FMkSMyhKMrOllW2TLMlt6gsci/DglT1s8d3NwPDAeOpZatYGO81lssO
uYG1G44HpbHAaCYj1wZ6Yossmscoho+N9tQU10gEAPXOHu3hLBxc2egUqPKD
cpNLdsovhL0flG32TcThoxP3rXIEHRnB+y6LBNhQ8dsskvCx78vpbm0ID3z8
TYnaUgSe28M1b456AR3K4Q3dIr5y5GrG+hbigQznnLYuBC8CVGlpm3jYldz9
sQ8z+dgV7tIkjsQHdJd4obV3iIvy6QTqGvHb+FlVDg8R0HWbm+cG+4I6bGeq
ehCB3j1l2KfKF1AuN/n5D2KRZOvkHycWu1FT8qNzAQtTId7+Jp0AuyGkLTY4
nI+tlVNG+yYeNk9zPO7QYU+YMBlbm/1YODUyqvO66w4WbaLE23ZfGTMj+0sX
Ayh5iONhQfDebSCo+g4Dp8WGN9c/EZfqA1S3PhLXKUdPvuwlzjk81nWhh9iY
/yl/mx4BEj954lLNwIaskh0dnQg6H1WhM2XE8SOy2e+WEIN4jeJmtyuIjwFT
oyfe2JvqIOgjrt9n17ThO3Ggx6IpwRwWW1IlPpu3jAWZ8uBrJoaL3R57nhHk
0NiKVtmcuEyLUJQwrzLehYXlgiOv3IZMwrsR/M8NPxF2h/xts76fuGhBlLrD
1rc24rTxXqFZWODXqukvQRCka5iaHLAKdeWvVcW3bXvSLe0qdLQK/RQx45Rt
X1ruqK6lj4J/vuGtfGowc7CT0ge9PhhooN0LFrrWIshOf37mQYkj+Ew/JTaU
ExeUcmKHFcR8Reu7wUwEt3PpugMSB2wrd7VseT8H237xjvYtAxPCyKie9KMN
CJzq5ue1hI0JzY8LvnmaiSsffV1HrWCxvUKlifFZLARItTOpi1PYBotUHb2L
hn8u7lNXXhlyghXRea4tLAvR4mcnzsld4f9/8RcAP+A5
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4vn+m/gLD4Y4dN0y62k6JeNQsFXXj/V4iMOU
WRdf2bvKwvlHRJ5e+hGJ4E/4qzNNyVLOgT31p52oIYL/srzr1fcnwXC+mwNn
zJrHwQ5Bz6rM2HrkHC4VqRzQexjs4NJp3azNKu8QY/pjQtdFBP9vDJPW6z3B
DqeY1Apeq4s7FM/Si+w/g+D/n5P4rvhcsIPZ9ufzpM6IO1xguqvDcSXYQW2B
7GmxACkHtynybQx3gh0MEnZoXjkF5KeYb096EOxw4Nynh/84pB28QmwvzxII
gfMntM9du0YCwT+VWeFxegaCr5Y38w/LpBCHMCnDzedTpBy4Q/9H+SaGOIT0
nXz0j0PM4Uis4+EDwSEOn8o0pQS2iziwep646iQDDE/pZTnuS/kcpMO0P71n
D3GwU/v+IKqNGc5/N2ENb/yeb/Ywfltlv7Gvylc4f4W5h67l49f2BxIbjReq
IPipuddLghwx+TD9MD7MfBj/yYrG7l3P/8H5//hcG+1uMjvA+K/2GrIwuHI4
+HEsXOPrFuLQc9Wgt2AWj8Phq60epz1CHOZWJBm6FvE5HCnduqo/MMThm8EW
K8s1Qg4zXi+/x5cb4tCxtFH+qqaoA3p6AgAmIwe+
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKC38U81k2c9Qhwsf0njvfRVwgPGdV1tULZQXcdiW
MGFi/7dQh3keBlfPuIs7hE8JmXf9QahDw5TjnanGUg7NWjL37I+EOuidXMao
8U/WIUPzm3L4xFCHLOctPOrz5Rw4ehf9tylH8FlVI+J+BSL4uzvXPlqqEuoQ
0izfrTxD1kEsStPNjjvUoWqKV4XTW0mHondM6YHfQxzyzsm8FTYWdxANyzli
9SUE7j4YH+Z+GP/om9TbmYw8cH60WoYF11MWB71szyfveEMd8kxU/5098df+
1fblk95pAP3PcuXpPcaP9lW3TgitDAt12D2F5ZPZhtf2NV35WRGlCP66klNP
zacj+Cdnyv2+dizUgWm/2yQFjY/2eRv1NuQ/CnWYZvjFzkWYAR5+6/b6hy5s
Z4WHLwuLhHXbOm4H9PCXP/Thx+KyUIdrLIHfGT0+2q98MiXdOg7Bf8N88FSc
ZajDHy/DwHO2X+3Lpq05I6MX6rDmyqIv1oZMDkw/1/+3UQ91iMi5K/7wPRuc
/+WNb3qTER+cv6bM1yM7VxDOPz3TfMb0L8JwvpS56YWaCWIOrydXmlvohDok
iMxYuWSjhIPnGXsbYYtQh4wHt/0VU2UdVrUcOfk/DZg+onI8/+6Xhbsfxq+b
9SzeuRvBt/G+pNu0JdTBKM07zJVL1mFW8wyj2AOhDsc4bLotFSUd1MIe/1gM
DM+AjUdPRrwWg/PtX0vpsr8WhvNh7ofxa34YBbZ84EHIMx81qZjE7rBxxzPt
I/uB8b33wxT5FiaHE76sh9O2hToEJ13/Vsb8zf4O01TjPZMQ4Yse/gDaOmZ0

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzFDMAOUzoInTgk1Pu6jFBgDBVwJ/
    
    "], CompressedData["
1:eJxl1GtM01cUAPDSUiwixbYQsS1/p1hNBsxKGAKiPZYZ1IoWkVvKmEB9QByj
kZhFJeADpEAGTiBEa1TwidAgWxMQKAsrKDH4ZhNBUDLagAJDa8dUWvX/pfcu
88P58MvNOfck956zWKPdtpvFYDDc6FDQwaTj38yh9P2hKhhKsyklv3HAZVOC
olC1gAcRS3MvJ31E8L6Z/aqd6wei/tXGj+3EfZW7RpnniFtL160KL0DwWP1o
ZrvWF2riw029WQjGKv26/hQIsFOSvUtyTUIY297YIztI50t09iNHhXDxRWaw
oQzBvBiL/Z9oIcQmnvA6XUvMKYrUvJgivkX9skG9UAXNLZcXUX0B2OGeBf19
iRR2U/Jo3p4KCqLE+cb9C1RQOLL56oMuCrz+LmAFC4iXBD5yVPCJD08os2N5
/zlPaOuVcul6erl8+iIFT7fKO01uKhAbNroZ5RTEHbdPqEcRDO2jri38IQBE
09f191qJU0uH3Rm1xClm882jhQiSWM8EX7cHQE3Zkw/KDAT6vEyp6gIFLTZu
T6IG4futKQ2tgenEcsmXQU9SiXV2h7Ve/bmHfAf8j+cQ1+h7vYseBmCXO5qq
REF87AjJXuPsjzzsE+qZpU0SHu4H27zsbcse4uKkUvZLuv/Nx5YdeBfDA6dE
W5uxF0Fjs2GePZ8HOV3fZ8fuQ9A+w7abxXy4IPHSriym/wMnR2kO9QX3tvTa
jDZiSvfX3OuDxOYlr29EvkRQP1D3Ji6dD4Ois1rRNII1Vh2juoEHhnjpc947
BJ3SrWedYfOx0dq2nmLkjb0jtPzk5E5P7FsdMWdCajywN6Z1nLlhcYPKbm5U
An3fpKakwyPQKctdNVVV9RRBtfj3/sWOGdmUf0n1cDeCteLsh4IRmyw1vGew
oY44pLvJ8jiX2GH1GX6WhCAqrDOtIn5WxteNj2VuQRDNyh8f/o4J50pEeXFK
BIFXvuF3bGLCbEhWpWIb/X5clX9WGBMEPpc0O9TEyb8qHlRnE38bNUfxEz1P
9UL/P/jR7thpt8+3npJ6YPsdWH6eknBwvqVgPPlm8Fxc32VXPy4bG21Hbkci
OORT9IrSe2LfFXqssY6wse/Ula3/6r5TFtT5RtO3i55XQ0iRacWkbCLivfbn
euLXX7D0Fhuxa/8MsO++5SCn7P/76RNSahjv
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYC4jDWd5l/6iIcum6Z9TSdknHQyM5cMaElwmHK
rIuv7F1l4fwjIk8v/YhE8Cf81ZmmZCnnsE/KdOaCd+Fw/gLdYy7NixD8v19d
tpkvDHcIelZlxtYj59CpkSC1a164g0undbM2q7yD8Gvj16L9CP4WIbuWsqpw
h1NMagWv1cUdtAKyNkt1IfjbguZ6/O8OdzDb/nye1Blxh/YdEu2TJ4Y7qC2Q
PS0WIOXwxzP6QffMcAeDhB2aV05JOfyVLBZ8Nzfc4cC5Tw//cUg7MHJV6qqd
Q/DdbW+yW1xD8BvltywKC4uA8+8qXw2b4B/hECZluPl8ipTDIS7rrTfkIhxC
+k4++sch5lAtXCvrIxjh8KlMU0pgu4jDnn/MBuduhjt0SS/LcV/K53CJO92n
+mi4g53a9wdRbcxw/rsJa3jj93yzh/HbKvuNfVW+wvkrzD10LR+/ti8X39ur
8wjBl1EWPn/3HyYfph/Gh5kP4z9Z0di96/k/OP8fn2uj3U1mBxj/1V5DFgZX
DgfWfXfYbjJHOPRcNegtmMXjUNV9cFEYW4TD3IokQ9ciPodq7Y8s0vwRDt8M
tlhZrhFy8Fv42GKWVoRDx9JG+auaog7o6QkA1esHhQ==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4s+mnZ4XN0Q6BLxZWLumjc1hdZj9TOGFCL7f
vhXf/syNdGDhPzQpUZ7Focan2KVxZqRD8XdLu6g5DA6HpN3+B0+OdMi9fj/X
8tw/+4Peeuc+9kU6HFshYMLd+dc+MZz9X30qgl8uw5dyIBzBz/3w4vP9ZxFw
vm6vbEywZqTDmb0H1gQ8Y3NY5XZisUZ3pMP5DeyeoU8EHGDuFenLUqplFYbz
eWZNi5D8IQbnCyzbs/F3mbSDd1hc6K6KSIcs5y086vPlHP5z8TZt00HwW1TN
37oB7Yfx11fPz1DbEeFglmBq/V1AGs5f1sGzumK+OJx/5U9P2oESUQdbt7c2
ndcQ/B/LmAJDbiD4Aik8Rzc8QvDD2bcYvfwe4dDgsb9W9iWCH7Nx/5t55eJw
/rND5sxCpRIOYfU/tn9+E+EQsf0q+9sCSQf+OwFeu68j+N8fLZl88xKCr+br
2Lb8IoKf/Ua76M75CIczHDvnxKRLOth9uiZkei/CQSotXGDnR2mH399ucJ34
H+EQcJjRrjNZ1uFf1l35T8qRcH6f6C6pRTEI/gq5u8fyyiMdgqKE00wNpOD8
e/GPTF5+EYPzs5YKnFA9LewQ/3x/VmREpMOcbaY3utYIOOwS58nRNYt0iJLe
90CvhMdBRXKOKdv+CIcT14xbkpW+28PCV491yV/+lK9wfq5MWKyOIIJ/jSXw
O6PHR3uFEB4W/fmRcD56egYA5Q5Hkw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{104.95421795999997`, 5.6021845625000015`}, {
     104.50122917249996`, 5.896393775000002}, {104.46231260999997`, 
     6.229519550000001}, {104.46231260999997`, 6.3960824375000005`}, {
     104.46231260999997`, 6.9938408375000005`}, {105.10210089749997`, 
     7.406356400000002}, {105.80259902249996`, 7.406356400000002}, {
     106.52177709749996`, 7.406356400000002}, {107.15222540999997`, 
     6.895771100000001}, {107.15222540999997`, 6.190602987500002}, {
     107.15222540999997`, 5.631761150000001}, {106.76772977249996`, 
     5.160092412500001}, {106.17619802249997`, 4.8176266625}, {
     104.95421795999997`, 5.6021845625000015`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQzdzvVmA5M8pBJTsjLnO9kMOqT/mxTkejHIqevpl7
UUnE4ZOpu6794yiHAu2k2hW6YnB+ReHF+qNHJOD8GeVXmZ8lyTh4eyUddVgT
5ZDlvIVHfb6cA4P6n3PfihH8rfYW0kZmCL6q7/9MUZYohx2GF6v3bZOG81Vm
dc1bKiCBkF+aufptlDicfyC+8K7lNFGH1pdBffpyUQ4b9thbpu4TdvjV5h/N
rxrlsEey/o29q7DDny6eu0I2UQ5eqg+fp3gKOSxQk+6e6x3l0PRnW+HVeYIO
4doLCnnVoxzWC3+a01Ep4MD74ejkLx8iHYorvm/zb+eB8+fuvaFgsZUFzi9l
bTi/Ze0P+zNL8h6bGUY58KzRbduj/8ZePMbrRGwxgu+z7v2T+l0IPvfkBuaE
b1EOqe+2/t5g+BvOj/F8aNDOy+YA4/NJp/5Ne8LhMO1rs1nD+ygHnYece/8V
8DikzZ+3svZ6lMP/fqZfxkf4HcyO7lLuPB3loJEa5Cy9TcBh0ltO48qDUQ6v
e/8vb5cSdECPXwBfPdUl
     "], {{105.40876340999996`, 4.258784825000001}, {
     105.68273600999997`, 4.092221937500001}, {106.14506477249996`, 
     3.7980127250000004`}, {106.61517684749997`, 3.4944635375000006`}, {
     106.89070610999997`, 3.3076640375000004`}, {107.35147820999997`, 
     3.013454825}, {107.35147820999997`, 2.415696425}, {107.35147820999997`, 
     1.6902917000000004`}, {106.61673350999997`, 1.1797064000000002`}, {
     105.81193899749996`, 1.1797064000000002`}, {104.96822792249996`, 
     1.1797064000000002`}, {104.26305980999997`, 1.7883614375000003`}, {
     104.26305980999997`, 2.6009392625000007`}, {104.26305980999997`, 
     3.1706777375000006`}, {104.57594897249997`, 3.7980127250000004`}, {
     105.40876340999996`, 4.258784825000001}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKH2smr+szzTG4cKHNN57XwUcYHzn1RZVC+VFHDIf
V1wuN4pxmOdhcPWMu7gDl7jtg/0yMQ4NU453phpLOZitZVHQYIhx0Du5jFHj
n6yD1Jp7qfZnox2ynLfwqM+Xc9jN3+2ouhnB37HcYcGjXgQ/j2eaSl9CtENI
s3y38gxZh5N3BDvU3KMdqqZ4VTi9lXRQLXy9wtI42iHvnMxbYWNxhxM3QtiU
DaLh7oPxYe6H8Y++Sb2dycgD50erZVhwPWVxePjWUO26J9A8E9V/Z0/8tZ9r
NeHKtRSgfpYrT+8xfrTXjd0YMnFStMPuKSyfzDa8ttfnjVjjsBHBT/y+SV3h
MoJfI8Nuu58pxoFpv9skBY2P9oom4p/C5WIcphl+sXMRZoCH37q9/qEL21nh
4cvCImHdto7bAT38L7nctOrZFO1wjSXwO6PHR/uY9NqVyrMQ/PltK3ncS6Md
/ngZBp6z/WqvKTmVjzUr2mHNlUVfrA2ZHLZWz3BUTY52iMi5K/7wPRuc/+WN
b3qTER+cv6bM1yM7VxDOPz3TfMb0L8JwvpS56YWaCWIO88SSKhUyoh0SRGas
XLJRwuGPn0bd7+Joh4wHt/0VU2UdYtnXcr9YFO0wLyrH8+9+Wbj7YXxD2fML
tY8j+O/P7srP+hDtYJTmHebKJevgy9ZY4von2uEYh023paKkw80bp616gOEZ
sPHoyYjXYnC+/WspXfbXwnA+zP0wfs0Po8CWDzwIeeajJhWT2B1SrM/nrvkN
jO+9H6bItzA5VF94y+L/KdohOOn6tzLmb/b9rbWlS84hwhc9/AGagVOV
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKN2YMu/FnpJYhwsf0njvfRVwgPGdV1tULZQXcVA5
w+62rDDWYZ6HwdUz7uIOR/+fDnoXHevQMOV4Z6qxlMPHqZMnhdnHOuidXMao
8U/W4dqU3Bu5PLEOWc5beNTnyzmU/ZDcEvwpBs4vnnBeSPAsgq/5VWX6nvkx
DiHN8t3KM2QdWo4u+BXSFuNQNcWrwumtpMODyCrpjKIYh7xzMm+FjcUdmg8+
rgjMj4G7D8aHuR/GP/om9XYmIw+cH62WYcH1lMVhzrUDM1g7geaZqP47e+Kv
fYSyvDvrEqB+litP7zF+tH/h6nB8/8UYh91TWD6ZbXht/+rrM7n8Dwi+zAPH
WX5CsXC+Oeu09W8dYx2Y9rtNUtD4aH9HZllKW2yswzTDL3Yuwgzw8Fu31z90
YTsrPHxZWCSs29ZxO6CHf69uxtpdH2McrrEEfmf0+GgvHsAjE3QTwY/Kt6gv
3RLj8MfLMPCc7Vf7J4wqjcYrYxzWXFn0xdqQyaEgRX1L8KIYh4icu+IP37PB
+V/e+KY3GfHB+WvKfD2ycwXh/NMzzWdM/yIM50uZm16omSDmEPn/w2u/5TEO
CSIzVi7ZKOGw3Xz7B83NMQ4ZD277K6bKOkh8sK4TexTjMC8qx/Pvflm4+2H8
N6xxIlFssXD+qm2ej2boxzoYpXmHuXLJOnC8539ebB3rcIzDpttSUdJhysGo
tbuA4Rmw8ejJiNdicL79ayld9tfCcD7M/TB+zQ+jwJYPPAh55qMmFZPYHeRV
4h7csop1yNv7YYp8C5OD2c6a8lrDWIfgpOvfypi/2Xvl8by4xBsLD1/08AcA
4HNicw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKP1Ya7Wy2uY4hwsf0njvfRVwgPGdV1tULZQXcWib
JNLIvyHOYZ6HwdUz7uIO6sdu9IbPinNomHK8M9VYyiE4ZsHZ/bVxDnonlzFq
/JN1sIiuEr7uFeeQ5byFR32+nMONfWrv9xgg+FfD7vhWcSP43bsNL6nei3UI
aZbvVp4h6/Cse63pviOxDlVTvCqc3ko6OCm0h13cEOuQd07mrbCxuMPT9g+b
d62NhbsPxoe5H8Y/+ib1diYjD5wfrZZhwfWUxeHfnLOX844DzTNR/Xf2xF/7
XS+1m/IeAfWzXHl6j/GjvRePL5OmQJzD7iksn8w2vLb32fM58oYegl+3zO/q
9gAEf+bpRa/CGuIcmPa7TVLQ+Ghv93jT/Pez4xymGX6xcxFmgIffur3+oQvb
WeHhy8IiYd22jtsBPfzffy55oQwMr2ssgd8ZPT7aV4pJhu8WR/D3mLruuvcp
1uGPl2HgOduv9m4nDPbMeR7rsObKoi/WhkwOl7RM3u95EOsQkXNX/OF7Njj/
yxvf9CYjPjh/TZmvR3auIJx/eqb5jOlfhOF8KXPTCzUTxBx2H/2rtuNprEOC
yIyVSzZKOEj+O6w9+WOsQ8aD2/6KqbIOVds8dtYrANNHVI7n3/2ycPfD+H5n
svwPuyD4PLVhskx5cQ5Gad5hrlyyDllbZZTuVsY5HOOw6bZUlHT41p7+QhkY
ngEbj56MeC0G59u/ltJlfy0M58PcD+PX/DAKbPnAg5BnPmpSMYndofFVlrQL
0Py8vR+myLcwOcyo79z0LD/OITjp+rcy5m/2a0wklW18EOGLHv4AxGltTw==

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYgHNRMblGgkOM1oP3PYNUHH41bjaZqVxggOj
OKcQwxllh8e3vpavtktwUAk8LPTKSdkh0oOr7K0nUP6KnMOFvUoO81cHyc/1
TXB4Ni3MOWkCkJ+/4Y54cILD7PtVcdZ+Sg7b29aa2IQi+IXn/RItIhH8BX89
BBtjExwW2J/gndWN4Htx28x5egfBl/9YmtzNquxwPv0ps39MggPPlJ3zei2U
HRZYvg5mi0hwmKWUapAdo+xgnyyqel07waHotHtQ0DYVB+fOBycVwhMcPEu0
SiwF1Bycs/s17gHtr3xnG/NJRQ1uvpl43nprZwT/waOHtu1TEPzOdaFnLj1V
g7u/j29xtaGyOtx/MP7TD57qXCFI8kv+Xa0LSnDw2C7ilimn7nDu+9wCDf8E
h+KLt+oOf1VzgIW/j+D5E2EyqnD3V4g4JYl5aThs9shboayT4HDktKy7bY8G
XP6Pqm16GqOmw+Y5LZfKVRD8ULHW2D3ySHyHCUXPpBMcNuYlNtnv14Dz07a3
zpWoRfCN9m7W8XPVcMg1js8PUUS45/IxweyDn+MdFmXHO+h/UHPombxxwvrX
8XD/wPgw//Ycnhnv+xzBL3knzaJ0H8Ev9nuzMPZaPDw8YXxYeMP4sPi4uG1W
6bW78Q5v7wcEqwHjq2SfsWnL43h4fD50Osx+WjbBYYfStXap3Spw+YeVn1ON
E5Xh+jf8v19b5aMMN//LtfVahnoIPiy9wfiw9AhzPyy9wvwH4zNMrPt96iWC
H6cpOu/hG6D9ZpxTmIOV4OG3TcY5emW1Ejx8793xExQLVYGHf0P8if65Qopw
PlefWpHMTwU4f5mko+TMNQoOp37ffcChkOCge+JBEVuBgoPddm1/bRUEH5Ze
0PmpSgyT9Z8qwNPPd4OstXI6ig7o+R8A0JCogw==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtQVFUcB3BWCHZ4JREtLQS7V/feDYVFnIAi8KfAqjwXYVcIh+4Bthq3
ANEFjBpSR3IWbNGJRiAeEghhJobhuBA0qxiFICKgSCXPgABZKF7y6v51j9Mf
vz8+M+d35pzf98wRxicfUBobGRlxmFIwtYkpbWvXULoIQdm4XU1apwg8nqXd
CKcQ3FLqPsmTk2ASFtt6xg1BN3dKoHQVw6ONGb+zAdimIT559lJsT4XZaE3o
c7a+7OYXhaCjuuSIqYGCN5Iy7x4PRjAyOnEo4iEF5z9svrMrEEEoL37+l1js
1HOZurdGSNaq2Q5pZD4JIQ2+V67uQ2Dqq3l9rxcJhorTbfwIbOWekxeeHcT2
yrDjziIEBTmR3GYttqF8+cr7cop19VPRuLlCDIZ6x2V1OAJi4EcDKhJDwss6
TnsAdp43P63EA1tbG7dSzczL6mfZfaKYgozLS51PtiBoGs/mkBIKuhseLBk5
IkhMJ/u0KjE0SkkfGwvcH2ewzv+Hg71exKOkgzTr0spOp8R7NHgsZt1W8kjW
py2cggMKRawt35k2TXtPBKPWCyc+78K+UeO53/UB9vYMh9GaHuwjy9clxb00
bOUtftyVIgL//PmFPQ9puB7YlXSsWAT3vKKfTjLnIV/TVPnXUmD0g6q3YoFm
882N6mgP5eC8G1J2yHzMsCt/zczxfQnBocW//WI3YY8RTbY7p0jW+hYN/24I
Ce9m/PbihCWCScfqpZG5rez+ltdKDxcICdCNq3sCV2nQL3hntA0J4L52W6H/
LA2RJ2NWOeYCWD/1za70YezUEyk15wexy1xzC2IeP2f1ePgdZj4pG5/9tLSP
WX9r5lJOPw1/dRL9x+MFMEZPHVUN0TAji1N/34a9Iou+8O9BIesQ7rUv/AaE
bH/+k7UQey4Ba1ZZc7/3Yq8e3R6U2469W/6Vh66FhotfW5W4ZQtZz7pPF62M
ClinaUo3B284Q1lCBKFi8uMqnGPMvZ1BUxLU6DKMrbOPqxhexJZkp5aLjBF8
92qTS+OcANRmltM8EwR/7OSo39wshLOWqbxBJq+10HZNaKwAJoPseiW2iO3X
6ufFJiR25o4vbZVS7D6q32FvNII/X3H41pUiWPNsDm9zqMTW6guTJx4RwK2w
fjtFjq0n1LOfRmH3JXt11UVgm3UvmFsznlQcy1u9TYCnd73/BzLmPbW2rjtd
JNj/Ryri76dOCeAFz7GBm+6IzTdI0lJbT2JfSj5TpeZjdxu7X/3IDkFPXctj
kyrspHIf18QwIeupupuCc81CoE0TAg7wmPvWB1nMSQjgywdd9Mx+YW0xE1k2
W+D//+l/s6BFxw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4gnaX3U8diU6WKTm7ZuZZeAA4597dPTQghkG
Dj3fKhSv7Ex0CPv6ydp3loGD+aFFSis2I/hs7idXL16a6JAavO6Dnr6Bg4lW
waaNExH8v9f8puzuwOR3VYZd6jqv7/Bsw+++b70I/s4CBZW0OQj+i1SR07kr
Eh1ilJsKPeQN4PwFSw4wRahowvkhvXG8C9ZpwPkreurnBzZoONxebH5nwiQE
f7p5e7Z1FyafAQw0HMyDFeV0+hD8hbrPgxRWIvhTvheaOGxE8G8L7XzAswPB
n31EYcOqywj+o8imnqobmHyY/fPeXpRWvYDgw8IfnQ/zH4zvNmNRjJWypgN6
/AEA2ae9wg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGCQB2IQPdE7TOW+TZLD288ST0/y6josfVq1a61vkoPODvkP
CpN1Hd7x9LKVRCQ5BF3LV9tmrgfnc/m/+HpdUx/Oz2++lS9qb+Dwecbu0iyn
JIewr5+sfWcZOMybt5HPQRfBZ5mqPdtJFMFf87rrxwLGJAeff+r176UR/Md9
5j9tX+nB+XsLnh9a4arnEFooe6iSLcnhpVtEiMs5XYevPdtLsriSHC44Mbm1
d+g6fJ/RJJLCl+RQLexc9MhO1+HLy9c33vAnOQhUnr763kDXYYIlZ8tTGaD/
tB6VGG3TcXh+IaatVyDJ4UvRjVr3BB0Hm/8bWnb+SnQo4M2ZqjBPG86XO3JO
pEtVC85/3vk8x3C6hoOBaOi8K8JJDgkvayqm7VB3MK9kETusg+DL//m3ptoD
wb9svvioeXySQ9b+rcKpDzXg/DcPEvKbcrXgfKl7aw5Wh2g7pP+K7z0eluQQ
HBP67a6EjsP5+/veOnklOfyqvzpxc7+Ow9sDxecq3IH+33Lk1IzVOg7qf7/v
f26f5CC2X3PNk486DujxCwCskuaA
     "], {{144.787512670625, 
     15.176370742187501`}, {144.6098974284375, 15.2787991640625}, {
     144.4181165534375, 15.4640420546875}, {144.4181165534375, 
     15.7168441171875}, {144.4181165534375, 16.1483510859375}, {
     144.91718269406252`, 16.4011531484375}, {145.4097108503125, 
     16.4011531484375}, {145.9436462409375, 16.4011531484375}, {146.41547078, 
     16.0655366171875}, {146.41547078, 15.5795464453125}, {146.41547078, 
     14.9715138984375}, {145.70392014718752`, 14.663138968750001`}, {
     145.69084417843752`, 14.663138968750001`}, {145.676678545625, 
     14.663138968750001`}, {145.6625129128125, 14.669676953125}, {
     145.615657358125, 14.6969185546875}, {144.787512670625, 
     15.176370742187501`}}, {{145.1220395378125, 14.2261836796875}, {
     145.5034219596875, 14.007161203125001`}, {145.5175875925, 
     14.007161203125001`}, {146.055881639375, 13.6857103046875}, {
     146.2324072175, 13.5832818828125}, {146.57347206906252`, 13.377335375}, {
     146.57347206906252`, 12.974159671875}, {146.57347206906252`, 
     12.4609278984375}, {146.0068467565625, 12.139477}, {145.4206074909375, 
     12.139477}, {144.7929609909375, 12.139477}, {144.25357728, 
     12.542652703125}, {144.25357728, 13.1038296953125}, {144.25357728, 
     13.610523484375001`}, {144.6295113815625, 14.00062321875}, {
     145.1220395378125, 14.2261836796875}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4tvBRX5vXJMdNjZpihjnqDiczto1T2IuEt/q
0vmqhQj+rzDToIzlmPzuExu6zC8h+Kl8Fow2Fqpw/XA+1HwYH2Y/Op/r5f0n
b/dpwflzvnv+v8OqDedLnMzQa0zVdqi9z8neY4/gy2cv3K9ticmH6YfxYebD
+DD7d+cxvNn0MAnO3zXvxa6Auwh+d1OrRfJ1TD7M/zA+LHxg+mF8mPkwPsx+
dP6ifQfYuQ7Lwvn1C99c0jZF8PMeXknyLpGB+x/Gh4UPOh+mH8aHmY8e/wDF
EtY/
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4g8/2U7XXs500LNLqHz9w8QBxq8M5fnja2QK
5+9fM8tQzNzUYVJ3te3EMwh+pZ5TesHOTIcfh8/X888zcZCat2Kb7TwEP356
W5vVFEz+VP9Xaj2BJg5MM516SmYh+J5R1rPfr0HwVyRJXtTZm+nQnFT6dctE
BD/vd+U6r5t6cH7Zj+xNx5T0HJIe1rdZ7cl0KJwhx5zxVNdh6YLb3koLEPxX
M3dKy0/D5KdEHJWe6a7rINUQLvp7AYL/7rca87vdCL6PnoBf6AkEf1XCzxl7
riD4dXdOtK1/j+CvPZTW0P0Lkw+z/9Nul4CODwi+afUC0YIrCD4s/JdM+lBs
JKsH5//iTN8udgvBh8UfAJKB07w=
    "]], 
   RasterBox[{{0}}, {{161.348, 10.187899999999999`}, {251.108, 10.6679}}, {0, 
    255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYquXSlo/21McNDpPadcsk3WA8YOeVZmx9cjB
+VnOW3jU58s53KmaPoenEcE/LBt37HVuioPfgg5XHmsZh5TeI6I7gxD8lW2L
nm71wOQfOPfp4T8OaQefjrjX7/0Q/Mme4b+yEhH8T4GmBisKUxwqpORlFnHK
wPlast96+q7+tYfxM1nb1uQp/rBfc2H2060FKQ4OrNJGlWbf7N/3f181NwTB
N+m8WjXLC5N/jSXwO6PHR/uU/OKSslAE3+K1U1JmAYI/TVZn7YUaBP+Lv+gP
804E/8TpJ0+1liD43zc23Wdbj8mH2W+zOmE981IEvz5rT8nrDgQfFv63rq3a
cebLdzi/fWLclXe3/9qjxx8APMvQyQ==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4rBjP6uSwlMdAt4srF3Txuaw6dqVRc3+CH5L
V2fgD99UBxb+Q5MS5VkcZl/Mq9jlnepQ/N3SLmoOg4Ot5Y2riz1SHXKv38+1
PPfP3jbQZ2+RW6rDsRUCJtydf+15r1tc3WmI4M+wtOG4pYXgT16seSHzUwqc
//mjc8ti4VSHM3sPrAl4xuaw0U9So88l1eH8BnbP0CcCDjD3ivRlKdWyCsP5
PLOmRUj+EIPzBZbt2fi7TNqhKewJQ7h1qkOW8xYe9flyDnc2WIuHiiL48vsu
+MgC7YfxTV62cPHeTnEwSzC1/i4gDecv6+BZXTFfHM6/8qcn7UCJqEP1udUl
dq8Q/Bt12/4pv0bwU2J3WwR9QPA59Pvz3/1KcWjw2F8r+xLBj9m4/828cnE4
/9khc2ahUgkHjmzDTcVfUxwitl9lf1sg6ZAyM7b6+isE/8Yc9gVpLxD89xdD
Z559juBPUvTmf/EsxeEMx845MemSDtVLFsSLvEtxkEoLF9j5Udrh1rKFt+/+
S3EIOMxo15ks63DngfKzTwKpcL6K2aTHXroI/oZdiy03WqU6BEUJp5kaSMH5
9+Ifmbz8IgbnZy0VOKF6WtiBR35qt5p2qsOcbaY3utYIOFiaW/cISKU6REnv
e6BXwuPw3pz5Y829FIcT14xbkpW+28PCV491yV/+lK9wfq5MWKyOIIJ/jSXw
O6PHR/ucUOuIiX6pcD56egYAXQ1FVw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4m8XN85RP57qoNF5SrtmmawDjB/0rMqMrUcO
zs9y3sKjPl/OYUayGr/1AQS/nu2thdTaVAe/BR2uPNYyDgplwR3PJyL4qfmG
EU/aMfkHzn16+I9D2oGj8G2sXB+C72/0LGfmAgR/ndWRRdc2pDpUSMnLLOKU
gfO1ZL/19F39aw/jZ7K2rclT/GGfsVMr4sn6VAcHVmmjSrNv9qsr2mTPTEbw
PxSmvD3Ricm/xhL4ndHjo71CBNPzJVMQ/C+XL16Zvh7BD2LbLf9/N4K/wWJJ
VtoJBL9lS3FE5GMEf/MswSDTd5h8mP0/Jr9XNHqC4FsHez+XPIHgw8L/1rVV
O858+Q7nt0+Mu/Lu9l979PgDAPAY1ic=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQXeepOGOPcZrDym99+yO9BB1g/H4bgcglNkJw/gdt
hX+rTWQcjutonKqNSnM4JZL0RHqBrMNMBRvb6iwE/3vHK4EvhQj+jx+GS6Tq
0xzWmWe1vsyUdcidplf4qzXNwW9BhyuPtYyDuv0Ca6NGBF/tqmlSfTEm38F2
W+qBEik4P+T79l1BNpIOLbZPTH9UpTks0T4u9WSJhMOPWw+YbjQi+I9KV1ld
bkPwTz/oXmwwIc1hTfbiD/1/EPx5G+XWKlRLwflFe2OqXp2QcdjsvqGrqynN
Ict5C4/6fDmHExO2vtyTgeAHRLet+eOA4N+wPR3GLZ7mcK6jXDWvSxLO/7Mq
ZsWfqwJwvs07r8bdbj/tLTK2r++zTnPgWaPbtkf/jf0xu/3fb0Qg+D9kEv5f
qEbwI/pX8B2cmebQ8W5xSvO1P3A+9+xlJaEHORxg/FVm75ofRQs6hB7cIHq+
Ns3hyc2uRWvkRB3uhe7x/xuF4N+xz1gwzxXB55LJiWO2SnN4cbmkPU5V2AE9
fQAAChD5pA==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQHRSZVtITkeZgJ5N3UfjBJ/v6/lixnS4I/trgt2/8
rNMcDrHe3FRj+8deMXBXeJZlmoPSAePX16b8s6/zVJyxxzjNgfmNx6wn35gc
YPzzzJvneplzwvmVmxwSuuZzwfmfXh30tI8WcFBUvNRxxjbNwU37O9NmJxGH
rDKHNpUoBN/60Yw6nXgE/0Fn4oJ5uQg+f81O3qTyNIet3zoezb8m6LCpOegs
f22aQ93Me1vOpwjA+ZUVJSeKzvLA+WGbgr5v/8UB53t7Zv2RtWaF8x+8jjIU
CmJ0yDFaGLgbaH7ZxOfzWzn/2m9UXZTukpfmMMVYpHzP0s/2Kmu9Wo/GI8IL
PTwB0YmZpA==
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQnWqinGW/Oc1hje3EM/0prA4nE9bwhLGlY/ADrueJ
deX/tYfx5d7d1OR58d3++5Fs1w2s6Q4OrNJGlWbf7FXkJzpNfpcG5/NY1Ozk
eYHJv8YS+J3R46P9ho+3OW59QfBDGg2ca4Hmwfinrl2I/CCE4NvrFBYkKyD4
EQvl9IINEfw/UXW1CnaYfJj9T4ozv8w0R/AFz/V9rFFA8O2N/LSuyyP8B+PD
/A/jw8LH6Y74CSF7TP6JB3smrzrB7gBTj86fUvtaziRGDs7vS+hwZNWVh/Pl
zh/6qZ8t79DyNa3wkBSCv7lw1sTX4gh+7gcG959iCL5AUO+rPJF0hz8ffTtv
vZNzgMUvzH70+AYATz3VRg==
     "], {{184.29763049000005`, 
     2.9729816000000007`}, {181.87390697750007`, 2.9729816000000007`}, {
     184.29763049000005`, 6.758784800000001}, {184.29763049000005`, 
     2.9729816000000007`}}}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzFDMAOUzoInTgk1Pu6jFBgDBVwJ/
    
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJvIGYC4qe2zbH7r6Y73En4FKC6j8MBxt8T7N0SLi7o
0DY7qN5wT7rDr22sH3bziTp8/2LE1joLwQ8Odp/X1o3gHztn6qFQl+5wLfLS
t5B8EQcrow1cr4vSHZ5PFj18VVgYzo+J4u2s3iPlcNc4R0C1Eqhftf1LQ6OU
g3XdSafo5nQHHucnX77aSDnwbonZFNiL4Oed2Xi3cjOCf2bG2wuGJ9Mdtm1f
Ki93WRbON+Nsvn45VA7O3xD1uDZtkpxDu3hIm/2JdIeWBz7LLxyWc8hnCNeT
Pobg/5b6t+rcUQRfs37vYw0k/m+joklzDwPNm+Xk9H6xnEO44bae5L3pDjJr
PBk3O8k5CPj0KxmtA4ZnodxKyVxZh+8MbytzZiL4M88x67P2Ivgzssr4jwHD
K4L5nrDpblkHywDGNboF6Q6zajMMwhfJORxtkhHYkIuw/872LE5xJD6XjJZT
YQ6Cv7Z58vyoTEz+HZGbEq1FCP6CWad52y7Kwvl9fzZMkdYWgvMtVLM2/y4T
hPP7I7+pbFAVhLsHzs9aofEwH8FfZxqlXwV0v0+TWsVPZ0GHjDk+f3cUpjus
27aG50udoIPS61OPNUrTHXZ/Y/1ySEbIwXqO1JO5DcD0wFEUcMhIxCH7mevf
HTMR/B8+bJvurETwT83i5Vy0Md1h1c0Vn30ThRzCpic/EdqS7mD7tJ1h2mpB
B3sjXRm+nekOBwz85/41EYDzw+x2He8I44Xz44z6Jr5J5oTzj+11nq27gA3O
90zYO3vHE0aHzdlzTq4D2vcmqXMvm/Jfe/Wl3OX+q9IdpskcvK7455v9g6k3
v3+el+5gJ5N3UfjBJ/uZS35I3p6A4Ddkv51XUIXgp/+Rmf0lI93ByuRAwqTA
3/affDoX7ExOd7BhrntxN5bJweKc0uvVKekOystchPZ6MTmkK3h/W5UKjD++
cIkcEyaHzwLPY00yEfzpj3ZNuVCMxF8mEeQNzE+rpCSuCNmwwPkJJ+fvnGHA
BueLVqjPl1PlgOt/0vwi6qgOF9x8GB/mHhj/cALf28zIdIcq/rYPcrM44fyz
Umy2Tx+wwvlnVvS66p3/a1//ku/euzxgfl2j27ZH/439fdVJKWcnIviPZk6r
/L4VwYeVPzdZz/7gCPtrj14+AQAIMBVN
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4lZP6/oW1wwHjc5T2jXLZB1g/KBnVWZsPXJw
fpbzFh71+XIO6rfXf5xuh+Dz1ZVJl2tnOPgt6HDlsZZxWP/2TpaLAIL/5dku
K0c2TP6Bc58e/uOQdpj+osyhmgfBv7cy3/+bHIJvu8m31Vg/w6FCSl5mEacM
nK8l+62n7+pfexg/k7VtTZ7iD/vvBlusHPUyHBxYpY0qzb7ZW33gZ9AUQvDr
X749r8qByb/GEvid0eOj/frz3ScZhRH8Zu/o7V90EfyHtS5MMVYIvv0GXd/D
bgi+sM5fq22JCL6T0GyTSTmYfJj97dyVLP1JCP6pU1dOlrkh+LDwv3Vt1Y4z
X77D+e0T4668u/3XHj3+AB5jwFY=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKP2czeijrESmw4UPabz3vgo4wPjOqy2qFsqLOOzY
9Wz+JLFMh3keBlfPuIs7dFzxWLaNO9OhYcrxzlRjKYf583WOZf3NcNA7uYxR
45+sg+B8ycxvjzMcspy38KjPl3N4eOF92MtrCP6DOV5sHkcQfGv/0hNz12Y4
hDTLdyvPkHXIMDf+9XJBhkPVFK8Kp7eSDtMYF3R9npbhkHdO5q2wsbhD+tYQ
y4ypGXD3wfgw98P4R9+k3s5k5IHzo9UyLLiesjh8sXf2dFoENM9E9d/ZE3/t
g9KKFA6tB+pnufL0HuNH+1nfmxLmH8tw2D2F5ZPZhtf2s/3DeL5fRfC3HGE+
9ewZgu90fW3Itn8ZDkz73SYpaHy0F3lsur6JJ9NhmuEXOxdhBnj4rdvrH7qw
nRUeviwsEtZt67gd0MM/9/W0y3OA4XWNJfA7o8dH+01/XnRlnELwg3nqbX5t
z3D442UYeM72q/2MqyW2kZsyHNZcWfTF2pDJ4V7bt7CX6zIcInLuij98zwbn
f3njm95kxAfnrynz9cjOFYTzT880nzH9izCcL2VueqFmgphDUMjtT2kbMxwS
RGasXLJRwqGxwK40BGh/xoPb/oqpsg6bzjDsOXUuw2FeVI7n3/2ycPfD+HOu
C7a/eYDg/17P/q77a4aDUZp3mCuXrIPWmayCyt8ZDsc4bLotFSUdCkwnXJ4D
DM+AjUdPRrwWg/PtX0vpsr8WhvNh7ofxa34YBbZ84EHIMx81qZjE7rDtmeBb
HaD5eXs/TJFvYXJwNFxoUfctwyE46fq3MuZv9qe5X35Y8QQRvujhDwCXZncS

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
    1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKO1aXam1dXumw4UPabz3vgo4wPjOqy2qFsqLOIjp
693U3JbpMM/D4OoZd3GHZx4T7vuuznRomHK8M9VYyuGvcMl/xrmZDnonlzFq
/JN1yBdOXNTbnOmQ5byFR32+nIO9q/mEhjIE305wkv39ZAR/5uE9jKa+mQ4h
zfLdyjNkHY6trjJudMh0qJriVeH0VtLhS+nzw11mmQ5552TeChuLOxzVnFP0
3wThPhgf5n4Y/+ib1NuZjDxwfrRahgXXUxaHoC1dTTcdgeaZqP47e+Kv/YZb
OyMj/YH6Wa48vcf40f5H9qmZZmmZDrunsHwy2/Da/ufhua59pQi+kKU3c10b
gr/A+2uv77xMB6b9bpMUND7aF4XXvpBck+kwzfCLnYswAzz81u31D13YzgoP
XxYWCeu2ddwO6OF/Ov4ejwkwvK6xBH5n9PhoL1BocOR/JoK/seFY6cTwTIc/
XoaB52y/2n/z3FP2ITDTYc2VRV+sDZkcbH7bTmjwy3SIyLkr/vA9G5z/5Y1v
epMRH5y/pszXIztXEM4/PdN8xvQvwnC+lLnphZoJYg4bTijp/AvIdEgQmbFy
yUYJh/tPWte9Dst0yHhw218xVdZBwNHja2IeMH1E5Xj+3S8Ldz+M/8s78kBz
A4IfqeKvrjw108EozTvMlUvWocNh00qB2ZkOxzhsui0VJR3OrbzOYwIMz4CN
R09GvBaD8+1fS+myvxaG82Huh/FrfhgFtnzgQcgzHzWpmMTuIBIdqXZkFjC+
936YIt/C5DB/6YtC0WmZDsFJ17+VMX+z12ww0HJoQYQvevgDAA6JXjo=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQnXksvtn4YqbDGtuJZ/pTWB3Ofnqh6qWShcEPuJ4n
1pX/1x7Gl3t3U5PnxXf732Er4pYoZzk4sEobVZp9s9fYeDa6nQfBFzi14xID
Gyb/Gkvgd0aPj/ZbmiWUzgkh+BHCuTGFygj+uQze4icGCL7zvrWd4XYIfoxx
tLu7P4LP8HbXNJEYTD7M/hesy3j7QhF80YTTXIV2CL7zkS7n07YI/8H4MP/D
+LDwccsLecgWi8k/8WDP5FUn2B1g6tH5U2pfy5nEyMH5fQkdjqy68nC+3PlD
P/Wz5R062hd3bbNA8LczX1913xTBL2yyTXhrguCLPDnJnGyU5fDno2/nrXdy
DrD4hdmPHt8AzFLeXQ==
     "], {{209.2336776800001, 2.9729816000000007`}, {
     206.80995416750014`, 2.9729816000000007`}, {209.2336776800001, 
     6.758784800000001}, {209.2336776800001, 2.9729816000000007`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKD2PlXnu429ZDhc+pPHe+yrgAOM7r7aoWigv4pC/
c7t3xNcsh3keBlfPuIs72F+WDKp5leXQMOV4Z6qxlEPYvL+FBneyHPROLmPU
+CfrcGLuK5E9h7Icspy38KjPl3OYcf4A0/qtCP702dKbeBcj+J983UqSe7Ic
Qprlu5VnyDrIm7EsW1+f5VA1xavC6a2kgy9DodnO0iyHvHMyb4WNxR3ktqg+
1S1BuA/Gh7kfxj/6JvV2JiMPnB+tlmHB9ZTFYbWdyFf2RqB5Jqr/zp74a8+Z
6nymvQ+on+XK03uMH+0DvwXzpC7Nctg9heWT2YbX9kF+6jv2bEHwsw9fKV1z
FMH/ebWOoeZulgPTfrdJChof7U8/ZIv2eJ3lMM3wi52LMAM8/Nbt9Q9d2M4K
D18WFgnrtnXcDujhr/IqvT4JGF7XWAK/M3p8tM/8vdNMbyWCz8Ud8GL/tCyH
P16Ggedsv9r7X3F9KTcxy2HNlUVfrA2ZHKa2Hmda35vlEJFzV/zhezY4/8sb
3/QmIz44f02Zr0d2riCcf3qm+YzpX4ThfClz0ws1E8QcOIPXzNOZkOWQIDJj
5ZKNEg4W+fyKUkD7Mx7c9ldMlXXIPH0xfcJaYPqIyvH8u18W7n4YP/jaI6NN
+xH8TetuzAy8kuVglOYd5sol6/DwlLWM/a0sh2McNt2WipIO6iaJ9UnA8AzY
ePRkxGsxON/+tZQu+2thOB/mfhi/5odRYMsHHoQ881GTiknsDrlPH834dBMY
33s/TJFvYXL4oV/0xPlqlkNw0vVvZczf7Ju4ds3JO4wIX/TwBwAwU2KB
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{217.80710128000015`, 5.6021845625000015`}, {
     217.35411249250015`, 5.896393775000002}, {217.31519593000016`, 
     6.229519550000001}, {217.31519593000016`, 6.3960824375000005`}, {
     217.31519593000016`, 6.9938408375000005`}, {217.95498421750017`, 
     7.406356400000002}, {218.65548234250016`, 7.406356400000002}, {
     219.37466041750017`, 7.406356400000002}, {220.00510873000016`, 
     6.895771100000001}, {220.00510873000016`, 6.190602987500002}, {
     220.00510873000016`, 5.631761150000001}, {219.62061309250015`, 
     5.160092412500001}, {219.02908134250015`, 4.8176266625}, {
     217.80710128000015`, 5.6021845625000015`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQzS8n2fU8PdtBJTsjLnO9kMOj82sZ3tRmOxQ9fTP3
opKIQ1vhzIxXPdkOBdpJtSt0xeD8isKL9UePSMD5M8qvMj9LknHY9HuZSXZh
tkOW8xYe9flyDryvii3dQhH8jG8T7yebIfgKtV/bQmWzHXYYXqzet00azleZ
1TVvqYAEQn5p5uq3UeJw/oH4wruW00Qd/L3lZyZpZTts2GNvmbpP2IFr1tz6
S7rZDnsk69/Yuwo7cMvUOIRYZjt4qT58nuIp5HA3s3m6pGO2Q9OfbYVX5wk6
WLw52nVRL9thvfCnOR2VAg6Tz92QPiqc7VBc8X2bfzsPnD937w0Fi60scH4p
a8P5LWt/2H/WWOv8zDjbgWeNbtse/Tf2M1mkt/0MQfA3r8090lWB4AsrbLtc
NS3bIfXd1t8bDH/D+TGeDw3aedkcYHw+6dS/aU84HCIumr/lmpztoPOQc++/
Ah4HB7Wjyzjbsx3+9zP9Mj7C76BheTmZvzHbQSM1yFl6m4BD2NmqbPaabIfX
vf+Xt0sJOqDHLwAbB9gV
     "], {{218.26164673000017`, 4.258784825000001}, {
     218.53561933000015`, 4.092221937500001}, {218.99794809250017`, 
     3.7980127250000004`}, {219.46806016750017`, 3.4944635375000006`}, {
     219.74358943000016`, 3.3076640375000004`}, {220.20436153000017`, 
     3.013454825}, {220.20436153000017`, 2.415696425}, {220.20436153000017`, 
     1.6902917000000004`}, {219.46961683000015`, 1.1797064000000002`}, {
     218.66482231750015`, 1.1797064000000002`}, {217.82111124250017`, 
     1.1797064000000002`}, {217.11594313000015`, 1.7883614375000003`}, {
     217.11594313000015`, 2.6009392625000007`}, {217.11594313000015`, 
     3.1706777375000006`}, {217.42883229250015`, 3.7980127250000004`}, {
     218.26164673000017`, 4.258784825000001}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{222.79431243000016`, 5.6021845625000015`}, {
     222.34132364250016`, 5.896393775000002}, {222.30240708000017`, 
     6.229519550000001}, {222.30240708000017`, 6.3960824375000005`}, {
     222.30240708000017`, 6.9938408375000005`}, {222.94219536750018`, 
     7.406356400000002}, {223.64269349250017`, 7.406356400000002}, {
     224.36187156750017`, 7.406356400000002}, {224.99231988000017`, 
     6.895771100000001}, {224.99231988000017`, 6.190602987500002}, {
     224.99231988000017`, 5.631761150000001}, {224.60782424250016`, 
     5.160092412500001}, {224.01629249250016`, 4.8176266625}, {
     222.79431243000016`, 5.6021845625000015`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQ/bn3/dE69hwHleyMuMz1Qg7H7FtsmmVzHIqevpl7
UUnEIeth/pJGnRyHAu2k2hW6YnB+ReHF+qNHJOD8GeVXmZ8lyThMy64tYBLM
cchy3sKjPl/O4WOkV+ndL9lwvk9ahvTvqwg+y9vTh97syXbYYXixet82aThf
ZVbXvKUCEgj5pZmr30aJw/kH4gvvWk4TdTDe/fXKz5PZDhv22Fum7hN2eMdZ
sjvzbLbDHsn6N/auwg7vu4NqXt/IdvBSffg8xVPI4eDNyMsbHmQ7NP3ZVnh1
nqCDTMycYxnnsh3WC3+a01Ep4FButz48ZnO2Q3HF923+7Txw/ty9NxQstrLA
+aWsDee3rP1hf31Gc33t5WwHnjW6bXv039jXlnz8OOELgj9d1oVBSSIHzv/e
38MvZJbjkPpu6+8Nhr/h/BjPhwbtvGwOMD6fdOrftCccDjaOfJqLjHIcdB5y
7v1XwOOgMm32owVqOQ7/+5l+GR/hd+BZuXL+MoUcB43UIGfpbQIOVraBy+dJ
5zi87v2/vF1K0AE9fgE6MeMg
     "], {{223.24885788000017`, 4.258784825000001}, {
     223.52283048000015`, 4.092221937500001}, {223.98515924250017`, 
     3.7980127250000004`}, {224.45527131750018`, 3.4944635375000006`}, {
     224.73080058000016`, 3.3076640375000004`}, {225.19157268000018`, 
     3.013454825}, {225.19157268000018`, 2.415696425}, {225.19157268000018`, 
     1.6902917000000004`}, {224.45682798000016`, 1.1797064000000002`}, {
     223.65203346750016`, 1.1797064000000002`}, {222.80832239250017`, 
     1.1797064000000002`}, {222.10315428000015`, 1.7883614375000003`}, {
     222.10315428000015`, 2.6009392625000007`}, {222.10315428000015`, 
     3.1706777375000006`}, {222.41604344250015`, 3.7980127250000004`}, {
     223.24885788000017`, 4.258784825000001}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H0w03EcB/DV1kjaZXM2GSU9aLvqXKF2tM9dRU+ublQ7T3WbRXxr6SKG
WMZZndLUUcrD5TBWqBCxplLy1NNRjUou7pKzPOfI9esPv+9df7z/eP3z+ePz
/tzHUSIXyagUCmUBkZ1EFhJxDOoQuBYgUOSNv7YPZoKoeNr3YB2C4fcj2coI
FnydWdXNaUPArJl23b3OhrTfVE2dyMOWtOhYkaZIzoWkCDVvoAJB+I6Hluvy
HEC3dMkX10xszZY3FLOz2LFmidPJgQieR/Kk6X5c0nBzZsJPbkv6fhq9Q8/n
wHBh3AupFIGNv0tN1xk2SHk03VmErd3XLuZHY/v4qINl8Qja1uSFhR3kkM5l
hHhWRdmSvmmtEFPldmAwMtz8T2KXdKc00U5g769lnU47g4CuO/R4Lc8e3HQV
vt2pCFqsJd/t8u1hcZf6wOBVbIv9926pcrEFv9puhJYjmOUvdxw1cElX8Bs9
eS62pPVplBHaIw5pTk20d8RJG+hJn0mUFCM43z9gYJdbQ/dYyQcrYn6Oh0X8
YDMTFj8fdbxC7PsLy+hcUMqEld6KS12XsMtir5vEamy3vqieISX2itYYVXMi
9qeA6FCXBKJfWUPDsgImmL1rax9QIGiqzhclZWHv6Vc69bhjg8xLXdxhBZkd
q7RHErDNz1ff0VzAdveizvIzsMdz7RxYpdhZIa7fXlYhUOaEv2N6MEg/80xh
chPopNVPlKu9o6aEFgK2fH0+gu3cU29ZvaNC941XrIM02E8/Dv/5ocLWlt2e
PE70rd+cOFKZMSEsceqLi5QgcDZUzE4b54SG3p+m9n/3ZdjWnGE+JzR9XMle
RNyXnjFgqO+kwLwLl+c8NU1QSYvRZ/Y3Ex2kDnu3phPz41Fr0oNr5jCc3SiK
D8EuPqrSTwZiD4kll8dECLTJdN1xuRnpOcYu5fZPVNK0LQHPDht/CxWbwrs8
TyOw1G1Ird80JDRGtthkaLDL5TFNtFpsVCr00nYiWKPQL6FcnCVtmlLcFQTR
Yd6azru5mb2WoKxsKulrRCCQvTqnSrOC///FX+UK6mw=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4hkV9v1rC3MdAt4srF3TxubwpUNq+7lMBP+Y
zflU54xcBxb+Q5MS5Vkc7jZv6WFNy3Uo/m5pFzWHwaH+teyrd0m5DrnX7+da
nvtnX8886eLehFyHYysETLg7/9r7d9a9ZPFB8G+9bpRRdUXwr4bmP9nCg+Cb
Lumc8U431+HM3gNrAp6xOXxmiLe5GZfrcH4Du2foEwEHmHtF+rKUalmF4Xye
WdMiJH+IwfkCy/Zs/F0m7XCEQ0t0UWiuQ5bzFh71+XIOcsmN2gv0EfzEArHE
DB4Ev2z2KbmIrzkOZgmm1t8FpOH8ZR08qyvmi8P5V/70pB0oEXXY2/Cxo5Ml
F86XMvwjlM+K4C/jZ/Sdy4Xgez280mwpmuvQ4LG/VvYlgh+zcf+beeXicP6z
Q+bMQqUSDl6y5cf28ec6RGy/yv62QNJhmffifiVWBF/K33fLRiYE37Bl9loJ
JP6VyxOUjRmB4cmxc05MuqTD3rBnxfEcuQ5SaeECOz9KO8hEPn+vIQmM78OM
dp3Jsg5ykzN/2Woj+Gkvrn+f6o7gf8p56fsnJNchKEo4zdRACs6/F//I5OUX
MTg/a6nACdXTwg5+F2/NLwTG95xtpje61gg4VL9sWBBtkusQJb3vgV4Jj4Ph
Kw/WEz9yHE5cM25JVvpuDwtfPdYlf/lTvsL5uTJhsTqCCP41lsDvjB4f7dex
N+bcAaZPGB89PQMAQPdCFg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKG1zdtnLEpE8hwsf0njvfRVwgPGdV1tULZQXceBt
jJ7xUijPYZ6HwdUz7uIOd2ftncfLkefQMOV4Z6qxlMOX1IX7Dv7MddA7uYxR
45+sQ1pqX6Lvg1yHLOctPOrz5RzMpqf4O1xG8E2T9/+bdwDBnyD66sCXlbkO
Ic3y3cozZB32/l3+yWFurkPVFK8Kp7eSDq+PizR7Tc51yDsn81bYWNxhT/VJ
w/0Tc+Hug/Fh7ofxj75JvZ3JyAPnR6tlWHA9ZXHwZNvhOHMe0DwT1X9nT/y1
X67zXEJyDVA/y5Wn9xg/2r/f+z3i26Fch91TWD6ZbXht/0H0NIvfJQSfs7vi
kO1jBH/6XCVf3t+5Dkz73SYpaHy0z1y5avlNYPhMM/xi5yLMAA+/dXv9Qxe2
s8LDl4VFwrptHbcDevgf2sh95jPQvmssgd8ZPT7asx+Obd5/DMFfcemzSeCW
XIc/XoaB52y/2r+d/dJ0w7pchzVXFn2xNmRyMPbN9ndYnesQkXNX/OF7Njj/
yxvf9CYjPjh/TZmvR3auIJx/eqb5jOlfhOF8KXPTCzUTxByWSwW83rs21yFB
ZMbKJRslHK6Zbc5dvTnXIePBbX/FVFkH9smlWxRP5zrMi8rx/LtfFu5+GP/j
3LZ657sIfkBZzbNHH3MdjNK8w1y5ZB3qJ93PuPA91+EYh023paKkw9HfLGc+
/8p1CNh49GTEazE43/61lC77a2E4H+Z+GL/mh1FgywcehDzzUZOKSewO3Gvb
njYDzc/b+2GKfAuTw7TvooZXP+U6BCdd/1bG/M1e4VLsy/8PEOGLHv4A0B12
/g==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKO2kozZz5eY8hwsf0njvfRVwgPGdV1tULZQXcRB+
cMtdblOewzwPg6tn3MUdHv+08XNanufQMOV4Z6qxlMOvIwp532bkOeidXMao
8U/WIecIr2BTfZ5DlvMWHvX5cg423x7/KylC8K0P2a27HI/gTyvJLND0zHMI
aZbvVp4h63A4Rn1RqU2eQ9UUrwqnt5IOH9WmGNUb5TnknZN5K2ws7nDolsfD
zwYI98H4MPfD+EffpN7OZOSB86PVMiy4nrI4+KeafzxrCzTPRPXf2RN/7dd2
p53w9QbqZ7ny9B7jR/uvMuUc2kl5DrunsHwy2/Da/luJ15amQgSf/9X3wqIm
BH/un4V/HGflOTDtd5ukoPHRPp9DK5xvRZ7DNMMvdi7CDPDwW7fXP3RhOys8
fFlYJKzb1nE7oIf/CYHuag1geF1jCfzO6PHRnlfprtGXVAR/nWHxk9bgPIc/
XoaB52y/2n/+lfH0iW+ew5ori75YGzI5WK559a/EK88hIueu+MP3bHD+lze+
6U1GfHD+mjJfj+xcQTj/9EzzGdO/CMP5UuamF2omiDmsrTw/65NPnkOCyIyV
SzZKONyZaiT7ICjPIePBbX/FVFkH3k9fksOygOkjKsfz735ZuPth/O9/WPUr
ahD8sKu/p4pPzHMwSvMOc+WSdWj9GCfBOj3P4RiHTbeloqTD6aiWag1geAZs
PHoy4rUYnG//WkqX/bUwnA9zP4xf88MosOUDD0Ke+ahJxSR2B0Eetqk7pgHj
e++HKfItTA5zwqY+4JyU5xCcdP1bGfM3ezXDuzNMGhDhix7+AOynZXQ=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKL3d7eZ5h+B8hwsf0njvfRVwgPGdV1tULZQXcej4
1Vu3NTDfYZ6HwdUz7uIOESIfWm665Ts0TDnemWos5ZB///KSXot8B72Tyxg1
/sk6PLx3wF1SPt8hy3kLj/p8OYeNAtNNeYQQ/A13Pj7J+p8H53P3yyw/8CLP
IaRZvlt5hqyDRfmtGzx38hyqpnhVOL2VdEhzdM8Uu5TnkHdO5q2wsbiD+dff
4t0X8uDug/Fh7ofxj75JvZ3JyAPnR6tlWHA9ZXE4Uv9KPfUu0DwT1X9nT/y1
V1om+f/JK6B+litP7zF+tM8y17I/xJjvsHsKyyezDa/ts/v/vpIURPBbWFav
4FRC8IXEQ41vWuY7MO13m6Sg8dH+idLd3qXu+Q7TDL/YuQgzwMNv3V7/0IXt
rPDwZWGRsG5bx+2AHv622nab9gPtu8YS+J3R46N9k82EzG5WBF/ZR01a9nOe
wx8vw8Bztl/tM0RlZGre5jmsubLoi7Uhk8O6Y3NNeYD+ici5K/7wPRuc/+WN
b3qTER+cv6bM1yM7VxDOPz3TfMb0L8JwvpS56YWaCWIOSlOaLna+yXNIEJmx
cslGCYfADU+Dyz/lOWQ8uO2vmCrr0MSzYtZbTmD6iMrx/LtfFu5+GD9HfGcq
vwyCf/r9ujPrDPIdjNK8w1y5ZB1+cQv5zzHLdzjGYdNtqSjp4FBqvmk/MDwD
Nh49GfFaDM63fy2ly/5aGM6HuR/Gr/lhFNjygQchz3zUpGISu0Ob2s7T/kDz
8/Z+mCLfwuQgWOghvtAw3yE46fq3MuZv9rO9J5w/LY8IX/TwBwCD+V79
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4j+ex6rlBQscZrQeuO0boOJQWJY9c4FYgQOj
OKcQwxllh2eLBLYryhQ4qAQeFnrlpOyw4KbUtkOKQPkrcg4X9io5OHPv75ql
XODwbFqYc9IEJQeXt7kvw9UKHGbfr4qz9lNyOF+RI5qljuDryu7VztBE8F1M
djX3aBc4LLA/wTurG8H34raZ8/QOgi//sTS5m1XZITqTo/azVoEDz5Sd83ot
lB1cgrhVz2sUOMxSSjXIjlF2EE5f0LtdqMCh6LR7UNA2FQfRX6wJMUB5zxKt
EksBNQfR7Fj+3UD7K9/ZxnxSUYObbyaet97aGcF/8OihbfsUBL9zXeiZS0/V
4O7v41tcbaisDvcfjP987S6+i2pI8uyiadxAvsd2EbdMOXWH6I0pxgkqBQ7F
F2/VHf6q5gALfx/B8yfCZFTh7q8QcUoS89JwOHfT5/xdIP/IaVl32x4NuPwf
Vdv0NEZNh7PMEU/Y+RH8+Q43NFfxIPjzrsaa7OcqcNiYl9hkv18Dzk/b3jpX
ohbBN9q7WcfPVcNBy/+oURkvwj2BfltWV3zOd1iUHe+g/0HNYZ1Jy7789/lw
/8D4MP+u8/mx1O4tgq+UZPlD4yUSf5Li8WNP8uHhCePDwhvGh8VHwLEfBs0v
8h3e3g8IVgPGl5LXUYGo1/nw+HwS9r1uI3eBww6la+1Su1Xg8g8rP6caJyrD
9W/4f7+2ykcZbv6Xa+u1DPUQfFh6g/Fh6RHmflh6hfkPxs/Y/Kq49h2CP/2/
6VGOD0D7zTinMAcrwcNvm4xz9MpqJXj43rvjJygWqgIP/4b4E/1zhRThfK4+
tSKZnwpw/jJJR8mZaxQcIje3ZF8Axq/uiQdFbAUKDsITVy96yIfgw9ILOj9V
iWGy/lMFePr5bpC1Vk5H0QE9/wMAa1iovA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H1Q03UYAPANPVpDclpKgMBvP9xLcQODuyI17ulAlvFy1GI1WTCQF2UN
vsjLlsZLoEOXsoGhAuIcLzK6qDilDhmgBicduNtWKuYlWCDvMqiEErXfX78v
1x/PH5+77/Pc9/s89324Kdnvp61hMBhMKqRUuFBh8SyeLdcjOD+56asCGw8q
gu23cg0Ifky7/Jkhng9qeXgS50sEv7BmiTSREBQdJ2o3GrE1CSHhw6usV9So
TI3Yhp3KjTMXEFjN53JcnQLQfyK5f7QBwdj4lPy92wLoVubfU1L5MR4pf19P
wD5Qeejy9jE+beWCNVJSzQfvk5fs/iYErm/pXhG/wYe58mGFrBm75ZZU/JMZ
25BDFPe1Iaj5QsLq1WM7G/5py4gX0DY/5E2ypUKY5TQtaZsQkKMdzuQ6IVzo
XTwUbMTutpOve5/Ctrj3a85T/XK/Emcn6wWwza3qj64KBD2TWiY/SABJJ4vV
QzoEqWr+Hb1SCI5h85kPSnF+o6i+v78QO7fM9EK2CjuCVcQuSkUQvFTcl+bB
p33EzTcqopZHe92eOdeCdB5MWDiW9enYNna7MWWVdTmNKlMGtijYWeW1D8FW
j6WDDsSDzSWGAhXlS7scWXn1PJDb3168St2H76NrCf9OAHkVUem+GjzfrpGV
+wcKsR2qwMb9Jdji2p+vTB9BIF+aDktwwZ4ge14MmeXTvtav8xqK5kPTwr+l
UIZgZot5eWxxK11/Xbsxs4ZLgqPVNv7wIHX+Uahm8HcCPi4MGFDlI5CUylaY
bALy1BO15VnYgY9i4qpV2LuG7l5f3o8d4Xze/1uqP+hZSffyOwSITp+wVmYi
eGAj736aQsDkuFsHk6o3H5eY/80g9uO4j8789SGXdjSrvSJslEvnV488iX6Z
RULuzvi87ftWeT6AqNqLvWlU8VJrEgLTWfdzgVou7YVtc3WPxwnaBTojJ+qZ
H0RkhB3/nJofS+onY4f6QefaHbLkLGzH1Ygb3Rrs48uxQ4lFCL727HnVskhA
UGfdwm3Kv4Uw89/kcKGry6q1UPN6EnNDF5NAwPQe4sFeLc63nDKst+qxg60j
h58asZN3rzk2T/23e5u9W0UCkrbHhswA72Zs/bXa7KlhEjTP+XgebsG+GWn7
k73KyarXxpqbV533q2RIKM9I8wwrfSTo7c4tDMrygYGnviaS3j+RPK/dgjIC
1HHHZoTVeL6eMRqJwIAtnrtjddVhJ/7Q5igtR3DzYv+va1uwsxp2iFJjubRn
L3YSlb1caAoV++Qfpd77/btui0EkuCi0HBFVL3ZQNlW8wR/+v0//A69HWM0=

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYlvvCYIfbhY4WKTm7ZuZZeAA4597dPTQghkG
DrsMLnFvA/LDvn6y9p1l4DBBLJ1nwTUE/0fErwtzzxc4pAav+6Cnb+DQf8r3
ypKjCP5nBdujmgcx+V2VYZe6zus7PO+d7HT8MIJ/8a0q7/9TCH7mi/kPmC4W
OMQoNxV6yBvA+QuWHGCKUNGE80N643gXrNOA81f01M8PbNBwSGo3zBQ5huA7
BN7c8PIgJp8BDDQcBOLVuB4dRvBdfTpVYi4i+HYb/URzriL4j+yKsi/dQPAP
iasFL3yG4Kc+CnPkfInJh9nvvOZfx70nCD4s/NH5MP/B+G4zFsVYKWs6oMcf
AOU9wXY=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQ/aM8WDZEqdDBjfMXd62GjgOM33ou+82i0xoO1f0X
lPpECh0WiDW3Z7prOGidbT5+nRfB/zyzszSJG8FXaCisKWBF8Pe4ZYTnMBU6
TPA/cY57pYaD7MVbDj/ZCh2Krwt9Ctyq4XBijzafH3uhg1mxR9ZDeU0432qd
W1moDYKvLtq79X+XpkNzwaLMSqD5QsJXPuhe0HQ4N6V4qz0Tgi+x04WR7X8B
nL96tsZUsb8FDpKRRseVJiL4HlkLU4zMEPxm03PLjL00HAKLVJQrmAsdEl7W
VEzboe5wOOukWSQfgv81u6M2Sg7Bb/xcP6tGt9DBYvGz1Vema8L5v+qvTtzc
rwPn7+1J2tn6X99hbrZpuZlioUPY10/WvrMMHLgOy1ariyD4AZuKdlcKIPj/
dYx/HOEodGiaxMSdMNEAHp6Kp8S3ROgZOKx4MzFy/r8Ch8DO1xLiL/Qd7HZL
HtT4VeBQ1Ru7aFcsgr/jzMtNO+T14Hy7qDmGPHE6DlP3rT3uAwzPJz8WXuoQ
1HaYu5SR30IIwfc0j6/gkkbwT76OqzohX+iwWKGiRvqcNjy9xPMGSFnlIdIP
LD0BAEk8/ug=
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQbf/KR3exUKGDQGzAfaFybQeLlaxNpnwI/uammjuM
XIUOfeEKVZeWaDskTK8TvchW6PA/xiRFx13HIUdLY4YxS6FDF8d/JY9TCH5i
bs9chThdOP/ppR+t7gp6cP7RtU0SHG8R/LoT0ev0qvQdvK6/FO5gL3TY9GUh
9ydmA4fftXP2+ALtt5KfpzrD0cDhXvwtZzGg+/5Ysv7cmGbgIJylrCUoguAr
LL7p8VESwVdT1OtJkC10UDwlviVCz8BhzlP/5ZbyhQ49PgfWBzIYOPwoD5YN
USp0ENZ7ImiTow/nH6l9ck2kVA/O36zxZtGJn7pwvoXvfNkFejoOUx6KTjkr
iQgv9PAEAJNfhpI=
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4sT7fkqH5hc6bGzSFDHOUXG4+arIK+I0Ev/S
v6TOswj+xwQDlYYLmPzuExu6zC8h+Kl8Fow2Fqpw/XA+1HwYH2Y/Op/r5f0n
b/dpwflzvnv+v8OqDedLnMzQa0zVdjBaOuvfxDkIPkv2s1uJMzH5MP0wPsx8
GB9m/8U3ooVLc5H4LF0RJdkI/q6yiOm1GZh8mP9hfFj4wPTD+VDzYXyY/ej8
RfsOsHMdloXz6xe+uaRtiuDnPbyS5F0iA/c/jA8LH3Q+TD+MDzMfPf4Bwzff
nQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4oqjTsl3+Eod9OwSKl//MHGA8StDef74GpnC
+fvXzDIUMzd18OSrlUnjRvD3xidsvMpY6vDj8Pl6/nkmDr3ThSNtvpTA+fpT
mA5avcfkT/V/pdYTaOLAOPXB4fBPCP7SrzHeU38j+Fd+ej/bzFzq0JxU+nXL
RAQ/73flOq+benB+2Y/sTceU9BwMLf8fsALyC2fIMWc81XW4LLF2sd7XEji/
VHQOt+4HTH5KxFHpme66Dr0c2RyzvyL45ceC6kWA5sH4y+KPq3hwIvhXf1if
quZH8PdvU3b8KoPgX1/5yTZZCZMPs79y2cOlibIIvnRbf0coP4IPC/8lkz4U
G8nqwfm/ONO3i91C8GHxBwCIkMge
    "]], 
   RasterBox[{{0}}, {{289.148, 10.187899999999999`}, {383.82800000000003`, 
    10.6679}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4pNfl+ZuiihyCHizsHZNG5vD99rJjIdDEPwH
199G/A0ucmDhPzQpUZ7FIbs6IedeUJFD8XdLu6g5DA62+qLSwYFFDrnX7+da
nvtnb2t9vs8qoMjh2AoBE+7Ov/YqdUel7rki+Fn67iZ5Tgh+xhNbCTM1BH8G
t/enS2ZFDmf2HlgT8Azonp2mLh7+RQ7nN7B7hj4RcIC5V6QvS6mWVRjO55k1
LULyhxicL7Bsz8bfZdIO921nb1jjVeSQ5byFR32+nAPP62O7V5sj+GsLJ17j
V0PwLdqzt7ZLFTmYJZhafxeQhvOXdfCsrpgvDudf+dOTdqBE1OHOz7osBSUE
nyuoRX8yEj/gYJuPliqCr7TqQ3qFVpFDg8f+WtmXCH7Mxv1v5pWLw/nPDpkz
C5VKOCidcOTcrV7kELH9KvvbAkmHgPvX3+YoIfhcD3UaTBQR/Gm/L/95roDg
py8+Z14K5J/h2DknJl3S4U7Kz3hulSIHqbRwgZ0fpR24n/2ULdABxvdhRrvO
ZFkHHmbrxVWmCP4G3U8Llzkj+N/e/zoTCQzPoCjhNFMDKTj/Xvwjk5dfxOD8
rKUCJ1RPCzuoLPpcOgUY33O2md7oWiPgYL3OrYzTqsghSnrfA70SHoep61at
sJcpcjhxzbglWem7PSx89ViX/OVP+Qrn58qExeoIIvjXWAK/M3p8tA/Z63bH
MwTBR0/PABIxQvI=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQXWTxeTVnepHDGtuJZ/pTWB2WnDP/O2UCJj/gep5Y
V/5fexhf7t1NTZ4X3+13N0yXdALyHViljSrNvtlf1NWasbkFwXfdNT+4oBGT
f40l8Dujx0d78en+v6+1I/iv7lXO0JiA4C/hPKX8aBqCH28itX72XAT/9bsP
vcLLEPy9pxeYVq3B5MPsN4wQ+2i2EsH3YF2Zv2Iugh+/naMndC7CfzA+zP8w
Pix8EnreRn1eg8k/8WDP5FUn2B1g6tH5U2pfy5nEyMH5fQkdjqy68nC+3PlD
P/Wz5R2YJKfqn56F4EteX7c/fiaCXyaWNOvZDATf3V0jZ+H0Ioc/H307b72T
c4DFL8x+9PgGAM0L6Rs=
     "], {{297.1360007, 2.9729816000000007`}, {
     294.71227718750004`, 2.9729816000000007`}, {297.1360007, 
     6.758784800000001}, {297.1360007, 2.9729816000000007`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxd1H0s1HEcB/DL6bI60s/t3HGqq8SoRUXL0+/TelBrerhRVqtJRKir7yjd
Tt2ljKxlMormaJ7iSI+uB+fkFPIsuo6IhSmlOxmWWb/+8Ptaf7z/eO37tH2/
732FwWJRKJPBYCygsoOKCZUwV/aTwj4EEsXvFrvjBMi6ckm3UQQ/Owx35JFW
8FbmHs+fQEBUTLvtduDS9p+seCny4tMWBRWkFogFkK4acZINI4jY/pTtoFgO
yqRi0yId9go783TLeuzbCSHE/koE2vNOJ2/6C2hD5p8JfzGf9uNEVrPamQd+
nQNTag0C7hHXii5kDWa8wkjfWuySoiVvVjVgxz0Y0ZJNCBrtFeHhB3i0sy1C
vJ/F8GlnciSBTLEtuJ9TurysxS75FRZ7qwZb2lfmd7AOAUsZ8Gqtkx0YA+Oq
JO0IGjjBX21z7KD7x2lvE908O86c3N+LPS5JHtAMIZhxthEaNQLa5c7V3k6u
fNrqRIbBVMWjzau44Bt5hgu19fcD1AMILg8OaawfckArvbSAS+2f5bVY+q2O
gO6Q7IIP1Pm9VnrH3GICTq0NPjr1AVtZJb75ogPbON4Xz2ydNz+8/7ChGbvG
Jag+n7ofUWhlpWUuAfrIZKmsEUHt8xyRLAN7z6B8dc8WbAjdlVTYvAxWRrh/
UzVh67fJwg61YhvzC6xWf8Q+0P44j/sVe9UzkmUYQSDPimgnvCxo13hfJwRx
LNpJVfI1vjGTZI/CpUlI9dlHcLbN6ouRNN4dVXjqsLeI73GutmGX6MZTNNR7
qzddMTxKmSCLOekdO6l+OWrKZ6b1s6T7eKZ59L9+abbWpZjNkvvEbrlLqX6p
LYY0rzsZMOc8m6w3YxNM2oFRn637x1hgRjQ86qDWS6Pey56kmYFfy0JybzV2
8cbh6MTKeeMbunoSVAgexLOUp8SLaM9a7JT7fGLSNt18tOaQfopMs9Ez1r1D
wFauT3i9YZTUei4WBuiwyzxOxN76js3WaVX90wjsJeoljBsztMcmJaUex1gw
59TO0uzbX9iQ0b0oYnYMgUdo/cVricvg///iL6Df/Ug=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYn0PFydRj2KHgDcLa9e0sTnEXjC8puqC4Ltp
9egmOBc7sPAfmpQoz+Jw8ew/B0enYofi75Z2UXMYHBY3bn6/1aHYIff6/VzL
c//sF/fmJs+1L3Y4tkLAhLvzr33XheT3DqYI/oXGpxwXDRH8c2Z33swQRfD/
xb48ZqpW7HBm74E1Ac+A7uG5IrHartjh/AZ2z9AnAg4w94r0ZSnVsgrD+Tyz
pkVI/hCD8wWW7dn4u0zawXWCZSu/VbFDlvMWHvX5cg5FtqkT+NQRfOEj+quL
RBH8eTc5u15xFjuYJZhafxeQhvOXdfCsrpgvDudf+dOTdqBE1MHJR9a+WRDB
L1iixPINib9NWFWxVwTB7/jTZ3NbstihwWN/rexLBD9m4/4388rF4fxnh8yZ
hUolHDqkHtyVFS92iNh+lf1tgaTDNsOyQ+cFEfwC49Mh0wUQ/D++RRe9kPhn
v+bw3OAHhifHzjkx6ZIOTtunm+QJFztIpYUL7Pwo7VBoMePTJWlgfB9mtOtM
lnUoCr1ZflcFwRdrmFDGaYzgxzjNXLjHstghKEo4zdRACs6/F//I5OUXMTg/
a6nACdXTwg5dXyZ6fQfG95xtpje61gg4LGR46pWjWewQJb3vgV4Jj8NvBs/a
RdzFDieuGbckK323h4WvHuuSv/wpX+H8XJmwWB1BBP8aS+B3Ro+P9rv4n25Y
44zgo6dnAOTtNbo=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQA2IQnTY9LlChu9hBV7VgwtZXAg4w/ozZcRLzQ/jh/A+V
kXlHhH7ZT17sdU+putjBTibvovCDT/YpGuq3DIsQ/JUBd2Om5CP43oW/5D3T
Efwk39RAheRih7Kko/GeK77bX3+VKMeQheBPCgx5Y5dd7MAmy6Gyx+APnH/K
22PrzCv/4Px4W4uXx68wOiTL1jY1Ac2fMCuVtZSB2WHFuX+zhVIQfBNGKYap
iQj+fu+V3s9iih0apNZGygYywfnWsrkHvy//Zw/jGyS97F0S98X+3ZmVnN6p
xQ48a3Tb9ui/sb/B2xBbV4Tg+0kf2dvShuBbzOX8VDGz2MHtwT+h5QcZHWD8
mj+WCZsiBOF8qbRwgZ0fpR0O/bJvj20vdshy3sKjPl/O4aaT6anwSgR/pYvy
yzUFCL6JwadNvzKKHf75TZbMfynrMNFEON0kqdhBTq00NlhNxiFJrnferuhi
B7UHNf3zE6UcKr9IiclFFDu8ObRFxHS3BJy/hmmrhM1JUTi/M7JSuPe+gMOB
jFcXPgD9K2B37+tjHi4HU8GJX+vLEXwzja8HxBoR/NrcNyeage5XZ2FbEhHM
64CengDnaQF2
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQ/YHBP+pNebGDz2xW0+tHuB3YTyvFZZQi+Kbldr76
eQi+bN2kab6ZxQ5cHHOir8cIOHj/OrqtLK3YIX/+rzXXLwrC+cEdZtt6TwrD
+WsOhYZs3i4K599ouiftfF0czmdwfnVx/QZJhwN293cfA5qfdstDeYOqtAPb
HK/VTED7vQ636KTJyjrIddq8+1Nc7HBKJOmJ9AJZh8lbH3LXVSL4Nwt5a/c2
IPi3dkSKf2otdlBaZvwsxVPGoTbRKHROR7GDVoK1xMYWKQeOlNRXDV3FDrP8
3D5IOUo6pE2PC1ToLnYwE9HVX39MDM7fJC/xLeuHCIJfdiqyb7Ogw+q7qaVH
WxHhgx6eAOkXmLs=
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKF2kldzr8rLY4cKHNN57XwUcYHzn1RZVC+VFHKJb
9j6pe1HsMM/D4OoZd3EH54nvngs8LnZomHK8M9VYyuFc2YPvr24XO+idXMao
8U/Wof1b2EmD88UOWc5beNTnyzkU8Ds5rDqB4OeXvp8euR/Bn3OOpZJlS7FD
SLN8t/IMWYfNhx5PXLW22KFqileF01tJh1PqUlHrVxQ75J2TeStsLO6wubFk
48vlCPfB+DD3w/hH36TezmTkgfOj1TIsuJ6yOPw8lr0zbB3QPBPVf2dP/LXX
iGJeKrYVqJ/lytN7jB/tzyzidm09UOywewrLJ7MNr+3P+n2VMjyB4Edynvm5
4gKCv0BIcf+EO8UOTPvdJilofLTvlEh9UwYMn2mGX+xchBng4bdur3/ownZW
ePiysEhYt63jdkAP/61zpv5rBtp3jSXwO6PHR/uIpXa3Mg8h+BprOTcb7Sx2
+ONlGHjO9qv96Yktxknbih3WXFn0xdqQySEvy9VhFTA8I3Luij98zwbnf3nj
m95kxAfnrynz9cjOFYTzT880nzH9izCcL2VueqFmgpiDxkVzvpfA8EkQmbFy
yUYJB4f4zPP3dxQ7ZDy47a+YKusQ0Xvq06wjwPQRleP5d78s3P0w/lmh4Bur
zyL4f/6d7f59vdjBKM07zJVL1kGk97/Pp1vFDsc4bLotFSUdtjtO+tcMDM+A
jUdPRrwWg/PtX0vpsr8WhvNh7ofxa34YBbZ84EHIMx81qZjE7hAlFcx9Bmh+
3t4PU+RbmBzm75faWHKj2CE46fq3MuZv9k/W2PF2nUeEL3r4AwA3KHil
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4qmzHolVmJc4BLxZWLumjc3hsNKFVR3GCP6a
Gi2mw0YlDiz8hyYlyrM4mCvMFV1iWOJQ/N3SLmoOgwPnlcAjEgYlDrnX7+da
nvtnz/mA24JBv8Th2AoBE+7Ov/YflJiOLFZB8M2uNN81VkTwTTqrDv5mQfBT
NrTPniFa4nBm74E1Ac+A7okresurV+JwfgO7Z+gTAQeYe0X6spRqWYXhfJ5Z
0yIkf4jB+QLL9mz8XSbtsPrR9cgizRKHLOctPOrz5Rxu9DOnFooh+JVi5+qv
siD4LDor4nx/FjuYJZhafxeQhvOXdfCsrpgvDudf+dOTdqBE1GHFvN3CzxhK
4Pxr3w7ciGBE8GXSDn99z4zgv/PTFbTjLHFo8NhfK/sSwY/ZuP/NvHJxOP/Z
IXNmoVIJh3c5dZsa2EocIrZfZX9bIOkg0yIy3YgRwb/Wmqn5638xnJ+0QGDZ
WiS+sQf3Qysg/wzHzjkx6ZIOKzjNOC8ylThIpYUL7Pwo7XC9y+y4KTcwvg8z
2nUmyzrcWF7u4yCC4Ndc0vPOUULwD00xL5MHhmdQlHCaqYEUnH8v/pHJyy9i
cH7WUoETqqeFHT64GchHAeN7zjbTG11rBBzYg5vlz0uUOERJ73ugV8LjkBj8
PJD1d7HDiWvGLclK3+1h4avHuuQvf8pXOD9XJixWRxDBv8YS+J3R46O9QlJz
Kz8wvcL46OkZADOKMng=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKD3v/fJjtztKHC58SOO991XAAcZ3Xm1RtVBexKHd
k0lODMif52Fw9Yy7uEN+mLHiiqYSh4YpxztTjaUcflmrGjZVlzjonVzGqPFP
1mHz7tlMJ/JKHLKct/Coz5dzmHOlrdIxA8GfbWVy8UMcgn9isuem2cElDiHN
8t3KM2Qd7rdrnHb0LXGomuJV4fRW0uHbm7jJbh4lDnnnZN4KG4s73Hfb+arB
HeE+GB/mfhj/6JvU25mMPHB+tFqGBddTFgfVng2f3gLNzzNR/Xf2xF/7EHmP
e2tDgPpZrjy9x/jR/kd6QJ1MQonD7iksn8w2vLb/KWwVciIdwW89J2DsUIDg
n7me+kO9psSBab/bJAWNj/Zb765U5WsucZhm+MXORZgBHn7r9vqHLmxnhYcv
C4uEdds6bgf08H+YeMtcGhhe11gCvzN6fLRvyWoWZkxC8EOK/N6cjChx+ONl
GHjO9qv997CTOT9DSxzWXFn0xdqQyWGWflelI9A/ETl3xR++Z4Pzv7zxTW8y
4oPz15T5emTnCsL5p2eaz5j+RRjOlzI3vVAzQcwhZFqNewPQ/ASRGSuXbJRw
yFFZx1EOtD/jwW1/xVRZh5Ygfh2jFGD6iMrx/LtfFu5+GP/n9emCzrkIvsYR
oaOTykscjNK8w1y5ZB0cglzaOqtKHI5x2HRbKko6PGa7bi4NDM+AjUdPRrwW
g/PtX0vpsr8WhvNh7ofxa34YBbZ84EHIMx81qZjE7tB2f7pLMtD8vL0fpsi3
MDmcbol/xV1R4hCcdP1bGfM3e4GiZjfFfET4ooc/AF7CXkw=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKH2jhjFp+Y0Shwsf0njvfRVwgPGdV1tULZQXcTh4
LXrnw+slDvM8DK6ecRd3WPm4Z0/xpRKHhinHO1ONpRxMTtad8T1d4qB3chmj
xj9Zh7ceX+dO3lfikOW8hUd9vpzDtcQHIrw7EPyrx3tz9qxD8JkUF/umLy5x
CGmW71aeIesgKdqUxju3xKFqileF01tJB4OqHXpCM0oc8s7JvBU2FneQvCLU
5jMd4T4YH+Z+GP/om9TbmYw8cH60WoYF11MWh3hJrr6dQPPzTFT/nT3x175v
zcLKyiVA/SxXnt5j/Ghv9HWl5Iv1JQ67p7B8Mtvw2t544eT3k7cj+Pujs85x
H0Dw2VL3T/4M9D/TfrdJChof7d9nMR+8CQyfaYZf7FyEGeDht26vf+jCdlZ4
+LKwSFi3reN2QA9/6ffGl58B7bvGEvid0eOj/b7vd9ad2Yjg9/1f3j51RYnD
Hy/DwHO2X+0NnyhxHF1a4rDmyqIv1oZMDlf2PBbhBfonIueu+MP3bHD+lze+
6U1GfHD+mjJfj+xcQTj/9EzzGdO/CMP5UuamF2omiDn0KV975A00P0Fkxsol
GyUclm1kX+IEtD/jwW1/xVRZh333M47/3QxMH1E5nn/3y8LdD+Mbp35cw7cX
wU8KzEmIO17iYJTmHebKJetQdX+uYuipEodjHDbdloqSDrJTDC4/A4ZnwMaj
JyNei8H59q+ldNlfC8P5MPfD+DU/jAJbPvAg5JmPmlRMYnc4kPPxvh7Q/Ly9
H6bItzA5sArtbL0OtD846fq3MuZv9l7/7zx8sw8RvujhDwD2PHRe
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{
     1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{335.6326814, 5.6021845625000015`}, {
     335.17969261250005`, 5.896393775000002}, {335.14077605, 
     6.229519550000001}, {335.14077605, 6.3960824375000005`}, {335.14077605, 
     6.9938408375000005`}, {335.78056433750004`, 7.406356400000002}, {
     336.4810624625, 7.406356400000002}, {337.2002405375, 
     7.406356400000002}, {337.83068885, 6.895771100000001}, {337.83068885, 
     6.190602987500002}, {337.83068885, 5.631761150000001}, {337.4461932125, 
     5.160092412500001}, {336.8546614625, 4.8176266625}, {335.6326814, 
     5.6021845625000015`}}, CompressedData["
1:eJxTTMoPSmViYGCQB2IQLdDZE6EpWOqgkp0Rl7leyOHXw2uTtWVKHYqevpl7
UUnE4cymM8dXKZc6FGgn1a7QFYPzKwov1h89IgHnzyi/yvwsScbhUfll3dei
pQ5Zzlt41OfLOQi8t9xwgx3Bt/3q0Zz+owTOn7njV9iD1yUOOwwvVu/bJg3n
q8zqmrdUQAIhvzRz9dsocTj/QHzhXctpog4b5/M/SPtU4rBhj71l6j5hB77j
fpflvpQ47JGsf2PvCuRz7Nt8/2eJg5fqw+cpnkIO39c5xh/6W+LQ9Gdb4dV5
gg6qHx5FzAOqXy/8aU5HpYBDcGKOosTzEofiiu/b/Nt54Py5e28oWGxlgfNL
WRvOb1n7w765L2yrxvcSB541um179N/Yh9b05m0C+hfGf3Rh29cqSQRfiCv6
b5FGqUPqu62/Nxj+hvNjPB8atPOyOcD4fNKpf9OecDhsfSTNtVut1EHnIefe
fwU8Dpq9j9J2KZQ6/O9n+mV8hN9h7rRM172ypQ4aqUHO0tsEHLYk2HpaSpc6
vO79v7xdStABPX4BGzriig==
     "], {{336.08722685000004`, 4.258784825000001}, {
     336.36119945, 4.092221937500001}, {336.82352821250004`, 
     3.7980127250000004`}, {337.2936402875, 3.4944635375000006`}, {
     337.56916955, 3.3076640375000004`}, {338.02994165, 3.013454825}, {
     338.02994165, 2.415696425}, {338.02994165, 1.6902917000000004`}, {
     337.29519695000005`, 1.1797064000000002`}, {336.49040243750005`, 
     1.1797064000000002`}, {335.6466913625, 1.1797064000000002`}, {
     334.94152325000005`, 1.7883614375000003`}, {334.94152325000005`, 
     2.6009392625000007`}, {334.94152325000005`, 3.1706777375000006`}, {
     335.2544124125, 3.7980127250000004`}, {336.08722685000004`, 
     4.258784825000001}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4r6CJbV740odNDpPadcsk3WA8YOeVZmx9cjB
+VnOW3jU58s5xO+8Z+YejeBf5jp0eltgqYPfgg5XHmsZh8VOpcWyLgi+q33K
bWl7TP6Bc58e/uOQdhB3cLpn4YTg716wL7XMG8F/tWQtw9TgUocKKXmZRZwy
cL6W7Leevqt/7WH8TNa2NXmKP+zdnyTclgbyHViljSrNvtm/PMy3j98Vwe8+
8FeVzwGTf40l8Dujx0f7xZvPKNW4Ivi9hVtmfg1C8PdwadprRiL4rxfPfRIT
j+BfTWyNvpaD4L8NCYlwKcLkw+zvD3Q+4JSL4BsaflxkFo/gw8L/1rVVO858
+Q7nt0+Mu/Lu9l979PgDAB91ymk=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI1IGYCYoF4ta4TJ0sdum6Z9TSdknFosTg6U/d0qcOU
WRdf2bvKwvlHRJ5e+hGJ4E/4qzNNyVLOIUvlx9SNSxF85cw7DqsmIfhW0jax
4UB+0LMqM7YeOYe7z52+bZ9Y6uDSad2szSrvUH+j/NW5XgQ/I2mXwPKOUodT
TGoFr9XFHY4WtspM6EHwM4wuOXIC1Zttfz5P6oy4wx3uwsC8vlIHtQWyp8UC
pBysNhxMz5lQ6mCQsEPzyikgfwn7lxagfQfOfXr4j0PawVqB8/ekuQg+j+7C
wunzEfzZT8Ml5u9H8DepJbS+3VvqECZluPl8ipRD9oKfc/ZvLHUI6Tv56B+H
mMNMJa7ymHWlDp/KNKUEtos4ZN1d/btmATA8pZfluC/lc1i/4IhTxuxSBzu1
7w+i2pjh/HcT1vDG7/lmD+O3VfYb+6p8hfNXmHvoWj5+bT9DWWrylEUIftOy
/McHVmLyYfphfJj5MP6TFY3du57/g/P/8bk22t1kdoDxX+01ZGFw5XCw4U3a
+H9VqUPPVYPeglk8DjMdoiXmry51mFuRZOhaxOcwU+O5wYW1pQ7fDLZYWa4R
cuA79vjv+i2lDh1LG+Wvaoo6oKcnAEhDGvg=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQ7ZziPvPyk1KHld/69kd6CTrA+P02ApFLbITg/A/a
Cv9Wm8g4vLjqZWTyo9ThlEjSE+kFsg4Xz195bcRQBuczsKwJfc+M4DPu8Z/f
xFXmsM48q/VlpqzDbq5zrZ94yxz8FnS48ljLOEjcZ8vu40bwxVcF/tvCgsl3
sN2WeqBECs4P+b59V5CNpIPbPY2MQo4yhyXax6WeLJFwYNRd7veQG8Ev/dX9
Ko4PwX+1/s88XuEyhzXZiz/0/0Hw522UW6tQLQXnF+2NqXp1QsYh7nHfJCue
Mocs5y086vPlHF60Cx4K/l8K5+u+rVxc/BrBL4yb86PqWqnDuY5y1bwuSTj/
z6qYFX+uCsD5Nu+8Gne7/bRfWCy0dM+LUgeeNbpte/Tf2L+IEzuZ+B3BZzj3
7MxdoP9gfAP27itXxcscOt4tTmm+9gfO5569rCT0IIcDjL/K7F3zo2hBB30F
/ht3OMscntzsWrRGTtSh+JXI12Jg/MH597PmHnmL4Heezfnz7Xmpw4vLJe1x
qsIO6OkDAObrAEs=
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQrfcms936e6mDnUzeReEHn+xd2lNvBL5F8KMz1x6e
86LU4RDrzU01tn/sRV8IV656XuqgdMD49bUp/+ydU9xnXn5S6sD8xmPWk29M
DjD+eebNc73MOeH8yk0OCV3zueD8T68OetpHCziIXpg/8fbLUgc37e9Mm51E
HHb+CpvA/gPBX2TQ3NP9C8EvaUmfe4SxDM7vqRUOWcZW5rD1W8ej+dcEHeIY
HxjXcpY51M28t+V8igCcX1lRcqLoLA+cH7Yp6Pv2Xxxwvrdn1h9Za1Y4/8Hr
KEOhIEaHXRHs3y4BzS+b+Hx+K+df+9hL7I3iTGUOU4xFyvcs/WwvLnaH/8Yv
RHihhycA19afew==
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGBQBmIQXftxgcl8kzKHld/69kd6CTrA+P02ApFLbITg/A/a
Cv9Wm8g4KCUvOfvfvczhlEjSE+kFsg7csXrt//wRfKuJrB93BSP41p4rrfyi
yhzWmWe1vsyUdfg6XV1xX2yZg9+CDlceaxmHoJwEtqhoBD/QfPXMhhBMvoPt
ttQDJVJwfsj37buCbCQdGrKbmG0jyhyWaB+XerJEwsF6F8OrNdEI/vr2p61a
cQi+im2Y1c2kMoc12Ys/9P9B8OdtlFurUC0F5xftjal6dULGYUbBC122mDKH
LOctPOrz5RyURLNj5f0R/PSqy3b21gj+6tdfJ7uplTmc6yhXzeuShPP/rIpZ
8eeqAJxv886rcbfbT/vbDDkOHRZlDjxrdNv26L+xV3qTn6LrjuBbRTtkrIxA
8LOmPMlfmF7m0PFucUrztT9wPvfsZSWhBzkcYPxVZu+aH0ULOmSuzSheEVnm
8ORm16I1cqIOa8vzJth7IPFzjlhMsEXwD0cdm37IvMzhxeWS9jhVYQf09AEA
+kvzyw==
     "], CompressedData["
1:eJxTTMoPSmViYGAQA2IQnVF5WIndvczBTibvovCDT/Z1IvuLZW0R/Knf2OIz
LMocDrHe3FRj+8fevzRXpMy8zEHpgPHra1P+2dd+XGAy36TMgfmNx6wn35gc
YPzzzJvneplzwvmVmxwSuuZzwfmfXh30tI8WcPCP/amz3LLMwU37O9NmJxGH
z+0btC+7I/h39t5RD/dC8NcJHrSYEIjgH+PKfV8YVuaw9VvHo/nXBB1m9Fme
94gsc6ibeW/L+RQBOL+youRE0VkeOD9sU9D37b844Hxvz6w/stascP6D11GG
QkGMDl+eJkycBzS/bOLz+a2cf+2nxyfKPAbaP8VYpHzP0s/2gYtNVy/2QoQX
engCALqsngk=
     "]}], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
      3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0,
      1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ/d4gwly/pMxhje3EM/0prA6Kx+d07JqLyQ+4nifW
lf/XHsaXe3dTk+fFd3uLyj9L0oF8B1Zpo0qzb/Z+av3KNyci+Ic2sdyf2ofJ
v8YS+J3R46P9lP4tbX+mIPjp1+8p+81F8BWZ9NezL0Hw7+jUWx1cheBnPA+V
tNyM4FsdYT04fycmH2b/uoDqmphtCP7Rv7y/z65C8O+szxWvXoXwH4wP8z+M
Dwufuy1BzyR2YfJPPNgzedUJdgeYenT+lNrXciYxcnB+X0KHI6uuPJwvd/7Q
T/1seYd6wV+7PixH8KedF/ZuXYbgf+Y7rsqDxD9i3/v9GDC8/nz07bz1Ts4B
Fr8w+9HjGwAJgu2q
     "], {{361.95766684, 2.9729816000000007`}, {
     359.5339433275, 2.9729816000000007`}, {361.95766684, 
     6.758784800000001}, {361.95766684, 2.9729816000000007`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKH1RdYYjO3u5w4UPabz3vgo4wPjOqy2qFsqLOOyq
/zTDka3cYZ6HwdUz7uIOi3qU51xmKHdomHK8M9VYykG3SHTN2p9lDnonlzFq
/JN1ePaxu/bzmzKHLOctPOrz5RzOc5V/yXmG4J8rUPGRuYvg/z5pqXv8YplD
SLN8t/IMWQehfRJuuafLHKqmeFU4vZV00FT25ys6VuaQd07mrbCxuINQ7crU
NUfL4O6D8WHuh/GPvkm9ncnIA+dHq2VYcD1lcYg4tCBX8gzQPBPVf2dP/LVv
D7WIvHkJqJ/lytN7jB/ttec5/HS/V+awewrLJ7MNr+11vLTOf36K4O9gYVyX
/Q7B/88bVhz8q8yBab/bJAWNj/YvhGctsGQsd5hm+MXORZgBHn7r9vqHLmxn
hYcvC4uEdds6bgf08BeZcWqTGzC8rrEEfmf0+Gi/fUFxn84DBL99hV3612tl
Dn+8DAPP2X611+rd+VzlSpnDmiuLvlgbMjmcTa36kgP0T0TOXfGH79ng/C9v
fNObjPjg/DVlvh7ZuYJw/umZ5jOmfxGG86XMTS/UTBBzaD+Tc2j15TKHBJEZ
K5dslHCYHzWveRHQ/owHt/0VU2Udtnf8Xxb7qMxhXlSO59/9snD3w/g6fB09
ea8R/OhfTA77vpY5GKV5h7lyyToUd5gwbv1R5nCMw6bbUlHSQcz2+CY3YHgG
bDx6MuK1GJxv/1pKl/21MJwPcz+MX/PDKLDlAw9CnvmoScUkdoedoh37+4Dm
5+39MEW+hcnh3y7/VPNvZQ7BSde/lTF/s3dZUXzQ5y0ifNHDHwCiN2xY
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKB1yNXzmwrByhwsf0njvfRVwgPGdV1tULZQXcbDV
3/Thdmi5wzwPg6tn3MUdVG0ef84NKHdomHK8M9VYymGD4lVmD89yB72Tyxg1
/sk6ZC70vtprU+6Q5byFR32+nEPQLjMfdjMEP1DhyeJtOgh+XeXPlkTFcoeQ
Zvlu5RmyDlNzb8xlly53qJriVeH0VtJhzSW+NB6xcoe8czJvhY3FHabqZO51
E0W4D8aHuR/GP/om9XYmIw+cH62WYcH1lMXhdmHC0c1A8/NMVP+dPfHXnov1
x4ZiJaB+litP7zF+tF/nyxD4SLfcYfcUlk9mG17br//5Uq3PFMG33nKAlc0O
wW/aK3r6LdD/TPvdJilofLTPPhz54zIwfKYZfrFzEWaAh9+6vf6hC9tZ4eHL
wiJh3baO2wE9/Ke7d3E9BNp3jSXwO6PHR3urAONnx/QRfK6If/v61cod/ngZ
Bp6z/Wq/1qbSfr9yucOaK4u+WBsyOQSIWvmwA/0TkXNX/OF7Njj/yxvf9CYj
Pjh/TZmvR3auIJx/eqb5jOlfhOF8KXPTCzUTxBy4anSk3IDmJ4jMWLlko4SD
ElfcbRug/RkPbvsrpso6WFns//fdEJg+onI8/+6Xhbsfxl+/1/0JhzWCf2/l
oekRruUORmneYa5csg7fzL9E+HuUOxzjsOm2VJR0mPmmjeshMDwDNh49GfFa
DM63fy2ly/5aGM6HuR/Gr/lhFNjygQchz3zUpGISu4PNUXdxTaD5eXs/TJFv
YXJozOLfexFof3DS9W9lzN/sj4UbSz63QYQvevgDAJbYT6Y=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKN2XtNEkd1m5w4UPabz3vgo4wPjOqy2qFsqLOJTv
4e5ZvrTcYZ6HwdUz7uIO8Sdt+i0XlDs0TDnemWos5fBqnd584ZnlDnonlzFq
/JN1WKy3tCCyp9why3kLj/p8OYce9wnPL7Ui+N1rbe2bahD8HWzBCrqF5Q4h
zfLdyjNkHc7/MrS8nFXuUDXFq8LpraTDs/gMxhup5Q5552TeChuLO5zfeShC
KBXhPhgf5n4Y/+ib1NuZjDxwfrRahgXXUxYH0f87E+qzgeaZqP47e+Kvvcuk
QB/7IqB+litP7zF+tH9xK/LN2tpyh91TWD6ZbXht/7LN+VBkK4Jf6ii18GIv
gr/HKz9tJ9D/TPvdJilofLRfGrB58nxg+Ewz/GLnIswAD791e/1DF7azwsOX
hUXCum0dtwN6+F+88njpGqB911gCvzN6fLQvudvTOKkewXd5Gh4VXVbu8MfL
MPCc7Vf75ycv3eoqLndYc2XRF2tDJoeuRZOfXwKGZ0TOXfGH79ng/C9vfNOb
jPjg/DVlvh7ZuYJw/umZ5jOmfxGG86XMTS/UTBBzcOFs2yoIND9BZMbKJRsl
HGKmby/jANqf8eC2v2KqrEPJUYlZhxuB6SMqx/Pvflm4+2H8l14L6690IfgS
5jLGKlPLHYzSvMNcuWQdDI76fpGaUe5wjMOm21JR0uFy5YOla4DhGbDx6MmI
12Jwvv1rKV3218JwPsz9MH7ND6PAlg88CHnmoyYVk9gdyoIWbvoyHRjfez9M
kW9hctj9PSNiLtD+4KTr38qYv9kzPO3ZsqkHEb7o4Q8ABBZ0qQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKC0oVNjD/q3c4cKHNN57XwUcYHzn1RZVC+VFHH5l
n37s+LXcYZ6HwdUz7uIOjyr+PLv8vtyhYcrxzlRjKYfcuHff1r4od9A7uYxR
45+sg9q9lBOfb5c7ZDlv4VGfL+fA/93fPvcqgs8X+3eazBkE33qbUMXxA+UO
Ic3y3cozZB2CVn2ckLur3KFqileF01tJh0x+jciireUOeedk3gobizsEZTZt
WLMF4T4YH+Z+GP/om9TbmYw8cH60WoYF11MWhxnrKndI7gaaZ6L67+yJv/bH
HQWX3DwI1M9y5ek9xo/22V2SLh5nyx12T2H5ZLbhtX2OGbPUlysI/o8PN39k
30Xw7X/p7Qt+We7AtN9tkoLGR3sNhuLXlh/KHaYZfrFzEWaAh9+6vf6hC9tZ
4eHLwiJh3baO2wE9/ENaFv91A4bXNZbA74weH+2/9/jc1DmP4B+fIr7p69Fy
hz9ehoHnbL/aZ1VOMlI9XO6w5sqiL9aGTA68QcH2uUD/ROTcFX/4ng3O//LG
N73JiA/OX1Pm65GdKwjnn55pPmP6F2E4X8rc9ELNBDGH4ztcedccKndIEJmx
cslGCYf7buXnFgHtz3hw218xVdbhe8mNj7EXgekjKsfz735ZuPth/JxfCdfz
biH4s5/d7tr3pNzBKM07zJVL1mFzCa/P1uflDsc4bLotFSUdwjQX/HUDhmfA
xqMnI16Lwfn2r6V02V8Lw/kw98P4NT+MAls+8CDkmY+aVExid/jJmMjVDzQ/
b++HKfItTA52yzU2mD8tdwhOuv6tjPmbfcsUHx7fO4jwRQ9/AMdjbuI=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYhuBxYZLYiocZrQeuO0boOKwwcbDXzWpwoFR
nFOI4Yyyg2rm25xl6RUOKoGHhV45KTs8mP892z0XKH9FzuHCXiWH5ouzHeTz
KxyeTQtzTpoA5G/2mn+nsMJh9v2qOGs/JQd+e8/T74oQ/JzHMx++KUHwW35N
sxQsr3BYYH+Cd1Y3gu/FbTPn6R0EX/5jaXI3q7LDbP2nRhVlFQ48U3bO67VQ
dmiWeHErGGjeLKVUg+wYZYdg3Vpnm7gKh6LT7kFB21QcQg88En1YXOHgWaJV
Yimg5hBqaHXUvrTCofKdbcwnFTW4+WbieeutnRH8B48e2rZPQfA714WeufRU
De7+Pr7F1YbK6nD/wfhqJdOPhCLx+c99lJ4ADA+P7SJumXLqDrPKHV8+AYZX
8cVbdYe/qjnAwt9H8PyJMBlVuPsrRJySxLw0HHgXaLYmAflHTsu62/ZowOX/
qNqmpzFqOvCeMpnVE4Xg32Pbel8vAok/2+qVc1iFw8a8xCb7/Rpwftr21rkS
tQi+0d7NOn6uGg5Zoote/IpAuCfj7TZuR9cKh0XZ8Q76H9Qcpj+Qm2rjjPAP
jA/z77Q3NzhUnBD8gPKfhpIOSPz+XMkXtojwhPFh4Q3jw+IjQzPS75h9hcPb
+wHBasD4Csy232foiIhPFdkrJmbhFQ47lK61S+1Wgcs/rPycapyoDNe/4f/9
2iofZbj5X66t1zLUQ/Bh6Q3Gh6VHmPth6RXmPxj/i/yl/MNIfO5j5RKdwPB4
aMY5hTlYCR5+22Sco1dWK8HD994dP0GxUBV4+DfEn+ifK6QI53P1qRXJ/FSA
85dJOkrOXKPgMKMyUTEUqF/3xIMitgIFh+Dwjoi0KAQfll7Q+alKDJP1nyrA
0893g6y1cjqKDuj5HwCd6aQ1
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1G0wXGcUB3C2ne3WS9lJQ0vKvVf27oZsXsgMTcucJK2SYISsZtl2Wo10
RuKtFX1SFZpFM5u2IsNsWCw6KWlsi60VRjEJqVhW0EREi8ZLvGettFYQvZ/u
Y/rhfPjNPOf/5TznkNEJYTEvWFhYWDIVwRSHqdWRqHKbIQSlU1t/SrkrgG6z
5lsz41sxjV9dktCgo4it+SMI/uDNETFiEahTY0OVM9j1pP2KbBbbQKe40U+w
ezgBHQkmBIbKkiSuUQgGzz1K2wUE4xPTsqMDQljbG5ZnZPKCHaP/+T0K+7Pc
1Mb94zTrU4sG//B8GiKlud9UziHg+ip2vOdNw86QOodhI/Zkkdd68FPsHu/1
fYErCAouhvNacrCN5SuaTyVC1pULgimrCBF4DGRorJk8arTO+LFKBBNZPXvr
Z7DXlBuz6r+xV/vLdgn+RGDbGtpLFQshoTe+AB4iaJ7KtqR3C6FEKhMfvY/g
xBf0YM4pEfDVWSGD3bj/0dLZ1MN3sGsDz7Ut3cCWGyJbOdUIPJfT22IcadZZ
1i5H3ikUsLaJnOemnBQALZ9PyqvBtuv9TvJ4k+94Z7jRWuzT5q4ANePtjstf
9iUKQOIft9PE+Nd3++KTiwWgUrpU+jcgoN9QVByqFoL2mGjbD7fwfJ9dHVQu
d2Dz91lLF/TY2R9VpyT0IpAtz/hFcbAfU81bvOZo1jfbFU5dQTSM1Q/4tBsQ
zG6rNI+btrP5NjXq2AKSAn6iRvX5beb9vz5I/4iAokO8c6ZWBOHnpWuWVgRo
fdtCbRqx45rcuU4N2JmXb6Sl1WHLdZMPvGoRJG5k/GYOIOD0B7GZDjoEk3ep
obPRBAirpmKzmf4noR+e+VmPvRp6/MrT90nWQbya7/1GSbY/f2Q96DUeBbUc
T/cW7SbX8e47/IJ97EffTvF1BGVFtiW7sknWi3vmVasTBOsUhdr+yIYryMXO
B7lMHi/CVWrl4wrmTke7yQZs/gVSfrANW9/scX6M+V9Vrze7N5kIiE9HFbJO
BH95WZ55056EZ19ff/tAF4L14G5FcBQBO8h11VQv7l+VxbWHDWEn5TXtl89i
l9qN+iUz+zbs4HxNLKRYO/JjPZyvYufcLEyYfkBBffeKgbeE/aqt5lqOCbvU
65VC98VN7yfidAPMPs5GJF9aa6PAoOzuy2Qs6+h47lJGsffHX+AUKJQToHM4
WaYZxfM9vkXyctUQdrZWl3nxHnZxmuLCS/0I7mnbH75YgR1f/pb4RAjJek7b
QOS2kDD23K1/hfGw7rC1aTcFB+hPbtcweSF66XQ63w3+f0//AxBMcnk=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4rrH2edzLCodZJXy/Fq7tBycdjBxtZog+NPP
bLQxAPINdqvz37bWcuD2+C3PZ1zpYDjt5fSMDE2HK9c/m043rHR4yKVxZbOL
psOfp5OnbjaodPgjeW/NRz1NB96+SeGcGgh+zZV4/WI1BD+uPcvroCCCnxd0
8cZ02UqHkpjeN6sqtBx487K7OxQrHd4s/7/m520th08zGr18gOYdu9etf6pJ
2yGj9pThMqB9Aq97oxhDdBxg/tmWs1b/kr4unF/1X179TIMenH/aU6PWUNzA
weRnmvQKnUqHsK+frH1nGThsup0umieH4Jt+fiK1QgDB/3DY0SmEvdJB61HJ
JFcmBL/5nrSzwWE9OP+TakjBCgE9B4Vr0lvvcFc6VKQ1PYz5r+uwlfFGwwse
BH+TqMnafH4Ev9I+b3+NUKVDoYIKd4adHpy/4YmW2P7DCP7zk6asm9j04eH3
Mumyl2KHvsMhqfTL7jwI/okZu8W2A80/ofZTcLuZgYN2DpuFvXilA5O+cY5K
lIHDxtAm10IZBN+5YkthszqC/zXdPshFF+j/NK/X/fP14XzfnwIhtsDwhPHj
Z/dO1fDWhcfvJ86blafDdBzq/wrMfqtU6VDenLGW47q2g2TE8cJcjkqH6797
y2K6NODhdXi2aUV/FoJf7l10wC8ZwWcAAw0Ht7d1oj9NEHz09AsAcNEnQw==

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}}}, {{{407.56282078000004`, 14.2109283828125}, {
     407.56282078000004`, 14.9736932265625}, {407.47346832687504`, 
     15.520704585937501`}, {407.15528642062503`, 16.0066947578125}, {
     406.9406226003125, 16.325966328125}, {406.51238462375005`, 16.602741}, {
     405.95883528, 16.602741}, {404.35484978000005`, 16.602741}, {
     404.35484978000005`, 14.709994523437501`}, {404.35484978000005`, 
     14.2109283828125}, {404.35484978000005`, 13.7118622421875}, {
     404.35484978000005`, 11.860523}, {405.95883528, 11.860523}, {
     407.56282078000004`, 11.860523}, {407.56282078000004`, 
     13.7118622421875}, {407.56282078000004`, 
     14.2109283828125}}, CompressedData["
1:eJxTTMoPSmViYGCQBGIQPW/uyuTw+EqHHl/tVgU5DQfH1gOyDlEIfmzUqria
4EqHz8XOwWJ1Gg43d7J1ugZWOvCwXb9zcIGmw+oPLH47/CsdwoRusv8s1ILz
85bkTFwyRRvOb/7NyH9nlg6c36FrO2vXXF04/+WVqeeNVus5GDMbHU8Bmj/L
QbD7Ra6+g8Bbhtu7gPYfMjw9z8XZwOFiNcO960D3tfgYFcVlGDgYsRUfT4lH
8E8xvJ2VkYrgr8sQ+KSbXenw5TDHw5O6Bg4P0/os9HMrHW4vq4hx6dN3mOjl
V/ktr9LBKiF88vNzenC+S3DZr8TzunA+zP0wPsx/ML6O+wmHe71aDj1B91lb
gOaXL/Cr3LJO04Fjk7WBL9B+73VJH61zNByW3vvAdzQZEb7o4Q8AGgSqZA==

     "]}]},
  AspectRatio->Automatic,
  ImageSize->{409., 91.},
  PlotRange->{{0., 409.}, {0., 91.}}]], "Output",
 CellChangeTimes->{3.516627758220174*^9}]
}, Open  ]],

Cell[TextData[{
 "You can select your own TeX converter by setting the option ",
 StyleBox["TeXForm",
  FontWeight->"Bold"],
 ". This is what we do in NCTeXForm. The remaining options ",
 StyleBox["PDFViewer",
  FontWeight->"Bold"],
 ", ",
 StyleBox["LaTeXCommand",
  FontWeight->"Bold"],
 ", ",
 StyleBox["PDFLaTeXCommand",
  FontWeight->"Bold"],
 ", ",
 StyleBox["DVIPSCommand",
  FontWeight->"Bold"],
 ", ",
 StyleBox["PS2PDFCommand",
  FontWeight->"Bold"],
 " let you specify the names and, when appropriate, the path, of the \
corresponding programs. With the option ",
 StyleBox["Verbose",
  FontWeight->"Bold"],
 " you can see a detailed display of what is going on behing the scenes. This \
is very useful for debugging. For example, lets try the previous command with \
the verbose flag on."
}], "Text",
 CellChangeTimes->{{3.4548754976620207`*^9, 3.4548757700819263`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"BesselJ", "[", 
   RowBox[{"2", ",", "x"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", 
  RowBox[{"exp", ",", 
   RowBox[{"Verbose", "\[Rule]", "True"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.454875776547596*^9, 3.4548757796277122`*^9}, {
   3.454875925134348*^9, 3.454875954187112*^9}, {3.4548969482587223`*^9, 
   3.454896960314149*^9}, {3.454897404287372*^9, 3.4548974083182173`*^9}, 
   3.454898349807742*^9}],

Cell[BoxData[
 RowBox[{"BesselJ", "[", 
  RowBox[{"2", ",", "x"}], "]"}]], "Output",
 CellChangeTimes->{3.516627758297328*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"* NCTeX - LaTeX processor for NCAlgebra - Version \
0.1\"\>"], "Print",
 CellChangeTimes->{3.5166277583005667`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Creating temporary file '\"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/mNCTeX.tex'...\"\>"}],
  SequenceForm["> Creating temporary file '", "/tmp/mNCTeX.tex'..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.51662775830332*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Processing '\"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/mNCTeX.tex'...\"\>"}],
  SequenceForm["> Processing '", "/tmp/mNCTeX.tex'..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.5166277583072453`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Running '\"\>", 
   "\[InvisibleSpace]", "\<\"latex -output-directory=/tmp/  /tmp/mNCTeX 1> \\\
\"/tmp/mNCRun.out\\\" 2> \\\"/tmp/mNCRun.err\\\"\"\>", 
   "\[InvisibleSpace]", "\<\"'...\"\>"}],
  SequenceForm[
  "> Running '", 
   "latex -output-directory=/tmp/  /tmp/mNCTeX 1> \"/tmp/mNCRun.out\" 2> \
\"/tmp/mNCRun.err\"", "'..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.516627758311624*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Running '\"\>", 
   "\[InvisibleSpace]", "\<\"dvips -o /tmp/mNCTeX.ps -E /tmp/mNCTeX 1> \
\\\"/tmp/mNCRun.out\\\" 2> \\\"/tmp/mNCRun.err\\\"\"\>", 
   "\[InvisibleSpace]", "\<\"'...\"\>"}],
  SequenceForm[
  "> Running '", 
   "dvips -o /tmp/mNCTeX.ps -E /tmp/mNCTeX 1> \"/tmp/mNCRun.out\" 2> \
\"/tmp/mNCRun.err\"", "'..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.5166277583973827`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Running '\"\>", 
   "\[InvisibleSpace]", "\<\"epstopdf  /tmp/mNCTeX.ps 1> \
\\\"/tmp/mNCRun.out\\\" 2> \\\"/tmp/mNCRun.err\\\"\"\>", 
   "\[InvisibleSpace]", "\<\"'...\"\>"}],
  SequenceForm[
  "> Running '", 
   "epstopdf  /tmp/mNCTeX.ps 1> \"/tmp/mNCRun.out\" 2> \"/tmp/mNCRun.err\"", 
   "'..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.516627758441393*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Importing pdf file '\"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/mNCTeX.pdf'...\"\>"}],
  SequenceForm["> Importing pdf file '", "/tmp/mNCTeX.pdf'..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.516627758576844*^9}]
}, Open  ]],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.017241379310344827`], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
      1, 0}}, {{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
     3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1,
      3, 3}}, {{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
     3}}}, {{{3.1117028000000007`, 6.641957025}, {3.1117028000000007`, 
     9.1061537625}, {3.1117028000000007`, 9.4361662125}, {3.1319394125000004`,
      9.506216025}, {3.5911548500000006`, 9.506216025}, {4.8069082625, 
     9.506216025}, {5.75802905, 9.506216025}, {6.100494800000001, 
     8.6547216375}, {6.100494800000001, 8.123899725000001}, {
     6.100494800000001, 7.4825547750000005`}, {5.621042750000001, 
     6.641957025}, {4.532935662500001, 6.641957025}, {3.1117028000000007`, 
     6.641957025}}, CompressedData["
1:eJxTTMoPSmViYGCQAmIQnRUlcUNys6jDtUc/3CQtpByubVdfrDpH0uHv/lcn
Jv6ScpibprZXJFnGYVKJeNG2Tlk4v2H70xP59gpwfl9Vh9v3P4oOac4e6jGH
JRxUczqX/V2g7GB/690VoaXCcP6GSf13WT99sUfnS+gY7NdjVnZ4Zarz5/yW
H3C+5PJsc+5oJgcYv3L2JPbaFiaHp4ZxfimnleD8t3oBQQ9EEPylnbqfeZr4
4PyjtV+Z/i7nhpv3Y8pa+8snuOD2wfgw96DzD0/xWDQ9kMOhVWS63fkDIg4w
/n3zZNsoVik4X9tij4LSVFmH7Z1L1MtC+OF87aMv60ViheH8nqS4N0mnxRx+
iUTP6bGWcnhkb/Hr8z5JB/T4AABhkrKC
     "], {{4.850494812500001, 
     3.3480591749999995`}, {3.6020514875000007`, 3.3480591749999995`}, {
     3.1319394125000004`, 3.3480591749999995`}, {3.1117028000000007`, 
     3.4165523249999996`}, {3.1117028000000007`, 3.7418947874999997`}, {
     3.1117028000000007`, 6.4271376}, {4.9905944375, 6.4271376}, {
     5.9790751250000005`, 6.4271376}, {6.399374000000001, 5.51182005}, {
     6.399374000000001, 4.8533518125}, {6.399374000000001, 
     4.154410349999999}, {5.8794487250000005`, 3.3480591749999995`}, {
     4.850494812500001, 3.3480591749999995`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQfbi+4VrFdHWHHxO8y42CRR3ms6YLsvFrwPmdGm8O
f5PD5Kezan/+rS0G5xuJM536oCPl0PWU8dMxAXWHLRNfL5siLucw20a7K3ie
Cpx//IKMvF+kEpwf/fPh94U9Cg4uJfv63v2UhPM58jw3y/0VgfPPpsmXtrrw
O7RXcv9eMUvJgZ/TamtfK7uDSF+3wbNbKnC+pMjdpxm26nA+zH1i9Q1RGy0F
4PzQSp93B/8i+Pr7L6ccSxZ02OK06U/AN3WHeMvnPvUVgg4n6/8+n30XwV/n
ZPpadwOCP61Vu/ziUnWHvyyJO1psBR24rvPxOM5Rd8gOO2598a2AQ75HZrjs
GzUH7TWpNStfcjq8+dzcMFdNFc7vitf1S/+iAudLZPd79vxQhvMnS5o2bNZX
dtD7FJ672IrH4dlZpsyw3UoOfP/6YzeL8DscFvh/cbOKEtz9MP4US59Xu94L
w/mw+EOPbwAwnt6i
     "], {{9.071684420000002, 5.539839975}, {
     9.129280932500002, 7.054472587499999}, {9.941858757500002, 
     7.308208575}, {10.270314545000002`, 7.308208575}, {11.266578545000002`, 
     7.308208575}, {11.363091620000002`, 5.9367889125}, {11.363091620000002`, 
     5.539839975}, {9.071684420000002, 5.539839975}}}], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1FtMU3ccB/BCtdDSciuc0kK9QcCeHs4x1Q2Hzv0s6KgS6dlgRsRMuQ4H
2gwQJeoWHZcGmeAYatFQZJMzo6h1F4owsCzMWrepGwRZWURXzOTSWetcK4bx
sv9J5sP34fPyfft+F2fvfiuPy+FwfOaycS6+c7lXbvF54CDAsrxVkz0mhl8q
3p5Meice9mal19aYxbCzKD11g5eEQOZY1pZw1p2CCDG9PBh5j35dgVsrhNY2
b8nf60koX7T5qFHOh0RCNMN8SyBjR5zLQgVK5IptMhlO45Cb5ttccl4ED3ct
vjvlVMA32jpX3JpQqMnUU9Z7CkjtTe4us4SCmvvcw7Er4MKV9488nAgFK33j
axXD+qBh+lZA/suubworJD5nLayU5tonQ5Bz+w03zmj5yGUvRpuin/ohr+qn
tBfy/CC9rzor0ch6sxE7XN3Feinv2LXIPgWkLyqM/WmvH0yQb8TWxOBQajzB
O+r1B+5kiuEPEofBxt4hTgwfmZemOqzewIePegqsNZ/gEPfzjhzuTQH8dXtP
O6ZTon4ZFWcyZhDIAyOKgteusQ4arlAmBFLIAc1nSzM8FNgP/Jmi7xMiJ2c5
p1LVIciZs6fbkreLobNt2nzoXQpmp0TSR5+GwVdJrYKYJRQIOpjy9sBw8F1J
nyX2kXDdQ/cXZ2DQyL09PXE5HvT3W3JoBoPXz9s+7hohQNUhdp3yYHA9Yfez
H68q4VJvg8O6UwILreDB8nB4k9RclDhZZzeEm75cK0N2L7Fm00wkqNc7bMse
4cDhjZprN8rhs77xqO42AvlDvm7w1jCJ/HQk5AntIiE4sW5L8yUp8u+nOPvy
SiJgtcq4VPaMhPr5TcWPsQjweGdH4xZQyF4DBZOxrJNNv1k2bX/ZB5m7zBMN
6y8qbXiRUIo8s6636DEmR3Yzp3mXv2cdPOBWFAkXwAN5ZX0Eybq56njTDxLW
hvGCFdwg1itNYy3+v5LA42XaOhrk4OqK9t8/QEI3KRINFsph6MDWgMCTJOiO
n/HZIZKDhgpaY64iwbTrgw6JMwoErySdYyzxqG9M4sppnyaQ86tUnloj657G
rtwoHEf+bw+MrScyf1sk8nf35/nULZQiEzStdXRK4Epp2nvRnXN7trst/5zE
IEpzSDdfjcOdoTtTr5rDofpFUsuKcRzq7PoU7sUwsCS4HOfKlDBTnFY/rAuD
///Tv7CR9zo=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1FtMk2ccBvCWYpHSMqDQg1AGOIcyxH7f64ipOv8KRjlsbR1GZUyhUhGF
zRMegrCgklC1A6bh2DJEGz82KQdhKYuuWJSA3WrSRLJBQSUQEWQdUhLpJIyb
vZ/Ri+fid/PcPU+46tsdahaDwWAuJmkxHosxloSGV6WTYEHXElTP+BDJyaro
rSLhdFrKpZJOPsycy+qxHkLgS/2QtieItokj4iuRH/ZJzdYsl4IL39fJBsL9
EZwK21VaL/GGgZG40PwEErs3oMPUfIzAzs9PbFovICBT7lF7/BYPCE/bZf2Y
FH5RaF9FfhYAHm7mOp9hKSSb4+/kWQJgn00muTkohabbhy8/nwyAhryIf833
aM9Xt5fcqn/fZRWB2dE3aHOLxZmOl/7Ymd01DxsU3th580MVy2e9sNd3r1E0
qb1gPLrI1n2X9gtdb8bEQ9p2Obuo/Q8ppIRlf2w77QVoNO32xIIUTtRXsUvd
S8FsyZgSLSHg8VVzP+Mjb2y2nDy/JdEbCj6Z9pxcS0Dko4z9rN850NHxeqbV
QOD+pFHF3EkRiR0us38Z9wXtByb3p5YTCDuupixVOYHAUfBiu6aLix2f5pxK
3uKPnbqgvx6fzoeaurXzWXoEC1M88cSVQKj8W2swFSLgGKlTN32DwDyuntkQ
haB3Ttmdu1MAJTZDpa6HBM3Ij/uVlAAcEddHWF+RQBr5r3RzArg27qrVWglo
MZeP9R0SwuetQyFkGAHbYhKahU7aqvKgtsbNy7BdEX0qJRUMw841bLOKAAZ7
qPNSkgSWNrUYL2wisQuUs5wPUhH2OllP9aMDCPxk2j21LWLsYR3jjPq4CAbV
2naUjaBsSUXutEAEssSNpb+efcvLdnaFFNF+uuJnpk3/vgupv6iZBNqGYmtU
DleM/WarOWdaIMF2UXp2633afj2uVTncUGge/G687QJtHz/N4Ytn3jIcla3M
oz2wIuafn3YhYLNTrcZyCcRGyW+MKhDcieHxHmdLoNFn0rBahuBIZQMzgycB
1Wj8JhaBoO2bY0ahMwTinu+dddtI3GfcHbvDnUl7urRf93Ij7ZDKGnu7B4H9
/x4o693gA18HY/824snUfijGjlYqFWMmIQi91CmmvsU9O1yW19UCSD5auLvR
lwB7v30qtjMIipKeOLvSCdA6NNtZzYFQdzCWf5Yi4E2uvOzPI4Hw7j/9B+wa
Ads=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ/U7TccY+YQuHHxO8y42CRR3u5GwxbfVH8AP/feur
Dcfkp7Nqf/6tLQbnG4kznfqgI+Vw8Q7jstQL5g5bJr5eNkVcziGqQ+yT9nQz
OL8gqN9mZYkpnL/r2UeN4D4TB5eSfX3vfkrC+Rx5npvl/orA+WfT5EtbXfgd
LixrWxU21dSBn9Nqa18ru4PYRjfX0q1mcL5kyfv5256Zw/kw94nVN0RttBSA
80Mrfd4d/Ivg6++/nHIsWdAhjTtqtZazhUO85XOf+gpBh48r/ytcMEPwk7tn
K0kqIPjX10x78UrKwuEvS+KOFltBh4mhHJuVxCwcssOOW198K+Dg0rf1hsA+
cwftNak1K19yOjA9cXobcNsMzr80U/yK6SEEf8b8E4EeLgj+tTLpt7fvmzro
fQrPXWzF48AQ2JS4dqmpA9+//tjNIvwOeUUMYjFRpnD3w/hTLH1e7XovDOfD
4g89vgHGldq2
     "], {{21.35296762000001, 5.539839975}, {21.410564132500006`,
      7.054472587499999}, {22.223141957500008`, 7.308208575}, {
     22.551597745000006`, 7.308208575}, {23.547861745000006`, 7.308208575}, {
     23.644374820000007`, 5.9367889125}, {23.644374820000007`, 5.539839975}, {
     21.35296762000001, 5.539839975}}}], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIxIGYCYm0x78szKq0chPjPPvx/Wdmh4XtprRGLpcOJ
6QEHExcj+HHN+758Y1d28PywXUVlM4L/Lvoes+BxS4cLX4SSJZ8owfk9VppN
ea8V4fzi87vcTkfzwfk/pqy1v3yCy0Hq2evzE1cj+DD70PmHp3gsmh7I4fA7
wldyQxiCv+rJvS9T7yD4PDunvA5RsILz83u9HgmnIPjejz38mB8g+DOqNkeW
21hj8GH2/++2ZZeYagXnw8ILnQ/zH3p4AgDcIp9B
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGItIGYC4k3/JvytKrBzmFU8dfJXdiEHGJ97x9ycnYd5
HJKep2d+/WDrcHiKx6LpgRwOj44WNdzNRPBbNt66tiMKwb90tcgxfq0NnC/g
+9Vue6CNw+9b8w3OSvI6eInHfGK7guAf3CHq+OqjjUP3+XU94SX8cP7at+Yq
//cKwPlhc44+s1MTcti9Y4b+8dU2Dnfeym8Qfy/ksHWHtNySVASf96zZtqV6
CP7KHYq/Y29aO+y44F1tmYjgsz96+Mh3oQCcP8H5yNmVcdwOone19m7usnFo
N1dMXjKTzSFse2u5INC/MP73p9fny2TYwfnvXzydvUDO3qGYs/3eI10eh8Nx
N87LW9k7bNEV+bVKVNAhrWv+q2Ybe4e4n+0d39IQ/L7i2QXrqxF8+aPvY85d
EILzV4Y3LNU0VoLzJXQM9usxKztkcsUVT41H8A0OO4T9+4PJV83pXPZ3gbLD
o9dlbYz9CH6NuVHmVwMEvyul09dojx2cH1y18YB+CIJ/5sV3o3OVtnC+xa9/
HydKYPJh9rdNzPzLWorgw9ITOv9sScgt9oNKcL70ySvCPvwIPiw9AgCTdDCe

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4n0vD86VY3Zy6Hi/djHr4Sf2MH6Bqb5twNan
cP4HttO14tHP7Jcu+bPuzFtHhzVy+3xETr62Dzq64/aJQEcHvu3zaq7+ZnBI
W2UgvUfT0UHzjo38ejYBOH+NTFSKtbwYnN+2pUb4J5+sw71uTz2NSEeHpdOT
Ivr/KTr02R97dvyTo4MFj4Gtdo2KA8x+25zaN507EfxQzfaEZ4cR/M228lzc
lxF8pzOnZr/4puJw1e9HqvI/R4cFD5JcedlUHZgZP/LFfUPwX0VHN114ieA/
tP7Qer3c0cFWc7JU1GplBwsNBUd5XUeHyd93H0xUVnRI9HqcHfvGweHEu+XZ
k57IOjCbeR+yuOvgcMd+94sLFZJwPsy/MD5PhvGMC8zCDv1b6uO0Xzs4JKw5
Jfk0gcfBX7ct+4WBo4NW1CnnD/HMDqeu7dx7qcbRofFHGeNT1c/2MPftOFD8
/uGkh/Yw98P4MP/B+DD/L2D72qHT+sgePX4BsG7fUA==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4qIdomJZdS4OIf8VJilKCTs8+dm49V0cgq95
MqTgYISLwzqBjTI1zwQd2p6+5D7l7+LwjCW36IeKgINAS39jvrOLA9+//tjN
IvwO/E/i5VdbuTjsTlvhIFPE5+D3W7D++HNnOL+qVd7b4wyCn657Nav9lROc
/zzNzjov39lBKGPDys+ewg4Pbk4+JWHs4vB7Z/gchd0SDjD3OkzfVepxRwrO
t1j8bPWTc3Jw/rzwtqbHyxQdlH/u17Xhc3HwVmMy+Gml7NCVJNtuUuYM50+b
Xhgb+tIJzn/t7BQi0uvksHGLk/vDYkU4/9LEmH/OZfJwPgPb3Z3d3rIOHDfv
/rl5EsGvmcWhWnAWwV8rIsOr+QjBt4nOfjGTx9lhTSD/xRf7EfyOXfwOWX7y
cD7nM+fV71QVHKy8v3xa983JwenBJN07ixUcVrMsFbc7g+BXC/muqjqE4N94
1tovdgDBT1GNTm/Y4+Twp4Plh/B8BQdOw40rDG86OSzeftnQ6YmiQ7PV1hnh
Ms4Ods9WeGjNVXLoVNp3aHUKgr+qvHwH9zUE/27nXoGl3C4O+zdujGlgVoTz
uTKNOracloPzp61LkP64UNrBR7o5ouqss8OJ/a3aYc0SDgw10tFKnc4ON8XW
H34kIOZwtc763eVZTg57/u7MOGHHDQ/f9yJFS+fFc8H5/QreV3XMEPzDUzwW
TQ/kcDjzRbpbNdoFzkdPzwCdMy3j
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCse8xcXZNdnP46rfb72Y5hwOMn+LPNLt4Da+D
WPKqVY4lbg4elp/ZPscLOGiu+NRe4IzgZ39n22UoheDf+yC22JPRzaHG/9uD
/0f44PwDCz6+DOvigfPl/NVOnkvigus/PMVj0fRADoczr3W7Fjsj+O17ugyn
BiH4Isrez3YkuTm01E5zql7C4aB74kGRW76bw4fC7abGUZwOLmfd5vIXuzkE
pt1jXdrMCXd/1mHxO0encTo8/8G7o7gUwY+5tOb4jTIEXzdD4CpXBUI/jM+t
YzbnRToHnH/FSWWe+ywmh7PdsW/SfYDy9ktaWI/8tue/XSinqezm8HPT0frT
U7/Zqy6oaMkUdXPYGzrP4cbdL3D+n5yABV+6EHzOU/3B5wUR/I8nZ/M6//xk
/+DC0pPTpN0czuZkiNyJ/GRv68on+F0RwVdvYF+9TR/Bh8Xfy1Oyb5ir/9mj
xy8Af0fUnA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtMk1cYB3DAya2llM609MIGDgQ3aLGBuQ4vj1p93xfI0OIklAoOSiRA
xeK4K7pqubPVLTLDRWqhBpSLMGCDIUOQbRoU3IBGEBQcFbaBDMQwR8b4dE6y
D/8Pv5z8z5fnnMctOkkWu8HCwsJyPUfWY7WeueoVU1sTCSMK96p2vjNkJOS/
y24nQRCmIuc8uNDTwTvxepiEHRWDupJhAThqVCRdSCHfay4tlvhh54zde6qR
Yed9H24zmEiBeNxf/Ei+fh5Qlt1FUaAI67dN2iqAFb8bx0d8KfDt6JQoxHzk
jIYXvXv28ZATT5Q8TjZyYSqp2rJkFwWGjQ4G+awznGTfydx7DFta1NZwOwu7
OGaDqqyKgp8NlVGBpVzklId/XC/z4COb46RvT21xgZORrtsawykYDVL66ppc
YNfQpVCaCHtRyfY4ZCaR56VeH2Z1kHCTVvqXUysfdL463ZEbJLCOWsucH/HA
MnlVNFZIQmTmfss/D7nAlYoDEgGJ+57SWb3xHeyaRdrsCz2B7MNd+Ol4OAGv
M1ZMX9c6I1ca/KYPN3KQG3b/qviO4MCBLu3h5VjsIp88dVEcdmQMf1KTjJ0a
9xktOJWAiXazVK3gQKfpvNezdAJW2RXera0cmP+EYZ1bRcBUH/1K6BgfGgMV
1+JfEWi+k0Pm8ww3/D4q9p8qvvMBtrS2PPO+koTgzAf9mrPYyoefpopDecg8
DuOCchMX3lOaCrNCSEjsI6HkGBvdXz+33X3tFhNKPbSGeToJfotD2T+eo8PS
7YjW6acEpLmGfaF3sYOaLwOCWmqxM/KSXrkZsLdJJpp3arFF4SFFC/EEzG5a
/iqLaw9pusSZjQUE9MpP2587aw9B1lECrZGA5/L4UzJ3OjI7QrYW/zED2adc
nkgFMFG/O/DlzGoBE6o7atlBadhXZVEptjLsNpM1p1tMQFO+JzuU4Yi8MGp0
yC2mI7O9fX8QvrQFkdPS8Hk1AQG9ooP1sTZgWjXt1NRgX572mIj9B1tVljai
8iLh8ZlZMr+bDlr9uMV2bxL05mV19vsO8Kwl5XpEAAlvhWy5+yDaHiIarIwl
cSTqzxVdWHj+DXYZ+W9pgj+FzN7M61w6TcHBduFVz7tM5N76fqNVnxNyC1Mo
rPRmwQBrZsdlNfa3DhrWgAr7zb2Fl65FY9//JS/dcf1/J0gmk/reYEFuTE5E
+lEKPhIUBNvfckL7Z19deI+/FQ165IGDXRMkmu/I7h7H5jZsYs/A7/Va7LWL
KrvP1SScMdvY1V2kIf+mfyLbKmIgj5lNruNLjiAsl0S6ZpAg+7s49uYoE5xN
4pUnOSSIN9e59Vew4P/79D94ykQ7
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4rLTmauaBHwc1shEpVjLiznA+D4XGwyWWUk6
vPIx5ZvA5OOg8ficNQufnIPmFT3Gy3u8HRTb0oPt3RUd1mv9XveiwNthjq32
kbpdyg59SyNfvWL2dljwIMmVl03VoYzhSGzsdy84f8mmPWwz3iP4u8U/n5vz
ysuhIM0/NuSjCpy/2Vaei/sygh+q2Z7w7DCCb5tT+6Zzp4pDeUf9jSAmb4fq
x/9fPoxVcbjHct/kbo23Q/3dl+cmpyg5CIe3BP4/7O3ApBm2iaNEDs6H+RfG
95rabLJvHp9DDvd576NTvR1MCsXZLk5lcHh98F3r519eDi7sC4uYDF/Zw+z/
wHa6Vjz6GZxfYKpvG7D1KZzf8X7tYtbDT+D8PcmrCwruPbKH+X/HgeL3Dyc9
tIeFD4wPCz8Yf8bRI88el3o7lMw29+Oa/9ne8eYU7TkHvB1Sp1R0pb1ndpDY
fpEhjtHHQXGqxK4Tm3ng8Vf988f9pUeFHNDjFwDPfuYs
    "]]},
  AspectRatio->Automatic,
  ImageSize->{58., 12.},
  PlotRange->{{0., 58.}, {0., 12.}}]], "Output",
 CellChangeTimes->{3.5166277586408777`*^9}]
}, Open  ]],

Cell["\<\
Locate the files with extension .err as indicated by the verbose run of NCTeX \
to diagnose errors.\
\>", "Text",
 CellChangeTimes->{{3.454875813874734*^9, 3.4548758488821383`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCTeX, NCRun and other commands", "Subsection",
 CellChangeTimes->{{3.454882998854615*^9, 3.4548830053605547`*^9}}],

Cell[TextData[{
 "NCTeX also comes with some other commands to run ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"L", 
     StyleBox[
      AdjustmentBox["A",
       BoxBaselineShift->-0.4,
       BoxMargins->{{-0.5, -0.3}, {0, 0}}],
      FontSize->Smaller], "T", 
     AdjustmentBox["E",
      BoxBaselineShift->0.5,
      BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}],
    SingleLetterItalics->False], TraditionalForm]]],
 ", DVIPS, etc. Take a look at:"
}], "Text",
 CellChangeTimes->{{3.454875813874734*^9, 3.4548758488821383`*^9}, {
  3.454876091529903*^9, 3.454876112065509*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "NCRun*"}]], "Input",
 CellChangeTimes->{{3.454876017704138*^9, 3.454876077731947*^9}, 
   3.4548818855555687`*^9}],

Cell[BoxData[{
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["NCRun`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["NCRun`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["NCRun",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3516602558-9938753", {"NCRun", "NCRun`"}},
          ButtonNote->"NCRun`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.95]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]], "\n", 
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["NCTeX`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["NCTeX`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["NCRunDVIPS",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3516602558-9938753", {"NCRunDVIPS", "NCTeX`"}},
          ButtonNote->"NCTeX`"], 
         ButtonBox["NCRunLaTeX",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3516602558-9938753", {"NCRunLaTeX", "NCTeX`"}},
          ButtonNote->"NCTeX`"], 
         ButtonBox["NCRunPDFLaTeX",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3516602558-9938753", {"NCRunPDFLaTeX", "NCTeX`"}},
          
          ButtonNote->"NCTeX`"], 
         ButtonBox["NCRunPDFViewer",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3516602558-9938753", {"NCRunPDFViewer", "NCTeX`"}},
          ButtonNote->"NCTeX`"], 
         ButtonBox["NCRunPS2PDF",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3516602558-9938753", {"NCRunPS2PDF", "NCTeX`"}},
          ButtonNote->"NCTeX`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.19]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]}], "Print", "InfoCell",
 CellChangeTimes->{3.516627758804016*^9}]
}, Open  ]],

Cell["For more details :", "Text",
 CellChangeTimes->{{3.454883062126731*^9, 3.454883069648705*^9}, {
  3.4549581614004517`*^9, 3.454958163502709*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "NCRunLaTeX"}]], "Input",
 CellChangeTimes->{{3.454883055571382*^9, 3.454883059000552*^9}}],

Cell[BoxData[
 StyleBox["\<\"NCRunLaTeX[file] typesets the LaTeX file with latex. Produces \
a dvi output.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.516627759053996*^9},
 CellTags->"Info3516602558-9938753"]
}, Open  ]],

Cell[TextData[{
 "You may also want to take a look at the package NCRun which implements an \
improved version of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "' s Run command and is used to run all commands performed by NCTeX."
}], "Text",
 CellChangeTimes->{{3.454876137194673*^9, 3.4548761897695923`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Some More Examples", "Subsection",
 CellChangeTimes->{{3.454899675948762*^9, 3.454899711088377*^9}}],

Cell["Here are some more examples", "Text",
 CellChangeTimes->{{3.454899666518029*^9, 3.454899672810293*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"inv", "[", 
     RowBox[{"x", "+", "y"}], "]"}], ",", 
    RowBox[{"inv", "[", 
     RowBox[{"x", "+", 
      RowBox[{"inv", "[", "y", "]"}]}], "]"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.454210269684779*^9, 3.4542102986845617`*^9}, {
  3.454210427693577*^9, 3.45421044536526*^9}, {3.454210545619924*^9, 
  3.454210557315393*^9}, {3.454253560180354*^9, 3.4542535606513243`*^9}, {
  3.454271563999792*^9, 3.454271566204994*^9}, {3.454272097295084*^9, 
  3.454272099616335*^9}, {3.454899722469433*^9, 3.4548997277717047`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"inv", "[", 
    RowBox[{"x", "+", "y"}], "]"}], ",", 
   RowBox[{"inv", "[", 
    RowBox[{"x", "+", 
     RowBox[{"inv", "[", "y", "]"}]}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.516627759214856*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.008771929824561403], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 
    1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxd01ssG3AUBvBWW5cWpTe0qA41l4VtOrzokdkmnW2yYYxs2EbU4pIYYVG3
EbcxIlLWdVvUZbKtiVsyNNGSMmPBeFhlHUsfrMxclmy2aeel/yYevoffy8lJ
vnM4aTlX7+IwGAz2MOGHsThMdfS67q+YDOrQUirxkyeY7D//+Q7xsjdy8HZU
Km7cGyhXWMVBCgeQeEVbcSK4kMFNS4rJc4SCmU5WqpQLzZWUdE08BcQ9zg3D
TB8YSmfiXlDoMM0JyM8J9IG6zcoAUiQd7ItGXoYE+8DSxLxel0WHJ1OWhQ3n
zR6czJHnpZnNSFSv9bT6AGWlQoB1Mduatb5xVkpDXm3tndtqc0DuKK7IVOCJ
MLK22PC8mYs8szLcKvbyRv4R3c/ey+UgY/0XOveobGRRIu92QLY7zGYrXzMO
rEDT59VPjnaDwey5jDqdJdRckyRiR11hlvBxWfUODzW5Fd52MhZ4lhaX/Boz
8k22La0OyZIZkH+KWna09Qd8nay+Vyc2ey/CzyPqpNl65VYVdZoJmklqva/I
gDyxH5ilwGPAZM/r56iVqThk0/4twm+sr9suyO3uNzmKTTryG+zw8YRdErIA
m2nECayQJfLOUV4bHkS+u5okP3vItxUtLHVhQRerZta+dwD7C3bJS7UG/vcO
nlt3GhXSncOPdUce8NmhqoOVZzRkv9/Jye1MOrKp36PG6Od69y2MyINl95VV
lzCQ1ySI1weZLU9/ulMyS0OOsyEkrQw5QqP6X0jdAAbYr26cIEU6QJuc20eJ
wQNGGlXfuEwGC+EDwsBpK3TfhobCTVuGNfKtcumYiG92v/ZthIFMQp5YHG8S
PqIil2mJTr0qGrImobYoXsUAboKSVpdDBkn5Ga2K6wQdlvqwxhR76J7qWv2i
cIGaYhIv9pQNyIQpMRcnmMAYD5t+bG0Jpv5N8+4VyP58eOiKTNjY2n4UxUZe
mjXGxPE84Og//wezY7og
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4umTnqqI/FFyOKcf/Wf7nX/2MP6hS9Ked0P/
w/lNuzNfHljx39647kLmmWVKDhsWF664r8/o8ILhoMxeMwUH4csPBAssuR3y
tBxNRXTlHbRf3c2sURWF89dp/V7HYScN57s85NN/LKboICHNkm4VouCwTG7z
36+9Kg43Xn7z2LlLycFycsOjidzqDjD77T6fnfjBA8EP23Cd1TcYwd9yJH99
YRKC7xws7ejfpu7wWW2/q/oLJYdF6ZtfFU9Vd1j1fuFLwZMIvme09/bb0xB8
5dvzjn4/p+Bgt+Hx/gNWag5/JPam6HrIO0yp40k/sUnZwVXr2i45J1mH1DqV
2+sbFR2C2kXzfp6QcbjvG2M8b7ocnA/zL4zPV3bl0VwlCYcd1Tv9+yxkHYxS
2q7b+ws77HR8u70sTd5Bv4znZtdcXocTbkeXPHmk4OA2469o7wVmuPvSJOyU
lrn8tYe5H8aH+Q/Gh/k/ave/vNN7EXxY/AIAulrc2w==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H0w23ccB/CIXR+mDJGka5OIh8TvlwfipGWMfXR66OoYXc5a6kaTdkWw
RdNR1YVO17XqaDvx1E5lTXOp5MxhHtZRUee0hnkqxozhVtXhpNiYv76/u/3x
/uP1x/vzx+dz93GKT4mUWpJIJIvtSLZD3s7gIdeK4Ac8GDlrWvjKlwk7Y0/P
tXfwgCW1KWoMYgFWol/9yJcPdwcaFjzX2RBTb44rLxEgh2ToFZE/EPZlJrcq
BULk98u1J/S3hFCSnhjQ38wG7/JqH9luIRhr6nBWFRtIOS/HTBoBvD3t3nYT
I3yhucDmrXhHZPkFbzdoZ4FW3h/UPiaAKkr1C7ddLJjaFYmfSxAie07uX/us
l7DEP3xpJNUduoygo/9IuDmlI0PszEZWNC3VDjk7wST2mIyHCuGlXtXifsYJ
6CT1NXWFAHn2UGmfMZOPPNw2xf24e3t/15gVi5+yIS5NdanjBg8cEu+XzZgd
gav02hy244EoaFkT4+MEpZwYl3Eyjvotj/5sJadhyD9/kTbFl3GRBynkk1Yh
HPgnT+0s7WQiVxoHPJyfMZCNYYr7l2UM8NFGFwRmEI6Qxr9RkUtY/a6hTakn
bI4ITipr4sDkk7wbAZkMsLX5cPK1iQNbrgFK1a8MGD6YKbmSyoWleYnCNosN
4yM1Q7RmN3RfDXk87HsZhnzbZKO4aCIsOlaLVabjgLXXW2E9hGUT1NatNEdk
BsfwzNOLBd3v3Uk+zsZB3j9/NSF7P5pv2BiWd49RIe+wpJNLw4CZZ3VVFEeB
hTojxVLmBgEVRwvLH9rB4zWPRP+vucg7erfoK2cJzxQ17k4wc5DHKNkp7vkc
UBaXOnzDt4fNV8sTOW9y4ZTfRPj1k/YQ1tliuHSeC+f8JLmrIgrydb8jXapQ
B2SRbqOOdpyK+m3Rt7y6HlChRj1XXPyIg6xZ+4mSzyP82jq2JOmhK4z21Q6s
ahyQMzY+7y2QUpBtXN/RTRfbwcSy9e1MLQfuLjYs3eu1hazK7w6k53KRvzw8
Umf5ixvyIINd7JKLwd/d1EW7bAqIPRsCQ4owiLIoy9nTSIFq1d655z0YFB4Q
G8QR9pB/5mhfRy5O9KeiSHtqeMj5vb66fQ0CZKW3zt1vUAhRT3r+WpmlIpua
kl/1/EFDrmf1nE/6gA4x6797PtUS3pwJvaJVE5bXy2/uSCYsWT/F1sULQR6s
aix0oUOA/wl9WLQQInj8b4dGaej/uE4/5c/dsQfevsTs07F8dN+M6iNZ4hYe
sl/txXmXNRyZaTYnVGlxCLTghN+btUdW/Ga78slBB+RUC+vRpr1UeO6I1S90
4HBsp4cxa40KKitrxxf/4iAWhSWpm+nw/3/6H88jYBI=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4vN7ZMrufzR1+DXvzcH/hVIOASWxPxxXW8D5
QV+kG4PPIfinr5pM2f8Xk79O6/c6DjtpOD9pG+ccQS4ZuH4YH2Y+jA+zH51/
beuajbu6leH8jCNiZ1ZeQvCfTDX97Wuk4vBI8qbV3X0I/teyqf9vdWPyYfph
fJj5MD7M/kuTe5NELhgh3CN8/ibTWgQ/zGjbsWm1mHyY/2F8WPjA9MP4MPNh
fJj96PyyDVuc3Hfywfn6ZTw3u+bywvn83+78OCnNA/c/jA8LH3Q+TD+MDzMf
Pf4BmF0HUQ==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1FtMkwcUB3CKKO0EBoyCCMV2CoJsKDhNI9/l7wYqFagio6BcAsJwTide
YFimIyAzXIor2DFBoIkNdqgDJNwkReQyhgwRdE4SFcmAIY5bIzUQcOse/L5k
e/g//F7OOTknOaK4YyEJy0xMTDjGyIwxNSZk+sfLKTJAV+VK6zYL4Ztz8uHx
SEDaciHiupx1YtqlXm4WawPPP2ZMy1qdPC41mIqwTWJn/UICNN+sDozfJELi
qb2Ul5h1cF9zjdqTdeVB1UCtA/AmO31+ta0IB0MP7gu3AEr4JeqiTiFa3S+L
X/GAdX7zGfbXhVBFlyhUf9NwMFOX7LQSot2d61I+R6PS4OdDJ6xB27g2wn6E
xhnHR2VXIl3Qqg1QKQZotCsk6q8kAmid3GfutdPQj4xcqN3qjCSlkMPdR2Mk
ZOaY57t8lB5QKG0CaAgOu7asS7HDbFXOk9SnFKiywILSGzaoS0hQO4hZxwcT
FgWNJGPl44DHtqUkpvPqN2QffY9xZnR3edOoHeOErh3C6Fv2aI97WFffRaK4
65rukrcjjr6JSY4XUFjUfDOVVOOMxci1Yo0/hcGgIVHaXhfcK6i/WiylIIuJ
4mvbWL/qVc6sUqxh/HZfv+h5H9WaUJi6nqHzOiSCz7qMXz2ySMZbYsMyVxYT
jJtipFndFAEJMTE/YilgbNcWYcKrdWa87euBbLMgZ/x7jlUy1hq9U8/zA6wv
1N0fUp1i7TNctDCfQuCwYfS4LtYZcc1p6VMZBHSK3vxQMwFunJAl8DsJPP5r
0tczVojz4z9XNriRUP/WOOm9IMSufrvdJadZV9R1uL6vYG1e+XKusP7/DqT6
7xfLWBuC9pzeUL0G2rm1E5VlJLqThkfzr7rAp6PGa8pYr6m6O/mnMQE+5qRz
7TeSeHBngT5f5Yi702fdLMxI5MYPPg36woGxIIjWr1LwGXvdCQ6rWWYLee75
10/KjfNMN+qv9FtDNrsY3uBNMY7p5yrXF7DWS29R5BiF9C06ec8ZGxzZLtl5
0ZNGVUjuwHSRLUJOdT8NXEmj22PGrCbfGqL93xb2TVL4UtEiviqxxKYuglDl
UMh5FtzFdeVh8QPfz1dIKBzyrZi6K1+BolTD7oWXJITPzuUpt5ohPzxXypGz
7o/5pOdTGetqPX/KbZxg3DHN4b/QEZixuI26z8yxL7jzd/cx1sMWEWLNcpKx
7eva2sz1JOI4Uf7fxXFx/Fra7SM0iaWNPpGpTjzY/9nU12zs19Cs26/58B3G
8RO8irnGlYwzLV/NiWCFLG3imBefhJ9h+/fLC63w/IjHo6FFgrEo/nBkQAfr
1B8MvUsnCFg7hs3u8LNknBdtuWf1Lh7jPb43tVTccvjGPrjo9ZzAH+lRQWVn
TfFwiBOaaNzPW+/QNGRr5BTjk8OGW2lyGqpnuyaCa3jYvH+pS9xKY/CFebJS
aoP//td/ALMCZn0=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4vPfnI9ncjs5rNP6vY7DTtoBxve7r1hdHCnn
4FTBr13+19Fh6g/zwxnTFB2a/nPI7dru6KDEu+PH0mvKDhxhV0+fz3Z0mHuk
OvOpp5rD8wvG7Jf+OTgsSt/8qniqusN57XlVLp8Q/L93pynXv0LwRZzPvm5+
6uBQ9HY+0+4GBH/Lkfz1hUkIftiG66y+wQi+3eezEz94qDtc2Bz51fKvg0NN
VkC/x1s1B3ODnYFHyh0dGlKsSn59VnHIaYrLe7bP0aFpdvW/rJOKcD7MvzD+
ihuPUnTyRByOmq3MWDPB0cGyN3J29mUuB5e3Jxbd+urgcC32leHtkwxw+5t2
Z748sOK/PYx/6JK0591QBP+cfvSf7Xf+wfkvXt5Myn311x7m/zQJO6VlLn/t
YeED48PCD8b/+GEe8+kCR4f9L2P3yPOyOMxiyfdo3u3okLVhlzyjLp9D4aPV
sq5/HB0mR6xdvrFCGB5/deyztIqfiDugxy8AvVjuAw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{42.1579921015625, 10.964135500000001`}, {42.246254890624996`,
     10.964135500000001`}, {42.4097045, 10.964135500000001`}, {42.4097045, 
    11.135212757812502`}, {42.4097045, 11.312828000000001`}, {42.252792875, 
    11.312828000000001`}, {42.1579921015625, 11.312828000000001`}, {
    38.0586758984375, 11.312828000000001`}, {37.963875125, 
    11.312828000000001`}, {37.806963499999995`, 11.312828000000001`}, {
    37.806963499999995`, 11.135212757812502`}, {37.806963499999995`, 
    10.964135500000001`}, {37.970413109374995`, 10.964135500000001`}, {
    38.0586758984375, 10.964135500000001`}, {42.1579921015625, 
    10.964135500000001`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4vbM+3fiT7k51Ev2CM7s1XaA8VeJWEstf6nt
UDL13br+E24Ouyyn8jC81XZQOjJ18/31CH7cdf0bZ8vdHG585S47LKbtIJ5y
+hOrBoJvLe5WpcuCyZ9xgjX9Q7uWw526nymSkgi+Rl3PzutBCP7zoJjQb01u
Dkenbi7/9g3BX/c5f/reO8pwftId3kWs6Qj+ttt6JtstlB02eb2c2aSN4C+a
qX5dhwuTz+e/fkrqDiUHBY4JC99LIvgnC5eXHGhF8KfOvPTLfhmCv5nt/eqi
g0j8s70vX+q7w/lnlUSiNZ0x+TD79xYGzbisiODDwh+dD/MfjB/yPPDj/NsI
Piz+AO+ozKs=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4r1m0tqGtz0c6rb++7gzStABxt9mqiTB/lXY
4dLuQ2de7PZw8HafEnigTtThKQP3KvFuBF89QP7OjUQEf5an/tEPHh4Oh0xl
rH0bReD8lHsz9/9IFobzJ5marDcJEILrT404Kj3TXdChw8VtjVc3gu8sujjY
ZhaCf6E6mSNhlYfDMZ83r7kKBR1eKvyc8nabh8OfYzVPn50WdGBQi9+/bZeH
g47jhLPzHwjC3b/j/RoLg1eCDosD1W5J7UXwJbSPvqzfh+C/PKDxfeN+hH4Y
n1Nlz4yDQQj+7bg040fXeRw6n5Ty8U/xcOixnhI+V57D4bRxl8OFLA+Hlq8q
oQ0drA4Pf0xYJhDr4fDMbeLWtjUscH5rUNZTkWYEn4eRy77JDcFnYBSQsdnF
7DBHc99r22QPh7ygsvkdWcwOP+eqGc/LRPAf35A/G1uO4MPir4YxsFummtMB
PX4BJFbXiA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIlIGYCYk9J9ZK3ij4ODc+XJiXHfbCH8Rl2Oi7WYvlo
z7xKJTxM3schQ1f9z9qAj/Z7rZSs9sv4OOxwCZhgfOGj/cJeoVVaj7wdJvzP
U/Ne9NP+xPy4+7Xd3g4NVk8v9rowO0ztlWh/EurtsMWhcFu+koAD+3YB+1kW
3g5MjZpxBw4LO8ilLN7LrevtEN1Yk3Luvjicf9Pa48v1qdJw/ssz7RvFOJUd
Zt595xBR6+3gf8rz7OEtag4Jx3Z+ihPzcXgit+zGGh9NB5j7/0fnXZWqQvDF
JSs8y1sQfP1rjXsv9yH4MpVHf1w9qOlwZX4E0xFxBN/jYPCJqUIIvn6K1KeS
/95wfsS2o68Ddnk79C3Xn3qiX8PhUUuwwZSV3g5axl42rs4aDmzlG6sE1b0d
bLQWm027qerwn+3t1eOXvRzYln9hWuSkBOenvkqJz5gvDed7znv9u+CbqEPZ
BCPbO5+9HHgahULXPeJ22HTo8cS82d4OCXorb+Vd+mMv+P69UtIKbwcLPbuE
yue/7EulK49W/PZ2MFggKLi45609zP0wPsx/MD7M/+h8WHoAAKB67ew=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H9Q02UcB3AWaZT8GBsDL8Y2BpMJOoYwFAn6nJie8f1+55nsisiKjh8m
wQr55ZjYkMFBwhIKdiDELxHixyKaMJgK8jsSUcEMBAs8MvQgZghySfvree56
7j5/vO6593PP3ed5Pq6RCUeiLC0sLGjmkpnrJXNlFeyUH6NRMPlp3xP1Xhew
l13pMVpRwIuyLTTs50B4rXRzlYCC78bbn/g850FdXNWDH5XYkRdGBb9nYnP6
N1I9q7B5F/MrUrooKE06EXy7y7y/7aZjtJYCXat+O6eGBxrugw3lGQpenxP1
FAmxT3dpbO0iucjy9N0e0MuBU+H3tEH5FFxkNj/2sOKAFW2N8VcL9lTywoHj
P2MLqD2bQkwUjOigwakD25jQf8qPz0NO6lxuu8t3BatDYUOyegqWGlVGUawr
TFwZXmg9jZ0rDTWuSrDV3h/c4r9GwW9fuZQvHueB0LlP+OI5CY4n6soePuOC
NsJnUDVJgs9+U23EHlfwz1GMXS8mUf6qiBNAJmLDffiyeIlA7rMUfGRXT8CL
bC0/atAFuUY37s2/wUZuJU/WZUWzYfqS4XHZT9juW42v+rVjr5CH0zx7sG3f
0Veb+gj4YyC7IFjBhqM97ddyBwmgCYJTVHfYoCZCykUmAkyPZCfpSh4clHwd
zDhAov6mXXVm6+XYEvElQVwO9lThGCOpjQRh7+UtwlHs2BlW98bnXGSOoOWG
jy8HrlPW7m4VJMhvP8r9JMMZnf/D+q/xI1Ms2EU37P02ggRu9pZc8YdMyGvU
kOfEJEA5cf5Ckz2AUj77/hqBbJ9Ykz/0N/aQGzP04R3sgZCz7iUGAtJKSh3y
vBhgp6g803SPgOjAGem5YwyYXSps2/EPAamBsrMrYiZyQeDbw6pDDsi7Gtb1
juEslO999xvf4XoWvFE73bzcjx0QVGSjq8SmegJbYlQE3L/VNr5S64Ccvp44
poliItPdAxrmSsz3XfeI9+omoGqxfbl6jA4J89YT21exxTfDk21CSeRN6sZ4
VioJphHWon0GE1zyGNppBQlhtLJMawMTFBUN+yzzSCiS+LX4HWaAqWR3UHA7
zmeldOQUWFLIvubFzMJutpYeLR2hIGxgdOHpPAt5oPOzpdFZR+QOzmhqXKgT
xPzLHn+zG1u6qm9INmJ/v+PaTqoVO8popF82/2/5QZXhvJsTcKlOE7eJgiOe
XsV3Jx3R/Nk294vXnxUMCH8rIzZaRKH+xns+q3tvM/aM18uZYeP4vRSnV1VK
ukkIoQmk1fMM5ORp+tOP/R2Qv6DZTHZuZUG/On5lYJAE2SveOuUaC3TdMZrs
CRL8xWSctssJ/j9P/wMWJWUe
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4jl5NxX/qQc6/Jn35uD/QimHmjmZh8KuIfi1
NjNVpO8j+LdL4jW/vcLkb9D6vY7DThrOT9nGOUeQSwauH8aHmQ/jw+xH59/Y
umbjrm5lOD/ziNiZlZcQ/GdTTX/7Gqk4PGzlmGwrjeCrzTVnqeXD5MP0w/gw
82F8mP2xS77GdMcHwPkxLMd+HQtD8P+d/v/1tRcmH+Z/GB8WPjD9MD7MfBgf
Zj86v2rDFif3nXxwvnEZz82uubxwvvC3Oz9OSvPA/Q/jw8IHnQ/TD+PDzEeP
fwBMJ+7P
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1GswnFcYB/DFJqzEbWOt1cVuSxKUuETIEPuYIqoWeY+h6pIQRGubBFlp
ViXGRAyxhGji3tUom9DGZWQJu0Kpe11aUSUynS4tddsMm5CJdr/kfWfaD/8P
vy/nOec55znsmAtYnAaJRFJTJVQVdVWoLnVFntMIZA8tOVInFtwg59l1zSAI
khWENQgIJ6SVjmplEVZSvE8viglX8/8KVKqzISs2YmRnHEFnc6N/rD0bKrYF
Zyv7Cesfsq8M6SZ8QlFhe0aCgJSbsW1CZUPZksb55iYEFbRy0d0+Fgwg0ZmM
RgQHvbYzjRpYoEtvr0usR2BMFpWf1GVB6Ye/7FsTI2hQejly4syh9Ernbzdr
EFxjPK26F2EGJfdr7luJEPQJ/USX/UwB84kgCSoQbMrlBS3HmNB7tszLNwPB
IrZxwUaPBkF3WsVD6QjMP7OUWaQaQtzfl9LkMQigyr+o8jsDeFqS+H7eccLq
KLr/AYOwsDV2Z4iKQJH3yDrn8wO4s6IGv25fMMR9rt+HFfXYCBgf9ytSTFXn
7a+XljowgMx5EP3cEcFuzbW1i01MqDMKx9bdEcxyn7PTTpkBU85Z43EQhJ2O
pIl7CCtHCzeMhea43/bLpDPYoMUGwUZDptQugQ38gWTJ+H7Cj6YPWVImMdyh
9NpvXTsw8Hdf3pbrmOI26gkjUVqYuN2/nMwhc5kAta2f+ncTprozLl/tITzC
8+msHyDc6vKqx2sQA55yIUkazQRPuyS55wgGXcLR/GCyKRgyxZXDcxjMrKy6
2USzIHdb48jRLQxEU22rDjsseJxCp69SEO5J3g+jP+kSXrYa9bRh/N9cj4nx
slDCr7hBV6wbzWHSfXbX/gCC4Yu/L+TXmQG/cXdMTQ9BR+Mg//tFU2jnJP/4
0UsMprp3ONkPGRD+WsHNWcFAGDvzjJtIx23O5bwwFtJw23cHhDRpUOHku0cz
01Xrf7Pe9uLehD7I0gpNNl0IP0kpPqwfRDjuZ1IxLQ5BprNUMJxuAL1jFiGJ
qQiasJuT63epkF7RmxZ2XrVfqw1yU74+KKacrHbiESQLZa51fjrgnBR92yYA
Qf58QL+WJQXE2tXzmh4IeG61a0OCvZD/LHD6+kEEFvPX8wqPkSGP5lyyV5tw
JP09SbgaYcPO6X8KFjDcYR1FOaRZDDb3d0FrvCa8KfpAoL9AuDozAVtfIWx7
guNwTnV/8WqR3rditMDb2uFS9GsM1OwdI754hwJ27eDKV9Xr6JB+UmOrjTth
mVK71bYPd7bO5hYbdCHXauXNxAYGvkrPO3tu60J12dxx2TLhpF955SVzhG8s
jEm8Ve/PkBGi8PHSwX0rSifIxJeCO9itWewRswck9Oylwj8w+DMjklt1VR0i
JRiDperPWwsOP4k/4ke476Wek2UugtJ53+WAJgpsfXUqtbhcNa9LmvzCQAP4
7//6L70zYEk=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{84.9982221015625, 10.123905500000003`}, {85.086484890625, 
    10.123905500000003`}, {85.24993450000001, 10.123905500000003`}, {
    85.24993450000001, 10.294982757812503`}, {85.24993450000001, 
    10.472598000000003`}, {85.093022875, 10.472598000000003`}, {
    84.9982221015625, 10.472598000000003`}, {80.8989058984375, 
    10.472598000000003`}, {80.804105125, 10.472598000000003`}, {80.6471935, 
    10.472598000000003`}, {80.6471935, 10.294982757812503`}, {80.6471935, 
    10.123905500000003`}, {80.81064310937501, 10.123905500000003`}, {
    80.8989058984375, 10.123905500000003`}, {84.9982221015625, 
    10.123905500000003`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4uCaGqdvUmEO3HdVC9PuazrA+GY3rlSWWGs5
eAq1aPMB+W5/9XLO2mk5LFh5XXcbL4Jvt1nFYe3HUIeUnUuvTsjQdJhVWeR7
8iSCr3tZX/Dudky+Ss/8Y3tvajj8betkCz6E4C9mu2xgdB/BZ/64q87xe6hD
YKTv9cMemnC+1XbO7116SnD+u/nLGS/vUITzneafmNzSpejwIodxYftpBD9h
yoL9d3Zh8mcJeX4x4lJ0mH/6isq+Qwh+SUNC37IfCH6USFngM44wOP+lF8uq
ejEEP3PdZY/dvgj+1xvTGKPDMfkw+3MZzBQ2uCH4sPBH58P8B+M/WPU6IFdX
yQE9/gC9K8rg
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJVIGYC4s9J4r8bM8Mdblt7fLk+VdoBxv9z+MHq9PkK
DhbzSo6XR4Y73Ps0ccqXhSoOUqwyc9exhjuE5Db6BTFoOLx6N/WKyf8wh6iz
5/5usNVw2BER2LzyapiDbOXRH1cPajqcZ33CKH0KwV9wWv/eq2MI/rnIX9r5
h8IcWPfsbqncjuAbXGvce7kPwWeIybsqVaXpUDixeteuw2EOC92vaX/L0nR4
FpcQZgE0z9nYrulitKbDCz72dc+fhDl0uT96mhmk4eDJrFcXyRfuEHDK8+zh
LWoOK+Y3LirWCHc49mmuX0anssP7rtZjEubhDvMvHfy1f4eiQ4qJDfsDm3CH
Z0sM3heGysP56a9S4jPmS8P59imqjsIzxOH6u/VPbtdtF3aQmevH268W7uCw
pPimsw0/3P4MhhWPjgmzODCI5N7Y8ALov4v/1sxL+G3vzLwxx+xEmMODhc2d
s/I/2cP8y7HTcbEWy0c43+PCZyb3jR/g/I7nS5OS4xD8A4VrA7OM3tnDwtdh
gaDg4p639rDwh/GjtzDkrr6M4DNW/Pr+/luYg0K30My45h/2TCpPzs7+F+aw
4X9SzvVdv+w/aG3VuGsf7jBh8dkz6izs8PRhfOOw75/1Qg7o6QcAbokUzg==

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
    3}, {0, 1, 0}}}, {{{100.2380621015625, 12.164145500000004`}, {
    100.326324890625, 12.164145500000004`}, {100.48977450000001`, 
    12.164145500000004`}, {100.48977450000001`, 12.335222757812504`}, {
    100.48977450000001`, 12.512838000000004`}, {100.332862875, 
    12.512838000000004`}, {100.2380621015625, 12.512838000000004`}, {
    96.1387458984375, 12.512838000000004`}, {96.04394512500001, 
    12.512838000000004`}, {95.8870335, 12.512838000000004`}, {95.8870335, 
    12.335222757812504`}, {95.8870335, 12.164145500000004`}, {
    96.05048310937501, 12.164145500000004`}, {96.1387458984375, 
    12.164145500000004`}, {100.2380621015625, 12.164145500000004`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4mO90Wf8X0U6lN6oPc7wRdcBxl9wWecCX4Ce
wx7l5K3pLyMdNvxoO5QerOcgvHvbdv67CP7GI8yn2A5GOpzb8ldbu1bXgbc7
8LrSTAR/wRO+2WbtmPy+9u8yEe90HApmZExYMxHBF5PYtKt7HYJfxjSLY/ax
SIfdIUt142J14fwlmxJ9VZ3V4PyI2f/Dc8+qwvlrZim8kpuv6hBd90Dr4SwE
//LSek+zLkw+C99Cr7Nyqg5CdzevE5+E4D+faC/BcALBP6saetv+BoIfE/PY
+OZTBP/O/k2XRGSj4PyMV6XdW9Qw+TD7HwiKruIUQ/Bh4Y/Oh/kPxvda5ryc
3UnNAT3+AGE/y1k=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI7IGYCYj/xvet2qUY7GFyfeJPfXsUBxr+ieunNh0xV
ON+h6nDtEzE1h2szDXf3skQ7TPtoefDEZTWHK0djODReRjl0l3SaWKerO8TM
eW7nfyDKweiAnVXpVHWHBey6tx6tRvCdJx+Z1LQUwX8qF+OtNB+T/+9ozslV
sQi+kLJm3wotdYe/yodKXy9C8LeHvN8lsRLB770V8aTpVpTD7MD2AnVBdYeE
BuPn8z9GOTjtUnLK1VBzMHq2TtXke5SDVG2C0s48VYd9Lx7ukvgZ5RBTsnCF
khmC77J9uskxbQT/3f2A4GXlKnD+tEPijT1FinC+zrrWLYrXFeD8F0c2ffmz
Rt4hUSHZM+VXlIPqHNYJEzzkHd7dstS4wxTtIBM2rbd4o4yD3/mEH7460Q5y
m2/LcqyRdlCKPS48xzXa4dxtQT9uO2m4eS0PvadveSsJ5xse6b+2V08czu8V
rVddyCMG5zvMa/0cP4sXzufaWvx13xl2OF8ov1qdm4PNwbAsfRLvqyiHorl5
/VOYWRz2cARPOX0vyoGXTcBuSh+Tw0umFZ+LLkQ5bD39YX7eAgaH7S3XO7ct
iXL48mjR/y5fBoeoNw7P5y+McrjdmqmZZcUAj68PShwLz97+bw/jZwS+93v8
/h+c/+zOjHkbXP7ai5g+Ep6zFMEvWukV/Wc1gn9lod7awjcIPiw92h9oenV1
CxM8ffa08Zu1FXHA+e3+51ZPnSEM58ulXxY8kCgO5y+0yA9qZ5dwWCM/+8l3
02gH3VNLP3JrSDqs3X/KbY9dtEMGS4hF03ZJhy+Topon+QP5z3Nzys5JOag5
Cu95U4bEF9R+61eN4Ks/dJLbWB/t8GVq13W2Gwg+LD5h/BWKM4/wL5F2eFD7
q4SxBsEPWb1+3a5SBD+TIb/xShSCD3O/xLQKh5s1MnC+Al+MvriTggN6fgYA
CB69zw==
    "]]},
  AspectRatio->Automatic,
  ImageSize->{114., 16.},
  PlotRange->{{0., 114.}, {0., 16.}}]], "Output",
 CellChangeTimes->{3.516627759562704*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Sin", "[", "x", "]"}], ",", 
    RowBox[{"x", " ", "y"}], ",", 
    RowBox[{
     RowBox[{"Sin", "[", "x", "]"}], "y"}], ",", 
    RowBox[{"Sin", "[", 
     RowBox[{"x", "+", "y"}], "]"}], ",", 
    RowBox[{"Cos", "[", "gamma", "]"}], ",", 
    RowBox[{
     RowBox[{"Sin", "[", "alpha", "]"}], 
     RowBox[{
      RowBox[{"tp", "[", "x", "]"}], "**", 
      RowBox[{"(", 
       RowBox[{"y", "-", 
        RowBox[{"tp", "[", "y", "]"}]}], ")"}]}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", "+", 
       RowBox[{"tp", "[", "x", "]"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"y", "**", "z"}], ")"}]}], ",", 
    RowBox[{"-", 
     RowBox[{"tp", "[", "y", "]"}]}], ",", 
    RowBox[{"1", "/", "2"}], ",", 
    RowBox[{
     RowBox[{"Sqrt", "[", "2", "]"}], 
     RowBox[{"x", "**", "y"}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.454211328811491*^9, 3.454211334363962*^9}, {
   3.45421147175054*^9, 3.454211489536913*^9}, {3.454247136473662*^9, 
   3.4542471724469757`*^9}, {3.454247385123349*^9, 3.454247389955035*^9}, {
   3.45424846873219*^9, 3.4542484918277607`*^9}, {3.454249978813348*^9, 
   3.45424998264818*^9}, {3.454250022869893*^9, 3.454250027331139*^9}, {
   3.454250944180146*^9, 3.454250957675816*^9}, {3.454251842097734*^9, 
   3.454251844077326*^9}, {3.454252411931177*^9, 3.4542524369499817`*^9}, {
   3.454253565727367*^9, 3.454253566126108*^9}, 3.454271573099585*^9, {
   3.454272103623201*^9, 3.454272105522636*^9}, {3.454899732543112*^9, 
   3.4548997381015778`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"x", " ", "y"}], ",", 
   RowBox[{"y", " ", 
    RowBox[{"Sin", "[", "x", "]"}]}], ",", 
   RowBox[{"Sin", "[", 
    RowBox[{"x", "+", "y"}], "]"}], ",", 
   RowBox[{"Cos", "[", "gamma", "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "x", "]"}], "**", 
     RowBox[{"(", 
      RowBox[{"y", "-", 
       RowBox[{"tp", "[", "y", "]"}]}], ")"}]}], " ", 
    RowBox[{"Sin", "[", "alpha", "]"}]}], ",", 
   RowBox[{
    RowBox[{"y", "**", "z"}], " ", 
    RowBox[{"(", 
     RowBox[{"x", "+", 
      RowBox[{"tp", "[", "x", "]"}]}], ")"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"tp", "[", "y", "]"}]}], ",", 
   FractionBox["1", "2"], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"x", "**", "y"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.516627759629483*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.0022026431718061676`], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 
    1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxd030s1HEcB/DDTS5b7s494DTdnXvg7n42ZGbX+ayWmi2UOeQk7M6qM3lq
ViKHtauFdIs7nIdWtMwQkceWpqgdcrnUUKOdCWszJjH5x/e3+eP9x+ufzz77
PLCT0i4o7QgEgs1eZHux3Qt5DQZD9WSQ8AM8LCZv2Hd5v+665ZQYuXpmVz3e
KYZZ1mLIjpYCRKqd82qABPzXMOFRGRVmui4KMJ0ELkXM+TZynWFXN1ZRSMZA
42cdS52jg4/TfL6Uh4H8dcRfC5kBN1TpnURvDOrKarraAhlg29mviZXidm/n
98picOeF3F7JuofBbGM40/SLjmy2dnSTr+FuTsw29CZTkP1p7nbRRkfgjGkr
U+9KkH1HUuuUbmJkedAV0RuVEHlRUzsznM9HFhjOn5gX80HpEHem9TEJvpwc
WTBX8SDMIcXGM88BxMzi7nORPFDVqtMUyfbQzMsxTr73BNG0PIaeY4PsMa04
PvabgEybTqJqEwjwbXA7Ifgt7sQjn1jpJbjjw1pMU7GeYJ/LTWj5ijv+0Qgx
2miD3Pdnttn9HxF5v/+2hheuslUucse2slq0zEZ+9v2DaHiBhZwVx2FWl7ki
17QHr3cEuIDL0P2s9SEnIP0U3ykaYEAb+5E1qpIC5eJ0zKmEDj0ptksZPjRY
vLxTOySlwzKxdLRJTUfeeOflpbLi3t/vQYdH1RfENOP2qhJuKqgMkCmY3K4d
OnKu39WBUD1uztSEoElDBYZM7ZdwmgHLOYItC5kCBt8C9RNnF9ibKlXXRYbx
UpEhs9gV3XdY/fMHdRu481j92bGObsjC0dBAfSYLeUReEanpO4bcpJAy2dFs
ZLP+1tlNOQd+5EgsD4vIEIB9volpOeBfVzgp2HKCoAnSdp+ZCxzaU9PKx8PQ
w7G+zIj2hNbYyUTvhkNo//v1jEKS1j+Qh7yUhBFpBj6ytOeVgiMSwMF//g92
WIuk
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1FtMk3cYBnCoLCGrHKoEp/3afoeelKAUnTgEfdVFsUohVqoirJaolYFQ
EhSP8YATRGY9jAibURCpUtHSMcCxtUyipRZBAlLKIYMB7TaPOBUsHnvj/0vm
xXPxu3lu3jwvkZK5ZsskLy8vb09WecLwZOx0mkHvxEHq7+ga2UHBv0VvSpgK
AiouGsfGVRQczHvrZk2QoLHGKwcDaN/efSay/zyBbLE7bJoSHOrN5YR5OQl+
uxsqI0p4EL+irlJTjyOvk0lMNVO5yMSzo9rhMgyW+lrPxo/i4J5a5Jc2wIZb
mEy/4hIJ0Q83NxA32RBwf6Y2w0VCdVRM3Kl6NiyWReeIXpPQ2OOyvIijLU6b
81bXMuMTGxtPOVd20346P2i4bC/tI9Kk5hs/85AL/94f6vahnWkTfr7IxIWu
OlWQD7CRe3YeUJ3Ppr1/6c4/LQfY8HrXsh1tFi4wfmi/fCEGg8lfbXRez+NB
uP+Idn0yBlE1Ga3qc7QTAq+U5xt4EGIknpRiHAj/Z+DYvAU4MHsX638f4KL+
MGm7clsCjtz/siPI+yZtwXOq550fhUzUxZEcNwWDnUsmKWpx5ALyvShRSCIH
Z9sZii8paDOfVUuVFGxLO2ES36PA9o30xkOCgoyWvvS8yXz4Qj4hf7GLhNVZ
1acfGPig5+45V2Mk4NqW7pSkHj7Im7PDD/ficHgVaxaDIYDfKsKkITk8WLK2
vbw4UgDfWjtjTXcwKGRW5Tfuoz0jekqBr06IPPxZekrSBhEYmrDno50cSB1/
+b17lhiu9mltueU4chF/em6xg0RmjjWUTv+PhCxWW/KhZCGyoylvu8ssgDWx
K+1/jZEgyelQV50UQEBw5fGnHAo5sM7xuEZIO7H1iCZ406e+EpP9Xaie9sKI
7ZZUphB56zS1uipQjDwUo5hXqKad1e1tST0uBveC2YsGQ2kby+Br7TTa1d6s
IZs/bVlrQWx7JwnpOb8EM2Vi8LXfrV1mIaGZeSKCGymGR8U+v3YVk4D/4ZCM
MMWg9Jzv4FESmq5CfuMbEeDxj9ZpmgjUNx7+EyvzCY68r6xPJy+lrVM2861y
DPnjHqITXWbXXBGy1XlMMhEkRH6HhW3QqQRwhvcsxJ7p2fPQoSlhHXzYbFVE
/ZiLQcfAqOieig+Rkt6SVy0cMKSsTqjtp8BQMV/kfMAFdcgc9wUTBf//Tx8A
oo8F0A==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0,
      1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGAQA2IQzWJx9I89t4ZD2CzLk79jNRwehuyNr/RXdVBakB5h
qIbgL+LTvvNporqDxvkjvftq1OD8zsOvYw2WqTk8ffqrY2Uxgt/FZz4trVIN
zr9otrj7k4winL/85qeGDHMFh/BMT3+tcgTf5uW0hh5rVQy+MRjIOyS6nar8
fAvBZ7z6xt7qohqcH/RG9Mr+AHU4H+Y/GH/L4qf/ilYj+B/3KuWYhWpi8GH2
y079dylBTgPOh5knu3rKvJcBCH73fZEwLQlFB/TwBACHQozr
     "], {{
     12.021972560000002`, 13.849190475}, {12.021972560000002`, 
     14.166749625000001`}, {11.786916522500002`, 14.375342400000001`}, {
     11.523840560000002`, 14.375342400000001`}, {11.232744672500003`, 
     14.375342400000001`}, {11.025708560000002`, 14.10759645}, {
     11.025708560000002`, 13.849190475}, {11.025708560000002`, 
     13.579887862500001`}, {11.232744672500003`, 13.321481887500001`}, {
     11.523840560000002`, 13.321481887500001`}, {11.786916522500002`, 
     13.321481887500001`}, {12.021972560000002`, 13.5300746625}, {
     12.021972560000002`, 13.849190475}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIzIGYC4huBuYp3knQcXLavSJhXouYA4180W9z9SUYR
zl9+81NDhrmCg2Fax8672gj+3445IvJ3tTD4xmAg79DwK337qm5tOP9zn6mc
1wQdOH9XOcOFAE1dOH/9L3/nw3sQfHn+eMXAeXpwvu7751lPXPQx+DD7H08J
FAv6qwvnBx9zO/D6OCbfTWNbkxrQfzB+2rmXGdyHVeB806pbbWWX1Ry21Yq9
nqek78B+OP/nv/fqDhcTubzbdA3gfJXIQ6yRxxH8nAPHDXgeGTj4mj/5demu
Gpy/suOy57bdqnA+zH4YH+Y+mHkw/n/t8tv9yph8mP9XHmeabVuJ4M+xui1x
9BuCH7P5oWqTjSGcX8mgKHG7HsEPVTPfqsNgBOeXbL6azReKyYfZ31DwdI/K
ZUM4f2WVCcOUKZj8vEN7jfIvIPjX7e2u685XgfP/1HezdIaqwflpU2Qvfv6g
5iA+Z9MWJ09Dh13ZKZuEl6o7PNsYbpmsbugwubAnpf+nugNfjfsOz+sGDmGz
LE/+jtVwYKrxncrsjeDrrO9YFm2sD+dL5m9am+mv5/DPyST+VJs6PH63afw9
dyBADc6HqYelX6UF6RGGagj+Ij7tO58mqjv0VykkM1nrwPmw/CHcUO8lmofg
w/ITAMElYOE=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtQVGUYB3AucpF1hQUUXIE9Z/HsIiThsHvOgUF4EE2E0GIDLRdpYcAU
ueggAnKRRSPFwFAJaLgICCyNESAlSiyXQiGxVtEFYsNCsUJIMCmKS3x636YP
/w+/mff/fHnmfciI+OAoQz09Pf3lhC7HYDnGW+e51ekMDFQWKy0uUCD4zr45
4hwDswLvEGdbETTEgqdLDwMm3fFzi7+LIWD+ydSuJBZZHQYpKiU221Ah8FJj
b4lvP/zwBQsGkcKAiiYxMPG++5qvsmBTESudKBaDXYRi09gJFrI0T/oVDthX
ApcKBmpEyOWfBgsm94jguVamiPiYBc8/uQY/zVGwiroguzmMfc0i+WYrzwP5
NTWPjVV4QP927aO9wSJkx7D09/VtxcgjdaqOalsn4LQEdlzsZyG0xKP3nzAn
qK2gjYKSsc27mLrBcQbZVLnv3iv5DEDqgKotXAyBb7tkjiUwMFNpNqyeFoHr
iGH7s80MFG2ub9zo6gQH3Yu+j6unUT/1pK48S4F9Qid0WyuXIuc4T0wa9Usg
utGwdGmIQr7+zWXHH+XYYH1k1HwjBV8mrjUhx7H9ZOt9d09g/9LuS3gtYdv0
co/dNZbCXk2q7LA7BVW1lg3zHCk8XQrZsfpdCkzbxIe2KaTwjpZ7UndUDGc/
7K7nmNBov1OXB6Nkcuzo7OlkdS72tYBtMs0YDfmNcTYvv8bm63yf3flMhDyb
ufpFlLkIlB2txza10uCgddFktGxA831iHP3cH5MQ7remykqy/P7ztjeirhBg
mdZ1W39ECtyUGyqmWADp9so/ymKxBSt/C0jdj5136FZ34wbss/WqJJvnEqhq
XVFYwCFg/brHrltdpcDPrWm2ogjoWtFbCFFSEHJ+DvLPw3bljCTk8UnkzC7J
gcFKEvV7i7Oopj4SEmP3594xxY4r7fXf0S5BLqq1PfdFpgQehH6UdNsfm5pI
SLxURyDrFms6M04JIJc/vdJ7QQLxfSIz768cYHj6xpBnjBRZ3h3KN+DRyCav
/m1mGUPDo/u+hqEtBNAePeHVR2ngTZ0Kun+PgBnFbNPkeRrcTN+MfGpPwNhb
FnWRE//pW1r7GCsZ5IgzJhe5p1nkPV4+D+2tPYCnKcu69SuJHPDtpGHLASFy
d5qDf/YnQuiz/0EbvcAil1iZZw+8xA5OI89kj2L3lNrtDln+3w68v94rzBGC
p9pmjfgBC+eVr2uvRwrR/UkZLSU7txPQeLV8sVnLoP0OHc9PL8nBbk1VuRdQ
2M524wnBCzSYxu1sLjtIIFfK1UaLFiQyEbdlzllJwgduGfzjqxiwPHJ3LHeG
BHlNwq5ZMQPK07rOdQNC+P89/RfvbT8h
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4n9/79UeeGTt4DMhhzPETd4BxnfiODE94IOC
gzqH3kH9JdYOvIKNJrpbFR38Ju2r7nVC8C8ZPL/P/8EKzt+uzL7Jfp+VgweH
68piMwR/5p3m7JPLFeB8A47A5OeyCnD9xmAg7zBF0rThM9B8GJ9r97tz1xIQ
fJWOfAu5RmuHKepRzEtj5B1CL80KtJxl7XBq4as/DdvlHVrupC07vdDa4Zf0
vyeWZ+Th7m87JRVw6qq8wynjr7cnL0PwNz8z+h27EsEPF/olemg1Qj+Mf/2f
5oZoOwTfmkvRsDtcxmFq5BSXmhCge36YH874Lekg9WPPin+M1g4TQhmcbq2X
cHBrOlVS/8zKwbHOrOiuI4IvwKLcpaKL4Ifc/mR2mw/B97tdqrrjhLjD7scq
/29+snJgZdFMv7dA3KH8zNfeWf8RfC+nFwclpa3hfFj89USLxWqslHJAj18A
UCXSAA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1FtQlHUYBvBlIVNOyxZxmlp2F/aAJFHUEMW330NgLJBhS5Aip0QOxmGF
YcplBOOkCQiKYiwKIcY5SiBGTiIoobtoSCyRKAloqEPAKCOHUSGuvv9MF8/F
7+J5b953XsFupSJKn8Vi6a0naD3s9aRMvj96lAPoKtWZZidEYNVqHGYtgEVb
WeBmKzHkS8EJQy7Ay1eUK6vzEhR3N3rfyyPePj+Wb1ZEbGJlNLHzPDFnWb2h
RguwI4W+Fc0SGO+/nVZcA1hWJLw3o5YgPWkmurEAyBj658aXPOIqv7UiXbWY
8Q8NCtvZL8SI/ek+K+EM8MGSCXtyRYQlhUGqdTex9tpiY8ktYvMKz/hkPQ/c
2Do6sUMhZmwXmnZIz0rC+E5tXc+PVlIslkY4H7oABJW6aZ6FStFn9qdiKp94
/9kge6kXcUpGrJvCCkCqrq4rXAKLhJuFWzYBTyoNxy49FsMsVBW2Z5hGydv1
TQ5OUvj+apI07Ucz/V16AVhhE4eEldw8+oJiHNsQUZCWSCG6Sb9s7ZaIcdtv
Z+3+DiGGedJdjoMIJU/zakoOE9vrjk325xNr6As9LRXEyz5Zr31cS2HHUGpA
vIsI2dLv/FMaKTxYC/Q2jRDhoXuZYRdbhuBRk2/HkyWIM3Xzy6qVMfsdFH66
YeAFsbdBjLXrFprcy0D7gjyHRmFTouXTPmKbcY9/r/8sZrx40HQhiiPGbo+3
LKqCafBGHYfSW+2Z+XScnafLfQHQl+uZNyLD4vmu7VFVfCw8d92rSpPBRNVR
56q2RVj50kkLDjErN3zm8RrFWDnjvsehnzjO0day8DiFc+0Gp4qM+Hiu3jnY
PkjBJq+65VURH+dyZK5tG2QQGk1tkxcQOxnd2VdgI2B88PK7MX9VCpi+Rp0h
atYKEDg37OhVT+zPox91hxOrpAVvOgkojAQd//qanFg0sy+luJbPeHy1ujc9
2xbxp6PrW8spKLViQ9lFHjqTnVObjWWMKa/rHapm4oe/KBuOGNOYGPbQD2rl
w7LjQ9br5jS4c9nbhv/gQzcVFxD1Dg3njZ9FPniDj76RHPntfJrpp2j65ru5
YCzMkZV+dIL4TFhwp3YM4A6VZ1x9JGDsOzCr3xojZHzlAE+edVqIQH+pu3KQ
WOZ7mVs9QFyaPnAyrYf4c47mm+mLAI+7HHvqsBCmFf3B/p3AscxPRtsihcz/
Ud0tE/Ru5cPn+9zBYncw+w09wOYcMScufcbTbbpKMzYq28XVltPYmOjTUr6X
z7gy5NJLq2YCxvxEamVzpgBfNS10zDXSeCXp93t5TwSgJNNzCRoamTnjvdY6
If7/T/8DPZdNWw==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4vk2F6U0Ul0cTtu7bHkupOLguuAXu+FEFweT
iz2vZvYpO7xhVvlqudfFIZzb/XUzq7LDwZ2lbx1fuTiY9i2SyGpQcrjlNn0S
w08XB6nAW9J/gpQcbofxdbzmc3U4N/Of2VUBJQfLzUwvasQRfOVr7bNy1RH8
+30FURMsXB2u/PR+ZuyH4Nce3V9SPx/BD1r901r1hJLDTPNHKieMXR3s/WzL
1X8rOdyt+5myVAlo3p0XHKzyyg5RqotWvih0cVjaelrrTYWKQ8beczb88q4O
NXrrfC5fUnXIdO3azqLl6rBmxUGTnueqcPMzL35sv8qqBucLz00VUwxH8Pdm
3FySs0IN7v5DJ9RCTj9Vg/sPxv8cXbJpixCCb6HtntvOA7S/cIYc80M1hynl
R67r/ndxWN4dFx67Q80BFv71p4MWfrinAnf/mnNHrTbwaDho72bdLlXs4vCj
daH8dT8NuLzBgwP2DEc0HDS54+OzQxD8zR8TumsdEfxNM3vvqxq5ODzReBp1
sxHBn1nIWbbJHsFPKzdnfcGu4SCQdvLSXXeEe5jVCl7zrXJ2uKr6WOLkJjWH
sv3rzV7PdIb7B8aH+bdUvuGK2kQE3620RfZCA4LvYqoa6Z7vDA9PGB8W3jA+
LD4Y2JoYLOucHRRnXdE+8EzVwU10S/2UTmd4fD5cHGmyw9LF4fWdyIQttSpw
eRGTcruzyspw/U92JoeJ8CvDzVefaMx8+oMSnA9LbzA+LD3C3A9LrzD/wfjx
uzx5lKYh+JKvywL95zg7iH7syZkrqgQPv1fXjhk72ynBw1dw+qWX68VV4OG/
RdInw/yqApxv57HKa9tuBP/W5SMfjfIVHFraj8xY7+TikNiU4r3ASMEhvPR3
oGUwgg9LL+j8mXeas08uV4CnH63Xb1t3vFNwQM//AKI0tq0=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1H0w23ccB/DSKENvK6FEJIIkHuppONf18DGT3y96QzDWmjqMeFr1QWti
1XaMlnhc62GE0g5pKJactiTs0LXqobqNTWWnjbZDdcaUTFWWf5bv3fbH+4/X
P5/P3efe96HFpYcm7NyxY4eWOpHqaKvTfr1qdoHIBrpAHlhoz4TKgNi9z8zZ
0C1iJWQdQx5PCpme5CFHb7xOEdcj68U3RA0qmXBZRzvsEz02WF/hfuzGsIMB
F9/zja9wjYWFwjXjBWQdaq4JcxKHxEwvnXldO+h7m1M5MoyD9s7Qtk97mWDx
9GI29y4OfLfOkrlGJjSn9L7lI8Ph7EpEC5HABOmDlYfv38JBljR9La2VAVKX
gfScDhwYm7QZii0Deksrdvc048D2kM/o1dLBZVir93ADDo9jhD8x9tDBmJDj
v5GIw7Rpx2DcGRo4JEsMtmJxON00nDLrSoNwY/cul3047M7qEXrVUMHzqJXx
2WlM42KFAVtag3y1xahjqwiDWXejxvI2K42FdbUzwiSaxiTOI4utUGuQLv0i
CGrEwOMhf7GmxAbKewRn6KMYPO9f//KrIDpMJ6uOBDzGIPxSc10hhQEDhOFK
eIaBsSDBlBaJHPuzKveQFPnfe/VLVuWjMgwivtk//DraDjLGnO31ziGvv6gm
ZOkje6Ve1vlVzgK+QduF/i/oGh8fnyviBCPnOV4JCSbTQf+ipFg1j9wuyW6N
f4FsbTr1bt8G8ppoP/ypZEHdvHBIxKCDYY1j7uI2C1gSy7CNTDp8l1Hz6g0V
A3h0DVNGMKHehWP2IAQD3cH0v7eXmaCy+XweeMjOphMfEfKQY8rmvGXV/7fY
8YKc+yFyPDEGV4wxwKVbdfMeH4PRb1tyLrEZkCFgHU5Rzxu6U8uyXaDDVq8T
th2OASdIIiobswFwd4rI8sWgveHq5kmRtcbrX0/lHZLSNH5TK/3s4DIVzM53
9cUWY5B+n6HvI6OArkfactAUsoHtCYOCXbjG4XOBinJXHILfcaxISKbCHnlF
oncYDv2VW2tDflaQd+rHLnN/HKoJR8gHeRRIm+80jPLAIZ82Jn5ZRoa/KIZP
ZNo4EANNsik5JJjmFGWeVmCQq/y+RGVnDi0b80nHxOp+sjt/U+wygyauePEk
D9k/tdSOkowslihv57she4uPjnHJGGCxYzfX6s0hL27iRoEr8ogfKSYAkJ92
3yV7cjA4F0V+T0EmAbFc1GQfjcH4an5ARBYJnt+478BR77t+a/SDNG0LjbUm
TiwS7yGXPeEaiQwsob6U1q2PY7AyWaIge1rCyHFt57kDyGkvrVeqqMhVugv2
q+ssiPzdrExWTNbYpDDDt6WUpHGm8ofU23VmoEyNLC50Uvevluyz4LAXAkR/
LDXzkHOKhwvubCIT9yVbdfFwIAVW8P2GSJCRtNRcKsChdegU3/EAFf77X/8B
DW5hCQ==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4tqpNW/0NLwcfCbkcIa4yTvA+E4cJ6YHfFBw
mCSl0veMw8uBV7DRRHerosPS+Jxs0RuecP7zdQ1zr61D8KNWTGh7N9XTwYPD
dWWxGYI/805z9snlCnC+AUdg8nNZBbh+YzCQd/BYvDzX4waCz1zCImr1HMGf
cOvIydjvng5T1KOYl8bIO6ysjwp7zezlcGrhqz8N2+UdDrQcaNjC7uXwS/rf
E8sz8nD3t52SCjh1Vd4heUP7bAkuBP9Gp9rqWm4Ef6V81471PAj9MP71f5ob
ou0QfGsuRcPucBkHT+fr53keAt3zw/xwxm9Jh+5JrxnPbfd0mBDK4HRrvYTD
wvBP6XyrPB0c68yK7joi+AIsyl0qugh+yO1PZrf5EHy/26WqO06IO8R0yK+1
3uDpwMqimX5vgbjDzj/tX2ZvQ/AXmzf2RR9B8GHx1xMtFquxUsoBPX4BGzvK
rA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1H0w23ccB3BPradm1dZjRCIqiTbTidbp6o6PVbXy+6mHdgkz7TxVZFVP
bS26ss5DXUSoOWoeWuopwkbVWMvYEiudOKZ08XCMDu0p6+bIhHX+Wb532x/v
P15/fe7e974PNTwuMEpXS0tLezvc7ehsR4Anbih1fIFWPskWHmBA+IKb86i+
L3wj9Y4SxCMP8vyVoynIoetqfmsFskHEnRCZigFhdZOx+BoOdnejg1h0BxAP
W5XdmkO+8nbGbr1nyMM9oU4WMhwuJLvuWNR3AGELs+VROw46uoGNkY8YsJAZ
WcRtw0HEahbPVTIgcVeR/SEpDmmvOXWmegzIThhYcq7FoYunrL5YT4fs4TLh
pXIc6BvUCbI9HW6yYh0aCnHwOTI5YVBKAzV/cpSdi8PMeckIfQ8NpmuCzi2c
xUFp/rUs/DoV1ozy6Et+OFyt6udPO1HBto0wQCHiQBA8lLiWUEDbRO0Y9xjT
ODhjPqLxJnKcz6v+JQEG04f3Vt5qtNVYUlY6IeFRNSYGjFtvBtpBtvh+h3se
BkeGRS9LxPsh9MNPbps9xGC+e+3zzNM0qDEeF7gMYnC2sLZMSKaDuPZei9MI
BvvKo8ypXOSwp2/SgzuR/+0rh6NY75RiwPny3X51qANAnKGXKhb5h9wkSoyK
rbEuId627wkbRMaN2d2f0jROGJzLCfBDzmDe9fcj0WDsYF79yhiygMORnVEi
L7c3+371G3KPr2nIzDwbyhYlcimdBr8c21kxvsQG7wc2Z9aTaZBqftlkmYAB
jFefVHEYwB9mHu52x0BfFvfX3ysM+Kk3UJfFQ95ob4hfTUBmOn8X1JT1f7cy
syejfZEjTM+fmlXQQc0d/7kjBYOBmrrUQh86gAf1ygeJGMh7S73tX9CgL9Qg
fPk9DAJOP5DmK/bDrlH9hBhHDJru3NtIktppvPbFWEZwJ1XjrdLOWGyFAs/t
RMqAaxjEPaEbuXeRYWTU28hDjvysF6cnryLbZtK2bpBx8DNhFkTFUGDqeuwN
R08cuos2V+WetuBv0TRgyMLhtt45EpZChqPCHAZmh0MWVdH6Kp8E3T3z6qbf
MTBlm10jpxKh5s+oggtDGKSresRvHKwgqUSW/lHl9j59mqdmd1rCJUPxjkge
8m4C//hbXOQ0zsjTqxRkw/d9FrlGGJwMU7SvVliBv560P5mMXDy3KnA5hNwc
VOVK88DgsxDSsVkSEWacs7qsMAwG/8g6wREQ4b5/zQnP7XsNHQNeF3WsNdYe
Snxp2oec/2v0XqmxDfBZm0MbLhi8HhXPklxsoHjf1KmRA8hH87aMswnIERKZ
1+xzNnAXLPO7ckkamwkve9TlETVOVv348bdlliAnONenWG/vr5Tk/uKgBezx
7dcv5iGz36mualtEnlEcd6vk4UBkF4g85UQAo8ffp+XgUC+/ImK6UeC///Uf
b4RbmQ==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4sNP/jDP9gxwOG3vsuW5kIrD9GkTq+bHBziY
XOx5NbNP2SHLQ+3j4tIAh3Bu99fNrMoOIcr+b9V7AhxM+xZJZDUoOTx8ed++
fXKAg1TgLek/QUoOjwpn76qZF+BwbuY/s6sCSg6CC6ZmHV2E4LcZ3ji8dxWC
/7j3jLL/5gCHKz+9nxn7Ifi1R/eX1M9H8INW/7RWPaHk4JDEyvl6Q4CDvZ9t
ufpvoH2sgisjVwDNu/OCg1Ve2UExMtX7t3+Aw9LW01pvKlQcNJb+ntK3LMCh
Rm+dz+VLqg6amZFBnGsCHNasOGjS81wVbn7mxY/tV1nV4HzhualiiuEI/t6M
m0tyVqjB3X/ohFrI6adqcP/B+Lkl5/wTFyD4AnfM13rNBdpfOEOO+aGag11T
2aO50wIclnfHhcfuUHOAhX/96aCFH+6pwN2/5txRqw08Gg5cKuJBUwICHH60
LpS/7qcBlzd4cMCe4YiGA8cZ52U2jgi+736XPUfNkfjC0c8kDQIcnmg8jbrZ
iODPLOQs22SP4KeVm7O+YNdwqPn54/5XK4R7Xm+acUPmhr/DVdXHEic3qTnE
+dxQ/nncH+4fGB/m31hQwO5H8PWY1nLdW4fg6xzydQud6w8PTxgfFt4wPiw+
Xkxa9dZtjb+D4qwr2geeqTroLbqTs2i7Pzw+UyQOCjw2DnB4fScyYUutClxe
xKTc7qyyMlz/k53JYSL8ynDz1ScaM5/+oATnw9IbjA9LjzD3w9IrzH8wvrt7
0U/9Iwg+Y8V8u9hT/g6iH3ty5ooqwcPv1bVjxs52SvDwFZx+6eV6cRV4+G+R
9Mkwv6oA59t5rPLathvBv3X5yEejfAUHs65vh+IsAhwSm1K8FxgpOCgwTpq/
2AHBh6UXdP7MO83ZJ5crwNOP1uu3rTveKTig538AHBrJzA==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1GtMk2cUB3AoImplXGQuGkJLb29X46AoFArVA9VNLgPeZwOlwkyJ0lUo
hQQHRBetl7UgIhYWp2NjCjgGVby0CSECSmppIAOkjpaJUkHqLUZ2cYg4tV98
H6Mf/h9+X/4fTs45oblqtMPLw8PD051kd2ju2Do0KZf/ISHpA8cfd3exQThm
U1o9ETSfvvDfrJwN22dtkYlRCIqs6ducftjXymvF4z+HUraMOvqLTjAhudva
eZuBwLe88zfRCQZ85TdAf/qYpCzbqohI6MD+zlQVxj1FQsIi6/H0GSYYj6t+
/b+OBHNwautnTSzgfy8OXFFLgt+Nj48Wuliwvl9H36cnYX2qpJSYZ4G/kSZd
WIVNSBR5Vw+87ws9x6YT7dhPooKmTu3GPpiU3ddxkUG56t63q+cWYKv7eUvW
dYXApPxPkc/htywxjKdXY9e37t7udZSE+TLprkFLCJjSAv6q+ZGEpTFbp89p
GbBFq987Xk9C3KXC3xX12Bn+LY26dgZo5d94X28hIeL+RMXaaCZ8uCH6Ku0a
7u9Mq6YZ72CHN3+ygniCPWbuuG6JRpRjJLdPCjIROG3xXpkmJuVK1itCxmNR
Xl4ySsuMZEPqOq10JgHB1/nVXfwht/U/qTbEIigcuFmgXcoBe80yDZeHIKX4
vP5hOweSKtk7Jb4Izu6w52aPcWDbxGTc5r9J2J8cIKDRuDCcLmorHyQh/svh
xh/EXJjfXzxwutE9X7pB17MHe6UksHLRGR7lKe+C3OwsAhoCLd6fGklQzj49
Mifgw8N4l7r0EbZP/uzClRGIclRzmyApEkFxwGCOJodH2dGrVbm6ucAoyhFO
uS0sHVEYargQpVx83yx+yzlpJbdisZnOJvNi6ftu2VRyaHUrdqxIZVHSeZTz
PlIoDP58ypObMtdWKbCL7Z4W5WE+1PnKXvbGYbfJgieexWC35o0iZzR2yC8b
PTRCBAWlxuX0VD5E3vlcNRSGoI9eLQoR80E/ZjwbKkDAvOIQ3qXz4UoaPchO
IOhtA13PCwLKho95ZvjhPpuhz3HjX5JyU6c6P+ARtvqys0xaj/3mHiQyV7dr
DUHZOl0hfB7Eo/wyODzrjJwLhVu+yFrgvg/zpCYwfIQD8xezTkIDCSMTM8SQ
nAO6B8J9lksktOemZJjG2TB03ifR5N53xaqwuYYuNrz7n14DoOX8ww==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0,
      1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGAQA2IQXfpW51vejSCHsFmWJ3/HajgIfOxW+tYQ5KC0ID3C
UA3BX8SnfefTRHWHyAc+J+YtQ/Cf7gtkOrs6yOHp018dK4sR/C4+82lplWpw
/kWzxd2fZBTh/OU3PzVkmCs4zC+udXizFMGfo7y8raIOk28MBvIODv1nU1Mn
IfgiDyfa6W1E8P8xi3+UO4jgw/wH47/+VRBW+gbBN5oncWQtYzAGH2a/hOQX
gcu3EO6BmSe7esq8lwEIfvd9kTAtCUUH9PAEAFG8ltc=
     "], {{75.38177256000002, 
     13.849190475}, {75.38177256000002, 14.166749625000001`}, {
     75.14671652250001, 14.375342400000001`}, {74.88364056000002, 
     14.375342400000001`}, {74.59254467250001, 14.375342400000001`}, {
     74.38550856, 14.10759645}, {74.38550856, 13.849190475}, {74.38550856, 
     13.579887862500001`}, {74.59254467250001, 13.321481887500001`}, {
     74.88364056000002, 13.321481887500001`}, {75.14671652250001, 
     13.321481887500001`}, {75.38177256000002, 13.5300746625}, {
     75.38177256000002, 13.849190475}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIzIGYC4qUn19UkJQc7uGxfkTCvRM0Bxr9otrj7k4wi
nL/85qeGDHMFBwOdTeubYhD8rg0it1cZYfKNwUDeYZdcnn+NB4LvcdHdRiAT
wU/UaxQyrEHwD8i9Tpjfh+D7Ma6VubgKwQ+Qvde6eD8mH2Y/W5C39cZpCL7J
j84ClgmYfDeNbU1qQP/B+GnnXmZwH1aB802rbrWVXVZzUHz/+GrU7mAH9sP5
P/+9V3e4t925O+MRgr9560fLuxwhcH4r/2aWLv4QB1/zJ78u3VWD81d2XPbc
tlsVzofZD+PD3AczD8bPehX3/tX9YAw+zP8hFx3jw74i+ILvttvtEAmB8x17
fjaqqyH4HfGd+/6aIfj/X5xTFQpH8N17yiZ75WDy4fFbvUv9gjeCL2LX90Pb
BpOfd2ivUf4FBP+6vd113fkqcP6f+m6WzlA1OD9tiuzFzx/UHAqOrV0arhni
sCs7ZZPwUnWHx9zXj91XCHGYXNiT0v9T3SH336S0mzwhDmGzLE/+jtVwyKq7
cvf4y2A43980KLdoL4Lvm2uu92VBsMM/J5P4U23q8PjdpvH33IEANTgfph6W
fpUWpEcYqiH4i/i073yaqO6wR++pS3ocgg/LH8IN9V6ieQg+LD8BAOLjZwo=

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtQlFUUAHBk1ySIBQQFeSzft7C7QA6jiaxg4mEYhkVjYlfvBxgkQbxm
CcQpFDQeG0jGRoHEw5JgDWSTGB7DtBIGC5JokK5swSobPgjEB4qrGBm7ff/0
3aY/zh+/uefcuXfOnEMmZUtTWBYWFqvooOiwpEPxMiFz/xGBTlkvtz/Bh2uZ
6U6jGgRLniHIz0UAuU6bA0OuIlgzlL1seiQE98P7vCL+xs63XxxOMGNPeh/P
lnMoxvrqq5YqNwosk3m7Grvo8705IYQ1Bc6N7229Xy+ESsnya20rCIq1f4y9
w8Vu3m2u0rUIGH99Vur5MEYALz16Zi5nUxD83Nby1jIfogZLX09ahy1aKfiN
9MKeSm/u4YgoGAufuBkrFTD2Svjw2CoXIeOpVtXANy4+EDXbXeuylgLqZNCl
Fwk+ENC00PoT/d9/XTHfXpkxia3Qi74qGEQA+TpV334hJFyRRTzoRfBEaX29
f1EA6x+Ttf5nEdRt/rbT198HZlZfdHvzOK73jau74ngIO6NDZVRvxW4bcrvz
1AFBaifrlFnPZ6webvL6PR4bnHKm7Xz5sK0mVbXdBfvG2JyobAP2hfTObDkX
O1o2w04jEMRq8/dkbuGDUZlyootEMGdGEZxEPrxy10/OFiHYN2FbZDgohMwp
iTQ3Eff7GOkcOvIB9kycIfx0Mfb3Ngf7ztQi+Kwzy/nZBWxXQ+iD0XYB46VC
jjHFTgB+GXbDJgUC7sSr2oIeb+b+nTKvsC0zJNyOTI1Wy+j8jr7olGYCOHVa
fTdCYJvXqxLVe0JGkcbbLRhbeuStvySB2O3jVZPTQuy25N3h51wRnD7Hrqmy
IUBijjOG+dHvK2/pduQTsD14z6esbQh4NrejxBXY/jZTBypcScaFgwFpk0qS
qb9UX8zvukxCWvXhT2YJ7NTE8aBwDvZj3hnrJtNe+JWqzB0RY/PvH3j/i1aC
scHUoiko8YTvdnrcs6T7l31ZYB1yngtFPXZceRD2LVXggjEJe7Rk/71DeQhu
joeyqB4CYsqqCuOPIHBYKIkav0ZAWeXbugU5gk1WkuQ5DwLCOM0SRT2uV6yk
PA/ox06+oRxdMmMTI5sMvfS8OWgbii/Ok4x3/fyQ1ZPGYzx0lCv+6EseHB2o
9bDlYi+ef/djH3dsz9j5yOr1/8kn0n8Q0/PNdfgzvaaMB/q7sxtXHCn4XP7G
hDqZx+yfvOlTpCacgNwZcVqjDvfXYoK95uQAtjqm/KlzK/a6oussqwYEVlmR
3Q0ZBGNlfP9qkz3JmMjasewnJ2FjKfhrmxCszfnlTvkTEpp4O1500PfJSw2a
DToe/H+f/gOnRVJz
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4q4dEu3J18McfCbkcIa4yTvA+E4cJ6YHfFBw
EKl+E77/eJgDr2Cjie5WRYe5cyccC1uP4NsfnRW/fRaC/+OgUohzX5iDB4fr
ymIzBH/mnebsk8sV4HwDjsDk57IKcP3GYCDvkG+/zr1gPYJ/dnmM9MttCL7w
7T1ff+0Lc5iiHsW8NEbeYf5a9j2OR8McTi189adhu7yD9garQDWge39J/3ti
eUYe7v62U1IBp67KO/x1nRcXcQLB374p9xnXSQR/Qa3828UnEfph/Ov/NDdE
2yH41lyKht3hMg75/McqLm0GuueH+eGM35IOAuYXBI3nhzlMCGVwurVewmHO
zMsuwTPCHBzrzIruOiL4AizKXSq6CH7I7U9mt/kQfL/bpao7Tog7/DTMep45
O8yBlUUz/d4CcQeNHDnuWfMQ/Lmc0jcqlyL4sPjriRaL1Vgp5YAevwCJiM8m

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1GtMk2cUB3AoIrqKXMZcNISW3t7axUGZUChUD9RtchGICs9DhZkSpeug
FBIcEF20brMVEbG6OB0bKqAIVby0CSECSmppIAOkjpaNSQXpnGaRXRwiTtcv
ex8zP/w//L78P5yccyILtZt3+vn4+Ph6k+4NwxtHpy7j+p8I0pa7fri/iwvi
cYfa7ouh5eyVv+eUXNgx54hNjcNQZs/e7g4ivlV9TDrxXSRt25hroOwkG9J7
7F13WRgCq7suSE6y4KOgQeaT3xBtxTZVTEon8QFLbRT/DIKUJfYT2bNsMJ/Q
nP/nOAJreGbbh80cEH4lDV15DEHQndVHSj0cWD9gYO4zIlifKaukFjgQbGbI
F9cSUzJV0c3PX/eV3qMzqU7ix3Fh02d2E3+Rlt/feZVFu/aXz9bMLyLWDgje
WNcdAVPKHyUBh16xzDSRXUfc0LZ7h98RBAtV8l1DtgiwZIX8Xv8NgmUJ22Yu
6VmA9ca9Ew0Ikq6Vfq9qIM4Jbm0ydLBAr/zU/3YrgpgHkwfXxrPhrQ3xNxm3
SH9XVh3DfI84uuXdldRj4nFr521bPKadILt7SpSLwe1I9su1sGnXcF5SCgGH
9oqKMUZuLBcy1+nlsykYPi6u6xYOe238VrMhEUPp4E8l+mU8cNa/qeMLMGSU
XzY+7OBBWg33E1kghos7nYX54zzYPjmVhP5AsD89RMRg8GEkW9JePYQgeetI
09dSPizsLx882+SdL9Nk6N1DvEoWWrPknID2tH9JYX4eBY2hNv8PzAjUc08O
z4uE8DDZo618RBxQPLd4VQymHdfSLkqLxVAeMlSgKxDQdvXpNZ4ePrDKCsTT
XosrR1Wmej7EqZc+sEpfcUFWxc+JxGx3s3Wp/HW3bqz4ck0bcaJEY1MzBbSL
3lapTMFC2lMbc9fWqojLnb429SEhHA9UvOhLIm5XhE8+TSBuKxrb7I4njjj9
vo9OjKGk0ryCmSmE2HubNMNRGPqZdZIIqRCM4+aLkSIM7Bsu8X2mEG5kMcOc
FIa+djD0PqegauSob04Q6XOY+l13/kK0m7u0xSGPiLXX3VXyBuL/7kGm8PR4
3qNo22cOip+FCWi/CI/OO6fkQynekrfIex/WKV1o9CgPFq7mnYJGBKOTs9Sw
kgeGX8X7bNcQdBRm5FgmuDB8OSDV4t131TtR843dXPj/f/oXw1X+hQ==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0,
      1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGAQA2IQXfpW51vejQiHsFmWJ3/HajgIfOxW+tYQ4aC0ID3C
UA3BX8SnfefTRHWHyAc+J+YtQ/Cf7gtkOrs6wuHp018dK4sR/C4+82lplWpw
/kWzxd2fZBTh/OU3PzVkmCs4zC+udXizFMGfo7y8raIOk28MBvIODv1nU1Mn
IfgiDyfa6W1E8P8xi3+UO4jgw/wH47/+VRBW+gbBN5oncWQtYyQGH2a/hOQX
gcu3EO6BmSe7esq8lwEIfvd9kTAtCUUH9PAEAK2El1s=
     "], {{99.38177256000002, 
     13.849190475}, {99.38177256000002, 14.166749625000001`}, {
     99.14671652250001, 14.375342400000001`}, {98.88364056000002, 
     14.375342400000001`}, {98.59254467250001, 14.375342400000001`}, {
     98.38550856, 14.10759645}, {98.38550856, 13.849190475}, {98.38550856, 
     13.579887862500001`}, {98.59254467250001, 13.321481887500001`}, {
     98.88364056000002, 13.321481887500001`}, {99.14671652250001, 
     13.321481887500001`}, {99.38177256000002, 13.5300746625}, {
     99.38177256000002, 13.849190475}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIzIGYC4qUn19UkJUc6uGxfkTCvRM0Bxr9otrj7k4wi
nL/85qeGDHMFBwOdTeubYhD8rg0it1cZYfKNwUDeYZdcnn+NB4LvcdHdRiAT
wU/UaxQyrEHwD8i9Tpjfh+D7Ma6VubgKwQ+Qvde6eD8mH2Y/W5C39cZpCL7J
j84ClgmYfDeNbU1qQP/B+GnnXmZwH1aB802rbrWVXVZzUHz/+GrU7kgH9sP5
P/+9V3e4t925O+MRgr9560fLuxxRcH4r/2aWLv4oB1/zJ78u3VWD81d2XPbc
tlsVzofZD+PD3AczD8bPehX3/tX9SAw+zP8hFx3jw74i+ILvttvtEImC8x17
fjaqqyH4HfGd+/6aIfj/X5xTFQpH8N17yiZ75WDy4fFbvUv9gjeCL2LX90Pb
BpOfd2ivUf4FBP+6vd113fkqcP6f+m6WzlA1OD9tiuzFzx/UHAqOrV0arhnl
sCs7ZZPwUnWHx9zXj91XiHKYXNiT0v9T3SH336S0mzxRDmGzLE/+jtVwyKq7
cvf4y0g43980KLdoL4Lvm2uu92VBpMM/J5P4U23q8PjdpvH33IEANTgfph6W
fpUWpEcYqiH4i/i073yaqO6wR++pS3ocgg/LH8IN9V6ieQg+LD8BAAhYaE4=

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYt3Uh+ZasdEOh5a1iJ1YJOoA4zec35IpeBDB
3+B5IvDUVVGHBYfqHBqDoh2Wr1n2urNZzOH7pTth9SzRDpEucQpBHdIOjUdn
fKv4EOVQ+2ipQ3eHIpy/v8kk+eIUFTh/zbmjVht4NBxszVQZ9DmiHfh4sjgP
N2s7iE5IvvMvJNphQYP5uzhGPbj9yx60zN1rh+Dvm9snKOWJ4MtsUtttF4Hg
r3K45CNTo+ewY/qf2Wuioh04Q7O+OXTrOZz/UPHhZBiC7yynp9UcgODb9f1Y
3SYOtG/urNO9BroOWS0TOrU+RTn8yT5cNHWFlkOd6Kd5Jy9GOZzJvv2splzD
wZ9bzcv8VJRDuEiq6hxHNTgf5l8YP19D8a80u7LDNC+HGQZA/Y3yVd9z5io4
fGs7LMf/JcrhueiX5vhdMg6bo++6s0hFO3xalrPowWVxuPteJPydf9hGFO5+
GB/mPxgfHl6dup95ohF8WPwCAFzF1lc=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtM01cUAPDKY7wGLWKgMtv+W/y3FRBHgDGWCYegEXlELVARbiOsIhre
ytTio1BUthB5Co4hCEx5GQaITMaQNxmPgRQKqAFBOkcYU7AOGFNh/bL/Xfbh
fPjlnnNzT07u4X4RJ4rQpdFom7Qh1oaONoZ1zQ5PNSBQlRUoGLkkWEaKadce
IFjhuAfZMvnQbMbhbfQgMOiKW1tfFEDYKW+6oQa71Xi6nr2MvY1zNtRLT0KZ
ldn66qS5BHSkPJ+Se9rzA0dtn28gsCqJcVkoEMCY7xw75g2CFOWLwXA29h3f
jRxVOZ/yrbsizsvDfPCZVy/4/Y3gs1VTnedrJGS3nBbamEgon1+N7pxlYhPS
3NJH9hIY3DsxEyziU7aRXLy6iSmgPFlZ1X6bKYTsmdLUJwYSEH/r1vdWIoRz
hZPX07T9/usR9c2LtkPYw6PkVx5NCCBJVdVyVAClfUecauoQaMqMn7a95kPI
7/TUxRIE3zhW1+9wEIKQ1mjAkOP6mICrP6misWuqb0zL7LCXHho9ajRAcLxe
t2jjCUm5qafU5hnChi0J0/QdJFzICsx7Z4rN6R2z8aZjG0pvhXptwb4eMbIk
sEQQrEwKiHYiwbUoQH7aCsHcRtA+szASDs4yY3vsEYRMmCZPnRJA3biHu6sY
z7v/I/2dX0dhCwMHHI+dxX6rH1Z54hqCzPpYq+VubOspzz9++Z5PeUVu9iaC
zodY6fu6NgUC9oSd8lLjdup+jygbL6dfucDfE/i5LFybX9dyMOIOAaKctp5E
XwSmsuYq1wIO1CTVMiZ3Yed/uf+3zfbYmsHk7hIW9pLEzTGJgeC7H/Xyc0wI
yFvbN61HaN+XXt5gQRIgd/aUde9EwDOZ9ffOwHYwmYzPsOZSlnc6Rz4u41L1
fQUp5L1+LtzNOH6mwhK7OqSD/EAP25mVtxL+ZyiMibPP9HpjkwvxiXmVBOWp
9fKOS5c58NrNZLzLAkFcP9/Y/SEbumvfG3ntwiZvb396PxibIfcf/zQOwcyo
p664kYDClOQoVgIC81eX/UdHCBhI92uvPYfgY8ND0jkWAWmGubv9M3H98GqA
evk+dsVYVtODZexjney+81slYK4sTvl5nkvZZ+ClbmMkj3LXBbZ3aiEP2puv
GA1ZYLs0iRLnzbGlogmXoA//k28trjDS/m+2+V8n8tN4wFKrmK1GEshS+E00
SXnU/pFNF3E79hLQ/OyTgPB+PN89So0m5Afsd4dkM4+LsI8k9S725iIwjN3f
UHySoFyG2vTXGVzKROzuNVsFF+LlDtY5NxBsThhSp2u48GKb3VxCMQLFlamO
rSoe/H+f/gMEN1dE
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4pWrLjjo3I5zeGqz9s0ZPRWHzhsJD1s64+H8
rooJzp6TEPwXG8I8VOZh8vc3mSRfnILgzzyx++bVXwj9MD7MfBgfZj86325x
8t72Ri04/8LGs9fLTiD4Ps1v2KQ1tB3eHfy/Mfscgm98U0959UFMPkw/jA8z
H8aH2Z/14E31TiEEP9Nhr+RXTgSfm+O7iNS/WAw+zP8wPix8YPphfJj5MD7M
fnQ+l/GJHbYesnD+c9EvzfG7ZOD8a6F3hOt/SsP9D+PDwgedD9MP48PMR49/
AHKCAqo=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1H0w1HkcB3BPxdVEZT20Fi1218bcJTmjEx+N7FnPTrvFLF+cxzTWCUdy
3VVyWtvmXIP12Cn2VnnukB1hdalduSHd4s6hKVLTZBrExv3+uf3e3P3x+eM1
832Y+X7e3w81JjU0TldLS0ubKC5ROkRdcXv8u+sgAlrlFLuQyQB2Td/NzPsI
7kh94rL52MOJwaonOdi8lfXktipsg9jqiIFVBviOSDJI/QhsahKOO9HtYYzs
1hcnwxa2GEce6ca+YcqmszoQxGe5bpnXJ9YXn/XhtyLQ0Q1t/PIuAxZ/feT5
tAWBwKlZOFfLgCLm8Tn/JgTfvOXUk/QYMNofZ2J4G4EsUVWX0kCH0QmVekqK
gL5GnbSyI7wU8EwqQeB7cGrSQEyD/X0So7F6BH9FSUbpu2iw8PiB090yBCrT
poGYs1T4OGk8NrcUQeb1oeTp/VToMv404KPLCHZkd0tcy6whLbmFxsvEvsRy
TE+Jx1au3hKoYxBMO++uvdq4V2NJhXhSkkjVmBwyYaEOtQFjdpRBSCKCg78J
XpYJbaFAFnxvazqC573L310MpEE4U9Jp+DWCsJKbFYVWdDARifMDshEYV8aZ
UrnY0WOb50/0YP/zXiQ1rZSfioBT7ja0zrMHLx2Xk5tR2DPfG10XH8FulQTG
OLsS+7c3FvTm0jROG567HBKEfcGhJjiIQgN6Gsf78CFsI3cDv/F/+dRY1etX
h7Fnulb4bh4IKuYlcimdBgyXdu1OTwQ+7ZZfrGTRYGdj0J9qFgKYqGOtchig
KP9AdwpDoD+Q+n7jDQOecfXFRZHY/DBe5gbCVh+IaXaM/7/bHAqmEgKwY0lR
n88q6cB3XxB+EotAcaM+r8SXDl7LOStm0Qjkg2IfuwUazMnal9yPIQgJbJeK
lLbQLj59ZzIIwa3qn9bSpTYaL/8wfuFED1XjD+KeU35vrGFf048jx4jzUx/S
t3nIrOB5hJxyNQP7xdNB2+pvsbv0c1VUAYKgnQ7FcUnWML9F2K0oQdB7Tf1O
7rUXjr7iKQdECEr1Iil+OVawWWBiRypCkE9Vtr0WUaCW46hqPIeAxDY5Y5VH
hnBbxUY5kZ/zq/eEm/Z7YFhge0aVQuTTt/mP2a3moLC/FlEeid3B3LHoHY69
KzfBKMofu23dO8yM6A8rWvnLu6o9cDGh0t/aH5s73dRpGIxd6W7RwCb6dy6C
cmiWQgamc8kQi0vMk6X8o5xsMlStiaUhxH0/dyq8U3QsNNYe+eol6QG2aCZh
t3S7JTxqTTPUCkXw9olwluJiCdzFJMflQGzPbQd4cyzsh6LYxS4if9wX5iJZ
EUVjk8LTnvVXyBpnrd4/2VVhDrNMTz3kR+RPTPFY2GcGHe/tKPWR2N6tk/23
87AXynQlkiriP7OLBV5yMmgn1bGjifnSIM8QOHxmDf+dr38DnOpppg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4vzdpYtNjBId9jeZJF+couIA4/PddT/ZpqTm
cHp2xp/teokOf56+O2fao+Ew+6/aTg/ZRIeuX3ksxWe0HGyFZ6n4cSU6sGwy
Kt1kr+vwdWPhZr73CQ6coVnfHLr1HNZ5+AS8fo3gW5V2/fr5EsFv4Juhs/tF
gsPNW2F8HWUIvswmtd12EQj+vrl9glKeCP6yBy1z99rpOazX+r1uxbsEhyfh
7LNFH+s6nOQUdvPmTXR4Efix/vhLbYewOJuzwvKJDq86jLgs9mvA+TD/wvi7
IzXsHusoOuRwn/duFU50yFko9dQ/VNqB52fYrQtvEhx2cSZvaA8Qg9u/wfNE
4KmronB+w/ktmYIHEfxDy1rETixC8D1DVQpM00Th/n+R8Hf+YRtRePjA+LDw
g/G/V/Z86uFOdFh3fs5XzU/iDg/rDjBbywHD29h7uRSTrEP4Nv7KbGD8bJzZ
e191kwI8/tQ+Mi9ke6HkgB6/AAFR2fo=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4m3ZTlHJExIdfCbkcIa4yTvA+E4cJ6YHfFBw
+O2zxmliR6IDr2Cjie5WRQeHuH8/Y2oQfMGiZjfeIgQ/t+C4w+XsRAcPDteV
xWYI/sw7zdknlyvA+QYcgcnPZRXg+o3BQN5BU793V2YNgh+RnKKi1oDg/66Z
IqjfkugwRT2KeWmMvIPjs50lQe2JDqcWvvrTsF3eoT09eL8L0L2/pP89sTwj
D3d/2ympgFNX5R0KjFiP3UXin33xhtO8E8F3POfa29yJ0A/jX/+nuSHaDsG3
5lI07A6XcdAUl7w8qw7onh/mhzN+Szr80pon712S6DAhlMHp1noJB/s78pa3
CxIdHOvMiu46IvgCLMpdKroIfsjtT2a3+RB8v9ulqjtOiDvkaWR3pQHDh5VF
M/3eAnGHVlfXOf+KEXyHKYeb8soRfFj89USLxWqslHJAj18AoJ7Eiw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGINIGYCYoVjUUa6AUkOJ04sTn2nre6QerdzcY4zgn/z
Vhhfh2OSw8tD/xb6T1SD84X+mm6J8UPwbyRtP7/quKrDFMFEXk33JIdiPueA
WwmqDmseMK5/4I/g337ywfN/OIJf/2yNv2VckoNs1TOHV7sQfKfrklaBUWpw
/pvW5X8mHFJ3WO3Tc4DZLcnB2baW5d8EDYeqP81vS3QRfENVc/3ZrAj+rtoF
ai4vEh1E7h65tTJDDc632ThDieu9Mpxvwh3ZtDFB0cGQ97D7GfYkh8i3q/fo
nZVzONC/JfWQDoJ/+9VZ5uJwBN/SVNtsZWKSw6z/f5LdLijC+cIbdVeIsCjB
+S/Npl+sM1VyUNR6EZgTh+DfWeHHXhWLJB/yOW1aFIIfsGPT/A+RSQ4upws+
TVRUcqiTKbrhFYkwv7ZJ3uAXMHyvCS9fMsNKwWHVkQuufNZJDs/3OSrY/Jd3
SN5d3aCmj+BPuKzYKCCH4Bv6O7kcZUxycNCwLGS+pgDnh+Qtmpb2UxnO/5ak
oR6lpu6w33m2bpBMkkNNyKag79/VHZLPCq1r1EXw2T7/4SsyQPBvbtPYfNEF
wUdPbwBcaRCw
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
     1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}}}, {{{151.96689062000002`, 9.9466375875}, {151.96689062000002`, 
     11.224657500000001`}, {151.00020320750002`, 12.283188}, {
     149.82959300750002`, 12.283188}, {148.62162290750004`, 12.283188}, {
     147.68295542, 11.1950809125}, {147.68295542, 9.9466375875}, {
     147.68295542, 8.6592777}, {148.68855939500003`, 7.7003736}, {
     149.82025303250003`, 7.7003736}, {150.99086323250003`, 7.7003736}, {
     151.96689062000002`, 8.6795143125}, {151.96689062000002`, 
     9.9466375875}}, CompressedData["
1:eJxTTMoPSmViYGCQBGIQXde2iK1nV5LD832OCjb/5R1uXZIvNFqL4N/M2Dq9
fn6SA0ee5+Z5mQoOcgF/LBWnJzkksq57GBGk6ODD9PVRdH+Sw+L7HHO2GSjB
+VfupEpppCrD+WfuF4utkVaB86e90Nnc8QDBP5p6esWLj6oOq7IWb7syLcmB
zUEt2e2CmkNqc4yIMdD+hOtdExl2qjscnnux/DTQfV9SN5swKms4cC30bLbf
heArWanOeXocwV+/z+yT99Ukh75C/uCczeoOXz9OOxN7N8lB7q/+9UW31Bxs
VL8vy3+a5KBclRzEy4jgB0ycV3vgtgqcD3M/jA/zH4xvmLdFd0qIksOGiM5Z
c+4lOXyYHFlsVqbooNwj3XfyepLD3eDmKpdJCg5KShu3iJ1ChC96+AMALiKz
Vg==
     "]}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1H8s1HEYB3BOLTkik5a437/SLkQuv+pRbeWci4aNtHIfuq47P265UClZ
DSn9UEut1SqkkkOslB9NOkZRV9xZGnMc+SNWyaTo+0/fj9Uf7z9e/zzb8/k8
z8OUpexKtLKwsLAkEkqEQsTGdE+dEoZAvMzYM6xhg9+38GxNJILSO9U/puPZ
sIsSYa5LRpDaHr530B77VWaRf/9NJmldr7Ej9RoDdImd5dkIgV3ms/uia3TY
WSh5VyDGDqu9nlDjgY3ihSY2B8EW6/ar4ZMMOKJ3ozvQELS6Sh9sL2GBT8Sp
D25uCOw/rDmfbGbBC+XaiHeuCDZLg9L5sywo3zemurwK27v0+px6xf+ubr44
EmLAnvB1Mt0+in1KHNf2tIZO+uxolnBmEXZKB89mUyMNLooiR51WLTC3sb7e
BfvLx5LfjqsRzGZs1XTpaHCkcuJlDBOBrd/ukcpcOkjEngXzhAMfJ7+R38CO
cii/m6elQ4KI1TXDR7B+bCDfZyMDHgqsKhx9cf2sdZUS5TbsjTFzBk4otq1i
a+33FOxAbm9x2XEEg++DraLrGKTPsOb5sTwWaee0Xkr0Bja0lbonLdUgOKAs
bBR0E+7ekOOtRpDc+VGVa8sB2+5Jasl+BBJ11aVxLQdedWZYeMYieJRokMX1
cWDnYePnBgmCnNDl7hQKF6y1FGaXP4LgyLd3i/25QGunV8u4xPtSK/Kaj2G7
BDmesS7jkTYtVsniYvgwaS+W1goRKKanzs24C+AKP9YqLASb3TAkvanCDuhr
2OdLzKN6edeek3t4pI0tuUnmJi5om1YM5xD2StfLKy5wIeC5svlb6gLXFS7O
VmNXHa4XOmv+d/mOtNPCB9gBoiSdgsojvX+lXF7hICA9tCPa56wcW22w1CkK
BHDQ7nLHVzX2lPfUs3OpC+ynT7NcYG1vfmcE0a8qvdaZKiX6nbajZCoRtFEL
RTR/ASgOBbPuHEDAeGH0GqYKILtS1XNMjqDlIeQ1/+JD/xeP1wG7cT2bTx1P
ZsOwv5poli4h2IYEw5LHTOy/+xAUa24ye/NJt4/ke/104pGec/WMKYvngqHG
IaOI2I/WoZOOnnoOuA0WFXuxEegHJvnd8RxImD1RkEb8r1YmiarrZ4P1wPiE
kph3+VqPmVuNbPj3Pv0BQm78cw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxd030s1HEcwPFzRyyjluVknJ/rHow656mObnxmnkZ3h0kM4e57ozZPzbKR
6JYWqskiwx83sSEPo1w7D+nhmpOWiR64yVM4hcWi83T1++v32/rj/cfrn8/2
2T4fZ2lWtJxGoVBM8HzwqHiNjFC7p+9lgO6XNSq6WJBstZWy/FUGOnaK66qB
A+FX9h3XdkmbqfNNk4ykN0qGY0pPI8JtE6HndvgIzP40oybFScLHcj4slG86
E74gv5UoHsCg8M7+SoY7AnmgosYvDbcye0yIz6Nb6l2pVAwsaLmmSRwErxIK
dmWYIzjVVNb9dUBwqe5eVU2pHeEwncGmSkEnPL8U40mxoYPo+/RqGQOBZvjA
OnjEFiZnvbR7GOnru7IeUzbpjaGwKAUXwYPu4I+ZrXR4EyzIW3RFUHu8TvnI
9QToONkhBg8E/mUz6vp8BxAMHlqx9kEQ137e0NTHgE32jkp0BkHCUXbPky0n
0P1qHVjCvca/qeILMdD0JWqKziJon8yqLC/E4AZTUvlCgMBQEZHXPYhBkUpT
XBeIoCNgPFHwjAmXO/0Z0lgEqRuLEnkTG7YDDus7pQi06eND3d5c2OZWU+YQ
gsBer8zgHC4Iy7+1VKQjaO74IpmaJS2yN/KGfpNmKtPiPDgusO2sDsmQk7a6
aA4TiLT2U8bWnIy0cNwv5SCV9AyT/5mOG8NaRp1oLlBsH62cikTQbXHk+w8W
ByJDIibigxDE814uUHgscL4aZDGJ79+7P98u9mQSFvIkd6NGSTfIpwNsRSwQ
x7CLu9wQ1Ls9rNZ54/f281qbgIVAZUmn9aRxoVVvVGroCGJrfYf3klxgPdnY
GUAlTfXtL4jQyQiPvZOa57+VgVo+VtIgZxOeSj71mjbCIrzer79tUsOCx2L3
5Ugt6ZXnMeG5I6T//59/Afd1Ng==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4l38bPs7l6Y4+EzI4Qxxk3eA8Z04TkwP+KDg
8P9D/vLtc1MceAUbTXS3Kjq4MB2Ka56I4IuKua82bkfwC0W6l/5sSHHw4HBd
WWyG4M+805x9crkCnG/AEZj8XFYBrt8YDOQddC8HyE+YiODHsGt0+kxF8P8r
RJSFzkxxmKIexbw0Rt7Btav2ZsWcFIdTC1/9adgu79DNLa6SDXTvL+l/TyzP
yMPd33ZKKuDUVXmHkmsntFjmIfgXezbkxSLxXYs4P62ch9AP41//p7kh2g7B
t+ZSNOwOl3HQ3X3H/OBkoHt+mB/O+C3p8O9cYkthZ4rDhFAGp1vrJRycGx7P
ZWxLcXCsMyu664jgC7Aod6noIvghtz+Z3eZD8P1ul6ruOCHuUHRG730PMHxY
WTTT7y0Qd+h8ycGo2ongu1i0P5/Sg+DD4q8nWixWY6WUA3r8AgC6Bcha
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIlIGYC4jV3D+jVdKQ6rAkR/2DELOQA4/N42h1YoiPk
cMuxIf1ae6qD2rLyaUfthRw4l9kvMADyf71u/L0sXsjh0C7rmu6KVIcNszgf
6oSIOPjs7/N8kATUX5HA8LBX3GG/Ve3nytBUhwbp+2c5+eQcpF2rE9X9Uh2e
rz1ttfa6gkPiB/mDzt6pDiJ6X223PFWC84O4b7PuPKAC5/vvstv7+J+mw4Fz
nx6Gxac6bN3OcHPCKl2Hjx2pfTNaUx1U2/Q+2SgawN2/acmkD5/NEXy75ula
SrYI/unEOSkBTgi+o7Fd08VoAwd/e99LH1sR/DXsZ5yXtSD4qRts+e7VI/jv
W1bwTM1Ldfgy5dmCqa36DpN+nL6bmpXqMEGB0UPIUt9BujTZ4KhnqsMi8Sin
5PM6DpKRRsc/maQ65ExZzZdvoQnnz0jKtG48qgLnd+1Z08n6UdGhfDfzw+82
wPCQ/u748Y60AxuHQdmdtFSHFDWJc6YKog5ywsVRkkD7otJq8yuWijiYx4ky
369LdbjEN6FSb64g3P0wPsx/cHmo/9H5sPQAAOhW6DA=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1HtMU1ccB/ACKo8C1rgxFGnvbektlgkIMrFO/eEkMDoIYCxsiuPhuUig
BbbpBoIIVMzCwhQmhhIJVmFURWkZRgiPgk+QuVTr6njIY6BOhA0XREJWdv/Z
PWZ//P74JOf3y8n55vzI5MxYZMfhcGyYUjBly5TsSI8ynkODWVtVxKsQw/Bl
eqe/LQ2vBdv3SN0puMqR705zpGHFjcwF658SKDaM9CoF2Hqr1GOBwB5zmM8s
9X7LRk0r348GmxRhRK1BAqNEetxnFA1utcqgqSoJbBNcjSGY/mOmyZ+T+Nh1
8qVycz3FuuZSrGA6joJ55YbgkyIatsy72I4tiKE67pBi0QebN5ctGgzAHpcu
rzB9SEN/qGU0PpZiLUrIL7Fxl7AebNAZL7h7Q3Was1ohpUGh2dK7mOANrnd0
3zUKsLdOOdoUuGDLUqJKvmXeC3LNuvbPJSDa/3yv0YpgVus00DVLQYHqRvHY
awRnNl7Ur/f1htSFd2/PTiK23/G8VWAewtZF2RuoduyIeKNu10UESG93duk3
Mevrt86JnuzD3vFO9sjK9WI42T3pfLAROzmBMrtcwbZIuVmlTdjrLl9oy9cj
iDPl7s4IFMNM2GShyIDg6dKeMNdEMeS+CMvpZ+7zqcXl2PAXErh0YG/ScRNi
891s3xnvO4RNi8hBj3Hs6Lx0N/40gjK96r25m9hrh0Ne9l+hWM8VuP6NVlLg
5NOm6X2GgG/xMR1t8WLn70gXfRQ4QQKqRomUhTnf1B6N6gjI2+kh9upH4JzT
pttcJQDdBxV9cZ3YnpsSg75sx5aPHvGStbxl78cD9cz7nG9dVlnOJcDz8MjG
jGsI1pTWN68WE1C+esgq70Ag5I5Hhpdh+3KHssrWkqwLejalPtaSbP/dqkKx
oY+EBqMqv0OP/SO17lFGA/ZL+5IOTS0Cs+LU4bvh2F5TWV+dbiBYD1nru4+q
mfu6hTTKmfxUfZTT9g4+BMXIwrid2OhepN/NB9gDwckbVjxBMPIwxE7RQgDR
tvj1G8a8GXXkwwcEBHclabuZvPwdYlKeeRJQ+c+yJN4M7pcdmmyeYPbDf6Ym
imtCSWz1QF+9JJAGnqmm8M4fJOuIe9N2LalC1j15/PDiaiE0K6y3o/2xlY8O
5O33w1YLJQk/vI9tKHl6eob53/xVbw5WnhDC2Iu6++GMvy/6xHI9Rcjun5yR
s2R3KAFNz39N13BpNt+5sZ+2nrHBjhF+E6CYw/kXXBPIov5C4KD6uLkmjWB9
bl/XciuPZC1QbVuQFpHAbY39JeAVglXZ938vfUXCLXtTi5aZV3h8uHuNWQj/
36f/AnutVi4=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1H9Q03UYB/Al6HmBiq40L4sYE0Z5X76HUDc64uHMOk7EkyAGgwMa++yI
ZI2f5hqgUs6p5RDCOWgno0E6r4lxU8Fr57Am0CAxZx6tRKnAZMFYzqWj73U3
Hi8/d88fr3+e5/N+7nOfiHekGeIgFov1BFM5TC1iqkxq5g73EDjwz6dpw3E0
vGt5YTLbTOABf/H904QGqad1bpDxiTm23V9KQ4/KP6LtIzDS6onRSWk4Zbiz
33SBgOArjn6LjAbtq76CvEvon7W/0Gcvo88mr1nGdqC/SAf2xTG0c2BVW9w4
gWvqyLaVIhqeV264EvYngZvyur1/p9JgGar5S85YaVGDcDVaMqe/WWyMXXBB
beflDyvQZxQ2IbU5Fvrlyze4p5j+lUk/iA9QwHnFukzJuLo/4llBMTqKX5it
B2phfm1FncdGUbDcsuT1xGm0IHheuHsGnceXSzyM1aMOd3M6BUVl98pLZgl8
u+2WM1RJgS78jaXpXgLmgtdyco7SCzZWjZdXnqbhZLdLZfKgQ1qyrn8zgzZO
2NP4peiKkgcXbWJ0WXy9OfMRy26tdg+KCFx1uBPYB2mY8x3xLn6bQK94nzf6
OAV6QVnJSBYBziXWfkMjBQ+dhuSZTAIrxF2qn8rRRPcdb74QbffDOUUGkydy
Nj8vC/P/IZmq0gvQhyUt0johOs44fmhKiPt15kZZk/IJqLi71q5voEAU3Rfs
KiFgmkxJkRXQsHVf+nCUDN9HvEQxUNSIDt/qKf5Mi+7+caKJ244O2hnCzW3H
9xpwoH/APMdTtv58dGYlt8WRSUO+f5Nv13EC0/YbO7ITaTDX+oa1DQT2WkM4
nOgYWDu5+W7nHgLeNSmiJR08sK7syPDvJtB1sE63vZ4Hwk1fXggqRa8LrRJw
RGhFtaWKKnrc5/v4eS/x0OxCgX8onAfhvSFNGsas/w4PhlzxmslidGBewK5B
zV21DP3riuT5r2vQV966HXZdgSZjV4E0oD2xqeJ6Ffr3iulq/WF0RLVhJOwo
mn1+y/jGz9HbS4/VPNOBnnCrOg0n0B81P/likwk9qtQoMrrRz32vbtb0PG77
usZc75vowP4GOj5+WXIG/dsH79fojWhPrylB0YUO3C/gwlM3EmZ16KiTnLEG
Jl/worbUOyrM29oeee49DTp0p6Zo1PrIPj5Jkk+PodOcrI2xt3lgc+3wuRgv
DU48cu3pGPj///svPehYww==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4tUXZj/lXZ/ucNreZctzIRWHqZrPFAR2pTuY
XOx5NbNP2aGuySBG6Gi6Qzi3++tmVmWHL+9dokIupDuY9i2SyGpQcrAK7mVm
uZLuIBV4S/pPEJAv/vpA3c10h3Mz/5ldFVByCNJ7IbH4NoLPU97pOv8+gm+9
tPnr88fpDld+ej8z9kPwa4/uL6mfj+AHrf5prXpCySGLX+HF1kfpDvZ+tuXq
v4HyD1Utcu8BzbvzgoNVXtnhFlcAp92mdIelrae13lSoONwzkF7XfjfdoUZv
nc/lS6oO94RO8bg+SHdYs+KgSc9zVbj5mRc/tl9lVYPzheemiimGI/h7M24u
yVmhBnf/oRNqIaefqsH9B+M3zGjhLryFJO9juevpDaD9hTPkmB+qOWTOvxHS
fzXdYXl3XHjsDjUHWPjXnw5a+OGeCtz9a84dtdrAo+Hg92FFTxeQ/6N1ofx1
Pw24vMGDA/YMR4DyLvu33VuF4H/Yu99ReRkS//mpMN9F6Q5PNJ5G3WxE8GcW
cpZtskfw08rNWV+wazhw3J4ZvHs5wj0s3YdnujekO1xVfSxxcpOaQ2Lh5DV2
NQj/wPgw/yZ2sk/hrULwr87zePa9FIl/zmDr1EJEeML4sPCG8WHxwczMIR8E
1K8464r2gWeqDlfbrvzTqEDEZ82rv68Nl6Q7vL4TmbClVgUuL2JSbndWWRmu
/8nO5DARfmW4+eoTjZlPf1CC82HpDcaHpUeY+2HpFeY/GF/6w89En2oE38vG
dfN1YHiIfuzJmSuqBA+/V9eOGTvbKcHDV3D6pZfrxVXg4b9F0ifD/KoCnG/n
scpr224E/9blIx+N8hUcUhdLHM0Hxm9iU4r3AiMFh5txacaTViH4sPSCzp95
pzn75HIFePrRev22dcc7BQf0/A8AXMTkXA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4vebdhnoemc4nLZ32fJcSMXhJjdrjn5YhoPJ
xZ5XM/uUHQ6l+C83TMxwCOd2f93MquxgcSl5aXFOhoNp3yKJrAYlhzrTNX7K
BRkOUoG3pP8EAfk/OXnmlWY4nJv5z+yqgJLDNAH2lEPlCH5A5IoJ+6oR/Pr2
RQ7sDRkOV356PzP2Q/Brj+4vqZ+P4Aet/mmtekLJYd1HO+OrdRkO9n625eq/
gfKHXZp7qoDm3XnBwSqv7CD3Ni8k1i/DYWnraa03FSoOSsJWP5dVZjjU6K3z
uXxJ1UHp64vwlJoMhzUrDpr0PFeFm5958WP7VVY1OF94bqqYYjiCvzfj5pKc
FWpw9x86oRZy+qka3H8w/pGqxWETypDk9SJYWYHhUVM4Q475oZrD2sbv89cV
Zjgs744Lj92h5gAL//rTQQs/3FOBu3/NuaNWG3g0HCZdOn59JZD/o3Wh/HU/
Dbi8wYMD9gxHgPJq9xj/uSH4Jgvu9Tg5IfFPvVyYY5fh8ETjadTNRgR/ZiFn
2SZ7BD+t3Jz1BbuGg8/eHfNuOSPc45H76EmaTIbDVdXHEic3qTksDd70PVYC
4R8YH+bfpdlq93XEEHzJxnRDcSEk/kZ/hq28iPCE8WHhDePD4sP9qVpWoWCG
g+KsK9oHnqk6SGZ+9vQQQcTngTMy5oEOGQ6v70QmbKlVgcuLmJTbnVVWhut/
sjM5TIRfGW6++kRj5tMflOB8WHqD8WHpEeZ+WHqF+Q/Gj78ksTZbHMHvk0v5
9w0YHqIfe3LmiirBw+/VtWPGznZK8PAVnH7p5XpxFXj4b5H0yTC/qgDn23ms
8tq2G8G/dfnIR6N8BYeVreYC/cD4TWxK8V5gpOAg69hat9ENwYelF3T+zDvN
2SeXK8DTj9brt6073ik4oOd/APZWv+A=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIlIGYC4i7RelVP00yHNSHiH4yYhRxgfB5PuwNLdIQc
dlTaxS02yXRQW1Y+7ai9kMPzu3+n/TXOdPj1uvH3snghhwWffhZFqGY6bJjF
+VAnRMRB67uPw1p+oP6KBIaHveIOc4usX7kxZTo0SN8/y8kn5/CzxjLiy68M
h+drT1utva7gYK9xb7vAjwwHEb2vtlueKsH5Qdy3WXceUIHz/XfZ7X38T9Nh
HtvGG8o8mQ5btzPcnLBK1+H8AeXWVKNMB9U2vU82igZw929aMunDZ3ME3655
upaSLYJ/OnFOSoATgu9obNd0MdrAQbec++Q+IwS/y77LqtgQwXd+8ZtltQ6C
f3ZPGnOSdKbDlynPFkxt1XcoMOi6YiSe6TBBgdFDyFLf4ecaRfVJ3zIcFolH
OSWf13H4PuHD3v0PMxxypqzmy7fQhPNnJGVaNx5VgfO79qzpZP2o6BD6+eD1
Iy+B4SH93fHjHWmHJ/bvclYKZzqkqEmcM1UQdfjjZRj4TCzTISqtNr9iqYiD
6LTLP1drZzpc4ptQqTdXEO5+GB/mP7g81P/ofFh6AACXTuPO
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1HtU02UYB3DECRWWRchljM3BLiSQckkOeoCHY6KMuGZDuY3bHC9xk0uE
GiaBcXCOIWjixlVoTOYtEDTGLZaBBzgIIg4oFE46SBIKgwZKv/5o7zn2x/PH
54/3+57zPM/70mNSgvnr9fT01hEVQpQ+UWOpB8jn7yFglE9wCt9jw9lRjub+
CILmBm9+dir2QHygeuQIdvjSSkJjBbZhbGVY9zIbSg2dWzLuIrCuEhxwZNkC
LfgH/dt92GqNtLKmF3veb1ggUyE4lOW6QWNoC9Q7BgWDXQj01wcr4lrZsGNt
/wlXwkLHa6LpajY8iHrEuNyOIGeBKzMhsYGq/Z2b3IZAGa+uTaxnAdU41sO9
FQFLSx+nMghvHWVuvIVgn8vE+GsSJhxddgpyaUHwkCcfZr3DBBfD4HRLOQK1
6dXumC/okF3Fq5uQIcis6U2Y3E4Hkm+HCF1AsDH7e7lrGQ2U1TsFbfnYQzk3
mvoysc23uw6EpyGYdDauLlZs0VkulYzL4+k6WwSNWa4GW0PkCY3P9SwELneF
s2UiGxheVK8T5CL4teOv3Hx/JtRFOWmTv0awv/RbaSGVBVE/MXouFyAwLueb
0kOwo++tfXVQif1fv3jOV9WDOQi4F9x6VyJsQejWruClYNt3nZ9eCcJ+8XD0
Yok3cd5IUdBxjKnz4YHpU0EB2Hl2VYEBFCYcrp/ML/fBDk0vFu7gYN80st3m
54dtv/Dld2WEpRq5qoHFhLRE993mAQi8m6w+XspiQtj0A1pECALPsdq9y1w2
mA2djC+ORWDQnfL3y2ds2FYknphLwm499bglMhV7b8JvC8LM/7vRrmBC4Icd
Y8LbN9XPgtb0tMEiYh59dbKcUh8WCB1Ibp8TeaofJd6MGSa8/9zdpTwOQaB/
U4O43wbWhl4s7eIhUFRe1KY3WOv8vOR+3kElXedViTLJ9xkNMh9TjZuJ/OQ7
rDc82qjgWOIXuZCH7bQpgL8mxiZ5brDMlSDwf9vuDB/RwNndbNW+FkH7udVF
ldcWENs8eYtRheAbUiTF9wgVOJ0V/Awpgnx6f+OcmAJPT98gv0nkvcvZfJSa
Q4a60E9ghdif3OVO0ZqtBVioFEq3Ywh+8bn285SBOZhF0cq1Sdh60efs6xB2
eON8YEcY9kungbNZXGJe0f0tixUWMFjBEh0Pw64xddMm87A16bUzl4j5HQ+j
7JyikCEjwcqo/hDR7z9O7uFmk2HGkTl3nbjv0s2+DxP1LXXWG0ybNenBLnok
MG4wsgLTWW1AVDSC+RHRFOUDK6ix/jOJG4ld6NVasTsEe3PPU3sysW/cJ+bi
ttMUnU0KMzxlRWSdP1u+/ektqTk4RPfs6QxFABKKx8xWM9BzvBJhmIxdNBNH
2iTC/vfdvn4FgTnnjNBLRYaPqhyEXc0IZKpMod0uGrz6v/4DJDpwng==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{215.8927060625, 10.091407199999999`}, {216.0296923625, 
    10.091407199999999`}, {216.21493519999999`, 10.091407199999999`}, {
    216.21493519999999`, 10.290659999999999`}, {216.21493519999999`, 
    10.489912799999999`}, {216.0296923625, 10.489912799999999`}, {
    215.8927060625, 10.489912799999999`}, {210.5595803375, 
    10.489912799999999`}, {210.4225940375, 10.489912799999999`}, {210.2373512,
     10.489912799999999`}, {210.2373512, 10.290659999999999`}, {210.2373512, 
    10.091407199999999`}, {210.4225940375, 10.091407199999999`}, {
    210.5595803375, 10.091407199999999`}, {215.8927060625, 
    10.091407199999999`}}}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1GlQ01cQAHAMEGjRqWBQEkIgSI7KWBVtqbYD6yjIMSYcDocoCDRAfREo
FihUsKJUBgIERBkNIuEUEwvlksgVBsRqieJwyA0l7XBYSrUgERH6/9K8Tvth
P/xm3u6b2d1ZZkiUl0BXR0dnAxG+RJCICA9KEDvoC8Hm5qhb+occsO5CgUlk
ITTInAUJ0dhPIjyG+hOxTyy/PV1biG0QeiugQ8MB5mvvneYkIVgXhfvtYXNB
DupvhO+Q1mHPW0xdV7CTPl8cO7qEICzeXn/GgHjfyFmLe4WApOsl/6KJAx3z
sctjLxGI9lRnqaUcEPBJEu8FBMkvfSooehyQzXygovyBoDliqFR4mw0ynUt1
6hcI2CvMEYYNYTONpGYWgcu+0RFDCQsMp70fDk8jmAyq7GUbs6B9KWa2fQjB
0NaqjpAkJpCzvzO/OIggtvjR6YndTMjZP6m3+WcEGxPuV9pftwRXccBYaAN2
0JmBHWfLscsYfod1SxBM7DWR5sittK4skIxURjC1pnoOm696WcOLqPeUvrcR
7HsmmruetR1OqVfiN9Ui+K3tdUoqjwV2fO9o00YEx/LKC9IZbJivd3I4pkBg
clOwlemLHdy3ftG/Gfuffv3O7OHHVyHwubH/0duTXKByJ6zJRdiKKoV/cQp2
+lMN9UA8kW8kT2s7x9L6qyfqDE8+9iXbIg8+nQVr13RWDyViTwfXkMb+ZacV
l7K/krAVE1IuJCMomKnslLFZsH48UNF6HoFznYX3cjwLZp69uaqbhsBxuPSI
xocDpcqKcfs8BOSOqDdrCxxoTvrRK68Q2yXR4CN9KXaf38aIveX/d61t2mj4
UewQSpDLlIoNLiFXnD8h5tFdVpGc58oGKp1VxSDqdT6QONvMsqBJHXjn0FUE
Hrw6mVi1HUTtjMipbATyWyUrZ2XWWi9dGbjk38zUelXSfMZ9wRJI/Y5pJ4j6
kY/Z7zu0MKD1QmRffj1227uokbJ27Jyd7BxuNwLeZttcwZeWoLT9NKa3D0Hr
tdXFzoNWYGFimPq4B0G+XiDdPZEBz39oG6GpEKQyVbXzYjoknBsQ1yoRbHEz
/ZaRTAM717gGKbE/KRpl1jqXCuU1KrtJOYJx1+qxKbIZlPJgi7QQO5N/r9j9
Bvas1PihQISdwVwwYlwm5hWsurdYSIWTmUf02CLsXfrHo03F2LEhD4I8ifmd
D6AfmKLTYIO/wwVePtHvV987+STQIM7KOdSP+O9OY/dhIclca52emDnKT9jZ
v4SbyIwsoGTQvIuci+DP/qwp+scWsMuY8utqFva23aOUucvYxQ2bSpTE/vlM
m4lbMulaU9K/dqzIpmkdp+lCigIzuM+fbQrLQAASusPsjm2Qafm0924hNn0w
NbG+Fbu97e6p6nEEZm65ooOdNBjK4pEiiPtS0Rkrsv3MEv57X/8GZJ1q0g==

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1GtMU1kQB/BaRapUXeUhRg1ShRbR2+sDIzR1h2VRiIiKGKBgWqhVI0cq
iLgWynWFVZYaSVGD7MKiQtAQ4gMUoYDISxBNVUpafEQrmBg1EKNU6y6L3piU
MXqS+fD7MnP+k5PjnaSOUk3kcDgT2Ipji8vWHQOzhH+IgO6/goh7y2nocnn1
9uTvBEYDnT5d2UHDXVCN8g4TqBpxNY4l0zDLfKu//wiB+yU2vzI1DVPf1eqH
jhKIvSQoX59Kg/1I287iAnTQy/OrbSfQ7rpnbpvOorl/8eZ+rkRLPB5XqKsJ
mPULS2cqacg0jTzcUEfgeSaT8yGchvmeYK9nnXdTD/Ee6J0j5c+3V4vHLc8+
fztrH7pW2x1PhYrBu8u8gr7G9k+XPlDpKGAO69w7rxLI6PCeG7sd7RuoiCkH
anx+9j7G1k1RkOxyb/2BevS1jV3KG43ohtwQ9fImAnqT5f2pSApuNLRoKlnf
2jj4lJ9Hweju6T/p2ghcl6+JiztNj7t6/0Ba+hUaeGPXC4da0LsG5ltHG9FT
lhVFZwSg71/t6HGi0XeYsBa9GG2knv3Lowj0Wd4HuB6jYfPaBE7IAgKNqqN2
4VkKOBWrUqexFnRy/qwspEC2WL2O8iIwQ3Uh/2EaekdZl+izAm0cgwZtFJsn
xaAq9sL8obU1WqsAPVQjP9Dkgy74WHVK6Iv7lVQO92iEBPIXaeb45FJwMy2X
v2QlgcuvgoNT5TRU9XpYlBJ8H/qa0N5/EtBZp5uJSYWe4X2xJJGgFe0m/yKC
79VhR3+HRRa37o5t6Oj0RUWWaBoM4XxufTKBYeOjPTFBNLj1tFn6IwnktLsI
BEI/yFg53fYigoB9drBycoUIFmwjMgnrC8eYss2HRFB/PLUTAtAHY6QK+VL0
o9Y8bbL/jzY0BSb4i9Cuitixu14iyJrc97eZNefrEYGf5P8zvmK0Y57DEbOT
bEYJWhrv7PwuGC0uq/Z0D0O3C0vDyiPRUZkz9zRHo39tqcu2ytDZrSn9G5LQ
e53cXu/dhb5Yl8RsTUH/8vOWS4Pp6AFr77IHGjTdl/hHQRZa4ykrNTM/2jiv
UGZfh3bsT/g2ck2FFh3SuZqxZqCjnA9KDWlox/0cbrafk4p3o3M+vB5sZfNN
4paGv8nHvCXnFjaQYjT/t+JEU/s3+zguzRx+go54ylkhfiECH8kq7lIlAd6k
oBNmdz/4/v/9AmYwQ0Q=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJVIGYC4mazKaauDrkOIdy3WXceUHGA8ZM2Tt9uMlXd
QfXKIWkHi1wHlwceCw5O13aY1j6tLZov12FXlEWU/Dc9h/qa4EVy3LkOB3a1
ctYZ6zukGW78GfEtx8HJ2K7pYrSBw8f2XzsmfkDwb2YpLP/5Dkl+I+u53W9y
HLaGWHosDkPwTyfOSQlwQvA3L5n04bO5gcMhX7epiW9zHFpmHZudaGDgULPF
InkB0LzQCb/czmsYONTx8PD/+Jvj8MFk5kczD32HdW3y3zcI5Tps285wc8Iq
XYd7IZ6c++RzHXQehESZ1ms5NHp5zxZQz3VgPVDB1rtOw8Fm/jLrL5q5Djft
/ZnbFqjB+bOSMq0bj6rA+W3zPddcO6gE16/TOvt58k4FhxmX1+87LZfr8GaN
OsueTlm4/Qy3D3bUfhV34OS3X3Lnf46DRP/aQwcPizisZkvMm/8+x8Hl8Lmd
De1CcP/yedodWKKD4N87p3XjtTiCvy5E/IMRM4LP0rk48flGQXj4XuGbUKk3
VxAe/jC++f2Od5FfEXyug6wmf9hyHabUbtpbyCPiwDX9l9wlrlyHHbPaPvnP
EnFolEo+U6QNlF9z5e/aXEl4+mi4OcPotK+CA3r6AQDaUwt9
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJVIGYC4qID6YHOl3IdQrhvs+48oOIA4ydtnL7dZKq6
g0jcNHO7U7kOLg88Fhycru3QKpi1KHJBrsOuKIso+W96Dnls6vtk5uY6HNjV
yllnrO8QurtFNLwj18HJ2K7pYrSBwwPBc1f6mxD8E18+H/regCRvffPlzrpc
h60hlh6LwxD804lzUgKcEPzNSyZ9+Gxu4LDxuuTG+Ppch5ZZx2YnGhg4ZNvx
1M8Dmhc64ZfbeQ0Dh9xp97W+9ec6fDCZ+dHMQ99hrsBnofVLch22bWe4OWGV
rsPZezKqezbmOug8CIkyrddyKLgit51vZ64D64EKtt51Gg7amlXhn3bnOty0
92duW6AG589KyrRuPKoC57fN91xz7aASXL9O6+znyTsVHNpjm2+d3JDr8GaN
OsueTlm4/Qy3D3bUfhV3+DFD6MCtibkOEv1rDx08LOIwa4JJ19xGYPgePrez
oV0I7l8+T7sDS3QQ/HvntG68Fkfw14WIfzBiRvBZOhcnPt8oCA/fK3wTKvXm
CsLDH8ZXy4zhimhH8H963fT/NSPXYUrtpr2FPCIOPxXOWV2Yk+uwY1bbJ/9Z
Ig4FS8xeFOwFyq+58ndtriQ8fTTcnGF02lfBAT39AAAloBNx
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYun2UHHvmXkOZ+xdtjwXUnFgfTA/yHdJnoPp
xZ5XM/uUHd5ZvOr1X5/nEMHt/rqZVdkhZdm/7om7gPJ9iySyGpQcVnG6mzru
y3OQCrwl/ScIyD+75NPuw3kO52f+M7sqoORw6MlCrwdHEfwaXefyOycR/NXR
tuqq5/Icrvz0fmbsh+DXHd1fUj8fwQ9e/dNa9YSSw62jNyU/n8lzcPCzLVf/
DZSffj9z1Yk8h3N3XnCwyis7eB3ktK6ek+ewrPW01psKFQe/51fuHzme51Cr
t87n8iVVB7+TzXZNp/Ic1q44aNLzXBVuftbFj+1XWdXgfJG5qWKK4Qj+3oyb
S3JWqMHdf+iEWsjpp2pw/8H4H/zsbNcdQZJn+vxaCRgeNYUz5JgfqjncDJ3U
dmZ/nsPy7rjw2B1qDrDwbzgdtPDDPRW4+9ecO2q1gUfDYd+ypH3HgfwfrQvl
r/tpwOUNHhywZzgClP9V8UJ6KoKfUFJZnDABiT+vpaOrJ8/hqcbTqJuNCP6s
Qs6yTfYIflq5OesLdg2HionBrT8mItxT4lh7uiUrz+Ga6mOJk5vUHC6q+96r
TkP4B8aH+fei/cGjXikIvmsok4RpAhK/9dWzS9GI8ITxYeEN48Pio3jnwYD+
+DwHxVlXtA88U3Vwte0zSEtCxOebBdtl8/vyHN7ciUzYUqsClxc1Kbc7q6wM
1/9kZ3KYCL8y3HyNicbMpz8owfmw9Abjw9IjzP2w9ArzH4zfvWzz5M5UBH/X
p39PRNKB9n/syZkrqgQPv1fXjhk72ynBw1do+qWX68VV4OG/RdInw/yqApxv
57HKa9tuBP/W5SMfjfIVHK5GXvq2Bhi/iU0p3guMFBw8RRVSz09B8GHpBZ0/
805z9snlCvD0o/36beuOdwoO6PkfAC0i3tI=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1GtQjGEUB/B2E7LK1iRG2fsNE2UprbY5RazSiql1KZeaWdvWtk+oWVGI
TDelNlLDlNs0SnLJbWKLlVq5TlSb2+6klmGQTEw05f3ifRo+/D/8vpyZc85z
HnYcWqO0t7OzoxAJI0Ilwv127Fa0FkGos7mjN5ULayhBbbGpCKpOX/7xM5YL
ifQg79OHESSbIjZbp2DfTyuRvK5gk27tNLcll7PAsuPWgCYLgXNaQ7VfORPi
TwR47EzE3mrMq6uIwE5HM73oIQiCJ5qORfSzoMTqpB4ORNDsKa9ZfpYD4ZtT
GJMI01/MOqy1caA7zeO4QYoA5FKd8DcH7mrN1/dJsFfW58k2+f7vy03FfSu6
sL/6ur07tRv7YGhM680rTNIF7zO8hsZhJ7cJJgUaGFATstSHIhlj8QX7qsXY
Ez4eWT5KeHjnktQnLQwouW1xWhaMwMk/uq8umwnKdayOT4Sl9drHqhPYCvq5
MzkXmZAR4jrdJkMg/mDJXbCIBc2+3wdHFLh+aUBF6Vol9mrVF7aLBpuvE49Y
i7CjxC09+koE1udB9oprLNL5nFHhBgGHtHtKJ1WxkAvW+hk3Bo8iUCcWGkRP
Cb/hP2LqEWgfvtJkT+YB/401qigbQfi2S/qPF3nwtjs+1HM3gjplV1xMNw/i
s0zi6iQE+8NcZlOpfGAbBhIaoon9Rj47Uybhg1/nlN/yZcR8abU5TenYM6Su
eROrBKR7HTRxMeuF4MiQlJ2UI0j4OVgwNFsEdQtDw/0TsAPa2svyCrAj39fW
cIj3uM3lycbMjQLSZmN2kq2RD6ZHDnMR4fm6dlVtER8iH0Q7WovH+N6eVRo9
9oOsah219H+fk6Uc9KrBDvBLalHTBKRV01SqWrqI9DuZYsEhFfb2LkqLOl8E
Bzyy3Cx6bOfgvnG7isdYZmz8XIRt6k2bGkj0q9FddafJiX4dRsKUhxCYaIV+
DIkI9mf6aApzEbDvmH16aSIovx3DVOcgMJ6HnKZhIQwOM91F6bge91MD5YMW
mzbgHDY+Abt/e+vqymDsv/cg3WBrtImFpE19uT6/3ASkRz2911fF8qH/jp1x
L3EPzT2Zrt7tPPD9cqBn5lIE7ZZ+4dNYHmQ4JndsIfZ7KW5l1LXXXGB/fum/
bi0xvznzhioNXPj3f/oDegsBkw==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0,
      1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGAQA2IQXdKdK7D1Qb5D2CzLk79jNRyceOcu+7El30F5QXqE
oRqCv4hP+86nieoOz1pqf545juDrfKkXSzmV7/Ds6a+OlcUIfjef+bS0SjU4
/5LZ4u5PMopw/vKbnxoyzBUcOs9N3Vp8HMFvX7bqxs7NmHwTYxCQd4i6Y+ux
YS+C78K6YIvIWQR/57RHvLxXEXyY/2B8/Un9DjteIfiXk5PLQ75i8mH2uype
lH3+EMGHmSe3esq8lwEIfs99kTAtCUUH9PAEAFU2mTs=
     "], {{255.02210256, 
     13.849190475000002`}, {255.02210256, 14.166749625000001`}, {
     254.7870465225, 14.375342400000001`}, {254.52397056, 
     14.375342400000001`}, {254.2328746725, 14.375342400000001`}, {
     254.02583856, 14.107596450000003`}, {254.02583856, 
     13.849190475000002`}, {254.02583856, 13.579887862500001`}, {
     254.2328746725, 13.321481887500003`}, {254.52397056, 
     13.321481887500003`}, {254.7870465225, 13.321481887500003`}, {
     255.02210256, 13.530074662500002`}, {255.02210256, 
     13.849190475000002`}}}], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIzIGYCYmbWhWniwgUOLttXJMwrUXOA8S+ZLe7+JKMI
5y+/+akhw1zBYdndxOJ4QQR/b51V3Us2TL6JMQjIO3jeCrgdy4Pgv3Frv9Yk
guAbzxPl8ZZE8L2kNsx/Jovgv5u0gO+zChL/5psV6lqYfJj9MuoeYq/lEfzl
F6Y/tpfD5LtpbGtSA/oPxk879zKD+7AKnG9adaut7LKaQ5LfuxpRzQIHjsP5
P/+9V3eY5OD26oYRgs9+4KNomQ2CXy22yEPRrsDBz/zJr0t31eD8VR2XPbft
VoXzYfbD+DD3wcyD8U15fZstjTD5MP+/P+YaP8UcwZfzU76eY4/gr9r6efkJ
ZwS/ZpW4+T93BP8Wz8sA5gAEf83XoJzAUEw+zP7aj8kXjXwRfPlHM456emLy
8w7tNcq/gOBft7e7rjtfBc7/U9/N0hmqBuenTZG9+PmDmoPZkQcbprgUOOzO
TtkkvFTdYbKo9s4ypwKHKYU9Kf0/1R3MhKQUS20LHMJmWZ78HavhYFr0at8G
EwT/3f2TSbM1Efy3usyXq5UKHP45mcSfalOHx+82jb/nDgSowfkw9bD0q7wg
PcJQDcFfxKd959NEdQfPeetm3BBE8GH5Q6Sh3ks0D8GH5ScA0AheIg==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
     3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {
     1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, {CompressedData["
1:eJxTTMoPSmViYGDQB2IQLRd8SY7rQIGDy8eSH1vdVBxg/PaLSfdbUtQdvC+I
RmdvLHAIm2V58neshgOry6UdJ5ci+FeCutLtJiD4BgX68vXVBQ5LT2z9I92u
Cuc3LPWbfWanEpz/5LP+O+2HCg5Li06qX2spcCg4pcZlt1fOwSimYufmKQi+
l3z88+Z5CP613U9Udq4scDiZ2G3xY6m8w4Hu5JO9WwscFu3pX2zJoehQldnF
MH97gUOx7v9jzt/lHW68XLP72R6EfrOrnjmSRxD8Q/0K3hPPIPjmhxYptV0s
cFhj6WBwvEQBzg9j3bJP6BiC/3RyfMCHlwoOHx04b0y+UODgvOL7T5GfCg7y
GtvfLj+PxDcpTOw/h+DXFKvYiJ1D6L+56brY3LMI82umB00/c6rAga9y10rz
mfIOZif7fxgeRfB9q9+L3D+C4MPiC51/fdoHq8AoRTg/zGPeBKcrCH7Z0802
/PZKcH7for0bsj2VHA6yp16YfbDAYTITd8KpNiWH2ugNIe5A/3Hfsl+1576K
Q615088JlwscvjNFdMrpq8P5tlHP9j0zRvDDxD8YOdupOxw+cnV7FpA//53N
R5k0dYfUudOObLqI4B96wSyseAGT73BrifuPMHWH1U5xWdHA8KwLVHcN+K3m
4Kd+81UXML4mZf80l9ul6mC2UVow+XiBw7M7d/wmmiPSr1bhIU0JbmUH9PQN
APKfTtw=
     "], CompressedData["
1:eJxTTMoPSmViYGAQBmIQXdV+e+HDLQUOFtruue09ig4rqoPdRZcXOOwyW++a
xqLgsPx/oAP77AIHvspdK81nyjtI6bJXHZiC4O+NvLchphvBv2ytNmd5W4HD
ppm991U3KcD5T655Kin8UITzN89X4Jn+UcnhSp/OqsNdBQ52VwSl28VVHZb9
all0ur/AQS3qU0WUtJqD9KQlW82nFzj8f5R8sK9f3WGCLFfonvkFDhyH83/+
e6/uULnp2yXnpQg+zD/ofBeT+FNPQ1Th/C83vVMMjivD+VqFhzQluBH8LTFm
VumPFR3QwwcAvROPbQ==
     "]}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4vN9XEH/fxU4+E7I4Qxxk3eA8Z04TkwP+KDg
UFRv7yb2vcCBV7DRRHerooNIxwvFPx8Q/D+C2h5XXiP42oK+rttfFDh4cLiu
LDZD8Gfeac4+uVwBzjfkCEx+LqsA129iDALyDh0f9JuYPiL4C7qktz/4hOAX
Td+s+/RLgcNU9SjmpTHyDqI+bvfLvhU4nF746k/DdnmHHTyTWT4A+b+l/z2x
PCMPd3/7KamAU1flHXQ+vW63QeJHnb2vmYnEF3Xoye7/jtAP49/4p7kh2g7B
t+FSNOwOl3HofFLKJw1039Qf5oczfks6FObtMPn8psBhYiiD0631Eg4i7pWO
1kD/OdWZFd11RPCFWJS7VHQR/NDbn8xu8yH4/rdLVXecEHfQfiv3igFoHhuL
Zvq9BeIO239zfz6DxBdR9n7W8g7Bh8Vfb7RYrMZKKQf0+AUArOTPzA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCsQ+1C80MK3Q4sqxF7MQiUQcYv+H8lkzBgwj+
Bs8TgaeuijrESq6/8i640GHFmmWvO5vFHIrnukXlORQ6RLnEKQR1SDuIzTI9
lGNd6FD3aKlDd4cinL+/yST54hQVOH/NuaNWG3g0HFy3zXCJcix04OPJ4jzc
rO2w22eFdV9IocPCBvN3cYx6cPuXPWiZu9cOwd83t09QyhPBl9mkttsuAsFf
7XDJR6ZGz2FxX9/qn6GFDlyhWd8cuvUcXi5Zy8CIxHf7IOWfH4zgu/b06hu4
Au2bO+t0r4Guw4XOz2o3ge79k324aOoKLQfRd95vDhgXOpzNvv2splzDofO1
RPgdw0KHCJFU1TmOanA+zL8wfr6G4l9pdmWH6Or5q2YB9TfKV33PmavgUOzl
4BNkU+jwQvRLc/wuGYdF+9umnQfa/3lZzqIHl8Xh7nuV8Hf+YRtRuPthfJj/
YHx4eHXqfuaJRvBh8QsAORXUmg==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1HtUE1QYAPAFhBSJQTzmGOA2tiFogWgUKX4aIkJDRhzAKFBgQAtlF5E3
gjySEJG3jvGWoDnGIzEs4dCJQdkB0wA7AguYiWAZjQBBQLr/tOupP74/fvfc
+33nfPe7lxES7SPQplAoL+Dwx6GFI+uaQ1yRDAG7cswjdysXJqdtlQ5NCDpk
boJEEfFPkd73hpOIg56sCK9WEeuFVgf2LGFTqhWUKwhYNREBDhwb4DaEC6WN
xFnqwetmDcSbrGfp5ZcRhMc7vTi9wQY4Kj3563UItLV9msJucOHL1ZatqloE
eQ6t+fdruZC5PW6logZBmtqv0ViHC5ynKSVr1Qi6Iu/VR33BAY6uk96DKoTX
GaOW1thG6uT+SgQeO8dG9SRs8F2uKpyoQDAZLB3kGLKhLb2ZOVSKYMS0pSck
lQG+vGs3dmLH1d0UjtszQMwU2CfnIzBI/EbqJLaChYE6OjuLOH330Z5tKcQs
E8bt2CQEE45GtYVNWzS+UiEZlUYyNKbxR8xXfZjQ17W80SoVwa47eY/E+Sw4
Ez83k5iBYKp7MSPbiw1CueXUGq7nW9JQkWvJge8nzHiV2QiMKwWmDH/ikKH1
zCOdxP/2q89UOdycjsCv/O2bKx/ZgFIctncxgViuvPOBq5C49LjauSAMwXn9
ppzuFLbGMbfun+MfJs62q/E+TGeDN3/BziScWPGmV8ux5/x3hpjyOIJYvnBg
/2uRCCqnpQoZB593rM/9Gdut3eL9J/Fs6P1TvTQfhQBG6g8u+XGBOeVusekk
nq+e6OVns1xoVvD89yQQz3+3pDiVSOy8Y2XylZT/u90uZyyCRxxqHOyuGuDA
/Fcu/Hx8H/2fN54uOcQBZfHZ7AycT9ErcbOeYUNzvLV2Ka7v49UuKxhgQVm4
juA3EQJ59eWnJ2VMjReL72Yd6WRo/EzSedxz1gr4fxnH1OL8oh85L7t0WUKL
2zZqdyZxq47cvO8zYjE9J27DBQTer9oVCT62gjZzw4cfFiPoLludV+zbAuMG
iaKAQgRinSC6Z5Il7FYOSdLx/rOMgauPC+iw0fXo4ns4n4mHSbLlaRoIbe1f
csXzkLX0bf66zWZgjQceDE3D83moVanSpQJre2nHuwnEF+Xe69Q44t67qYac
aOKysj8cM/D9uB8b6Jiv2gxp/VR73WjiSD3m1JqIWL/jF6U57t+ZQLqzik4D
/o6SE+WxCG7NfXrAL5EG+qaXgq1wvabr/a5RWuYaa92OeWT8A3HhZISRTN8C
mHNahYsIwdxwvoq+ywIiDdarkYh4zCL0rekoYsZkctognr+Ah9SCrvN0jU1z
Y/c2XqBpnLDU98nXFVRols+caziBYL+E7jJjawYXS8fMPBKIf1U7/c7LIW57
4BnkeQm/Z4+ivH0KGuzh0d9oxP+LVHEqz+4dK/jv//oP1xtqgw==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4jRlxduHGYsczti7bHkupOJwy//YDxf2IgfT
iz2vZvYpO/jXZIsd4ylyiOB2f93MquzAtblUNF0IKN+3SCKrQclh7RPJV3Yi
RQ5Sgbek/wQB+cdOePwRK3I4P/Of2VUBJQfLoOMlfBII/rRv4t08Ugj+Ol7R
xwYyRQ5Xfno/M/ZD8OuO7i+pn4/gB6/+aa16QsnhqFPynenSRQ4Ofrbl6r+B
9mmntRRLFjmcu/OCg1Ve2aHW4febaOYih2Wtp7XeVKg41F9O2M8AlK/VW+dz
+ZKqQ73Ljrx4oP1rVxw06XmuCjc/6+LH9qusanC+yNxUMcVwBH9vxs0lOSvU
4O4/dEIt5PRTNbj/YPyAdtG8UnEk+Yf5R9cDw6OmcIYc80M1hyNd+yexiBY5
LO+OC4/doeYAC/+G00ELP9xTgbt/zbmjVht4NBzMNy/XawLyf7QulL/upwGX
N3hwwJ7hCFD+7ibnNf8L4XwOKeNOv79I/PU7Jif/LnR4qvE06mYjgj+rkLNs
kz2Cn1ZuzvqCXcNhiobCJKl/hXD3TGIw3ZrwqtDhmupjiZOb1BwOfp5jF/Oi
EO4fGB/m3wP/wzY5P0fwq7rKb1s8ReIven2I/XEhPDxhfFh4w/iw+Jhkc/37
0yeFDoqzrmgfeKbqUF23Nz3wWSE8Pv0Mgu6F/il0eHMnMmFLrQpcXtSk3O6s
sjJc/5OdyWEi/Mpw8zUmGjOf/qAE58PSG4wPS48w98PSK8x/ML6ccYDkYyS+
6c2vB1cAw0P0Y0/OXFElePi9unbM2NlOCR6+QtMvvVwvrgIP/y2SPhnmVxXg
fDuPVV7bdiP4ty4f+WiUr+BwqOf+qRJg/CY2pXgvMFJwqM1iY2r7j+DD0gs6
f+ad5uyTyxXg6Uf79dvWHe8UHNDzPwBJiNRB
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4vYpGxou+xc5nLF32fJcSMXh94HQeSGhRQ6m
F3tezexTdih4+2v31agihwhu99fNrMoO2iqsu8sSgPJ9iySyGpQczoWu7PdL
KnKQCrwl/ScIyDePeMedWuRwfuY/s6sCSg5Rh8Ok5NIQ/O3pyw1kMhD883VL
Ohyyihyu/PR+ZuyH4Ncd3V9SPx/BD17901r1hJLDs82fGpdnFjk4+NmWq/8G
2jfnq2ZzepHDuTsvOFjllR3mbeyalB1Y5LCs9bTWmwoVhwUuH1IEgPK1eut8
Ll9SdViw1V0kH2j/2hUHTXqeq8LNz7r4sf0qqxqcLzI3VUwxHMHfm3FzSc4K
Nbj7D51QCzn9VA3uPxi/8McS4dZUJPmg/1n7U4ocagpnyDE/VHN4+tvPQiS5
yGF5d1x47A41B1j4N5wOWvjhngrc/WvOHbXawKPhEKFifmUikP+jdaH8dT8N
uLzBgwP2DEeA8n5OL3f7Ivia3Yf04ryR+AoelsWeRQ5PNZ5G3WxE8GcVcpZt
skfw08rNWV+wazhsnbneXMsH4Z7NhUeiCiyKHK6pPpY4uUnN4VGKzpNsM4R/
YHyYfx8WPAsPNkXwZ/9ma/QwRuILV2eIGyLCE8aHhTeMD4uPzWvT5n41KnJQ
nHVF+8AzVYc57314E00Q8Zm/8GFzqleRw5s7kQlbalXg8qIm5XZnlZXh+p/s
TA4T4VeGm68x0Zj59AclOB+W3mB8WHqEuR+WXmH+g/Htl9zf9wmJH+bVmr4D
GB6iH3ty5ooqwcPv1bVjxs52SvDwFZp+6eV6cRV4+G+R9Mkwv6oA59t5rPLa
thvBv3X5yEejfAWHx3/zClqA8ZvYlOK9wEjBYd7tqcun+iL4sPSCzp95pzn7
5HIFePrRfv22dcc7BQf0/A8ADPPGvQ==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsqrEBLWICow==
    "], CompressedData["
1:eJxd1GswnFcYB3ChrctONcG0k4i1+65db0npKJuQMk9MNYnroMmU1rjEsk1m
XA6KXdYlu2lYIaW7FZdt1CVqEYRWxiVWTRCSNhMiDcmoRhKjwYYi3aqeT3tM
PzwffjNn5jz//3thxySGCIwMDAx24fkUjyEepqjq2jvZCPY6RXNyHNjAH3d0
KZAhMHI1MIsNpkBrvlK3pxDBJ37vqhZ+pUDt83dtRwmCaHm+rDuBo/eVud09
uSkcMFW6Xvz8EoLJyKtts1I7GBr3KtlSIUgqlg6PeHKhVZfdNdmC4HQno3d0
vz0Iff+p9GlHoAy2ls9Y0nrfHHNKUdDEJyvcR3URNKwlRRTNXiVmcPoaL+y0
c/r+tFZiYYLDhg7f5/XI+cR3oTQEj0gD+dhrgmuuuzg0zFhYVXzViGCETjVy
4NjDDN/7L896BKesIo/N3eZBi+EZeV4NsWmcv6a/mvjlWFTRbCWC9cHNIYWN
PRxKpl0KcP4DngX9yRn2wPpjPalUiYC/xbFxXrWHbA/mB8/LyH6CoaiwgWJi
zb8fKxlniWMtm+YfiBE8n0sUG6bz9C5nNKhfNyWmPF4rli5zwXhi3SwkC0Hc
ngmPw3e5IG5R7Pspmzh2WVxI5RA/mJh4MxFbqI2JPr/IBQ2VptVgt9G5fdVm
PPitraGjOx/BNDfK4c9NHgTynctH5cQm1ew4kws7nLlqFnKRmGXMHT+G8wZ8
21luPskDxUjQ2mPcR0a76K6wmQfNLqHhtrhPK09FxnwkD8zCSwOmVMTsGdPK
p98Tx9dvV/rg873zJead57nwsHpbyMX3WRw09E9l2cHgW3euOOF91jLFN9d+
4UBWWM5KDH6fd6eGaV2WKQiQyAP52F7mjztUC5S+j4jzorglRwr8u6JWc1IR
qKpquk/NsGAgzFfJSESQW+glYkps9RYVaoS6g8ThL9S9TreZsFSveKZMIp5a
dRtb2OGvw+lLNCIWNY5kibFTfOdLg2aZ4K/ZFx+fgiDrFus96XFbcFssWjZK
R+DvszfqhB8Lmi5v1Xbg502fcd5qGGNB2eHh6ZZc4iyBe6yvlLipXdo1ifO2
hTlZV19mgYkmSNNfgOCoTGfR8zYL1F/Q28IiBOz7Xya4xdmCiaxF4l5C9vt5
OFmrKSM2c2iSuNcSM44uGn3UjOBVikDdcJ+tt7XWVDLwGaV36aC68kgaBa2W
L6vq1AhMvgm4PlhMwWrz9h1BE3HOvagbBj8QK2UD0y34+1xSPsl9hPD5oZQf
XbFLvF9YvB9CgcToeLGqDkHP9c1pph0bDgkS+msqSH7WctuTTAXxQ5k872Qp
cfbpNwzP4bxJhjYbG7+zQLsu7vPGfTy912+VqcP91d86snQOQd2HgQf8HNmw
4lv6TIn7Tfd+NV7rzobYKePa0DxicUH8DYMdNu7N55yVEP//f/sfWnB6jQ==

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4m0y80RkXhY57G8ySb44RcUBxue/636yTUnN
4UmP+MHY50UOf5++O2fao+FwZm+Z/LJ7RQ5dv/JYis9oOcz1MLiqcbXIgXWT
Uekme12Hn+JzZDqPFzlwhWZ9c+jWcwhL5sz+fhTBn12pceDfEQTfzk0/Mh7I
v3UrjK+jDMGX2aS22y4Cwd83t09QyhPBX/agZe5eO6D5VxKkwoD2PQlnny36
WNfh8eE3qcuvFTm8CPxYf/yltoNmXuPK7vtFDq86jLgs9mvA+TD/wvh7IjXs
HusoOmw5cirjyM0ih9yFUk/9Q6UdWnbzGWQdK3LYzZm8oT1ADG7/Bs8Tgaeu
isL5Dee3ZAoeRPCPLGsRO7EIwfcKVSkwTROF+/9Vwt/5h21E4eED48PCD8b/
Va1pcwIYvhvOz/mq+UncIb/usIs80L2sxt7LpZhkHbSksuvNgfGzaWbvfdVN
CvD4U//IvJDthZIDevwCAF7U204=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYCYmHGGTW1DsUOZ+xdtjwXUnFo17Wd9c+12MH0
Ys+rmX3KDn8iH22v9y52iOB2f93MquywfcKbbQqBQPm+RRJZDUoOUYcmdP8I
KnaQCrwl/ScIyF9i/2praLHD+Zn/zK4KKDk807cTOxGG4Dtf6dM5FoHgR7/u
bnkVVexw5af3M2M/BL/u6P6S+vkIfvDqn9aqJ5QcihRu1QYC+Q5+tuXqv4H2
cd5V1QWad+7OCw5WeWUHLbmiPlGnYodlrae13lSoOOhsvJ6wK7zYoVZvnc/l
S6oOOkr6ApKRxQ5rVxw06XmuCjc/6+LH9qusanC+yNxUMcVwBH9vxs0lOSvU
4O4/dEIt5PRTNbj/YPy/KT38+kj8Z/uepWUCw6OmcIYc80M1h8IMM5N9wcUO
y7vjwmN3qDnAwr/hdNDCD/dU4O5fc+6o1QYeDYcnE+QuWAP5P1oXyl/304DL
Gzw4YM9wBCi/S/Npqh2Cv/X7Si0OGyR+j76prFWxw1ONp1E3GxH8WYWcZZvs
Efy0cnPWF+waDo5s042v2CDcY39vdZiUZrHDNdXHEic3qTnkXRR+IKqO8A+M
D/Nv7t2zwX9VEXz1jHc1n5SR+A1JKQcVEeEJ48PCG8aHxYe9lN/M+UD9irOu
aB94puqgEWPCya2KiM/fvCfr+a2LHd7ciUzYUqsClxc1Kbc7q6wM1/9kZ3KY
CL8y3HyNicbMpz8owfmw9Abjw9IjzP2w9ArzH4x/WuD4rjlqCP6jbTnJScDw
EP3YkzNXVAkefq+uHTN2tlOCh6/Q9Esv14urwMN/i6RPhvlVBTjfzmOV17bd
CP6ty0c+GuUrOORnheXoAfUnNqV4LzBScNDyqF1sb4fgw9ILOn/mnebsk8sV
4OlH+/Xb1h3vFBzQ8z8A1nG6Hw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIlIGYC4gVJjmyvTxc7rAsR/2DELOQA4/N52h1YoiPk
sENkodIMIF9jWfm0o/ZCDuePMdi7Avl/Xjf+XhYv5KB98d+aT4eLHTbN4nyo
EyLiUBC8Qlh2J1B/RQLDw15xB62J819kbip2aJK+f5aTT84hYtq8+QfWFTu8
WHvaau11BYffrwvO+60tdhDR+2q75akSnB/CfZt15wEVOD9gl93ex/80HbSi
b8VHbC922Lad4eaEVboOzjuEzSpPFTuotul9slE0gLt/85JJHz6bI/j2zdO1
lGwR/NOJc1ICnBB8J2O7povRBg5Fk9lvLD2F4C/4fkyAAYn/9/T/r7OPI/hO
Zqal3/cVO3yd8mzB1FZ9B5EPx+7e31PsMFGB0UPIUt8hYp1Qe/+aYocl4lFO
yed1HMIVqoLUFhU75E1ZzZdvoQnnz0rKtG48qgLn9+xZ08n6UdGh7WLSfY1l
wPCQ/u748Y60w7nvPzSldxc7pKlJnDNVEHWIrJWasxNoX0xabX7FUhGHZ4uy
C2SA7rvCN6FSb64g3P0wPsx/cHmo/9H5sPQAAEGy8cc=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H9Qk2UcAHBgUUvYGEXHQGDvO3i3AXd5hF3UCXypQ6doF4sNKClyh2KT
X71vXC5DGKJdXJzJYYEn4kIETRMYBgXIzyGSnuAUBAaDBukRoSCDQQc9//Q+
XH98//jc83y/97zf5/s+5L4MRQrHwcHBEYUKhRMKpbOhdfgFBkz6Up2gmAKp
3/M1Ri4DS6IIZZBQAgL5FyFqVwa4nRn2tTkp2Cs6DqV4YrvvSH0lWIgt230n
8tlm7EBZhTVcxICTWryrog6tJ3xdP+LNgLAi7fWZUimo4i9da0X18vqnbn/i
h10Vs37KVCVhfe6yQjQbLwFDzuMfs70YeGuJ5zRhp+A4zQv9yRcbOgq9fEjs
wCRlrKeEgdvRg5YEhYR1QNJXxx2FUtaj1TVtlUIZFPwz1PvQhwFV2Zu9q0ky
iLwsfbfAE1vVEs9N52Mr7fZdC6hfUVpTTfPHUui1GRv4qJ/z+k3DN55KYDnH
sFPEYeCHkEu1ga/KQNNl/vTiCs3mb/Ma+F5ow3bNeGBpn8I2L9SN3h2lYX8t
5+z6Q4p1U/d5/7G92OCRNe4WSEFudXTRvjHsg7aprIYN9k8ainw2jm30pVLS
LDQk9GvfPxRKwc+abnkb8qN15Q5+MgWLzdldHtM0fDDIyzV/JgWeNjcs6wnN
3m9cX4ihexFbk6j+vHkZ21LALQ5fo+FkbbrnYhf2ZnPUX79flbC2HeUvpLhJ
INy8RVm8SoNoMLg/pyGArQ8a/3dCrSRoSpwboxbQ/mvN76VcIMCWmlzWNksD
//CvNW+UioCn9kkbnsbumdCJH01hj/0iKIuZxDaPRCw6on5UNj13+pQLAUZd
R4UVrXsXVtW/TBFoLuFEHKrn7zK5R16EvcVlNLPIm2Sd27H1wJCeZPN7S/Oo
ulskuMq+2f6tZYNHkuetI9hX+0qmVwdpuK/6LvumHJuayWRKqgnWY2tV7TnH
0HkV9EcmdN7MW5JNES1+oHiSEWyYxtZcOXxO8BSbsuaX16L5styL4qgaCLhZ
ebczaIkG97+P7bk3QEDcRU6im52GEG6s+k9fAvK3Kxuvr+F8pa57gkDz/Z/7
mjziY4XYK1vDPnwb/W8v9Zfn9TwmWcf0zXIaDohZdx7xk+efEYP7QuzMAxF2
+mvOxqQNXknYf33Zd8N+F+PABWSR+3Lq6RNikLVQcwrkk7rdg41qMfv+aMfP
ku3RBAi2tbZ8yWPY+60Lu0JpudiWIf75RCfsJf1k5f11Gl5M31lffpBgrd97
w3lNQLIm0sPtQToSwgOOzPU4oO/NuvNH4TwJZ2J+mzyK6ukKzO1eJjH8/z39
F+Wmcao=
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYu71KpXrJpY4PLVZ++aMnopD8y6PhS57kfiL
ruws3Y/gzzZgq845hMnf32SSfHEKgj/zxO6bV38h9MP5UPNhfJj96Hy7xcl7
2xu14PwLG89eLzuB4Ps0v2GT1tB2uFNSEFrXh+Cvs9pj6NeNyYfph/Fh5sP4
MPur97w+PjEeiX8lfn1CLIKf4qb3LjMKkw/zP4wPCx+Yfjgfaj6MD7Mfnc9t
fGKHrYcsnP9C9Etz/C4ZOP966B3h+p/ScP/D+LDwQefD9MP4MPPR4x8AaN79
CQ==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H1MU1cUAPBCWQYSCp0ILSJ9r+W9AuI2A8ikRQ4bbGzqpt0sukim40sy
LR/jCWs2gQo1DEcQGVAGDjrXgGZoJSSTIFo/gLa6pFJWh4DANLNjyvxCigx2
/9m7ZH+cP36595x37r3vXvLTXEUml8PhuKFQonBHQUuKv5mhGLDrdRq/4xTM
ySxFt2kGnos27YgQ0DCZKecURzDgeSXXtTgjBUufVqaOwZ7KiLybsAHblVPL
84rDnk/O6FLEM+CeLn6v9RwaZ7Zo/n6DAUHrgZhpnRSkjKpkCNUrs927sTcE
27B5qdZuoFl/f1ohepBKQ0XzTwVVsQzEPfdxn3RRkHrM5maSYfMnPrj/egL2
vFpIRCYxcCPZMbFTQbMOTftK6yaQsh5t77h0UhAGyqCWxoeof2XTRvOLtDDw
M08HN8VgS2+vdmgisenAPqGnlIFEtb2j9xMpNPlXlUvQfj7Wrxi5+IgGc3Ox
IJpkoHH9KWP4q2Egn2rb2CvA+T6x9Vnr/LHHjjad+ZWL3ckvOn1vvhCyjNyW
pd8o1uevtUnGd2ODf/4d33AKtvd7pRUtYMf5nwLLMj9VN/O8FrEbZM4oDfJO
m/rD/VEUlFZWBg4j31/a8Q5vDwX9I3HHwz0Y+NjhUzpWIIXxhqSXtTx8vpTz
mWZkJba8SJpkC8A2/nB9ryKYgRqjKvDZVezVY4l/Xe+kWc+W8J5k+tLAe/FE
0i5kQORYazvUHcrWh88kb0XdJUHeZdYq+Wj+2d5tmT8SMKANzRn2ZoD3RU9H
rE4E46UTshkP7Maltx8tcLHPDNv37eFgd7rcrwb8Uwgnz3vU13oT0NCqzXWh
8aAqQ9dKigDFjIcyB9WTeE9tTanGfs17NK86iGRdejk6+5aeZPPNujLqnIWE
seT3V+nRfrKeCzW5XNglzl3dfrOFMKw8dnAwBZuaziv8tp1gPb5oMB0qR/3m
xa5zon7zLPSKTRdCQMKLnh9E3//Pcmu8ivLFnnVLOdCP/q+JoUSuspsA3eW6
2oRVDPAflm8dukkAdW1AGhrIwHrP7el/rCHgowzhEWswzqdbK8/G0NjNjltU
1gZsq2IhPBXdt1dsJ8oGnCTrzdYH3O5sMesrX4akHP5ODFN+AT3T8dgJ28x1
BctsPRhR4SNfNj/s67YedL9F/Ll99UfE4BpxXshGrtFscfycLmbfH/WdFtKU
TMDkLs3RmrX4fA8r859W09jG2Zu5KgJ78JLh8z/XMOClerfrRA7BWr/74kuL
fiRrQhXvitCQwHsT+kZD0Hrzf/m96jEJ+3NKjHWonqZizCS0i+H/7+m/P2hZ
zQ==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1HtMU2cUAPDyMioknalIdCSMAnpZzeVGoxEM86Awx+iUFZAiT7WlOsR6
gY+HWAoDJ5amCkwUVmAUBYr4wBeC/qERpBItvlI2HzCnWdRpVUCokaA3S8oh
80vOH79/zvnOycnx3qyUyJ14PJ4DF3FcOHIhuc6LNBYSKPuwX9y/hIHb7LLT
6UUEJgJd3renMhClHelo5tw6KjBPpjEwtsG3iV9C4Jb+nX+9koHhpzWONZyl
J4WNESwD2wIMr5SlaM3QXEutBp3TzoRGlKOtK8J6hb+iXXNotwdVBCzlPrVz
tjBwLObiwr7fCDzOVxePhTMwMf7XuY+cSy+XQ/w8tGK08bGsLWDKyQXN13dn
os+oTPF0WACo1rdFreRsyQq+LS+jYfHxX7pdOGd3e38plaEXBqbENgI9Vb8g
U/3ORNNgYFuGBvXo3sojaT/Xob8/sZm9xLn87sDIwXU03DB9lTPG+dr6J4Nu
pTSkeZuuPGsg0JH8TVzcYWbKbeTvjKx2Bt6+8HSq+R3t/ajf2FCHZkvcZEnx
6JhvfbyapOg7Ivn87dMcXcx0NMcSuDcwskygZWAe/3VndySBi/K9tkUNNLwK
Thg2chb28PY1VdCwoCg3MYgzX96i+TMDnVrfS31MQZsnoVMl4frxqXupjMT+
D4TV5AokaFnPTlIUhT6nqHLuiML5zl61oj4lmoDGd9d8vxIafvBzgs6NBE49
DwlhkxlYHSP2i0nC/Vje88QwvAMtuuD1RpuJJhMeM+9lo2tvtvZbs3Ff7bbn
t5samGvqTkRHZ/keGohmoO+L3iA1Z6v5fnpsEAPjkYaj/K0Eiq+6CoWL/IGa
8d1ZdwUBm0fIlhlHKFAtGP/nciqBFq26/sdCCsLP5OnXxKONh4aeS2LR98V7
bNINn7vrUmCCiEILUqSTN7woEL1u3avjzPvvUVC0b5VmuRRtr2d35Th7VpOE
1laHBus3ofes9Lh2XIY2q/mDowp0lTH8jUMaen+EZ55gB7pNbPPrY9FHrX0n
HmShQ9dmvL+Zg9aV/TTHPR+dlNB6x7UA7WJhJ15M89e29FJd4ec2e1ZstK1F
2+fnIHsmJWq0bl1inmA3ukqpkvJ2oe3/s1u8teKPLoKmFedFzhkEnB1rw//V
YL96g0/n9mq0W271prtXp81DF5xvfYgWD/KWBjylQD3rYVcgl2+mc1Clxd0f
/n9/PwFVPVQ2
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJVIGYCYn4J05WbHpU6hHDfZt15QMUBxk/aOH27yVR1
hwdpPjIb7pU6uDzwWHBwurbDDIdtF/eeLHXYFWURJf9Nz4Fn95R4+ROlDgd2
tXLWGes7NEx17t6zt9TBydiu6WK0gcNRhxevbuxC8K2Mfj/kQeIfvZr79e2O
UoetIZYei8MQ/NOJc1ICnBD8zUsmffhsbuCwTpnvpsPOUoeWWcdmJxoYOHCH
szs8APJDJ/xyO69h4MDD/FG052CpwweTmR/NPPQdVA786nxxutRh23aGmxNW
6TrYLOcXzr9U6qDzICTKtF7LgW+RQIzEtVIH1gMVbL3rNByyfex0uq6XOty0
92duW6AG589KyrRuPKoC57fN91xz7aASXL9O6+znyTsVHGY+O/T268VShzdr
1Fn2dMrC7We4fbCj9qu4Q1BLV0LdoVIHif61hw4eFnFQaph9NB4YHi6Hz+1s
aBeC+5fP0+7AEh0E/945rRuvxRH8dSHiH4yYEXyWzsWJzzcKwsP3Ct+ESr25
gvDwh/Ezc9az2u5F8IPu5mrwHSt1mFK7aW8hj4hDkMcL2Z/HSx12zGr75D9L
xIGva06J5w2g/Jorf9fmSsLTR8PNGUanfRUc0NMPAHTOFBk=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4qw5vu4MpmUOvhNyOEPc5B1gfCeOE9MDPig4
8PY2WYsbljnwCjaa6G5VdFg/VVv8rxaCP10+z/aqKoJ/TG6C1Q6lMgcPDteV
xWYI/sw7zdknlyvA+YYcgcnPZRXg+k2MQUDeQflfUTmzNoJvPSNuzUMdBJ93
6TelZ3plDlPVo5iXxsg7bIjsvFJuUOZweuGrPw3b5R2Cpa79/ADk/5b+98Ty
jDzc/e2npAJOXZV3OP5fr9YWif/1lpJ8FhJ/g+/5hAmGCP0w/o1/mhui7RB8
Gy5Fw+5wGQeVTzuYZYDum/rD/HDGb0kHnprfml/UyhwmhjI43Vov4bA+ZI+Z
DdB/TnVmRXcdEXwhFuUuFV0EP/T2J7PbfAi+/+1S1R0nxB2O/Uq8zwg0j41F
M/3eAnGHIE7/F2eR+OsN+m63aiD4sPjrjRaL1Vgp5YAevwDLSb3h
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{364.21224606249996`, 10.0914072}, {364.34923236249995`, 
    10.0914072}, {364.5344752, 10.0914072}, {364.5344752, 10.29066}, {
    364.5344752, 10.4899128}, {364.34923236249995`, 10.4899128}, {
    364.21224606249996`, 10.4899128}, {358.87912033749996`, 10.4899128}, {
    358.74213403749997`, 10.4899128}, {358.55689119999994`, 10.4899128}, {
    358.55689119999994`, 10.29066}, {358.55689119999994`, 10.0914072}, {
    358.74213403749997`, 10.0914072}, {358.87912033749996`, 10.0914072}, {
    364.21224606249996`, 10.0914072}}}], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1G1Uk2UYB3DcVF5GDGjM8TAGY2wDKdIEMSi5MEXEVBgexCg4gLwJHM30
eQIMXQHRxPGiJ+JdlETcBEM8gEKgTA6GkMbLSWASIwfMkDPeBYSeL+3u5Ifr
w+/Dfd3nvq//ubjhx0SRVD09vTVkHSKLQpaqcjf2Dp8AfvGgr8RRCJ5KEHeQ
rpN5RyYeR/4txu9pbxJyyPzS0VslyAYRpcGtC6Rna2MKeATwLkUHbRY4QFrB
aZOPuciq5+Of/WyDnMBad2+LNQFRhNu6MX0HSO3j+LdbEUCliuRH7grBVPug
M5l05uab0pEyIQxzM0u3YgSc0QZWMNYKIfVl7rY8SwKaYp6Wx18TQOriJ/IU
FgGCRe4Ax570en3bqA0E+LoMDhgU8qFmotY1iUnAcGhlt8CMD/RTirYEOgH9
zOrW8K+5UOPVEdplQgB++eHRoU1cmGcm9zAMCDBJvFPplm8DAffrW355jev8
bBMe3TaLLDZ0O2kyg8OfW8zLcuS2Ol8vKhyojOHqjPn3Wy2L7MC+hl5TP4eD
65NMTb6UB0NxBtK3l3FQN899k7afD+1lLpK8FRwOXrxaJOEIgN/7rnbrKg6M
4kgm9xByeM/qt4cbkf/9L3vadKLPIg6BBR88XPrcATykSSNZU8i030dXlCPI
02H6Q47PcDhPk2c0n+brfKJr5Jz/AeQ0p0t+B9h8qNpFe1w1hGzndCRg6T/2
J6rL04eRaZpgtZx08VilQiYgzwvvOMercPCutQ6YJ/jAG9EvlqpxgP7y3QuB
QjjbH3Lv2t84GLQee7UyKQTjhoilPi2yqM4klj6N/KPALP3q7JuudcoYjN6H
HMEI9VF1CkAkOzgrJOfx6KeKlIt7BOCRUezIJvspHhR624/zwTjevcJ5AgfR
/lpZdicPZj7FDFM0ONwovbL4pcxO57kLfamHG7k6rxQ2JuydtIHqvzYyPcj+
x38VGG1v4sBbHjsag14jm7y63xxKJXSeNy3Bysi8+Zk65UbG2gDdVHhuzpiA
5h+WZxRetvARNYsxZURA/toQ9t4kDhQ80XhihgR8x+28NZHNhrhteIGaQoCF
r0UyJwWDdo73DSWZn9SFFumqgyWIu794sbxA5nPPTaVqPQvEXFmwUos8WxZ1
pWYSmddx4XbzGPKMhPKHFTkfn7DOupkSS1C2OPeUjiG3LbtJ8jTIsbIJ8W1y
fuJgtruKjUG14Lq5y0scuqbSdwUmYhBrVEVtIO+T1z/aGU+x0pny+ISG0Y6c
MxxtLqNZw1k1yzX7BQ5TvVIV29Ua2igWO2kaZHfzxEGxGvlMbw4vgcxb0Cgr
u+k8W2em5KRnRRam81cLbXENRSwwvrz6HpDv2VHI3j6+cQPMfj91d0SL/KF6
X9boGkJnen8Y5bkZAZhvbqaXAoNCr/e7gdwvlYpTmU4eNvD//foP1XFzGg==

    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1HtMU3cUB/AroM7gYwYfM8C0PG813t7x0LWxePBdIROF2ZZCWsCyBIqm
Al6wPC1EXj6AkYHBMYEUxAIaJVpR8QWi0Q4GaWd1DUxkOOYTEXys282Scsz8
JeePzz+/8/uenPw4sXt2KB0JgpjGlpQtB7ZyT63J/T6WgeL3R0J/9qOBiFA/
ksQx8IE//e2ZeBoO7OY9KWPd9NrFaEukwZuvML9TMtBTPc6t2UMD55bJPz+e
AUmrR12ImobK+dYvZQlow7WwmYUqtK5clboqGe3umjs5Zx9aIE0QdqUxYCr1
PD4/jgbL6glxWyYDg5ps7RsRDSssbn/8ybrgainIFqG/e103uEvPm7I8q+F2
RjL6bGa3jNrIA/1XI3k+rE0pwl5lMQVRR66Pv8hgYN9NjqtkF9qHrxDXATXV
Pys5e7yboqA3fOjzO1noN6kD1Uk56PSjP9Y2sC7tM49VfEPB+6aoxkHWXdse
WWcXUHDM0WmsT8vAeXmQVFpJT1mf+vvelDM0LLsnCcg/gA7rcH5QkoP+KX5L
hUiIziPlYaUC9LS5J7aKP7JWqRop4zPQbx4LdCmhYePL5aOtfgy0Kw9O+p6g
wG1ZpWcFa49OolBXRoEo7txhb9bzlI1F9/ei42tukf8o0EYbGDJ3sHmmW9xl
fpi/w9d00uaPLm/Q61SB6CHRL4G1gThfPielJ2QVA0Ve+5d451GQMXOtun4N
A6efBAer5TSoVxfsBMD9UDYs7f8tDB15TMZJ+xZdbw3nd0jQd1uHCYsE99Vu
+/12k+YF3Tej0REpXj+YI2h4+8pBlcD6mdGSJBbQ4ONvNb0TMaC94ezh4csF
8Yj2McF6cnFw3Ix6EvQf/L7Qb2GgsSS7ZnsOCWkVbfcoIfrXdFfXID56Fu8a
d8PXn/riJX7UChLtopDY7i4lIbJ3+EI6a+K/Q8LpRE07R4C297P7+v3mx6mA
btfk7D64Hn3OPXyichP675iQeQMidGdxPudpKPrKSkmTbRv6ARUgbgtH9/fM
GOjaiU7mtiw3SNGXk3TriGj0oaBhxwk5OuBC80qTAi21nDSkx35qo1tZ5ORm
tH1+9CavIkUM+jJd1WSLRnduNxSOytD299mt2WqcpROjo0Wvop6z+ZwcjotG
izBvda2nQVWFnp1WFdN346N5HBZqnj1Eh1oJf94QCS2ji//yimDgMydBuWkh
F/7///4LrThFJw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYunZsivt1pc7+EzI4Qxxk3eA8Z04TkwP+KDg
sK87aG7o6nIHXsFGE92tig4JU35XWC9F8D3k7OYLL0Dwy2UT5nybU+7gweG6
stgMwZ95pzn75HIFON+AIzD5uawCXL8xGMg7XPnjdNNxKYL/Zpoen8JyBH/f
4mMtKivLHaaoRzEvjZF3SIyINNu2qtzh1MJXfxq2yzuwSC6L1ge695f0vyeW
Z+Th7m87JRVw6qq8Q8W/f/eqkfjLbn5qWIHET/SZf+gckn4Y//o/zQ3Rdgi+
NZeiYXe4jMPVDx2pUcuA7vlhfjjjt6TD3qrT3UYLyx0mhDI43Vov4ZAQ3DOj
an65g2OdWdFdRwRfgEW5S0UXwQ+5/cnsNh+C73e7VHXHCXGH8p+Gjg7A8GFl
0Uy/t0DcgZlD3otnIYKfoB9ne2QRgg+Lv55osViNlVIO6PELACo9zJA=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4o2nlwldEa9w8JBelGpxy8QBxp9s5PdilrAp
nH+z845ssoSpQ5PIw9OxIgj+t9QjCWe5KhyEFgrmxNSbOBybW85h8rcczs+Y
lVZg9AOTv15HR/imkYmD1WyXYv/fCP693wd+9bBUwPm8DBumruapcJhrv/0h
YzGCv2jr37Yns/Xg/FWb3nclPNV1yLJPLjAC8pcGLbrNuELXgUdeMFjtXzmc
v06aYbfKT0z+DCHPL0Zcug7H+M5vn/QPwd9wZpseD9A8GP9+qvYVeyEEn+//
/MpiCQT/x572D29UEXyBDWFvo7Qx+TD7N61xDY1UQ/BDej6b+0og+LDwv+FT
4nPmPoKvd+RV/4Y5eg7o8QcAFh/C5A==
    "]], 
   RasterBox[{{0}}, {{382.588, 10.0676}, {387.62800000000004`, 
    10.547600000000001`}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4gUzxVbv0a9w4Hx48ZjgRFaHc4os9me1Efzt
1XHT2IH8fcyfbh/TZHZwkr+48oVmhUPUjct89b7/7UUut0bEalQ4PDhgz8Dy
+I+9yH37My7qFQ5WkwqOXZ372/63olnECxkE3/Hy9sIKSQTfvmNdqMPfcjg/
b/1u/bu8FQ5tmz583foB6J7YZY1BahUOOqvnv23PFHCAubewg+n4+i4hOD9j
it5f71oxOD9nQUiY3h8ph20Pud9tU6xwOG7rszFSRc7hcZ/5z618CH6LKJOI
FNB+GJ9f+86niR/LHSZFnb2vOU0KzmdqXuK/WkUczjf8rsL9+aeIw+a575dr
/UTwH379kjMXia+e+r3T5A+C/9M3cWkTY4XDXadwpYA8UTh/5+rwiRf/iMH5
znvPL3f5Je7wM3uT29F/5Q5bN+aukf8m4aDe7KFd/hPBf9gyd6/dDwQ/d76L
1afvCL6du31pPZCvwRzo2P9GwmEzR9Zc0d/lDmUJ77e8LpN2eNSZFV3FXOGw
du/MR7tfyDg8Xrb6QQsPgt9+Men+BikE/+zkbK4UYHiuC1nNlbFVEs63iqq6
KV0lBucfn78iJyJA2OG3a8rmecD4/rnhbM1eQwEHoaDtm4UFKxxEBN5pTqnj
dsgJkn7m+bncwebAZDE986/2sPBd9I55wq2Kz3D+Q9Zt77+pIviT7yQKz9z5
zl47cbtkCDB9wvjo6RkA73Zavw==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4tOLpRMDcyscHMX+/glyk3eA8W28JwgGfFBw
yJsSEJqRWeHAHuK5TmerooPA3J8GfskI/g81m3C1OARfXS0uhDO6wsHJm1e5
2AzBnyzv8/TEcgU4X9tb8u4zWQW4fo2dh9WMjOUdWlgdJ4YkI/hz5uscM0pF
8PPWHLExT69w6Fz76tviGHkHwcTwdycyKhz2q1d/qN8u77BFcYmwE9C97xf2
3bA4Iw93f3XAaueTV+UdNNj/TutD4oc9+mCxG4kvGDq36iGSfhj/TMuuxVF2
CL7BhI0qXeEyDq0/22RzU4DuqTuxLf23pENu80ln1/gKh9bbE0xvrpdwEIjp
CuiNrXAwYzmeescRwWfr2lyrrIvgeyY2a93iQ/CdE9kkt58Qd1BnMvgZBAyf
X507o+4uEHfYLCDLJB+P4AtYxHy9loDgw+Kv8eGyAPWVUg7o8QsAiwPJog==

    "]], FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
    1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJVIGYCYlbdvLe7LlQ4XEkL+tkrquBQ7nK+XHRrhUPN
8z3ZpU/UHaQErwmUbalwuHP7sfVzXg0Hw8OmuspA/kwWkX4DHQ2HpebmjIKb
EXym8le3p29C8CU1vX64IPGX+q9+cX9DhcMRuVvHu5g1HPT7J9xpXFjhcOlG
HPevFjWHS+mBL0/Or3DQ6V3JeiBMzUHi65Lli4H8Z6bSF74HIvhbd7O/sLNF
8DdZe8brSqk5lGrM43NeUOHQdNC0vIRVzcHd8cMPvYUI/ktGW7kVSPxL/ncZ
fyPx3TVrBBMWVziEL8+3k9JTc+iNufO6cDXQvbfff436qubw1jUyxeRUhcO/
iMfHP0+RcdgXt9pP4XSFwyE508ZaVhmH5Wu8jYqBfLMCCbG3v6UdJmQ7H1U5
i+CzWmokLjqP4FfKNT55B+TPSLF/Fqcq41ApdLyA/WKFQ5wv14zUfTIOlvXC
XHfFKx3Stbs2TZpm4BCounPTIolKh+PrM9/f3WTgwD0j9csJID/rtgGX01YE
X/UI40ymQwi+/cGsi8/vGjgEGBardQHNE0p3vcLy1cDBcnr7x9WiCL7S39l7
zgoj+J+XTPseBeSfnp/PLfbYwGGt8t81GUKVDifen9icdsTAAT39AAC0ygDV

    "]], RasterBox[{{0}}, {{401.548, 16.5477}, {406.588, 17.0277}}, {0, 255},
    ColorFunction->GrayLevel], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYv0YnisS8ZUOwl/Eq1yElB1in/xM14xG8N3s
QvYnR1U6HPgTv7+wQsnh4sNjl1wiKx3ufLN9tX66osPiqdWNO8MrHd4UZ3ck
eAH5C02/LgirdJDoMzy4S1HRoeuJdqOLD4J/YeraWVc8EPxzXkvq5ugg+P8K
N0ZY2lY6FK2436qrBXSPwpxV60IrHdICjf8ffqTqAHMv54Enr8M/q8H5LMd+
sS17owHns53pNRbX0XZwXcIoLhxY6bBlFudDnQM6DkWBukpCdgi+8I3vNmU6
CP68txel3ylUOkhpev0Q+akF5wftNd0Q6qAJ52d+/9r7U0vDwSnh6YU2DQS/
YMerqT+R+NvU326aoI3gdwiEn7tnUOlgL9svqZGK4K8N5L+YoaMJ5xdFecco
rQby9VbkK+pVOqwOmXWPX1PLYZurXchlDQS/wH3ys1nqCP6fRKtkPyT+WU7T
ebfVKh1S/nKvdFfRcnA6HX+sUKvSgUfn9qPSTG2HQp+ElmtGlQ7Lozb8jFUC
hk/mQs6H1gi+2JQIDl4vBD8mLNH4QEClg4baTt4tHVpw/rsVCl95X2vA+VtO
b7fTCVN36OKIuvMLGN++IaeO3Tum6rBQZO2dfIdKh6v/7wkt7VVx+C0iyL9M
qdLhxmfT009DFODhu/RncpS0LILfYxP1bJ8Qgm8MBvIOu5TXOm2IQvDR0zMA
Pxk4GA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4r3NL4/O2lrpcNreZctzIRUHww19j6V3VzqY
XOx5NbNP2WHZHWPGuQcqHcK53V83syo7JArbMdgdq3Qw7VskkdWg5MDi+uiK
6IlKB6nAW9J/goB89YnGl09VOpyb+c/sqoCSw4RN/fFPTyP4b8MelD4+i+Cz
5t09y36h0uHKT+9nxn4Ifu3R/SX18xH8oNU/rVVPKDnILNY+nne+0sHez7Zc
/TfQvh69fC+QeXdecLDKKztcWXD4utH2Soelrae13lSoOFwz1lx1/UylQ43e
Op/Ll1Qdri1piDQ7V+mwZsVBk57nqnDzMy9+bL/KqgbnC89NFVMMR/D3Ztxc
krNCDe7+QyfUQk4/VYP7D8Zf/vxuhA8Sf4KjxYY2YHjUFM6QY36o5iD9ur32
NjC8lnfHhcfuUHOAhX/96aCFH+6pwN2/5txRqw08Gg59wgWSkUD+j9aF8tf9
NODyBg8O2DMcAcrbVus1b0bw46t+F6tuROLzN9ZZra90eKLxNOpmI4I/s5Cz
bJM9gp9Wbs76gl3D4XXHi5qPGxHueZnwd775vEqHq6qPJU5uUnOQCEnVNJ6D
8A+MD/OveIL8XKnZCP7FV/bH+Gci8Zm2rL03DRGeMD4svGF8WHy8nDP/0Z4Z
lQ6Ks65oH3im6nDpXmuQxixEfC6dIHVSZ0Olw+s7kQlbalXg8iIm5XZnlZXh
+p/sTA4T4VeGmw9MpsynPyjB+bD0BuPD0iPM/bD0CvMfjF86WYJlFxK/x3Lf
mnpgeIh+7MmZK6oED79X144ZO9spwcNXcPqll+vFVeDhv0XSJ8P8qgKcb+ex
ymvbbgT/1uUjH43yFRwk3y7f6g3Un9iU4r3ASMHhyqlzb2I2I/iw9ILOn3mn
OfvkcgV4+tF6/bZ1xzsFB/T8DwBtL+hJ
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4o+7X07jNKlyOLSsRezEIlEHGL/h/JZMwYMI
/gbPE4Gnroo6+AoLRsYbVjksX7PsdWezmEPy9BX37slWOUS6xCkEdUg7sE2Z
7nZXosqh9tFSh+4ORTh/f5NJ8sUpKnD+mnNHrTbwaDiYbvh14pRclQMfTxbn
4WZth9VuXAf+Ac1f0GD+Lo5RD27/sgctc/faIfj75vYJSnki+DKb1HbbRSD4
qxwu+cjU6DlM7vign2Vc5cAZmvXNoVvP4eY8/tZCIwTf7FXN5fsGCL5p2/vN
C5SA9s2ddbrXQNfhQHPoak/JKoc/2YeLpq7QcmB9sbbAULDK4Uz27Wc15RoO
lU+rbvvwVzmEi6SqznFUg/Nh/oXx8zUU/0qzKzt4lzLqcwP1N8pXfc+Zq+CQ
7LLowiGg+c9FvzTH75JxmLTzhZSDcpXDp2U5ix5cFoe770XC3/mHbUTh7ofx
Yf6D8eHh1an7mScawYfFLwCMbd83
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1H9Q03UYB3BkLEGO8Wu0ZQHb4LuxoSuyjvJOfEiHOOFA5OcOglyAS9rY
MIlPogyQjebvkmsqjGb8MvsxkBM5yIBWAZJOFyDnEARSDq0LC8Ud0Pev78fr
j+eP130/7+8993nu+XB3q5JyaS4uLqvISiXLlSyNpe31IjUCu9lY7vMZAVsH
6IHZGgQLwVEpIjYf1v9T3OD8CMHqPtXi8l8CeDG+d2KpDFv8OL+6T4steTrU
duQwdozdlD6sR+Aq50nrW8nvbnrBvkoErPoP35wzCqCIdiE0jcxrbTND7wVh
N+xYOWVv5FM2fZ0U/CiNDzbRLMu7AsHGJ16uk4sEnA/2atqqw85SGo5e+hQ7
xiPF+t1xBEOSkYn0JD7lkKzSqlVsAeU7zS0/fsUOA3Pz6CZNFYLUM2/3O7PC
IDNN0BuoxS5SpB144WNsTcPiDwbyvgDZW7qyBfCH+WdhUyGCefOasat/8yEg
/FL35QIEX0RcsAjFYaAvdIxvfh/nM6w2T0s2tvDl4WRZAvYzU2uiIgZBnoVW
u3KboNxh/TJkPBMbmOq73kICapMlrs5t2FXmmZn4WGzwGG07sh17qj/0Nl2K
IN2GdhVsIOAay9qVTvr+Sso2Rg4Bfor9b31D9iMb8SpzaAQg4pdd9JDh+aqL
I8LezcbW0+WzybuxlyLcVw/nIzhuUbL+/Ql7rSP64bVv+ZQXDjEe53rzQVb9
an94LoKgkXDbwfZQ6v+b94Zs2TDNBX00fd1YJnn++67E3AYO+AfkMDLSEHiV
dLZEGoNB5P3KpCYRe/poeU1ZArZT7sOY3oH9TBelOEPez/krbjWnPDkwJe5l
lsaR/Rka2/wJDtSVgvMhmed53ouPPYYt9rxTeGwtl/Kh3jfyR81cKt9v1BKt
A1wQ2qs7Celz1uXklUqwB4tPyz6PRvB76sn9v8ZiE3OF+043cyg7lht7DlaS
/S5rbhaQ81MN8NdEdQeB6pzKFJeIrc8o8W+RYb9zosJPmoNg4lY0LbWdAzOJ
NyL7SPv+WRl/6yYH1LtoQ03kvF5z3ym/H8iB+vnkdQl7cF4jtqZcUWM/yGUO
zmqxWZOR18fIffO11Wl/meVSlg4+orXn8yj3HQiKrTjLA7FpZ7aqGtsw7rZx
QY/NoueJTuqeO3/ZGhNFOsj36Z4aHQ8kCkI+R+7nifK4kQ45j3p/Su7Wcnsk
HFj/oDuCWYzne336otFPg71UyQiY34vNTLjHVioQuCu3t9UpOJTNmVfpyz5c
yhzlpkVRORdkNz6R53yAwE/925RhngsdTzpT2eR+lx929Lxk58H/39P/ALEU
VeE=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4oeHzT5/fVLlcNreZctzIRWH0A+3BcpfVTmY
XOx5NbNP2eGUTKPej/dVDuHc7q+bWZUdWoO7dWd+rXIw7VskkdWg5KDRqs9U
+L3KQSrwlvSfICA//V6C3q8qh3Mz/5ldFVBy2PLpTo/DbwRfcLruYru/CL7m
Oq3fSf+rHK789H5m7Ifg1x7dX1I/H8EPWv3TWvWEkoPD44ovJ/9VOdj72Zar
/wbad6Z6ztI/QPPuvOBglVd2+PFAgLXvWZXD0tbTWm8qVBx+FZddNwLK1+it
87l8SdXh15OzbROB9q9ZcdCk57kq3PzMix/br7KqwfnCc1PFFMMR/L0ZN5fk
rFCDu//QCbWQ00/V4P6D8U+ra7ct/4Uk39h69+FPoP2FM+SYH6o52GtfXWX2
o8pheXdceOwONQdY+NefDlr44Z4K3P1rzh212sCj4bApeK/bFiD/R+tC+et+
GnB5gwcH7BmOAOVrT0Tfe4TgN+/yWNjwAInvf2711HtVDk80nkbdbETwZxZy
lm2yR/DTys1ZX7BrOPCfNF3l8xDhHt6FXmcnna1yuKr6WOLkJjUHmymbwvpO
I/wD48P8a70g51TpKQT/q1bv56wTSHwnxtuWxxDhCePDwhvGh8UH7903/BJA
/YqzrmgfeKbq8E3ucn3zSUR8nryQ/q39fpXD6zuRCVtqVeDyIibldmeVleH6
n+xMDhPhV4abrz7RmPn0ByU4H5beYHxYeoS5H5ZeYf6D8WdeTjUUPY3gb6jk
vnULyBf92JMzV1QJHn6vrh0zdrZTgoev4PRLL9eLq8DDf4ukT4b5VQU4385j
lde23Qj+rctHPhrlKzjY6n59tAwYv4lNKd4LjBQcfnDJSO14hODD0gs6f+ad
5uyTyxXg6Ufr9dvWHe8UHNDzPwC09/o8
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzATYDFA+AxqbFnpxqae1vdRyA7IaAB5+
Al0=
    "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJHIGYC4oLm17NZjasdTtu7bHkupOLwZP2EnW0W1Q4m
F3tezexTdoi8Y3qd3a7aIZzb/XUzq7KDiLDDtRXO1Q6mfYskshqUHLa7PFnV
4FrtIBV4S/pPEJCvNpnTzqPa4dzMf2ZXBZQcnDdNNA3wRPAXhD3y9vNG8Hfk
3l9c5FvtcOWn9zNjPwS/9uj+kvr5CH7Q6p/WqieUHM4v0p1706fawd7Ptlz9
N9C+bgPXrV5A8+684GCVV3ZoX3B07VyTaoelrae13lSoOHQaazc4AeVr9Nb5
XL6k6tC5pEl/IdD+NSsOmvQ8V4Wbn3nxY/tVVjU4X3huqphiOIK/N+PmkpwV
anD3HzqhFnL6qRrcfzB+1PP7ets9kOQdrdo+ugPtL5whx/xQzeHcq85gN7dq
h+XdceGxO9QcYOFffzpo4Yd7KnD3rzl31GoDj4aDo3DR+8NA/o/WhfLX/TTg
8gYPDtgzHAHK29ayvDNA8IWq/npO0EPi8zeHLNWpdnii8TTqZiOCP7OQs2yT
PYKfVm7O+oJdw2Fex6ugGH2Ee+Yk/C9dJF3tcFX1scTJTWoOp4PT/8+VRPgH
xof591S8YnGrBILf8spxTpUYEp9pW7OnCCI8YXxYeMP4sPiYM2fhDnWgfsVZ
V7QPPFN1aL3XrjFZHBGfERNk5k/XrXZ4fScyYUutClxexKTc7qyyMlz/k53J
YSL8ynDz1ScaM5/+oATnw9IbjA9LjzD3w9IrzH8wvsZkqVsqkgi+veWBpldA
vujHnpy5okrw8Ht17Zixs50SPHwFp196uV5cBR7+WyR9MsyvKsD5dh6rvLbt
RvBvXT7y0ShfweHMm5Xd24Dxm9iU4r3ASMGh/dSFQ8cNEHxYekHnz7zTnH1y
uQI8/Wi9ftu6452CA3r+BwBFXMf7
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1H0wG2YYAHDUptrGSlHSSESbhLlb59ae6xiPXiujV9+C+moRgmjaKsY7
9e0IRemUJChqmkbnq4f5qK3CMGquq53SMW6lvW5W5zTD2PvP8u62P54/fnfv
8zx37/u8DzNM5MXfpaGhoYnDD4cWDlGITNV9CwGratZVbMWBsRtfhJ6rQNCh
cOYnXyJ+LPCYfppCHPx2M6a9mnh3eE3ggApbrsu1KkdgcTvK34ZtCQbuk68n
y4hFEgc7KCXeGAuoeVSMIDLJ9p1lHUvQL4g/6leEQGuXV1NEDweqGqhNe7AL
bVqKFms5cHFqPnWwEEHaG16joTYH9OuXjNnYfYLpO8K7bNBvrhVTChCwN5gz
9CPYPYHba/kIXI7NzuyWssCxTtdQF3s+VP6Erc8CmZVpw1YGgmnj5oGwVCY4
rjMcgrET60Zi5j5kQvb3E231KQgoyd1y20oGzCdSas5eIo79dfS0r4BY72GB
V1UkgrmPDGpvNJmrLZdJZ+QCptpUz2eHtrwsoDUyooQbjeDYZOGryqLDIDQP
FtZdRPCifz0zx40Fvrx8AfsyAp+bX8rEdDa05WdODGIfqOIbM/2IL/y4kxXQ
S/zPfbX2c/1/EiLgSU6MbAZbwvDJiW/pfOKKXPvnQh5xunFQX5cHzt/blNf/
OUvty48XCzzdibOtb3u401hgtxH61SdexM1zXTbif/lna+0sIx/iiuoWpR22
bFmuVLBx/qweZRPb+YGZ99skFrTcCkJmAQjg2R2uiscBSnF7jW0oAp0B0Z/b
KxyojOua5kcQz8WGc6v5xKwZfsRxwf/dbp03G3WWONww9NOFcTbM4TnowO8x
1tB47aYLG4btV3UUuJ5yUOp85CULKs2Lc/pwf0+3B4qS8cOQ8Z5oaV8wgvs1
9RvxCgu118umsgN6mWr/Je2NO7PCAPvKtLURXF80yt7j0EcHyUq5ZElELL1/
sPr3BOLswVXVUYTAfb91KT+aATIlis5JQ9BfvrWmdDKH0c7F1fRUBBXaIbQz
KXTg5DrS5fh8LnO8/bcSGqhej36WgOsZuhoh+jUq+D6RFAjxPGSpvinasTQF
vbyhkYJYPJ8uLc8X3jUBvamdE8II4kxeT4ZTGHFL2nKZWyBxhqNfxz1/BNwL
451r1aYQk5DV9kEgsXdroYAdTLweevL8KXx/6YG0jxdoVLCf2f7j0Xm8T1Zz
T/OSqbD+UGuBi/vd6xo7JdQ6pLbmD1deGQ4Tl/wSZaDYawYUadwBRgiCN0+L
FmjHzcC7M9pCEkT83dB49/4A4n3iF5pb3gj8lkxK+q7T1DYSX3VsLKaqnaQa
iv1aZgKVPB+9iXN4/qQ0h5fvH4RMB67kSgTxiKQuLvEqsayoYz4+G/9n19JC
JyUVLNdzWyfyENxVJhRa2zHgv/v1b+t/cHs=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4vj572Mtz1U77G8ySb44RcUBxue7636yTUnN
oZc/k6v6TLXDn6fvzpn2aDiUOpzIOHy42qHrVx5L8RktB7fTjXJuu6odWDYZ
lW6y13VYNOtt6rI11Q6coVnfHLr1HP4/jdoishrBd/lTySmzCsF/fqJhUc3K
aoebt8L4OsoQfJlNarvtIhD8fXP7BKU8EfxlD1rm7rUDmh+2KbkYaN+TcPbZ
oo91HXrc7NYf2V3t8CLwY/3xl9oOlz5c+rTiSLXDqw4jLov9GnA+zL8w/u5I
DbvHOooOce4ymx7uq3bIWSj11D9U2kHXLqGyHej+XZzJG9oDxOD2b/A8EXjq
qiic33B+S6bgQQT/0LIWsROLEHzPUJUC0zRRuP9fJPydf9hGFB4+MD4s/GD8
xf+qWp8Cw3fd+TlfNT+JO0gwivbZAN3LYuy9XIpJ1uHynD0nQoDxs3Fm733V
TQrw+FP7yLyQ7YWSA3r8AgBYp/GJ
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 
    3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI7IGYCYv5/r8TUOGoc2HP2Tr1tou0A46/Z9XfFnngd
OF+C/73lBh5dh01yHLdu/a92yG1LrZ1yUtdh48ugXMaf1Q5JnFs/sMXqOQTP
/2p1+l21A2do1jeHbj0HlV/HFDe8RPB5777hl3iB4H/dL/Sv/hkm/1rUjNay
YAT/5fYQrxIFPQdrxzUeRc8R/Kze7zP/vkDw778LVIn4Wu1Q9GyTzmc2PYeQ
GRyp8r+rHST9/f5ZyOk6nCxcXtLyp9rhk2DPvZYUHYccoy8z/wL5xpxnU95p
I/jSPoc/TFRE8I+V1PAX5WrD+XnhzrYRGRpwPovzxoK3Z9ThfJ/vLWZeZ9Qc
Qhqm1Ab8rXZ4laTHIjJLzeG7nldpHjD8nu3/1tTqp+og8Cb45SnOGoe0PMnT
50+rOLT06xbICdQ47G8ySb44RQVu3szWi+zL3ijD+R/Kipdr9SrB+fPkX/vJ
/FGE88//kCw6vkMGzjdhEfz87aIknG/xUIRn7nsJhxNTr563AsZfRgXfgcS3
4g7ZVQEBWd+qHbbpxE9/aCTu8G2HqsaVT9UOXf3+J85ZizlkzdzI+xQY/pqz
NX7ECIk5BH3mTpUH8ue84e49wyEGj69so5kPuh6JIuL3n5DPhOUI/ouEv/MP
24g6NLqaFMi9QPBnJPE1bXuJ4G9MaL92+SeCD0uP5zpn5DK5icP5X9/ETb6l
IgXnz94jNEnskAKcn+4henT1MiU4X8MwObX/p5KDekNSiilPjcO7yn9bLnYq
O6hnvKtJ46tx4JkeeqPnorLDzxghnjlCNQ49HUmf2GJVHFo7HGYVySD4bTVt
at2ySPyCM5sWy9U4XLr/Qf18IoIPi08Yf41qxbzLx1UctoRXndgui+ALLn4u
piaD4IdVTO/OEUXwYe5/fD89xsJEFc7/vqj99SNzdQf0/AwAXJbOng==
    "]]},
  AspectRatio->Automatic,
  ImageSize->{454., 22.},
  PlotRange->{{0., 454.}, {0., 22.}}]], "Output",
 CellChangeTimes->{3.5166277600907707`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"inv", "[", 
   RowBox[{"x", "+", 
    RowBox[{"tp", "[", 
     RowBox[{"inv", "[", "y", "]"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", "exp", "]"}]}], "Input",
 CellChangeTimes->{{3.4542545352731323`*^9, 3.454254537467516*^9}, {
   3.454254582668867*^9, 3.4542545872758503`*^9}, {3.454258332615262*^9, 
   3.45425836796087*^9}, {3.4542721103207912`*^9, 3.454272111324039*^9}, 
   3.454899745515049*^9}],

Cell[BoxData[
 RowBox[{"inv", "[", 
  RowBox[{"x", "+", 
   RowBox[{"inv", "[", 
    RowBox[{"tp", "[", "y", "]"}], "]"}]}], "]"}]], "Output",
 CellChangeTimes->{3.5166277601170588`*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.015625], 
   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4qCcBLZ96eIOG4I1dZaf/mTf/Kz4XVmNuEPD
zG31qUs/2e9MYHkRdF3cQaBp5tJg3o/2sTq/U6ofIfiORrJWtocl4Px/Ub69
bQ8R/OVqB6UvGUk6ONjwBE01RvBh5sP4DNlBB3S8P9uXr1lrLCkn6XAgeEGC
wLzP9u5Gs7wTOCUdNnxLWGsq/sXenn+J44FZ4g4G3xfKiN34aT937w0Fi2JR
hx+/FdRs/BgdAhbMLEz5JeSw5c+B0HlCXA6uJruab0TyOuxQ/3cvZoOIQylr
w/ktmlwOMe/uGkh3ycH5n7w36/PzqcD5WVeDA74913Fo2R64zkpayGH542ue
j3gNHV7/nXCiQ0TSQVj6Ed+pi0YOMPc7qa5LjrmJ4BfqV+149wDB/8db/0nm
GYJfcl9BYN5/I4cuzqwfYq8l4PwMna/tB/MQ/F0LktfcfiGOUK8WcETpCoJv
0/90x7pycYeuN8063q+NHBjXvLwavVjYwbOpgFVEysihQnCZxvQVfA5FlnGN
GdsNHF5tXvFlhxSng8jC4/ccLXUdRFo/6hUtYXX4PNcv48R0LYcry7nTc08y
OwRyziwVSFKH8y0WO6ZeF1KB85cd1Xr/ZaOcw02B8oAnTuwOB47Iu85lEnHY
UOjuGflb0OEL+6nc322sDscLrfufCgs7OJid7P+RyeSwY/s277JJIg4BD5wO
s7v/s4fxBdQuiB1T+Gc/6a/toaofIg4fVFPnXDD9Y3/W/A3Hx3ZRhwUnjmmU
rP5pX86cMN3mpqiDQUjW7PaeH/bo6RcAgeI30g==
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1F1QVGUYB/BFMJYvE1fBdD/OOXvOWQXWCAgQ13jYFhYcEQVByIYQ2hwQ
WkBZMCaIHUuEhTRQQV1A2W0FQ6plFiy2XBWIigXGgUa+BISB1piRRIaKPrh6
z0wX/4vfxf+5eJ95HzxVGauwZ7FYdmtJWMu6tZDRnubbRiGoTltzorZSEH/8
LUefQSHULufK0rQUqHT1W8wyEpprdfNBeSJottiKHPQU8qUz9VV3zIxLRSmT
E4E08gXD1Q84DTTodh/Z/ShIBB8brh/p49DwjeoGSQpEcKBi6i+fLykQ3txm
vtJII0cSAWo3H8Zh6rMb6HEKlgu607znKBjrky6+UkyBLyc8cjyLRi62bdg6
MspYJ5e6hxWKQMl1HbjwC+Nu/6/zQrQ0clHxROu4VgS7/E34+TgaVrLf7wh4
IgKFs+YWq4lCfj26ctHzExKZ7hsKvzsshCcHnWpfzNDQUphXL74ihOrTob0r
KhpOldA84AohhP24IdUogl9fjZHK3AjUd/nx0WR6IY7MZfeuo6f4yFES2x8z
Oi6wS4M1we9QyEevDW/ynCaRp216a+RtElwVl5MPOfGQJY+bI5z5jK0Vsvvm
LMblplMejhoe/Gloleo7SPjWt/Sf7xt4UDZcFiifJWG/esw28YIPqy1SpccK
Dd4z+uUPuzG03+euA5luOTjyTL9d1Ww/46Jkg9zpIwL8Shtf2rWPsdmoGl0f
QCPXJLw5XVdNwbZ9n2ksXgRYWlLutoeQaP50WKJfZjoOQzFRcxUYDjVnF0Pr
vDDYY2n0y8jGIJYmS5sa+UCwIzZHiQTIN02zWSYbH/k9ydFD1faM4yUzXO/X
eFCOnXS+jAugZrnv76GdfCi4bwqvPSyAQP0xbf96AXRNeewt4WDIg1MbU3rq
GRO16QnuO3DUP5Ft2vw0BgdWZLvy3yoe8pzjuwpbOhdZ49uQa1Buh3xxt8LO
iiH3WPRpVjFj4ouNDc8q+ZC0apfRpeBBW/75+dYeHlxM2tnUwRMg98f8PJQx
giGTIk57WSUO6mbV75UhGKj33Epp1eJgfHBH4pqIwarGxVE6gsPnZhc9RAhg
LDd0UfwpwfQXIgQnO4XIY6Pi3pJ7FHJXmDb6xiQNbYaH2SwljrxwnXi+8Btj
RVxcUCdGQLPD0MEAI+P9zySGl3WMOy3HjFn5jHUOiaHua//bMueT2O9KgEZ+
4Ke2VBr8kkq6F+dxdH+CM/X40kUBFJDJddbjJNrvDx17r13tESKf+y6HXW7P
+ITdU7WLkYD4c6uy1nEBssx/aSnwEoZ8T5Y7n+aIww6v7cOHB9feR27/8EE+
DgNbWG/EsYVAvr3pq9gkAv5/T/8DGE9IFA==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
    0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYC4m+O01iFy40c2oUf3WbdouxQ9vNae6mBKZxf
VTlVoD0Ywf8UtU75cxMmPzEyM4hLSgXOt57/4QRfgwpcP4wPMx/Gh9mPzn9Q
OWPNATYtOL+og+n4el8E/12k4rfgtVoOnPODTgm4IPgyf/j6+QQx+TD9MD7M
fBgfZv9HQ74n/av04Pw3hhMv5aQg+L/z4tdMYcXkw/wP48PCB6YfxoeZD+PD
7Efn+z8wnL4+SAbO1zkcm3TxiDScL83s9ukDszTc/zA+LHzQ+TD9MD7MfPT4
BwDGV9Oe
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzCSwGaB8BjL0jgQ2cvgAAEeWAp8=
    
    "], CompressedData["
1:eJxl1H0w2wccx/FQNtMe9XAkFZrIL8ltLsMh/H4J+dLTNpZ2d2ZMzOx09JYK
sShXD+tGpWhrOVMjYafKdYppFd3uaNellqBNMw9FG1EPM4+bOSqGmn/2+91t
f7z/eP31vfv88aUnpkUm7SORSBZ7xexludejU491NP9g0ModMM33LPi26uMg
15BgiM3PiWpbJ5wuKNTZkdi4SXof8RKD8E10KGI7jw1qSl2rtVsw9GRWH5M0
sWFdSj2gXOfjfsj4azXDSDhXVO+vbueDzcmUNdoVNvzBAe5MDR8axhTqGmDD
d09vk6hVfHjb5rc8KpsN3dPO7r0X+EDXXao4UcyCxZYvWway+ZAgsCtv4LBg
Qeo5L/yUDzpDdF9MIxPmOBrkQQwflmwd+kNpTDDUXjtvKeRDAdf0c0IFApUu
KiVvlAe5y9Ntaks69Lx4jR6u5wH53KtYcicNKAFWKc2JPIhkIUWN1z1gfMHk
/U43hvvyYIe6J5jwj/Ga00c9Mci3Pabs86XhFskNfVPLhLvY9vsDRumw+PuJ
8AURBiM3HowNODHgasGYVWUdBkUVXp/dG0QAmarWjvRh8FLy/JLmOhNeuvoE
6ocw6JSrrMVGwlZN/vKyUBbuf/daySrQzBZiYJal/uA/zQZx41ZcvC3h+Nkn
joLDKO7JGZ3zjiYIvKdeZJktmLidG8g5JUMIbrblsKDoGgIK2utMkZHwo6yr
YudJwnexiLTeTcLiZIcSznYQCO6b7sw0IVAC6/aeNijMlUSG+ewgMLxhWDse
gcLUrTGur5EFrVLAFptQuFlVPxd4lg2y6NJn+leE9VhIx/uOGG5v76RCLe//
jrbs7q8dYOG2Xvw60O09Fhiya86ZGBik5hqlj/VMEAu97tGdMEiuNgTEpzJB
otj8RtiOwhoyr+qNZMBqhrlDUIzCu5mj880+nrgrJfszykLpuMOELFH3pgfU
HbS4eJCJQXuWcq5V6w7nMzPnFjoJX4zOp8W58nAfGvbTy87woLy7XDYi94Dy
XzRPtbd4oHmWqNu6chiyN8OkXyh5MH5b+3fXBXcQTux67pPzoF/PLUtQu8EH
os5+nT0PYjc+j1UWUQBpazejTzDQNbwlTfcjw/2dtOecdAyQDUpXlIMrdI5b
Tfjvorg3Z7rExUbCo1lf5YmlhJcycuqpR1C4bBdYkdxIhpzBkNMfniH8RtmA
dqSEMJbLOXK3GYUeGwU5ik2BKp/1k7UPUXCsXWHoCigQkuKX8OfevZUkLsN0
4BDuo3lGnWKA8HDprytUFyq0cCbPJqpQ4BaYfyoVUMFmtS7JKZ+wcH56MVdI
uNZdFu9rDoLq8vxU70o33OJAkztFRcHd1eAT4XXDFU7NipDEJBQUxxXUuAAX
2P4kZ1q1Szj1TV/K6C6GW50si2jd5cFHG1uSO3oKxE1kxqSE82E5fUJSE+4B
//2v/wC1F14S
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIlIIaxWZDYzCSwGaB8BjLUkCpOa/cMBjay2wCzZgKh

    "], CompressedData["
1:eJxl1H1Uk2UUAPDJnNacMkNFzzQ+Ym5Br3s3Q4TWu/sO2oyjCH5wlL5kxFct
RQaMjyOigWfAhOosJFkjwIN5yEKSWAz1YJw8B3AEMujDBiszOIRB86gnGoZ/
7L2d/OP+8fvjPvd57nPPDdIc2pXKZrFYixZi/0L4LEReQMmwqgwghmtRUucl
kJ4ivJ1ZCfBBdM/1Y1wSCiPWrIo6CQDzQ412XxJMRnNZwScAac0X5w/6kZD9
T3xm/xmAO1aXXrCahLD4yu6ib9DSwUDO1DDacuBhbiKXZrzL3FT1VBA64uR0
+/AWGrR1vxx2LSEh8vieih2v0zDDPdJq/EkC3aZj7L/foEFuaghNzEGblgZX
Lr67ibHxfaFuvQ09/p6KYzdugoH4m7Mj+2lgG2yFnBsEqKkv8kP30dA0Wt9z
vwW9e7uTFW0gmPotJzyWjDwC7iVfSnCnoZ/WWS745qCl6uqxsVwaLt/e+3F4
DQExgpLlrXoa3Jpkw2cDBMjHOzXKahriMj3Es3KSsfJogzpmLwlvP5f8Tn8p
evrSg8Ync9E/z9gmne0U41W+4rqkCvSdNJWi8wSaOzYnyCmk4C1XG/dXCQlB
dbfUMTwKJvI5jdcmCPjI0GE/xaVg5/fFMtWPBKTYikosbArk+RufL+hEm9pe
GrJ8ip5beUWz4TQBunFH9v0lFPP+qz61MjII/WjW+FvRfGHSXxkvUEx/taf1
Zh8VBV9FPLja00dA7bzwnLGFApWbtYZmk3DLY/XE/kYx8xHgkYwG/6lgHFWj
d6Ssx/kqt0Z+aN6Cvk5/N5gdgfPqtfd8ry+P3zCbFqGH574djZuVgOyVttB7
mwG4FzaXxXVJIPzrtWx3iQJaR8r7ug+KQcnLmd59WAHCsCu85ikRmBJS1y7V
KsBR79k2e00Eic6qLNlFivGrIdMqUS46U79Nakh93L8PdHD6DqFBN3JWmy6C
fHPjM64MCgi/4nP1ahE46T+2J7+L9tbz2h3sN9M0gT6ufPFI1zoFY74mneuI
RX/ePFWuOooWRled929Ff6mxRpEudHSUvHTHCmDMjR3s/WEj2seXF6il0AlS
+9iZfWhHR/9kUtZ/8sue2LpHj5bVTJ7KKn3ccxL+4tpqtLd/k3e7BGeL0Ikv
vxlQewD96H8e7kR77+c1+C9ft7AWMH8F0baBDyBdLXBXDOF7e9sbNDwXOrLS
f5lumRj70WALqQpBF8wW37SHicEZmBTWuxIg3N8qz3tNDP/fv/8Cc8RSIw==

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
    3}, {0, 1, 0}}}, {{{41.07831010156251, 15.523955500000003`}, {
    41.166572890625005`, 15.523955500000003`}, {41.330022500000005`, 
    15.523955500000003`}, {41.330022500000005`, 15.695032757812504`}, {
    41.330022500000005`, 15.872648000000003`}, {41.173110875000006`, 
    15.872648000000003`}, {41.07831010156251, 15.872648000000003`}, {
    36.97899389843751, 15.872648000000003`}, {36.88419312500001, 
    15.872648000000003`}, {36.727281500000004`, 15.872648000000003`}, {
    36.727281500000004`, 15.695032757812504`}, {36.727281500000004`, 
    15.523955500000003`}, {36.890731109375004`, 15.523955500000003`}, {
    36.97899389843751, 15.523955500000003`}, {41.07831010156251, 
    15.523955500000003`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYCYv/489d1HNwcAjZdfSoTZuQA4z/V132l3GLk
YNN9b2WMnZtDrlNU8oVWI4dXO1vXrVFF8NXOyl+e9dbVoWaBqMQmKSOH+5G7
316ai+Az85qV/qrE5N/pnDTB47Khw5KSl/HP+hD8D8U1W5acQPDXe/gEHP7h
6lBU8HLGaS4jOP+cXX9g3G8dOL9JXTdmWSuCf03N7114uI5DlcPNKf4LEfys
fvFLP+sx+XqzzvmxXdd2ePG3fs6efgR/Yvr0/N7fCH5s/6GvPDJucH71n3vL
7M2R+Idrn2xbiuBPlWAJ+7YDkw+zvzXdafKC6Qg+LPzR+TD/wfglRoWrHX4h
+LD4AwAxKsx+
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGINIGYCYuPegiW1mZ4ODHG/Pt0VUnGA8dnP/uA4dlrT
YYGa8T0zYU+HC0dKFMMe6DvoenEe1BL1cJhx6aV+lp6Rw7Mm4x/WzB4OuTuU
v/OHGzloSC15kHnZ3WHJpcdBG3YZOTSpHWpr3+LuUKWRurbmg5HDfadwpQmr
3R1u2PwNW/jfyGHm5RDWnysQfOVFjzxtZiD4R0uv7fDoRvBvK2Wa76rH5Cdl
R1sqPEPwPdcFHj1828ghnTGv8EWLu0N5xb7QsxeNHLh0TXt82t0dXs/cKT3/
jJHDiaNrivZscnc4Y8NsEl1s5PBH/1jZ2u/uDgdsOAVFnxs6LBNe9+a4m4dD
8tZ5x5TOGTjkLFn6qeyCh4P4NL3N+07oOkS6v9StZPZ0OLLJruv+bQ04Hxae
MP6rd1bSn66LOUyKk6spyvJwaNE90HG8lwPuvoR53uonXn22V5yUHRLY5O6w
YOvftifTP9vD/LNByNZqvxyCfyC/5u3MpZ/g/ICIeOEO3o/2sPCC8WHhCePD
whvGh8UHjH9i6pHFctvdHRja9Xy3BX2yNxBSYVhp6OHAoJ26TyPtv/2MZ2Ec
3bs9HBzuHKkvOMHlULhn2usMEU+HPYJn2sPOizpc5piYbuTr6fBmF+MGb1dp
eHqKO+nCoHZXwQE9vQEA2DIb/g==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
     1, 0}}}, {{{57.75799010156251, 18.164195500000005`}, {57.84625289062501, 
    18.164195500000005`}, {58.00970250000001, 18.164195500000005`}, {
    58.00970250000001, 18.335272757812504`}, {58.00970250000001, 
    18.512888000000004`}, {57.85279087500001, 18.512888000000004`}, {
    57.75799010156251, 18.512888000000004`}, {53.65867389843751, 
    18.512888000000004`}, {53.563873125000015`, 18.512888000000004`}, {
    53.40696150000001, 18.512888000000004`}, {53.40696150000001, 
    18.335272757812504`}, {53.40696150000001, 18.164195500000005`}, {
    53.57041110937501, 18.164195500000005`}, {53.65867389843751, 
    18.164195500000005`}, {57.75799010156251, 18.164195500000005`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1,
     3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}, {1, 3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4q12T2foTPdzmOc5exXzLxMHGN/k+Kd1XBqm
DouyvmTFTPVz2HNTXmO7pqlDwMzZ+WtqEPyeNaZTZrn4OZw2v31nxj4TB1fL
i+suffGF8zPfeJv9uoDJ11aMCNUvN3HgCvmv8Owpgh8WPKl0ibwfnC+qkSR4
2N/P4RD7+thN6xD8bWa9b6cqGsL5Atp3Pu18ZgDn71r1Zvek8wYOD+Tfh/r/
8IXzL+TpTv55DZOf9kTnTWa/gYPf3amxe54h+N/d1hr0BvnB+YfzbmzjKUbw
H97+km7fh8RfNHnptj8I/u/vkuLf+P0x+DD7X7tFhCx4h3AvLPzR+TD/wfid
BnVS7ED/o8cfAJkZ2uw=
    "]]},
  AspectRatio->Automatic,
  ImageSize->{64., 22.},
  PlotRange->{{0., 64.}, {0., 22.}}]], "Output",
 CellChangeTimes->{3.516627760449251*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notes on NCTeXForm Implementation", "Section",
 CellChangeTimes->{{3.4548982739186993`*^9, 3.454898286081026*^9}}],

Cell["\<\
NCTeXForm does not know as many functions as TeXForm. In some cases TeXForm \
will produce better results. Compare:\
\>", "Text",
 CellChangeTimes->{{3.4548982950314617`*^9, 3.4548983630204363`*^9}, {
  3.454899797276557*^9, 3.454899798289291*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"exp", "=", 
  RowBox[{"BesselJ", "[", 
   RowBox[{"2", ",", "x"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"NCTeX", "[", 
  RowBox[{"exp", ",", 
   RowBox[{"TeXProcessor", "\[Rule]", "TeXForm"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.454898366238731*^9, 3.454898394463563*^9}}],

Cell[BoxData[
 RowBox[{"BesselJ", "[", 
  RowBox[{"2", ",", "x"}], "]"}]], "Output",
 CellChangeTimes->{3.5166277604842663`*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.038461538461538464`], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJLIGYCYpsN5bdKVaQckhk+5SfqKTk8q36dcbBUyuHv
u/RDB64qOfy/oWL/qEPKQULHYL8es7LDQq0P8VkbZOD8u0v+ZmUGysL5OjXH
rdL2Y/ItTrpm/85F8LOad4jbTlF22KyVPuVyk6yDak7nsr8LlB0Uas6KKxgj
+MeWcKretZCB8w/K7ciPuiYJ59elnOtbf1cCzp9wr0B+52RxOF9OZf6mr5ki
cL7hPEfn//LCcP4v5Y2eykeF4Hz5eaf4pvli8lfOyiqPdETwYf7b6JPS7TkX
wZ9xyeWlzEJhOP+w/tfPy9pE4Py2iEURwq8R/If6ad5hT0UR+q2NDxZcEXPY
JT5DlOuLksM86w2XJkuJO0QzM+Q8fYLgn/oyNfDbXASf90zqvzX1Sg65B+e8
usUq7lBnuyvnfLSSQ0hKssiuT2IOK8MblmoaKzncOfYr8X62kIOAq/nGMkUh
B955wbd0qgUdDiz4+DKsi8ehovHt7trZvA6Hp3gsmh7I4VD3lenv+VZOOL9x
fa/szyp2ON+uZ2vKLz9mByNODblELU6HY9Nn+f3hYXJ4V5tQ+2kSr4PDy19f
+jyZHJY9K2peWMPrsDI2Nt70DoLPFdSiv5yVGc73u7SwwkqHDc5nY3zx7KIz
h4Pw/4MX54sJwPlF0xYL1roKwvmSR4u8V3cJORxUbuVdpcTmcOet/Abx90IO
jDNq/kadYoHzNdZbib+OY4bzpzBMyLv/75/9LoHV9oeKEPwLz+7+nZbOD+f7
dt568y+Vy0Fv/XYNvqXMDu3mislLZrI5CCyZU9l8lRPOf8jgwi3VIgDnrw2q
WjZ9mohDyJoL3+Zd4Xbg0LKbeWuCqMMdLrYa5RuCDuj5DwDkuHnq
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4qZAz7kNdSoOdqGtbI++sTm8eqn8oZ0Rwe8r
YXN7903ZoWdnNqflHlYHwcem61ddUnaYqFqsk5/H5GBxxz3v7GJlh4AfObJz
7jM6mCz0TIpsV3bYa+LaMLmD0SFysdwiwSIlON+58PhsH3sE/8Es61/yQfJw
frn+95MPlRUd5tkx1VesZ3PIWmwl+2OhokNVzumGzTYcDkAnMxRUKTk8cf/T
9fU6l8OaPpmXa1qVHbgrWcwvyfA5wPxz0f7gUa5jAnB+VOqyLf/SheH8yb3s
0TqHxRwMOdbIvGIFutfaKGz2eQmHz+EnYlbaKcL5syZck7jCLQ/nl+3n+nB3
m4wD/3vLDTX5YnB+jvK8N8feCMP5Xpv43Le3Czkkefcv+3VD1iHUOFtTIVXI
YYbBrKlvpeXg/Nv689fs2Ivg71qoaf23Qd7BY/m6GrPHCP4x/T2TnrwVhvNN
fl0sOFUsAg8/Cx3ePyvKRB3uFSdYHvosC+c3f63nm3xezqGN0Xudk6O4g3z6
rA1nIxQccpSMxX+cE3c4M108gf8/gs/zKvpZSKISnJ/4YOf3AkllByHj3zZt
S0XhfIbIDr6HacJwvsrcxonb/wjA43fKF4Mtv9T5HPomvhGcdU7RYeWtvKb3
GjwOe07mX9T8K+PgW8HpV/vmrz0svDaVu0WLvvsD5wd81Z7LvwXBnzETBH7a
N3WtiucUUEHw0dIvAMkYMq4=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4qQbiT5VlroOHe/XLmY9/MQexi8w1bcN2PoU
zv/AdrpWPPqZ/b/DPhONnug4rJHb5yNy8rX9JjdbF+USLQe+7fNqrv5mcGC6
LeP04bKmg+YdG/n1bAJw/hqZqBRreTE4v21LjfBPPlmHJwkNfQsmajksnZ4U
0f9P0WGxfnGB/A8dBwseA1vtGhUHmP22ObVvOnci+KGa7QnPDiP4m23lubgv
I/hOZ07NfvFNxWFfjnVur6quw4IHSa68bKoOpaZyghVsCL7IwuP3HK/owPnv
FKTfxvJoO9hqTpaKWq3s4Hnp1s2ah5oOk7/vPpiorOjwLup5S+k9DYcT75Zn
T3oi61DC2X7v0UINhzv2u19cqJCE82H+hfF5MoxnXGAWdljOHOm/9qaGQ8Ka
U5JPE3gcVjwral74QdNBK+qU84d4ZodJPY5nvBS0HRp/lDE+Vf1sD3PfjgPF
7x9OemgPcz+MD/MfjA/z/wK2rx06rY/s0eMXAFts1vQ=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1G00m2cYB3BCvUQQGpEIxWjVijzPk7Bpetqrp5yaacujTY403Zw2VNu0
lrJprUGNOvRYrS/pjlaFTk0bb2cc1Y0h0k1nDq3OvGaMrKmpGrYZh/l0Pzv7
8P/w+/C/PtzXuS/vo8lkgoWZmZn5esTroa0nOqx3QpxCwE8y37vNPA6c6JvL
c8kmwF1yOmJmMxeWklmOY18TsKOkt0j93B2urzbrzBUCZNt41n7ZOcrZ9akL
rxoo5ymv7s43CYAYDSYGpe5wUemCJd4VgEzSbZPs7w6J8mCaWikA7NE3oTKC
h3y+Zla3e48bsuKMeuRsBRe2D/mFuBQKoHyDfbnUxAGx3/GtZ3oprzpHFSms
hchF7VMML4kQvi8vfT+ymIv8Yd/0/VubecjGpDDPiS0ecKjJ88ZenQCG3pVj
RfUeMFdOH1o7TTmu0051eYRAJnP4lYYcAursiuecGnlw4/BarDqRAOcjViRn
0A3OjQ1cLfUj4L30cPPfYzzgq2BFhbcGR/3O9QcTSijrDX9adsVgyGVxGbnK
XD78c/7vgZtVHOTScuHUwVpX5Jpdz2QP97qCxav+psomyrwHY9ssOyjLs7e9
HDVR7lDrrtGW+DDWbAxTylxhpsr4Sa05BivskoDGRlcgW5d3/iXGYELPuBM7
zIP+KzczW1cwtN+3v9ButyJx5Lpc/b6zFymvRnG25gziEJXe052dSVnel/oR
EeuG7ObqkCNncaG7ozDylxocFPoIUMez0fzqmbd811qYUBVuSnvsj4Pwj/6M
x1kMkGWoSxr6MEjzklzReNjCd57irphjlE/YtXoGHqT8s+LW53I3ypVxy+rr
P/DBxFq89jGXDgm8hxaLPhjopBfoWZl0YFiXnJqXYvCb9GQK6ctAZh8m104e
ckAOvC1VvCNion5b5MKLlQImqAzyttUVPvIHu0SiheOUdbGD7U9fBkF9vh87
1sER+fVQhX1eIQOZHYB9G7RgA/dDC1rGp/gg0vGjqxOswXfh05qZeAz5nv7N
2QYrHDkG7zF0xuMwojJF5LcxIEtULJQk4aAxLiozQuxhh/xJnuYSDpsObOnq
OUqHQMnkBfb4f/qsFxub0whk7eXhpLZ0AXLZzo0Pem2FEN0cVObXxUTWVXdX
0PROyA3MoKDSAGdgedVqufMC5EmXXyV505RvZyweCXlOmal57WOz/r9PhY4n
6y2dIad92jT4RAD73Qui6C1O6P7s0cZ1BNPsYLk25VnijwTar0/6MXKfirKF
SmUTzqOcuulR+IZ5HFRGa1vtZ3bIkxoD6c93QB42DniNzjvCU4Kc9acRQC4V
JtQNMeHel2E+VR4EEG9ovbtLnOH/9/Rfceo/KA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYtk5dh+DNpg7rJGJSrGWF3OA8X0uNhgss5J0
YJ5/dUfuFHMHjcfnrFn45Bya156Y95nD3EGxLT3Y3l3RoTcq8ZdcoZnDHFvt
I3W7lB18A+QKlaebOix4kOTKy6bqIMP2OZyjDsGvyHqysjYPwV9qEmjVnmLq
UJDmHxvyUQXO32wrz8V9GcEP1WxPeHYYwbfNqX3TuVPFQU4sy/fzZFOH6sf/
Xz6MVXF4y6fJxtFp5lB/9+W5ySlKDmGbi+19xM0dmDTDNnGUyMH5MP/C+F5T
m032zeNz4JDhNLmxy8zBpFCc7eJUBgfWTo8VJq2mDi7sC4uYDF/Zw+z/wHa6
Vjz6GZxfYKpvG7D1KZzf8X7tYtbDT+D8PcmrCwruPbKH+X/HgeL3Dyc9tIeF
D4wPCz8YP2HCl0zRajOHktnmflzzP9tv2j7lc6uAuUPqlIqutPfMDgnFfPM4
JwHjY6rErhObeeDxV/3zx/2lR4Uc0OMXAH9rx4Y=
    "]]},
  AspectRatio->Automatic,
  ImageSize->{26., 12.},
  PlotRange->{{0., 26.}, {0., 12.}}]], "Output",
 CellChangeTimes->{3.5166277608143883`*^9}]
}, Open  ]],

Cell["with", "Text",
 CellChangeTimes->{{3.454898396028743*^9, 3.454898396405352*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NCTeX", "[", 
  RowBox[{"exp", ",", 
   RowBox[{"TeXProcessor", "\[Rule]", "NCTeXForm"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4548984035821733`*^9, 3.454898403701187*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.017241379310344827`], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0,
      1, 0}}, {{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
     3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1,
      3, 3}}, {{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
     3}}}, {{{3.1117028000000007`, 6.641957025}, {3.1117028000000007`, 
     9.1061537625}, {3.1117028000000007`, 9.4361662125}, {3.1319394125000004`,
      9.506216025}, {3.5911548500000006`, 9.506216025}, {4.8069082625, 
     9.506216025}, {5.75802905, 9.506216025}, {6.100494800000001, 
     8.6547216375}, {6.100494800000001, 8.123899725000001}, {
     6.100494800000001, 7.4825547750000005`}, {5.621042750000001, 
     6.641957025}, {4.532935662500001, 6.641957025}, {3.1117028000000007`, 
     6.641957025}}, CompressedData["
1:eJxTTMoPSmViYGCQAmIQnRUlcUNys6jDtUc/3CQtpByubVdfrDpH0uHv/lcn
Jv6ScpibprZXJFnGYVKJeNG2Tlk4v2H70xP59gpwfl9Vh9v3P4oOac4e6jGH
JRxUczqX/V2g7GB/690VoaXCcP6GSf13WT99sUfnS+gY7NdjVnZ4Zarz5/yW
H3C+5PJsc+5oJgcYv3L2JPbaFiaHp4ZxfimnleD8t3oBQQ9EEPylnbqfeZr4
4PyjtV+Z/i7nhpv3Y8pa+8snuOD2wfgw96DzD0/xWDQ9kMOhVWS63fkDIg4w
/n3zZNsoVik4X9tij4LSVFmH7Z1L1MtC+OF87aMv60ViheH8nqS4N0mnxRx+
iUTP6bGWcnhkb/Hr8z5JB/T4AABhkrKC
     "], {{4.850494812500001, 
     3.3480591749999995`}, {3.6020514875000007`, 3.3480591749999995`}, {
     3.1319394125000004`, 3.3480591749999995`}, {3.1117028000000007`, 
     3.4165523249999996`}, {3.1117028000000007`, 3.7418947874999997`}, {
     3.1117028000000007`, 6.4271376}, {4.9905944375, 6.4271376}, {
     5.9790751250000005`, 6.4271376}, {6.399374000000001, 5.51182005}, {
     6.399374000000001, 4.8533518125}, {6.399374000000001, 
     4.154410349999999}, {5.8794487250000005`, 3.3480591749999995`}, {
     4.850494812500001, 3.3480591749999995`}}}], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQfbi+4VrFdHWHHxO8y42CRR3ms6YLsvFrwPmdGm8O
f5PD5Kezan/+rS0G5xuJM536oCPl0PWU8dMxAXWHLRNfL5siLucw20a7K3ie
Cpx//IKMvF+kEpwf/fPh94U9Cg4uJfv63v2UhPM58jw3y/0VgfPPpsmXtrrw
O7RXcv9eMUvJgZ/TamtfK7uDSF+3wbNbKnC+pMjdpxm26nA+zH1i9Q1RGy0F
4PzQSp93B/8i+Pr7L6ccSxZ02OK06U/AN3WHeMvnPvUVgg4n6/8+n30XwV/n
ZPpadwOCP61Vu/ziUnWHvyyJO1psBR24rvPxOM5Rd8gOO2598a2AQ75HZrjs
GzUH7TWpNStfcjq8+dzcMFdNFc7vitf1S/+iAudLZPd79vxQhvMnS5o2bNZX
dtD7FJ672IrH4dlZpsyw3UoOfP/6YzeL8DscFvh/cbOKEtz9MP4US59Xu94L
w/mw+EOPbwAwnt6i
     "], {{9.071684420000002, 5.539839975}, {
     9.129280932500002, 7.054472587499999}, {9.941858757500002, 
     7.308208575}, {10.270314545000002`, 7.308208575}, {11.266578545000002`, 
     7.308208575}, {11.363091620000002`, 5.9367889125}, {11.363091620000002`, 
     5.539839975}, {9.071684420000002, 5.539839975}}}], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1FtMU3ccB/BCtdDSciuc0kK9QcCeHs4x1Q2Hzv0s6KgS6dlgRsRMuQ4H
2gwQJeoWHZcGmeAYatFQZJMzo6h1F4owsCzMWrepGwRZWURXzOTSWetcK4bx
sv9J5sP34fPyfft+F2fvfiuPy+FwfOaycS6+c7lXbvF54CDAsrxVkz0mhl8q
3p5Meice9mal19aYxbCzKD11g5eEQOZY1pZw1p2CCDG9PBh5j35dgVsrhNY2
b8nf60koX7T5qFHOh0RCNMN8SyBjR5zLQgVK5IptMhlO45Cb5ttccl4ED3ct
vjvlVMA32jpX3JpQqMnUU9Z7CkjtTe4us4SCmvvcw7Er4MKV9488nAgFK33j
axXD+qBh+lZA/suubworJD5nLayU5tonQ5Bz+w03zmj5yGUvRpuin/ohr+qn
tBfy/CC9rzor0ch6sxE7XN3Feinv2LXIPgWkLyqM/WmvH0yQb8TWxOBQajzB
O+r1B+5kiuEPEofBxt4hTgwfmZemOqzewIePegqsNZ/gEPfzjhzuTQH8dXtP
O6ZTon4ZFWcyZhDIAyOKgteusQ4arlAmBFLIAc1nSzM8FNgP/Jmi7xMiJ2c5
p1LVIciZs6fbkreLobNt2nzoXQpmp0TSR5+GwVdJrYKYJRQIOpjy9sBw8F1J
nyX2kXDdQ/cXZ2DQyL09PXE5HvT3W3JoBoPXz9s+7hohQNUhdp3yYHA9Yfez
H68q4VJvg8O6UwILreDB8nB4k9RclDhZZzeEm75cK0N2L7Fm00wkqNc7bMse
4cDhjZprN8rhs77xqO42AvlDvm7w1jCJ/HQk5AntIiE4sW5L8yUp8u+nOPvy
SiJgtcq4VPaMhPr5TcWPsQjweGdH4xZQyF4DBZOxrJNNv1k2bX/ZB5m7zBMN
6y8qbXiRUIo8s6636DEmR3Yzp3mXv2cdPOBWFAkXwAN5ZX0Eybq56njTDxLW
hvGCFdwg1itNYy3+v5LA42XaOhrk4OqK9t8/QEI3KRINFsph6MDWgMCTJOiO
n/HZIZKDhgpaY64iwbTrgw6JMwoErySdYyzxqG9M4sppnyaQ86tUnloj657G
rtwoHEf+bw+MrScyf1sk8nf35/nULZQiEzStdXRK4Epp2nvRnXN7trst/5zE
IEpzSDdfjcOdoTtTr5rDofpFUsuKcRzq7PoU7sUwsCS4HOfKlDBTnFY/rAuD
///Tv7CR9zo=
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIpIIaxWZDYzCSwGaB8BjL00ppNa7cBAMQnAn8=
    
    "], CompressedData["
1:eJxl1FtMk2ccBvCWYpHSMqDQg1AGOIcyxH7f64ipOv8KRjlsbR1GZUyhUhGF
zRMegrCgklC1A6bh2DJEGz82KQdhKYuuWJSA3WrSRLJBQSUQEWQdUhLpJIyb
vZ/Ri+fid/PcPU+46tsdahaDwWAuJmkxHosxloSGV6WTYEHXElTP+BDJyaro
rSLhdFrKpZJOPsycy+qxHkLgS/2QtieItokj4iuRH/ZJzdYsl4IL39fJBsL9
EZwK21VaL/GGgZG40PwEErs3oMPUfIzAzs9PbFovICBT7lF7/BYPCE/bZf2Y
FH5RaF9FfhYAHm7mOp9hKSSb4+/kWQJgn00muTkohabbhy8/nwyAhryIf833
aM9Xt5fcqn/fZRWB2dE3aHOLxZmOl/7Ymd01DxsU3th580MVy2e9sNd3r1E0
qb1gPLrI1n2X9gtdb8bEQ9p2Obuo/Q8ppIRlf2w77QVoNO32xIIUTtRXsUvd
S8FsyZgSLSHg8VVzP+Mjb2y2nDy/JdEbCj6Z9pxcS0Dko4z9rN850NHxeqbV
QOD+pFHF3EkRiR0us38Z9wXtByb3p5YTCDuupixVOYHAUfBiu6aLix2f5pxK
3uKPnbqgvx6fzoeaurXzWXoEC1M88cSVQKj8W2swFSLgGKlTN32DwDyuntkQ
haB3Ttmdu1MAJTZDpa6HBM3Ij/uVlAAcEddHWF+RQBr5r3RzArg27qrVWglo
MZeP9R0SwuetQyFkGAHbYhKahU7aqvKgtsbNy7BdEX0qJRUMw841bLOKAAZ7
qPNSkgSWNrUYL2wisQuUs5wPUhH2OllP9aMDCPxk2j21LWLsYR3jjPq4CAbV
2naUjaBsSUXutEAEssSNpb+efcvLdnaFFNF+uuJnpk3/vgupv6iZBNqGYmtU
DleM/WarOWdaIMF2UXp2633afj2uVTncUGge/G687QJtHz/N4Ytn3jIcla3M
oz2wIuafn3YhYLNTrcZyCcRGyW+MKhDcieHxHmdLoNFn0rBahuBIZQMzgycB
1Wj8JhaBoO2bY0ahMwTinu+dddtI3GfcHbvDnUl7urRf93Ij7ZDKGnu7B4H9
/x4o693gA18HY/824snUfijGjlYqFWMmIQi91CmmvsU9O1yW19UCSD5auLvR
lwB7v30qtjMIipKeOLvSCdA6NNtZzYFQdzCWf5Yi4E2uvOzPI4Hw7j/9B+wa
Ads=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
      3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}}, {{1, 4, 
     3}, {1, 3, 3}, {0, 1, 0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ/U7TccY+YQuHHxO8y42CRR3u5GwxbfVH8AP/feur
Dcfkp7Nqf/6tLQbnG4kznfqgI+Vw8Q7jstQL5g5bJr5eNkVcziGqQ+yT9nQz
OL8gqN9mZYkpnL/r2UeN4D4TB5eSfX3vfkrC+Rx5npvl/orA+WfT5EtbXfgd
LixrWxU21dSBn9Nqa18ru4PYRjfX0q1mcL5kyfv5256Zw/kw94nVN0RttBSA
80Mrfd4d/Ivg6++/nHIsWdAhjTtqtZazhUO85XOf+gpBh48r/ytcMEPwk7tn
K0kqIPjX10x78UrKwuEvS+KOFltBh4mhHJuVxCwcssOOW198K+Dg0rf1hsA+
cwftNak1K19yOjA9cXobcNsMzr80U/yK6SEEf8b8E4EeLgj+tTLpt7fvmzro
fQrPXWzF48AQ2JS4dqmpA9+//tjNIvwOeUUMYjFRpnD3w/hTLH1e7XovDOfD
4g89vgHGldq2
     "], {{21.35296762000001, 5.539839975}, {21.410564132500006`,
      7.054472587499999}, {22.223141957500008`, 7.308208575}, {
     22.551597745000006`, 7.308208575}, {23.547861745000006`, 7.308208575}, {
     23.644374820000007`, 5.9367889125}, {23.644374820000007`, 5.539839975}, {
     21.35296762000001, 5.539839975}}}], 
   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0,
     1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIxIGYCYm0x78szKq0chPjPPvx/Wdmh4XtprRGLpcOJ
6QEHExcj+HHN+758Y1d28PywXUVlM4L/Lvoes+BxS4cLX4SSJZ8owfk9VppN
ea8V4fzi87vcTkfzwfk/pqy1v3yCy0Hq2evzE1cj+DD70PmHp3gsmh7I4fA7
wldyQxiCv+rJvS9T7yD4PDunvA5RsILz83u9HgmnIPjejz38mB8g+DOqNkeW
21hj8GH2/++2ZZeYagXnw8ILnQ/zH3p4AgDcIp9B
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGItIGYC4k3/JvytKrBzmFU8dfJXdiEHGJ97x9ycnYd5
HJKep2d+/WDrcHiKx6LpgRwOj44WNdzNRPBbNt66tiMKwb90tcgxfq0NnC/g
+9Vue6CNw+9b8w3OSvI6eInHfGK7guAf3CHq+OqjjUP3+XU94SX8cP7at+Yq
//cKwPlhc44+s1MTcti9Y4b+8dU2Dnfeym8Qfy/ksHWHtNySVASf96zZtqV6
CP7KHYq/Y29aO+y44F1tmYjgsz96+Mh3oQCcP8H5yNmVcdwOone19m7usnFo
N1dMXjKTzSFse2u5INC/MP73p9fny2TYwfnvXzydvUDO3qGYs/3eI10eh8Nx
N87LW9k7bNEV+bVKVNAhrWv+q2Ybe4e4n+0d39IQ/L7i2QXrqxF8+aPvY85d
EILzV4Y3LNU0VoLzJXQM9usxKztkcsUVT41H8A0OO4T9+4PJV83pXPZ3gbLD
o9dlbYz9CH6NuVHmVwMEvyul09dojx2cH1y18YB+CIJ/5sV3o3OVtnC+xa9/
HydKYPJh9rdNzPzLWorgw9ITOv9sScgt9oNKcL70ySvCPvwIPiw9AgCTdDCe

    "]], FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4n0vD86VY3Zy6Hi/djHr4Sf2MH6Bqb5twNan
cP4HttO14tHP7Jcu+bPuzFtHhzVy+3xETr62Dzq64/aJQEcHvu3zaq7+ZnBI
W2UgvUfT0UHzjo38ejYBOH+NTFSKtbwYnN+2pUb4J5+sw71uTz2NSEeHpdOT
Ivr/KTr02R97dvyTo4MFj4Gtdo2KA8x+25zaN507EfxQzfaEZ4cR/M228lzc
lxF8pzOnZr/4puJw1e9HqvI/R4cFD5JcedlUHZgZP/LFfUPwX0VHN114ieA/
tP7Qer3c0cFWc7JU1GplBwsNBUd5XUeHyd93H0xUVnRI9HqcHfvGweHEu+XZ
k57IOjCbeR+yuOvgcMd+94sLFZJwPsy/MD5PhvGMC8zCDv1b6uO0Xzs4JKw5
Jfk0gcfBX7ct+4WBo4NW1CnnD/HMDqeu7dx7qcbRofFHGeNT1c/2MPftOFD8
/uGkh/Yw98P4MP/B+DD/L2D72qHT+sgePX4BsG7fUA==
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 
    1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYC4qIdomJZdS4OIf8VJilKCTs8+dm49V0cgq95
MqTgYISLwzqBjTI1zwQd2p6+5D7l7+LwjCW36IeKgINAS39jvrOLA9+//tjN
IvwO/E/i5VdbuTjsTlvhIFPE5+D3W7D++HNnOL+qVd7b4wyCn657Nav9lROc
/zzNzjov39lBKGPDys+ewg4Pbk4+JWHs4vB7Z/gchd0SDjD3OkzfVepxRwrO
t1j8bPWTc3Jw/rzwtqbHyxQdlH/u17Xhc3HwVmMy+Gml7NCVJNtuUuYM50+b
Xhgb+tIJzn/t7BQi0uvksHGLk/vDYkU4/9LEmH/OZfJwPgPb3Z3d3rIOHDfv
/rl5EsGvmcWhWnAWwV8rIsOr+QjBt4nOfjGTx9lhTSD/xRf7EfyOXfwOWX7y
cD7nM+fV71QVHKy8v3xa983JwenBJN07ixUcVrMsFbc7g+BXC/muqjqE4N94
1tovdgDBT1GNTm/Y4+Twp4Plh/B8BQdOw40rDG86OSzeftnQ6YmiQ7PV1hnh
Ms4Ods9WeGjNVXLoVNp3aHUKgr+qvHwH9zUE/27nXoGl3C4O+zdujGlgVoTz
uTKNOracloPzp61LkP64UNrBR7o5ouqss8OJ/a3aYc0SDgw10tFKnc4ON8XW
H34kIOZwtc763eVZTg57/u7MOGHHDQ/f9yJFS+fFc8H5/QreV3XMEPzDUzwW
TQ/kcDjzRbpbNdoFzkdPzwCdMy3j
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCse8xcXZNdnP46rfb72Y5hwOMn+LPNLt4Da+D
WPKqVY4lbg4elp/ZPscLOGiu+NRe4IzgZ39n22UoheDf+yC22JPRzaHG/9uD
/0f44PwDCz6+DOvigfPl/NVOnkvigus/PMVj0fRADoczr3W7Fjsj+O17ugyn
BiH4Isrez3YkuTm01E5zql7C4aB74kGRW76bw4fC7abGUZwOLmfd5vIXuzkE
pt1jXdrMCXd/1mHxO0encTo8/8G7o7gUwY+5tOb4jTIEXzdD4CpXBUI/jM+t
YzbnRToHnH/FSWWe+ywmh7PdsW/SfYDy9ktaWI/8tue/XSinqezm8HPT0frT
U7/Zqy6oaMkUdXPYGzrP4cbdL3D+n5yABV+6EHzOU/3B5wUR/I8nZ/M6//xk
/+DC0pPTpN0czuZkiNyJ/GRv68on+F0RwVdvYF+9TR/Bh8Xfy1Oyb5ir/9mj
xy8Af0fUnA==
    "]], FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1GtMk1cYB3DAya2llM609MIGDgQ3aLGBuQ4vj1p93xfI0OIklAoOSiRA
xeK4K7pqubPVLTLDRWqhBpSLMGCDIUOQbRoU3IBGEBQcFbaBDMQwR8b4dE6y
D/8Pv5z8z5fnnMctOkkWu8HCwsJyPUfWY7WeueoVU1sTCSMK96p2vjNkJOS/
y24nQRCmIuc8uNDTwTvxepiEHRWDupJhAThqVCRdSCHfay4tlvhh54zde6qR
Yed9H24zmEiBeNxf/Ei+fh5Qlt1FUaAI67dN2iqAFb8bx0d8KfDt6JQoxHzk
jIYXvXv28ZATT5Q8TjZyYSqp2rJkFwWGjQ4G+awznGTfydx7DFta1NZwOwu7
OGaDqqyKgp8NlVGBpVzklId/XC/z4COb46RvT21xgZORrtsawykYDVL66ppc
YNfQpVCaCHtRyfY4ZCaR56VeH2Z1kHCTVvqXUysfdL463ZEbJLCOWsucH/HA
MnlVNFZIQmTmfss/D7nAlYoDEgGJ+57SWb3xHeyaRdrsCz2B7MNd+Ol4OAGv
M1ZMX9c6I1ca/KYPN3KQG3b/qviO4MCBLu3h5VjsIp88dVEcdmQMf1KTjJ0a
9xktOJWAiXazVK3gQKfpvNezdAJW2RXera0cmP+EYZ1bRcBUH/1K6BgfGgMV
1+JfEWi+k0Pm8ww3/D4q9p8qvvMBtrS2PPO+koTgzAf9mrPYyoefpopDecg8
DuOCchMX3lOaCrNCSEjsI6HkGBvdXz+33X3tFhNKPbSGeToJfotD2T+eo8PS
7YjW6acEpLmGfaF3sYOaLwOCWmqxM/KSXrkZsLdJJpp3arFF4SFFC/EEzG5a
/iqLaw9pusSZjQUE9MpP2587aw9B1lECrZGA5/L4UzJ3OjI7QrYW/zED2adc
nkgFMFG/O/DlzGoBE6o7atlBadhXZVEptjLsNpM1p1tMQFO+JzuU4Yi8MGp0
yC2mI7O9fX8QvrQFkdPS8Hk1AQG9ooP1sTZgWjXt1NRgX572mIj9B1tVljai
8iLh8ZlZMr+bDlr9uMV2bxL05mV19vsO8Kwl5XpEAAlvhWy5+yDaHiIarIwl
cSTqzxVdWHj+DXYZ+W9pgj+FzN7M61w6TcHBduFVz7tM5N76fqNVnxNyC1Mo
rPRmwQBrZsdlNfa3DhrWgAr7zb2Fl65FY9//JS/dcf1/J0gmk/reYEFuTE5E
+lEKPhIUBNvfckL7Z19deI+/FQ165IGDXRMkmu/I7h7H5jZsYs/A7/Va7LWL
KrvP1SScMdvY1V2kIf+mfyLbKmIgj5lNruNLjiAsl0S6ZpAg+7s49uYoE5xN
4pUnOSSIN9e59Vew4P/79D94ykQ7
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4rLTmauaBHwc1shEpVjLiznA+D4XGwyWWUk6
vPIx5ZvA5OOg8ficNQufnIPmFT3Gy3u8HRTb0oPt3RUd1mv9XveiwNthjq32
kbpdyg59SyNfvWL2dljwIMmVl03VoYzhSGzsdy84f8mmPWwz3iP4u8U/n5vz
ysuhIM0/NuSjCpy/2Vaei/sygh+q2Z7w7DCCb5tT+6Zzp4pDeUf9jSAmb4fq
x/9fPoxVcbjHct/kbo23Q/3dl+cmpyg5CIe3BP4/7O3ApBm2iaNEDs6H+RfG
95rabLJvHp9DDvd576NTvR1MCsXZLk5lcHh98F3r519eDi7sC4uYDF/Zw+z/
wHa6Vjz6GZxfYKpvG7D1KZzf8X7tYtbDT+D8PcmrCwruPbKH+X/HgeL3Dyc9
tIeFD4wPCz8Yf8bRI88el3o7lMw29+Oa/9ne8eYU7TkHvB1Sp1R0pb1ndpDY
fpEhjtHHQXGqxK4Tm3ng8Vf988f9pUeFHNDjFwDPfuYs
    "]]},
  AspectRatio->Automatic,
  ImageSize->{58., 12.},
  PlotRange->{{0., 58.}, {0., 12.}}]], "Output",
 CellChangeTimes->{3.5166277612668257`*^9}]
}, Open  ]],

Cell["\<\
It should be easy to customize if though. Just overload NCTeXForm. In this \
example:\
\>", "Text",
 CellChangeTimes->{{3.454898412163022*^9, 3.454898436031858*^9}, {
  3.454898533813443*^9, 3.4548985444527283`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NCTeXForm", "[", 
   RowBox[{"BesselJ", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], "]"}], ":=", 
  RowBox[{"Format", "[", 
   RowBox[{
    RowBox[{"BesselJ", "[", 
     RowBox[{"x", ",", "y"}], "]"}], ",", "TeXForm"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.454898451534726*^9, 3.454898455085573*^9}, {
  3.454898495102592*^9, 3.454898529245335*^9}, {3.45489877067636*^9, 
  3.454898811070908*^9}, {3.454899344412693*^9, 3.4548993521393347`*^9}, {
  3.45489951083595*^9, 3.454899551747658*^9}, {3.4548996061167717`*^9, 
  3.454899634876369*^9}}],

Cell[" makes NCTeX produce", "Text",
 CellChangeTimes->{{3.4548996365776167`*^9, 3.4548996374892*^9}, {
  3.454944404227071*^9, 3.454944408424415*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NCTeX", "[", 
  RowBox[{"exp", ",", 
   RowBox[{"TeXProcessor", "\[Rule]", "NCTeXForm"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.45489882441739*^9, 3.4548988296614037`*^9}, 
   3.454899633681944*^9}],

Cell[BoxData[
 GraphicsBox[
  {Thickness[0.038461538461538464`], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 
    3, 3}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJLIGYCYpsN5bdKVaQckhk+5SfqKTk8q36dcbBUyuHv
u/RDB64qOfy/oWL/qEPKQULHYL8es7LDQq0P8VkbZOD8u0v+ZmUGysL5OjXH
rdL2Y/ItTrpm/85F8LOad4jbTlF22KyVPuVyk6yDak7nsr8LlB0Uas6KKxgj
+MeWcKretZCB8w/K7ciPuiYJ59elnOtbf1cCzp9wr0B+52RxOF9OZf6mr5ki
cL7hPEfn//LCcP4v5Y2eykeF4Hz5eaf4pvli8lfOyiqPdETwYf7b6JPS7TkX
wZ9xyeWlzEJhOP+w/tfPy9pE4Py2iEURwq8R/If6ad5hT0UR+q2NDxZcEXPY
JT5DlOuLksM86w2XJkuJO0QzM+Q8fYLgn/oyNfDbXASf90zqvzX1Sg65B+e8
usUq7lBnuyvnfLSSQ0hKssiuT2IOK8MblmoaKzncOfYr8X62kIOAq/nGMkUh
B955wbd0qgUdDiz4+DKsi8ehovHt7trZvA6Hp3gsmh7I4VD3lenv+VZOOL9x
fa/szyp2ON+uZ2vKLz9mByNODblELU6HY9Nn+f3hYXJ4V5tQ+2kSr4PDy19f
+jyZHJY9K2peWMPrsDI2Nt70DoLPFdSiv5yVGc73u7SwwkqHDc5nY3zx7KIz
h4Pw/4MX54sJwPlF0xYL1roKwvmSR4u8V3cJORxUbuVdpcTmcOet/Abx90IO
jDNq/kadYoHzNdZbib+OY4bzpzBMyLv/75/9LoHV9oeKEPwLz+7+nZbOD+f7
dt568y+Vy0Fv/XYNvqXMDu3mislLZrI5CCyZU9l8lRPOf8jgwi3VIgDnrw2q
WjZ9mohDyJoL3+Zd4Xbg0LKbeWuCqMMdLrYa5RuCDuj5DwDkuHnq
    "]], 
   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 
    0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4qZAz7kNdSoOdqGtbI++sTm8eqn8oZ0Rwe8r
YXN7903ZoWdnNqflHlYHwcem61ddUnaYqFqsk5/H5GBxxz3v7GJlh4AfObJz
7jM6mCz0TIpsV3bYa+LaMLmD0SFysdwiwSIlON+58PhsH3sE/8Es61/yQfJw
frn+95MPlRUd5tkx1VesZ3PIWmwl+2OhokNVzumGzTYcDkAnMxRUKTk8cf/T
9fU6l8OaPpmXa1qVHbgrWcwvyfA5wPxz0f7gUa5jAnB+VOqyLf/SheH8yb3s
0TqHxRwMOdbIvGIFutfaKGz2eQmHz+EnYlbaKcL5syZck7jCLQ/nl+3n+nB3
m4wD/3vLDTX5YnB+jvK8N8feCMP5Xpv43Le3Czkkefcv+3VD1iHUOFtTIVXI
YYbBrKlvpeXg/Nv689fs2Ivg71qoaf23Qd7BY/m6GrPHCP4x/T2TnrwVhvNN
fl0sOFUsAg8/Cx3ePyvKRB3uFSdYHvosC+c3f63nm3xezqGN0Xudk6O4g3z6
rA1nIxQccpSMxX+cE3c4M108gf8/gs/zKvpZSKISnJ/4YOf3AkllByHj3zZt
S0XhfIbIDr6HacJwvsrcxonb/wjA43fKF4Mtv9T5HPomvhGcdU7RYeWtvKb3
GjwOe07mX9T8K+PgW8HpV/vmrz0svDaVu0WLvvsD5wd81Z7LvwXBnzETBH7a
N3WtiucUUEHw0dIvAMkYMq4=
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4qQbiT5VlroOHe/XLmY9/MQexi8w1bcN2PoU
zv/AdrpWPPqZ/b/DPhONnug4rJHb5yNy8rX9JjdbF+USLQe+7fNqrv5mcGC6
LeP04bKmg+YdG/n1bAJw/hqZqBRreTE4v21LjfBPPlmHJwkNfQsmajksnZ4U
0f9P0WGxfnGB/A8dBwseA1vtGhUHmP22ObVvOnci+KGa7QnPDiP4m23lubgv
I/hOZ07NfvFNxWFfjnVur6quw4IHSa68bKoOpaZyghVsCL7IwuP3HK/owPnv
FKTfxvJoO9hqTpaKWq3s4Hnp1s2ah5oOk7/vPpiorOjwLup5S+k9DYcT75Zn
T3oi61DC2X7v0UINhzv2u19cqJCE82H+hfF5MoxnXGAWdljOHOm/9qaGQ8Ka
U5JPE3gcVjwral74QdNBK+qU84d4ZodJPY5nvBS0HRp/lDE+Vf1sD3PfjgPF
7x9OemgPcz+MD/MfjA/z/wK2rx06rY/s0eMXAFts1vQ=
    "]], 
   FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGJZIIaxWZDYzKNsitgMUD4IAAAtOgKd
    "], CompressedData["
1:eJxd1G00m2cYB3BCvUQQGpEIxWjVijzPk7Bpetqrp5yaacujTY403Zw2VNu0
lrJprUGNOvRYrS/pjlaFTk0bb2cc1Y0h0k1nDq3OvGaMrKmpGrYZh/l0Pzv7
8P/w+/C/PtzXuS/vo8lkgoWZmZn5esTroa0nOqx3QpxCwE8y37vNPA6c6JvL
c8kmwF1yOmJmMxeWklmOY18TsKOkt0j93B2urzbrzBUCZNt41n7ZOcrZ9akL
rxoo5ymv7s43CYAYDSYGpe5wUemCJd4VgEzSbZPs7w6J8mCaWikA7NE3oTKC
h3y+Zla3e48bsuKMeuRsBRe2D/mFuBQKoHyDfbnUxAGx3/GtZ3oprzpHFSms
hchF7VMML4kQvi8vfT+ymIv8Yd/0/VubecjGpDDPiS0ecKjJ88ZenQCG3pVj
RfUeMFdOH1o7TTmu0051eYRAJnP4lYYcAursiuecGnlw4/BarDqRAOcjViRn
0A3OjQ1cLfUj4L30cPPfYzzgq2BFhbcGR/3O9QcTSijrDX9adsVgyGVxGbnK
XD78c/7vgZtVHOTScuHUwVpX5Jpdz2QP97qCxav+psomyrwHY9ssOyjLs7e9
HDVR7lDrrtGW+DDWbAxTylxhpsr4Sa05BivskoDGRlcgW5d3/iXGYELPuBM7
zIP+KzczW1cwtN+3v9ButyJx5Lpc/b6zFymvRnG25gziEJXe052dSVnel/oR
EeuG7ObqkCNncaG7ozDylxocFPoIUMez0fzqmbd811qYUBVuSnvsj4Pwj/6M
x1kMkGWoSxr6MEjzklzReNjCd57irphjlE/YtXoGHqT8s+LW53I3ypVxy+rr
P/DBxFq89jGXDgm8hxaLPhjopBfoWZl0YFiXnJqXYvCb9GQK6ctAZh8m104e
ckAOvC1VvCNion5b5MKLlQImqAzyttUVPvIHu0SiheOUdbGD7U9fBkF9vh87
1sER+fVQhX1eIQOZHYB9G7RgA/dDC1rGp/gg0vGjqxOswXfh05qZeAz5nv7N
2QYrHDkG7zF0xuMwojJF5LcxIEtULJQk4aAxLiozQuxhh/xJnuYSDpsObOnq
OUqHQMnkBfb4f/qsFxub0whk7eXhpLZ0AXLZzo0Pem2FEN0cVObXxUTWVXdX
0PROyA3MoKDSAGdgedVqufMC5EmXXyV505RvZyweCXlOmal57WOz/r9PhY4n
6y2dIad92jT4RAD73Qui6C1O6P7s0cZ1BNPsYLk25VnijwTar0/6MXKfirKF
SmUTzqOcuulR+IZ5HFRGa1vtZ3bIkxoD6c93QB42DniNzjvCU4Kc9acRQC4V
JtQNMeHel2E+VR4EEG9ovbtLnOH/9/Rfceo/KA==
    "]], 
   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1,
     3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYtk5dh+DNpg7rJGJSrGWF3OA8X0uNhgss5J0
YJ5/dUfuFHMHjcfnrFn45Bya156Y95nD3EGxLT3Y3l3RoTcq8ZdcoZnDHFvt
I3W7lB18A+QKlaebOix4kOTKy6bqIMP2OZyjDsGvyHqysjYPwV9qEmjVnmLq
UJDmHxvyUQXO32wrz8V9GcEP1WxPeHYYwbfNqX3TuVPFQU4sy/fzZFOH6sf/
Xz6MVXF4y6fJxtFp5lB/9+W5ySlKDmGbi+19xM0dmDTDNnGUyMH5MP/C+F5T
m032zeNz4JDhNLmxy8zBpFCc7eJUBgfWTo8VJq2mDi7sC4uYDF/Zw+z/wHa6
Vjz6GZxfYKpvG7D1KZzf8X7tYtbDT+D8PcmrCwruPbKH+X/HgeL3Dyc9tIeF
D4wPCz8YP2HCl0zRajOHktnmflzzP9tv2j7lc6uAuUPqlIqutPfMDgnFfPM4
JwHjY6rErhObeeDxV/3zx/2lR4Uc0OMXAH9rx4Y=
    "]]},
  AspectRatio->Automatic,
  ImageSize->{26., 12.},
  PlotRange->{{0., 26.}, {0., 12.}}]], "Output",
 CellChangeTimes->{3.516627761651888*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{920, 856},
WindowMargins->{{Automatic, 3}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 6, \
2010)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3516602558-9938753"->{
  Cell[468417, 8546, 223, 4, 49, "Print",
   CellTags->"Info3516602558-9938753"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3516602558-9938753", 614919, 11259}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 203, 3, 74, "Title"],
Cell[773, 27, 145, 5, 59, "Subsubtitle"],
Cell[CellGroupData[{
Cell[943, 36, 157, 2, 89, "Section"],
Cell[1103, 40, 957, 25, 53, "Text"],
Cell[2063, 67, 534, 11, 51, "Text"],
Cell[CellGroupData[{
Cell[2622, 82, 342, 6, 66, "Input"],
Cell[CellGroupData[{
Cell[2989, 92, 137, 2, 25, "Print"],
Cell[3129, 96, 269, 6, 25, "Print"],
Cell[3401, 104, 365, 8, 25, "Print"],
Cell[3769, 114, 110, 1, 25, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3940, 122, 241, 3, 89, "Section"],
Cell[4184, 127, 236, 4, 70, "Text"],
Cell[CellGroupData[{
Cell[4445, 135, 748, 20, 85, "Input"],
Cell[5196, 157, 394, 12, 46, "Output"],
Cell[5593, 171, 195, 2, 66, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5837, 179, 162, 2, 89, "Section"],
Cell[6002, 183, 632, 19, 53, "Text"],
Cell[6637, 204, 229, 6, 46, "Input"],
Cell[CellGroupData[{
Cell[6891, 214, 126, 2, 46, "Input"],
Cell[7020, 218, 34777, 624, 59, "Output"]
}, Open  ]],
Cell[41812, 845, 136, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[41973, 850, 592, 19, 66, "Input"],
Cell[42568, 871, 443, 16, 69, "Output"],
Cell[43014, 889, 28669, 507, 71, "Output"]
}, Open  ]],
Cell[71698, 1399, 320, 5, 51, "Text"],
Cell[CellGroupData[{
Cell[72043, 1408, 288, 7, 66, "Input"],
Cell[72334, 1417, 187, 6, 46, "Output"],
Cell[72524, 1425, 18990, 338, 46, "Output"]
}, Open  ]],
Cell[91529, 1766, 176, 4, 32, "Text"],
Cell[CellGroupData[{
Cell[91730, 1774, 913, 18, 66, "Input"],
Cell[92646, 1794, 347, 10, 46, "Output"],
Cell[92996, 1806, 29452, 524, 47, "Output"]
}, Open  ]],
Cell[122463, 2333, 111, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[122599, 2338, 648, 14, 66, "Input"],
Cell[123250, 2354, 213, 7, 46, "Output"],
Cell[123466, 2363, 7601, 134, 64, "Output"]
}, Open  ]],
Cell[131082, 2500, 274, 5, 51, "Text"],
Cell[CellGroupData[{
Cell[131381, 2509, 242, 5, 46, "Input"],
Cell[131626, 2516, 7603, 134, 64, "Output"]
}, Open  ]],
Cell[139244, 2653, 265, 5, 51, "Text"],
Cell[139512, 2660, 645, 20, 66, "Input"],
Cell[CellGroupData[{
Cell[140182, 2684, 103, 1, 42, "Subsection"],
Cell[140288, 2687, 281, 5, 51, "Text"],
Cell[CellGroupData[{
Cell[140594, 2696, 775, 23, 66, "Input"],
Cell[141372, 2721, 445, 16, 69, "Output"]
}, Open  ]],
Cell[141832, 2740, 349, 7, 51, "Text"],
Cell[CellGroupData[{
Cell[142206, 2751, 165, 3, 46, "Input"],
Cell[142374, 2756, 1252, 34, 217, "Output"]
}, Open  ]],
Cell[143641, 2793, 255, 6, 51, "Text"],
Cell[CellGroupData[{
Cell[143921, 2803, 564, 13, 66, "Input"],
Cell[144488, 2818, 1312, 40, 215, "Output"],
Cell[145803, 2860, 302121, 5218, 145, "Output"]
}, Open  ]],
Cell[447939, 8081, 882, 27, 107, "Text"],
Cell[CellGroupData[{
Cell[448846, 8112, 478, 10, 66, "Input"],
Cell[449327, 8124, 126, 3, 46, "Output"],
Cell[CellGroupData[{
Cell[449478, 8131, 133, 2, 25, "Print"],
Cell[449614, 8135, 281, 6, 25, "Print"],
Cell[449898, 8143, 258, 6, 25, "Print"],
Cell[450159, 8151, 456, 11, 64, "Print"],
Cell[450618, 8164, 450, 11, 45, "Print"],
Cell[451071, 8177, 422, 11, 25, "Print"],
Cell[451496, 8190, 272, 6, 25, "Print"]
}, Open  ]],
Cell[451783, 8199, 12754, 224, 46, "Output"]
}, Open  ]],
Cell[464552, 8426, 191, 4, 32, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[464780, 8435, 121, 1, 42, "Subsection"],
Cell[464904, 8438, 588, 18, 34, "Text"],
Cell[CellGroupData[{
Cell[465517, 8460, 143, 3, 46, "Input"],
Cell[465663, 8465, 2441, 68, 152, "Print"]
}, Open  ]],
Cell[468119, 8536, 151, 2, 32, "Text"],
Cell[CellGroupData[{
Cell[468295, 8542, 119, 2, 46, "Input"],
Cell[468417, 8546, 223, 4, 49, "Print",
 CellTags->"Info3516602558-9938753"]
}, Open  ]],
Cell[468655, 8553, 316, 7, 51, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[469008, 8565, 106, 1, 42, "Subsection"],
Cell[469117, 8568, 109, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[469251, 8573, 674, 15, 66, "Input"],
Cell[469928, 8590, 260, 8, 46, "Output"],
Cell[470191, 8600, 17892, 313, 51, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[488120, 8918, 1652, 40, 85, "Input"],
Cell[489775, 8960, 872, 28, 100, "Output"],
Cell[490650, 8990, 87210, 1550, 59, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[577897, 10545, 479, 11, 66, "Input"],
Cell[578379, 10558, 186, 5, 46, "Output"],
Cell[578568, 10565, 10010, 176, 59, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[588639, 10748, 120, 1, 89, "Section"],
Cell[588762, 10751, 258, 5, 51, "Text"],
Cell[CellGroupData[{
Cell[589045, 10760, 308, 7, 66, "Input"],
Cell[589356, 10769, 128, 3, 46, "Output"],
Cell[589487, 10774, 5323, 95, 46, "Output"]
}, Open  ]],
Cell[594825, 10872, 86, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[594936, 10877, 200, 4, 46, "Input"],
Cell[595139, 10883, 12754, 224, 46, "Output"]
}, Open  ]],
Cell[607908, 11110, 226, 5, 32, "Text"],
Cell[608137, 11117, 583, 13, 46, "Input"],
Cell[608723, 11132, 151, 2, 32, "Text"],
Cell[CellGroupData[{
Cell[608899, 11138, 225, 5, 46, "Input"],
Cell[609127, 11145, 5321, 95, 46, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
