(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    194957,       5321]
NotebookOptionsPosition[    191928,       5216]
NotebookOutlinePosition[    192404,       5235]
CellTagsIndexPosition[    192361,       5232]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\

SINGULAR PERTURBATION
     NCAlgebra NOTEBOOK
           follows CDC99
         by  Dell   and Bill
         
         This is an old version (pre 2000) of the SingularPerturbation.nb
\
\>", "Title",
 CellChangeTimes->{{3.471815333148844*^9, 3.4718153513171577`*^9}}],

Cell[CellGroupData[{

Cell["The system we study and its control (Sec 2)", "Section"],

Cell[TextData[{
 "\n\n",
 Cell[BoxData[{
  RowBox[{
   RowBox[{
    RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
       {
        FractionBox["dx", "dt"]},
       {
        RowBox[{"\[Epsilon]", 
         FractionBox["dz", "dt"]}]}
      }], "\[NegativeThinSpace]", ")"}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
         {
          SubscriptBox["A", "11"], 
          SubscriptBox["A", "12"]},
         {
          SubscriptBox["A", "21"], 
          SubscriptBox["A", "22"]}
        }], "\[NegativeThinSpace]", ")"}], 
      RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
         {"x"},
         {"z"}
        }], "\[NegativeThinSpace]", ")"}]}], " ", "+", " ", 
     RowBox[{
      RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
         {
          SubscriptBox["B", "1"]},
         {
          SubscriptBox["B", "2"]}
        }], "\[NegativeThinSpace]", ")"}], " ", "u"}]}]}], "\n"}], "\n", 
  RowBox[{
   RowBox[{"y", " ", "=", " ", 
    RowBox[{
     RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
        {
         SubscriptBox["M", "1"], 
         SubscriptBox["M", "2"]}
       }], "\[NegativeThinSpace]", ")"}], 
     RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
        {"x"},
        {"z"}
       }], "\[NegativeThinSpace]", ")"}]}]}], "\n", "\t"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"Minimize", "   ", "J"}], " ", "=", "  ", 
    RowBox[{
     RowBox[{
      SubsuperscriptBox["\[Integral]", "0", "\[Infinity]"], "   ", 
      RowBox[{
       SuperscriptBox["y", "T"], "  ", "y"}]}], " ", "+", " ", 
     RowBox[{
      SuperscriptBox["u", "T"], " ", "R", " ", "u", "     ", "dt"}]}]}], 
   "\n"}], "\n", 
  RowBox[{
  "where", "  ", "R", " ", "is", " ", "a", " ", "positive", " ", "definite", 
   " ", "weight", " ", 
   RowBox[{"matrix", ".", "\n", "It"}], " ", "is", " ", "well", " ", "known", 
   " ", "that", " ", "the", " ", "solution", " ", "to", " ", "this", " ", 
   "problem"}], "\n", 
  RowBox[{
   RowBox[{"is", " ", "of", " ", "the", " ", "form"}], " ", "\n"}], "\n", 
  RowBox[{
   RowBox[{
    SuperscriptBox["u", "*"], " ", "=", "  ", 
    RowBox[{
     RowBox[{"-", " ", 
      SuperscriptBox["R", 
       RowBox[{"-", "1"}]]}], "  ", 
     SuperscriptBox["B", "T"], "  ", "K", 
     RowBox[{"(", "\[Epsilon]", ")"}], " ", 
     RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
        {"x"},
        {"z"}
       }], "\[NegativeThinSpace]", ")"}]}]}], "\n"}], "\n", 
  RowBox[{
   RowBox[{
   "where", "  ", "K", " ", "is", " ", "the", " ", "solution", " ", "to", " ",
     "the", " ", "ARE"}], "\n"}], "\n", 
  RowBox[{"        ", 
   RowBox[{
    RowBox[{
     RowBox[{"K", " ", "A"}], "  ", "+", " ", 
     RowBox[{
      SuperscriptBox["A", "T"], "K"}], " ", "-", " ", 
     RowBox[{"K", " ", "B", "  ", 
      SuperscriptBox["R", 
       RowBox[{"-", "1"}]], "   ", 
      SuperscriptBox["B", "T"], " ", "K"}], "  ", "+", " ", 
     RowBox[{
      SuperscriptBox["M", "T"], "  ", "M"}]}], " ", "=", " ", "0"}], 
   "\n"}], "\n", 
  RowBox[{"with", " ", "\n"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"A", " ", "=", "    ", 
     RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
        {
         SubscriptBox["A", "11"], 
         SubscriptBox["A", "12"]},
        {
         FractionBox[
          SubscriptBox["A", "21"], "\[Epsilon]"], 
         FractionBox[
          SubscriptBox["A", "22"], "\[Epsilon]"]}
       }], "\[NegativeThinSpace]", ")"}]}], ",", "  ", 
    RowBox[{"B", " ", "=", "   ", 
     RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
        {
         SubscriptBox["B", "1"]},
        {
         FractionBox[
          SubscriptBox["B", "2"], "\[Epsilon]"]}
       }], "\[NegativeThinSpace]", ")"}]}], ",", "  ", "\n", "           ", 
    RowBox[{
     RowBox[{"and", "   ", "M"}], " ", "=", " ", 
     RowBox[{"(", "\[NegativeThinSpace]", GridBox[{
        {
         SubscriptBox["M", "1"], 
         SubscriptBox["M", "2"]}
       }], "\[NegativeThinSpace]", ")"}]}]}], "\n"}], "\n", 
  RowBox[{"K", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["K", "0"], " ", "+", "   ", 
      RowBox[{"\[Epsilon]", " ", 
       SubscriptBox["K", "1"]}], "  ", "+", " ", 
      RowBox[{
       SuperscriptBox["\[Epsilon]", "2"], "  ", 
       SubscriptBox["K", "2"]}], " ", "+"}], " ", "..."}], "."}]}], "\n", 
  RowBox[{"\t\t"}]}]],
 "\n"
}], "Text"],

Cell[TextData[{
 "Format K compatibly with the partitioning of A using the notation\nof \
[KKO86].\n\t\tK = ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"i", "=", "0"}], "\[Infinity]"], 
    SuperscriptBox["\[Epsilon]", "i"]}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", GridBox[{
      {
       SubscriptBox["k", 
        RowBox[{"1", "i"}]], 
       RowBox[{"\[Epsilon]", " ", 
        SubscriptBox["k", 
         RowBox[{"2", "i"}]]}]},
      {
       RowBox[{"\[Epsilon]", " ", 
        SubsuperscriptBox["k", 
         RowBox[{"2", "i"}], "T"]}], 
       RowBox[{"\[Epsilon]", " ", 
        SubscriptBox["k", 
         RowBox[{"3", "i"}]]}]}
     }], ")"}], TraditionalForm]]],
 "\n\n"
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Computer Algebra vs the problem (Sec3)", "Section"],

Cell[CellGroupData[{

Cell["\<\

The ZEROth order term of the Riccati equation (Sec3.1)\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["\<\

Computer Algebra Finds the Basic Equation (Sec 3.1.1)\
\>", "Subsubsection"],

Cell["\<\

We begin by  setting the matrices in our problem to 
be noncommutative.\
\>", "Text"],

Cell["\<\

SetNonCommutative[
\tk10,k20,k30,A11, 
\tA12,A21,A22,B1,B2,M1,M2,R
\t];\
\>", "Input"],

Cell[TextData[{
 "Next we create the first term of the power series \n      \n         K  =   \
",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["K", "0"], " ", "+", 
     RowBox[{"\[Epsilon]", " ", 
      SubscriptBox["K", "1"]}], "+", " ", 
     RowBox[{
      SuperscriptBox["\[Epsilon]", "2"], "  ", 
      SubscriptBox["K", "2"]}], " ", "+"}], " ", "..."}], "."}]],
  FontFamily->"Bold"],
 "\n\nIt contains an \[Epsilon]."
}], "Text"],

Cell[CellGroupData[{

Cell["\<\

K0 = {{k10, ep**k20},
     {ep**tp[k20], ep**k30 }};
     
K0//MatrixForm     \
\>", "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", GridBox[{
     {"k10", 
      RowBox[{"ep", " ", "k20"}]},
     {
      RowBox[{"ep", " ", 
       RowBox[{"tp", "[", "k20", "]"}]}], 
      RowBox[{"ep", " ", "k30"}]}
    }], ")"}],
  MatrixForm[#]& ]], "Output"]
}, Open  ]],

Cell["\<\

Next we define the block matrices present in our problem.
\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
A  = {{A11, A12},
      {(1/ep)**A21,(1/ep)**A22}};
B  = {{B1},{(1/ep)**B2}};
Mm = {{M1,M2}}; 

A//MatrixForm 
B//MatrixForm
Mm//MatrixForm\
\>", "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", GridBox[{
     {"A11", "A12"},
     {
      FractionBox["A21", "ep"], 
      FractionBox["A22", "ep"]}
    }], ")"}],
  MatrixForm[#]& ]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", GridBox[{
     {"B1"},
     {
      FractionBox["B2", "ep"]}
    }], ")"}],
  MatrixForm[#]& ]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", GridBox[{
     {"M1", "M2"}
    }], ")"}],
  MatrixForm[#]& ]], "Output"]
}, Open  ]],

Cell[TextData[{
 "The following ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " input creates a function which \nmakes Riccatis and sets G to be the \
optimal control.\n"
}], "Text"],

Cell[CellGroupData[{

Cell["\<\
Riccati[K_] := MatMult[K,A] + 
\tMatMult[tpMat[A],K ] -
\tMatMult[K,B,{{Inv[R]}},tpMat[B],K] +
\tMatMult[tpMat[Mm],Mm]

G = - MatMult[{{Inv[R]}},tpMat[B],K0]\
\>", "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       RowBox[{"Inv", "[", "R", "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}], "**", "k10"}]}], "-", 
     RowBox[{
      RowBox[{"Inv", "[", "R", "]"}], "**", 
      RowBox[{"tp", "[", "B2", "]"}], "**", 
      RowBox[{"tp", "[", "k20", "]"}]}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "ep"}], " ", 
      RowBox[{
       RowBox[{"Inv", "[", "R", "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}], "**", "k20"}]}], "-", 
     RowBox[{
      RowBox[{"Inv", "[", "R", "]"}], "**", 
      RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}]}], "}"}], 
  "}"}]], "Output"]
}, Open  ]],

Cell["\<\

\
\>", "Input"],

Cell["\<\
Extract the zero-th order terms in \[Epsilon] 
from the upper left entry of the perturbed
Riccati  to create a polynomial. \
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\

Ep10 = NCTermsOfDegree[ 
\t\t\tRiccati[K0][[1,1]],{ep},{0} ]\
\>", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k10", "**", "A11"}], "+", 
  RowBox[{"k20", "**", "A21"}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "A11", "]"}], "**", "k10"}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "A21", "]"}], "**", 
   RowBox[{"tp", "[", "k20", "]"}]}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "M1", "]"}], "**", "M1"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"k10", "**", "B1"}], "+", 
     RowBox[{"k20", "**", "B2"}]}], ")"}], "**", 
   RowBox[{"Inv", "[", "R", "]"}], "**", 
   RowBox[{"tp", "[", "B1", "]"}], "**", "k10"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"k10", "**", "B1"}], "+", 
     RowBox[{"k20", "**", "B2"}]}], ")"}], "**", 
   RowBox[{"Inv", "[", "R", "]"}], "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", 
   RowBox[{"tp", "[", "k20", "]"}]}]}]], "Output"]
}, Open  ]],

Cell["\<\
Extract the zero-th order terms in \[Epsilon] from the upper right entry of \
the perturbed Riccati  to create a polynomial. \
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
Ep20 = NCTermsOfDegree[ 
\t\t\tRiccati[K0][[1,2]],{ep},{0} ]\
\>", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k10", "**", "A12"}], "+", 
  RowBox[{"k20", "**", "A22"}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "A21", "]"}], "**", "k30"}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "M1", "]"}], "**", "M2"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"k10", "**", "B1"}], "+", 
     RowBox[{"k20", "**", "B2"}]}], ")"}], "**", 
   RowBox[{"Inv", "[", "R", "]"}], "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
NCCollect[ NCExpand[Ep20], {k20}]

\
\>", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k10", "**", "A12"}], "+", 
  RowBox[{"k20", "**", 
   RowBox[{"(", 
    RowBox[{"A22", "-", 
     RowBox[{"B2", "**", 
      RowBox[{"Inv", "[", "R", "]"}], "**", 
      RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "A21", "]"}], "**", "k30"}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "M1", "]"}], "**", "M2"}], "-", 
  RowBox[{"k10", "**", "B1", "**", 
   RowBox[{"Inv", "[", "R", "]"}], "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}]], "Output"]
}, Open  ]],

Cell["\<\
Notice that by assuming the invertibility of  
                               (A22-B2**Inv[R]**tp[B2]**k30)
 in the above equation we can solve for k20.

         k20 = ( k10**A12  +tp[A21]**k30+
               tp[M1]**M2-k10**B1**Inv[R]**tp[B2]**k30 ) **   
               Inv[ A22-B2**Inv[R]**tp[B2]**k30 ]

This observation will be used below.
\
\>", "Text"],

Cell["\<\
Next, extract the zero-th order terms in \[Epsilon]  from the 
lower right entry of the perturbed Riccati  to create a polynomial. 
\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
Ep30 = NCTermsOfDegree[ 
\t\t\tRiccati[K0][[2,2]],{ep},{0} ]
\
\>", "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k30", "**", "A22"}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "A22", "]"}], "**", "k30"}], "+", 
  RowBox[{
   RowBox[{"tp", "[", "M2", "]"}], "**", "M2"}], "-", 
  RowBox[{"k30", "**", "B2", "**", 
   RowBox[{"Inv", "[", "R", "]"}], "**", 
   RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}]], "Output"]
}, Open  ]],

Cell["\<\
Notice that the above equation is a Riccati in k30 and can be used to
determine this matrix.

The matrix which is still unknown is k10.  Solving for it by hand is a bit \
tricky, see Section 3.4 [KKO86].
Solving for k10 by computer is what  we turn to after introducing  other \
basic though rinky dink algebraic identities.
\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["    Other Algebraic Identities Known to Hold (Sec 3.1.3)    ", \
"Subsubsection"],

Cell["\<\

Abbreviations which are standard conventions in the field [KKO86]:\
\>", "Text"],

Cell["\<\

SetNonCommutative[G1,G2,N0,M0,A0,B0,R0];
Abbreviations = {
\tG1 == G[[1,1]]/.ep->0,
\tG2 == G[[1,2]]/.ep->0,
\tN0 == - M2**Inv[A22]**B2,
\tM0 == M1 - M2**Inv[A22]**A21,
\tA0 == A11 - A12 ** Inv[A22]**A21,
\tB0 == B1 - A12**Inv[A22]**B2,
\tR0 == R + tp[N0]**N0
\t};\
\>", "Input"],

Cell["\<\

Also some of our matrices are known to be self adjoint.\
\>", "Text"],

Cell["\<\

SelfAdjoint = {
\tk10 == tp[k10],
\tk30 == tp[k30],
\tR == tp[R],
\tR0 == tp[R0],
\tInv[R] == tp[Inv[R]],
\tInv[R0] == tp[Inv[R0]]
\t};\
\>", "Input"],

Cell["\<\
It is standard that A0, A11, and A22 are invertible.
Also, the fast  sub-system is (assumed ) strictly stable which makes
                   A22 + B2**G2  invertible.  
Recall  the 
              invertibility of    A22 - B2**Inv[R]**tp[B2]**k30 
 follows from our solution for k20.
We make the resulting relations with the next command.\
\>", "Text"],

Cell["\<\

inverses = NCMakeRelations[{Inv,
\tR,R0,A0,A11,A22,(A22 + B2**G2), 
\t(A22 - B2**Inv[R]**tp[B2]**k30) }];\
\>", "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Solving for k10 using a  Grobner Basis.\
\>", "Subsubsection"],

Cell["\<\
Next we combine all the relations created above and add in 
their tranposes. 
\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
Relations = Union[{Ep10,Ep20,Ep30},
 \tAbbreviations,
\tSelfAdjoint, inverses ];

AllRelations = NCAddTp[ Relations ]\
\>", "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"A0", "==", 
    RowBox[{"A11", "-", 
     RowBox[{"A12", "**", 
      RowBox[{"Inv", "[", "A22", "]"}], "**", "A21"}]}]}], ",", 
   RowBox[{"B0", "==", 
    RowBox[{"B1", "-", 
     RowBox[{"A12", "**", 
      RowBox[{"Inv", "[", "A22", "]"}], "**", "B2"}]}]}], ",", 
   RowBox[{"G1", "==", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       RowBox[{"Inv", "[", "R", "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}], "**", "k10"}]}], "-", 
     RowBox[{
      RowBox[{"Inv", "[", "R", "]"}], "**", 
      RowBox[{"tp", "[", "B2", "]"}], "**", 
      RowBox[{"tp", "[", "k20", "]"}]}]}]}], ",", 
   RowBox[{"G2", "==", 
    RowBox[{"-", 
     RowBox[{
      RowBox[{"Inv", "[", "R", "]"}], "**", 
      RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}]}], ",", 
   RowBox[{"k10", "==", 
    RowBox[{"tp", "[", "k10", "]"}]}], ",", 
   RowBox[{"k30", "==", 
    RowBox[{"tp", "[", "k30", "]"}]}], ",", 
   RowBox[{"M0", "==", 
    RowBox[{"M1", "-", 
     RowBox[{"M2", "**", 
      RowBox[{"Inv", "[", "A22", "]"}], "**", "A21"}]}]}], ",", 
   RowBox[{"N0", "==", 
    RowBox[{"-", 
     RowBox[{"M2", "**", 
      RowBox[{"Inv", "[", "A22", "]"}], "**", "B2"}]}]}], ",", 
   RowBox[{"R", "==", 
    RowBox[{"tp", "[", "R", "]"}]}], ",", 
   RowBox[{"R0", "==", 
    RowBox[{"R", "+", 
     RowBox[{
      RowBox[{"tp", "[", "N0", "]"}], "**", "N0"}]}]}], ",", 
   RowBox[{"R0", "==", 
    RowBox[{"tp", "[", "R0", "]"}]}], ",", 
   RowBox[{
    RowBox[{"Inv", "[", "R", "]"}], "==", 
    RowBox[{"tp", "[", 
     RowBox[{"Inv", "[", "R", "]"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Inv", "[", "R0", "]"}], "==", 
    RowBox[{"tp", "[", 
     RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"A0", "**", 
     RowBox[{"Inv", "[", "A0", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{"A11", "**", 
     RowBox[{"Inv", "[", "A11", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{"A22", "**", 
     RowBox[{"Inv", "[", "A22", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{"R", "**", 
     RowBox[{"Inv", "[", "R", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{"R0", "**", 
     RowBox[{"Inv", "[", "R0", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "[", "A0", "]"}], "**", "A0"}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "[", "A11", "]"}], "**", "A11"}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "[", "A22", "]"}], "**", "A22"}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "[", "R", "]"}], "**", "R"}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "[", "R0", "]"}], "**", "R0"}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "[", 
      RowBox[{"A22", "+", 
       RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
     RowBox[{"(", 
      RowBox[{"A22", "+", 
       RowBox[{"B2", "**", "G2"}]}], ")"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "[", 
      RowBox[{"A22", "-", 
       RowBox[{"B2", "**", 
        RowBox[{"Inv", "[", "R", "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], "**", 
     RowBox[{"(", 
      RowBox[{"A22", "-", 
       RowBox[{"B2", "**", 
        RowBox[{"Inv", "[", "R", "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ")"}]}], "==", "1"}],
    ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"A22", "+", 
       RowBox[{"B2", "**", "G2"}]}], ")"}], "**", 
     RowBox[{"Inv", "[", 
      RowBox[{"A22", "+", 
       RowBox[{"B2", "**", "G2"}]}], "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"A22", "-", 
       RowBox[{"B2", "**", 
        RowBox[{"Inv", "[", "R", "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ")"}], "**", 
     RowBox[{"Inv", "[", 
      RowBox[{"A22", "-", 
       RowBox[{"B2", "**", 
        RowBox[{"Inv", "[", "R", "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}]}], "==", "1"}],
    ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "A0", "]"}], "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "A0", "]"}], "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "A11", "]"}], "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "A11", "]"}], "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "A22", "]"}], "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"tp", "[", "G2", "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}]}], "+", 
       RowBox[{"tp", "[", "A22", "]"}]}], ")"}], "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", 
       RowBox[{"A22", "+", 
        RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"tp", "[", "k30", "]"}], "**", "B2", "**", 
         RowBox[{"tp", "[", 
          RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
         RowBox[{"tp", "[", "B2", "]"}]}]}], "+", 
       RowBox[{"tp", "[", "A22", "]"}]}], ")"}], "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", 
       RowBox[{"A22", "-", 
        RowBox[{"B2", "**", 
         RowBox[{"Inv", "[", "R", "]"}], "**", 
         RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], "]"}]}], "==",
     "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "R", "]"}], "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "R0", "]"}], "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "A0", "]"}], "]"}], "**", 
     RowBox[{"tp", "[", "A0", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "A11", "]"}], "]"}], "**", 
     RowBox[{"tp", "[", "A11", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
     RowBox[{"tp", "[", "A22", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
     RowBox[{"tp", "[", "R", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
     RowBox[{"tp", "[", "R0", "]"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", 
       RowBox[{"A22", "+", 
        RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"tp", "[", "G2", "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}]}], "+", 
       RowBox[{"tp", "[", "A22", "]"}]}], ")"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", 
       RowBox[{"A22", "-", 
        RowBox[{"B2", "**", 
         RowBox[{"Inv", "[", "R", "]"}], "**", 
         RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], "]"}], "**", 
     
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"tp", "[", "k30", "]"}], "**", "B2", "**", 
         RowBox[{"tp", "[", 
          RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
         RowBox[{"tp", "[", "B2", "]"}]}]}], "+", 
       RowBox[{"tp", "[", "A22", "]"}]}], ")"}]}], "==", "1"}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "A0", "]"}], "==", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       RowBox[{"tp", "[", "A21", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}]}], "+", 
     RowBox[{"tp", "[", "A11", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "B0", "]"}], "==", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}]}], "+", 
     RowBox[{"tp", "[", "B1", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "G1", "]"}], "==", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"k20", "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}], "-", 
     RowBox[{
      RowBox[{"tp", "[", "k10", "]"}], "**", "B1", "**", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "G2", "]"}], "==", 
    RowBox[{"-", 
     RowBox[{
      RowBox[{"tp", "[", "k30", "]"}], "**", "B2", "**", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "k10", "]"}], "==", "k10"}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "k30", "]"}], "==", "k30"}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "M0", "]"}], "==", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       RowBox[{"tp", "[", "A21", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}]}], "+", 
     RowBox[{"tp", "[", "M1", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "N0", "]"}], "==", 
    RowBox[{"-", 
     RowBox[{
      RowBox[{"tp", "[", "B2", "]"}], "**", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
      RowBox[{"tp", "[", "M2", "]"}]}]}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "R", "]"}], "==", "R"}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "R0", "]"}], "==", "R0"}], ",", 
   RowBox[{
    RowBox[{"tp", "[", "R0", "]"}], "==", 
    RowBox[{
     RowBox[{
      RowBox[{"tp", "[", "N0", "]"}], "**", "N0"}], "+", 
     RowBox[{"tp", "[", "R", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", 
     RowBox[{"Inv", "[", "R", "]"}], "]"}], "==", 
    RowBox[{"Inv", "[", "R", "]"}]}], ",", 
   RowBox[{
    RowBox[{"tp", "[", 
     RowBox[{"Inv", "[", "R0", "]"}], "]"}], "==", 
    RowBox[{"Inv", "[", "R0", "]"}]}], ",", 
   RowBox[{
    RowBox[{"k10", "**", "A12"}], "+", 
    RowBox[{"k20", "**", "A22"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "A21", "]"}], "**", "k30"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "M1", "]"}], "**", "M2"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"k10", "**", "B1"}], "+", 
       RowBox[{"k20", "**", "B2"}]}], ")"}], "**", 
     RowBox[{"Inv", "[", "R", "]"}], "**", 
     RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ",", 
   RowBox[{
    RowBox[{"k10", "**", "A11"}], "+", 
    RowBox[{"k20", "**", "A21"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "A11", "]"}], "**", "k10"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "A21", "]"}], "**", 
     RowBox[{"tp", "[", "k20", "]"}]}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "M1", "]"}], "**", "M1"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"k10", "**", "B1"}], "+", 
       RowBox[{"k20", "**", "B2"}]}], ")"}], "**", 
     RowBox[{"Inv", "[", "R", "]"}], "**", 
     RowBox[{"tp", "[", "B1", "]"}], "**", "k10"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"k10", "**", "B1"}], "+", 
       RowBox[{"k20", "**", "B2"}]}], ")"}], "**", 
     RowBox[{"Inv", "[", "R", "]"}], "**", 
     RowBox[{"tp", "[", "B2", "]"}], "**", 
     RowBox[{"tp", "[", "k20", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"k20", "**", "A21"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "A11", "]"}], "**", 
     RowBox[{"tp", "[", "k10", "]"}]}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "A21", "]"}], "**", 
     RowBox[{"tp", "[", "k20", "]"}]}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "k10", "]"}], "**", "A11"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "M1", "]"}], "**", "M1"}], "-", 
    RowBox[{"k20", "**", "B2", "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"tp", "[", "B1", "]"}], "**", 
        RowBox[{"tp", "[", "k10", "]"}]}], "+", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", "k20", "]"}]}]}], ")"}]}], "-", 
    RowBox[{
     RowBox[{"tp", "[", "k10", "]"}], "**", "B1", "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"tp", "[", "B1", "]"}], "**", 
        RowBox[{"tp", "[", "k10", "]"}]}], "+", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", "k20", "]"}]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "A12", "]"}], "**", 
     RowBox[{"tp", "[", "k10", "]"}]}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "A22", "]"}], "**", 
     RowBox[{"tp", "[", "k20", "]"}]}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "k30", "]"}], "**", "A21"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "M2", "]"}], "**", "M1"}], "-", 
    RowBox[{
     RowBox[{"tp", "[", "k30", "]"}], "**", "B2", "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"tp", "[", "B1", "]"}], "**", 
        RowBox[{"tp", "[", "k10", "]"}]}], "+", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", "k20", "]"}]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{"k30", "**", "A22"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "A22", "]"}], "**", "k30"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "M2", "]"}], "**", "M2"}], "-", 
    RowBox[{"k30", "**", "B2", "**", 
     RowBox[{"Inv", "[", "R", "]"}], "**", 
     RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tp", "[", "A22", "]"}], "**", 
     RowBox[{"tp", "[", "k30", "]"}]}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "k30", "]"}], "**", "A22"}], "+", 
    RowBox[{
     RowBox[{"tp", "[", "M2", "]"}], "**", "M2"}], "-", 
    RowBox[{
     RowBox[{"tp", "[", "k30", "]"}], "**", "B2", "**", 
     RowBox[{"tp", "[", 
      RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
     RowBox[{"tp", "[", "B2", "]"}], "**", 
     RowBox[{"tp", "[", "k30", "]"}]}]}]}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
Now that we have created all equations which need to be solved 
simultaneously to find k10,  we invoke the NC Groebner Basis
program NCProccess to solve for  k10. First we set the order reflecting our \
priorities on which variables should be eliminated.
\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\

NCAutomaticOrder[ {{N0,M0,R0,A0,B0}, 
\t\t{k10},{B1,B2,M1,M2,R,
\t\tA11,A12,A21,A22,
\t\tInv[A22-B2**Inv[R]**tp[B2]**k30],
\t    tp[Inv[A22-B2**Inv[R]**tp[B2]**k30]]},
\t    {k30},{k20},{G1,G2}},  AllRelations];
\
\>", "Input"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" Computed monomial order is : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"N0", ",", 
       RowBox[{"tp", "[", "N0", "]"}], ",", "M0", ",", 
       RowBox[{"tp", "[", "M0", "]"}], ",", "R0", ",", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], ",", 
       RowBox[{"tp", "[", "R0", "]"}], ",", 
       RowBox[{"Inv", "[", "R0", "]"}], ",", "A0", ",", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A0", "]"}], "]"}], ",", 
       RowBox[{"tp", "[", "A0", "]"}], ",", 
       RowBox[{"Inv", "[", "A0", "]"}], ",", "B0", ",", 
       RowBox[{"tp", "[", "B0", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k10", ",", 
       RowBox[{"tp", "[", "k10", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"B1", ",", 
       RowBox[{"tp", "[", "B1", "]"}], ",", "B2", ",", 
       RowBox[{"tp", "[", "B2", "]"}], ",", "M1", ",", 
       RowBox[{"tp", "[", "M1", "]"}], ",", "M2", ",", 
       RowBox[{"tp", "[", "M2", "]"}], ",", "R", ",", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], ",", 
       RowBox[{"tp", "[", "R", "]"}], ",", 
       RowBox[{"Inv", "[", "R", "]"}], ",", "A11", ",", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A11", "]"}], "]"}], ",", 
       RowBox[{"tp", "[", "A11", "]"}], ",", 
       RowBox[{"Inv", "[", "A11", "]"}], ",", "A12", ",", 
       RowBox[{"tp", "[", "A12", "]"}], ",", "A21", ",", 
       RowBox[{"tp", "[", "A21", "]"}], ",", "A22", ",", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], ",", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], ",", 
       RowBox[{"tp", "[", "A22", "]"}], ",", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], ",", 
       RowBox[{"Inv", "[", "A22", "]"}], ",", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "-", 
         RowBox[{"B2", "**", 
          RowBox[{"Inv", "[", "R", "]"}], "**", 
          RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], ",", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "-", 
          RowBox[{"B2", "**", 
           RowBox[{"Inv", "[", "R", "]"}], "**", 
           RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k30", ",", 
       RowBox[{"tp", "[", "k30", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k20", ",", 
       RowBox[{"tp", "[", "k20", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"G1", ",", 
       RowBox[{"tp", "[", "G1", "]"}], ",", "G2", ",", 
       RowBox[{"tp", "[", "G2", "]"}]}], "}"}]}], "}"}]}],
  SequenceForm[" Computed monomial order is : ", {{N0, 
     tp[N0], M0, 
     tp[M0], R0, 
     tp[
      Inv[R0]], 
     tp[R0], 
     Inv[R0], A0, 
     tp[
      Inv[A0]], 
     tp[A0], 
     Inv[A0], B0, 
     tp[B0]}, {k10, 
     tp[k10]}, {B1, 
     tp[B1], B2, 
     tp[B2], M1, 
     tp[M1], M2, 
     tp[M2], R, 
     tp[
      Inv[R]], 
     tp[R], 
     Inv[R], A11, 
     tp[
      Inv[A11]], 
     tp[A11], 
     Inv[A11], A12, 
     tp[A12], A21, 
     tp[A21], A22, 
     tp[
      Inv[A22 + NonCommutativeMultiply[B2, G2]]], 
     tp[
      Inv[A22]], 
     tp[A22], 
     Inv[A22 + NonCommutativeMultiply[B2, G2]], 
     Inv[A22], 
     Inv[A22 - NonCommutativeMultiply[B2, 
       Inv[R], 
       tp[B2], k30]], 
     tp[
      Inv[A22 - NonCommutativeMultiply[B2, 
        Inv[R], 
        tp[B2], k30]]]}, {k30, 
     tp[k30]}, {k20, 
     tp[k20]}, {G1, 
     tp[G1], G2, 
     tp[G2]}}],
  Editable->False]], "Print"]
}, Open  ]],

Cell[TextData[{
 "\nFinally we make the call to NCProcess[ ]  which will \ncreate a sorted \
Groebner basis from the relations in AllRelations\nand hopefully give us an \
answer for k10.  The ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " answer\ncan be found below and the TeX answer can be found on the \nmain \
Singular Perturbation page.\n"
}], "Text"],

Cell[CellGroupData[{

Cell["\<\

answer = NCProcess[AllRelations,4,
\t\"FindK10\",SBByCat->False  ,
\tDegreeCap->14, DegreeSumCap->17] ;\
\>", "Input"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Done outputting results to the stream \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{"OutputStream", "[", 
      RowBox[{"\"\<FindK10.tex\>\"", ",", " ", "6"}], "]"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    Format[
     OutputStream["FindK10.tex", 6], InputForm],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["Done outputting results to the stream ", 
   Format[
    OutputStream["FindK10.tex", 6], InputForm]],
  Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

answer\
\>", "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"A0", "**", 
       RowBox[{"Inv", "[", "A0", "]"}]}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Inv", "[", "A0", "]"}], "**", "A0"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "A0", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A0", "]"}], "]"}]}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A0", "]"}]}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", "R0"}], "\[Rule]", 
      "1"}], ",", 
     RowBox[{"G1", "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"tp", "[", 
          RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
         RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}]}], "+", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", 
        "A21"}], "+", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "M2", "]"}], "**", "M1"}], "-", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", 
        "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "+", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}]}]}], ",", 
     RowBox[{"G2", "\[Rule]", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}]}], ",", 
     RowBox[{"k20", "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"k10", "**", "A12", "**", 
         RowBox[{"Inv", "[", "A22", "]"}]}]}], "+", 
       RowBox[{
        RowBox[{"tp", "[", "A21", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
       RowBox[{
        RowBox[{"tp", "[", "M0", "]"}], "**", "M2", "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
       RowBox[{"k10", "**", "B0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "+", 
       RowBox[{"k10", "**", "B0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
        RowBox[{"Inv", "[", "A22", "]"}]}]}]}], ",", 
     RowBox[{"R", "\[Rule]", 
      RowBox[{"R0", "-", 
       RowBox[{
        RowBox[{"tp", "[", "N0", "]"}], "**", "N0"}]}]}], ",", 
     RowBox[{
      RowBox[{"Inv", "[", "R", "]"}], "\[Rule]", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", "R", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"Inv", "[", "R0", "]"}], "\[Rule]", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"Inv", "[", 
       RowBox[{"A22", "-", 
        RowBox[{"B2", "**", 
         RowBox[{"Inv", "[", "R", "]"}], "**", 
         RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], "\[Rule]", 
      RowBox[{"Inv", "[", 
       RowBox[{"A22", "+", 
        RowBox[{"B2", "**", "G2"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"tp", "[", "G1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"k10", "**", "B0", "**", 
         RowBox[{"tp", "[", 
          RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], "-", 
       RowBox[{
        RowBox[{"tp", "[", "A21", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30", "**", "B2", "**",
         
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"tp", "[", "M0", "]"}], "**", "M2", "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
       RowBox[{"k10", "**", "B0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30", "**", "B2", "**",
         
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"tp", "[", "G2", "]"}], "\[Rule]", 
      RowBox[{"-", 
       RowBox[{"k30", "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"tp", "[", "k10", "]"}], "\[Rule]", "k10"}], ",", 
     RowBox[{
      RowBox[{"tp", "[", "k20", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"tp", "[", 
          RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
         RowBox[{"tp", "[", "A12", "]"}], "**", "k10"}]}], "-", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", 
        "A21"}], "-", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "M2", "]"}], "**", "M1"}], "+", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "+", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", 
        "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "-", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}]}]}], ",", 
     RowBox[{
      RowBox[{"tp", "[", "k30", "]"}], "\[Rule]", "k30"}], ",", 
     RowBox[{
      RowBox[{"tp", "[", "R", "]"}], "\[Rule]", 
      RowBox[{"R0", "-", 
       RowBox[{
        RowBox[{"tp", "[", "N0", "]"}], "**", "N0"}]}]}], ",", 
     RowBox[{
      RowBox[{"tp", "[", "R0", "]"}], "\[Rule]", "R0"}], ",", 
     RowBox[{
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "-", 
         RowBox[{"B2", "**", 
          RowBox[{"Inv", "[", "R", "]"}], "**", 
          RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], "]"}], 
      "\[Rule]", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"Inv", "[", 
       RowBox[{"A22", "-", 
        RowBox[{"B2", "**", 
         RowBox[{"Inv", "[", "R", "]"}], "**", 
         RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"A0", "**", 
       RowBox[{"Inv", "[", "A0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"A11", "**", 
       RowBox[{"Inv", "[", "A11", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"Inv", "[", "A0", "]"}], "**", "A0"}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"Inv", "[", "A11", "]"}], "**", "A11"}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"Inv", "[", "A22", "]"}], "**", "A22"}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "A0", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A0", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "A11", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A11", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "A22", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}]}], ",", 
     RowBox[{"R", "-", "R0", "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "N0"}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A11", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A11", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", "R0"}]}], ",", 
     RowBox[{"A0", "-", "A11", "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "A21"}]}], ",", 
     RowBox[{"B0", "-", "B1", "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2"}]}], ",", 
     RowBox[{"M0", "-", "M1", "+", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "A21"}]}], ",", 
     RowBox[{"N0", "+", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2"}]}], ",", 
     RowBox[{"1", "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}], ",", 
     RowBox[{"G2", "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ",", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", "R0"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "N0"}]}], ",", 
     RowBox[{"k30", "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", 
       "A22"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2"}]}], ",", 
     RowBox[{
      RowBox[{"k30", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"k30", "**", "A22"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "A22", "]"}], "**", "k30"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2"}], "+", 
      RowBox[{"k30", "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ",", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"tp", "[", "A22", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "+", 
      RowBox[{"k30", "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "A22"}], "+", 
      RowBox[{
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"k10", "**", "A0"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "A0", "]"}], "**", "k10"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "M0", "]"}], "**", "M0"}], "+", 
      RowBox[{"k10", "**", "B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "+", 
      RowBox[{"k10", "**", "B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M0"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "M0", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "M0", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M0"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}]}], ",", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "M2", "]"}]}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}]}], ",", 
     RowBox[{"k20", "+", 
      RowBox[{"k10", "**", "A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "A21", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "M0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"k10", "**", "B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"k10", "**", "B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}]}]}], "+", 
      RowBox[{
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}]}], ",", 
     RowBox[{"G1", "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", 
       "A21"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M1"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"B0", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}]}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "-", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "N0", "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}]}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}]}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "N0", "]"}]}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"M2", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B0", "]"}]}]}], "+", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "+", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", 
          RowBox[{"A22", "+", 
           RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30"}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "A12", "]"}]}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B1", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}]}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A22", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"A12", "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", 
        RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}]}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "+", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "-", 
      RowBox[{"A12", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "+", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "-", 
      RowBox[{"B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "-", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "+", 
      RowBox[{"B1", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
        RowBox[{"tp", "[", "B2", "]"}], "**", 
        RowBox[{"tp", "[", 
         RowBox[{"Inv", "[", "A22", "]"}], "]"}]}]}], "+", 
      RowBox[{
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "+", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "-", 
      RowBox[{"A22", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "-", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "+", 
      RowBox[{"B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "-", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "+", 
      RowBox[{"M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "-", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "+", 
      RowBox[{"N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "-", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", "A22", "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}]}], "+", 
      RowBox[{"R0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "N0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "A21", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "+", 
      RowBox[{"tp", "[", "A0", "]"}], "-", 
      RowBox[{"tp", "[", "A11", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}]}], "+", 
      RowBox[{"tp", "[", "B0", "]"}], "-", 
      RowBox[{"tp", "[", "B1", "]"}]}], ",", 
     RowBox[{
      RowBox[{"k10", "**", "B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "A21", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30", "**", "B2", "**",
        
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"tp", "[", "M0", "]"}], "**", "M2", "**", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "+", 
         RowBox[{"B2", "**", "G2"}]}], "]"}], "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "-", 
      RowBox[{"k10", "**", "B0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", "k30", "**", "B2", "**",
        
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"tp", "[", "G1", "]"}]}], ",", 
     RowBox[{
      RowBox[{"k30", "**", "B2", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R", "]"}], "]"}]}], "+", 
      RowBox[{"tp", "[", "G2", "]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "k10"}], "+", 
      RowBox[{"tp", "[", "k10", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "A12", "]"}], "**", "k10"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", 
       "A21"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "M1"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "-", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", "k30", "**", "B2",
        "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}], "**", "N0", "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "R0", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "B0", "]"}], "**", "k10"}], "+", 
      RowBox[{"tp", "[", "k20", "]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "k30"}], "+", 
      RowBox[{"tp", "[", "k30", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "A21", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"tp", "[", "M0", "]"}], "-", 
      RowBox[{"tp", "[", "M1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"tp", "[", "B2", "]"}], "**", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", "A22", "]"}], "]"}], "**", 
       RowBox[{"tp", "[", "M2", "]"}]}], "+", 
      RowBox[{"tp", "[", "N0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "R0"}], "+", 
      RowBox[{
       RowBox[{"tp", "[", "N0", "]"}], "**", "N0"}], "+", 
      RowBox[{"tp", "[", "R", "]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "R0"}], "+", 
      RowBox[{"tp", "[", "R0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Inv", "[", "R", "]"}], "-", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", "R", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"Inv", "[", "R0", "]"}], "-", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", "R0", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"tp", "[", 
        RowBox[{"Inv", "[", 
         RowBox[{"A22", "+", 
          RowBox[{"B2", "**", "G2"}]}], "]"}], "]"}]}], "+", 
      RowBox[{"tp", "[", 
       RowBox[{"Inv", "[", 
        RowBox[{"A22", "-", 
         RowBox[{"B2", "**", 
          RowBox[{"Inv", "[", "R", "]"}], "**", 
          RowBox[{"tp", "[", "B2", "]"}], "**", "k30"}]}], "]"}], "]"}]}]}], 
    "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{670, 657},
WindowMargins->{{156, Automatic}, {Automatic, 82}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792}},
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 278, 10, 499, "Title"],
Cell[CellGroupData[{
Cell[893, 37, 62, 0, 67, "Section"],
Cell[958, 39, 4399, 135, 520, "Text"],
Cell[5360, 176, 770, 28, 110, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6167, 209, 57, 0, 67, "Section"],
Cell[CellGroupData[{
Cell[6249, 213, 85, 3, 49, "Subsection"],
Cell[CellGroupData[{
Cell[6359, 220, 87, 3, 39, "Subsubsection"],
Cell[6449, 225, 96, 4, 56, "Text"],
Cell[6548, 231, 97, 6, 79, "Input"],
Cell[6648, 239, 462, 15, 89, "Text"],
Cell[CellGroupData[{
Cell[7135, 258, 104, 6, 79, "Input"],
Cell[7242, 266, 252, 10, 45, "Output"]
}, Open  ]],
Cell[7509, 279, 83, 4, 56, "Text"],
Cell[CellGroupData[{
Cell[7617, 287, 164, 9, 118, "Input"],
Cell[7784, 298, 186, 8, 56, "Output"],
Cell[7973, 308, 144, 7, 56, "Output"],
Cell[8120, 317, 111, 5, 70, "Output"]
}, Open  ]],
Cell[8246, 325, 189, 6, 70, "Text"],
Cell[CellGroupData[{
Cell[8460, 335, 182, 7, 70, "Input"],
Cell[8645, 344, 691, 22, 70, "Output"]
}, Open  ]],
Cell[9351, 369, 26, 3, 70, "Input"],
Cell[9380, 374, 147, 4, 70, "Text"],
Cell[CellGroupData[{
Cell[9552, 382, 86, 4, 70, "Input"],
Cell[9641, 388, 826, 25, 70, "Output"]
}, Open  ]],
Cell[10482, 416, 149, 3, 70, "Text"],
Cell[CellGroupData[{
Cell[10656, 423, 85, 3, 70, "Input"],
Cell[10744, 428, 469, 14, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11250, 447, 60, 4, 70, "Input"],
Cell[11313, 453, 543, 15, 70, "Output"]
}, Open  ]],
Cell[11871, 471, 371, 11, 70, "Text"],
Cell[12245, 484, 156, 4, 70, "Text"],
Cell[CellGroupData[{
Cell[12426, 492, 86, 4, 70, "Input"],
Cell[12515, 498, 336, 9, 70, "Output"]
}, Open  ]],
Cell[12866, 510, 349, 9, 70, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13252, 524, 87, 1, 70, "Subsubsection"],
Cell[13342, 527, 91, 3, 70, "Text"],
Cell[13436, 532, 290, 12, 70, "Input"],
Cell[13729, 546, 80, 3, 70, "Text"],
Cell[13812, 551, 161, 10, 70, "Input"],
Cell[13976, 563, 361, 8, 70, "Text"],
Cell[14340, 573, 131, 5, 70, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14508, 583, 73, 3, 70, "Subsubsection"],
Cell[14584, 588, 102, 4, 70, "Text"],
Cell[CellGroupData[{
Cell[14711, 596, 142, 6, 70, "Input"],
Cell[14856, 604, 14381, 433, 70, "Output"]
}, Open  ]],
Cell[29252, 1040, 279, 6, 70, "Text"],
Cell[CellGroupData[{
Cell[29556, 1050, 238, 9, 70, "Input"],
Cell[29797, 1061, 3771, 115, 70, "Print"]
}, Open  ]],
Cell[33583, 1179, 364, 8, 70, "Text"],
Cell[CellGroupData[{
Cell[33972, 1191, 129, 5, 70, "Input"],
Cell[34104, 1198, 563, 17, 70, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34704, 1220, 32, 3, 70, "Input"],
Cell[34739, 1225, 157125, 3984, 70, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

