(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    150803,       3436]
NotebookOptionsPosition[    148060,       3346]
NotebookOutlinePosition[    148499,       3363]
CellTagsIndexPosition[    148456,       3360]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{"<<", "NC`"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "NCPoly`"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "NCPolyAssociationGraded`"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "NCPolyGroebner`"}]}], "Input",
 CellChangeTimes->{{3.460511046476254*^9, 3.460511056052753*^9}, {
  3.4605110900940647`*^9, 3.4605110921732073`*^9}, {3.460511425866008*^9, 
  3.4605114284085493`*^9}, {3.61944755148664*^9, 3.6194475536586447`*^9}, {
  3.63223540858878*^9, 3.632235410088994*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"You are using the version of NCAlgebra which is found in:\"\
\>"], "Print",
 CellChangeTimes->{3.632235429180904*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  \"\>", "\[InvisibleSpace]", "\<\"/home/mauricio/NC\"\>"}],
  SequenceForm["  ", "/home/mauricio/NC"],
  Editable->False]], "Print",
 CellChangeTimes->{3.632235429181484*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"You can now use \\\"<< NCAlgebra`\\\" to load NCAlgebra or \
\"\>", "\[InvisibleSpace]", "\<\"\\\"<< NCGB`\\\" to load NCGB.\"\>"}],
  SequenceForm[
  "You can now use \"<< NCAlgebra`\" to load NCAlgebra or ", 
   "\"<< NCGB`\" to load NCGB."],
  Editable->False]], "Print",
 CellChangeTimes->{3.632235429182165*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "NCPower", "]"}], "\n", 
 RowBox[{
  RowBox[{"NCPower", "[", 
   RowBox[{"a_", ",", "0"}], "]"}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{"NCPower", "[", 
   RowBox[{"a_NCPoly", ",", "1"}], "]"}], ":=", "a"}], "\n", 
 RowBox[{
  RowBox[{"NCPower", "[", 
   RowBox[{"a_NCPoly", ",", "n_"}], "]"}], ":=", 
  RowBox[{"a", "**", 
   RowBox[{"NCPower", "[", 
    RowBox[{"a", ",", 
     RowBox[{"n", "-", "1"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{3.460511104723051*^9}],

Cell[BoxData[{
 RowBox[{"Clear", "[", "NCLie", "]"}], "\n", 
 RowBox[{
  RowBox[{"NCLie", "[", 
   RowBox[{"a_NCPoly", ",", "b_NCPoly"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"a", "**", "b"}], "-", 
   RowBox[{"b", "**", "a"}]}]}]}], "Input",
 CellChangeTimes->{3.460511109673398*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vars", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{"{", "b", "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{3.460511118047925*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}]}], ";"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4605148789394903`*^9, 3.460514880453496*^9}, {
  3.619225809525916*^9, 3.619225811848221*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "b", "}"}], ",", 
      RowBox[{"{", "a", "}"}]}], "}"}]}], ";"}], " ", "*)"}]], "Input",
 CellChangeTimes->{
  3.460511122566228*^9, {3.619225813285828*^9, 3.619225814813962*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"{", 
     RowBox[{"b", ",", "a"}], "}"}]}], ";"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.46051489700352*^9, 3.4605148978793507`*^9}, {
  3.61922581637365*^9, 3.619225818100998*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"A", "=", 
  RowBox[{"NCPolyMonomial", "[", 
   RowBox[{
    RowBox[{"{", "a", "}"}], ",", "vars"}], "]"}]}], "\n", 
 RowBox[{"NCPolyDisplay", "[", 
  RowBox[{"A", ",", "vars"}], "]"}]}], "Input",
 CellChangeTimes->{{3.460511167608807*^9, 3.460511188485807*^9}, 
   3.6192258255416594`*^9}],

Cell[BoxData[
 RowBox[{"NCPoly", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "1"}], 
    "\[RightAssociation]"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.460511168324955*^9, 3.460511188999799*^9}, 
   3.460513763030353*^9, 3.460513796712846*^9, 3.460513871479056*^9, 
   3.460514159318707*^9, 3.460514198622867*^9, 3.460514427398573*^9, 
   3.460514462062845*^9, 3.4605145378687162`*^9, 3.460514717600626*^9, {
   3.460514883167409*^9, 3.460514919013174*^9}, 3.6164666932809467`*^9, 
   3.619222907309306*^9, {3.6192234417700768`*^9, 3.619223496064135*^9}, 
   3.619223593259452*^9, {3.61922372423142*^9, 3.619223749139989*^9}, 
   3.619224302033661*^9, 3.619224372396386*^9, 3.619224455886742*^9, {
   3.6192258234362097`*^9, 3.619225827939066*^9}, 3.6194475652598467`*^9, 
   3.6322354293227663`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  StyleBox["a",
   StripOnInput->False,
   FontWeight->Bold], "}"}]], "Output",
 CellChangeTimes->{{3.460511168324955*^9, 3.460511188999799*^9}, 
   3.460513763030353*^9, 3.460513796712846*^9, 3.460513871479056*^9, 
   3.460514159318707*^9, 3.460514198622867*^9, 3.460514427398573*^9, 
   3.460514462062845*^9, 3.4605145378687162`*^9, 3.460514717600626*^9, {
   3.460514883167409*^9, 3.460514919013174*^9}, 3.6164666932809467`*^9, 
   3.619222907309306*^9, {3.6192234417700768`*^9, 3.619223496064135*^9}, 
   3.619223593259452*^9, {3.61922372423142*^9, 3.619223749139989*^9}, 
   3.619224302033661*^9, 3.619224372396386*^9, 3.619224455886742*^9, {
   3.6192258234362097`*^9, 3.619225827939066*^9}, 3.6194475652598467`*^9, 
   3.6322354293343983`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"NCPolyMonomial", "[", 
    RowBox[{
     RowBox[{"{", "b", "}"}], ",", "vars"}], "]"}]}], ";"}], "\n", 
 RowBox[{"NCPolyDisplay", "[", 
  RowBox[{"B", ",", "vars"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  StyleBox["b",
   StripOnInput->False,
   FontWeight->Bold], "}"}]], "Output",
 CellChangeTimes->{
  3.4605111904120817`*^9, 3.4605137635463657`*^9, 3.460513797243758*^9, 
   3.460513873276278*^9, 3.460514159884828*^9, 3.460514199105645*^9, 
   3.460514427962908*^9, 3.460514462526702*^9, 3.460514538408766*^9, 
   3.460514718099312*^9, {3.4605148838158484`*^9, 3.460514919993229*^9}, 
   3.616466693315192*^9, 3.619222907344761*^9, {3.6192234418016253`*^9, 
   3.619223496099126*^9}, 3.619223593286543*^9, {3.6192237242628107`*^9, 
   3.619223749205749*^9}, 3.619224302072613*^9, 3.6192243724269648`*^9, 
   3.619224455920205*^9, 3.6192258292394953`*^9, 3.6194475653058643`*^9, 
   3.632235429362092*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"NCPower", "[", 
   RowBox[{"A", ",", "3"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"NCPolyDisplay", "[", 
  RowBox[{"%", ",", "vars"}], "]"}]}], "Input",
 CellChangeTimes->{3.460511194045394*^9}],

Cell[BoxData[
 RowBox[{"{", 
  StyleBox[
   RowBox[{"a", ".", "a", ".", "a"}],
   StripOnInput->False,
   FontWeight->Bold], "}"}]], "Output",
 CellChangeTimes->{
  3.460511194421544*^9, 3.460513764112199*^9, 3.460513797776629*^9, 
   3.460513874206829*^9, 3.460514160417375*^9, 3.460514199621714*^9, 
   3.460514428512067*^9, 3.4605144630105467`*^9, 3.460514538975334*^9, 
   3.460514718598112*^9, {3.460514884314847*^9, 3.460514920491105*^9}, 
   3.616466693350326*^9, 3.619222907392914*^9, {3.619223441852151*^9, 
   3.619223496147896*^9}, 3.6192235933210897`*^9, {3.619223724316781*^9, 
   3.6192237492588987`*^9}, 3.619224302106209*^9, 3.619224372471518*^9, 
   3.61922445595325*^9, 3.61922583082346*^9, 3.619447565337384*^9, 
   3.632235429388507*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"NCLie", "[", 
   RowBox[{"A", ",", "B"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"NCPolyDisplay", "[", 
  RowBox[{"%", ",", "vars"}], "]"}]}], "Input",
 CellChangeTimes->{3.460511209711358*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox[
    RowBox[{"a", ".", "b"}],
    StripOnInput->False,
    FontWeight->Bold], ",", 
   RowBox[{"-", 
    StyleBox[
     RowBox[{"b", ".", "a"}],
     StripOnInput->False,
     FontWeight->Bold]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460511225791361*^9, 3.460513764660273*^9, 3.46051379834313*^9, 
   3.4605138748551292`*^9, 3.4605141610153646`*^9, 3.460514200137085*^9, 
   3.460514429044874*^9, 3.4605144635106173`*^9, 3.460514539541499*^9, 
   3.46051471911412*^9, {3.460514884815043*^9, 3.4605149210261374`*^9}, 
   3.616466693399803*^9, 3.6192229074432*^9, {3.619223441885639*^9, 
   3.619223496197507*^9}, 3.6192235933704*^9, {3.619223724348495*^9, 
   3.619223749290863*^9}, 3.6192243021550827`*^9, 3.619224372505076*^9, 
   3.6192244560036488`*^9, 3.6192258316239223`*^9, 3.61944756535673*^9, 
   3.632235429424124*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"NCLie", "[", 
   RowBox[{"A", ",", 
    RowBox[{"NCLie", "[", 
     RowBox[{"A", ",", "B"}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"NCPolyDisplay", "[", 
  RowBox[{"%", ",", "vars"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox[
    RowBox[{"a", ".", "a", ".", "b"}],
    StripOnInput->False,
    FontWeight->Bold], ",", 
   RowBox[{
    RowBox[{"-", "2"}], " ", 
    StyleBox[
     RowBox[{"a", ".", "b", ".", "a"}],
     StripOnInput->False,
     FontWeight->Bold]}], ",", 
   StyleBox[
    RowBox[{"b", ".", "a", ".", "a"}],
    StripOnInput->False,
    FontWeight->Bold]}], "}"}]], "Output",
 CellChangeTimes->{
  3.46051122828806*^9, 3.4605137652258797`*^9, 3.460513798924882*^9, 
   3.4605138754214993`*^9, 3.460514161780745*^9, 3.460514200652926*^9, 
   3.460514429544067*^9, 3.460514463975398*^9, 3.460514540106558*^9, 
   3.4605147196678133`*^9, {3.460514885346933*^9, 3.4605149215753193`*^9}, 
   3.616466693431356*^9, 3.619222907474699*^9, {3.619223441935688*^9, 
   3.619223496231038*^9}, 3.6192235934207363`*^9, {3.619223724403709*^9, 
   3.619223749324641*^9}, 3.6192243022048893`*^9, 3.6192243725555*^9, 
   3.619224456054191*^9, 3.6192258323206987`*^9, 3.6194475653899508`*^9, 
   3.63223542945164*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NCPower", "[", 
      RowBox[{"A", ",", "3"}], "]"}], ",", 
     RowBox[{"NCLie", "[", 
      RowBox[{"A", ",", 
       RowBox[{"NCLie", "[", 
        RowBox[{"A", ",", "B"}], "]"}]}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"NCPolyDisplay", "[", 
   RowBox[{"g", ",", "vars"}], "]"}], "//", "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.4605110891267347`*^9, 3.460511242406741*^9}, {
   3.460511353057979*^9, 3.460511355376729*^9}, 3.619225751081566*^9, 
   3.619225800615367*^9}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{"a", ".", "a", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{"a", ".", "a", ".", "b"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{"a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"b", ".", "a", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`b, $CellContext`a, $CellContext`a], Bold]}}],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.4605110949392567`*^9, 3.460511128295745*^9, {3.460511158884378*^9, 
   3.460511202914977*^9}, {3.4605112409205313`*^9, 3.4605112428082438`*^9}, {
   3.460511358230155*^9, 3.460511360025045*^9}, 3.46051376589247*^9, 
   3.460513799724234*^9, 3.46051387598909*^9, 3.460514162679523*^9, 
   3.460514201302658*^9, 3.460514430128016*^9, 3.460514464491015*^9, 
   3.46051454072185*^9, 3.460514720196612*^9, {3.460514885978855*^9, 
   3.460514922124214*^9}, 3.6164666934828444`*^9, 3.619222907511093*^9, {
   3.619223441967972*^9, 3.619223496282509*^9}, 3.619223593470996*^9, {
   3.619223724460947*^9, 3.619223749356429*^9}, 3.6192243022563963`*^9, 
   3.6192243726059227`*^9, 3.619224456104278*^9, 3.6192257517366323`*^9, 
   3.6192258023288794`*^9, 3.619225833238365*^9, 3.619447565439684*^9, 
   3.632235429487709*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{
   RowBox[{"G", "=", 
    RowBox[{"NCPolyGroebner", "[", 
     RowBox[{"g", ",", "9", ",", "\[IndentingNewLine]", 
      RowBox[{"PrintBasis", "\[Rule]", "False"}], ",", 
      RowBox[{"PrintObstructions", "\[Rule]", "False"}], ",", 
      RowBox[{"PrintSPolynomials", "\[Rule]", "False"}], ",", 
      RowBox[{"VerboseLevel", "\[Rule]", "1"}]}], "]"}]}], ";"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NCPolyDisplay", "[", 
   RowBox[{"G", ",", "vars"}], "]"}], "//", "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.460511271949955*^9, 3.460511319162175*^9}, {
   3.460514024578785*^9, 3.460514028149103*^9}, {3.460514087711278*^9, 
   3.460514188188622*^9}, {3.460514547742209*^9, 3.4605145479577427`*^9}, {
   3.619223061104621*^9, 3.619223062239381*^9}, {3.619223367147397*^9, 
   3.619223372731258*^9}, {3.6192235061360683`*^9, 3.619223506632751*^9}, {
   3.6192237196264963`*^9, 3.6192237200331373`*^9}, {3.6192242331618853`*^9, 
   3.619224234219363*^9}, {3.619224270558339*^9, 3.619224272083996*^9}, {
   3.619224361295733*^9, 3.619224361670767*^9}, 3.6194476250396557`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"* * * * * * * * * * * * * * * *\"\>"], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.63223542951492*^9}],

Cell[BoxData["\<\"* * *   NCPolyGroebner    * * *\"\>"], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235429515585*^9}],

Cell[BoxData["\<\"* * * * * * * * * * * * * * * *\"\>"], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235429516635*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"* Monomial order : \"\>", 
   "\[InvisibleSpace]", "\<\"NCPoly[{1, 1}, <|{0, 1, 0} -> 1|>] \[LessLess] \
NCPoly[{1, 1}, <|{1, 0, 1} -> 1|>]\"\>"}],
  SequenceForm[
  "* Monomial order : ", 
   "NCPoly[{1, 1}, <|{0, 1, 0} -> 1|>] \[LessLess] NCPoly[{1, 1}, <|{1, 0, 1} \
-> 1|>]"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235429517701*^9}],

Cell[BoxData["\<\"* Reduce and normalize initial basis\"\>"], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.63223542951931*^9}],

Cell[BoxData["\<\"* Computing initial set of obstructions\"\>"], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235429520361*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "7", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 1, ", ", 3, " polys in the basis, ", 7, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.6322354295214376`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "8", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 2, ", ", 4, " polys in the basis, ", 8, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235429540989*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "12", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 3, ", ", 5, " polys in the basis, ", 12, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235429569745*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "15", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 4, ", ", 6, " polys in the basis, ", 15, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.6322354296846848`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "17", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 5, ", ", 7, " polys in the basis, ", 17, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.6322354300125217`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "22", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 6, ", ", 8, " polys in the basis, ", 22, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235431211619*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "22", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 7, ", ", 9, " polys in the basis, ", 22, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235435121806*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "29", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 8, ", ", 10, " polys in the basis, ", 29, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.63223544561974*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"> Major Iteration \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "11", 
   "\[InvisibleSpace]", "\<\" polys in the basis, \"\>", "\[InvisibleSpace]", 
   "27", "\[InvisibleSpace]", "\<\" obstructions\"\>"}],
  SequenceForm[
  "> Major Iteration ", 9, ", ", 11, " polys in the basis, ", 27, 
   " obstructions"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235489739229*^9}],

Cell[BoxData["\<\"* Cleaning up basis.\"\>"], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235489795451*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"* Interrupted before Groebner basis with \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", 
   "\[InvisibleSpace]", "\<\" relations currently on the basis\"\>"}],
  SequenceForm[
  "* Interrupted before Groebner basis with ", "11", 
   " relations currently on the basis"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.6322354898166637`*^9}],

Cell[BoxData["\<\"* * * * * * * * * * * * * * * *\"\>"], "Print",
 CellChangeTimes->{{3.460511274695092*^9, 3.460511326509355*^9}, 
   3.4605113614218283`*^9, 3.460512163729245*^9, 3.4605137672198553`*^9, 
   3.4605138006542788`*^9, 3.460513876685945*^9, {3.4605140313921843`*^9, 
   3.460514202716154*^9}, 3.4605144307400103`*^9, 3.460514464989965*^9, {
   3.460514541303665*^9, 3.4605145534808493`*^9}, 3.460514720729126*^9, {
   3.460514886577067*^9, 3.46051492267216*^9}, 3.6164666935190067`*^9, 
   3.619222907544544*^9, 3.6192230628610363`*^9, {3.619223373705737*^9, 
   3.619223400080287*^9}, {3.619223442019532*^9, 3.619223508772478*^9}, 
   3.61922359352079*^9, {3.619223724495919*^9, 3.6192237494121304`*^9}, 
   3.6192242351270027`*^9, {3.6192242725183077`*^9, 3.619224302308652*^9}, 
   3.619224372655223*^9, 3.61922445615412*^9, 3.619225834921914*^9, 
   3.619447565490137*^9, 3.619447625475821*^9, 3.632235489817483*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "60.31947399999999959163687890395522117615`7.801057459007828", ",", 
   "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.460514031475092*^9, 3.460514202907538*^9}, 
   3.460514430928569*^9, 3.460514465175943*^9, {3.46051454148495*^9, 
   3.460514553551179*^9}, 3.460514721342503*^9, {3.46051488719645*^9, 
   3.4605149233034678`*^9}, 3.6164667731824703`*^9, {3.619223057943657*^9, 
   3.619223069004985*^9}, {3.619223379811584*^9, 3.6192234061745768`*^9}, {
   3.619223448151183*^9, 3.619223502377699*^9}, 3.619223572858214*^9, 
   3.619223658201075*^9, {3.619223725707097*^9, 3.619223750478507*^9}, 
   3.6192242361810093`*^9, {3.619224278609267*^9, 3.6192243084768267`*^9}, 
   3.619224437630321*^9, 3.619224519833143*^9, 3.619225880406003*^9, 
   3.6194475811908627`*^9, 3.619447683759636*^9, 3.632235489818223*^9}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{"a", ".", "a", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{"a", ".", "a", ".", "b"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{"a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"b", ".", "a", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["2", "3"]}], " ", 
        StyleBox[
         RowBox[{"a", ".", "a", ".", "a", ".", "b"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"a", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{"a", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"a", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", 
         "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", 
         "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", 
         "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", 
         "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", 
         "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", 
         "b", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "a", ".", 
         "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", 
         "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", 
         "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", 
         "b", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", "a", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"16", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", 
         "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"2", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".",
           "b", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "b", ".", "a", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{"4", " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a", ".", "a", ".", "b", ".", "b", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".",
           "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", 
          ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
         "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".",
          "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`b, $CellContext`a, $CellContext`a], Bold]}, {
    Rational[-2, 3] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b], 
       Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a], 
      Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
    Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], Rational[-1, 2] 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold], Rational[-1, 2] 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], Rational[-1, 2] 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-8) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-8) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 4 Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-8) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-8) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-8) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 16 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-8) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-8) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-8) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 2 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-8) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 4 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`b, $CellContext`a], Bold], (-2) 
     Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold]}}],
  Editable->False]], "Output",
 CellChangeTimes->{{3.460514031475092*^9, 3.460514202907538*^9}, 
   3.460514430928569*^9, 3.460514465175943*^9, {3.46051454148495*^9, 
   3.460514553551179*^9}, 3.460514721342503*^9, {3.46051488719645*^9, 
   3.4605149233034678`*^9}, 3.6164667731824703`*^9, {3.619223057943657*^9, 
   3.619223069004985*^9}, {3.619223379811584*^9, 3.6192234061745768`*^9}, {
   3.619223448151183*^9, 3.619223502377699*^9}, 3.619223572858214*^9, 
   3.619223658201075*^9, {3.619223725707097*^9, 3.619223750478507*^9}, 
   3.6192242361810093`*^9, {3.619224278609267*^9, 3.6192243084768267`*^9}, 
   3.619224437630321*^9, 3.619224519833143*^9, 3.619225880406003*^9, 
   3.6194475811908627`*^9, 3.619447683759636*^9, 3.63223548987155*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Gr", "=", 
   RowBox[{"Sort", "[", 
    RowBox[{"NCPolyReduce", "[", 
     RowBox[{"G", ",", "True"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NCPolyDisplay", "[", 
   RowBox[{"Gr", ",", "vars"}], "]"}], "//", "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.4605117565212183`*^9, 3.4605118384169607`*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{"a", ".", "a", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{"a", ".", "a", ".", "b"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{"a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"b", ".", "a", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{"a", ".", "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{"a", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"a", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
        "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
        "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
        "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", 
        "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`b, $CellContext`a, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a], 
      Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
    Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold]}}],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.46051176002492*^9, {3.460511807518175*^9, 3.460511877464046*^9}, 
   3.460512166051468*^9, 3.460513805469048*^9, 3.460513879156953*^9, 
   3.460514012393112*^9, {3.460514045580546*^9, 3.460514203415523*^9}, 
   3.460514431691657*^9, 3.46051446570687*^9, {3.460514542102107*^9, 
   3.460514554169821*^9}, 3.4605147217584248`*^9, {3.4605147827203817`*^9, 
   3.4605148047941236`*^9}, {3.460514888003481*^9, 3.4605149236078568`*^9}, 
   3.619223081047667*^9, {3.619223448947541*^9, 3.619223503105649*^9}, 
   3.619223661307266*^9, {3.619223726169529*^9, 3.619223750854808*^9}, 
   3.619224309274187*^9, 3.619224440738885*^9, 3.619224522909096*^9, 
   3.619225884564878*^9, 3.6194475816850367`*^9, 3.632235490571706*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Gr", "=", 
   RowBox[{"Sort", "[", 
    RowBox[{"NCPolyFullReduce", "[", 
     RowBox[{"G", ",", "True"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NCPolyDisplay", "[", 
   RowBox[{"Gr", ",", "vars"}], "]"}], "//", "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.460514765185384*^9, 3.460514801700576*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{"a", ".", "a", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       StyleBox[
        RowBox[{"a", ".", "a", ".", "b"}],
        StripOnInput->False,
        FontWeight->Bold], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        StyleBox[
         RowBox[{"a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"b", ".", "a", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{"a", ".", "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{"a", ".", "a", ".", "b", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{"a", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
        "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
        "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        StyleBox[
         RowBox[{
         "a", ".", "a", ".", "b", ".", "b", ".", "b", ".", "a", ".", "b", ".",
           "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
         StripOnInput->False,
         FontWeight->Bold]}], ",", 
       StyleBox[
        RowBox[{
        "a", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", 
         "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "a"}],
        StripOnInput->False,
        FontWeight->Bold]}], "}"}]},
    {
     RowBox[{"{", 
      StyleBox[
       RowBox[{
       "a", ".", "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", 
        "a", ".", "b", ".", "b", ".", "a", ".", "b", ".", "b", ".", "a", ".", 
        "b", ".", "a"}],
       StripOnInput->False,
       FontWeight->Bold], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b], Bold], (-2) Style[
       Dot[$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`b, $CellContext`a, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`a], 
      Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
    Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`a], Bold]}, {Rational[-1, 2] Style[
       Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold], 
     Style[
      Dot[$CellContext`a, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`a], Bold]}, {
     Style[
      Dot[$CellContext`a, $CellContext`a, $CellContext`b, $CellContext`b, \
$CellContext`a, $CellContext`b, $CellContext`b, $CellContext`a, \
$CellContext`b, $CellContext`b, $CellContext`a, $CellContext`b, \
$CellContext`b, $CellContext`a, $CellContext`b, $CellContext`a], Bold]}}],
  Editable->False]], "Output",
 CellChangeTimes->{{3.4605147790487423`*^9, 3.460514805376992*^9}, {
   3.460514888895938*^9, 3.460514924084155*^9}, 3.619223083787128*^9, {
   3.61922344965869*^9, 3.619223503813859*^9}, 3.619223664438779*^9, {
   3.619223726391244*^9, 3.61922375101645*^9}, 3.619224309989539*^9, 
   3.6192244438623543`*^9, 3.619224525983079*^9, 3.619225889500602*^9, 
   3.619447582084693*^9, 3.632235491238855*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"p", "=", 
   RowBox[{"NCPower", "[", 
    RowBox[{
     RowBox[{"A", "**", "B"}], ",", 
     RowBox[{
      RowBox[{"2", "*", "3"}], "-", "2"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"NCPolyDisplay", "[", 
  RowBox[{"p", ",", "vars"}], "]"}]}], "Input",
 CellChangeTimes->{{3.460511900403509*^9, 3.4605119043323727`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  StyleBox[
   RowBox[{
   "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b", ".", "a", ".", "b"}],
   StripOnInput->False,
   FontWeight->Bold], "}"}]], "Output",
 CellChangeTimes->{{3.460511903152566*^9, 3.4605119046663218`*^9}, {
   3.460512158706256*^9, 3.460512166807438*^9}, 3.4605138109177237`*^9, 
   3.460513880378828*^9, 3.4605140131460238`*^9, {3.4605140490408487`*^9, 
   3.460514203996833*^9}, 3.460514432504918*^9, 3.460514466471065*^9, {
   3.46051454305062*^9, 3.4605145549099216`*^9}, 3.460514722474368*^9, {
   3.460514786444811*^9, 3.460514805972477*^9}, {3.4605148897378073`*^9, 
   3.460514924685136*^9}, 3.619223085950412*^9, {3.619223346293826*^9, 
   3.6192233511125803`*^9}, {3.6192234497504053`*^9, 3.619223503859501*^9}, 
   3.619223664496023*^9, {3.619223726442877*^9, 3.619223751057846*^9}, 
   3.619224310068324*^9, 3.61922444391637*^9, 3.6192245260356207`*^9, 
   3.61922589073132*^9, 3.6194475821674356`*^9, 3.6322354913282957`*^9}]
}, Open  ]]
},
WindowSize->{892, 784},
WindowMargins->{{233, Automatic}, {Automatic, -10}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"10.0 for Linux x86 (64-bit) (September 9, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 495, 8, 99, "Input"],
Cell[CellGroupData[{
Cell[1087, 34, 135, 2, 23, "Print"],
Cell[1225, 38, 224, 5, 23, "Print"],
Cell[1452, 45, 365, 8, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[1844, 57, 510, 15, 99, "Input"],
Cell[2357, 74, 283, 8, 55, "Input"],
Cell[2643, 84, 213, 7, 32, "Input"],
Cell[2859, 93, 274, 7, 32, "Input"],
Cell[3136, 102, 302, 9, 32, "Input"],
Cell[3441, 113, 272, 7, 32, "Input"],
Cell[CellGroupData[{
Cell[3738, 124, 314, 8, 55, "Input"],
Cell[4055, 134, 961, 19, 32, "Output"],
Cell[5019, 155, 779, 14, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5835, 174, 241, 7, 55, "Input"],
Cell[6079, 183, 735, 14, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6851, 202, 239, 6, 55, "Input"],
Cell[7093, 210, 757, 15, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7887, 230, 237, 6, 55, "Input"],
Cell[8127, 238, 886, 21, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9050, 264, 255, 7, 55, "Input"],
Cell[9308, 273, 1042, 26, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10387, 304, 586, 16, 55, "Input"],
Cell[10976, 322, 2033, 51, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13046, 378, 1157, 21, 99, "Input"],
Cell[CellGroupData[{
Cell[14228, 403, 933, 12, 23, "Print"],
Cell[15164, 417, 934, 12, 23, "Print"],
Cell[16101, 431, 934, 12, 23, "Print"],
Cell[17038, 445, 1228, 21, 23, "Print"],
Cell[18269, 468, 938, 12, 23, "Print"],
Cell[19210, 482, 942, 12, 23, "Print"],
Cell[20155, 496, 1303, 21, 23, "Print"],
Cell[21461, 519, 1301, 21, 23, "Print"],
Cell[22765, 542, 1303, 21, 23, "Print"],
Cell[24071, 565, 1305, 21, 23, "Print"],
Cell[25379, 588, 1305, 21, 23, "Print"],
Cell[26687, 611, 1303, 21, 23, "Print"],
Cell[27993, 634, 1303, 21, 23, "Print"],
Cell[29299, 657, 1304, 21, 23, "Print"],
Cell[30606, 680, 1305, 21, 23, "Print"],
Cell[31914, 703, 923, 12, 23, "Print"],
Cell[32840, 717, 1219, 20, 23, "Print"],
Cell[34062, 739, 934, 12, 23, "Print"]
}, Open  ]],
Cell[35011, 754, 861, 14, 32, "Output"],
Cell[35875, 770, 94810, 2108, 267, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130722, 2883, 370, 9, 55, "Input"],
Cell[131095, 2894, 7744, 202, 256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[138876, 3101, 370, 9, 55, "Input"],
Cell[139249, 3112, 7405, 197, 256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146691, 3314, 353, 10, 55, "Input"],
Cell[147047, 3326, 997, 17, 65, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
