(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    135555,       3314]
NotebookOptionsPosition[    132011,       3204]
NotebookOutlinePosition[    132464,       3222]
CellTagsIndexPosition[    132421,       3219]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["One example from COMPleib (AC1.m)", "Title",
 CellChangeTimes->{{3.522422618311421*^9, 3.522422652270892*^9}, 
   3.522424360608466*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", "NC`"}], "\n", 
 RowBox[{"<<", "SDP`"}], "\n", 
 RowBox[{"<<", "SDPSylvester`"}]}], "Input",
 CellChangeTimes->{
  3.5146023054779673`*^9, {3.54368287089953*^9, 3.5436828720995083`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"You are using the version of NCAlgebra which is found in:\"\
\>"], "Print",
 CellChangeTimes->{3.5436828779447193`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  \"\>", "\[InvisibleSpace]", "\<\"/Users/mauricio/NC\"\>", 
   "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm["  ", "/Users/mauricio/NC", "."],
  Editable->False]], "Print",
 CellChangeTimes->{3.543682877946393*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"You can now use \\\"<< NCAlgebra`\\\" to load NCAlgebra or \
\"\>", "\[InvisibleSpace]", "\<\"\\\"<< NCGB`\\\" to load NCGB.\"\>"}],
  SequenceForm[
  "You can now use \"<< NCAlgebra`\" to load NCAlgebra or ", 
   "\"<< NCGB`\" to load NCGB."],
  Editable->False]], "Print",
 CellChangeTimes->{3.543682877948491*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"<<", "COMPleib/MmaCOMPleib/ROC4.m"}]], "Input",
 CellChangeTimes->{{3.522425178223008*^9, 3.52242524529819*^9}, {
  3.52450612916959*^9, 3.524506138600926*^9}, {3.5245061871014423`*^9, 
  3.524506187565132*^9}, {3.52502716561875*^9, 3.525027177505761*^9}, {
  3.5252277789262657`*^9, 3.5252277808134604`*^9}, {3.525228732284198*^9, 
  3.525228766014284*^9}, {3.525488707886463*^9, 3.525488710396453*^9}, {
  3.525488782783085*^9, 3.5254887839970303`*^9}, {3.525489323538082*^9, 
  3.525489378000819*^9}, {3.5436828805249367`*^9, 3.543682960649*^9}}],

Cell[BoxData[
 RowBox[{"<<", "\"\<COMPleib/MmaCOMPleib/AC1.m\>\""}]], "Input",
 CellChangeTimes->{{3.5436829449376383`*^9, 3.5436829533774033`*^9}, {
  3.54368313212528*^9, 3.5436831480365047`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"C1", "\[IndentingNewLine]", "D12"}], "Input",
 CellChangeTimes->{{3.5254893299296083`*^9, 3.525489337438178*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0.707106781186547`", ",", "0", ",", "0", ",", "0"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0.707106781186547`", ",", "0", ",", "0"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.525489331088344*^9, 3.525489378986066*^9}, 
   3.543682962195198*^9, {3.5436830215778313`*^9, 3.543683051192148*^9}, {
   3.543683142309544*^9, 3.543683149355734*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.707106781186547`", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0.707106781186547`", ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.525489331088344*^9, 3.525489378986066*^9}, 
   3.543682962195198*^9, {3.5436830215778313`*^9, 3.543683051192148*^9}, {
   3.543683142309544*^9, 3.5436831493589582`*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"Id", ",", "Ze"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Id", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{"IdentityMatrix", "[", "n", "]"}], "//", "N"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Ze", "[", 
    RowBox[{"m_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ConstantArray", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", "n"}], "}"}]}], "]"}], "//", "N"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5224230650097113`*^9, 3.5224230898755617`*^9}, {
  3.52242397062582*^9, 3.522424027222501*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"C1X", "=", 
   RowBox[{"ArrayFlatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "C1", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Ze", "[", 
        RowBox[{"nx", ",", "nx"}], "]"}], "}"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IdX", "=", 
   RowBox[{"ArrayFlatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Ze", "[", 
        RowBox[{"nz", ",", "nx"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Id", "[", "nx", "]"}], "}"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"D12L", "=", 
   RowBox[{"ArrayFlatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "D12", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Ze", "[", 
        RowBox[{"nx", ",", "nu"}], "]"}], "}"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IdW", "=", 
   RowBox[{"ArrayFlatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Id", "[", "nz", "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Ze", "[", 
        RowBox[{"nx", ",", "nz"}], "]"}], "}"}]}], "}"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.514602374113695*^9, 3.514602403064478*^9}, {
   3.514602620394805*^9, 3.51460263408458*^9}, {3.514602681752643*^9, 
   3.514602706140211*^9}, {3.514602783200057*^9, 3.514602784243003*^9}, {
   3.5146029062277203`*^9, 3.514602987151579*^9}, {3.514603036291893*^9, 
   3.51460310865879*^9}, {3.514603164242757*^9, 3.514603174435382*^9}, 
   3.5146032192836027`*^9, {3.514603258077044*^9, 3.514603258947957*^9}, {
   3.5146041242994537`*^9, 3.5146041270313053`*^9}, {3.514604429533717*^9, 
   3.5146044316980877`*^9}, {3.514604473057836*^9, 3.514604473974074*^9}, {
   3.514604505261573*^9, 3.5146045115171337`*^9}, {3.514604620740148*^9, 
   3.5146046211838408`*^9}, {3.514656385758348*^9, 3.514656386250115*^9}, {
   3.5146565137975883`*^9, 3.514656513914187*^9}, {3.514656633647333*^9, 
   3.514656635047391*^9}, {3.515240433803259*^9, 3.5152404355991793`*^9}, {
   3.5152404962866*^9, 3.515240496670414*^9}, {3.51524054060154*^9, 
   3.515240541406598*^9}, {3.515241758854982*^9, 3.5152417831507998`*^9}, {
   3.5159601082340403`*^9, 3.515960108796794*^9}, {3.5159603960145206`*^9, 
   3.51596039712269*^9}, {3.522422446183709*^9, 3.522422448445162*^9}, {
   3.522422687942601*^9, 3.522422688619083*^9}, {3.522423177844145*^9, 
   3.522423274052772*^9}, 3.522423308316379*^9, {3.522423655010379*^9, 
   3.5224236568258257`*^9}, {3.522423701104494*^9, 3.522423716226*^9}, {
   3.52242386862886*^9, 3.522423918667001*^9}, {3.522424081426547*^9, 
   3.522424082067679*^9}, {3.522424141818871*^9, 3.5224241529537582`*^9}, {
   3.522424721037027*^9, 3.522424749780511*^9}}],

Cell[TextData[{
 "This is the semidefinite program:\n\nmin ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"<", "I"}], ",", 
    RowBox[{"W", ">"}]}], TraditionalForm]]],
 "\ns.t.   ",
 Cell[BoxData[{
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"A", " ", "X"}], "+", 
     RowBox[{"B", " ", "L"}], "+", 
     RowBox[{"X", " ", 
      SuperscriptBox["A", "T"]}], "+", 
     RowBox[{
      SuperscriptBox["L", "T"], 
      SuperscriptBox["B", "T"]}], "+", 
     RowBox[{
      SuperscriptBox[
       SubscriptBox["B", "1"], "T"], 
      SubscriptBox["B", "1"]}]}], "\[LessEqual]", "0"}], 
   TraditionalForm], "\[IndentingNewLine]", 
  FormBox[
   RowBox[{
    TagBox[
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"W", 
         RowBox[{
          RowBox[{
           SubscriptBox["C", "1"], "X"}], "+", 
          RowBox[{
           SubscriptBox["D", "12"], "L"}]}]},
        {
         RowBox[{
          RowBox[{"X", " ", 
           SuperscriptBox[
            SubscriptBox["C", "1"], "T"]}], " ", "+", 
          RowBox[{
           SuperscriptBox["L", "T"], 
           SuperscriptBox[
            SubscriptBox["D", "12"], "T"]}]}], "X"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
     Function[BoxForm`e$, 
      MatrixForm[BoxForm`e$]]], "\[GreaterEqual]", "0"}], 
   TraditionalForm]}]],
 "\n\nwhich we canonical form"
}], "Text",
 CellChangeTimes->{{3.5152415562569733`*^9, 3.5152416226783047`*^9}, {
  3.5152416783408957`*^9, 3.5152417200203657`*^9}, {3.522422700970278*^9, 
  3.522422763076387*^9}, {3.5224228386807137`*^9, 3.5224229118562593`*^9}, {
  3.522422996160348*^9, 3.522423014139876*^9}, {3.522423499698606*^9, 
  3.52242352792863*^9}, {3.543683052783581*^9, 3.543683053965156*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AA", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", " ", "A"}], ",", 
         RowBox[{"Id", "[", "nx", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", "B"}], ",", 
         RowBox[{"Id", "[", "nx", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Ze", "[", 
          RowBox[{"nx", ",", "nz"}], "]"}], ",", 
         RowBox[{"Ze", "[", 
          RowBox[{"nz", ",", "nx"}], "]"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"A", " ", "X"}], " ", "+", " ", 
        RowBox[{"B", " ", "L"}]}], " ", "<", " ", 
       RowBox[{"-", "I"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ArrayFlatten", "[", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "IdX"}], ",", 
             RowBox[{
              RowBox[{"-", "2"}], "C1X"}]}], "}"}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ArrayFlatten", "[", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Transpose", "[", "IdX", "]"}], ",", 
             RowBox[{"Transpose", "[", "IdX", "]"}]}], "}"}], "}"}], "]"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "D12L"}], ",", 
         RowBox[{"Transpose", "[", "IdX", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", " ", "IdW"}], ",", 
         RowBox[{"Transpose", "[", "IdW", "]"}]}], "}"}]}], "}"}]}], " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"[", 
        RowBox[{"X", ",", " ", 
         RowBox[{
          RowBox[{"L", "^", "T"}], ";", " ", 
          RowBox[{"L", " ", "W"}]}]}], "]"}]}], " ", "<", " ", "0"}], " ", 
     "*)"}], "\[IndentingNewLine]", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"CC", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"B1", ".", 
       RowBox[{"Transpose", "[", "B1", "]"}]}]}], ",", 
     RowBox[{"Ze", "[", 
      RowBox[{
       RowBox[{"nx", "+", "nz"}], ",", 
       RowBox[{"nx", "+", "nz"}]}], "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"BB", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Ze", "[", 
      RowBox[{"nx", ",", "nx"}], "]"}], ",", 
     RowBox[{"Ze", "[", 
      RowBox[{"nu", ",", "nx"}], "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"Id", "[", "nz", "]"}]}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5146026454147882`*^9, 3.5146026770668573`*^9}, {
   3.514602710362245*^9, 3.5146028552671967`*^9}, {3.514602996015814*^9, 
   3.514603010760762*^9}, {3.5146031169433813`*^9, 3.51460314690228*^9}, {
   3.514603178911397*^9, 3.5146032485992413`*^9}, {3.514603398492549*^9, 
   3.514603401410026*^9}, {3.514603522375819*^9, 3.514603522572736*^9}, 
   3.514603582964954*^9, 3.514604355806038*^9, 3.514604387189908*^9, {
   3.514604560165989*^9, 3.51460456682931*^9}, {3.514656365101453*^9, 
   3.5146563661613827`*^9}, {3.514656606480259*^9, 3.51465661248846*^9}, {
   3.515241738677841*^9, 3.51524175087737*^9}, {3.5224231057619743`*^9, 
   3.522423158080101*^9}, {3.522423728931666*^9, 3.522423763763011*^9}, {
   3.522423795850829*^9, 3.5224238304099817`*^9}, {3.522423903761002*^9, 
   3.522423905231997*^9}, {3.5224241872145557`*^9, 3.522424257347031*^9}, {
   3.522424559958902*^9, 3.522424563328031*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Dimensions", ",", "BB"}], "]"}]], "Input",
 CellChangeTimes->{{3.522424293480467*^9, 3.522424297057315*^9}, {
  3.5224243894311047`*^9, 3.522424391862801*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.52242429900529*^9, {3.5224243866844254`*^9, 3.522424392208713*^9}, {
   3.52242456791765*^9, 3.522424594125944*^9}, 3.5224247534733257`*^9, 
   3.522424796775858*^9, {3.5224252200741653`*^9, 3.522425236251096*^9}, 
   3.524506263802619*^9, 3.525027189176277*^9, 3.525027576210225*^9, 
   3.5250276823350163`*^9, 3.5250278963557863`*^9, {3.525227769460925*^9, 
   3.525227783613619*^9}, 3.525227826702858*^9, 3.525488721644269*^9, 
   3.525488789809218*^9, 3.543682968540967*^9, 3.543683025818289*^9, 
   3.5436830567534924`*^9, 3.543683153811514*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Dimensions", ",", "CC"}], "]"}]], "Input",
 CellChangeTimes->{{3.522424397662551*^9, 3.522424397862653*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "7"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.522424423847081*^9, {3.522424569101288*^9, 3.522424594811096*^9}, 
   3.52242475430481*^9, 3.522424797342876*^9, {3.522425221262292*^9, 
   3.522425237002528*^9}, 3.5245062647208*^9, 3.525027190177458*^9, 
   3.525027576242998*^9, 3.525027682352138*^9, 3.5250278963899403`*^9, {
   3.525227769492469*^9, 3.525227783632308*^9}, 3.525227826736285*^9, 
   3.5254887223310413`*^9, 3.5254887903604927`*^9, 3.543682969174077*^9, 
   3.543683026584731*^9, 3.543683057403948*^9, 3.543683154446843*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Eigenvalues", ",", "CC"}], "]"}]], "Input",
 CellChangeTimes->{{3.5252285333663273`*^9, 3.525228559337159*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.008073646398255571`"}], ",", 
     RowBox[{"-", "0.005795042500000001`"}], ",", 
     RowBox[{"-", "0.0012211068017444317`"}], ",", 
     RowBox[{"-", "1.6526142196523434`*^-18"}], ",", 
     RowBox[{"-", "1.3552527156068805`*^-20"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", 
     "0.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.525228534177429*^9, 3.5252285599537287`*^9}, 
   3.525488723113393*^9, 3.525488790944171*^9, 3.543682969774886*^9, 
   3.543683027202291*^9, 3.54368305802225*^9, 3.543683154946361*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"MatrixForm", ",", 
   RowBox[{"AA", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.522424424594305*^9, 3.522424522027493*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "2.264`", "0", 
          RowBox[{"-", "2"}]},
         {"0", 
          RowBox[{"-", "0.1076`"}], 
          RowBox[{"-", "0.3424`"}], "0", "0.141`"},
         {"0", "0", "0", "2", "0"},
         {"0", "0.097`", "0", 
          RowBox[{"-", "1.7112`"}], 
          RowBox[{"-", "2.026`"}]},
         {"0", 
          RowBox[{"-", "0.5818`"}], "0", "2.1064`", 
          RowBox[{"-", "1.3718`"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1.`", "0.`", "0.`", "0.`", "0.`"},
         {"0.`", "1.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "1.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "1.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "1.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0"},
         {
          RowBox[{"-", "0.24`"}], "2", "0"},
         {"0", "0", "0"},
         {"8.838`", "0", 
          RowBox[{"-", "3.33`"}]},
         {"3.15`", "0", 
          RowBox[{"-", "0.1464`"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1.`", "0.`", "0.`", "0.`", "0.`"},
         {"0.`", "1.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "1.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "1.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "1.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0.`", "0.`"},
         {"0.`", "0.`"},
         {"0.`", "0.`"},
         {"0.`", "0.`"},
         {"0.`", "0.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0.`", "0.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "0.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.522424429552663*^9, 3.5224245223768682`*^9}, {
   3.522424570403809*^9, 3.522424595746168*^9}, 3.52242475499137*^9, 
   3.522424797910812*^9, {3.522425221845623*^9, 3.52242523757237*^9}, 
   3.524506265860729*^9, 3.525027191392905*^9, 3.52502757626164*^9, 
   3.525027682386471*^9, 3.5250278964260263`*^9, {3.525227769526506*^9, 
   3.525227783666156*^9}, 3.525227826771431*^9, 3.525488724389744*^9, 
   3.525488791615087*^9, 3.54368297042669*^9, 3.543683027937003*^9, 
   3.543683058573408*^9, 3.543683155514785*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"MatrixForm", ",", 
   RowBox[{"AA", "[", 
    RowBox[{"[", "2", "]"}], "]"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.522424581716063*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0.`", "0.`", "0.`", "0.`", "0.`", "0", 
          RowBox[{"-", "1.414213562373094`"}], "0", "0", "0"},
         {"0.`", "0.`", "0.`", "0.`", "0.`", "0", "0", 
          RowBox[{"-", "1.414213562373094`"}], "0", "0"},
         {
          RowBox[{"-", "1.`"}], "0.`", "0.`", "0.`", "0.`", "0.`", "0.`", 
          "0.`", "0.`", "0.`"},
         {"0.`", 
          RowBox[{"-", "1.`"}], "0.`", "0.`", "0.`", "0.`", "0.`", "0.`", 
          "0.`", "0.`"},
         {"0.`", "0.`", 
          RowBox[{"-", "1.`"}], "0.`", "0.`", "0.`", "0.`", "0.`", "0.`", 
          "0.`"},
         {"0.`", "0.`", "0.`", 
          RowBox[{"-", "1.`"}], "0.`", "0.`", "0.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", 
          RowBox[{"-", "1.`"}], "0.`", "0.`", "0.`", "0.`", "0.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0.`", "0.`", "1.`", "0.`", "0.`", "0.`", "0.`", "0.`", "0.`", 
          "1.`", "0.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "1.`", "0.`", "0.`", "0.`", "0.`", "0.`", 
          "0.`", "1.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "1.`", "0.`", "0.`", "0.`", "0.`", 
          "0.`", "0.`", "1.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "0.`", "1.`", "0.`", "0.`", "0.`", 
          "0.`", "0.`", "0.`", "1.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "0.`", "0.`", "1.`", "0.`", "0.`", 
          "0.`", "0.`", "0.`", "0.`", "1.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"-", "1.414213562373094`"}], "0", "0"},
         {"0", 
          RowBox[{"-", "1.414213562373094`"}], "0"},
         {"0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0.`", "0.`", "1.`", "0.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "1.`", "0.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "1.`", "0.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "0.`", "1.`", "0.`"},
         {"0.`", "0.`", "0.`", "0.`", "0.`", "0.`", "1.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"-", "1.`"}], "0.`"},
         {"0.`", 
          RowBox[{"-", "1.`"}]},
         {"0.`", "0.`"},
         {"0.`", "0.`"},
         {"0.`", "0.`"},
         {"0.`", "0.`"},
         {"0.`", "0.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1.`", "0.`", "0.`", "0.`", "0.`", "0.`", "0.`"},
         {"0.`", "1.`", "0.`", "0.`", "0.`", "0.`", "0.`"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.522424582258306*^9, 3.5224245968788958`*^9}, 
   3.522424755993844*^9, 3.522424798748205*^9, {3.5224252232471*^9, 
   3.522425238423416*^9}, 3.524506274054172*^9, 3.525027192562731*^9, 
   3.5250275762955647`*^9, 3.5250276824037027`*^9, 3.525027896457315*^9, {
   3.5252277695641336`*^9, 3.525227783699337*^9}, 3.5252278268051147`*^9, 
   3.525488725588028*^9, 3.525488792363515*^9, 3.543682971414131*^9, 
   3.543683028672618*^9, 3.543683059339745*^9, 3.5436831562009363`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "S", ",", "iters"}], "}"}], "=", 
   RowBox[{"SDPSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"AA", ",", "BB", ",", "CC"}], "}"}], ",", 
     RowBox[{"SymmetricVariables", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5146033839182653`*^9, 3.514603384469534*^9}, 
   3.5146034603814573`*^9, {3.5146040476820383`*^9, 3.514604051143736*^9}, {
   3.514604152962029*^9, 3.514604168231779*^9}, {3.525027235009232*^9, 
   3.525027265689097*^9}, {3.525027990653455*^9, 3.525027998645369*^9}, {
   3.525028160408791*^9, 3.5250281809763203`*^9}, {3.525227794211331*^9, 
   3.5252278011620893`*^9}, {3.525228000117725*^9, 3.5252280003714743`*^9}, {
   3.52522814353547*^9, 3.525228143636689*^9}, {3.5252286399217653`*^9, 
   3.525228640249148*^9}, {3.525488730085857*^9, 3.525488730166003*^9}, {
   3.5254887606076317`*^9, 3.5254887608056517`*^9}, {3.525488807582694*^9, 
   3.525488845014009*^9}, {3.525489108450472*^9, 3.525489112376811*^9}, {
   3.543682979116458*^9, 3.543682996130472*^9}, 3.543683038913353*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\" Problem data:\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156736047*^9}],

Cell[BoxData["\<\" * Dimensions (total):\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831567385473`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   - Variables             = \"\>", "\[InvisibleSpace]", "44"}],
  SequenceForm["   - Variables             = ", 44],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156741281*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   - Inequalities          = \"\>", "\[InvisibleSpace]", "2"}],
  
  SequenceForm["   - Inequalities          = ", 2],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156743877*^9}],

Cell[BoxData["\<\" * Dimensions (detail):\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156747098*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   - Variables             = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}],
  SequenceForm["   - Variables             = ", {{5, 5}, {3, 5}, {2, 2}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156750784*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   - Inequalities          = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7"}], "}"}]}],
  SequenceForm["   - Inequalities          = ", {5, 7}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831567530327`*^9}],

Cell[BoxData["\<\"\\n Method:\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831567559443`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" * Method                  = \"\>", "\[InvisibleSpace]", 
   "PredictorCorrector"}],
  SequenceForm[" * Method                  = ", PrimalDual`PredictorCorrector],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156759203*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" * Search direction        = \"\>", "\[InvisibleSpace]", "NT"}],
  SequenceForm[" * Search direction        = ", PrimalDual`NT],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831567619543`*^9}],

Cell[BoxData["\<\"\\n Precision:\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156764077*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" * Gap tolerance           = \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"1.\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-9\"\>"]}],
     1.*^-9,
     AutoDelete->True],
    ScientificForm]}],
  SequenceForm[" * Gap tolerance           = ", 
   ScientificForm[1.*^-9]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831567662354`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" * Feasibility tolerance   = \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"1.\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     1.0000000000000002`*^-6,
     AutoDelete->True],
    ScientificForm]}],
  SequenceForm[" * Feasibility tolerance   = ", 
   ScientificForm[1.0000000000000002`*^-6]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156768304*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" * Rationalize iterates    = \"\>", "\[InvisibleSpace]", 
   "False", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[" * Rationalize iterates    = ", False, ""],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156770335*^9}],

Cell[BoxData["\<\"\\n Other options:\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156772232*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" * Debug level             = \"\>", "\[InvisibleSpace]", "0"}],
  
  SequenceForm[" * Debug level             = ", 0],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156774117*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156776*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  K     <B, Y>         mu  theta/tau      alpha\"\>", 
   "\[InvisibleSpace]", "\<\"     |X S|2    |X S|oo \"\>", 
   "\[InvisibleSpace]", "\<\" |A* X-B|   |A Y+S-C|\"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "  K     <B, Y>         mu  theta/tau      alpha", 
   "     |X S|2    |X S|oo ", " |A* X-B|   |A Y+S-C|", ""],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831567778797`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" -----------------------------------------------------\"\>", 
   "\[InvisibleSpace]", "\<\"--------------------------------------\"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  " -----------------------------------------------------", 
   "--------------------------------------", ""],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156779997*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  1\"\>",
     1,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 7.095\"", 7.09549, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-02\"", -2, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.07095489664790415,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.566\"", 1.56582, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.15658188913664925`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.458\"", 1.4583, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.14583046335306188`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.528\"", 8.52751, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.8527510860901087,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.550\"", 1.5499, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.5498950303121373`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.956\"", 9.95604, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.9956039002180493,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.736\"", 1.73604, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.7360373567034387`*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 5.812\"", 5.81239, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-16\"", -16, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     5.81238509478598*^-16,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[1, 2], " ", 
   ScientificForm[
   0.07095489664790415, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.15658188913664925`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.14583046335306188`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.8527510860901087, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.5498950303121373`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.9956039002180493, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.7360373567034387`*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   5.81238509478598*^-16, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831567831717`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  2\"\>",
     2,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.052\"", 3.05198, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-02\"", -2, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.030519838714624416`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 7.337\"", 7.33679, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-02\"", -2, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.07336785339197918,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.109\"", 8.10942, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-02\"", -2, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.081094184259651,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 5.314\"", 5.31441, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.531441,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.394\"", 1.39443, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.3944315940163512`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.546\"", 9.54601, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.95460067966378,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.815\"", 1.81494, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.814944349453446*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.207\"", 1.20718, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.2071787237926603`*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[2, 2], " ", 
   ScientificForm[
   0.030519838714624416`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.07336785339197918, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.081094184259651, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.531441, NumberFormat -> PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.3944315940163512`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.95460067966378, NumberFormat -> PrimalDual`Private`NumberFormatFunction],
    " ", 
   ScientificForm[
   1.814944349453446*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.2071787237926603`*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156790752*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  3\"\>",
     3,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.860\"", 4.8595, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-03\"", -3, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.0048595031092912135`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.394\"", 1.39445, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-02\"", -2, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.013944454263266882`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.511\"", 1.51077, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-02\"", -2, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.015107705248069857`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.100\"", 8.1, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.81,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.541\"", 1.54092, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.5409180942491698`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 7.244\"", 7.24431, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.7244314926818909,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.933\"", 1.93333, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.9333338927833265`*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.270\"", 2.27025, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     2.2702483934121662`*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[3, 2], " ", 
   ScientificForm[
   0.0048595031092912135`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.013944454263266882`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.015107705248069857`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.81, NumberFormat -> PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.5409180942491698`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.7244314926818909, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.9333338927833265`*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   2.2702483934121662`*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156800208*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  4\"\>",
     4,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.952\"", 2.95212, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-04\"", -4, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.0002952117447836952,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.649\"", 2.64945, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-03\"", -3, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.0026494463100207068`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.360\"", 3.35994, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-03\"", -3, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.0033599448821213978`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.100\"", 8.1, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.81,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.562\"", 1.562, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.5620002069192278`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 7.003\"", 7.0027, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.7002703312178226,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.924\"", 1.92388, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.9238755863854316`*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.881\"", 1.88106, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.8810555120520697`*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[4, 2], " ", 
   ScientificForm[
   0.0002952117447836952, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.0026494463100207068`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.0033599448821213978`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.81, NumberFormat -> PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.5620002069192278`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.7002703312178226, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.9238755863854316`*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.8810555120520697`*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.54368315681098*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  5\"\>",
     5,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.941\"", 4.9406, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-05\"", -5, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.00004940598364878694,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.806\"", 2.80608, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-04\"", -4, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.0002806082125671931,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.639\"", 3.63864, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-04\"", -4, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.0003638637081005575,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.941\"", 8.94088, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.8940879792483888,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.557\"", 1.55681, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.5568110392572607`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 6.527\"", 6.5273, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.6527295750859871,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.970\"", 1.97028, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.9702839584737552`*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.491\"", 3.49133, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     3.491325912761349*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[5, 2], " ", 
   ScientificForm[
   0.00004940598364878694, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.0002806082125671931, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.0003638637081005575, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.8940879792483888, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.5568110392572607`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.6527295750859871, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.9702839584737552`*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   3.491325912761349*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156840632*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  6\"\>",
     6,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.814\"", 8.81375, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-06\"", -6, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     8.813752994591839*^-6,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.131\"", 3.13132, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-05\"", -5, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.00003131322156889921,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.938\"", 3.93827, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-05\"", -5, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.00003938274955765663,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.884\"", 8.88419, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.8884187866281752,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.572\"", 1.5722, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.5721992374286666`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 6.524\"", 6.52394, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.6523943049295506,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.960\"", 1.95993, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.9599334248754163`*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.806\"", 2.80571, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     2.805705432644116*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[6, 2], " ", 
   ScientificForm[
   8.813752994591839*^-6, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.00003131322156889921, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.00003938274955765663, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.8884187866281752, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.5721992374286666`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.6523943049295506, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.9599334248754163`*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   2.805705432644116*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831568525543`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  7\"\>",
     7,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.249\"", 1.24872, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-06\"", -6, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.2487163041155394`*^-6,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.459\"", 3.45905, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-06\"", -6, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     3.4590474474814265`*^-6,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.220\"", 4.22027, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-06\"", -6, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.220273501932773*^-6,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.895\"", 8.89545, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.8895445958544633,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.588\"", 1.58833, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.5883318398714867`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 6.563\"", 6.56344, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.6563436877496879,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 1.988\"", 1.9878, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     1.9877984378969236`*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.125\"", 2.12453, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     2.124534641628454*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[7, 2], " ", 
   ScientificForm[
   1.2487163041155394`*^-6, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   3.4590474474814265`*^-6, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.220273501932773*^-6, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.8895445958544633, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.5883318398714867`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.6563436877496879, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   1.9877984378969236`*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   2.124534641628454*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156863884*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  8\"\>",
     8,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.947\"", 4.94712, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-08\"", -8, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.9471166440822694`*^-8,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.238\"", 4.23822, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-08\"", -8, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.238219313084771*^-8,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.994\"", 4.99415, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-08\"", -8, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.9941511883727246`*^-8,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.878\"", 9.8776, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.9877599870645627,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.444\"", 2.44438, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     2.4443785286609216`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.751\"", 9.75096, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.9750960035710659,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.053\"", 9.05286, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-14\"", -14, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     9.052856997236388*^-14,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.567\"", 4.56744, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.567440755057032*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[8, 2], " ", 
   ScientificForm[
   4.9471166440822694`*^-8, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.238219313084771*^-8, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.9941511883727246`*^-8, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.9877599870645627, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   2.4443785286609216`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.9750960035710659, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   9.052856997236388*^-14, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.567440755057032*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156900867*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\"  9\"\>",
     9,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.378\"", 4.37839, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-09\"", -9, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.378391940149847*^-9,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.280\"", 4.27955, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-09\"", -9, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.279548129629334*^-9,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.426\"", 4.42624, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-09\"", -9, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.4262384110051485`*^-9,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.000\"", 9., AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.9,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.423\"", 2.42298, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     2.4229844429402125`,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.680\"", 9.67955, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.9679546684216147,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 7.275\"", 7.27497, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-13\"", -13, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     7.274969904457963*^-13,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.685\"", 3.68484, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     3.6848394959584915`*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[9, 2], " ", 
   ScientificForm[
   4.378391940149847*^-9, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.279548129629334*^-9, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.4262384110051485`*^-9, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.9, NumberFormat -> PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   2.4229844429402125`, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.9679546684216147, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   7.274969904457963*^-13, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   3.6848394959584915`*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.54368315690886*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    InterpretationBox["\<\" 10\"\>",
     10,
     Editable->False],
    PaddedForm[#, 2]& ], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.692\"", 4.69155, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-10\"", -10, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.691554962486019*^-10,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.809\"", 4.80884, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-10\"", -10, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.808839625882147*^-10,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 4.722\"", 4.72234, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-10\"", -10, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     4.722340521555044*^-10,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 8.877\"", 8.87695, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.8876947130063123,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.400\"", 2.40011, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"+00\"", 0, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     2.400107335450019,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 9.698\"", 9.69829, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-01\"", -1, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     0.9698288480524457,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 2.551\"", 2.55123, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-12\"", -12, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     2.5512256304682428`*^-12,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     TemplateBox[{TagBox[
        InterpretationBox["\" 3.595\"", 3.595, AutoDelete -> True], 
        NumberForm[#, {4, 3}, NumberPadding -> {" ", "0"}]& ],"\"e\"",TagBox[
        InterpretationBox["\"-15\"", -15, Editable -> False], 
        NumberForm[#, 2, NumberPadding -> {"0", ""}, 
         NumberSigns -> {"-", "+"}, SignPadding -> True]& ]},
      "Row",
      DisplayFunction->(
       RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{"{", 
           RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
     3.5949985586512866`*^-15,
     Editable->False],
    ScientificForm[#, NumberFormat -> 
     PrimalDual`Private`NumberFormatFunction]& ], 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"    \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>", "\[InvisibleSpace]", "\<\"      \"\>"}],
  SequenceForm[
   PaddedForm[10, 2], " ", 
   ScientificForm[
   4.691554962486019*^-10, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.808839625882147*^-10, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   4.722340521555044*^-10, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.8876947130063123, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   2.400107335450019, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   0.9698288480524457, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   2.5512256304682428`*^-12, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], " ", 
   ScientificForm[
   3.5949985586512866`*^-15, NumberFormat -> 
    PrimalDual`Private`NumberFormatFunction], "", "    ", "", "      "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831569352427`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" -----------------------------------------------------\"\>", 
   "\[InvisibleSpace]", "\<\"--------------------------------------\"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  " -----------------------------------------------------", 
   "--------------------------------------", ""],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.5436831569419813`*^9}],

Cell[BoxData["\<\"* Primal solution is feasible \"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156944345*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"(max eig(A* Y - C) = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "6.737107081333354`*^-11"}], 
   "\[InvisibleSpace]", "\<\" <= 0 )\"\>"}],
  SequenceForm["(max eig(A* Y - C) = ", -6.737107081333354*^-11, " <= 0 )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156946632*^9}],

Cell[BoxData["\<\"* Dual solution is within tolerance\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156949458*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"(|| A X - B || = \"\>", "\[InvisibleSpace]", 
   "5.303538469902862`*^-9", "\[InvisibleSpace]", "\<\" < \"\>", 
   "\[InvisibleSpace]", "1.0000000000000002`*^-6", 
   "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm[
  "(|| A X - B || = ", 5.303538469902862*^-9, " < ", 1.0000000000000002`*^-6, 
   ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156951811*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"* Feasibility radius = \"\>", "\[InvisibleSpace]", 
   "0.9999979998672581`"}],
  SequenceForm["* Feasibility radius = ", 0.9999979998672581],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156954356*^9}],

Cell[BoxData["\<\"  (should be less than 1 when feasible)\"\>"], "Print",
 CellChangeTimes->{
  3.525227826883574*^9, 3.5252280008466253`*^9, 3.525228144065381*^9, 
   3.525228641303814*^9, 3.5254887305934362`*^9, 3.525488761445619*^9, {
   3.5254887932489653`*^9, 3.525488845488442*^9}, 3.525489112738947*^9, {
   3.543682972379819*^9, 3.543682996485628*^9}, {3.543683029406341*^9, 
   3.543683060024971*^9}, 3.543683156956626*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "PrimalDual", "]"}]], "Input",
 CellChangeTimes->{{3.525489056903426*^9, 3.5254890601018877`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"SearchDirection", "\[Rule]", "NT"}], ",", 
   RowBox[{"Method", "\[Rule]", "PredictorCorrector"}], ",", 
   RowBox[{"LeastSquares", "\[Rule]", "Direct"}], ",", 
   RowBox[{"LeastSquaresSolver", "\[Rule]", "Null"}], ",", 
   RowBox[{"LeastSquaresSolverFactored", "\[Rule]", "Null"}], ",", 
   RowBox[{"GapTol", "\[Rule]", "1.`*^-9"}], ",", 
   RowBox[{"FeasibilityTol", "\[Rule]", 
    RowBox[{"1000.`", " ", "GapTol"}]}], ",", 
   RowBox[{"MaxIter", "\[Rule]", "250"}], ",", 
   RowBox[{"CGTol", "\[Rule]", "0.001`"}], ",", 
   RowBox[{"CGMaxIter", "\[Rule]", "\[Infinity]"}], ",", 
   RowBox[{"CGPreconditioner", "\[Rule]", "Diagonal"}], ",", 
   RowBox[{"ScaleHessian", "\[Rule]", "True"}], ",", 
   RowBox[{"SparseWeights", "\[Rule]", "True"}], ",", 
   RowBox[{"RationalizeIterates", "\[Rule]", "False"}], ",", 
   RowBox[{"RationalizeTol", "\[Rule]", "GapTol"}], ",", 
   RowBox[{"SymmetricVariables", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DebugLevel", "\[Rule]", "0"}], ",", 
   RowBox[{"PrintSummary", "\[Rule]", "True"}], ",", 
   RowBox[{"Profiling", "\[Rule]", "False"}]}], "}"}]], "Output",
 CellChangeTimes->{3.525489060502171*^9, 3.543683042143935*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"A", "\[IndentingNewLine]", "B", "\[IndentingNewLine]", "B1", "\
\[IndentingNewLine]", "C1", "\[IndentingNewLine]", "D12", \
"\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.525489172701792*^9, 3.5254891965504723`*^9}, {
  3.525489239110855*^9, 3.525489239622821*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9801`", ",", "0.0003`", ",", 
     RowBox[{"-", "0.098`"}], ",", "0.0038`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3868`"}], ",", "0.9071`", ",", "0.0471`", ",", 
     RowBox[{"-", "0.0008`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.1591`", ",", 
     RowBox[{"-", "0.0015`"}], ",", "0.9691`", ",", "0.0003`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0198`"}], ",", "0.0958`", ",", "0.0021`", ",", "1"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.52548917355554*^9, 3.525489193038692*^9}, 
   3.5254892400186777`*^9, 3.543683043446652*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0001`"}], ",", "0.0058`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.0296`", ",", "0.0153`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.0012`", ",", 
     RowBox[{"-", "0.0908`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.0015`", ",", "0.0008`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.52548917355554*^9, 3.525489193038692*^9}, 
   3.5254892400186777`*^9, 3.543683043449614*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.52548917355554*^9, 3.525489193038692*^9}, 
   3.5254892400186777`*^9, 3.543683043451831*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.52548917355554*^9, 3.525489193038692*^9}, 
   3.5254892400186777`*^9, 3.5436830434532547`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.52548917355554*^9, 3.525489193038692*^9}, 
   3.5254892400186777`*^9, 3.5436830434546537`*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1439, 768},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 142, 2, 114, "Title"],
Cell[CellGroupData[{
Cell[746, 28, 216, 5, 87, "Input"],
Cell[CellGroupData[{
Cell[987, 37, 137, 2, 30, "Print"],
Cell[1127, 41, 269, 6, 30, "Print"],
Cell[1399, 49, 365, 8, 30, "Print"]
}, Open  ]]
}, Open  ]],
Cell[1791, 61, 573, 8, 40, "Input"],
Cell[2367, 71, 198, 3, 40, "Input"],
Cell[CellGroupData[{
Cell[2590, 78, 128, 1, 64, "Input"],
Cell[2721, 81, 465, 11, 40, "Output"],
Cell[3189, 94, 420, 10, 40, "Output"]
}, Open  ]],
Cell[3624, 107, 631, 19, 89, "Input"],
Cell[4258, 128, 2799, 64, 110, "Input"],
Cell[7060, 194, 2136, 63, 209, "Text"],
Cell[9199, 259, 3618, 97, 202, "Input"],
Cell[CellGroupData[{
Cell[12842, 360, 206, 4, 40, "Input"],
Cell[13051, 366, 805, 17, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13893, 388, 155, 3, 40, "Input"],
Cell[14051, 393, 689, 14, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14777, 412, 158, 3, 40, "Input"],
Cell[14938, 417, 695, 16, 49, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15670, 438, 243, 6, 40, "Input"],
Cell[15916, 446, 5660, 149, 267, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21613, 600, 219, 6, 40, "Input"],
Cell[21835, 608, 6635, 163, 368, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28507, 776, 1182, 22, 40, "Input"],
Cell[CellGroupData[{
Cell[29714, 802, 407, 6, 30, "Print"],
Cell[30124, 810, 417, 6, 30, "Print"],
Cell[30544, 818, 555, 10, 30, "Print"],
Cell[31102, 830, 556, 11, 30, "Print"],
Cell[31661, 843, 416, 6, 30, "Print"],
Cell[32080, 851, 794, 18, 30, "Print"],
Cell[32877, 871, 609, 12, 30, "Print"],
Cell[33489, 885, 406, 6, 54, "Print"],
Cell[33898, 893, 602, 11, 30, "Print"],
Cell[34503, 906, 568, 10, 30, "Print"],
Cell[35074, 918, 407, 6, 54, "Print"],
Cell[35484, 926, 752, 18, 34, "Print"],
Cell[36239, 946, 784, 18, 34, "Print"],
Cell[37026, 966, 602, 11, 30, "Print"],
Cell[37631, 979, 411, 6, 54, "Print"],
Cell[38045, 987, 556, 11, 30, "Print"],
Cell[38604, 1000, 390, 6, 30, "Print"],
Cell[38997, 1008, 780, 15, 30, "Print"],
Cell[39780, 1025, 739, 14, 30, "Print"],
Cell[40522, 1041, 8312, 194, 30, "Print"],
Cell[48837, 1237, 8280, 193, 30, "Print"],
Cell[57120, 1432, 8290, 193, 30, "Print"],
Cell[65413, 1627, 8289, 193, 30, "Print"],
Cell[73705, 1822, 8322, 194, 30, "Print"],
Cell[82030, 2018, 8327, 194, 30, "Print"],
Cell[90360, 2214, 8329, 194, 30, "Print"],
Cell[98692, 2410, 8325, 194, 30, "Print"],
Cell[107020, 2606, 8285, 193, 30, "Print"],
Cell[115308, 2801, 8333, 194, 30, "Print"],
Cell[123644, 2997, 741, 14, 30, "Print"],
Cell[124388, 3013, 423, 6, 30, "Print"],
Cell[124814, 3021, 655, 12, 34, "Print"],
Cell[125472, 3035, 428, 6, 30, "Print"],
Cell[125903, 3043, 744, 15, 34, "Print"],
Cell[126650, 3060, 580, 11, 30, "Print"],
Cell[127233, 3073, 432, 6, 30, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[127714, 3085, 137, 2, 40, "Input"],
Cell[127854, 3089, 1235, 24, 126, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129126, 3118, 289, 4, 156, "Input"],
Cell[129418, 3124, 683, 18, 64, "Output"],
Cell[130104, 3144, 494, 14, 40, "Output"],
Cell[130601, 3160, 484, 12, 40, "Output"],
Cell[131088, 3174, 486, 12, 40, "Output"],
Cell[131577, 3188, 406, 12, 40, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
